{-# LANGUAGE EmptyDataDecls, RankNTypes, ScopedTypeVariables #-}

module Ceta where {

import Prelude ((==), (/=), (<), (<=), (>=), (>), (+), (-), (*), (/), (**),
  (>>=), (>>), (=<<), (&&), (||), (^), (^^), (.), ($), ($!), (++), (!!), Eq,
  error, id, return, not, fst, snd, map, filter, concat, concatMap, reverse,
  zip, null, takeWhile, dropWhile, all, any, Integer, negate, abs, divMod,
  String, Bool(True, False), Maybe(Nothing, Just));
import qualified Prelude;

data Num = One | Bit0 Num | Bit1 Num;

data Int = Zero_int | Pos Num | Neg Num;

data Nat = Zero_nat | Nat_of_num Num;

class Ord a where {
  less_eq :: a -> a -> Bool;
  less :: a -> a -> Bool;
};

class (Ord a) => Preorder a where {
};

class (Preorder a) => Order a where {
};

class (Order a) => Linorder a where {
};

data Color = R | B;

data Rbta a b = Emptya | Branch Color (Rbta a b) a b (Rbta a b);

newtype Rbt a b = Rbt (Rbta a b);

newtype Rat = Frct (Int, Int);

class Corder a where {
  corder :: Maybe (a -> a -> Bool, a -> a -> Bool);
};

newtype Mapping_rbt a b = Mapping_RBT (Rbta a b);

class Ceq a where {
  ceq :: Maybe (a -> a -> Bool);
};

newtype Set_dlist a = Abs_dlist [a];

data Set a = Collect_set (a -> Bool) | DList_set (Set_dlist a)
  | RBT_set (Mapping_rbt a ()) | Set_Monad [a] | Complement (Set a);

data Xml =
  Xml [Prelude.Char] [([Prelude.Char], [Prelude.Char])] [Xml]
    (Maybe [Prelude.Char]);

dup :: Int -> Int;
dup (Neg n) = Neg (Bit0 n);
dup (Pos n) = Pos (Bit0 n);
dup Zero_int = Zero_int;

nat :: Int -> Nat;
nat (Pos k) = Nat_of_num k;
nat Zero_int = Zero_nat;
nat (Neg k) = Zero_nat;

uminus_int :: Int -> Int;
uminus_int (Neg m) = Pos m;
uminus_int (Pos m) = Neg m;
uminus_int Zero_int = Zero_int;

plus_num :: Num -> Num -> Num;
plus_num (Bit1 m) (Bit1 n) = Bit0 (plus_num (plus_num m n) One);
plus_num (Bit1 m) (Bit0 n) = Bit1 (plus_num m n);
plus_num (Bit1 m) One = Bit0 (plus_num m One);
plus_num (Bit0 m) (Bit1 n) = Bit1 (plus_num m n);
plus_num (Bit0 m) (Bit0 n) = Bit0 (plus_num m n);
plus_num (Bit0 m) One = Bit1 m;
plus_num One (Bit1 n) = Bit0 (plus_num n One);
plus_num One (Bit0 n) = Bit1 n;
plus_num One One = Bit0 One;

bitM :: Num -> Num;
bitM One = One;
bitM (Bit0 n) = Bit1 (bitM n);
bitM (Bit1 n) = Bit1 (Bit0 n);

sub :: Num -> Num -> Int;
sub (Bit0 m) (Bit1 n) = minus_int (dup (sub m n)) (Pos One);
sub (Bit1 m) (Bit0 n) = plus_int (dup (sub m n)) (Pos One);
sub (Bit1 m) (Bit1 n) = dup (sub m n);
sub (Bit0 m) (Bit0 n) = dup (sub m n);
sub One (Bit1 n) = Neg (Bit0 n);
sub One (Bit0 n) = Neg (bitM n);
sub (Bit1 m) One = Pos (Bit0 m);
sub (Bit0 m) One = Pos (bitM m);
sub One One = Zero_int;

plus_int :: Int -> Int -> Int;
plus_int (Neg m) (Neg n) = Neg (plus_num m n);
plus_int (Neg m) (Pos n) = sub n m;
plus_int (Pos m) (Neg n) = sub m n;
plus_int (Pos m) (Pos n) = Pos (plus_num m n);
plus_int Zero_int l = l;
plus_int k Zero_int = k;

minus_int :: Int -> Int -> Int;
minus_int (Neg m) (Neg n) = sub n m;
minus_int (Neg m) (Pos n) = Neg (plus_num m n);
minus_int (Pos m) (Neg n) = Pos (plus_num m n);
minus_int (Pos m) (Pos n) = sub m n;
minus_int Zero_int l = uminus_int l;
minus_int k Zero_int = k;

hd :: forall a. [a] -> a;
hd (x : xs) = x;

tl :: forall a. [a] -> [a];
tl [] = [];
tl (x : xs) = xs;

plus_nat :: Nat -> Nat -> Nat;
plus_nat Zero_nat n = n;
plus_nat m Zero_nat = m;
plus_nat (Nat_of_num k) (Nat_of_num l) = Nat_of_num (plus_num k l);

suc :: Nat -> Nat;
suc n = plus_nat n (Nat_of_num One);

data Order_tag = Lex | Mul;

list_of_dlist :: forall a. (Ceq a) => Set_dlist a -> [a];
list_of_dlist (Abs_dlist x) = x;

dlist_ex :: forall a. (Ceq a) => (a -> Bool) -> Set_dlist a -> Bool;
dlist_ex x xa = any x (list_of_dlist xa);

rBT_Impl_rbt_ex :: forall a b. (a -> b -> Bool) -> Rbta a b -> Bool;
rBT_Impl_rbt_ex p (Branch c l k v r) =
  p k v || (rBT_Impl_rbt_ex p l || rBT_Impl_rbt_ex p r);
rBT_Impl_rbt_ex p Emptya = False;

impl_ofa :: forall a b. (Corder a) => Mapping_rbt a b -> Rbta a b;
impl_ofa (Mapping_RBT x) = x;

ex :: forall a b. (Corder a) => (a -> b -> Bool) -> Mapping_rbt a b -> Bool;
ex x xa = rBT_Impl_rbt_ex x (impl_ofa xa);

data Nibble = Nibble0 | Nibble1 | Nibble2 | Nibble3 | Nibble4 | Nibble5
  | Nibble6 | Nibble7 | Nibble8 | Nibble9 | NibbleA | NibbleB | NibbleC
  | NibbleD | NibbleE | NibbleF;

bex :: forall a. (Ceq a, Corder a) => Set a -> (a -> Bool) -> Bool;
bex (RBT_set rbt) p =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing -> error "Bex RBT_set: corder = None" (\ _ -> bex (RBT_set rbt) p);
    Just _ -> ex (\ k _ -> p k) rbt;
  });
bex (DList_set dxs) p =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing -> error "Bex DList_set: ceq = None" (\ _ -> bex (DList_set dxs) p);
    Just _ -> dlist_ex p dxs;
  });
bex (Set_Monad xs) p = any p xs;

tag :: Xml -> [Prelude.Char];
tag (Xml name uu uv uw) = name;

dupa :: Nat -> Nat;
dupa (Nat_of_num k) = Nat_of_num (Bit0 k);
dupa Zero_nat = Zero_nat;

equal_num :: Num -> Num -> Bool;
equal_num (Bit1 numa) (Bit0 num) = False;
equal_num (Bit0 numa) (Bit1 num) = False;
equal_num (Bit1 num) One = False;
equal_num One (Bit1 num) = False;
equal_num (Bit0 num) One = False;
equal_num One (Bit0 num) = False;
equal_num (Bit1 numa) (Bit1 num) = equal_num numa num;
equal_num (Bit0 numa) (Bit0 num) = equal_num numa num;
equal_num One One = True;

equal_nat :: Nat -> Nat -> Bool;
equal_nat (Nat_of_num k) (Nat_of_num l) = equal_num k l;
equal_nat (Nat_of_num k) Zero_nat = False;
equal_nat Zero_nat (Nat_of_num l) = False;
equal_nat Zero_nat Zero_nat = True;

mapa :: forall a b. (a -> b) -> Maybe a -> Maybe b;
mapa f (Just x) = Just (f x);
mapa f Nothing = Nothing;

minus_nat :: Nat -> Nat -> Nat;
minus_nat Zero_nat n = Zero_nat;
minus_nat m Zero_nat = m;
minus_nat (Nat_of_num k) (Nat_of_num l) =
  (case suba k l of {
    Nothing -> Zero_nat;
    Just j -> j;
  });

suba :: Num -> Num -> Maybe Nat;
suba (Bit0 m) (Bit1 n) =
  (case suba m n of {
    Nothing -> Nothing;
    Just q ->
      (if equal_nat q Zero_nat then Nothing
        else Just (minus_nat (dupa q) (Nat_of_num One)));
  });
suba (Bit1 m) (Bit0 n) =
  mapa (\ q -> plus_nat (dupa q) (Nat_of_num One)) (suba m n);
suba (Bit1 m) (Bit1 n) = mapa dupa (suba m n);
suba (Bit0 m) (Bit0 n) = mapa dupa (suba m n);
suba One (Bit1 n) = Nothing;
suba One (Bit0 n) = Nothing;
suba (Bit1 m) One = Just (Nat_of_num (Bit0 m));
suba (Bit0 m) One = Just (Nat_of_num (bitM m));
suba One One = Just Zero_nat;

nth :: forall a. [a] -> Nat -> a;
nth (x : xs) n =
  (if equal_nat n Zero_nat then x else nth xs (minus_nat n (Nat_of_num One)));

set :: forall a. [a] -> Set a;
set = Set_Monad;

less_num :: Num -> Num -> Bool;
less_num (Bit1 m) (Bit0 n) = less_num m n;
less_num (Bit1 m) (Bit1 n) = less_num m n;
less_num (Bit0 m) (Bit1 n) = less_eq_num m n;
less_num (Bit0 m) (Bit0 n) = less_num m n;
less_num One (Bit1 n) = True;
less_num One (Bit0 n) = True;
less_num m One = False;

less_eq_num :: Num -> Num -> Bool;
less_eq_num (Bit1 m) (Bit0 n) = less_num m n;
less_eq_num (Bit1 m) (Bit1 n) = less_eq_num m n;
less_eq_num (Bit0 m) (Bit1 n) = less_eq_num m n;
less_eq_num (Bit0 m) (Bit0 n) = less_eq_num m n;
less_eq_num (Bit1 m) One = False;
less_eq_num (Bit0 m) One = False;
less_eq_num One n = True;

less_nat :: Nat -> Nat -> Bool;
less_nat (Nat_of_num k) (Nat_of_num l) = less_num k l;
less_nat Zero_nat (Nat_of_num l) = True;
less_nat m Zero_nat = False;

upt :: Nat -> Nat -> [Nat];
upt i j =
  (if less_nat i j then i : upt (plus_nat i (Nat_of_num One)) j else []);

data Partial_object_ext a b = Partial_object_ext (Set a) b;

data Monoid_ext a b = Monoid_ext (a -> a -> a) a b;

data Ring_ext a b = Ring_ext a (a -> a -> a) b;

add ::
  forall a b. Partial_object_ext a (Monoid_ext a (Ring_ext a b)) -> a -> a -> a;
add (Partial_object_ext carrier (Monoid_ext mult one (Ring_ext zero add more)))
  = add;

dlist_all :: forall a. (Ceq a) => (a -> Bool) -> Set_dlist a -> Bool;
dlist_all x xa = all x (list_of_dlist xa);

rBT_Impl_rbt_all :: forall a b. (a -> b -> Bool) -> Rbta a b -> Bool;
rBT_Impl_rbt_all p (Branch c l k v r) =
  p k v && rBT_Impl_rbt_all p l && rBT_Impl_rbt_all p r;
rBT_Impl_rbt_all p Emptya = True;

alla :: forall a b. (Corder a) => (a -> b -> Bool) -> Mapping_rbt a b -> Bool;
alla x xa = rBT_Impl_rbt_all x (impl_ofa xa);

ball :: forall a. (Ceq a, Corder a) => Set a -> (a -> Bool) -> Bool;
ball (RBT_set rbt) p =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      error "Ball RBT_set: corder = None" (\ _ -> ball (RBT_set rbt) p);
    Just _ -> alla (\ k _ -> p k) rbt;
  });
ball (DList_set dxs) p =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      error "Ball DList_set: ceq = None" (\ _ -> ball (DList_set dxs) p);
    Just _ -> dlist_all p dxs;
  });
ball (Set_Monad xs) p = all p xs;

data Term a b = Var b | Fun a [Term a b];

data Ctxt a b = Hole | More a [Term a b] (Ctxt a b) [Term a b];

data Sum a b = Inl a | Inr b;

newtype Sum_bot a b = Sumbot (Sum a b);

returna :: forall a b. a -> Sum_bot b a;
returna x = Sumbot (Inr x);

errora :: forall a b. a -> Sum_bot a b;
errora x = Sumbot (Inl x);

int_of_digit :: Prelude.Char -> Sum_bot [Prelude.Char] Int;
int_of_digit x =
  (if x == '0' then returna Zero_int
    else (if x == '1' then returna (Pos One)
           else (if x == '2' then returna (Pos (Bit0 One))
                  else (if x == '3' then returna (Pos (Bit1 One))
                         else (if x == '4' then returna (Pos (Bit0 (Bit0 One)))
                                else (if x == '5'
                                       then returna (Pos (Bit1 (Bit0 One)))
                                       else (if x == '6'
      then returna (Pos (Bit0 (Bit1 One)))
      else (if x == '7' then returna (Pos (Bit1 (Bit1 One)))
             else (if x == '8' then returna (Pos (Bit0 (Bit0 (Bit0 One))))
                    else (if x == '9'
                           then returna (Pos (Bit1 (Bit0 (Bit0 One))))
                           else errora
                                  [x, ' ', 'i', 's', ' ', 'n', 'o', 't', ' ',
                                    'a', ' ', 'd', 'i', 'g', 'i',
                                    't']))))))))));

binda :: forall a b c. Sum_bot a b -> (b -> Sum_bot a c) -> Sum_bot a c;
binda (Sumbot a) f = (case a of {
                       Inl b -> Sumbot (Inl b);
                       Inr aa -> f aa;
                     });

times_num :: Num -> Num -> Num;
times_num (Bit1 m) (Bit1 n) =
  Bit1 (plus_num (plus_num m n) (Bit0 (times_num m n)));
times_num (Bit1 m) (Bit0 n) = Bit0 (times_num (Bit1 m) n);
times_num (Bit0 m) (Bit1 n) = Bit0 (times_num m (Bit1 n));
times_num (Bit0 m) (Bit0 n) = Bit0 (Bit0 (times_num m n));
times_num One n = n;
times_num m One = m;

times_int :: Int -> Int -> Int;
times_int (Neg m) (Neg n) = Pos (times_num m n);
times_int (Neg m) (Pos n) = Neg (times_num m n);
times_int (Pos m) (Neg n) = Neg (times_num m n);
times_int (Pos m) (Pos n) = Pos (times_num m n);
times_int Zero_int l = Zero_int;
times_int k Zero_int = Zero_int;

int_of_string_aux :: Int -> [Prelude.Char] -> Sum_bot [Prelude.Char] Int;
int_of_string_aux n [] = returna n;
int_of_string_aux n (d : s) =
  binda (int_of_digit d)
    (\ m ->
      int_of_string_aux
        (plus_int (times_int (Pos (Bit0 (Bit1 (Bit0 One)))) n) m) s);

take :: forall a. Nat -> [a] -> [a];
take n [] = [];
take n (x : xs) =
  (if equal_nat n Zero_nat then []
    else x : take (minus_nat n (Nat_of_num One)) xs);

int_of_string :: [Prelude.Char] -> Sum_bot [Prelude.Char] Int;
int_of_string s =
  (if null s
    then errora
           ['c', 'a', 'n', 'n', 'o', 't', ' ', 'c', 'o', 'n', 'v', 'e', 'r',
             't', ' ', 'e', 'm', 'p', 't', 'y', ' ', 's', 't', 'r', 'i', 'n',
             'g', ' ', 'i', 'n', 't', 'o', ' ', 'n', 'u', 'm', 'b', 'e', 'r']
    else (if take (Nat_of_num One) s == ['-']
           then binda (int_of_string_aux Zero_int (tl s))
                  (\ i -> returna (minus_int Zero_int i))
           else int_of_string_aux Zero_int s));

class Showa a where {
  shows_prec :: Nat -> a -> [Prelude.Char] -> [Prelude.Char];
  shows_list :: [a] -> [Prelude.Char] -> [Prelude.Char];
};

shows_prec_list ::
  forall a. (Showa a) => Nat -> [a] -> [Prelude.Char] -> [Prelude.Char];
shows_prec_list d l = shows_list l;

shows_string :: [Prelude.Char] -> [Prelude.Char] -> [Prelude.Char];
shows_string = (\ a b -> a ++ b);

shows_prec_char :: Nat -> Prelude.Char -> [Prelude.Char] -> [Prelude.Char];
shows_prec_char d c = (\ a -> c : a);

shows_list_char :: [Prelude.Char] -> [Prelude.Char] -> [Prelude.Char];
shows_list_char cs = shows_string cs;

instance Showa Prelude.Char where {
  shows_prec = shows_prec_char;
  shows_list = shows_list_char;
};

shows_attr ::
  ([Prelude.Char], [Prelude.Char]) -> [Prelude.Char] -> [Prelude.Char];
shows_attr av =
  shows_prec_list Zero_nat (fst av) .
    shows_string ['='] . shows_string ('\"' : snd av ++ ['\"']);

shows_map ::
  forall a.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      [a] -> [Prelude.Char] -> [Prelude.Char];
shows_map s [] = id;
shows_map s (x : xs) = s x . shows_map s xs;

shows_attrs ::
  [([Prelude.Char], [Prelude.Char])] -> [Prelude.Char] -> [Prelude.Char];
shows_attrs asa = shows_map (\ a -> shows_string [' '] . shows_attr a) asa;

is_none :: forall a. Maybe a -> Bool;
is_none (Just x) = False;
is_none Nothing = True;

replicate :: forall a. Nat -> a -> [a];
replicate n x =
  (if equal_nat n Zero_nat then []
    else x : replicate (minus_nat n (Nat_of_num One)) x);

the :: forall a. Maybe a -> a;
the (Just x) = x;

shows_XML_indent ::
  [Prelude.Char] -> Nat -> Xml -> [Prelude.Char] -> [Prelude.Char];
shows_XML_indent ind i (Xml n a c t) =
  shows_string ind .
    shows_string ['<'] .
      shows_prec_list Zero_nat n .
        shows_attrs a .
          (if null c && is_none t then shows_string ['/', '>']
            else shows_string ['>'] .
                   (if not (null c)
                     then shows_map
                            (shows_XML_indent (ind ++ replicate i ' ') i) c .
                            shows_string ind
                     else id) .
                     (if is_none t then id else shows_string (the t)) .
                       shows_string ['<', '/'] .
                         shows_prec_list Zero_nat n . shows_string ['>']);

shows_prec_xml :: Nat -> Xml -> [Prelude.Char] -> [Prelude.Char];
shows_prec_xml d xml = shows_XML_indent ['\n'] (Nat_of_num (Bit0 One)) xml;

text :: [Prelude.Char] -> Xml -> Sum_bot [Prelude.Char] [Prelude.Char];
text tag (Xml n atts cs t) =
  (if n == tag && null atts && null cs && not (is_none t) && not (null (the t))
    then returna (the t)
    else errora
           (concat
             [['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'x', 't',
                'r', 'a', 'c', 't', ' ', 't', 'e', 'x', 't', ' ', 'f', 'o', 'r',
                ' '],
               tag, [' ', 'f', 'r', 'o', 'm', ' '], ['\n'],
               shows_prec_xml Zero_nat (Xml n atts cs t) []]));

int :: [Prelude.Char] -> Xml -> Sum_bot [Prelude.Char] Int;
int tag x = binda (text tag x) int_of_string;

nata :: [Prelude.Char] -> Xml -> Sum_bot [Prelude.Char] Nat;
nata tag x =
  binda (text tag x)
    (\ txt -> binda (int_of_string txt) (\ i -> returna (nat i)));

quotient_of :: Rat -> (Int, Int);
quotient_of (Frct x) = x;

apsnd :: forall a b c. (a -> b) -> (c, a) -> (c, b);
apsnd f (x, y) = (x, f y);

class Plus a where {
  plus :: a -> a -> a;
};

class (Plus a) => Semigroup_add a where {
};

class (Semigroup_add a) => Cancel_semigroup_add a where {
};

class (Semigroup_add a) => Ab_semigroup_add a where {
};

class (Ab_semigroup_add a,
        Cancel_semigroup_add a) => Cancel_ab_semigroup_add a where {
};

class Zero a where {
  zeroa :: a;
};

class (Semigroup_add a, Zero a) => Monoid_add a where {
};

class (Ab_semigroup_add a, Monoid_add a) => Comm_monoid_add a where {
};

class (Cancel_ab_semigroup_add a,
        Comm_monoid_add a) => Cancel_comm_monoid_add a where {
};

class Times a where {
  times :: a -> a -> a;
};

class (Times a, Zero a) => Mult_zero a where {
};

class (Times a) => Semigroup_mult a where {
};

class (Ab_semigroup_add a, Semigroup_mult a) => Semiring a where {
};

class (Comm_monoid_add a, Mult_zero a, Semiring a) => Semiring_0 a where {
};

class (Cancel_comm_monoid_add a, Semiring_0 a) => Semiring_0_cancel a where {
};

class (Semigroup_mult a) => Ab_semigroup_mult a where {
};

class (Ab_semigroup_mult a, Semiring a) => Comm_semiring a where {
};

class (Comm_semiring a, Semiring_0 a) => Comm_semiring_0 a where {
};

class (Comm_semiring_0 a,
        Semiring_0_cancel a) => Comm_semiring_0_cancel a where {
};

class One a where {
  onea :: a;
};

class (One a, Times a) => Power a where {
};

class (Semigroup_mult a, Power a) => Monoid_mult a where {
};

class (One a, Semigroup_add a) => Numeral a where {
};

class (Monoid_mult a, Numeral a, Semiring a) => Semiring_numeral a where {
};

class (One a, Zero a) => Zero_neq_one a where {
};

class (Semiring_numeral a, Semiring_0 a, Zero_neq_one a) => Semiring_1 a where {
};

class (Semiring_0_cancel a, Semiring_1 a) => Semiring_1_cancel a where {
};

class (Ab_semigroup_mult a, Monoid_mult a) => Comm_monoid_mult a where {
};

class (Times a) => Dvd a where {
};

class (Comm_monoid_mult a, Comm_semiring_0 a, Dvd a,
        Semiring_1 a) => Comm_semiring_1 a where {
};

class (Comm_semiring_0_cancel a, Comm_semiring_1 a,
        Semiring_1_cancel a) => Comm_semiring_1_cancel a where {
};

class (Times a, Zero a) => No_zero_divisors a where {
};

class (Dvd a) => Div a where {
  div :: a -> a -> a;
  mod :: a -> a -> a;
};

class (Div a, Comm_semiring_1_cancel a,
        No_zero_divisors a) => Semiring_div a where {
};

class Minus a where {
  minus :: a -> a -> a;
};

class (Ab_semigroup_add a, Order a) => Ordered_ab_semigroup_add a where {
};

class (Comm_monoid_add a, Ordered_ab_semigroup_add a,
        Semiring a) => Ordered_semiring a where {
};

class (Ordered_semiring a,
        Semiring_0_cancel a) => Ordered_cancel_semiring a where {
};

class (Comm_semiring_0 a, Ordered_semiring a) => Ordered_comm_semiring a where {
};

class (Comm_semiring_0_cancel a, Ordered_cancel_semiring a,
        Ordered_comm_semiring a) => Ordered_cancel_comm_semiring a where {
};

class (Cancel_ab_semigroup_add a,
        Ordered_ab_semigroup_add a) => Ordered_cancel_ab_semigroup_add a where {
};

class (Ordered_cancel_ab_semigroup_add a) => Ordered_ab_semigroup_add_imp_le a where {
};

class (Ordered_ab_semigroup_add a,
        Linorder a) => Linordered_ab_semigroup_add a where {
};

class (Linordered_ab_semigroup_add a,
        Ordered_ab_semigroup_add_imp_le a) => Linordered_cancel_ab_semigroup_add a where {
};

class (Comm_monoid_add a,
        Ordered_cancel_ab_semigroup_add a) => Ordered_comm_monoid_add a where {
};

class (Linordered_cancel_ab_semigroup_add a, Ordered_comm_monoid_add a,
        Ordered_cancel_semiring a) => Linordered_semiring a where {
};

class (Linordered_semiring a) => Linordered_semiring_strict a where {
};

class (Linordered_semiring_strict a,
        Ordered_cancel_comm_semiring a) => Linordered_comm_semiring_strict a where {
};

class (Semiring_1 a) => Semiring_char_0 a where {
};

class (Semiring_char_0 a, Comm_semiring_1_cancel a,
        Linordered_comm_semiring_strict a) => Linordered_semidom a where {
};

class (Semiring_div a, Minus a,
        Linordered_semidom a) => Semiring_numeral_div a where {
};

instance Plus Int where {
  plus = plus_int;
};

instance Semigroup_add Int where {
};

instance Cancel_semigroup_add Int where {
};

instance Ab_semigroup_add Int where {
};

instance Cancel_ab_semigroup_add Int where {
};

instance Zero Int where {
  zeroa = Zero_int;
};

instance Monoid_add Int where {
};

instance Comm_monoid_add Int where {
};

instance Cancel_comm_monoid_add Int where {
};

instance Times Int where {
  times = times_int;
};

instance Mult_zero Int where {
};

instance Semigroup_mult Int where {
};

instance Semiring Int where {
};

instance Semiring_0 Int where {
};

instance Semiring_0_cancel Int where {
};

less_eq_int :: Int -> Int -> Bool;
less_eq_int (Neg k) (Neg l) = less_eq_num l k;
less_eq_int (Neg k) (Pos l) = True;
less_eq_int (Neg k) Zero_int = True;
less_eq_int (Pos k) (Neg l) = False;
less_eq_int (Pos k) (Pos l) = less_eq_num k l;
less_eq_int (Pos k) Zero_int = False;
less_eq_int Zero_int (Neg l) = False;
less_eq_int Zero_int (Pos l) = True;
less_eq_int Zero_int Zero_int = True;

less_int :: Int -> Int -> Bool;
less_int (Neg k) (Neg l) = less_num l k;
less_int (Neg k) (Pos l) = True;
less_int (Neg k) Zero_int = True;
less_int (Pos k) (Neg l) = False;
less_int (Pos k) (Pos l) = less_num k l;
less_int (Pos k) Zero_int = False;
less_int Zero_int (Neg l) = False;
less_int Zero_int (Pos l) = True;
less_int Zero_int Zero_int = False;

instance Ord Int where {
  less_eq = less_eq_int;
  less = less_int;
};

instance Preorder Int where {
};

instance Order Int where {
};

instance Ordered_ab_semigroup_add Int where {
};

instance Ordered_semiring Int where {
};

instance Ordered_cancel_semiring Int where {
};

instance Ab_semigroup_mult Int where {
};

instance Comm_semiring Int where {
};

instance Comm_semiring_0 Int where {
};

instance Comm_semiring_0_cancel Int where {
};

instance Ordered_comm_semiring Int where {
};

instance Ordered_cancel_comm_semiring Int where {
};

instance Ordered_cancel_ab_semigroup_add Int where {
};

instance Ordered_ab_semigroup_add_imp_le Int where {
};

instance Linorder Int where {
};

instance Linordered_ab_semigroup_add Int where {
};

instance Linordered_cancel_ab_semigroup_add Int where {
};

instance Ordered_comm_monoid_add Int where {
};

instance Linordered_semiring Int where {
};

instance Linordered_semiring_strict Int where {
};

instance Linordered_comm_semiring_strict Int where {
};

one_int :: Int;
one_int = Pos One;

instance One Int where {
  onea = one_int;
};

instance Power Int where {
};

instance Monoid_mult Int where {
};

instance Numeral Int where {
};

instance Semiring_numeral Int where {
};

instance Zero_neq_one Int where {
};

instance Semiring_1 Int where {
};

instance Semiring_1_cancel Int where {
};

instance Comm_monoid_mult Int where {
};

instance Dvd Int where {
};

instance Comm_semiring_1 Int where {
};

instance Comm_semiring_1_cancel Int where {
};

instance Semiring_char_0 Int where {
};

instance Linordered_semidom Int where {
};

instance No_zero_divisors Int where {
};

instance Minus Int where {
  minus = minus_int;
};

numeral :: forall a. (Numeral a) => Num -> a;
numeral (Bit1 n) = let {
                     m = numeral n;
                   } in plus (plus m m) onea;
numeral (Bit0 n) = let {
                     m = numeral n;
                   } in plus m m;
numeral One = onea;

divmod_step :: forall a. (Semiring_numeral_div a) => Num -> (a, a) -> (a, a);
divmod_step l (q, r) =
  (if less_eq (numeral l) r
    then (plus (times (numeral (Bit0 One)) q) onea, minus r (numeral l))
    else (times (numeral (Bit0 One)) q, r));

divmod :: forall a. (Semiring_numeral_div a) => Num -> Num -> (a, a);
divmod (Bit1 m) (Bit0 n) =
  let {
    (q, r) = divmod m n;
  } in (q, plus (times (numeral (Bit0 One)) r) onea);
divmod (Bit0 m) (Bit0 n) =
  let {
    (q, r) = divmod m n;
  } in (q, times (numeral (Bit0 One)) r);
divmod m n =
  (if less_num m n then (zeroa, numeral m)
    else divmod_step n (divmod m (Bit0 n)));

abs_int :: Int -> Int;
abs_int i = (if less_int i Zero_int then uminus_int i else i);

equal_int :: Int -> Int -> Bool;
equal_int (Neg k) (Neg l) = equal_num k l;
equal_int (Neg k) (Pos l) = False;
equal_int (Neg k) Zero_int = False;
equal_int (Pos k) (Neg l) = False;
equal_int (Pos k) (Pos l) = equal_num k l;
equal_int (Pos k) Zero_int = False;
equal_int Zero_int (Neg l) = False;
equal_int Zero_int (Pos l) = False;
equal_int Zero_int Zero_int = True;

sgn_int :: Int -> Int;
sgn_int i =
  (if equal_int i Zero_int then Zero_int
    else (if less_int Zero_int i then Pos One else uminus_int (Pos One)));

div_int :: Int -> Int -> Int;
div_int a b = fst (divmod_int a b);

instance Semiring_numeral_div Int where {
};

divmod_abs :: Int -> Int -> (Int, Int);
divmod_abs Zero_int j = (Zero_int, Zero_int);
divmod_abs j Zero_int = (Zero_int, abs_int j);
divmod_abs (Pos k) (Neg l) = divmod k l;
divmod_abs (Neg k) (Pos l) = divmod k l;
divmod_abs (Neg k) (Neg l) = divmod k l;
divmod_abs (Pos k) (Pos l) = divmod k l;

divmod_int :: Int -> Int -> (Int, Int);
divmod_int k l =
  (if equal_int k Zero_int then (Zero_int, Zero_int)
    else (if equal_int l Zero_int then (Zero_int, k)
           else apsnd (times_int (sgn_int l))
                  (if equal_int (sgn_int k) (sgn_int l) then divmod_abs k l
                    else let {
                           (r, s) = divmod_abs k l;
                         } in (if equal_int s Zero_int
                                then (uminus_int r, Zero_int)
                                else (minus_int (uminus_int r) (Pos One),
                                       minus_int (abs_int l) s)))));

mod_int :: Int -> Int -> Int;
mod_int a b = snd (divmod_int a b);

instance Div Int where {
  div = div_int;
  mod = mod_int;
};

instance Semiring_div Int where {
};

gcd_int :: Int -> Int -> Int;
gcd_int k l =
  abs_int
    (if equal_int l Zero_int then k
      else gcd_int l (mod_int (abs_int k) (abs_int l)));

normalize :: (Int, Int) -> (Int, Int);
normalize p =
  (if less_int Zero_int (snd p)
    then let {
           a = gcd_int (fst p) (snd p);
         } in (div_int (fst p) a, div_int (snd p) a)
    else (if equal_int (snd p) Zero_int then (Zero_int, Pos One)
           else let {
                  a = uminus_int (gcd_int (fst p) (snd p));
                } in (div_int (fst p) a, div_int (snd p) a)));

divide_rat :: Rat -> Rat -> Rat;
divide_rat p q =
  Frct (let {
          (a, c) = quotient_of p;
          (b, d) = quotient_of q;
        } in normalize (times_int a d, times_int c b));

map_of :: forall a b. (Eq a) => [(a, b)] -> a -> Maybe b;
map_of ((l, v) : ps) k = (if l == k then Just v else map_of ps k);
map_of [] k = Nothing;

options ::
  forall a.
    [([Prelude.Char], Xml -> Sum_bot [Prelude.Char] a)] ->
      Xml -> Sum_bot [Prelude.Char] a;
options ps x =
  (case map_of ps (tag x) of {
    Nothing ->
      errora
        (concat
          [['e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'o', 'n', 'e', ' ',
             'o', 'f', ':', ' '],
            concatMap (\ p -> fst p ++ [' ']) ps, ['\n'],
            ['b', 'u', 't', ' ', 'f', 'o', 'u', 'n', 'd'], ['\n'],
            shows_prec_xml Zero_nat x []]);
    Just p -> p x;
  });

change ::
  forall a b.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      (a -> b) -> Xml -> Sum_bot [Prelude.Char] b;
change p f x = binda (p x) (\ a -> returna (f a));

of_int :: Int -> Rat;
of_int a = Frct (a, Pos One);

list2elements :: forall a. [a] -> Maybe (a, a);
list2elements [x, y] = Just (x, y);
list2elements [] = Nothing;
list2elements [v] = Nothing;
list2elements (v : vb : vd : ve) = Nothing;

fail :: forall a. [Prelude.Char] -> Xml -> Sum_bot [Prelude.Char] a;
fail tag xml =
  errora
    (concat
      [['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 't', 'r', 'a', 'n',
         's', 'f', 'o', 'r', 'm', ' ', 't', 'h', 'e', ' ', 'f', 'o', 'l', 'l',
         'o', 'w', 'i', 'n', 'g', ' ', 'x', 'm', 'l', ' ', 'e', 'l', 'e', 'm',
         'e', 'n', 't', ' ', '(', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' '],
        tag, [')'], ['\n'], shows_prec_xml Zero_nat xml []]);

pair ::
  forall a b c.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (Xml -> Sum_bot [Prelude.Char] b) ->
          (a -> b -> c) -> Xml -> Sum_bot [Prelude.Char] c;
pair tag p1 p2 f xml =
  let {
    (Xml name atts cs text) = xml;
  } in (if name == tag && null atts && is_none text
         then (case list2elements cs of {
                Nothing -> fail tag xml;
                Just (cs1, cs2) ->
                  binda (p1 cs1)
                    (\ a -> binda (p2 cs2) (\ b -> returna (f a b)));
              })
         else fail tag xml);

rat :: Xml -> Sum_bot [Prelude.Char] Rat;
rat = options
        [(['i', 'n', 't', 'e', 'g', 'e', 'r'],
           change (int ['i', 'n', 't', 'e', 'g', 'e', 'r']) of_int),
          (['r', 'a', 't', 'i', 'o', 'n', 'a', 'l'],
            pair ['r', 'a', 't', 'i', 'o', 'n', 'a', 'l']
              (int ['n', 'u', 'm', 'e', 'r', 'a', 't', 'o', 'r'])
              (int ['d', 'e', 'n', 'o', 'm', 'i', 'n', 'a', 't', 'o', 'r'])
              (\ x y -> divide_rat (of_int x) (of_int y)))];

one :: forall a b. Partial_object_ext a (Monoid_ext a b) -> a;
one (Partial_object_ext carrier (Monoid_ext mult one more)) = one;

drop :: forall a. Nat -> [a] -> [a];
drop n [] = [];
drop n (x : xs) =
  (if equal_nat n Zero_nat then x : xs
    else drop (minus_nat n (Nat_of_num One)) xs);

find :: forall a. (a -> Bool) -> [a] -> Maybe a;
find uu [] = Nothing;
find p (x : xs) = (if p x then Just x else find p xs);

fold :: forall a b. (a -> b -> b) -> [a] -> b -> b;
fold f (x : xs) s = fold f xs (f x s);
fold f [] s = s;

last :: forall a. [a] -> a;
last (x : xs) = (if null xs then x else last xs);

data Itself a = Type;

empty :: forall a b. (Linorder a) => Rbt a b;
empty = Rbt Emptya;

zero :: forall a b. Partial_object_ext a (Monoid_ext a (Ring_ext a b)) -> a;
zero (Partial_object_ext carrier (Monoid_ext mult one (Ring_ext zero add more)))
  = zero;

newtype Phantom a b = Phantom b;

data Set_impl = Set_Choose | Set_Collect | Set_DList | Set_RBT | Set_Monada;

class Set_impla a where {
  set_impl :: Phantom a Set_impl;
};

foldd :: forall a b. (Ceq a) => (a -> b -> b) -> Set_dlist a -> b -> b;
foldd x xa = fold x (list_of_dlist xa);

foldb :: forall a b c. (a -> b -> c -> c) -> Rbta a b -> c -> c;
foldb f (Branch c lt k v rt) x = foldb f rt (f k v (foldb f lt x));
foldb f Emptya x = x;

foldc :: forall a b. (Corder a) => (a -> b -> b) -> Mapping_rbt a () -> b -> b;
foldc x xa = foldb (\ a _ -> x a) (impl_ofa xa);

of_phantom :: forall a b. Phantom a b -> b;
of_phantom (Phantom x) = x;

emptyc :: forall a b. (Corder a) => Mapping_rbt a b;
emptyc = Mapping_RBT Emptya;

emptyb :: forall a. (Ceq a) => Set_dlist a;
emptyb = Abs_dlist [];

set_empty_choose :: forall a. (Ceq a, Corder a) => Set a;
set_empty_choose =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      (case (ceq :: Maybe (a -> a -> Bool)) of {
        Nothing -> Set_Monad [];
        Just _ -> DList_set emptyb;
      });
    Just _ -> RBT_set emptyc;
  });

set_empty :: forall a. (Ceq a, Corder a) => Set_impl -> Set a;
set_empty Set_Choose = set_empty_choose;
set_empty Set_Monada = Set_Monad [];
set_empty Set_RBT = RBT_set emptyc;
set_empty Set_DList = DList_set emptyb;
set_empty Set_Collect = Collect_set (\ _ -> False);

bot_set :: forall a. (Ceq a, Corder a, Set_impla a) => Set a;
bot_set = set_empty (of_phantom (set_impl :: Phantom a Set_impl));

balance :: forall a b. Rbta a b -> a -> b -> Rbta a b -> Rbta a b;
balance (Branch R a w x b) s t (Branch R c y z d) =
  Branch R (Branch B a w x b) s t (Branch B c y z d);
balance (Branch R (Branch R a w x b) s t c) y z Emptya =
  Branch R (Branch B a w x b) s t (Branch B c y z Emptya);
balance (Branch R (Branch R a w x b) s t c) y z (Branch B va vb vc vd) =
  Branch R (Branch B a w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch R Emptya w x (Branch R b s t c)) y z Emptya =
  Branch R (Branch B Emptya w x b) s t (Branch B c y z Emptya);
balance (Branch R (Branch B va vb vc vd) w x (Branch R b s t c)) y z Emptya =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z Emptya);
balance (Branch R Emptya w x (Branch R b s t c)) y z (Branch B va vb vc vd) =
  Branch R (Branch B Emptya w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch R (Branch B ve vf vg vh) w x (Branch R b s t c)) y z
  (Branch B va vb vc vd) =
  Branch R (Branch B (Branch B ve vf vg vh) w x b) s t
    (Branch B c y z (Branch B va vb vc vd));
balance Emptya w x (Branch R b s t (Branch R c y z d)) =
  Branch R (Branch B Emptya w x b) s t (Branch B c y z d);
balance (Branch B va vb vc vd) w x (Branch R b s t (Branch R c y z d)) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z d);
balance Emptya w x (Branch R (Branch R b s t c) y z Emptya) =
  Branch R (Branch B Emptya w x b) s t (Branch B c y z Emptya);
balance Emptya w x (Branch R (Branch R b s t c) y z (Branch B va vb vc vd)) =
  Branch R (Branch B Emptya w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch B va vb vc vd) w x (Branch R (Branch R b s t c) y z Emptya) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z Emptya);
balance (Branch B va vb vc vd) w x
  (Branch R (Branch R b s t c) y z (Branch B ve vf vg vh)) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t
    (Branch B c y z (Branch B ve vf vg vh));
balance Emptya s t Emptya = Branch B Emptya s t Emptya;
balance Emptya s t (Branch B va vb vc vd) =
  Branch B Emptya s t (Branch B va vb vc vd);
balance Emptya s t (Branch v Emptya vb vc Emptya) =
  Branch B Emptya s t (Branch v Emptya vb vc Emptya);
balance Emptya s t (Branch v (Branch B ve vf vg vh) vb vc Emptya) =
  Branch B Emptya s t (Branch v (Branch B ve vf vg vh) vb vc Emptya);
balance Emptya s t (Branch v Emptya vb vc (Branch B vf vg vh vi)) =
  Branch B Emptya s t (Branch v Emptya vb vc (Branch B vf vg vh vi));
balance Emptya s t
  (Branch v (Branch B ve vj vk vl) vb vc (Branch B vf vg vh vi)) =
  Branch B Emptya s t
    (Branch v (Branch B ve vj vk vl) vb vc (Branch B vf vg vh vi));
balance (Branch B va vb vc vd) s t Emptya =
  Branch B (Branch B va vb vc vd) s t Emptya;
balance (Branch B va vb vc vd) s t (Branch B ve vf vg vh) =
  Branch B (Branch B va vb vc vd) s t (Branch B ve vf vg vh);
balance (Branch B va vb vc vd) s t (Branch v Emptya vf vg Emptya) =
  Branch B (Branch B va vb vc vd) s t (Branch v Emptya vf vg Emptya);
balance (Branch B va vb vc vd) s t
  (Branch v (Branch B vi vj vk vl) vf vg Emptya) =
  Branch B (Branch B va vb vc vd) s t
    (Branch v (Branch B vi vj vk vl) vf vg Emptya);
balance (Branch B va vb vc vd) s t
  (Branch v Emptya vf vg (Branch B vj vk vl vm)) =
  Branch B (Branch B va vb vc vd) s t
    (Branch v Emptya vf vg (Branch B vj vk vl vm));
balance (Branch B va vb vc vd) s t
  (Branch v (Branch B vi vn vo vp) vf vg (Branch B vj vk vl vm)) =
  Branch B (Branch B va vb vc vd) s t
    (Branch v (Branch B vi vn vo vp) vf vg (Branch B vj vk vl vm));
balance (Branch v Emptya vb vc Emptya) s t Emptya =
  Branch B (Branch v Emptya vb vc Emptya) s t Emptya;
balance (Branch v Emptya vb vc (Branch B ve vf vg vh)) s t Emptya =
  Branch B (Branch v Emptya vb vc (Branch B ve vf vg vh)) s t Emptya;
balance (Branch v (Branch B vf vg vh vi) vb vc Emptya) s t Emptya =
  Branch B (Branch v (Branch B vf vg vh vi) vb vc Emptya) s t Emptya;
balance (Branch v (Branch B vf vg vh vi) vb vc (Branch B ve vj vk vl)) s t
  Emptya =
  Branch B (Branch v (Branch B vf vg vh vi) vb vc (Branch B ve vj vk vl)) s t
    Emptya;
balance (Branch v Emptya vf vg Emptya) s t (Branch B va vb vc vd) =
  Branch B (Branch v Emptya vf vg Emptya) s t (Branch B va vb vc vd);
balance (Branch v Emptya vf vg (Branch B vi vj vk vl)) s t
  (Branch B va vb vc vd) =
  Branch B (Branch v Emptya vf vg (Branch B vi vj vk vl)) s t
    (Branch B va vb vc vd);
balance (Branch v (Branch B vj vk vl vm) vf vg Emptya) s t
  (Branch B va vb vc vd) =
  Branch B (Branch v (Branch B vj vk vl vm) vf vg Emptya) s t
    (Branch B va vb vc vd);
balance (Branch v (Branch B vj vk vl vm) vf vg (Branch B vi vn vo vp)) s t
  (Branch B va vb vc vd) =
  Branch B (Branch v (Branch B vj vk vl vm) vf vg (Branch B vi vn vo vp)) s t
    (Branch B va vb vc vd);

rbt_insa ::
  forall a b.
    (a -> a -> Bool) -> (a -> b -> b -> b) -> a -> b -> Rbta a b -> Rbta a b;
rbt_insa less f k v (Branch R l x y r) =
  (if less k x then Branch R (rbt_insa less f k v l) x y r
    else (if less x k then Branch R l x y (rbt_insa less f k v r)
           else Branch R l x (f k y v) r));
rbt_insa less f k v (Branch B l x y r) =
  (if less k x then balance (rbt_insa less f k v l) x y r
    else (if less x k then balance l x y (rbt_insa less f k v r)
           else Branch B l x (f k y v) r));
rbt_insa less f k v Emptya = Branch R Emptya k v Emptya;

paint :: forall a b. Color -> Rbta a b -> Rbta a b;
paint c Emptya = Emptya;
paint c (Branch uu l k v r) = Branch c l k v r;

rbt_insert_with_keya ::
  forall a b.
    (a -> a -> Bool) -> (a -> b -> b -> b) -> a -> b -> Rbta a b -> Rbta a b;
rbt_insert_with_keya less f k v t = paint B (rbt_insa less f k v t);

rbt_inserta :: forall a b. (a -> a -> Bool) -> a -> b -> Rbta a b -> Rbta a b;
rbt_inserta less = rbt_insert_with_keya less (\ _ _ nv -> nv);

insertd ::
  forall a b. (Corder a) => a -> b -> Mapping_rbt a b -> Mapping_rbt a b;
insertd x xa xb =
  Mapping_RBT (rbt_inserta (snd (the corder)) x xa (impl_ofa xb));

fun_upda :: forall a b. (a -> a -> Bool) -> (a -> b) -> a -> b -> a -> b;
fun_upda equal f aa b a = (if equal aa a then b else f a);

list_member :: forall a. (a -> a -> Bool) -> [a] -> a -> Bool;
list_member equal (x : xs) y = equal x y || list_member equal xs y;
list_member equal [] y = False;

list_insert :: forall a. (a -> a -> Bool) -> a -> [a] -> [a];
list_insert equal x xs = (if list_member equal xs x then xs else x : xs);

insertc :: forall a. (Ceq a) => a -> Set_dlist a -> Set_dlist a;
insertc x xa = Abs_dlist (list_insert (the ceq) x (list_of_dlist xa));

balance_right :: forall a b. Rbta a b -> a -> b -> Rbta a b -> Rbta a b;
balance_right a k x (Branch R b s y c) = Branch R a k x (Branch B b s y c);
balance_right (Branch B a k x b) s y Emptya =
  balance (Branch R a k x b) s y Emptya;
balance_right (Branch B a k x b) s y (Branch B va vb vc vd) =
  balance (Branch R a k x b) s y (Branch B va vb vc vd);
balance_right (Branch R a k x (Branch B b s y c)) t z Emptya =
  Branch R (balance (paint R a) k x b) s y (Branch B c t z Emptya);
balance_right (Branch R a k x (Branch B b s y c)) t z (Branch B va vb vc vd) =
  Branch R (balance (paint R a) k x b) s y
    (Branch B c t z (Branch B va vb vc vd));
balance_right Emptya k x Emptya = Emptya;
balance_right (Branch R va vb vc Emptya) k x Emptya = Emptya;
balance_right (Branch R va vb vc (Branch R ve vf vg vh)) k x Emptya = Emptya;
balance_right Emptya k x (Branch B va vb vc vd) = Emptya;
balance_right (Branch R ve vf vg Emptya) k x (Branch B va vb vc vd) = Emptya;
balance_right (Branch R ve vf vg (Branch R vi vj vk vl)) k x
  (Branch B va vb vc vd) = Emptya;

balance_left :: forall a b. Rbta a b -> a -> b -> Rbta a b -> Rbta a b;
balance_left (Branch R a k x b) s y c = Branch R (Branch B a k x b) s y c;
balance_left Emptya k x (Branch B a s y b) =
  balance Emptya k x (Branch R a s y b);
balance_left (Branch B va vb vc vd) k x (Branch B a s y b) =
  balance (Branch B va vb vc vd) k x (Branch R a s y b);
balance_left Emptya k x (Branch R (Branch B a s y b) t z c) =
  Branch R (Branch B Emptya k x a) s y (balance b t z (paint R c));
balance_left (Branch B va vb vc vd) k x (Branch R (Branch B a s y b) t z c) =
  Branch R (Branch B (Branch B va vb vc vd) k x a) s y
    (balance b t z (paint R c));
balance_left Emptya k x Emptya = Emptya;
balance_left Emptya k x (Branch R Emptya vb vc vd) = Emptya;
balance_left Emptya k x (Branch R (Branch R ve vf vg vh) vb vc vd) = Emptya;
balance_left (Branch B va vb vc vd) k x Emptya = Emptya;
balance_left (Branch B va vb vc vd) k x (Branch R Emptya vf vg vh) = Emptya;
balance_left (Branch B va vb vc vd) k x
  (Branch R (Branch R vi vj vk vl) vf vg vh) = Emptya;

combine :: forall a b. Rbta a b -> Rbta a b -> Rbta a b;
combine Emptya x = x;
combine (Branch v va vb vc vd) Emptya = Branch v va vb vc vd;
combine (Branch R a k x b) (Branch R c s y d) =
  (case combine b c of {
    Emptya -> Branch R a k x (Branch R Emptya s y d);
    Branch R b2 t z c2 -> Branch R (Branch R a k x b2) t z (Branch R c2 s y d);
    Branch B b2 t z c2 -> Branch R a k x (Branch R (Branch B b2 t z c2) s y d);
  });
combine (Branch B a k x b) (Branch B c s y d) =
  (case combine b c of {
    Emptya -> balance_left a k x (Branch B Emptya s y d);
    Branch R b2 t z c2 -> Branch R (Branch B a k x b2) t z (Branch B c2 s y d);
    Branch B b2 t z c2 ->
      balance_left a k x (Branch B (Branch B b2 t z c2) s y d);
  });
combine (Branch B va vb vc vd) (Branch R b k x c) =
  Branch R (combine (Branch B va vb vc vd) b) k x c;
combine (Branch R a k x b) (Branch B va vb vc vd) =
  Branch R a k x (combine b (Branch B va vb vc vd));

rbt_dela :: forall a b. (a -> a -> Bool) -> a -> Rbta a b -> Rbta a b;
rbt_dela less x (Branch c a y s b) =
  (if less x y then rbt_del_from_lefta less x a y s b
    else (if less y x then rbt_del_from_righta less x a y s b
           else combine a b));
rbt_dela less x Emptya = Emptya;

rbt_del_from_lefta ::
  forall a b.
    (a -> a -> Bool) -> a -> Rbta a b -> a -> b -> Rbta a b -> Rbta a b;
rbt_del_from_lefta less x (Branch R va vb vc vd) y s b =
  Branch R (rbt_dela less x (Branch R va vb vc vd)) y s b;
rbt_del_from_lefta less x Emptya y s b =
  Branch R (rbt_dela less x Emptya) y s b;
rbt_del_from_lefta less x (Branch B lt z v rt) y s b =
  balance_left (rbt_dela less x (Branch B lt z v rt)) y s b;

rbt_del_from_righta ::
  forall a b.
    (a -> a -> Bool) -> a -> Rbta a b -> a -> b -> Rbta a b -> Rbta a b;
rbt_del_from_righta less x a y s (Branch R va vb vc vd) =
  Branch R a y s (rbt_dela less x (Branch R va vb vc vd));
rbt_del_from_righta less x a y s Emptya =
  Branch R a y s (rbt_dela less x Emptya);
rbt_del_from_righta less x a y s (Branch B lt z v rt) =
  balance_right a y s (rbt_dela less x (Branch B lt z v rt));

rbt_deletea :: forall a b. (a -> a -> Bool) -> a -> Rbta a b -> Rbta a b;
rbt_deletea less k t = paint B (rbt_dela less k t);

deletea :: forall a b. (Corder a) => a -> Mapping_rbt a b -> Mapping_rbt a b;
deletea x xa = Mapping_RBT (rbt_deletea (snd (the corder)) x (impl_ofa xa));

list_remove1 :: forall a. (a -> a -> Bool) -> a -> [a] -> [a];
list_remove1 equal x (y : xs) =
  (if equal x y then xs else y : list_remove1 equal x xs);
list_remove1 equal x [] = [];

removea :: forall a. (Ceq a) => a -> Set_dlist a -> Set_dlist a;
removea x xa = Abs_dlist (list_remove1 (the ceq) x (list_of_dlist xa));

remove :: forall a. (Ceq a, Corder a) => a -> Set a -> Set a;
remove x (RBT_set rbt) =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      error "remove RBT_set: corder = None" (\ _ -> remove x (RBT_set rbt));
    Just _ -> RBT_set (deletea x rbt);
  });
remove x (DList_set dxs) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      error "remove DList_set: ceq = None" (\ _ -> remove x (DList_set dxs));
    Just _ -> DList_set (removea x dxs);
  });
remove x (Collect_set a) =
  (case ceq of {
    Nothing ->
      error "remove Collect: ceq = None" (\ _ -> remove x (Collect_set a));
    Just eq -> Collect_set (fun_upda eq a x False);
  });

inserta :: forall a. (Ceq a, Corder a) => a -> Set a -> Set a;
inserta xa (Complement x) = Complement (remove xa x);
inserta x (RBT_set rbt) =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      error "insert RBT_set: corder = None" (\ _ -> inserta x (RBT_set rbt));
    Just _ -> RBT_set (insertd x () rbt);
  });
inserta x (DList_set dxs) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      error "insert DList_set: ceq = None" (\ _ -> inserta x (DList_set dxs));
    Just _ -> DList_set (insertc x dxs);
  });
inserta x (Set_Monad xs) = Set_Monad (x : xs);
inserta x (Collect_set a) =
  (case ceq of {
    Nothing ->
      error "insert Collect_set: ceq = None" (\ _ -> inserta x (Collect_set a));
    Just eq -> Collect_set (fun_upda eq a x True);
  });

image ::
  forall a b.
    (Ceq a, Corder a, Ceq b, Corder b,
      Set_impla b) => (a -> b) -> Set a -> Set b;
image h (RBT_set rbt) =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      error "image RBT_set: corder = None" (\ _ -> image h (RBT_set rbt));
    Just _ -> foldc (inserta . h) rbt bot_set;
  });
image g (DList_set dxs) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      error "image DList_set: ceq = None" (\ _ -> image g (DList_set dxs));
    Just _ -> foldd (inserta . g) dxs bot_set;
  });
image f (Complement (Complement b)) = image f b;
image f (Collect_set a) =
  error "image Collect_set" (\ _ -> image f (Collect_set a));
image f (Set_Monad xs) = Set_Monad (map f xs);

args :: forall a b. Term a b -> [Term a b];
args (Var x) = [];
args (Fun f ts) = ts;

folda :: forall a b c. (a -> b) -> (c -> [b] -> b) -> Term c a -> b;
folda var fun (Var x) = var x;
folda var fun (Fun f ts) = fun f (map (folda var fun) ts);

gen_length :: forall a. Nat -> [a] -> Nat;
gen_length n (x : xs) = gen_length (plus_nat n (Nat_of_num One)) xs;
gen_length n [] = n;

size_list :: forall a. [a] -> Nat;
size_list = gen_length Zero_nat;

root :: forall a b. Term a b -> Maybe (a, Nat);
root (Var x) = Nothing;
root (Fun f ts) = Just (f, size_list ts);

flip :: forall a b c. (a -> b -> c) -> b -> a -> c;
flip f = (\ x y -> f y x);

data Xmldoc = Xmldoc [Prelude.Char] Xml;

bool_of_string :: [Prelude.Char] -> Sum_bot [Prelude.Char] Bool;
bool_of_string s =
  (if s == ['t', 'r', 'u', 'e'] then returna True
    else (if s == ['f', 'a', 'l', 's', 'e'] then returna False
           else errora
                  (['c', 'a', 'n', 'n', 'o', 't', ' ', 'c', 'o', 'n', 'v', 'e',
                     'r', 't', ' '] ++
                    s ++ [' ', 'i', 'n', 't', 'o', ' ', 'B', 'o', 'o', 'l', 'e',
                           'a', 'n'])));

bool :: [Prelude.Char] -> Xml -> Sum_bot [Prelude.Char] Bool;
bool tag node = binda (text tag node) bool_of_string;

leaf :: forall a. [Prelude.Char] -> a -> Xml -> Sum_bot [Prelude.Char] a;
leaf tag x (Xml name atts cs text) =
  (if name == tag && null atts && null cs && is_none text then returna x
    else fail tag (Xml name atts cs text));

map_sum_bot :: forall a b c. (a -> Sum_bot b c) -> [a] -> Sum_bot b [c];
map_sum_bot f [] = returna [];
map_sum_bot f (x : xs) =
  binda (f x) (\ y -> binda (map_sum_bot f xs) (\ ys -> returna (y : ys)));

many ::
  forall a b.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        ([a] -> b) -> Xml -> Sum_bot [Prelude.Char] b;
many tag p f (Xml name atts cs text) =
  (if name == tag && null atts && is_none text
    then binda (map_sum_bot p cs) (returna . f)
    else fail tag (Xml name atts cs text));

mult :: forall a b. Partial_object_ext a (Monoid_ext a b) -> a -> a -> a;
mult (Partial_object_ext carrier (Monoid_ext mult one more)) = mult;

class Abs a where {
  absa :: a -> a;
};

class Sgn a where {
  sgn :: a -> a;
};

instance Plus Nat where {
  plus = plus_nat;
};

instance Semigroup_add Nat where {
};

instance Zero Nat where {
  zeroa = Zero_nat;
};

instance Monoid_add Nat where {
};

times_nat :: Nat -> Nat -> Nat;
times_nat Zero_nat n = Zero_nat;
times_nat m Zero_nat = Zero_nat;
times_nat (Nat_of_num k) (Nat_of_num l) = Nat_of_num (times_num k l);

foldr :: forall a b. (a -> b -> b) -> [a] -> b -> b;
foldr f [] = id;
foldr f (x : xs) = f x . foldr f xs;

listsum :: forall a. (Monoid_add a) => [a] -> a;
listsum xs = foldr plus xs zeroa;

weight ::
  forall a b.
    ((a, Nat) -> Nat) -> Nat -> ((a, Nat) -> Nat -> Nat) -> Term a b -> Nat;
weight w w0 scf (Fun f ts) =
  let {
    n = size_list ts;
    scff = scf (f, n);
  } in plus_nat (w (f, n))
         (listsum
           (map (\ (ti, i) -> times_nat (weight w w0 scf ti) (scff i))
             (zip ts (upt Zero_nat n))));
weight w w0 scf (Var x) = w0;

foldl :: forall a b. (a -> b -> a) -> a -> [b] -> a;
foldl f a [] = a;
foldl f a (x : xs) = foldl f (f a x) xs;

instance Times Nat where {
  times = times_nat;
};

instance Dvd Nat where {
};

of_nat :: forall a. (Semiring_1 a) => Nat -> a;
of_nat (Nat_of_num k) = numeral k;
of_nat Zero_nat = zeroa;

one_nat :: Nat;
one_nat = Nat_of_num One;

instance One Nat where {
  onea = one_nat;
};

less_eq_nat :: Nat -> Nat -> Bool;
less_eq_nat (Nat_of_num k) (Nat_of_num l) = less_eq_num k l;
less_eq_nat (Nat_of_num k) Zero_nat = False;
less_eq_nat Zero_nat n = True;

instance Ord Nat where {
  less_eq = less_eq_nat;
  less = less_nat;
};

seta :: forall a. (Ceq a, Corder a, Set_impla a) => Maybe a -> Set a;
seta Nothing = bot_set;
seta (Just x) = inserta x bot_set;

rbt_del :: forall a b. (Ord a) => a -> Rbta a b -> Rbta a b;
rbt_del x Emptya = Emptya;
rbt_del x (Branch c a y s b) =
  (if less x y then rbt_del_from_left x a y s b
    else (if less y x then rbt_del_from_right x a y s b else combine a b));

rbt_del_from_left ::
  forall a b. (Ord a) => a -> Rbta a b -> a -> b -> Rbta a b -> Rbta a b;
rbt_del_from_left x (Branch B lt z v rt) y s b =
  balance_left (rbt_del x (Branch B lt z v rt)) y s b;
rbt_del_from_left x Emptya y s b = Branch R (rbt_del x Emptya) y s b;
rbt_del_from_left x (Branch R va vb vc vd) y s b =
  Branch R (rbt_del x (Branch R va vb vc vd)) y s b;

rbt_del_from_right ::
  forall a b. (Ord a) => a -> Rbta a b -> a -> b -> Rbta a b -> Rbta a b;
rbt_del_from_right x a y s (Branch B lt z v rt) =
  balance_right a y s (rbt_del x (Branch B lt z v rt));
rbt_del_from_right x a y s Emptya = Branch R a y s (rbt_del x Emptya);
rbt_del_from_right x a y s (Branch R va vb vc vd) =
  Branch R a y s (rbt_del x (Branch R va vb vc vd));

rbt_delete :: forall a b. (Ord a) => a -> Rbta a b -> Rbta a b;
rbt_delete k t = paint B (rbt_del k t);

impl_of :: forall a b. (Linorder a) => Rbt a b -> Rbta a b;
impl_of (Rbt x) = x;

delete :: forall a b. (Linorder a) => a -> Rbt a b -> Rbt a b;
delete x xa = Rbt (rbt_delete x (impl_of xa));

rbt_ins ::
  forall a b. (Ord a) => (a -> b -> b -> b) -> a -> b -> Rbta a b -> Rbta a b;
rbt_ins f k v Emptya = Branch R Emptya k v Emptya;
rbt_ins f k v (Branch B l x y r) =
  (if less k x then balance (rbt_ins f k v l) x y r
    else (if less x k then balance l x y (rbt_ins f k v r)
           else Branch B l x (f k y v) r));
rbt_ins f k v (Branch R l x y r) =
  (if less k x then Branch R (rbt_ins f k v l) x y r
    else (if less x k then Branch R l x y (rbt_ins f k v r)
           else Branch R l x (f k y v) r));

rbt_insert_with_key ::
  forall a b. (Ord a) => (a -> b -> b -> b) -> a -> b -> Rbta a b -> Rbta a b;
rbt_insert_with_key f k v t = paint B (rbt_ins f k v t);

rbt_insert :: forall a b. (Ord a) => a -> b -> Rbta a b -> Rbta a b;
rbt_insert = rbt_insert_with_key (\ _ _ nv -> nv);

insert :: forall a b. (Linorder a) => a -> b -> Rbt a b -> Rbt a b;
insert x xa xb = Rbt (rbt_insert x xa (impl_of xb));

rbt_lookup :: forall a b. (Ord a) => Rbta a b -> a -> Maybe b;
rbt_lookup Emptya k = Nothing;
rbt_lookup (Branch uu l x y r) k =
  (if less k x then rbt_lookup l k
    else (if less x k then rbt_lookup r k else Just y));

lookup :: forall a b. (Linorder a) => Rbt a b -> a -> Maybe b;
lookup x = rbt_lookup (impl_of x);

abs_rat :: Rat -> Rat;
abs_rat p = Frct (let {
                    (a, b) = quotient_of p;
                  } in (abs_int a, b));

instance Abs Rat where {
  absa = abs_rat;
};

times_rat :: Rat -> Rat -> Rat;
times_rat p q =
  Frct (let {
          (a, c) = quotient_of p;
          (b, d) = quotient_of q;
        } in normalize (times_int a b, times_int c d));

instance Times Rat where {
  times = times_rat;
};

instance Dvd Rat where {
};

one_rat :: Rat;
one_rat = Frct (Pos One, Pos One);

instance One Rat where {
  onea = one_rat;
};

less_eq_rat :: Rat -> Rat -> Bool;
less_eq_rat p q =
  let {
    (a, c) = quotient_of p;
    (b, d) = quotient_of q;
  } in less_eq_int (times_int a d) (times_int c b);

less_rat :: Rat -> Rat -> Bool;
less_rat p q =
  let {
    (a, c) = quotient_of p;
    (b, d) = quotient_of q;
  } in less_int (times_int a d) (times_int c b);

instance Ord Rat where {
  less_eq = less_eq_rat;
  less = less_rat;
};

sgn_rat :: Rat -> Rat;
sgn_rat p = Frct (sgn_int (fst (quotient_of p)), Pos One);

instance Sgn Rat where {
  sgn = sgn_rat;
};

class (Comm_semiring_1_cancel a) => Comm_semiring_1_cancel_crossproduct a where {
};

class Uminus a where {
  uminus :: a -> a;
};

class (Cancel_semigroup_add a, Minus a, Monoid_add a,
        Uminus a) => Group_add a where {
};

class (Cancel_comm_monoid_add a, Group_add a) => Ab_group_add a where {
};

class (Ab_group_add a, Semiring_0_cancel a) => Ring a where {
};

class (No_zero_divisors a, Ring a) => Ring_no_zero_divisors a where {
};

class (Group_add a, Numeral a) => Neg_numeral a where {
};

class (Neg_numeral a, Ring a, Semiring_1_cancel a) => Ring_1 a where {
};

class (Ring_1 a, Ring_no_zero_divisors a) => Ring_1_no_zero_divisors a where {
};

class (Comm_semiring_0_cancel a, Ring a) => Comm_ring a where {
};

class (Comm_ring a, Comm_semiring_1_cancel a, Ring_1 a) => Comm_ring_1 a where {
};

class (Comm_ring_1 a, Ring_1_no_zero_divisors a,
        Comm_semiring_1_cancel_crossproduct a) => Idom a where {
};

proja :: forall a b. Term a b -> Nat -> Term a b;
proja (Fun f ts) i = (if less_nat i (size_list ts) then nth ts i else Fun f ts);

memberc :: forall a. (Ceq a) => Set_dlist a -> a -> Bool;
memberc x = list_member (the ceq) (list_of_dlist x);

rbt_lookupa :: forall a b. (a -> a -> Bool) -> Rbta a b -> a -> Maybe b;
rbt_lookupa less (Branch uu l x y r) k =
  (if less k x then rbt_lookupa less l k
    else (if less x k then rbt_lookupa less r k else Just y));
rbt_lookupa less Emptya k = Nothing;

lookupb :: forall a b. (Corder a) => Mapping_rbt a b -> a -> Maybe b;
lookupb x = rbt_lookupa (snd (the corder)) (impl_ofa x);

memberb :: forall a. (Corder a) => Mapping_rbt a () -> a -> Bool;
memberb t x = lookupb t x == Just ();

member :: forall a. (Ceq a, Corder a) => a -> Set a -> Bool;
member x (Set_Monad xs) =
  (case ceq of {
    Nothing ->
      error "member Set_Monad: ceq = None" (\ _ -> member x (Set_Monad xs));
    Just eq -> list_member eq xs x;
  });
member xa (Complement x) = not (member xa x);
member x (RBT_set rbt) = memberb rbt x;
member x (DList_set dxs) = memberc dxs x;
member x (Collect_set a) = a x;

subst :: forall a b. (Eq a) => a -> Term b a -> a -> Term b a;
subst x t = (\ y -> (if x == y then t else Var y));

const :: forall a b. a -> b -> a;
const = (\ x _ -> x);

debug :: forall a. [Prelude.Char] -> [Prelude.Char] -> a -> a;
debug i t x = x;

guard ::
  forall a.
    (Xml -> Bool) ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (Xml -> Sum_bot [Prelude.Char] a) -> Xml -> Sum_bot [Prelude.Char] a;
guard p p1 p2 x = (if p x then p1 x else p2 x);

many1_gen ::
  forall a b c.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (a -> Xml -> Sum_bot [Prelude.Char] b) ->
          (a -> [b] -> c) -> Xml -> Sum_bot [Prelude.Char] c;
many1_gen tag p1 p2 f (Xml name atts cs text) =
  (if name == tag && null atts && is_none text && not (null cs)
    then let {
           (h : t) = cs;
         } in binda (p1 h)
                (\ x -> binda (map_sum_bot (p2 x) t) (\ xs -> returna (f x xs)))
    else fail tag (Xml name atts cs text));

many1 ::
  forall a b c.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (Xml -> Sum_bot [Prelude.Char] b) ->
          (a -> [b] -> c) -> Xml -> Sum_bot [Prelude.Char] c;
many1 tag p1 p2 = many1_gen tag p1 (\ _ -> p2);

length_ge_2 :: forall a. [a] -> Bool;
length_ge_2 (uu : uv : uw) = True;
length_ge_2 [] = False;
length_ge_2 [v] = False;

many2 ::
  forall a b c d.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (Xml -> Sum_bot [Prelude.Char] b) ->
          (Xml -> Sum_bot [Prelude.Char] c) ->
            (a -> b -> [c] -> d) -> Xml -> Sum_bot [Prelude.Char] d;
many2 tag p1 p2 p3 f (Xml name atts cs text) =
  (if name == tag && null atts && is_none text && length_ge_2 cs
    then let {
           (cs0 : cs1 : t) = cs;
         } in binda (p1 cs0)
                (\ x ->
                  binda (p2 cs1)
                    (\ y ->
                      binda (map_sum_bot p3 t) (\ xs -> returna (f x y xs))))
    else fail tag (Xml name atts cs text));

fun_upd :: forall a b. (Eq a) => (a -> b) -> a -> b -> a -> b;
fun_upd f a b = (\ x -> (if x == a then b else f x));

membera :: forall a. (Eq a) => [a] -> a -> Bool;
membera [] y = False;
membera (x : xs) y = x == y || membera xs y;

insertb :: forall a. (Eq a) => a -> [a] -> [a];
insertb x xs = (if membera xs x then xs else x : xs);

bind :: forall a b. Maybe a -> (a -> Maybe b) -> Maybe b;
bind Nothing f = Nothing;
bind (Just x) f = f x;

data Pos = Empty | PCons Nat Pos;

powera :: forall a. a -> (a -> a -> a) -> a -> Nat -> a;
powera one times a n =
  (if equal_nat n Zero_nat then one
    else times a (powera one times a (minus_nat n (Nat_of_num One))));

power :: forall a. (Power a) => a -> Nat -> a;
power = powera onea times;

data Compare = Lt | Gt | Eqa;

prc_nat :: forall a. (a -> Nat -> Nat) -> a -> Nat -> a -> Nat -> (Bool, Bool);
prc_nat pr =
  (\ f n g m ->
    let {
      pf = pr f n;
      pg = pr g m;
    } in (less_nat pg pf, less_eq_nat pg pf));

prl_nat :: forall a. (a -> Nat -> Nat) -> a -> Bool;
prl_nat pr = (\ f -> equal_nat (pr f Zero_nat) Zero_nat);

plus_rat :: Rat -> Rat -> Rat;
plus_rat p q =
  Frct (let {
          (a, c) = quotient_of p;
          (b, d) = quotient_of q;
        } in normalize
               (plus_int (times_int a d) (times_int b c), times_int c d));

instance Plus Rat where {
  plus = plus_rat;
};

instance Semigroup_add Rat where {
};

instance Cancel_semigroup_add Rat where {
};

instance Ab_semigroup_add Rat where {
};

instance Cancel_ab_semigroup_add Rat where {
};

zero_rat :: Rat;
zero_rat = Frct (Zero_int, Pos One);

instance Zero Rat where {
  zeroa = zero_rat;
};

instance Monoid_add Rat where {
};

instance Comm_monoid_add Rat where {
};

instance Cancel_comm_monoid_add Rat where {
};

instance Mult_zero Rat where {
};

instance Semigroup_mult Rat where {
};

instance Semiring Rat where {
};

instance Semiring_0 Rat where {
};

instance Semiring_0_cancel Rat where {
};

instance Ab_semigroup_mult Rat where {
};

instance Comm_semiring Rat where {
};

instance Comm_semiring_0 Rat where {
};

instance Comm_semiring_0_cancel Rat where {
};

instance Power Rat where {
};

instance Monoid_mult Rat where {
};

instance Numeral Rat where {
};

instance Semiring_numeral Rat where {
};

instance Zero_neq_one Rat where {
};

instance Semiring_1 Rat where {
};

instance Semiring_1_cancel Rat where {
};

instance Comm_monoid_mult Rat where {
};

instance Comm_semiring_1 Rat where {
};

instance Comm_semiring_1_cancel Rat where {
};

instance Comm_semiring_1_cancel_crossproduct Rat where {
};

instance No_zero_divisors Rat where {
};

uminus_rat :: Rat -> Rat;
uminus_rat p = Frct (let {
                       (a, b) = quotient_of p;
                     } in (uminus_int a, b));

minus_rat :: Rat -> Rat -> Rat;
minus_rat p q =
  Frct (let {
          (a, c) = quotient_of p;
          (b, d) = quotient_of q;
        } in normalize
               (minus_int (times_int a d) (times_int b c), times_int c d));

instance Uminus Rat where {
  uminus = uminus_rat;
};

instance Minus Rat where {
  minus = minus_rat;
};

instance Group_add Rat where {
};

instance Ab_group_add Rat where {
};

instance Ring Rat where {
};

instance Ring_no_zero_divisors Rat where {
};

instance Neg_numeral Rat where {
};

instance Ring_1 Rat where {
};

instance Ring_1_no_zero_divisors Rat where {
};

instance Comm_ring Rat where {
};

instance Comm_ring_1 Rat where {
};

instance Idom Rat where {
};

lterms ::
  forall a b. ((a, Nat) -> [(Nat, Nat)]) -> Term a b -> [(Term a b, Nat)];
lterms pi =
  (\ (Fun f ts) ->
    map (\ (i, a) -> (proja (Fun f ts) i, a)) (pi (f, size_list ts)));

class Cenum a where {
  cEnum :: Maybe ([a], ((a -> Bool) -> Bool, (a -> Bool) -> Bool));
};

collect :: forall a. (Cenum a) => (a -> Bool) -> Set a;
collect p =
  (case cEnum of {
    Nothing -> Collect_set p;
    Just (enum, _) -> Set_Monad (filter p enum);
  });

inter_list ::
  forall a. (Corder a) => Mapping_rbt a () -> [a] -> Mapping_rbt a ();
inter_list x xa =
  Mapping_RBT
    (fold (\ k -> rbt_inserta (snd (the corder)) k ())
      (filter
        (\ xaa ->
          not (is_none (rbt_lookupa (snd (the corder)) (impl_ofa x) xaa)))
        xa)
      Emptya);

apfst :: forall a b c. (a -> b) -> (a, c) -> (b, c);
apfst f (x, y) = (f x, y);

instance Cancel_semigroup_add Nat where {
};

instance Ab_semigroup_add Nat where {
};

instance Cancel_ab_semigroup_add Nat where {
};

instance Comm_monoid_add Nat where {
};

instance Cancel_comm_monoid_add Nat where {
};

instance Mult_zero Nat where {
};

instance Semigroup_mult Nat where {
};

instance Semiring Nat where {
};

instance Semiring_0 Nat where {
};

instance Semiring_0_cancel Nat where {
};

instance Preorder Nat where {
};

instance Order Nat where {
};

instance Ordered_ab_semigroup_add Nat where {
};

instance Ordered_semiring Nat where {
};

instance Ordered_cancel_semiring Nat where {
};

instance Ab_semigroup_mult Nat where {
};

instance Comm_semiring Nat where {
};

instance Comm_semiring_0 Nat where {
};

instance Comm_semiring_0_cancel Nat where {
};

instance Ordered_comm_semiring Nat where {
};

instance Ordered_cancel_comm_semiring Nat where {
};

instance Ordered_cancel_ab_semigroup_add Nat where {
};

instance Ordered_ab_semigroup_add_imp_le Nat where {
};

instance Linorder Nat where {
};

instance Linordered_ab_semigroup_add Nat where {
};

instance Linordered_cancel_ab_semigroup_add Nat where {
};

instance Ordered_comm_monoid_add Nat where {
};

instance Linordered_semiring Nat where {
};

instance Linordered_semiring_strict Nat where {
};

instance Linordered_comm_semiring_strict Nat where {
};

instance Power Nat where {
};

instance Monoid_mult Nat where {
};

instance Numeral Nat where {
};

instance Semiring_numeral Nat where {
};

instance Zero_neq_one Nat where {
};

instance Semiring_1 Nat where {
};

instance Semiring_1_cancel Nat where {
};

instance Comm_monoid_mult Nat where {
};

instance Comm_semiring_1 Nat where {
};

instance Comm_semiring_1_cancel Nat where {
};

instance Semiring_char_0 Nat where {
};

instance Linordered_semidom Nat where {
};

instance No_zero_divisors Nat where {
};

instance Minus Nat where {
  minus = minus_nat;
};

divmod_nat :: Nat -> Nat -> (Nat, Nat);
divmod_nat Zero_nat n = (Zero_nat, Zero_nat);
divmod_nat m Zero_nat = (Zero_nat, m);
divmod_nat (Nat_of_num k) (Nat_of_num l) = divmod k l;

div_nat :: Nat -> Nat -> Nat;
div_nat m n = fst (divmod_nat m n);

mod_nat :: Nat -> Nat -> Nat;
mod_nat m n = snd (divmod_nat m n);

instance Div Nat where {
  div = div_nat;
  mod = mod_nat;
};

instance Semiring_div Nat where {
};

instance Semiring_numeral_div Nat where {
};

rbtreeify_g :: forall a b. Nat -> [(a, b)] -> (Rbta a b, [(a, b)]);
rbtreeify_g n kvs =
  (if equal_nat n Zero_nat || equal_nat n (Nat_of_num One) then (Emptya, kvs)
    else let {
           (na, r) = divmod_nat n (Nat_of_num (Bit0 One));
         } in (if equal_nat r Zero_nat
                then let {
                       (t1, (k, v) : kvsa) = rbtreeify_g na kvs;
                     } in apfst (Branch B t1 k v) (rbtreeify_g na kvsa)
                else let {
                       (t1, (k, v) : kvsa) = rbtreeify_f na kvs;
                     } in apfst (Branch B t1 k v) (rbtreeify_g na kvsa)));

rbtreeify_f :: forall a b. Nat -> [(a, b)] -> (Rbta a b, [(a, b)]);
rbtreeify_f n kvs =
  (if equal_nat n Zero_nat then (Emptya, kvs)
    else (if equal_nat n (Nat_of_num One)
           then let {
                  ((k, v) : kvsa) = kvs;
                } in (Branch R Emptya k v Emptya, kvsa)
           else let {
                  (na, r) = divmod_nat n (Nat_of_num (Bit0 One));
                } in (if equal_nat r Zero_nat
                       then let {
                              (t1, (k, v) : kvsa) = rbtreeify_f na kvs;
                            } in apfst (Branch B t1 k v) (rbtreeify_g na kvsa)
                       else let {
                              (t1, (k, v) : kvsa) = rbtreeify_f na kvs;
                            } in apfst (Branch B t1 k v)
                                   (rbtreeify_f na kvsa))));

rbtreeify :: forall a b. [(a, b)] -> Rbta a b;
rbtreeify kvs =
  fst (rbtreeify_g (plus_nat (size_list kvs) (Nat_of_num One)) kvs);

gen_entries :: forall a b. [((a, b), Rbta a b)] -> Rbta a b -> [(a, b)];
gen_entries kvts (Branch c l k v r) = gen_entries (((k, v), r) : kvts) l;
gen_entries ((kv, t) : kvts) Emptya = kv : gen_entries kvts t;
gen_entries [] Emptya = [];

entries :: forall a b. Rbta a b -> [(a, b)];
entries = gen_entries [];

filterb ::
  forall a b.
    (Corder a) => ((a, b) -> Bool) -> Mapping_rbt a b -> Mapping_rbt a b;
filterb x xa = Mapping_RBT (rbtreeify (filter x (entries (impl_ofa xa))));

skip_red :: forall a b. Rbta a b -> Rbta a b;
skip_red (Branch R l k v r) = l;
skip_red Emptya = Emptya;
skip_red (Branch B va vb vc vd) = Branch B va vb vc vd;

skip_black :: forall a b. Rbta a b -> Rbta a b;
skip_black t =
  let {
    ta = skip_red t;
  } in (case ta of {
         Emptya -> ta;
         Branch R l _ _ _ -> ta;
         Branch B l _ _ _ -> l;
       });

compare_height ::
  forall a b. Rbta a b -> Rbta a b -> Rbta a b -> Rbta a b -> Compare;
compare_height sx s t tx =
  (case (skip_red sx, (skip_red s, (skip_red t, skip_red tx))) of {
    (Emptya, (Emptya, (_, Emptya))) -> Eqa;
    (Emptya, (Emptya, (_, Branch _ _ _ _ _))) -> Lt;
    (Emptya, (Branch _ sa _ _ _, (Emptya, b))) -> Eqa;
    (Emptya, (Branch _ sa _ _ _, (Branch _ ta _ _ _, Emptya))) -> Eqa;
    (Emptya, (Branch _ sa _ _ _, (Branch _ ta _ _ _, Branch _ txa _ _ _))) ->
      compare_height Emptya sa ta (skip_black txa);
    (Branch _ sxa _ _ _, (Emptya, (Emptya, Emptya))) -> Gt;
    (Branch _ sxa _ _ _, (Emptya, (Emptya, Branch _ _ _ _ _))) -> Lt;
    (Branch _ sxa _ _ _, (Emptya, (Branch _ _ _ _ _, Emptya))) -> Eqa;
    (Branch _ sxa _ _ _, (Emptya, (Branch _ _ _ _ _, Branch _ _ _ _ _))) -> Lt;
    (Branch _ sxa _ _ _, (Branch _ sa _ _ _, (Emptya, xf))) -> Gt;
    (Branch _ sxa _ _ _, (Branch _ sa _ _ _, (Branch _ ta _ _ _, Emptya))) ->
      compare_height (skip_black sxa) sa ta Emptya;
    (Branch _ sxa _ _ _,
      (Branch _ sa _ _ _, (Branch _ ta _ _ _, Branch _ txa _ _ _)))
      -> compare_height (skip_black sxa) sa ta (skip_black txa);
  });

sinter_with ::
  forall a b.
    (a -> a -> Bool) -> (a -> b -> b -> b) -> [(a, b)] -> [(a, b)] -> [(a, b)];
sinter_with less f uv [] = [];
sinter_with less f [] uu = [];
sinter_with less f ((ka, va) : asa) ((k, v) : bs) =
  (if less k ka then sinter_with less f ((ka, va) : asa) bs
    else (if less ka k then sinter_with less f asa ((k, v) : bs)
           else (ka, f ka va v) : sinter_with less f asa bs));

map_filter :: forall a b. (a -> Maybe b) -> [a] -> [b];
map_filter f [] = [];
map_filter f (x : xs) =
  (case f x of {
    Nothing -> map_filter f xs;
    Just y -> y : map_filter f xs;
  });

rbt_inter_with_key ::
  forall a b.
    (a -> a -> Bool) -> (a -> b -> b -> b) -> Rbta a b -> Rbta a b -> Rbta a b;
rbt_inter_with_key less f t1 t2 =
  (case compare_height t1 t1 t2 t2 of {
    Lt -> rbtreeify
            (map_filter
              (\ (k, v) -> mapa (\ w -> (k, f k v w)) (rbt_lookupa less t2 k))
              (entries t1));
    Gt -> rbtreeify
            (map_filter
              (\ (k, v) -> mapa (\ w -> (k, f k w v)) (rbt_lookupa less t1 k))
              (entries t2));
    Eqa -> rbtreeify (sinter_with less f (entries t1) (entries t2));
  });

meet ::
  forall a b.
    (Corder a) => (a -> b -> b -> b) ->
                    Mapping_rbt a b -> Mapping_rbt a b -> Mapping_rbt a b;
meet x xa xb =
  Mapping_RBT
    (rbt_inter_with_key (snd (the corder)) x (impl_ofa xa) (impl_ofa xb));

filtera :: forall a. (Ceq a) => (a -> Bool) -> Set_dlist a -> Set_dlist a;
filtera x xa = Abs_dlist (filter x (list_of_dlist xa));

sunion_with ::
  forall a b.
    (a -> a -> Bool) -> (a -> b -> b -> b) -> [(a, b)] -> [(a, b)] -> [(a, b)];
sunion_with less f asa [] = asa;
sunion_with less f [] bs = bs;
sunion_with less f ((ka, va) : asa) ((k, v) : bs) =
  (if less k ka then (k, v) : sunion_with less f ((ka, va) : asa) bs
    else (if less ka k then (ka, va) : sunion_with less f asa ((k, v) : bs)
           else (ka, f ka va v) : sunion_with less f asa bs));

rbt_union_with_key ::
  forall a b.
    (a -> a -> Bool) -> (a -> b -> b -> b) -> Rbta a b -> Rbta a b -> Rbta a b;
rbt_union_with_key less f t1 t2 =
  (case compare_height t1 t1 t2 t2 of {
    Lt -> foldb (rbt_insert_with_keya less (\ k v w -> f k w v)) t1 t2;
    Gt -> foldb (rbt_insert_with_keya less f) t2 t1;
    Eqa -> rbtreeify (sunion_with less f (entries t1) (entries t2));
  });

join ::
  forall a b.
    (Corder a) => (a -> b -> b -> b) ->
                    Mapping_rbt a b -> Mapping_rbt a b -> Mapping_rbt a b;
join x xa xb =
  Mapping_RBT
    (rbt_union_with_key (snd (the corder)) x (impl_ofa xa) (impl_ofa xb));

union :: forall a. (Ceq a) => Set_dlist a -> Set_dlist a -> Set_dlist a;
union = foldd insertc;

uminus_set :: forall a. Set a -> Set a;
uminus_set (Complement b) = b;
uminus_set (Collect_set p) = Collect_set (\ x -> not (p x));
uminus_set a = Complement a;

inf_set :: forall a. (Ceq a, Corder a) => Set a -> Set a -> Set a;
inf_set (RBT_set rbt1) (Set_Monad xs) =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      error "inter RBT_set Set_Monad: corder = None"
        (\ _ -> inf_set (RBT_set rbt1) (Set_Monad xs));
    Just _ -> RBT_set (inter_list rbt1 xs);
  });
inf_set (RBT_set rbt) (DList_set dxs) =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      error "inter RBT_set DList_set: corder = None"
        (\ _ -> inf_set (RBT_set rbt) (DList_set dxs));
    Just _ ->
      (case (ceq :: Maybe (a -> a -> Bool)) of {
        Nothing ->
          error "inter RBT_set DList_set: ceq = None"
            (\ _ -> inf_set (RBT_set rbt) (DList_set dxs));
        Just _ -> RBT_set (inter_list rbt (list_of_dlist dxs));
      });
  });
inf_set (RBT_set rbt1) (RBT_set rbt2) =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      error "inter RBT_set RBT_set: corder = None"
        (\ _ -> inf_set (RBT_set rbt1) (RBT_set rbt2));
    Just _ -> RBT_set (meet (\ _ _ -> id) rbt1 rbt2);
  });
inf_set (DList_set dxs1) (Set_Monad xs) =
  (case ceq of {
    Nothing ->
      error "inter DList_set Set_Monad: ceq = None"
        (\ _ -> inf_set (DList_set dxs1) (Set_Monad xs));
    Just eq -> DList_set (filtera (list_member eq xs) dxs1);
  });
inf_set (DList_set dxs1) (DList_set dxs2) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      error "inter DList_set DList_set: ceq = None"
        (\ _ -> inf_set (DList_set dxs1) (DList_set dxs2));
    Just _ -> DList_set (filtera (memberc dxs2) dxs1);
  });
inf_set (DList_set dxs) (RBT_set rbt) =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      error "inter DList_set RBT_set: corder = None"
        (\ _ -> inf_set (DList_set dxs) (RBT_set rbt));
    Just _ ->
      (case (ceq :: Maybe (a -> a -> Bool)) of {
        Nothing ->
          error "inter DList_set RBT_set: ceq = None"
            (\ _ -> inf_set (DList_set dxs) (RBT_set rbt));
        Just _ -> RBT_set (inter_list rbt (list_of_dlist dxs));
      });
  });
inf_set (Set_Monad xs1) (Set_Monad xs2) =
  (case ceq of {
    Nothing ->
      error "inter Set_Monad Set_Monad: ceq = None"
        (\ _ -> inf_set (Set_Monad xs1) (Set_Monad xs2));
    Just eq -> Set_Monad (filter (list_member eq xs2) xs1);
  });
inf_set (Set_Monad xs) (DList_set dxs2) =
  (case ceq of {
    Nothing ->
      error "inter Set_Monad DList_set: ceq = None"
        (\ _ -> inf_set (Set_Monad xs) (DList_set dxs2));
    Just eq -> DList_set (filtera (list_member eq xs) dxs2);
  });
inf_set (Set_Monad xs) (RBT_set rbt1) =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      error "inter Set_Monad RBT_set: corder = None"
        (\ _ -> inf_set (RBT_set rbt1) (Set_Monad xs));
    Just _ -> RBT_set (inter_list rbt1 xs);
  });
inf_set (Complement ba) (Complement b) = Complement (sup_set ba b);
inf_set g (RBT_set rbt2) =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      error "inter RBT_set2: corder = None" (\ _ -> inf_set g (RBT_set rbt2));
    Just _ -> RBT_set (filterb ((\ x -> member x g) . fst) rbt2);
  });
inf_set (RBT_set rbt1) g =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      error "inter RBT_set1: corder = None" (\ _ -> inf_set (RBT_set rbt1) g);
    Just _ -> RBT_set (filterb ((\ x -> member x g) . fst) rbt1);
  });
inf_set h (DList_set dxs2) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      error "inter DList_set2: ceq = None" (\ _ -> inf_set h (DList_set dxs2));
    Just _ -> DList_set (filtera (\ x -> member x h) dxs2);
  });
inf_set (DList_set dxs1) h =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      error "inter DList_set1: ceq = None" (\ _ -> inf_set (DList_set dxs1) h);
    Just _ -> DList_set (filtera (\ x -> member x h) dxs1);
  });
inf_set i (Set_Monad xs) = Set_Monad (filter (\ x -> member x i) xs);
inf_set (Set_Monad xs) i = Set_Monad (filter (\ x -> member x i) xs);
inf_set j (Collect_set a) = Collect_set (\ x -> a x && member x j);
inf_set (Collect_set a) j = Collect_set (\ x -> a x && member x j);

sup_set :: forall a. (Ceq a, Corder a) => Set a -> Set a -> Set a;
sup_set ba (Complement b) = Complement (inf_set (uminus_set ba) b);
sup_set (Complement ba) b = Complement (inf_set ba (uminus_set b));
sup_set b (Collect_set a) = Collect_set (\ x -> a x || member x b);
sup_set (Collect_set a) b = Collect_set (\ x -> a x || member x b);
sup_set (Set_Monad xs) (Set_Monad ys) = Set_Monad (xs ++ ys);
sup_set (DList_set dxs1) (Set_Monad ws) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      error "union DList_set Set_Monad: ceq = None"
        (\ _ -> sup_set (DList_set dxs1) (Set_Monad ws));
    Just _ -> DList_set (fold insertc ws dxs1);
  });
sup_set (Set_Monad ws) (DList_set dxs2) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      error "union Set_Monad DList_set: ceq = None"
        (\ _ -> sup_set (Set_Monad ws) (DList_set dxs2));
    Just _ -> DList_set (fold insertc ws dxs2);
  });
sup_set (RBT_set rbt1) (Set_Monad zs) =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      error "union RBT_set Set_Monad: corder = None"
        (\ _ -> sup_set (RBT_set rbt1) (Set_Monad zs));
    Just _ -> RBT_set (fold (\ k -> insertd k ()) zs rbt1);
  });
sup_set (Set_Monad zs) (RBT_set rbt2) =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      error "union Set_Monad RBT_set: corder = None"
        (\ _ -> sup_set (Set_Monad zs) (RBT_set rbt2));
    Just _ -> RBT_set (fold (\ k -> insertd k ()) zs rbt2);
  });
sup_set (DList_set dxs1) (DList_set dxs2) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      error "union DList_set DList_set: ceq = None"
        (\ _ -> sup_set (DList_set dxs1) (DList_set dxs2));
    Just _ -> DList_set (union dxs1 dxs2);
  });
sup_set (DList_set dxs) (RBT_set rbt) =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      error "union DList_set RBT_set: corder = None"
        (\ _ -> sup_set (RBT_set rbt) (DList_set dxs));
    Just _ ->
      (case (ceq :: Maybe (a -> a -> Bool)) of {
        Nothing ->
          error "union DList_set RBT_set: ceq = None"
            (\ _ -> sup_set (RBT_set rbt) (DList_set dxs));
        Just _ -> RBT_set (foldd (\ k -> insertd k ()) dxs rbt);
      });
  });
sup_set (RBT_set rbt) (DList_set dxs) =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      error "union RBT_set DList_set: corder = None"
        (\ _ -> sup_set (RBT_set rbt) (DList_set dxs));
    Just _ ->
      (case (ceq :: Maybe (a -> a -> Bool)) of {
        Nothing ->
          error "union RBT_set DList_set: ceq = None"
            (\ _ -> sup_set (RBT_set rbt) (DList_set dxs));
        Just _ -> RBT_set (foldd (\ k -> insertd k ()) dxs rbt);
      });
  });
sup_set (RBT_set rbt1) (RBT_set rbt2) =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      error "union RBT_set RBT_set: corder = None"
        (\ _ -> sup_set (RBT_set rbt1) (RBT_set rbt2));
    Just _ -> RBT_set (join (\ _ _ -> id) rbt1 rbt2);
  });

top_set :: forall a. (Ceq a, Corder a, Set_impla a) => Set a;
top_set = uminus_set bot_set;

ground :: forall a b. Term a b -> Bool;
ground (Var x) = False;
ground (Fun f ts) = all ground ts;

is_Var :: forall a b. Term a b -> Bool;
is_Var (Var x) = True;
is_Var (Fun f ts) = False;

add_vars_term_list :: forall a b. Term a b -> [b] -> [b];
add_vars_term_list =
  folda (\ a b -> a : b) (const (flip (foldr (\ a b -> a . b)) id));

vars_term_list :: forall a b. Term a b -> [b];
vars_term_list t = add_vars_term_list t [];

remdups :: forall a. (Eq a) => [a] -> [a];
remdups [] = [];
remdups (x : xs) = (if membera xs x then remdups xs else x : remdups xs);

vars_term_lista :: forall a b. (Eq b) => Term a b -> [b];
vars_term_lista = remdups . vars_term_list;

wf_rule :: forall a b. (Eq b) => (Term a b, Term a b) -> Bool;
wf_rule r =
  not (is_Var (fst r)) &&
    all (membera (vars_term_lista (fst r))) (vars_term_lista (snd r));

fun_of :: forall a b. (Eq a) => [(a, b)] -> a -> b;
fun_of vec x = the (map_of vec x);

letters :: [Prelude.Char];
letters =
  ['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
    'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D',
    'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S',
    'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '_', '0', '1', '2', '3', '4', '5', '6',
    '7', '8', '9', '&', ';', ':'];

catch :: forall a b c. Sum_bot a b -> (a -> Sum_bot c b) -> Sum_bot c b;
catch (Sumbot a) f = (case a of {
                       Inl aa -> f aa;
                       Inr aa -> Sumbot (Inr aa);
                     });

choice ::
  forall a.
    [Prelude.Char] ->
      [Xml -> Sum_bot [Prelude.Char] a] -> Xml -> Sum_bot [Prelude.Char] a;
choice e [] x =
  errora
    (concat
      [['e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ', 'p', 'a', 'r', 's', 'i',
         'n', 'g', ' ', 'c', 'h', 'o', 'i', 'c', 'e', ' ', 'f', 'o', 'r', ' '],
        e, ['\n'], shows_prec_xml Zero_nat x []]);
choice e (p : ps) x = catch (p x) (\ _ -> choice e ps x);

list3elements :: forall a. [a] -> Maybe (a, (a, a));
list3elements [x, y, z] = Just (x, (y, z));
list3elements [] = Nothing;
list3elements [v] = Nothing;
list3elements [v, vb] = Nothing;
list3elements (v : vb : vd : vf : vg) = Nothing;

triple ::
  forall a b c d.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (Xml -> Sum_bot [Prelude.Char] b) ->
          (Xml -> Sum_bot [Prelude.Char] c) ->
            (a -> b -> c -> d) -> Xml -> Sum_bot [Prelude.Char] d;
triple tag p1 p2 p3 f xml =
  let {
    (Xml name atts cs text) = xml;
  } in (if name == tag && null atts && is_none text
         then (case list3elements cs of {
                Nothing -> fail tag xml;
                Just (cs1, (cs2, cs3)) ->
                  binda (p1 cs1)
                    (\ a ->
                      binda (p2 cs2)
                        (\ b -> binda (p3 cs3) (\ c -> returna (f a b c))));
              })
         else fail tag xml);

list4elements :: forall a. [a] -> Maybe (a, (a, (a, a)));
list4elements [x, y, z, u] = Just (x, (y, (z, u)));
list4elements [] = Nothing;
list4elements [v] = Nothing;
list4elements [v, vb] = Nothing;
list4elements [v, vb, vd] = Nothing;
list4elements (v : vb : vd : vf : vh : vi) = Nothing;

tuple4 ::
  forall a b c d e.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (Xml -> Sum_bot [Prelude.Char] b) ->
          (Xml -> Sum_bot [Prelude.Char] c) ->
            (Xml -> Sum_bot [Prelude.Char] d) ->
              (a -> b -> c -> d -> e) -> Xml -> Sum_bot [Prelude.Char] e;
tuple4 tag p1 p2 p3 p4 f xml =
  let {
    (Xml name atts cs text) = xml;
  } in (if name == tag && null atts && is_none text
         then (case list4elements cs of {
                Nothing -> fail tag xml;
                Just (cs1, (cs2, (cs3, cs4))) ->
                  binda (p1 cs1)
                    (\ a ->
                      binda (p2 cs2)
                        (\ b ->
                          binda (p3 cs3)
                            (\ c ->
                              binda (p4 cs4) (\ d -> returna (f a b c d)))));
              })
         else fail tag xml);

list5elements :: forall a. [a] -> Maybe (a, (a, (a, (a, a))));
list5elements [x, y, z, u, v] = Just (x, (y, (z, (u, v))));
list5elements [] = Nothing;
list5elements [v] = Nothing;
list5elements [v, vb] = Nothing;
list5elements [v, vb, vd] = Nothing;
list5elements [v, vb, vd, vf] = Nothing;
list5elements (v : vb : vd : vf : vh : vj : vk) = Nothing;

tuple5 ::
  forall a b c d e f.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (Xml -> Sum_bot [Prelude.Char] b) ->
          (Xml -> Sum_bot [Prelude.Char] c) ->
            (Xml -> Sum_bot [Prelude.Char] d) ->
              (Xml -> Sum_bot [Prelude.Char] e) ->
                (a -> b -> c -> d -> e -> f) -> Xml -> Sum_bot [Prelude.Char] f;
tuple5 tag p1 p2 p3 p4 p5 f xml =
  let {
    (Xml name atts cs text) = xml;
  } in (if name == tag && null atts && is_none text
         then (case list5elements cs of {
                Nothing -> fail tag xml;
                Just (cs1, (cs2, (cs3, (cs4, cs5)))) ->
                  binda (p1 cs1)
                    (\ a ->
                      binda (p2 cs2)
                        (\ b ->
                          binda (p3 cs3)
                            (\ c ->
                              binda (p4 cs4)
                                (\ d ->
                                  binda (p5 cs5)
                                    (\ e -> returna (f a b c d e))))));
              })
         else fail tag xml);

list6elements :: forall a. [a] -> Maybe (a, (a, (a, (a, (a, a)))));
list6elements [x, y, z, u, v, w] = Just (x, (y, (z, (u, (v, w)))));
list6elements [] = Nothing;
list6elements [v] = Nothing;
list6elements [v, vb] = Nothing;
list6elements [v, vb, vd] = Nothing;
list6elements [v, vb, vd, vf] = Nothing;
list6elements [v, vb, vd, vf, vh] = Nothing;
list6elements (v : vb : vd : vf : vh : vj : vl : vm) = Nothing;

tuple6 ::
  forall a b c d e f g.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (Xml -> Sum_bot [Prelude.Char] b) ->
          (Xml -> Sum_bot [Prelude.Char] c) ->
            (Xml -> Sum_bot [Prelude.Char] d) ->
              (Xml -> Sum_bot [Prelude.Char] e) ->
                (Xml -> Sum_bot [Prelude.Char] f) ->
                  (a -> b -> c -> d -> e -> f -> g) ->
                    Xml -> Sum_bot [Prelude.Char] g;
tuple6 tag p1 p2 p3 p4 p5 p6 f xml =
  let {
    (Xml name atts cs text) = xml;
  } in (if name == tag && null atts && is_none text
         then (case list6elements cs of {
                Nothing -> fail tag xml;
                Just (cs1, (cs2, (cs3, (cs4, (cs5, cs6))))) ->
                  binda (p1 cs1)
                    (\ a ->
                      binda (p2 cs2)
                        (\ b ->
                          binda (p3 cs3)
                            (\ c ->
                              binda (p4 cs4)
                                (\ d ->
                                  binda (p5 cs5)
                                    (\ e ->
                                      binda (p6 cs6)
(\ ff -> returna (f a b c d e ff)))))));
              })
         else fail tag xml);

data Mini_alg_number = Sp Rat Rat;

data Arctic_delta a = MinInfty_delta | Num_arc_delta a;

data Af_entry = Collapse Nat | AFList [Nat];

data Arctic = MinInfty | Num_arc Int;

data Redtriple_impl a = Int_carrier [((a, Nat), (Int, [Int]))]
  | Int_nl_carrier [((a, Nat), [([(Nat, Nat)], Int)])]
  | Rat_carrier [((a, Nat), (Rat, [Rat]))]
  | Rat_nl_carrier Rat [((a, Nat), [([(Nat, Nat)], Rat)])]
  | Mini_alg_carrier [((a, Nat), (Mini_alg_number, [Mini_alg_number]))]
  | Mini_alg_nl_carrier Mini_alg_number
      [((a, Nat), [([(Nat, Nat)], Mini_alg_number)])]
  | Arctic_carrier [((a, Nat), (Arctic, [Arctic]))]
  | Arctic_rat_carrier [((a, Nat), (Arctic_delta Rat, [Arctic_delta Rat]))]
  | Int_mat_carrier Nat Nat [((a, Nat), ([[Int]], [[[Int]]]))]
  | Rat_mat_carrier Nat Nat [((a, Nat), ([[Rat]], [[[Rat]]]))]
  | Mini_alg_mat_carrier Nat Nat
      [((a, Nat), ([[Mini_alg_number]], [[[Mini_alg_number]]]))]
  | Arc_mat_carrier Nat [((a, Nat), ([[Arctic]], [[[Arctic]]]))]
  | Arc_rat_mat_carrier Nat
      [((a, Nat), ([[Arctic_delta Rat]], [[[Arctic_delta Rat]]]))]
  | Rpo [((a, Nat), (Nat, Order_tag))] [((a, Nat), Af_entry)]
  | Kbo ([((a, Nat), (Nat, (Nat, Maybe [Nat])))], Nat) [((a, Nat), Af_entry)];

data ArithFun = Arg Nat | Const Nat | Sum [ArithFun] | Max [ArithFun]
  | Min [ArithFun] | Prod [ArithFun]
  | IfEqual ArithFun ArithFun ArithFun ArithFun;

data Sl_inter a = SL_Inter Nat [((a, Nat), ArithFun)];

data Sl_variant a b = Rootlab (Maybe (a, Nat)) | Finitelab (Sl_inter a)
  | QuasiFinitelab (Sl_inter a) b;

data Complex_constant_removal_prf a b =
  Complex_Constant_Removal_Proof (Term a b)
    [((Term a b, Term a b), (Term a b, Term a b))];

data List_order_type = MS_Ext | Max_Ext | Min_Ext | Dms_Ext;

data Root_redtriple_impl a =
  Scnp List_order_type [((a, Nat), [(Nat, Nat)])] (Redtriple_impl a);

data Cond_constraint a b = CC_cond Bool (Term a b, Term a b)
  | CC_rewr (Term a b) (Term a b)
  | CC_impl [Cond_constraint a b] (Cond_constraint a b)
  | CC_all b (Cond_constraint a b);

data Cond_constraint_prf a b = Final
  | Delete_Condition (Cond_constraint a b) (Cond_constraint_prf a b)
  | Different_Constructor (Cond_constraint a b)
  | Same_Constructor (Cond_constraint a b) (Cond_constraint a b)
      (Cond_constraint_prf a b)
  | Variable_Equation b (Term a b) (Cond_constraint a b)
      (Cond_constraint_prf a b)
  | Funarg_Into_Var (Cond_constraint a b) Nat b (Cond_constraint a b)
      (Cond_constraint_prf a b)
  | Simplify_Condition (Cond_constraint a b) [(b, Term a b)]
      (Cond_constraint a b) (Cond_constraint_prf a b)
  | Induction (Cond_constraint a b) [Cond_constraint a b]
      [((Term a b, Term a b),
         ([(Term a b, [b])], (Cond_constraint a b, Cond_constraint_prf a b)))];

data Cond_red_pair_prf a b =
  Cond_Red_Pair_Prf a
    [(Cond_constraint a b, ([(Term a b, Term a b)], Cond_constraint_prf a b))]
    Nat Nat;

data Join_info a =
  Guided
    [(Term a [Prelude.Char],
       ([(Pos, ((Term a [Prelude.Char], Term a [Prelude.Char]),
                 Term a [Prelude.Char]))],
         (Term a [Prelude.Char],
           [(Pos, ((Term a [Prelude.Char], Term a [Prelude.Char]),
                    Term a [Prelude.Char]))])))]
  | Join_NF | Join_BFS Nat;

newtype ProjL a = Projection [((a, Nat), Nat)];

data Lab a b = Lab (Lab a b) b | FunLab (Lab a b) [Lab a b] | UnLab a
  | Sharp (Lab a b);

data Dp_termination_proof a b c = P_is_Empty
  | Subterm_Criterion_Proc (ProjL (Lab a b))
      [((Term (Lab a b) c, Term (Lab a b) c),
         [(Pos, ((Term (Lab a b) c, Term (Lab a b) c), Term (Lab a b) c))])]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Redpair_Proc
      (Sum (Root_redtriple_impl (Lab a b)) (Redtriple_impl (Lab a b)))
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Redpair_UR_Proc
      (Sum (Root_redtriple_impl (Lab a b)) (Redtriple_impl (Lab a b)))
      [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Usable_Rules_Proc [(Term (Lab a b) c, Term (Lab a b) c)]
      (Dp_termination_proof a b c)
  | Dep_Graph_Proc
      [(Maybe (Dp_termination_proof a b c),
         [(Term (Lab a b) c, Term (Lab a b) c)])]
  | Mono_Redpair_Proc (Redtriple_impl (Lab a b))
      [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Mono_Redpair_UR_Proc (Redtriple_impl (Lab a b))
      [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Size_Change_Subterm_Proc
      [((Term (Lab a b) c, Term (Lab a b) c), ([(Nat, Nat)], [(Nat, Nat)]))]
  | Size_Change_Redpair_Proc (Redtriple_impl (Lab a b))
      (Maybe [(Term (Lab a b) c, Term (Lab a b) c)])
      [((Term (Lab a b) c, Term (Lab a b) c), ([(Nat, Nat)], [(Nat, Nat)]))]
  | Uncurry_Proc (Maybe Nat)
      (Lab a b,
        ([((Lab a b, Nat), [Lab a b])],
          ([(Term (Lab a b) c, Term (Lab a b) c)],
            [(Term (Lab a b) c, Term (Lab a b) c)])))
      [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Fcc_Proc (Lab a b) [Ctxt (Lab a b) c] [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Split_Proc [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
      (Dp_termination_proof a b c)
  | Semlab_Proc (Sl_variant (Lab a b) c) [(Term (Lab a b) c, Term (Lab a b) c)]
      [Term (Lab a b) c] [(Term (Lab a b) c, Term (Lab a b) c)]
      (Dp_termination_proof a b c)
  | Switch_Innermost_Proc (Join_info (Lab a b)) (Dp_termination_proof a b c)
  | Rewriting_Proc (Maybe [(Term (Lab a b) c, Term (Lab a b) c)])
      (Term (Lab a b) c, Term (Lab a b) c) (Term (Lab a b) c, Term (Lab a b) c)
      (Term (Lab a b) c, Term (Lab a b) c) (Term (Lab a b) c, Term (Lab a b) c)
      Pos (Dp_termination_proof a b c)
  | Instantiation_Proc (Term (Lab a b) c, Term (Lab a b) c)
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Forward_Instantiation_Proc (Term (Lab a b) c, Term (Lab a b) c)
      [(Term (Lab a b) c, Term (Lab a b) c)]
      (Maybe [(Term (Lab a b) c, Term (Lab a b) c)])
      (Dp_termination_proof a b c)
  | Narrowing_Proc (Term (Lab a b) c, Term (Lab a b) c) Pos
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Assume_Finite
      (Bool,
        (Bool,
          ([(Term (Lab a b) c, Term (Lab a b) c)],
            ([(Term (Lab a b) c, Term (Lab a b) c)],
              ([Term (Lab a b) c],
                ([(Term (Lab a b) c, Term (Lab a b) c)],
                  [(Term (Lab a b) c, Term (Lab a b) c)]))))))
      [((Bool,
          (Bool,
            ([(Term (Lab a b) c, Term (Lab a b) c)],
              ([(Term (Lab a b) c, Term (Lab a b) c)],
                ([Term (Lab a b) c],
                  ([(Term (Lab a b) c, Term (Lab a b) c)],
                    [(Term (Lab a b) c, Term (Lab a b) c)])))))),
         Dp_termination_proof a b c)]
  | Unlab_Proc [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | Q_Reduction_Proc [Term (Lab a b) c] (Dp_termination_proof a b c)
  | Complex_Constant_Removal_Proc (Complex_constant_removal_prf (Lab a b) c)
      (Dp_termination_proof a b c)
  | General_Redpair_Proc (Redtriple_impl (Lab a b))
      [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Cond_red_pair_prf (Lab a b) c)
      [Dp_termination_proof a b c];

data Ta_rule a b = TA_rule b [a] a;

data Tree_automaton a b = Tree_Automaton [a] [Ta_rule a b] [(a, a)];

data Ta_relation a = Id_Relation | Some_Relation [(a, a)];

data Boundstype = Roof | Match;

data Bounds_info a b =
  Bounds_Info Boundstype Nat [b] (Tree_automaton b (a, Nat)) (Ta_relation b);

data Trs_termination_proof a b c =
  DP_Trans Bool Bool [(Term (Lab a b) c, Term (Lab a b) c)]
    (Dp_termination_proof a b c)
  | Rule_Removal (Redtriple_impl (Lab a b))
      [(Term (Lab a b) c, Term (Lab a b) c)] (Trs_termination_proof a b c)
  | String_Reversal (Trs_termination_proof a b c)
  | Bounds (Bounds_info (Lab a b) c)
  | Uncurry
      (Lab a b,
        ([((Lab a b, Nat), [Lab a b])],
          ([(Term (Lab a b) c, Term (Lab a b) c)],
            [(Term (Lab a b) c, Term (Lab a b) c)])))
      [(Term (Lab a b) c, Term (Lab a b) c)] (Trs_termination_proof a b c)
  | Semlab (Sl_variant (Lab a b) c) [Term (Lab a b) c]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Trs_termination_proof a b c)
  | R_is_Empty
  | Fcc [Ctxt (Lab a b) c] [(Term (Lab a b) c, Term (Lab a b) c)]
      (Trs_termination_proof a b c)
  | Split [(Term (Lab a b) c, Term (Lab a b) c)] (Trs_termination_proof a b c)
      (Trs_termination_proof a b c)
  | Switch_Innermost (Join_info (Lab a b)) (Trs_termination_proof a b c)
  | Drop_Equality (Trs_termination_proof a b c)
  | Remove_Nonapplicable_Rules [(Term (Lab a b) c, Term (Lab a b) c)]
      (Trs_termination_proof a b c)
  | Assume_SN
      (Bool,
        ([Term (Lab a b) c],
          ([(Term (Lab a b) c, Term (Lab a b) c)],
            [(Term (Lab a b) c, Term (Lab a b) c)])))
      [((Bool,
          ([Term (Lab a b) c],
            ([(Term (Lab a b) c, Term (Lab a b) c)],
              [(Term (Lab a b) c, Term (Lab a b) c)]))),
         Trs_termination_proof a b c)];

class Inverse a where {
  inverse :: a -> a;
  divide :: a -> a -> a;
};

class (Inverse a, Ring_1_no_zero_divisors a) => Division_ring a where {
};

class (Division_ring a, Idom a) => Field a where {
};

instance Eq Int where {
  a == b = equal_int a b;
};

scf_list :: forall a. (Nat -> Nat) -> [a] -> [a];
scf_list scf xs =
  concatMap (\ (x, i) -> replicate (scf i) x)
    (zip xs (upt Zero_nat (size_list xs)));

scf_term :: forall a b. ((a, Nat) -> Nat -> Nat) -> Term a b -> Term a b;
scf_term scf (Var x) = Var x;
scf_term scf (Fun f ts) =
  Fun f (scf_list (scf (f, size_list ts)) (map (scf_term scf) ts));

butlast :: forall a. [a] -> [a];
butlast [] = [];
butlast (x : xs) = (if null xs then [] else x : butlast xs);

product :: forall a b. [a] -> [b] -> [(a, b)];
product [] uu = [];
product (x : xs) ys = map (\ a -> (x, a)) ys ++ product xs ys;

remove1 :: forall a. (Eq a) => a -> [a] -> [a];
remove1 x [] = [];
remove1 x (y : xs) = (if x == y then xs else y : remove1 x xs);

it_add ::
  forall a b c d.
    (a -> b -> c -> c) ->
      (d -> (c -> Bool) -> ((a, b) -> c -> c) -> c -> c) -> c -> d -> c;
it_add update iti m1 m2 = iti m2 (\ _ -> True) (\ (a, b) -> update a b) m1;

data Memory_ext a b c d =
  Memory_ext (() -> a) (a -> b -> Maybe c) (a -> (b, c) -> a) d;

l2m_lookup ::
  forall a b c. (Eq a, Eq b) => [(a, [(b, c)])] -> (a, b) -> Maybe c;
l2m_lookup [] uu = Nothing;
l2m_lookup ((a, kvs) : rec) (k1, k2) =
  (case k1 == a of {
    True -> map_of kvs k2;
    False -> l2m_lookup rec (k1, k2);
  });

lm_store_acc ::
  forall a b. (Eq a) => [(a, b)] -> (a, b) -> [(a, b)] -> [(a, b)];
lm_store_acc [] kv accu = kv : accu;
lm_store_acc ((a, uu) : rec) (k, v) accu =
  (case k == a of {
    True -> accu;
    False -> lm_store_acc rec (k, v) accu;
  });

lm_store :: forall a b. (Eq a) => [(a, b)] -> (a, b) -> [(a, b)];
lm_store m kv = lm_store_acc m kv m;

l2m_store ::
  forall a b c.
    (Eq a, Eq b) => [(a, [(b, c)])] -> ((a, b), c) -> [(a, [(b, c)])];
l2m_store [] ((k1, k2), v) = [(k1, [(k2, v)])];
l2m_store ((a, kvs) : rec) ((k1, k2), v) =
  (case k1 == a of {
    True -> (a, lm_store kvs (k2, v)) : rec;
    False -> (a, kvs) : l2m_store rec ((k1, k2), v);
  });

l2m :: forall a b c. (Eq a, Eq b) => Memory_ext [(a, [(b, c)])] (a, b) c ();
l2m = Memory_ext (\ _ -> []) l2m_lookup l2m_store ();

less_eq_prod_aux ::
  forall a b. (Eq a, Ord a, Ord b) => (a, b) -> (a, b) -> Bool;
less_eq_prod_aux (a1, a2) (b1, b2) = less a1 b1 || a1 == b1 && less_eq a2 b2;

less_eq_prod :: forall a b. (Eq a, Ord a, Ord b) => (a, b) -> (a, b) -> Bool;
less_eq_prod a b = less_eq_prod_aux a b;

less_prod :: forall a b. (Eq a, Ord a, Eq b, Ord b) => (a, b) -> (a, b) -> Bool;
less_prod a b = not (a == b) && less_eq_prod_aux a b;

instance (Eq a, Ord a, Eq b, Ord b) => Ord (a, b) where {
  less_eq = less_eq_prod;
  less = less_prod;
};

rm_update :: forall a b. (Linorder a) => a -> b -> Rbt a b -> Rbt a b;
rm_update = insert;

rm_update_dj :: forall a b. (Linorder a) => a -> b -> Rbt a b -> Rbt a b;
rm_update_dj = rm_update;

rm_lookup :: forall a b. (Linorder a) => a -> Rbt a b -> Maybe b;
rm_lookup k m = lookup m k;

aux ::
  forall a b.
    (Eq a,
      Linorder b) => (a -> Maybe b) -> Rbt b [a] -> a -> Rbt b [a] -> Rbt b [a];
aux key ma v m =
  (case key v of {
    Nothing -> m;
    Just k ->
      (case rm_lookup k ma of {
        Nothing -> m;
        Just ws ->
          (if membera ws v
            then (case rm_lookup k m of {
                   Nothing -> rm_update_dj k [v] m;
                   Just vs -> rm_update k (insertb v vs) m;
                 })
            else m);
      });
  });

instance Eq Nat where {
  a == b = equal_nat a b;
};

append :: Pos -> Pos -> Pos;
append Empty q = q;
append (PCons i p) q = PCons i (append p q);

rev :: Pos -> Pos;
rev Empty = Empty;
rev (PCons i p) = append (rev p) (PCons i Empty);

equal_rat :: Rat -> Rat -> Bool;
equal_rat a b = quotient_of a == quotient_of b;

instance Eq Rat where {
  a == b = equal_rat a b;
};

inverse_rat :: Rat -> Rat;
inverse_rat p =
  Frct (let {
          (a, b) = quotient_of p;
        } in (if equal_int a Zero_int then (Zero_int, Pos One)
               else (times_int (sgn_int a) b, abs_int a)));

instance Inverse Rat where {
  inverse = inverse_rat;
  divide = divide_rat;
};

instance Division_ring Rat where {
};

instance Field Rat where {
};

instance Preorder Rat where {
};

instance Order Rat where {
};

key :: forall a b c. (a, (Term b c, Term b c)) -> Maybe (b, Nat);
key (uu, (Fun f ts, uv)) = Just (f, size_list ts);
key (uw, (Var ux, uy)) = Nothing;

class (Corder a) => Cproper_interval a where {
  cproper_interval :: Maybe a -> Maybe a -> Bool;
};

is_emptya :: forall a b. (Corder a) => Mapping_rbt a b -> Bool;
is_emptya x =
  (case impl_ofa x of {
    Emptya -> True;
    Branch _ _ _ _ _ -> False;
  });

class Finite_UNIV a where {
  finite_UNIV :: Phantom a Bool;
};

class (Finite_UNIV a) => Card_UNIV a where {
  card_UNIV :: Phantom a Nat;
};

newtype Generator a s = Generator (s -> Bool, s -> (a, s));

generatora :: forall a s. Generator a s -> (s -> Bool, s -> (a, s));
generatora (Generator x) = x;

has_next :: forall a b. Generator a b -> b -> Bool;
has_next g = fst (generatora g);

next :: forall a b. Generator a b -> b -> (a, b);
next g = snd (generatora g);

exhaustive_above_fusion ::
  forall a b. (Maybe a -> Maybe a -> Bool) -> Generator a b -> a -> b -> Bool;
exhaustive_above_fusion proper_interval g y s =
  (if has_next g s
    then let {
           (x, sa) = next g s;
         } in not (proper_interval (Just y) (Just x)) &&
                exhaustive_above_fusion proper_interval g x sa
    else not (proper_interval (Just y) Nothing));

exhaustive_fusion ::
  forall a b. (Maybe a -> Maybe a -> Bool) -> Generator a b -> b -> Bool;
exhaustive_fusion proper_interval g s =
  has_next g s &&
    let {
      (x, sa) = next g s;
    } in not (proper_interval Nothing (Just x)) &&
           exhaustive_above_fusion proper_interval g x sa;

rbt_keys_next ::
  forall a b. ([(a, Rbta a b)], Rbta a b) -> (a, ([(a, Rbta a b)], Rbta a b));
rbt_keys_next ((k, t) : kts, Emptya) = (k, (kts, t));
rbt_keys_next (kts, Branch c l k v r) = rbt_keys_next ((k, r) : kts, l);

rbt_has_next :: forall a b c. ([(a, Rbta b c)], Rbta b c) -> Bool;
rbt_has_next ([], Emptya) = False;
rbt_has_next (vb : vc, va) = True;
rbt_has_next (v, Branch vb vc vd ve vf) = True;

rbt_keys_generator :: forall a b. Generator a ([(a, Rbta a b)], Rbta a b);
rbt_keys_generator = Generator (rbt_has_next, rbt_keys_next);

card_UNIVa :: forall a. (Card_UNIV a) => Phantom a Nat;
card_UNIVa = card_UNIV;

rbt_init :: forall a b c. Rbta a b -> ([(c, Rbta a b)], Rbta a b);
rbt_init = (\ a -> ([], a));

init ::
  forall a b c. (Corder a) => Mapping_rbt a b -> ([(c, Rbta a b)], Rbta a b);
init x = rbt_init (impl_ofa x);

finite :: forall a. (Finite_UNIV a, Ceq a, Corder a) => Set a -> Bool;
finite (Collect_set p) =
  of_phantom (finite_UNIV :: Phantom a Bool) ||
    error "finite Collect_set" (\ _ -> finite (Collect_set p));
finite (Set_Monad xs) = True;
finite (Complement a) =
  (if of_phantom (finite_UNIV :: Phantom a Bool) then True
    else (if finite a then False
           else error "finite Complement: infinite set"
                  (\ _ -> finite (Complement a))));
finite (RBT_set rbt) =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      error "finite RBT_set: corder = None" (\ _ -> finite (RBT_set rbt));
    Just _ -> True;
  });
finite (DList_set dxs) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      error "finite DList_set: ceq = None" (\ _ -> finite (DList_set dxs));
    Just _ -> True;
  });

list_remdups :: forall a. (a -> a -> Bool) -> [a] -> [a];
list_remdups equal (x : xs) =
  (if list_member equal xs x then list_remdups equal xs
    else x : list_remdups equal xs);
list_remdups equal [] = [];

length :: forall a. (Ceq a) => Set_dlist a -> Nat;
length x = size_list (list_of_dlist x);

gen_keys :: forall a b. [(a, Rbta a b)] -> Rbta a b -> [a];
gen_keys kts (Branch c l k v r) = gen_keys ((k, r) : kts) l;
gen_keys ((k, t) : kts) Emptya = k : gen_keys kts t;
gen_keys [] Emptya = [];

keys :: forall a b. Rbta a b -> [a];
keys = gen_keys [];

keysa :: forall a. (Corder a) => Mapping_rbt a () -> [a];
keysa x = keys (impl_ofa x);

card :: forall a. (Card_UNIV a, Ceq a, Corder a) => Set a -> Nat;
card (Complement a) =
  let {
    aa = card a;
    s = of_phantom (card_UNIVa :: Phantom a Nat);
  } in (if less_nat Zero_nat s then minus_nat s aa
         else (if finite a then Zero_nat
                else error "card Complement: infinite"
                       (\ _ -> card (Complement a))));
card (Set_Monad xs) =
  (case ceq of {
    Nothing -> error "card Set_Monad: ceq = None" (\ _ -> card (Set_Monad xs));
    Just eq -> size_list (list_remdups eq xs);
  });
card (RBT_set rbt) =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing -> error "card RBT_set: corder = None" (\ _ -> card (RBT_set rbt));
    Just _ -> size_list (keysa rbt);
  });
card (DList_set dxs) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing -> error "card DList_set: ceq = None" (\ _ -> card (DList_set dxs));
    Just _ -> length dxs;
  });

is_UNIV ::
  forall a.
    (Card_UNIV a, Ceq a, Cproper_interval a, Set_impla a) => Set a -> Bool;
is_UNIV (RBT_set rbt) =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      error "is_UNIV RBT_set: corder = None" (\ _ -> is_UNIV (RBT_set rbt));
    Just _ ->
      (finite :: Set a -> Bool) (top_set :: Set a) &&
        exhaustive_fusion cproper_interval rbt_keys_generator (init rbt);
  });
is_UNIV a =
  let {
    aa = of_phantom (card_UNIVa :: Phantom a Nat);
    b = card a;
  } in (if less_nat Zero_nat aa then equal_nat aa b
         else (if less_nat Zero_nat b then False
                else error "is_UNIV called on infinite type and set"
                       (\ _ -> is_UNIV a)));

nulla :: forall a. (Ceq a) => Set_dlist a -> Bool;
nulla x = null (list_of_dlist x);

is_empty ::
  forall a.
    (Card_UNIV a, Ceq a, Cproper_interval a, Set_impla a) => Set a -> Bool;
is_empty (Complement a) = is_UNIV a;
is_empty (RBT_set rbt) =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      error "is_empty RBT_set: corder = None" (\ _ -> is_empty (RBT_set rbt));
    Just _ -> is_emptya rbt;
  });
is_empty (DList_set dxs) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      error "is_empty DList_set: ceq = None" (\ _ -> is_empty (DList_set dxs));
    Just _ -> nulla dxs;
  });
is_empty (Set_Monad xs) = null xs;

subt_at :: forall a b. Term a b -> Pos -> Term a b;
subt_at s Empty = s;
subt_at (Fun f ss) (PCons i p) = subt_at (nth ss i) p;

the_Var :: forall a b. Term a b -> b;
the_Var (Var x) = x;

map_term :: forall a b c. (a -> b) -> Term a c -> Term b c;
map_term fun (Var x) = Var x;
map_term fun (Fun f ts) = Fun (fun f) (map (map_term fun) ts);

map_rule ::
  forall a b c. (a -> b) -> (Term a c, Term a c) -> (Term b c, Term b c);
map_rule fg lr = (map_term fg (fst lr), map_term fg (snd lr));

children :: Xml -> [Xml];
children (Xml uu uv cs uw) = cs;

data Gctxt a b = GCHole | GCFun a [Gctxt a b];

zip_option :: forall a b. [a] -> [b] -> Maybe [(a, b)];
zip_option [] [] = Just [];
zip_option (x : xs) (y : ys) =
  bind (zip_option xs ys) (\ zs -> Just ((x, y) : zs));
zip_option (x : xs) [] = Nothing;
zip_option [] (y : ys) = Nothing;

guarda :: Bool -> Maybe ();
guarda b = (if b then Just () else Nothing);

match_lista ::
  forall a b. (Eq a) => [(Gctxt a b, Term a b)] -> Maybe [(Gctxt a b, b)];
match_lista ((GCFun f ss, Var x) : ps) =
  bind (match_lista ps) (\ psa -> Just ((GCFun f ss, x) : psa));
match_lista ((GCFun f ss, Fun g ts) : ps) =
  bind (guarda (f == g))
    (\ _ -> bind (zip_option ss ts) (\ psa -> match_lista (psa ++ ps)));
match_lista ((GCHole, t) : ps) = match_lista ps;
match_lista [] = Just [];

merge_lists ::
  forall a b. (Eq a) => [Gctxt a b] -> [Gctxt a b] -> Maybe [Gctxt a b];
merge_lists (c : cs) [] = Nothing;
merge_lists [] (d : ds) = Nothing;
merge_lists (GCFun f ss : cs) (GCFun g ts : ds) =
  bind (guarda (f == g))
    (\ _ ->
      bind (merge_lists ss ts)
        (\ us -> bind (merge_lists cs ds) (\ es -> Just (GCFun f us : es))));
merge_lists (c : cs) (GCHole : ds) =
  bind (merge_lists cs ds) (\ es -> Just (c : es));
merge_lists (GCHole : cs) (d : ds) =
  bind (merge_lists cs ds) (\ es -> Just (d : es));
merge_lists [] [] = Just [];

mergea :: forall a b. (Eq a) => Gctxt a b -> Gctxt a b -> Maybe (Gctxt a b);
mergea c d = bind (merge_lists [c] [d]) (\ es -> Just (nth es Zero_nat));

merge_var ::
  forall a b.
    (Eq a,
      Eq b) => a -> Gctxt b a ->
                      [(Gctxt b a, a)] ->
                        Maybe ((Gctxt b a, a), [(Gctxt b a, a)]);
merge_var x c ((d, y) : ps) =
  (if x == y then bind (mergea c d) (\ e -> merge_var x e ps)
    else bind (merge_var x c ps) (\ (b, psa) -> Just (b, (d, y) : psa)));
merge_var x c [] = Just ((c, x), []);

merge_alla ::
  forall a b. (Eq a, Eq b) => [(Gctxt a b, b)] -> Maybe [(Gctxt a b, b)];
merge_alla [] = Just [];
merge_alla ((c, x) : ps) =
  bind (merge_var x c ps)
    (\ (cx, psa) -> bind (merge_alla psa) (\ psb -> Just (cx : psb)));

matchc ::
  forall a b. (Eq a, Eq b) => (Gctxt a b, Term a b) -> Maybe [(Gctxt a b, b)];
matchc (c, t) = bind (match_lista [(c, t)]) merge_alla;

matchb :: forall a b. (Eq a, Eq b) => Gctxt a b -> Term a b -> Bool;
matchb c t = not (is_none (matchc (c, t)));

capI ::
  forall a b. (Eq a, Eq b) => [(Term a b, Term a b)] -> Term a b -> Gctxt a b;
capI uu (Var uv) = GCHole;
capI r (Fun f ts) =
  let {
    h = GCFun f (map (capI r) ts);
  } in (if any (\ ra -> matchb h (fst ra)) r then GCHole else h);

class (Abs a, Minus a, Uminus a, Zero a, Ord a) => Abs_if a where {
};

class (Minus a, One a, Sgn a, Uminus a, Zero a, Ord a) => Sgn_if a where {
};

distinct :: forall a. (Eq a) => [a] -> Bool;
distinct [] = True;
distinct (x : xs) = not (membera xs x) && distinct xs;

list_rec :: forall a b. a -> (b -> [b] -> a -> a) -> [b] -> a;
list_rec f1 f2 [] = f1;
list_rec f1 f2 (a : list) = f2 a list (list_rec f1 f2 list);

sequences :: forall a b. (Linorder b) => (a -> b) -> [a] -> [[a]];
sequences key (a : b : xs) =
  (if less (key b) (key a) then desc key b [a] xs
    else asc key b (\ ba -> a : ba) xs);
sequences key [] = [[]];
sequences key [v] = [[v]];

asc ::
  forall a b. (Linorder b) => (a -> b) -> a -> ([a] -> [a]) -> [a] -> [[a]];
asc key a f (b : bs) =
  (if not (less (key b) (key a)) then asc key b (f . (\ ba -> a : ba)) bs
    else f [a] : sequences key (b : bs));
asc key a f [] = f [a] : sequences key [];

desc :: forall a b. (Linorder b) => (a -> b) -> a -> [a] -> [a] -> [[a]];
desc key a asa (b : bs) =
  (if less (key b) (key a) then desc key b (a : asa) bs
    else (a : asa) : sequences key (b : bs));
desc key a asa [] = (a : asa) : sequences key [];

merge :: forall a b. (Linorder b) => (a -> b) -> [a] -> [a] -> [a];
merge key (a : asa) (b : bs) =
  (if less (key b) (key a) then b : merge key (a : asa) bs
    else a : merge key asa (b : bs));
merge key [] bs = bs;
merge key (v : va) [] = v : va;

merge_pairs :: forall a b. (Linorder b) => (a -> b) -> [[a]] -> [[a]];
merge_pairs key (a : b : xs) = merge key a b : merge_pairs key xs;
merge_pairs key [] = [];
merge_pairs key [v] = [v];

merge_all :: forall a b. (Linorder b) => (a -> b) -> [[a]] -> [a];
merge_all key [] = [];
merge_all key [x] = x;
merge_all key (v : vb : vc) = merge_all key (merge_pairs key (v : vb : vc));

sort_key :: forall a b. (Linorder b) => (a -> b) -> [a] -> [a];
sort_key key = merge_all key . sequences key;

max :: forall a. (Ord a) => a -> a -> a;
max a b = (if less_eq a b then b else a);

min :: forall a. (Ord a) => a -> a -> a;
min a b = (if less_eq a b then a else b);

instance Abs_if Rat where {
};

floor_rat :: Rat -> Int;
floor_rat p = let {
                (a, b) = quotient_of p;
              } in div_int a b;

class (Order a) => No_bot a where {
};

instance No_bot Rat where {
};

class (Order a) => No_top a where {
};

instance No_top Rat where {
};

instance Sgn_if Rat where {
};

shows_between ::
  ([Prelude.Char] -> [Prelude.Char]) ->
    ([Prelude.Char] -> [Prelude.Char]) ->
      ([Prelude.Char] -> [Prelude.Char]) -> [Prelude.Char] -> [Prelude.Char];
shows_between l p r = l . p . r;

shows_sep ::
  forall a.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      ([Prelude.Char] -> [Prelude.Char]) ->
        [a] -> [Prelude.Char] -> [Prelude.Char];
shows_sep s sep [] = shows_string [];
shows_sep s sep [x] = s x;
shows_sep s sep (x : v : va) = s x . sep . shows_sep s sep (v : va);

shows_list_gen ::
  forall a.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      [Prelude.Char] ->
        [Prelude.Char] ->
          [Prelude.Char] ->
            [Prelude.Char] -> [a] -> [Prelude.Char] -> [Prelude.Char];
shows_list_gen elt e l s r xs =
  (if null xs then shows_string e
    else shows_between (shows_string l) (shows_sep elt (shows_string s) xs)
           (shows_string r));

shows_list_aux ::
  forall a.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      [a] -> [Prelude.Char] -> [Prelude.Char];
shows_list_aux s xs = shows_list_gen s ['[', ']'] ['['] [',', ' '] [']'] xs;

shows_list_list ::
  forall a. (Showa a) => [[a]] -> [Prelude.Char] -> [Prelude.Char];
shows_list_list = shows_list_aux (shows_prec_list Zero_nat);

instance (Showa a) => Showa [a] where {
  shows_prec = shows_prec_list;
  shows_list = shows_list_list;
};

shows_nl :: [Prelude.Char] -> [Prelude.Char];
shows_nl = shows_prec_char Zero_nat '\n';

ctxt_rec ::
  forall a b c.
    a -> (b -> [Term b c] -> Ctxt b c -> [Term b c] -> a -> a) -> Ctxt b c -> a;
ctxt_rec f1 f2 Hole = f1;
ctxt_rec f1 f2 (More f list1 ctxt list2) =
  f2 f list1 ctxt list2 (ctxt_rec f1 f2 ctxt);

hole_pos :: forall a b. Ctxt a b -> Pos;
hole_pos Hole = Empty;
hole_pos (More f ss d ts) = PCons (size_list ss) (hole_pos d);

map_vars :: forall a b c. (a -> b) -> Term c a -> Term c b;
map_vars m (Var x) = Var (m x);
map_vars m (Fun f ts) = Fun f (map (map_vars m) ts);

num_args :: forall a b. Term a b -> Nat;
num_args (Var x) = Zero_nat;
num_args (Fun f ts) = size_list ts;

vars_term :: forall a b. (Ceq b, Corder b, Set_impla b) => Term a b -> Set b;
vars_term (Var x) = inserta x bot_set;
vars_term (Fun f ts) = foldr (sup_set . vars_term) ts bot_set;

vars_rule ::
  forall a b. (Ceq b, Corder b, Set_impla b) => (Term a b, Term a b) -> Set b;
vars_rule r = sup_set (vars_term (fst r)) (vars_term (snd r));

unapp :: forall a b. (Eq a) => a -> Term a b -> (Term a b, [Term a b]);
unapp a (Var x) = (Var x, []);
unapp a (Fun f ss) =
  (if f == a && equal_nat (size_list ss) (Nat_of_num (Bit0 One))
    then let {
           (r, ts) = unapp a (nth ss Zero_nat);
         } in (r, ts ++ [nth ss (Nat_of_num One)])
    else (Fun f ss, []));

min_list :: forall a. (Linorder a) => [a] -> a;
min_list [x] = x;
min_list (x : v : va) = min x (min_list (v : va));

update_tokens :: forall a. ([a] -> [a]) -> [a] -> Sum [Prelude.Char] ([a], [a]);
update_tokens f ts = Inr (ts, f ts);

remove_comments_aux_acc ::
  [Prelude.Char] -> Bool -> [Prelude.Char] -> [Prelude.Char];
remove_comments_aux_acc a False (c : cs) =
  (if c == '<' && take (Nat_of_num (Bit1 One)) cs == ['!', '-', '-']
    then remove_comments_aux_acc a True (tl cs)
    else remove_comments_aux_acc (c : a) False cs);
remove_comments_aux_acc a True (c : cs) =
  (if c == '-' && take (Nat_of_num (Bit0 One)) cs == ['-', '>']
    then remove_comments_aux_acc a False (drop (Nat_of_num (Bit0 One)) cs)
    else remove_comments_aux_acc a True cs);
remove_comments_aux_acc a uu [] = a;

remove_comments_aux :: Bool -> [Prelude.Char] -> [Prelude.Char];
remove_comments_aux False (c : cs) =
  (if c == '<' && take (Nat_of_num (Bit1 One)) cs == ['!', '-', '-']
    then remove_comments_aux True (tl cs)
    else c : remove_comments_aux False cs);
remove_comments_aux True (c : cs) =
  (if c == '-' && take (Nat_of_num (Bit0 One)) cs == ['-', '>']
    then remove_comments_aux False (drop (Nat_of_num (Bit0 One)) cs)
    else remove_comments_aux True cs);
remove_comments_aux uu [] = [];

remove_comments :: [Prelude.Char] -> [Prelude.Char];
remove_comments =
  (if False then reverse . remove_comments_aux_acc [] False
    else remove_comments_aux False);

returnb :: forall a b. a -> [b] -> Sum [Prelude.Char] (a, [b]);
returnb x = (\ ts -> Inr (x, ts));

bindb :: forall a b c. Sum a b -> (b -> Sum a c) -> Sum a c;
bindb m f = (case m of {
              Inl a -> Inl a;
              Inr a -> f a;
            });

bindc ::
  forall a b c.
    ([a] -> Sum [Prelude.Char] (b, [a])) ->
      (b -> [a] -> Sum [Prelude.Char] (c, [a])) ->
        [a] -> Sum [Prelude.Char] (c, [a]);
bindc m f ts = bindb (m ts) (\ (a, b) -> f a b);

shows_quote ::
  ([Prelude.Char] -> [Prelude.Char]) -> [Prelude.Char] -> [Prelude.Char];
shows_quote s =
  shows_between (shows_prec_char Zero_nat '\'') s
    (shows_prec_char Zero_nat '\'');

scan_upto ::
  [Prelude.Char] ->
    [Prelude.Char] -> Sum [Prelude.Char] ([Prelude.Char], [Prelude.Char]);
scan_upto end (t : ts) =
  (if map snd (zip end (t : ts)) == end
    then Inr (end, drop (size_list end) (t : ts))
    else bindb (scan_upto end ts) (\ (res, tsa) -> Inr (t : res, tsa)));
scan_upto end [] =
  Inl (['d', 'i', 'd', ' ', 'n', 'o', 't', ' ', 'f', 'i', 'n', 'd', ' ', 'e',
         'n', 'd', '-', 'm', 'a', 'r', 'k', 'e', 'r', ' '] ++
        shows_quote (shows_prec_list Zero_nat end) []);

trim :: [Prelude.Char] -> [Prelude.Char];
trim = dropWhile (membera [' ', '\n', '\t', '\r']);

manya ::
  (Prelude.Char -> Bool) ->
    [Prelude.Char] -> Sum [Prelude.Char] ([Prelude.Char], [Prelude.Char]);
manya p (t : ts) =
  (if p t then bindb (manya p ts) (\ (rs, tsa) -> Inr (t : rs, tsa))
    else Inr ([], t : ts));
manya p [] = Inr ([], []);

parse_header ::
  [Prelude.Char] -> Sum [Prelude.Char] ([Prelude.Char], [Prelude.Char]);
parse_header ts =
  (if take (Nat_of_num (Bit0 One)) (trim ts) == ['<', '?']
    then bindc (scan_upto ['?', '>'])
           (\ h -> bindc parse_header (\ hs -> returnb (h ++ hs))) ts
    else bindc (bindc (manya (membera [' ', '\n', '\t', '\r']))
                 (\ _ -> returnb ()))
           (\ _ -> returnb []) ts);

err_expecting ::
  forall a b. (Showa a) => [Prelude.Char] -> [a] -> Sum [Prelude.Char] (b, [a]);
err_expecting msg ts =
  Inl (['e', 'x', 'p', 'e', 'c', 't', 'i', 'n', 'g', ' '] ++
        msg ++
          [',', ' ', 'b', 'u', 't', ' ', 'f', 'o', 'u', 'n', 'd', ':', ' '] ++
            shows_quote
              (shows_prec_list Zero_nat
                (take (Nat_of_num (Bit0 (Bit1 (Bit1 (Bit1 One))))) ts))
              []);

eoi :: forall a. (Showa a) => [a] -> Sum [Prelude.Char] ((), [a]);
eoi [] = Inr ((), []);
eoi (v : va) =
  err_expecting ['e', 'n', 'd', ' ', 'o', 'f', ' ', 'i', 'n', 'p', 'u', 't']
    (v : va);

exactly_aux ::
  [Prelude.Char] ->
    [Prelude.Char] ->
      [Prelude.Char] ->
        [Prelude.Char] -> Sum [Prelude.Char] ([Prelude.Char], [Prelude.Char]);
exactly_aux s i (x : xs) (y : ys) =
  (if x == y then exactly_aux s i xs ys
    else err_expecting (['\"'] ++ s ++ ['\"']) i);
exactly_aux s i [] xs = Inr (s, trim xs);
exactly_aux s i (x : xs) [] = err_expecting (['\"'] ++ s ++ ['\"']) i;

exactly ::
  [Prelude.Char] ->
    [Prelude.Char] -> Sum [Prelude.Char] ([Prelude.Char], [Prelude.Char]);
exactly s x = exactly_aux s x s x;

parse_attribute_value ::
  [Prelude.Char] -> Sum [Prelude.Char] ([Prelude.Char], [Prelude.Char]);
parse_attribute_value =
  bindc (exactly ['\"'])
    (\ _ ->
      bindc (manya (\ y -> not ('\"' == y)))
        (\ v -> bindc (exactly ['\"']) (\ _ -> returnb v)));

errorb :: forall a b. [Prelude.Char] -> [a] -> Sum [Prelude.Char] (b, [a]);
errorb e = (\ _ -> Inl e);

letters_impl :: Prelude.Char -> Bool;
letters_impl c =
  'a' <= c && c <= 'z' ||
    ('A' <= c && c <= 'Z' ||
      ('0' <= c && c <= '9' || membera ['_', '&', ';', ':'] c));

parse_name ::
  [Prelude.Char] -> Sum [Prelude.Char] ([Prelude.Char], [Prelude.Char]);
parse_name =
  bindc (manya letters_impl)
    (\ n ->
      bindc (bindc (manya (membera [' ', '\n', '\t', '\r']))
              (\ _ -> returnb ()))
        (\ _ -> (if null n then errorb letters else returnb n)));

parse_attributes ::
  [Prelude.Char] ->
    Sum [Prelude.Char] ([([Prelude.Char], [Prelude.Char])], [Prelude.Char]);
parse_attributes [] = Inr ([], []);
parse_attributes (c : s) =
  (if membera ['/', '>'] c then Inr ([], c : s)
    else bindc parse_name
           (\ k ->
             bindc (exactly ['='])
               (\ _ ->
                 bindc parse_attribute_value
                   (\ v ->
                     bindc parse_attributes
                       (\ atts -> returnb ((k, v) : atts)))))
           (c : s));

oneof_closed ::
  [Prelude.Char] -> Sum [Prelude.Char] ([Prelude.Char], [Prelude.Char]);
oneof_closed (x : xs) =
  (if x == '>' then Inr (['>'], trim xs)
    else (if x == '/' && (case xs of {
                           [] -> False;
                           y : _ -> y == '>';
                         })
           then Inr (['/', '>'], trim (tl xs))
           else err_expecting
                  ['o', 'n', 'e', ' ', 'o', 'f', ' ', '[', '/', '>', ',', ' ',
                    '>', ']']
                  (x : xs)));
oneof_closed [] =
  err_expecting
    ['o', 'n', 'e', ' ', 'o', 'f', ' ', '[', '/', '>', ',', ' ', '>', ']'] [];

parse_text ::
  [Prelude.Char] -> Sum [Prelude.Char] (Maybe [Prelude.Char], [Prelude.Char]);
parse_text =
  bindc (manya (\ y -> not ('<' == y)))
    (\ ts ->
      let {
        text = trim ts;
      } in (if null text then returnb Nothing
             else returnb (Just (reverse (trim (reverse text))))));

parse_nodes :: [Prelude.Char] -> Sum [Prelude.Char] ([Xml], [Prelude.Char]);
parse_nodes ts =
  (if null ts || take (Nat_of_num (Bit0 One)) ts == ['<', '/']
    then returnb [] ts
    else bindc (exactly ['<'])
           (\ _ ->
             bindc parse_name
               (\ n ->
                 bindc parse_attributes
                   (\ atts ->
                     bindc oneof_closed
                       (\ e ->
                         (if e == ['/', '>']
                           then bindc parse_nodes
                                  (\ cs -> returnb (Xml n atts [] Nothing : cs))
                           else bindc parse_text
                                  (\ t ->
                                    bindc parse_nodes
                                      (\ cs ->
bindc (exactly ['<', '/'])
  (\ _ ->
    bindc (exactly n)
      (\ _ ->
        bindc (exactly ['>'])
          (\ _ ->
            bindc parse_nodes (\ ns -> returnb (Xml n atts cs t : ns))))))))))))
           ts);

parse_node :: [Prelude.Char] -> Sum [Prelude.Char] (Xml, [Prelude.Char]);
parse_node =
  bindc (exactly ['<'])
    (\ _ ->
      bindc parse_name
        (\ n ->
          bindc parse_attributes
            (\ atts ->
              bindc oneof_closed
                (\ e ->
                  (if e == ['/', '>'] then returnb (Xml n atts [] Nothing)
                    else bindc parse_text
                           (\ t ->
                             bindc parse_nodes
                               (\ cs ->
                                 bindc (exactly ['<', '/'])
                                   (\ _ ->
                                     bindc (exactly n)
                                       (\ _ ->
 bindc (exactly ['>']) (\ _ -> returnb (Xml n atts cs t)))))))))));

parse_doc :: [Prelude.Char] -> Sum [Prelude.Char] (Xmldoc, [Prelude.Char]);
parse_doc =
  bindc (update_tokens remove_comments)
    (\ _ ->
      bindc parse_header
        (\ h ->
          bindc parse_node
            (\ xml -> bindc eoi (\ _ -> returnb (Xmldoc h xml)))));

position :: Xml -> Sum_bot [Prelude.Char] Nat;
position =
  change (nata ['p', 'o', 's', 'i', 't', 'i', 'o', 'n'])
    (\ n -> minus_nat n (Nat_of_num One));

afs ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] [((a, Nat), Af_entry)];
afs xml2name =
  many ['a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 'F', 'i', 'l', 't', 'e', 'r']
    (triple
      ['a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 'F', 'i', 'l', 't', 'e', 'r',
        'E', 'n', 't', 'r', 'y']
      xml2name (nata ['a', 'r', 'i', 't', 'y'])
      (options
        [(['c', 'o', 'l', 'l', 'a', 'p', 's', 'i', 'n', 'g'],
           change (nata ['c', 'o', 'l', 'l', 'a', 'p', 's', 'i', 'n', 'g'])
             (\ i -> Collapse (minus_nat i (Nat_of_num One)))),
          (['n', 'o', 'n', 'C', 'o', 'l', 'l', 'a', 'p', 's', 'i', 'n', 'g'],
            many ['n', 'o', 'n', 'C', 'o', 'l', 'l', 'a', 'p', 's', 'i', 'n',
                   'g']
              position AFList)])
      (\ f a -> (\ b -> ((f, a), b))))
    id;

list2position :: [Nat] -> Pos;
list2position [] = Empty;
list2position (n : ns) = PCons n (list2position ns);

pos :: Xml -> Sum_bot [Prelude.Char] Pos;
pos = many ['p', 'o', 's', 'i', 't', 'i', 'o', 'n', 'I', 'n', 'T', 'e', 'r',
             'm']
        position list2position;

scg_position :: Xml -> Sum_bot [Prelude.Char] Nat;
scg_position = nata ['p', 'o', 's', 'i', 't', 'i', 'o', 'n'];

list1element :: forall a. [a] -> Maybe a;
list1element [x] = Just x;
list1element [] = Nothing;
list1element (v : vb : vc) = Nothing;

singleton ::
  forall a b.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (a -> b) -> Xml -> Sum_bot [Prelude.Char] b;
singleton tag p1 f xml =
  let {
    (Xml name atts cs text) = xml;
  } in (if name == tag && null atts && is_none text
         then (case list1element cs of {
                Nothing -> fail tag xml;
                Just cs1 -> binda (p1 cs1) (\ a -> returna (f a));
              })
         else fail tag xml);

var :: forall a. Xml -> Sum_bot [Prelude.Char] (Term a [Prelude.Char]);
var x = binda (text ['v', 'a', 'r'] x) (returna . Var);

term ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Term a [Prelude.Char]);
term xml2name x =
  options
    [(['v', 'a', 'r'], var),
      (['f', 'u', 'n', 'a', 'p', 'p'],
        many1 ['f', 'u', 'n', 'a', 'p', 'p'] xml2name
          (singleton ['a', 'r', 'g'] (term xml2name) id) Fun)]
    x;

rule ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char] (Term a [Prelude.Char], Term a [Prelude.Char]);
rule xml2name =
  pair ['r', 'u', 'l', 'e'] (singleton ['l', 'h', 's'] (term xml2name) id)
    (singleton ['r', 'h', 's'] (term xml2name) id) (\ a b -> (a, b));

scg ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          ((Term a [Prelude.Char], Term a [Prelude.Char]),
            ([(Nat, Nat)], [(Nat, Nat)]));
scg xml2name =
  many1 ['s', 'i', 'z', 'e', 'C', 'h', 'a', 'n', 'g', 'e', 'G', 'r', 'a', 'p',
          'h']
    (rule xml2name)
    (triple ['e', 'd', 'g', 'e'] scg_position
      (bool ['s', 't', 'r', 'i', 'c', 't']) scg_position
      (\ p s q -> (s, (p, q))))
    (\ lr edges ->
      (lr, (map_filter (\ x -> (if fst x then Just (snd x) else Nothing)) edges,
             map_filter (\ x -> (if not (fst x) then Just (snd x) else Nothing))
               edges)));

data Tp_ops_ext a b c d =
  Tp_ops_ext
    (a -> (Bool,
            (Set (Term b c),
              (Set (Term b c, Term b c), Set (Term b c, Term b c)))))
    (a -> [Term b c]) (a -> [(Term b c, Term b c)])
    (a -> [(Term b c, Term b c)]) (a -> [(Term b c, Term b c)]) (a -> Bool)
    (a -> Term b c -> Bool) (a -> Bool)
    (a -> (b, Nat) -> [(Term b c, Term b c)])
    (a -> [(Term b c, Term b c)] -> [(Term b c, Term b c)] -> a)
    (a -> [(Term b c, Term b c)] ->
            ([(Term b c, Term b c)], [(Term b c, Term b c)]))
    (Bool ->
      [Term b c] -> [(Term b c, Term b c)] -> [(Term b c, Term b c)] -> a)
    (a -> Bool) d;

mka ::
  forall a b c d.
    Tp_ops_ext a b c d ->
      Bool ->
        [Term b c] -> [(Term b c, Term b c)] -> [(Term b c, Term b c)] -> a;
mka (Tp_ops_ext qreltrs q r rw rules q_empty is_QNF nFQ_subset_NF_rules
      rules_map delete_R_Rw split_rules mk nfs more)
  = mk;

mk_tp ::
  forall a b c d.
    Tp_ops_ext a b c d ->
      (Bool, ([Term b c], ([(Term b c, Term b c)], [(Term b c, Term b c)]))) ->
        a;
mk_tp i (nfs, (q, (r, rw))) = mka i nfs q r rw;

capRM2 ::
  forall a b.
    (Eq a,
      Eq b) => ((a, Nat) -> [(Term a b, Term a b)]) -> Term a b -> Gctxt a b;
capRM2 uu (Var uv) = GCHole;
capRM2 rm (Fun f ts) =
  let {
    h = GCFun f (map (capRM2 rm) ts);
    n = size_list ts;
  } in (if any (\ r -> matchb h (fst r)) (rm (f, n)) then GCHole else h);

capRM ::
  forall a b.
    (Eq a,
      Eq b) => Bool ->
                 ((a, Nat) -> [(Term a b, Term a b)]) -> Term a b -> Gctxt a b;
capRM nlv rm = (if nlv then capRM2 rm else (\ _ -> GCHole));

digit2string :: Nat -> [Prelude.Char];
digit2string n =
  (if equal_nat n Zero_nat then ['0']
    else (if equal_nat n (Nat_of_num One) then ['1']
           else (if equal_nat n (Nat_of_num (Bit0 One)) then ['2']
                  else (if equal_nat n (Nat_of_num (Bit1 One)) then ['3']
                         else (if equal_nat n (Nat_of_num (Bit0 (Bit0 One)))
                                then ['4']
                                else (if equal_nat n
   (Nat_of_num (Bit1 (Bit0 One)))
                                       then ['5']
                                       else (if equal_nat n
          (Nat_of_num (Bit0 (Bit1 One)))
      then ['6']
      else (if equal_nat n (Nat_of_num (Bit1 (Bit1 One))) then ['7']
             else (if equal_nat n (Nat_of_num (Bit0 (Bit0 (Bit0 One))))
                    then ['8'] else ['9'])))))))));

shows_nat :: Nat -> [Prelude.Char] -> [Prelude.Char];
shows_nat n =
  (if less_nat n (Nat_of_num (Bit0 (Bit1 (Bit0 One))))
    then shows_string (digit2string n)
    else shows_nat (div_nat n (Nat_of_num (Bit0 (Bit1 (Bit0 One))))) .
           shows_string
             (digit2string (mod_nat n (Nat_of_num (Bit0 (Bit1 (Bit0 One)))))));

shows_prec_nat :: Nat -> Nat -> [Prelude.Char] -> [Prelude.Char];
shows_prec_nat d n = shows_nat n;

class_to_term_intern ::
  forall a b. (Nat -> a) -> Nat -> Term b (Sum () a) -> (Nat, Term b a);
class_to_term_intern iv i (Fun f ts) =
  let {
    (k, ss) =
      foldr (\ t (j, ss) ->
              let {
                (k, s) = class_to_term_intern iv j t;
              } in (k, s : ss))
        ts (i, []);
  } in (k, Fun f ss);
class_to_term_intern iv i (Var (Inl uu)) =
  (plus_nat i (Nat_of_num One), Var (iv i));
class_to_term_intern iv i (Var (Inr x)) = (i, Var x);

class_to_term ::
  forall a.
    Prelude.Char -> Term a (Sum () [Prelude.Char]) -> Term a [Prelude.Char];
class_to_term c t =
  snd (class_to_term_intern (\ i -> c : shows_prec_nat Zero_nat i []) Zero_nat
        t);

subst_of :: forall a b. (Eq b) => [(Term a b, Term a b)] -> b -> Term a b;
subst_of [] = Var;
subst_of ((Var x, t) : ts) = (\ y -> (if x == y then t else subst_of ts y));

subst_apply_term :: forall a b c. Term a b -> (b -> Term a c) -> Term a c;
subst_apply_term (Var x) sigma = sigma x;
subst_apply_term (Fun f ss) sigma =
  Fun f (map (\ t -> subst_apply_term t sigma) ss);

subst_list ::
  forall a b.
    (a -> Term b a) -> [(Term b a, Term b a)] -> [(Term b a, Term b a)];
subst_list sigma ys =
  map (\ p -> (subst_apply_term (fst p) sigma, subst_apply_term (snd p) sigma))
    ys;

decompose ::
  forall a b. (Eq a) => Term a b -> Term a b -> Maybe [(Term a b, Term a b)];
decompose s t =
  (case (s, t) of {
    (Var _, b) -> Nothing;
    (Fun f ss, Var _) -> Nothing;
    (Fun f ss, Fun g ts) -> (if f == g then zip_option ss ts else Nothing);
  });

equal_term :: forall a b. (Eq a, Eq b) => Term a b -> Term a b -> Bool;
equal_term (Fun f list) (Var v) = False;
equal_term (Var v) (Fun f list) = False;
equal_term (Fun fa lista) (Fun f list) = fa == f && lista == list;
equal_term (Var va) (Var v) = va == v;

instance (Eq a, Eq b) => Eq (Term a b) where {
  a == b = equal_term a b;
};

unify ::
  forall a b.
    (Eq a,
      Eq b) => [(Term a b, Term a b)] ->
                 [(Term a b, Term a b)] -> Maybe [(Term a b, Term a b)];
unify [] seen = Just seen;
unify ((Fun f ss, Fun g ts) : unifs) seen =
  (case decompose (Fun f ss) (Fun g ts) of {
    Nothing -> Nothing;
    Just e -> unify (e ++ unifs) seen;
  });
unify ((Fun f ss, Var x) : unifs) seen = unify ((Var x, Fun f ss) : unifs) seen;
unify ((Var x, t) : unifs) seen =
  (if equal_term t (Var x) then unify unifs seen
    else (if membera (vars_term_lista t) x then Nothing
           else unify (subst_list (subst x t) unifs)
                  ((Var x, t) : subst_list (subst x t) seen)));

mgu ::
  forall a b. (Eq a, Eq b) => Term a b -> Term a b -> Maybe (b -> Term a b);
mgu s t =
  (case unify [(s, t)] [] of {
    Nothing -> Nothing;
    Just res -> Just (subst_of res);
  });

mgu_class ::
  forall a.
    (Eq a) => Term a (Sum () [Prelude.Char]) ->
                Term a [Prelude.Char] ->
                  Maybe ([Prelude.Char] -> Term a [Prelude.Char]);
mgu_class cs t = mgu (class_to_term 'z' cs) (map_vars (\ a -> 'y' : a) t);

partition :: forall a. (a -> Bool) -> [a] -> ([a], [a]);
partition p [] = ([], []);
partition p (x : xs) =
  let {
    (yes, no) = partition p xs;
  } in (if p x then (x : yes, no) else (yes, x : no));

removeAll :: forall a. (Eq a) => a -> [a] -> [a];
removeAll x [] = [];
removeAll x (y : xs) = (if x == y then removeAll x xs else y : removeAll x xs);

class (Linorder a) => Key a where {
};

emptya :: forall a b c d. Memory_ext a b c d -> () -> a;
emptya (Memory_ext empty lookup store more) = empty;

store :: forall a b c d. Memory_ext a b c d -> a -> (b, c) -> a;
store (Memory_ext empty lookup store more) = store;

instance (Eq a, Order a, Eq b, Order b) => Preorder (a, b) where {
};

instance (Eq a, Order a, Eq b, Order b) => Order (a, b) where {
};

s_ins :: forall a b c. (a -> () -> b -> c) -> a -> b -> c;
s_ins update x s = update x () s;

mk_eq :: forall a. (a -> a -> Bool) -> a -> a -> Bool;
mk_eq le x y = le x y && le y x;

sharp_term :: forall a b. (a -> a) -> Term a b -> Term a b;
sharp_term shp (Var x) = Var x;
sharp_term shp (Fun f ss) = Fun (shp f) ss;

aarity :: forall a. (a -> Nat -> [a]) -> a -> Nat -> Nat;
aarity sm f n = minus_nat (size_list (sm f n)) (Nat_of_num One);

list_diff :: forall a. (Eq a) => [a] -> [a] -> [a];
list_diff [] ys = [];
list_diff (x : xs) ys =
  let {
    zs = list_diff xs ys;
  } in (if membera ys x then zs else x : zs);

ctxt ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Ctxt a [Prelude.Char]);
ctxt xml2name x =
  options
    [(['b', 'o', 'x'], leaf ['b', 'o', 'x'] Hole),
      (['f', 'u', 'n', 'C', 'o', 'n', 't', 'e', 'x', 't'],
        tuple4 ['f', 'u', 'n', 'C', 'o', 'n', 't', 'e', 'x', 't'] xml2name
          (many ['b', 'e', 'f', 'o', 'r', 'e'] (term xml2name) id)
          (ctxt xml2name) (many ['a', 'f', 't', 'e', 'r'] (term xml2name) id)
          More)]
    x;

data Complexity_measure a b = Derivational_Complexity [(a, Nat)]
  | Runtime_Complexity [(a, Nat)] [(a, Nat)];

data Location = H | A | Ba;

newtype Complexity_class = Comp_Poly Nat;

data Ostrategy a b = Outermost | Outermost_Q [Term a b];

data Strategy a b = No_Strategy | Innermost | Innermost_Q [Term a b];

data Input a b =
  DP_input
    (Bool, ([(Term a b, Term a b)], (Strategy a b, [(Term a b, Term a b)])))
  | TRS_input
      (Strategy a b, ([(Term a b, Term a b)], Maybe [(Term a b, Term a b)]))
  | COMP_input ([(Term a b, Term a b)], [(Term a b, Term a b)])
  | EQ_input ([(Term a b, Term a b)], (Term a b, Term a b))
  | CPX_input
      (Strategy a b,
        ([(Term a b, Term a b)],
          (Maybe [(Term a b, Term a b)],
            (Complexity_measure a b, Complexity_class))))
  | OTRS_input (Ostrategy a b, [(Term a b, Term a b)])
  | FPTRS_input ([(Term a b, Term a b)], [(Ctxt a b, (Term a b, Location))])
  | CTRS_input [((Term a b, Term a b), [(Term a b, Term a b)])];

xml3to4elements ::
  forall a b c d e.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (Xml -> Sum_bot [Prelude.Char] b) ->
          (Xml -> Sum_bot [Prelude.Char] c) ->
            (Xml -> Sum_bot [Prelude.Char] d) ->
              (a -> b -> Maybe c -> d -> e) -> Xml -> Sum_bot [Prelude.Char] e;
xml3to4elements tag p1 p2 p3 p4 f (Xml name atts cs text) =
  let {
    l = size_list cs;
  } in (if name == tag &&
             null atts &&
               less_eq_nat (Nat_of_num (Bit1 One)) l &&
                 less_eq_nat l (Nat_of_num (Bit0 (Bit0 One))) && is_none text
         then binda (p1 (nth cs Zero_nat))
                (\ x1 ->
                  binda (p2 (nth cs (Nat_of_num One)))
                    (\ x2 ->
                      (if equal_nat l (Nat_of_num (Bit0 (Bit0 One)))
                        then binda (p3 (nth cs (Nat_of_num (Bit0 One))))
                               (\ x3 ->
                                 binda (p4 (nth cs (Nat_of_num (Bit1 One))))
                                   (\ x4 -> returna (f x1 x2 (Just x3) x4)))
                        else binda (p4 (nth cs (Nat_of_num (Bit0 One))))
                               (\ x4 -> returna (f x1 x2 Nothing x4)))))
         else fail tag (Xml name atts cs text));

relstep ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          (Pos, ((Term a [Prelude.Char], Term a [Prelude.Char]),
                  (Bool, Term a [Prelude.Char])));
relstep xml2name =
  xml3to4elements ['r', 'e', 'w', 'r', 'i', 't', 'e', 'S', 't', 'e', 'p'] pos
    (rule xml2name) (leaf ['r', 'e', 'l', 'a', 't', 'i', 'v', 'e'] ())
    (term xml2name) (\ p r rel t -> (p, (r, (is_none rel, t))));

relsteps ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          (Term a [Prelude.Char],
            [(Pos, ((Term a [Prelude.Char], Term a [Prelude.Char]),
                     (Bool, Term a [Prelude.Char])))]);
relsteps xml2name =
  many1 ['r', 'e', 'w', 'r', 'i', 't', 'e', 'S', 'e', 'q', 'u', 'e', 'n', 'c',
          'e']
    (singleton ['s', 't', 'a', 'r', 't', 'T', 'e', 'r', 'm'] (term xml2name) id)
    (relstep xml2name) (\ a b -> (a, b));

substa ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] [([Prelude.Char], Term a [Prelude.Char])];
substa xml2name =
  many ['s', 'u', 'b', 's', 't', 'i', 't', 'u', 't', 'i', 'o', 'n']
    (pair ['s', 'u', 'b', 's', 't', 'E', 'n', 't', 'r', 'y']
      (text ['v', 'a', 'r']) (term xml2name) (\ a b -> (a, b)))
    id;

loop ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          (Term a [Prelude.Char],
            ([(Pos, ((Term a [Prelude.Char], Term a [Prelude.Char]),
                      (Bool, Term a [Prelude.Char])))],
              ([([Prelude.Char], Term a [Prelude.Char])],
                Ctxt a [Prelude.Char])));
loop xml2name =
  triple ['l', 'o', 'o', 'p'] (relsteps xml2name) (substa xml2name)
    (ctxt xml2name) (\ (s, rseq) sigma c -> (s, (rseq, (sigma, c))));

proj ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (ProjL a);
proj xml2name =
  change (afs xml2name)
    (\ afl ->
      Projection
        (map (\ a ->
               (case a of {
                 (fa, Collapse aa) -> (fa, aa);
                 (fa, AFList _) -> (fa, snd fa);
               }))
          afl));

proj_term :: forall a b. ((a, Nat) -> Nat) -> Term a b -> Term a b;
proj_term p (Var x) = Var x;
proj_term p (Fun f ts) =
  let {
    n = size_list ts;
    i = p (f, n);
  } in (if less_nat i n then nth ts i else Fun f ts);

start_term ::
  forall a.
    (Eq a) => (Xml -> Sum_bot [Prelude.Char] a) ->
                Term a [Prelude.Char] ->
                  Xml -> Sum_bot [Prelude.Char] (Term a [Prelude.Char]);
start_term xml2name t =
  singleton ['s', 't', 'a', 'r', 't', 'T', 'e', 'r', 'm']
    (\ xml ->
      binda (term xml2name xml)
        (\ s ->
          (if equal_term s t then returna t
            else errora
                   ['<', 's', 't', 'a', 'r', 't', 'T', 'e', 'r', 'm', '>', ' ',
                     'd', 'o', 'e', 's', ' ', 'n', 'o', 't', ' ', 'm', 'a', 't',
                     'c', 'h', ' ', 'l', 'h', 's'])))
    id;

rstep ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          (Pos, ((Term a [Prelude.Char], Term a [Prelude.Char]),
                  Term a [Prelude.Char]));
rstep xml2name =
  triple ['r', 'e', 'w', 'r', 'i', 't', 'e', 'S', 't', 'e', 'p'] pos
    (rule xml2name) (term xml2name) (\ p r t -> (p, (r, t)));

rseq ::
  forall a.
    (Eq a) => (Xml -> Sum_bot [Prelude.Char] a) ->
                ((a, Nat) -> Nat) ->
                  (Term a [Prelude.Char], Term a [Prelude.Char]) ->
                    Xml ->
                      Sum_bot [Prelude.Char]
                        ((Term a [Prelude.Char], Term a [Prelude.Char]),
                          [(Pos, ((Term a [Prelude.Char],
                                    Term a [Prelude.Char]),
                                   Term a [Prelude.Char]))]);
rseq xml2name pi r =
  many1 ['r', 'e', 'w', 'r', 'i', 't', 'e', 'S', 'e', 'q', 'u', 'e', 'n', 'c',
          'e']
    (start_term xml2name (proj_term pi (fst r))) (rstep xml2name)
    (\ _ -> (\ a -> (r, a)));

supteq_list :: forall a b. Term a b -> [Term a b];
supteq_list (Var x) = [Var x];
supteq_list (Fun f ts) = Fun f ts : concatMap supteq_list ts;

match_term_list ::
  forall a b c. (Eq a) => [(Term a b, Term a c)] -> Maybe [(c, Term a b)];
match_term_list [] = Just [];
match_term_list ((Var uu, Fun uv uw) : ps) = Nothing;
match_term_list ((Fun f ts, Fun g ls) : ps) =
  bind (guarda (f == g))
    (\ _ -> bind (zip_option ts ls) (\ e -> match_term_list (e ++ ps)));
match_term_list ((t, Var x) : ps) =
  bind (match_term_list ps) (\ e -> Just ((x, t) : e));

match_vars ::
  forall a b c. (Eq a, Eq b, Eq c) => [(a, Term b c)] -> Maybe [(a, Term b c)];
match_vars [] = Just [];
match_vars ((x, t) : ps) =
  (case map_of ps x of {
    Nothing ->
      (case match_vars ps of {
        Nothing -> Nothing;
        Just sigma -> Just ((x, t) : sigma);
      });
    Just s -> (if equal_term t s then match_vars ps else Nothing);
  });

match_list ::
  forall a b c.
    (Eq a, Eq b, Eq c) => [(Term a b, Term a c)] -> Maybe [(c, Term a b)];
match_list tls =
  (case match_term_list tls of {
    Nothing -> Nothing;
    Just a -> match_vars a;
  });

mk_subst ::
  forall a b c. (Eq a) => (a -> Term b c) -> [(a, Term b c)] -> a -> Term b c;
mk_subst d xts =
  (\ x -> (case map_of xts x of {
            Nothing -> d x;
            Just t -> t;
          }));

matcha ::
  forall a b c.
    (Eq a, Eq b, Eq c) => Term a b -> Term a c -> Maybe (c -> Term a b);
matcha t l =
  (case match_list [(t, l)] of {
    Nothing -> Nothing;
    Just bs -> Just (mk_subst (\ _ -> t) bs);
  });

matches :: forall a b c. (Eq a, Eq b, Eq c) => Term a b -> Term a c -> Bool;
matches t l = (case matcha t l of {
                Nothing -> False;
                Just _ -> True;
              });

is_NF ::
  forall a b.
    (Eq a, Key a,
      Eq b) => Bool -> [Term a b] -> (a -> [Term a b]) -> Term a b -> Bool;
is_NF var_cond r m =
  (if var_cond then (\ _ -> False)
    else (if null r then (\ _ -> True)
           else (\ t ->
                  all (\ u ->
                        all (\ l -> not (matches u l)) (m (fst (the (root u)))))
                    (supteq_list t))));

label :: forall a b. Lab a b -> Nat -> Sum b [Lab a b] -> Lab a b;
label f n (Inl l) = Lab f l;
label f n (Inr l) = FunLab f l;

unlab :: forall a b. Lab a b -> Lab a b;
unlab (Lab f l) = f;
unlab (FunLab f l) = f;
unlab (UnLab v) = UnLab v;
unlab (Sharp v) = Sharp v;

lookupa :: forall a b c d. Memory_ext a b c d -> a -> b -> Maybe c;
lookupa (Memory_ext empty lookup store more) = lookup;

rm_reverse_iterateoi ::
  forall a b c. Rbta a b -> (c -> Bool) -> ((a, b) -> c -> c) -> c -> c;
rm_reverse_iterateoi Emptya c f sigma = sigma;
rm_reverse_iterateoi (Branch col l k v r) c f sigma =
  (if c sigma
    then let {
           sigmaa = rm_reverse_iterateoi r c f sigma;
         } in (if c sigmaa then rm_reverse_iterateoi l c f (f (k, v) sigmaa)
                else sigmaa)
    else sigma);

rm_reverse_iterateoia ::
  forall a b c.
    (Linorder a) => Rbt a b -> (c -> Bool) -> ((a, b) -> c -> c) -> c -> c;
rm_reverse_iterateoia r = rm_reverse_iterateoi (impl_of r);

it_map_to_list ::
  forall a b.
    (a -> ([b] -> Bool) -> (b -> [b] -> [b]) -> [b] -> [b]) -> a -> [b];
it_map_to_list iti m = iti m (\ _ -> True) (\ a b -> a : b) [];

rm_to_list :: forall a b. (Linorder a) => Rbt a b -> [(a, b)];
rm_to_list = it_map_to_list rm_reverse_iterateoia;

values :: forall a b. (Linorder a) => Rbt a [b] -> [b];
values m = concatMap snd (rm_to_list m);

class (Semiring_char_0 a, Ring_1 a) => Ring_char_0 a where {
};

data Tpoly a b = PVar a | PNum b | PSum [Tpoly a b] | PMult [Tpoly a b];

one_pos :: Pos;
one_pos = Empty;

instance One Pos where {
  onea = one_pos;
};

instance Linorder Rat where {
};

sorted_list_subset_fusion ::
  forall a b c.
    (a -> a -> Bool) ->
      (a -> a -> Bool) -> Generator a b -> Generator a c -> b -> c -> Bool;
sorted_list_subset_fusion less eq g1 g2 s1 s2 =
  (if has_next g1 s1
    then let {
           (x, s1a) = next g1 s1;
         } in has_next g2 s2 &&
                let {
                  (y, s2a) = next g2 s2;
                } in (if eq x y
                       then sorted_list_subset_fusion less eq g1 g2 s1a s2a
                       else less y x &&
                              sorted_list_subset_fusion less eq g1 g2 s1 s2a)
    else True);

list_all_fusion :: forall a b. Generator a b -> (a -> Bool) -> b -> Bool;
list_all_fusion g p s =
  (if has_next g s
    then let {
           (x, sa) = next g s;
         } in p x && list_all_fusion g p sa
    else True);

subset_eq :: forall a. (Cenum a, Ceq a, Corder a) => Set a -> Set a -> Bool;
subset_eq (RBT_set rbt1) (RBT_set rbt2) =
  (case corder of {
    Nothing ->
      error "subset RBT_set RBT_set: corder = None"
        (\ _ -> subset_eq (RBT_set rbt1) (RBT_set rbt2));
    Just (le, lt) ->
      (case ceq of {
        Nothing ->
          sorted_list_subset_fusion lt (mk_eq le) rbt_keys_generator
            rbt_keys_generator (init rbt1) (init rbt2);
        Just eq ->
          sorted_list_subset_fusion lt eq rbt_keys_generator rbt_keys_generator
            (init rbt1) (init rbt2);
      });
  });
subset_eq (Complement a1) (Complement a2) = subset_eq a2 a1;
subset_eq (Collect_set p) (Complement a) =
  subset_eq a (collect (\ x -> not (p x)));
subset_eq (Set_Monad xs) c = all (\ x -> member x c) xs;
subset_eq (DList_set dxs) c =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      error "subset DList_set1: ceq = None"
        (\ _ -> subset_eq (DList_set dxs) c);
    Just _ -> dlist_all (\ x -> member x c) dxs;
  });
subset_eq (RBT_set rbt) b =
  (case (corder :: Maybe (a -> a -> Bool, a -> a -> Bool)) of {
    Nothing ->
      error "subset RBT_set1: corder = None" (\ _ -> subset_eq (RBT_set rbt) b);
    Just _ -> list_all_fusion rbt_keys_generator (\ x -> member x b) (init rbt);
  });

less_eq_set :: forall a. (Cenum a, Ceq a, Corder a) => Set a -> Set a -> Bool;
less_eq_set = subset_eq;

s_memb :: forall a b c. (a -> b -> Maybe c) -> a -> b -> Bool;
s_memb lookup x s = not (is_none (lookup x s));

ctxt_apply :: forall a b. Ctxt a b -> Term a b -> Term a b;
ctxt_apply Hole s = s;
ctxt_apply (More f ss1 c ss2) s = Fun f (ss1 ++ ctxt_apply c s : ss2);

equal_ctxt :: forall a b. (Eq a, Eq b) => Ctxt a b -> Ctxt a b -> Bool;
equal_ctxt (More f list1 ctxt list2) Hole = False;
equal_ctxt Hole (More f list1 ctxt list2) = False;
equal_ctxt (More fa list1a ctxta list2a) (More f list1 ctxt list2) =
  fa == f && list1a == list1 && equal_ctxt ctxta ctxt && list2a == list2;
equal_ctxt Hole Hole = True;

less_eq_proda ::
  forall a b.
    (a -> a -> Bool) ->
      (a -> a -> Bool) -> (b -> b -> Bool) -> (a, b) -> (a, b) -> Bool;
less_eq_proda leq_a less_a leq_b =
  (\ (x1, x2) (y1, y2) -> less_a x1 y1 || leq_a x1 y1 && leq_b x2 y2);

less_proda ::
  forall a b.
    (a -> a -> Bool) ->
      (a -> a -> Bool) -> (b -> b -> Bool) -> (a, b) -> (a, b) -> Bool;
less_proda leq_a less_a less_b =
  (\ (x1, x2) (y1, y2) -> less_a x1 y1 || leq_a x1 y1 && less_b x2 y2);

corder_prod ::
  forall a b.
    (Corder a,
      Corder b) => Maybe ((a, b) -> (a, b) -> Bool, (a, b) -> (a, b) -> Bool);
corder_prod =
  (case corder of {
    Nothing -> Nothing;
    Just (leq_a, lt_a) ->
      (case corder of {
        Nothing -> Nothing;
        Just (leq_b, lt_b) ->
          Just (less_eq_proda leq_a lt_a leq_b, less_proda leq_a lt_a lt_b);
      });
  });

instance (Corder a, Corder b) => Corder (a, b) where {
  corder = corder_prod;
};

corder_nat :: Maybe (Nat -> Nat -> Bool, Nat -> Nat -> Bool);
corder_nat = Just (less_eq_nat, less_nat);

instance Corder Nat where {
  corder = corder_nat;
};

set_impl_choose2 :: Set_impl -> Set_impl -> Set_impl;
set_impl_choose2 Set_Monada Set_Monada = Set_Monada;
set_impl_choose2 Set_RBT Set_RBT = Set_RBT;
set_impl_choose2 Set_DList Set_DList = Set_DList;
set_impl_choose2 Set_Collect Set_Collect = Set_Collect;
set_impl_choose2 x y = Set_Choose;

set_impl_prod ::
  forall a b. (Set_impla a, Set_impla b) => Phantom (a, b) Set_impl;
set_impl_prod =
  Phantom
    (set_impl_choose2 (of_phantom (set_impl :: Phantom a Set_impl))
      (of_phantom (set_impl :: Phantom b Set_impl)));

instance (Set_impla a, Set_impla b) => Set_impla (a, b) where {
  set_impl = set_impl_prod;
};

prod_rec :: forall a b c. (a -> b -> c) -> (a, b) -> c;
prod_rec f1 (a, b) = f1 a b;

ceq_prod :: forall a b. (Ceq a, Ceq b) => Maybe ((a, b) -> (a, b) -> Bool);
ceq_prod =
  (case ceq of {
    Nothing -> Nothing;
    Just eq_0 ->
      (case ceq of {
        Nothing -> Nothing;
        Just eq_1 ->
          Just (prod_rec
                 (\ x_0 x_1 (y_0, y_1) -> eq_0 x_0 y_0 && eq_1 x_1 y_1));
      });
  });

instance (Ceq a, Ceq b) => Ceq (a, b) where {
  ceq = ceq_prod;
};

set_impl_nat :: Phantom Nat Set_impl;
set_impl_nat = Phantom Set_RBT;

instance Set_impla Nat where {
  set_impl = set_impl_nat;
};

ceq_nat :: Maybe (Nat -> Nat -> Bool);
ceq_nat = Just equal_nat;

instance Ceq Nat where {
  ceq = ceq_nat;
};

funas_term ::
  forall a b. (Ceq a, Corder a, Set_impla a) => Term a b -> Set (a, Nat);
funas_term (Var uu) = bot_set;
funas_term (Fun f ts) =
  sup_set (inserta (f, size_list ts) bot_set)
    (foldr (sup_set . funas_term) ts bot_set);

term_rec_1 ::
  forall a b c d.
    (a -> b) ->
      (c -> [Term c a] -> d -> b) ->
        d -> (Term c a -> [Term c a] -> b -> d -> d) -> Term c a -> b;
term_rec_1 f1 f2 f3 f4 (Var v) = f1 v;
term_rec_1 f1 f2 f3 f4 (Fun f list) = f2 f list (term_rec_2 f1 f2 f3 f4 list);

term_rec_2 ::
  forall a b c d.
    (a -> b) ->
      (c -> [Term c a] -> d -> b) ->
        d -> (Term c a -> [Term c a] -> b -> d -> d) -> [Term c a] -> d;
term_rec_2 f1 f2 f3 f4 [] = f3;
term_rec_2 f1 f2 f3 f4 (term : list) =
  f4 term list (term_rec_1 f1 f2 f3 f4 term) (term_rec_2 f1 f2 f3 f4 list);

hvf_top :: forall a b. (Eq a) => a -> Nat -> Term a b -> Bool;
hvf_top a n (Fun f ts) =
  (if f == a && equal_nat (size_list ts) n then not (is_Var (hd ts)) else True);
hvf_top a n (Var uu) = False;

list_inter :: forall a. (Eq a) => [a] -> [a] -> [a];
list_inter [] bs = [];
list_inter (a : asa) bs =
  (if membera bs a then a : list_inter asa bs else list_inter asa bs);

list_union :: forall a. (Eq a) => [a] -> [a] -> [a];
list_union [] ys = ys;
list_union (x : xs) ys =
  let {
    zs = list_union xs ys;
  } in (if membera zs x then zs else x : zs);

crule ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          ((Term a [Prelude.Char], Term a [Prelude.Char]),
            [(Term a [Prelude.Char], Term a [Prelude.Char])]);
crule xml2name =
  many1 ['c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n', 'a', 'l', 'R', 'u', 'l',
          'e']
    (rule xml2name) (rule xml2name) (\ a b -> (a, b));

data Domain = Natural Nat | Integera | Arctic | Arctic_rat | Int_mat Nat Nat
  | Arc_mat Nat | Arc_rat_mat Nat | Rational Rat Nat | Rat_mat Nat Nat
  | Mini_Alg Mini_alg_number Nat | Mini_Alg_mat Nat Nat;

estep ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          (Pos, ((Term a [Prelude.Char], Term a [Prelude.Char]),
                  (Bool, Term a [Prelude.Char])));
estep xml2name =
  tuple4 ['e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 'S', 't', 'e', 'p'] pos
    (rule xml2name)
    (options
      [(['l', 'e', 'f', 't', 'R', 'i', 'g', 'h', 't'],
         leaf ['l', 'e', 'f', 't', 'R', 'i', 'g', 'h', 't'] True),
        (['r', 'i', 'g', 'h', 't', 'L', 'e', 'f', 't'],
          leaf ['r', 'i', 'g', 'h', 't', 'L', 'e', 'f', 't'] False)])
    (term xml2name) (\ p r b t -> (p, (r, (b, t))));

rules ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char] [(Term a [Prelude.Char], Term a [Prelude.Char])];
rules xml2name = many ['r', 'u', 'l', 'e', 's'] (rule xml2name) id;

state :: Xml -> Sum_bot [Prelude.Char] [Prelude.Char];
state = text ['s', 't', 'a', 't', 'e'];

xml_lab :: forall a b. (Showa a, Showa b) => Lab a [b] -> Xml;
xml_lab (UnLab x) =
  Xml ['n', 'a', 'm', 'e'] [] [] (Just (shows_prec Zero_nat x []));
xml_lab (Sharp x) = Xml ['s', 'h', 'a', 'r', 'p'] [] [xml_lab x] Nothing;
xml_lab (FunLab x l) =
  Xml ['l', 'a', 'b', 'e', 'l', 'e', 'd', 'S', 'y', 'm', 'b', 'o', 'l'] []
    [xml_lab x,
      Xml ['s', 'y', 'm', 'b', 'o', 'l', 'L', 'a', 'b', 'e', 'l'] []
        (map xml_lab l) Nothing]
    Nothing;
xml_lab (Lab x l) =
  Xml ['l', 'a', 'b', 'e', 'l', 'e', 'd', 'S', 'y', 'm', 'b', 'o', 'l'] []
    [xml_lab x,
      Xml ['n', 'u', 'm', 'b', 'e', 'r', 'L', 'a', 'b', 'e', 'l'] []
        (map (\ n ->
               Xml ['n', 'u', 'm', 'b', 'e', 'r'] [] []
                 (Just (shows_prec Zero_nat n [])))
          l)
        Nothing]
    Nothing;

xml_term ::
  forall a b c. (Showa a, Showa b, Showa c) => Term (Lab a [b]) c -> Xml;
xml_term (Var x) = Xml ['v', 'a', 'r'] [] [] (Just (shows_prec Zero_nat x []));
xml_term (Fun f ts) =
  Xml ['f', 'u', 'n', 'a', 'p', 'p'] []
    (xml_lab f : map (\ t -> Xml ['a', 'r', 'g'] [] [xml_term t] Nothing) ts)
    Nothing;

xml_Q ::
  forall a b c.
    (Showa a, Showa b,
      Showa c) => Sum (Strategy (Lab a [b]) c) (Ostrategy (Lab a [b]) c) ->
                    [Xml];
xml_Q (Inl No_Strategy) = [];
xml_Q (Inl Innermost) =
  [Xml ['s', 't', 'r', 'a', 't', 'e', 'g', 'y'] []
     [Xml ['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't'] [] [] Nothing] Nothing];
xml_Q (Inr Outermost) =
  [Xml ['s', 't', 'r', 'a', 't', 'e', 'g', 'y'] []
     [Xml ['o', 'u', 't', 'e', 'r', 'm', 'o', 's', 't'] [] [] Nothing] Nothing];
xml_Q (Inl (Innermost_Q q)) =
  [Xml ['s', 't', 'r', 'a', 't', 'e', 'g', 'y'] []
     [Xml ['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't', 'L', 'h', 's', 's'] []
        (map xml_term q) Nothing]
     Nothing];

instance Ord Prelude.Char where {
  less_eq = (\ a b -> a <= b);
  less = (\ a b -> a < b);
};

data Cr_proof a b c = SN_WCR (Join_info (Lab a b)) (Trs_termination_proof a b c)
  | Weakly_Orthogonal | Strongly_Closed Nat;

data Dpp_ops_ext a b c d =
  Dpp_ops_ext
    (a -> (Bool,
            (Bool,
              (Set (Term b c, Term b c),
                (Set (Term b c, Term b c),
                  (Set (Term b c),
                    (Set (Term b c, Term b c), Set (Term b c, Term b c))))))))
    (a -> [(Term b c, Term b c)]) (a -> [(Term b c, Term b c)])
    (a -> [(Term b c, Term b c)]) (a -> [Term b c])
    (a -> [(Term b c, Term b c)]) (a -> [(Term b c, Term b c)])
    (a -> [(Term b c, Term b c)]) (a -> Bool) (a -> Bool) (a -> Bool)
    (a -> Term b c -> Bool) (a -> Bool)
    (a -> (b, Nat) -> [(Term b c, Term b c)])
    (a -> (b, Nat) -> [(Term b c, Term b c)]) (a -> [(Term b c, Term b c)] -> a)
    (a -> (Term b c, Term b c) -> [(Term b c, Term b c)] -> a)
    (a -> [(Term b c, Term b c)] -> a)
    (a -> [(Term b c, Term b c)] -> [(Term b c, Term b c)] -> a)
    (a -> [(Term b c, Term b c)] -> [(Term b c, Term b c)] -> a)
    (a -> [(Term b c, Term b c)] ->
            ([(Term b c, Term b c)], [(Term b c, Term b c)]))
    (a -> [(Term b c, Term b c)] ->
            ([(Term b c, Term b c)], [(Term b c, Term b c)]))
    (Bool ->
      Bool ->
        [(Term b c, Term b c)] ->
          [(Term b c, Term b c)] ->
            [Term b c] -> [(Term b c, Term b c)] -> [(Term b c, Term b c)] -> a)
    (a -> Bool) (a -> Bool) (a -> Bool) d;

mkc ::
  forall a b c d.
    Dpp_ops_ext a b c d ->
      Bool ->
        Bool ->
          [(Term b c, Term b c)] ->
            [(Term b c, Term b c)] ->
              [Term b c] ->
                [(Term b c, Term b c)] -> [(Term b c, Term b c)] -> a;
mkc (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
      rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map
      reverse_rules_map intersect_pairs replace_pair intersect_rules delete_P_Pw
      delete_R_Rw split_pairs split_rules mk minimal nfs wwf_rules more)
  = mk;

mk_dpp ::
  forall a b c d.
    Dpp_ops_ext a b c d ->
      (Bool,
        (Bool,
          ([(Term b c, Term b c)],
            ([(Term b c, Term b c)],
              ([Term b c],
                ([(Term b c, Term b c)], [(Term b c, Term b c)])))))) ->
        a;
mk_dpp i (nfs, (m, (p, (pw, (q, (r, rw)))))) = mkc i nfs m p pw q r rw;

update :: forall a b c. (a -> b) -> (a, c) -> (b, c);
update p_to_p (p, info) = (p_to_p p, info);

isOK :: forall a b. Sum a b -> Bool;
isOK m = (case m of {
           Inl _ -> False;
           Inr _ -> True;
         });

mapM :: forall a b c. (a -> Sum b c) -> [a] -> Sum b [c];
mapM f [] = Inr [];
mapM f (x : xs) = bindb (f x) (\ y -> bindb (mapM f xs) (\ ys -> Inr (y : ys)));

list_update :: forall a. [a] -> Nat -> a -> [a];
list_update [] i y = [];
list_update (x : xs) i y =
  (if equal_nat i Zero_nat then y : xs
    else x : list_update xs (minus_nat i (Nat_of_num One)) y);

base :: forall a. (a, Nat) -> a;
base (f, h) = f;

lift :: forall a. Nat -> a -> (a, Nat);
lift h f = (f, h);

roof :: forall a b. (Eq b) => (Term a b, Term a b) -> Term a b -> Bool;
roof (l, r) =
  let {
    xs = vars_term_lista r;
  } in (\ t -> let {
                 xt = vars_term_lista t;
               } in all (membera xt) xs);

vec :: forall a. Nat -> [a] -> Bool;
vec n x = equal_nat (size_list x) n;

mat :: forall a. Nat -> Nat -> [[a]] -> Bool;
mat nr nc m = equal_nat (size_list m) nc && all (vec nr) m;

extracta :: forall a. (a -> Bool) -> [a] -> Maybe ([a], (a, [a]));
extracta p [] = Nothing;
extracta p (x : xs) =
  (if p x then Just ([], (x, xs))
    else (case extracta p xs of {
           Nothing -> Nothing;
           Just (ys, (y, zs)) -> Just (x : ys, (y, zs));
         }));

eq_monom :: forall a. (Eq a) => [(a, Nat)] -> [(a, Nat)] -> Bool;
eq_monom [] n = null n;
eq_monom ((x, p) : m) n =
  (case extracta (\ yq -> fst yq == x) n of {
    Nothing -> False;
    Just (n1, ((_, q), n2)) -> equal_nat p q && eq_monom m (n1 ++ n2);
  });

poly_split ::
  forall a b.
    (Eq a, Zero b) => [(a, Nat)] -> [([(a, Nat)], b)] -> (b, [([(a, Nat)], b)]);
poly_split m p =
  (case extracta (\ (n, _) -> eq_monom m n) p of {
    Nothing -> (zeroa, p);
    Just (p1, ((_, c), p2)) -> (c, p1 ++ p2);
  });

max_v ::
  forall a b.
    (Zero a,
      Ord a) => a -> ((b, Nat) -> [([(Nat, Nat)], a)]) -> [(b, Nat)] -> a;
max_v v i fs =
  max v (foldr (\ f m -> max m (fst (poly_split [] (i f)))) fs zeroa);

to_list :: Pos -> [Nat];
to_list Empty = [];
to_list (PCons i p) = i : to_list p;

equal_color :: Color -> Color -> Bool;
equal_color B R = False;
equal_color R B = False;
equal_color B B = True;
equal_color R R = True;

equal_rbta :: forall a b. (Eq a, Eq b) => Rbta a b -> Rbta a b -> Bool;
equal_rbta (Branch color rbt1 a b rbt2) Emptya = False;
equal_rbta Emptya (Branch color rbt1 a b rbt2) = False;
equal_rbta (Branch colora rbt1a aa ba rbt2a) (Branch color rbt1 a b rbt2) =
  equal_color colora color &&
    equal_rbta rbt1a rbt1 && aa == a && ba == b && equal_rbta rbt2a rbt2;
equal_rbta Emptya Emptya = True;

equal_rbt :: forall a b. (Eq a, Linorder a, Eq b) => Rbt a b -> Rbt a b -> Bool;
equal_rbt ra r = equal_rbta (impl_of ra) (impl_of r);

instance (Eq a, Linorder a, Eq b) => Eq (Rbt a b) where {
  a == b = equal_rbt a b;
};

class (Field a, Ring_char_0 a) => Field_char_0 a where {
};

shows_paren ::
  ([Prelude.Char] -> [Prelude.Char]) -> [Prelude.Char] -> [Prelude.Char];
shows_paren p = shows_prec_char Zero_nat '(' . p . shows_prec_char Zero_nat ')';

sum_map :: forall a b c d. (a -> b) -> (c -> d) -> Sum a c -> Sum b d;
sum_map f1 f2 (Inl a) = Inl (f1 a);
sum_map f1 f2 (Inr a) = Inr (f2 a);

linear_term_impl ::
  forall a b. (Ceq a, Corder a) => Set a -> Term b a -> Maybe (Set a);
linear_term_impl xs (Var x) =
  (if member x xs then Nothing else Just (inserta x xs));
linear_term_impl xs (Fun uu []) = Just xs;
linear_term_impl xs (Fun f (t : ts)) =
  (case linear_term_impl xs t of {
    Nothing -> Nothing;
    Just ys -> linear_term_impl ys (Fun f ts);
  });

linear_term :: forall a b. (Ceq b, Corder b, Set_impla b) => Term a b -> Bool;
linear_term t = not (is_none (linear_term_impl bot_set t));

map_term_wa :: forall a b c. (a -> Nat -> b) -> Term a c -> Term b c;
map_term_wa fg (Var x) = Var x;
map_term_wa fg (Fun f ts) = Fun (fg f (size_list ts)) (map (map_term_wa fg) ts);

newline :: Prelude.Char;
newline = '\n';

ctxt_of_pos_term :: forall a b. Pos -> Term a b -> Ctxt a b;
ctxt_of_pos_term Empty t = Hole;
ctxt_of_pos_term (PCons i ps) (Fun f ts) =
  More f (take i ts) (ctxt_of_pos_term ps (nth ts i))
    (drop (plus_nat i (Nat_of_num One)) ts);

poss_list :: forall a b. Term a b -> [Pos];
poss_list (Var x) = [Empty];
poss_list (Fun f ss) =
  Empty :
    concatMap (\ (i, a) -> map (PCons i) a)
      (zip (upt Zero_nat (size_list ss)) (map poss_list ss));

rewrite ::
  forall a b. (Eq a, Eq b) => [(Term a b, Term a b)] -> Term a b -> [Term a b];
rewrite r s =
  concatMap
    (\ (l, ra) ->
      concatMap
        (\ p ->
          (case matcha (subt_at s p) l of {
            Nothing -> [];
            Just sigma ->
              [ctxt_apply (ctxt_of_pos_term p s) (subst_apply_term ra sigma)];
          }))
        (poss_list s))
    r;

hvf_term :: forall a b. (Eq a) => a -> Term a b -> Bool;
hvf_term a t =
  (case unapp a t of {
    (Var _, ts) -> null ts;
    (Fun _ us, ts) -> all (hvf_term a) (us ++ ts);
  });

max_list :: [Nat] -> Nat;
max_list [] = Zero_nat;
max_list (x : xs) = max x (max_list xs);

num_children :: Xml -> Nat;
num_children (Xml uu uv cs uw) = size_list cs;

crules ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          [((Term a [Prelude.Char], Term a [Prelude.Char]),
             [(Term a [Prelude.Char], Term a [Prelude.Char])])];
crules xml2name =
  many ['c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n', 'a', 'l', 'R', 'u', 'l',
         'e', 's']
    (crule xml2name) id;

rsteps ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          (Term a [Prelude.Char],
            [(Pos, ((Term a [Prelude.Char], Term a [Prelude.Char]),
                     Term a [Prelude.Char]))]);
rsteps xml2name =
  many1 ['r', 'e', 'w', 'r', 'i', 't', 'e', 'S', 'e', 'q', 'u', 'e', 'n', 'c',
          'e']
    (singleton ['s', 't', 'a', 'r', 't', 'T', 'e', 'r', 'm'] (term xml2name) id)
    (rstep xml2name) (\ a b -> (a, b));

data Non_join_info a b = Diff_NFs
  | Tcap_Non_Unif (Term a b -> Term a b -> b -> Term a b);

data Ncr_proof a b c = SN_NWCR (Trs_termination_proof a b c)
  | Non_Join (Term (Lab a b) c)
      [(Pos, ((Term (Lab a b) c, Term (Lab a b) c), Term (Lab a b) c))]
      [(Pos, ((Term (Lab a b) c, Term (Lab a b) c), Term (Lab a b) c))]
      (Non_join_info (Lab a b) c);

missing ::
  [Prelude.Char] ->
    ([Prelude.Char] -> [Prelude.Char]) -> [Prelude.Char] -> [Prelude.Char];
missing s x =
  shows_string ['t', 'h', 'e', ' '] .
    shows_string s .
      shows_string [' '] .
        x . shows_string
              [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n', 'g'];

instance (Eq a, Eq b) => Eq (Lab a b) where {
  a == b = equal_lab a b;
};

equal_lab :: forall a b. (Eq a, Eq b) => Lab a b -> Lab a b -> Bool;
equal_lab (Sharp lab) (UnLab f) = False;
equal_lab (UnLab f) (Sharp lab) = False;
equal_lab (Sharp laba) (FunLab lab list) = False;
equal_lab (FunLab laba list) (Sharp lab) = False;
equal_lab (UnLab f) (FunLab lab list) = False;
equal_lab (FunLab lab list) (UnLab f) = False;
equal_lab (Sharp laba) (Lab lab l) = False;
equal_lab (Lab laba l) (Sharp lab) = False;
equal_lab (UnLab f) (Lab lab l) = False;
equal_lab (Lab lab l) (UnLab f) = False;
equal_lab (FunLab laba list) (Lab lab l) = False;
equal_lab (Lab laba l) (FunLab lab list) = False;
equal_lab (Sharp laba) (Sharp lab) = equal_lab laba lab;
equal_lab (UnLab fa) (UnLab f) = fa == f;
equal_lab (FunLab laba lista) (FunLab lab list) =
  equal_lab laba lab && lista == list;
equal_lab (Lab laba la) (Lab lab l) = equal_lab laba lab && la == l;

no_decr ::
  forall a b c.
    (Eq a, Eq b,
      Eq c) => [(Term (Lab a b) c, Term (Lab a b) c)] ->
                 [(Term (Lab a b) c, Term (Lab a b) c)];
no_decr =
  filter
    (\ (l, r) ->
      not (not (equal_term l r) &&
            equal_term (map_term unlab l) (map_term unlab r)));

toomuch ::
  [Prelude.Char] ->
    ([Prelude.Char] -> [Prelude.Char]) -> [Prelude.Char] -> [Prelude.Char];
toomuch s x =
  shows_string ['s', 'u', 'p', 'e', 'r', 'f', 'l', 'u', 'o', 'u', 's', ' '] .
    shows_string s . shows_string [' '] . x . x;

check :: forall a. Bool -> a -> Sum a ();
check b e = (if b then Inr () else Inl e);

degree :: Complexity_class -> Nat;
degree (Comp_Poly d) = d;

catcha :: forall a b c. Sum a b -> (a -> Sum c b) -> Sum c b;
catcha m f = (case m of {
               Inl a -> f a;
               Inr a -> Inr a;
             });

forallM :: forall a b. (a -> Sum b ()) -> [a] -> Sum (a, b) ();
forallM f [] = Inr ();
forallM f (x : xs) =
  bindb (catcha (f x) (\ xa -> Inl (x, xa))) (\ _ -> forallM f xs);

check_edges ::
  forall a.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      ((a, a) -> Bool) ->
        [a] -> [a] -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_edges ss g c d =
  catcha
    (forallM
      (\ n ->
        catcha
          (forallM
            (\ m ->
              check (not (g (m, n)))
                (shows_string
                   ['e', 'd', 'g', 'e', ' ', 'f', 'r', 'o', 'm', ' '] .
                  ss m . shows_string [' ', 't', 'o', ' '] . ss n))
            d)
          (\ x -> Inl (snd x)))
      c)
    (\ x -> Inl (snd x));

lex_ext_unbounded ::
  forall a. (a -> a -> (Bool, Bool)) -> [a] -> [a] -> (Bool, Bool);
lex_ext_unbounded f [] [] = (False, True);
lex_ext_unbounded f (uu : uv) [] = (True, True);
lex_ext_unbounded f [] (uw : ux) = (False, False);
lex_ext_unbounded f (a : asa) (b : bs) =
  (case f a b of {
    (True, nstri) -> (True, True);
    (False, True) -> lex_ext_unbounded f asa bs;
    (False, False) -> (False, False);
  });

extract :: forall a. (a -> Bool) -> [a] -> Maybe ([a], (a, [a]));
extract p [] = Nothing;
extract p (x : xs) =
  (if p x then Just ([], (x, xs))
    else (case extract p xs of {
           Nothing -> Nothing;
           Just (ys, (y, zs)) -> Just (x : ys, (y, zs));
         }));

ms_lesseq :: forall a. (Eq a) => [a] -> [a] -> Bool;
ms_lesseq [] uu = True;
ms_lesseq (x : xs) ys =
  (case extract (\ a -> x == a) ys of {
    Nothing -> False;
    Just (ys1, (_, ys2)) -> ms_lesseq xs (ys1 ++ ys2);
  });

kbo_impl ::
  forall a b.
    (Eq b) => ((a, Nat) -> Nat) ->
                Nat ->
                  ((a, Nat) -> Nat) ->
                    (a -> Bool) ->
                      ((a, Nat) -> Nat -> Nat) ->
                        Term a b -> Term a b -> (Bool, Bool);
kbo_impl w w0 prc least scf s t =
  let {
    wt = weight w w0 scf t;
    ws = weight w w0 scf s;
  } in (if ms_lesseq (vars_term_list (scf_term scf t))
             (vars_term_list (scf_term scf s)) &&
             less_eq_nat wt ws
         then (if less_nat wt ws then (True, True)
                else (case s of {
                       Var _ ->
                         (False,
                           (case t of {
                             Var _ -> True;
                             Fun g ts -> null ts && least g;
                           }));
                       Fun f ss ->
                         (case t of {
                           Var _ -> (True, True);
                           Fun g ts ->
                             let {
                               pf = prc (f, size_list ss);
                               pg = prc (g, size_list ts);
                             } in (if less_nat pg pf then (True, True)
                                    else (if less_eq_nat pg pf
   then lex_ext_unbounded (kbo_impl w w0 prc least scf) ss ts
   else (False, False)));
                         });
                     }))
         else (False, False));

lab_rec_1 ::
  forall a b c d.
    (Lab a b -> b -> c -> c) ->
      (Lab a b -> [Lab a b] -> c -> d -> c) ->
        (a -> c) ->
          (Lab a b -> c -> c) ->
            d -> (Lab a b -> [Lab a b] -> c -> d -> d) -> Lab a b -> c;
lab_rec_1 f1 f2 f3 f4 f5 f6 (Lab lab l) =
  f1 lab l (lab_rec_1 f1 f2 f3 f4 f5 f6 lab);
lab_rec_1 f1 f2 f3 f4 f5 f6 (FunLab lab list) =
  f2 lab list (lab_rec_1 f1 f2 f3 f4 f5 f6 lab)
    (lab_rec_2 f1 f2 f3 f4 f5 f6 list);
lab_rec_1 f1 f2 f3 f4 f5 f6 (UnLab f) = f3 f;
lab_rec_1 f1 f2 f3 f4 f5 f6 (Sharp lab) =
  f4 lab (lab_rec_1 f1 f2 f3 f4 f5 f6 lab);

lab_rec_2 ::
  forall a b c d.
    (Lab a b -> b -> c -> c) ->
      (Lab a b -> [Lab a b] -> c -> d -> c) ->
        (a -> c) ->
          (Lab a b -> c -> c) ->
            d -> (Lab a b -> [Lab a b] -> c -> d -> d) -> [Lab a b] -> d;
lab_rec_2 f1 f2 f3 f4 f5 f6 [] = f5;
lab_rec_2 f1 f2 f3 f4 f5 f6 (lab : list) =
  f6 lab list (lab_rec_1 f1 f2 f3 f4 f5 f6 lab)
    (lab_rec_2 f1 f2 f3 f4 f5 f6 list);

less_eq_lab ::
  forall a b. (Eq a, Ord a, Eq b, Ord b) => Lab a b -> Lab a b -> Bool;
less_eq_lab =
  (\ x y ->
    lab_rec_1
      (\ x_0 x_1 res_0 a ->
        (case a of {
          Lab y_0 y_1 -> res_0 y_0 || equal_lab x_0 y_0 && less x_1 y_1;
          FunLab _ _ -> True;
          UnLab _ -> True;
          Sharp _ -> True;
        }))
      (\ x_0 _ res_0 res_1 a ->
        (case a of {
          Lab _ _ -> False;
          FunLab y_0 y_1 -> res_0 y_0 || equal_lab x_0 y_0 && res_1 y_1;
          UnLab _ -> True;
          Sharp _ -> True;
        }))
      (\ x_0 a ->
        (case a of {
          Lab _ _ -> False;
          FunLab _ _ -> False;
          UnLab aa -> less x_0 aa;
          Sharp _ -> True;
        }))
      (\ _ a b ->
        (case b of {
          Lab _ _ -> False;
          FunLab _ _ -> False;
          UnLab _ -> False;
          Sharp ba -> a ba;
        }))
      (\ a -> (case a of {
                [] -> False;
                _ : _ -> True;
              }))
      (\ x_0 _ res_0 res_1 a ->
        (case a of {
          [] -> False;
          y_0 : y_1 -> res_0 y_0 || equal_lab x_0 y_0 && res_1 y_1;
        }))
      x y ||
      equal_lab x y);

less_lab ::
  forall a b. (Eq a, Ord a, Eq b, Ord b) => Lab a b -> Lab a b -> Bool;
less_lab =
  lab_rec_1
    (\ x_0 x_1 res_0 a ->
      (case a of {
        Lab y_0 y_1 -> res_0 y_0 || equal_lab x_0 y_0 && less x_1 y_1;
        FunLab _ _ -> True;
        UnLab _ -> True;
        Sharp _ -> True;
      }))
    (\ x_0 _ res_0 res_1 a ->
      (case a of {
        Lab _ _ -> False;
        FunLab y_0 y_1 -> res_0 y_0 || equal_lab x_0 y_0 && res_1 y_1;
        UnLab _ -> True;
        Sharp _ -> True;
      }))
    (\ x_0 a ->
      (case a of {
        Lab _ _ -> False;
        FunLab _ _ -> False;
        UnLab aa -> less x_0 aa;
        Sharp _ -> True;
      }))
    (\ _ a b ->
      (case b of {
        Lab _ _ -> False;
        FunLab _ _ -> False;
        UnLab _ -> False;
        Sharp ba -> a ba;
      }))
    (\ a -> (case a of {
              [] -> False;
              _ : _ -> True;
            }))
    (\ x_0 _ res_0 res_1 a ->
      (case a of {
        [] -> False;
        y_0 : y_1 -> res_0 y_0 || equal_lab x_0 y_0 && res_1 y_1;
      }));

instance (Eq a, Ord a, Eq b, Ord b) => Ord (Lab a b) where {
  less_eq = less_eq_lab;
  less = less_lab;
};

instance (Eq a, Order a, Eq b, Order b) => Preorder (Lab a b) where {
};

instance (Eq a, Order a, Eq b, Order b) => Order (Lab a b) where {
};

instance (Eq a, Linorder a, Eq b, Linorder b) => Linorder (Lab a b) where {
};

instance (Eq a, Key a, Eq b, Key b) => Key (Lab a b) where {
};

instance Key Nat where {
};

match :: forall a b. (Term a b, Term a b) -> Term a b -> Bool;
match = (\ _ _ -> True);

instance (Eq a, Linorder a, Eq b, Linorder b) => Linorder (a, b) where {
};

fresh_strings_list ::
  [Prelude.Char] -> Nat -> [[Prelude.Char]] -> Nat -> [[Prelude.Char]];
fresh_strings_list name offset used n =
  take n
    (filter (\ s -> not (membera (remdups used) s))
      (map (\ i -> name ++ shows_prec_nat Zero_nat (plus_nat i offset) [])
        (upt Zero_nat (plus_nat n (size_list (remdups used))))));

fresh_string :: [Prelude.Char] -> [[Prelude.Char]] -> [Prelude.Char];
fresh_string pre =
  (\ s -> hd (fresh_strings_list pre (Nat_of_num One) s (Nat_of_num One)));

mapMa :: forall a b. (a -> Maybe b) -> [a] -> Maybe [b];
mapMa f [] = Just [];
mapMa f (x : xs) =
  bind (f x) (\ y -> bind (mapMa f xs) (\ ys -> Just (y : ys)));

equal_pos :: Pos -> Pos -> Bool;
equal_pos (PCons nat pos) Empty = False;
equal_pos Empty (PCons nat pos) = False;
equal_pos (PCons nata posa) (PCons nat pos) =
  equal_nat nata nat && equal_pos posa pos;
equal_pos Empty Empty = True;

instance Eq Pos where {
  a == b = equal_pos a b;
};

less_eq_pos :: Pos -> Pos -> Bool;
less_eq_pos (PCons i q1) (PCons j q2) = equal_nat i j && less_eq_pos q1 q2;
less_eq_pos (PCons i q1) Empty = False;
less_eq_pos Empty p = True;

less_pos :: Pos -> Pos -> Bool;
less_pos p q = less_eq_pos p q && not (equal_pos p q);

times_pos :: Pos -> Pos -> Pos;
times_pos p q = append p q;

instance Times Pos where {
  times = times_pos;
};

instance Power Pos where {
};

size_pos :: Pos -> Nat;
size_pos Empty = Zero_nat;
size_pos (PCons nat pos) =
  plus_nat (size_pos pos) (plus_nat Zero_nat (Nat_of_num One));

rm_iterateoi ::
  forall a b c. Rbta a b -> (c -> Bool) -> ((a, b) -> c -> c) -> c -> c;
rm_iterateoi Emptya c f sigma = sigma;
rm_iterateoi (Branch col l k v r) c f sigma =
  (if c sigma
    then let {
           sigmaa = rm_iterateoi l c f sigma;
         } in (if c sigmaa then rm_iterateoi r c f (f (k, v) sigmaa)
                else sigmaa)
    else sigma);

rm_iterateoia ::
  forall a b c.
    (Linorder a) => Rbt a b -> (c -> Bool) -> ((a, b) -> c -> c) -> c -> c;
rm_iterateoia r = rm_iterateoi (impl_of r);

rm_iteratei ::
  forall a b c.
    (Linorder a) => Rbt a b -> (c -> Bool) -> ((a, b) -> c -> c) -> c -> c;
rm_iteratei = rm_iterateoia;

rm_add :: forall a b. (Linorder a) => Rbt a b -> Rbt a b -> Rbt a b;
rm_add = it_add rm_update rm_iteratei;

rs_ins :: forall a. (Linorder a) => a -> Rbt a () -> Rbt a ();
rs_ins = s_ins rm_update;

any_nstri_efficient_m ::
  forall a b. (a -> b -> ((Bool, Bool), b)) -> [a] -> b -> (Bool, b);
any_nstri_efficient_m f [] m = (False, m);
any_nstri_efficient_m f (a : asa) m =
  let {
    (aa, b) = f a m;
  } in let {
         (_, ns) = aa;
       } in (\ ma ->
              (if ns then (True, ma) else any_nstri_efficient_m f asa ma))
         b;

all_stri_efficient_m ::
  forall a b. (a -> b -> ((Bool, Bool), b)) -> [a] -> b -> (Bool, b);
all_stri_efficient_m f [] m = (True, m);
all_stri_efficient_m f (a : asa) m =
  let {
    (aa, b) = f a m;
  } in let {
         (s, _) = aa;
       } in (\ ma -> (if s then all_stri_efficient_m f asa ma else (False, ma)))
         b;

filter_not_stri_efficient_m_aux ::
  forall a b. (a -> b -> ((Bool, Bool), b)) -> [a] -> [a] -> b -> ([a], b);
filter_not_stri_efficient_m_aux f [] bs m = (bs, m);
filter_not_stri_efficient_m_aux f (a : asa) bs m =
  let {
    (b, c) = f a m;
  } in let {
         (s, _) = b;
       } in (\ ma ->
              (if s then filter_not_stri_efficient_m_aux f asa bs ma
                else filter_not_stri_efficient_m_aux f asa (a : bs) ma))
         c;

filter_not_stri_efficient_m ::
  forall a b. (a -> b -> ((Bool, Bool), b)) -> [a] -> b -> ([a], b);
filter_not_stri_efficient_m f asa m =
  let {
    (ys, a) = filter_not_stri_efficient_m_aux f asa [] m;
  } in (reverse ys, a);

mul_ext_efficient_m ::
  forall a b.
    (Eq a) => (a -> a -> b -> ((Bool, Bool), b)) ->
                [a] -> [a] -> b -> ((Bool, Bool), b);
mul_ext_efficient_m f [] [] m = ((False, True), m);
mul_ext_efficient_m f [] (v : va) m = ((False, False), m);
mul_ext_efficient_m f (v : va) [] m = ((True, True), m);
mul_ext_efficient_m f (v : va) (y : ys) m =
  ex_dom_efficient_m f y (v : va) (v : va) ys m;

ex_dom_efficient_m ::
  forall a b.
    (Eq a) => (a -> a -> b -> ((Bool, Bool), b)) ->
                a -> [a] -> [a] -> [a] -> b -> ((Bool, Bool), b);
ex_dom_efficient_m f y [] uw ux m = ((False, False), m);
ex_dom_efficient_m f y (b : bs) xs ys m =
  let {
    (a, c) = f b y m;
  } in let {
         (s, ns) = a;
       } in (\ ma ->
              (if s then let {
                           (ysa, m2) = filter_not_stri_efficient_m (f b) ys ma;
                           (aa, ba) =
                             mul_ext_efficient_m f (remove1 b xs) ysa m2;
                         } in let {
                                (_, ns1) = aa;
                              } in (\ m3 ->
                                     (if ns1 then ((True, True), m3)
                                       else ex_dom_efficient_m f y bs xs ys m3))
                                ba
                else (if ns
                       then let {
                              (aa, ba) =
                                mul_ext_efficient_m f (remove1 b xs) ys ma;
                            } in let {
                                   (s1, ns1) = aa;
                                 } in (\ mb ->
(if s1 then ((True, True), mb)
  else let {
         (ab, bb) = ex_dom_efficient_m f y bs xs ys mb;
       } in let {
              (s2, ns2) = ab;
            } in (\ m3 ->
                   (if s2 then ((True, True), m3)
                     else ((False, ns1 || ns2), m3)))
              bb))
                                   ba
                       else ex_dom_efficient_m f y bs xs ys ma)))
         c;

lex_ext_efficient_m ::
  forall a b.
    (a -> a -> b -> ((Bool, Bool), b)) -> [a] -> [a] -> b -> ((Bool, Bool), b);
lex_ext_efficient_m f [] [] m = ((False, True), m);
lex_ext_efficient_m f (uu : uv) [] m = ((True, True), m);
lex_ext_efficient_m f [] (uw : ux) m = ((False, False), m);
lex_ext_efficient_m f (a : asa) (b : bs) m =
  let {
    (aa, ba) = f a b m;
  } in let {
         (s, ns) = aa;
       } in (\ ma ->
              (if s then ((True, True), ma)
                else (if ns then lex_ext_efficient_m f asa bs ma
                       else ((False, False), ma))))
         ba;

diag_l :: forall a b. (a, b) -> ((a, a), b);
diag_l (a, b) = ((a, a), b);

equal_order_tag :: Order_tag -> Order_tag -> Bool;
equal_order_tag Mul Lex = False;
equal_order_tag Lex Mul = False;
equal_order_tag Mul Mul = True;
equal_order_tag Lex Lex = True;

rpo_efficient_m ::
  forall a b c.
    (Eq b,
      Eq c) => Memory_ext a (Term b c, Term b c) (Bool, Bool) () ->
                 (b -> Nat -> b -> Nat -> (Bool, Bool), b -> Bool) ->
                   (b -> Nat -> Order_tag) ->
                     Term b c -> Term b c -> a -> ((Bool, Bool), a);
rpo_efficient_m model pr tag s t m =
  (case lookupa model m (s, t) of {
    Nothing ->
      let {
        (res, res_m) =
          (case (s, t) of {
            (Var x, Var y) -> ((False, x == y), m);
            (Var x, Fun g ts) -> ((False, null ts && snd pr g), m);
            (Fun f ss, Var y) ->
              diag_l
                (any_nstri_efficient_m
                  (\ sa -> rpo_efficient_m model pr tag sa (Var y)) ss m);
            (Fun f ss, Fun g ts) ->
              (case any_nstri_efficient_m
                      (\ sa -> rpo_efficient_m model pr tag sa (Fun g ts)) ss m
                of {
                (True, ma) -> ((True, True), ma);
                (False, ma) ->
                  let {
                    maa = size_list ss;
                    n = size_list ts;
                  } in (case fst pr f maa g n of {
                         (prs, True) ->
                           (case all_stri_efficient_m
                                   (rpo_efficient_m model pr tag (Fun f ss)) ts
                                   ma
                             of {
                             (True, mb) ->
                               (if prs then ((True, True), mb)
                                 else let {
cf = tag f maa;
                                      } in
(if equal_order_tag cf (tag g n)
  then (if equal_order_tag cf Mul
         then mul_ext_efficient_m (rpo_efficient_m model pr tag) ss ts mb
         else lex_ext_efficient_m (rpo_efficient_m model pr tag) ss ts mb)
  else let {
         b = equal_nat n Zero_nat;
       } in ((not (equal_nat maa Zero_nat) && b, b), mb)));
                             (False, mb) -> ((False, False), mb);
                           });
                         (prs, False) -> ((False, False), ma);
                       });
              });
          });
      } in (res, store model res_m ((s, t), res));
    Just v -> (v, m);
  });

efficient_rpo_2 ::
  forall a b.
    (Eq a,
      Eq b) => (a -> Nat -> a -> Nat -> (Bool, Bool), a -> Bool) ->
                 (a -> Nat -> Order_tag) ->
                   Term a b -> Term a b -> (Bool, Bool);
efficient_rpo_2 pr tag p q =
  fst (rpo_efficient_m l2m pr tag p q (emptya l2m ()));

rpo_unbounded_impl ::
  forall a b.
    (Eq a,
      Eq b) => (a -> Nat -> a -> Nat -> (Bool, Bool), a -> Bool) ->
                 (a -> Nat -> Order_tag) ->
                   Term a b -> Term a b -> (Bool, Bool);
rpo_unbounded_impl = efficient_rpo_2;

rpo_unbounded ::
  forall a b.
    (Eq a,
      Eq b) => (a -> Nat -> a -> Nat -> (Bool, Bool), a -> Bool) ->
                 (a -> Nat -> Order_tag) ->
                   Term a b -> Term a b -> (Bool, Bool);
rpo_unbounded = rpo_unbounded_impl;

equal_sum :: forall a b. (Eq a, Eq b) => Sum a b -> Sum a b -> Bool;
equal_sum (Inr b) (Inl a) = False;
equal_sum (Inl a) (Inr b) = False;
equal_sum (Inr ba) (Inr b) = ba == b;
equal_sum (Inl aa) (Inl a) = aa == a;

instance (Eq a, Eq b) => Eq (Sum a b) where {
  a == b = equal_sum a b;
};

subt_at_ctxt :: forall a b. Ctxt a b -> Pos -> Ctxt a b;
subt_at_ctxt c Empty = c;
subt_at_ctxt (More f bef c aft) (PCons i p) = subt_at_ctxt c p;

in_poss :: forall a b. Pos -> Term a b -> Bool;
in_poss Empty uu = True;
in_poss (PCons i p) (Fun f ts) =
  less_nat i (size_list ts) && in_poss p (nth ts i);
in_poss (PCons i p) (Var uv) = False;

data Redtriple_ext a b c =
  Redtriple_ext (Sum ([Prelude.Char] -> [Prelude.Char]) ())
    ((Term a b, Term a b) -> Sum ([Prelude.Char] -> [Prelude.Char]) ())
    ((Term a b, Term a b) -> Sum ([Prelude.Char] -> [Prelude.Char]) ())
    ((Term a b, Term a b) -> Sum ([Prelude.Char] -> [Prelude.Char]) ())
    ((a, Nat) -> Nat -> Bool)
    ([(Term a b, Term a b)] -> Sum ([Prelude.Char] -> [Prelude.Char]) ())
    ([Prelude.Char] -> [Prelude.Char])
    (Complexity_measure a b ->
      Sum ([Prelude.Char] -> [Prelude.Char]) Complexity_class)
    c;

s :: forall a b c.
       Redtriple_ext a b c ->
         (Term a b, Term a b) -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
s (Redtriple_ext valid s ns nst af mono desc cpx more) = s;

instance_rule ::
  forall a b c.
    (Eq a, Eq b, Eq c) => (Term a b, Term a b) -> (Term a c, Term a c) -> Bool;
instance_rule lr st =
  not (is_none (match_list [(fst lr, fst st), (snd lr, snd st)]));

label_depth :: forall a b. Lab a b -> Nat;
label_depth (UnLab uu) = Zero_nat;
label_depth (Lab f uv) = plus_nat (label_depth f) (Nat_of_num One);
label_depth (FunLab f uw) = plus_nat (label_depth f) (Nat_of_num One);
label_depth (Sharp f) = plus_nat (label_depth f) (Nat_of_num One);

gen_label :: forall a b. Lab a b -> Nat -> Lab a b;
gen_label f n =
  (if equal_nat n Zero_nat then f
    else FunLab (gen_label f (minus_nat n (Nat_of_num One))) []);

fmap ::
  forall a b.
    (Eq a,
      Eq b) => Lab a b ->
                 Nat ->
                   [((Lab a b, Nat), [Lab a b])] -> Lab a b -> Nat -> Lab a b;
fmap a nn sml =
  let {
    m = plus_nat (max_list (map label_depth (a : concatMap snd sml)))
          (Nat_of_num One);
  } in (\ f n -> (if (f, n) == (a, nn) then a else gen_label f m));

enum_vectors :: forall a b. [a] -> [b] -> [[(b, a)]];
enum_vectors c [] = [[]];
enum_vectors c (x : xs) =
  let {
    a = enum_vectors c xs;
  } in concatMap (\ vec -> map (\ ca -> (x, ca) : vec) c) a;

replace_impl :: forall a. (Eq a) => a -> [a] -> [a] -> [a];
replace_impl a bs m =
  (if membera m a then bs ++ filter (\ b -> not (b == a)) m else m);

doc_of_string :: [Prelude.Char] -> Sum [Prelude.Char] Xmldoc;
doc_of_string s = bindb (parse_doc s) (\ (doc, _) -> Inr doc);

data Pat_rule_pos = Pat_Base | Pat_Pump | Pat_Close;

data Pat_eqv_prf a b = Pat_Dom_Renaming [(b, Term a b)]
  | Pat_Irrelevant [(b, Term a b)] [(b, Term a b)]
  | Pat_Simplify [(b, Term a b)] [(b, Term a b)];

data Pat_rule_prf a b = Pat_OrigRule (Term a b, Term a b) Bool
  | Pat_InitPump (Pat_rule_prf a b) [(b, Term a b)] [(b, Term a b)]
  | Pat_InitPumpCtxt (Pat_rule_prf a b) [(b, Term a b)] Pos b
  | Pat_Equiv (Pat_rule_prf a b) Bool (Pat_eqv_prf a b)
  | Pat_Narrow (Pat_rule_prf a b) (Pat_rule_prf a b) Pos
  | Pat_Inst (Pat_rule_prf a b) [(b, Term a b)] Pat_rule_pos
  | Pat_Rewr (Pat_rule_prf a b)
      (Term a b, [(Pos, ((Term a b, Term a b), Term a b))]) Pat_rule_pos b;

data Non_loop_prf a b =
  Non_Loop_Prf (Pat_rule_prf a b) [(b, Term a b)] [(b, Term a b)] Nat Nat Pos;

pat_eqv_prf ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Pat_eqv_prf a [Prelude.Char]);
pat_eqv_prf xml2name =
  let {
    sub = substa xml2name;
  } in singleton
         ['p', 'a', 't', 't', 'e', 'r', 'n', 'E', 'q', 'u', 'i', 'v', 'a', 'l',
           'e', 'n', 'c', 'e']
         (options
           [(['d', 'o', 'm', 'a', 'i', 'n', 'R', 'e', 'n', 'a', 'm', 'i', 'n',
               'g'],
              singleton
                ['d', 'o', 'm', 'a', 'i', 'n', 'R', 'e', 'n', 'a', 'm', 'i',
                  'n', 'g']
                sub Pat_Dom_Renaming),
             (['i', 'r', 'r', 'e', 'l', 'e', 'v', 'a', 'n', 't'],
               pair ['i', 'r', 'r', 'e', 'l', 'e', 'v', 'a', 'n', 't'] sub sub
                 Pat_Irrelevant),
             (['s', 'i', 'm', 'p', 'l', 'i', 'f', 'i', 'c', 'a', 't', 'i', 'o',
                'n'],
               pair ['s', 'i', 'm', 'p', 'l', 'i', 'f', 'i', 'c', 'a', 't', 'i',
                      'o', 'n']
                 sub sub Pat_Simplify)])
         id;

pat_term ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          (Term a [Prelude.Char],
            ([([Prelude.Char], Term a [Prelude.Char])],
              [([Prelude.Char], Term a [Prelude.Char])]));
pat_term xml2name =
  triple ['p', 'a', 't', 't', 'e', 'r', 'n', 'T', 'e', 'r', 'm'] (term xml2name)
    (substa xml2name) (substa xml2name) (\ t s1 s2 -> (t, (s1, s2)));

pat_rule_prf ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Pat_rule_prf a [Prelude.Char]);
pat_rule_prf xml2name x =
  let {
    pat = pat_rule_prf xml2name;
    sub = substa xml2name;
    pt = pat_term xml2name;
    var = text ['v', 'a', 'r'];
  } in triple ['p', 'a', 't', 't', 'e', 'r', 'n', 'R', 'u', 'l', 'e'] pt pt
         (options
           [(['o', 'r', 'i', 'g', 'i', 'n', 'a', 'l', 'R', 'u', 'l', 'e'],
              pair ['o', 'r', 'i', 'g', 'i', 'n', 'a', 'l', 'R', 'u', 'l', 'e']
                (rule xml2name) (bool ['i', 's', 'P', 'a', 'i', 'r'])
                Pat_OrigRule),
             (['i', 'n', 'i', 't', 'i', 'a', 'l', 'P', 'u', 'm', 'p', 'i', 'n',
                'g'],
               triple
                 ['i', 'n', 'i', 't', 'i', 'a', 'l', 'P', 'u', 'm', 'p', 'i',
                   'n', 'g']
                 pat sub sub Pat_InitPump),
             (['i', 'n', 'i', 't', 'i', 'a', 'l', 'P', 'u', 'm', 'p', 'i', 'n',
                'g', 'C', 'o', 'n', 't', 'e', 'x', 't'],
               tuple4
                 ['i', 'n', 'i', 't', 'i', 'a', 'l', 'P', 'u', 'm', 'p', 'i',
                   'n', 'g', 'C', 'o', 'n', 't', 'e', 'x', 't']
                 pat sub pos var Pat_InitPumpCtxt),
             (['e', 'q', 'u', 'i', 'v', 'a', 'l', 'e', 'n', 'c', 'e'],
               triple ['e', 'q', 'u', 'i', 'v', 'a', 'l', 'e', 'n', 'c', 'e']
                 pat (options
                       [(['l', 'e', 'f', 't'], leaf ['l', 'e', 'f', 't'] True),
                         (['r', 'i', 'g', 'h', 't'],
                           leaf ['r', 'i', 'g', 'h', 't'] False)])
                 (pat_eqv_prf xml2name) Pat_Equiv),
             (['n', 'a', 'r', 'r', 'o', 'w', 'i', 'n', 'g'],
               triple ['n', 'a', 'r', 'r', 'o', 'w', 'i', 'n', 'g'] pat pat pos
                 Pat_Narrow),
             (['i', 'n', 's', 't', 'a', 'n', 't', 'i', 'a', 't', 'i', 'o', 'n'],
               triple
                 ['i', 'n', 's', 't', 'a', 'n', 't', 'i', 'a', 't', 'i', 'o',
                   'n']
                 pat sub
                 (options
                   [(['b', 'a', 's', 'e'], leaf ['b', 'a', 's', 'e'] Pat_Base),
                     (['p', 'u', 'm', 'p', 'i', 'n', 'g'],
                       leaf ['p', 'u', 'm', 'p', 'i', 'n', 'g'] Pat_Pump),
                     (['c', 'l', 'o', 's', 'i', 'n', 'g'],
                       leaf ['c', 'l', 'o', 's', 'i', 'n', 'g'] Pat_Close)])
                 Pat_Inst),
             (['r', 'e', 'w', 'r', 'i', 't', 'i', 'n', 'g'],
               triple ['r', 'e', 'w', 'r', 'i', 't', 'i', 'n', 'g'] pat
                 (rsteps xml2name)
                 (options
                   [(['b', 'a', 's', 'e'],
                      leaf ['b', 'a', 's', 'e'] (Pat_Base, [])),
                     (['p', 'u', 'm', 'p', 'i', 'n', 'g'],
                       singleton ['p', 'u', 'm', 'p', 'i', 'n', 'g'] var
                         (\ a -> (Pat_Pump, a))),
                     (['c', 'l', 'o', 's', 'i', 'n', 'g'],
                       singleton ['c', 'l', 'o', 's', 'i', 'n', 'g'] var
                         (\ a -> (Pat_Close, a)))])
                 (\ p seq (a, b) -> Pat_Rewr p seq a b))])
         (\ _ _ z -> z) x;

nonloop ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Non_loop_prf a [Prelude.Char]);
nonloop xml2name =
  tuple6 ['n', 'o', 'n', 'L', 'o', 'o', 'p'] (pat_rule_prf xml2name)
    (substa xml2name) (substa xml2name)
    (nata ['n', 'a', 't', 'u', 'r', 'a', 'l'])
    (nata ['n', 'a', 't', 'u', 'r', 'a', 'l']) pos Non_Loop_Prf;

xml_pos :: Pos -> Xml;
xml_pos p =
  Xml ['p', 'o', 's', 'i', 't', 'i', 'o', 'n', 'I', 'n', 'T', 'e', 'r', 'm'] []
    (map (\ i ->
           Xml ['p', 'o', 's', 'i', 't', 'i', 'o', 'n'] [] []
             (Just (shows_prec_nat Zero_nat (plus_nat i (Nat_of_num One)) [])))
      (to_list p))
    Nothing;

subset ::
  forall a. (Card_UNIV a, Cenum a, Ceq a, Corder a) => Set a -> Set a -> Bool;
subset = subset_eq;

instance Preorder Prelude.Char where {
};

instance Order Prelude.Char where {
};

carrier :: forall a b. Partial_object_ext a b -> Set a;
carrier (Partial_object_ext carrier more) = carrier;

rules_no_left_vara :: forall a b c d. Dpp_ops_ext a b c d -> a -> Bool;
rules_no_left_vara
  (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
    rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
    intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
    split_pairs split_rules mk minimal nfs wwf_rules more)
  = rules_no_left_var;

rules_mapb ::
  forall a b c d.
    Dpp_ops_ext a b c d -> a -> (b, Nat) -> [(Term b c, Term b c)];
rules_mapb
  (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
    rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
    intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
    split_pairs split_rules mk minimal nfs wwf_rules more)
  = rules_map;

capRM_dpp ::
  forall a b c.
    (Eq b, Eq c) => Dpp_ops_ext a b c () -> a -> Term b c -> Gctxt b c;
capRM_dpp i dpp = capRM (rules_no_left_vara i dpp) (rules_mapb i dpp);

rm_empty :: forall a b. (Linorder a) => () -> Rbt a b;
rm_empty = (\ _ -> empty);

rm_alpha :: forall a b. (Linorder a) => Rbt a b -> a -> Maybe b;
rm_alpha = lookup;

elem_list_to_rm :: forall a b. (Linorder b) => (a -> b) -> [a] -> Rbt b [a];
elem_list_to_rm key [] = rm_empty ();
elem_list_to_rm key (d : ds) =
  let {
    rm = elem_list_to_rm key ds;
    k = key d;
  } in (case rm_alpha rm k of {
         Nothing -> rm_update_dj k [d] rm;
         Just dataa -> rm_update k (d : dataa) rm;
       });

fun_of_map :: forall a b. (a -> Maybe b) -> b -> a -> b;
fun_of_map m d a = (case m a of {
                     Nothing -> d;
                     Just b -> b;
                   });

term_map :: forall a b. (Key a) => [Term a b] -> a -> [Term a b];
term_map ts =
  fun_of_map (rm_alpha (elem_list_to_rm ((fst . the) . root) ts)) [];

instance Linorder Prelude.Char where {
};

instance Key Prelude.Char where {
};

less_eq_list :: forall a. (Eq a, Order a) => [a] -> [a] -> Bool;
less_eq_list (x : xs) (y : ys) = less x y || x == y && less_eq_list xs ys;
less_eq_list [] xs = True;
less_eq_list (x : xs) [] = False;

less_list :: forall a. (Eq a, Order a) => [a] -> [a] -> Bool;
less_list (x : xs) (y : ys) = less x y || x == y && less_list xs ys;
less_list [] (x : xs) = True;
less_list xs [] = False;

instance (Eq a, Order a) => Ord [a] where {
  less_eq = less_eq_list;
  less = less_list;
};

instance (Eq a, Order a) => Preorder [a] where {
};

instance (Eq a, Order a) => Order [a] where {
};

instance (Eq a, Linorder a) => Linorder [a] where {
};

instance (Eq a, Key a) => Key [a] where {
};

instance (Eq a, Key a, Eq b, Key b) => Key (a, b) where {
};

less_eq_term ::
  forall a b. (Eq a, Ord a, Eq b, Ord b) => Term a b -> Term a b -> Bool;
less_eq_term =
  (\ x y ->
    term_rec_1
      (\ x_0 a -> (case a of {
                    Var aa -> less x_0 aa;
                    Fun _ _ -> True;
                  }))
      (\ x_0 _ res_0 a ->
        (case a of {
          Var _ -> False;
          Fun y_0 y_1 -> less x_0 y_0 || x_0 == y_0 && res_0 y_1;
        }))
      (\ a -> (case a of {
                [] -> False;
                _ : _ -> True;
              }))
      (\ x_0 _ res_0 res_1 a ->
        (case a of {
          [] -> False;
          y_0 : y_1 -> res_0 y_0 || equal_term x_0 y_0 && res_1 y_1;
        }))
      x y ||
      equal_term x y);

less_term ::
  forall a b. (Eq a, Ord a, Eq b, Ord b) => Term a b -> Term a b -> Bool;
less_term =
  term_rec_1
    (\ x_0 a -> (case a of {
                  Var aa -> less x_0 aa;
                  Fun _ _ -> True;
                }))
    (\ x_0 _ res_0 a ->
      (case a of {
        Var _ -> False;
        Fun y_0 y_1 -> less x_0 y_0 || x_0 == y_0 && res_0 y_1;
      }))
    (\ a -> (case a of {
              [] -> False;
              _ : _ -> True;
            }))
    (\ x_0 _ res_0 res_1 a ->
      (case a of {
        [] -> False;
        y_0 : y_1 -> res_0 y_0 || equal_term x_0 y_0 && res_1 y_1;
      }));

instance (Eq a, Ord a, Eq b, Ord b) => Ord (Term a b) where {
  less_eq = less_eq_term;
  less = less_term;
};

instance (Eq a, Order a, Eq b, Order b) => Preorder (Term a b) where {
};

instance (Eq a, Order a, Eq b, Order b) => Order (Term a b) where {
};

instance (Eq a, Linorder a, Eq b, Linorder b) => Linorder (Term a b) where {
};

instance (Eq a, Key a, Eq b, Key b) => Key (Term a b) where {
};

height :: forall a. (a, Nat) -> Nat;
height (f, h) = h;

vec0I :: forall a. a -> Nat -> [a];
vec0I ze n = replicate n ze;

mat0I :: forall a. a -> Nat -> Nat -> [[a]];
mat0I ze nr nc = replicate nc (vec0I ze nr);

vec1I :: forall a. a -> a -> Nat -> Nat -> [a];
vec1I ze on n i =
  replicate i ze ++
    on : replicate (minus_nat (minus_nat n (Nat_of_num One)) i) ze;

mat1I :: forall a. a -> a -> Nat -> [[a]];
mat1I ze on n = map (vec1I ze on n) (upt Zero_nat n);

data Dependance = Ignore | Increase | Decrease | Wild;

class (Ord a) => Non_strict_order a where {
};

class (Ab_semigroup_add a, Monoid_add a,
        Non_strict_order a) => Ordered_ab_semigroup a where {
};

class (Semiring_0 a, Ordered_ab_semigroup a) => Ordered_semiring_0 a where {
};

class (Semiring_1 a, Ordered_semiring_0 a) => Ordered_semiring_1 a where {
};

class (Comm_semiring_1 a, Ordered_semiring_1 a) => Poly_carrier a where {
};

shows_term ::
  forall a b.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      (b -> [Prelude.Char] -> [Prelude.Char]) ->
        Term a b -> [Prelude.Char] -> [Prelude.Char];
shows_term fun var (Var x) = var x;
shows_term fun var (Fun f ts) =
  fun f .
    shows_list_gen id [] ['('] [',', ' '] [')'] (map (shows_term fun var) ts);

shows_prec_term ::
  forall a b.
    (Showa a, Showa b) => Nat -> Term a b -> [Prelude.Char] -> [Prelude.Char];
shows_prec_term d t = shows_term (shows_prec Zero_nat) (shows_prec Zero_nat) t;

check_poly_ge ::
  forall a b.
    (Eq a,
      Ordered_semiring_0 b) => [([(a, Nat)], b)] -> [([(a, Nat)], b)] -> Bool;
check_poly_ge [] q = all (\ (_, d) -> less_eq d zeroa) q;
check_poly_ge ((m, c) : p) q =
  (case extracta (\ nd -> eq_monom (fst nd) m) q of {
    Nothing -> less_eq zeroa c && check_poly_ge p q;
    Just (q1, ((_, d), q2)) -> less_eq d c && check_poly_ge p (q1 ++ q2);
  });

check_poly_gt ::
  forall a b.
    (Ordered_semiring_0 a,
      Eq b) => (a -> a -> Bool) ->
                 [([(b, Nat)], a)] -> [([(b, Nat)], a)] -> Bool;
check_poly_gt gt p q =
  let {
    (a1, p1) = poly_split [] p;
    (b1, q1) = poly_split [] q;
  } in gt a1 b1 && check_poly_ge p1 q1;

shows_monom ::
  forall a. (Showa a) => [(a, Nat)] -> [Prelude.Char] -> [Prelude.Char];
shows_monom [(x, p)] =
  (if equal_nat p (Nat_of_num One) then shows_prec Zero_nat x
    else shows_prec Zero_nat x .
           shows_string ['^'] . shows_prec_nat Zero_nat p);
shows_monom ((x, p) : v : va) =
  (if equal_nat p (Nat_of_num One) then shows_prec Zero_nat x
    else shows_prec Zero_nat x .
           shows_string ['^'] . shows_prec_nat Zero_nat p) .
    shows_string ['*'] . shows_monom (v : va);
shows_monom [] = shows_string ['1'];

shows_poly ::
  forall a b.
    (Showa a, Eq b, Poly_carrier b,
      Showa b) => [([(a, Nat)], b)] -> [Prelude.Char] -> [Prelude.Char];
shows_poly [] = shows_string ['0'];
shows_poly ((m, c) : p) =
  (if c == onea then shows_monom m
    else (if null m then shows_prec Zero_nat c
           else shows_prec Zero_nat c . shows_string ['*'] . shows_monom m)) .
    (if null p then shows_string []
      else shows_string [' ', '+', ' '] . shows_poly p);

monom_mult :: forall a. (Eq a) => [(a, Nat)] -> [(a, Nat)] -> [(a, Nat)];
monom_mult [] n = n;
monom_mult ((x, p) : m) n =
  (case extracta (\ yq -> fst yq == x) n of {
    Nothing -> (x, p) : monom_mult m n;
    Just (n1, ((_, q), n2)) -> (x, plus_nat p q) : monom_mult m (n1 ++ n2);
  });

monom_mult_poly ::
  forall a b.
    (Eq a, Eq b,
      Semiring_0 b) => ([(a, Nat)], b) ->
                         [([(a, Nat)], b)] -> [([(a, Nat)], b)];
monom_mult_poly uu [] = [];
monom_mult_poly (ma, c) ((m, d) : p) =
  (if times c d == zeroa then monom_mult_poly (ma, c) p
    else (monom_mult ma m, times c d) : monom_mult_poly (ma, c) p);

poly_add ::
  forall a b.
    (Eq a, Eq b,
      Semiring_0 b) => [([(a, Nat)], b)] ->
                         [([(a, Nat)], b)] -> [([(a, Nat)], b)];
poly_add [] q = q;
poly_add ((m, c) : p) q =
  (case extracta (\ mc -> eq_monom (fst mc) m) q of {
    Nothing -> (m, c) : poly_add p q;
    Just (q1, ((_, d), q2)) ->
      (if plus c d == zeroa then poly_add p (q1 ++ q2)
        else (m, plus c d) : poly_add p (q1 ++ q2));
  });

poly_mult ::
  forall a b.
    (Eq a, Eq b,
      Semiring_0 b) => [([(a, Nat)], b)] ->
                         [([(a, Nat)], b)] -> [([(a, Nat)], b)];
poly_mult [] q = [];
poly_mult (mc : p) q = poly_add (monom_mult_poly mc q) (poly_mult p q);

one_poly :: forall a b. (Semiring_1 b) => [([(a, Nat)], b)];
one_poly = [([], onea)];

poly_power ::
  forall a b.
    (Eq a, Eq b,
      Comm_semiring_1 b) => [([(a, Nat)], b)] -> Nat -> [([(a, Nat)], b)];
poly_power uu n =
  (if equal_nat n Zero_nat then one_poly
    else poly_mult uu (poly_power uu (minus_nat n (Nat_of_num One))));

monom_subst ::
  forall a b c.
    (Eq b, Eq c,
      Comm_semiring_1 c) => (a -> [([(b, Nat)], c)]) ->
                              [(a, Nat)] -> [([(b, Nat)], c)];
monom_subst sigma [] = one_poly;
monom_subst sigma ((x, p) : m) =
  poly_mult (poly_power (sigma x) p) (monom_subst sigma m);

zero_poly :: forall a b. [([(a, Nat)], b)];
zero_poly = [];

poly_subst ::
  forall a b c.
    (Eq b, Eq c,
      Comm_semiring_1 c) => (a -> [([(b, Nat)], c)]) ->
                              [([(a, Nat)], c)] -> [([(b, Nat)], c)];
poly_subst sigma [] = zero_poly;
poly_subst sigma ((m, c) : p) =
  poly_add (poly_mult [([], c)] (monom_subst sigma m)) (poly_subst sigma p);

eval_term ::
  forall a b c.
    (Eq b, Poly_carrier b,
      Eq c) => ((a, Nat) -> [([(Nat, Nat)], b)]) ->
                 Term a c -> [([(c, Nat)], b)];
eval_term uu (Var x) = [([(x, Nat_of_num One)], onea)];
eval_term i (Fun f ts) =
  let {
    ps = map (eval_term i) ts;
    n = size_list ts;
  } in poly_subst (\ ia -> (if less_nat ia n then nth ps ia else zero_poly))
         (i (f, n));

check_s ::
  forall a b c.
    (Eq a, Poly_carrier a, Showa a, Showa b, Eq c,
      Showa c) => (a -> a -> Bool) ->
                    ((b, Nat) -> [([(Nat, Nat)], a)]) ->
                      (Term b c, Term b c) ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_s gt i =
  (\ (s, t) ->
    let {
      p = eval_term i s;
      q = eval_term i t;
    } in check (check_poly_gt gt p q)
           (shows_string
              ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'n', 's',
                'u', 'r', 'e', ' '] .
             shows_prec_term Zero_nat s .
               shows_string [' ', '>', ' '] .
                 shows_prec_term Zero_nat t .
                   shows_string
                     [' ', 's', 'i', 'n', 'c', 'e', ' ', 'w', 'e', ' '] .
                     shows_nl .
                       shows_string
                         ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e',
                           'n', 's', 'u', 'r', 'e', ' '] .
                         shows_poly p .
                           shows_string [' ', '>', ' '] . shows_poly q));

poly_of ::
  forall a b. (Eq a, Eq b, Comm_semiring_1 b) => Tpoly a b -> [([(a, Nat)], b)];
poly_of (PNum i) = (if i == zeroa then [] else [([], i)]);
poly_of (PVar x) = [([(x, Nat_of_num One)], onea)];
poly_of (PSum []) = zero_poly;
poly_of (PSum (p : ps)) = poly_add (poly_of p) (poly_of (PSum ps));
poly_of (PMult []) = one_poly;
poly_of (PMult (p : ps)) = poly_mult (poly_of p) (poly_of (PMult ps));

shows_pos :: Pos -> [Prelude.Char] -> [Prelude.Char];
shows_pos (PCons i Empty) =
  shows_prec_nat Zero_nat (plus_nat i (Nat_of_num One));
shows_pos (PCons i (PCons v va)) =
  shows_prec_nat Zero_nat (plus_nat i (Nat_of_num One)) .
    shows_pos (PCons v va);
shows_pos Empty = shows_string ['e', 'p', 's', 'i', 'l', 'o', 'n'];

rs_memb :: forall a. (Linorder a) => a -> Rbt a () -> Bool;
rs_memb = s_memb rm_lookup;

shows_rpo_repr ::
  forall a.
    (Showa a) => [((a, Nat), (Nat, Order_tag))] ->
                   [Prelude.Char] -> [Prelude.Char];
shows_rpo_repr prs =
  shows_string
    ['R', 'P', 'O', ' ', 'w', 'i', 't', 'h', ' ', 't', 'h', 'e', ' ', 'f', 'o',
      'l', 'l', 'o', 'w', 'i', 'n', 'g', ' ', 'p', 'r', 'e', 'c', 'e', 'd', 'e',
      'n', 'c', 'e'] .
    shows_nl .
      shows_map
        (\ (a, b) ->
          let {
            (f, n) = a;
          } in (\ (pr, _) ->
                 shows_string
                   ['p', 'r', 'e', 'c', 'e', 'd', 'e', 'n', 'c', 'e', '('] .
                   shows_prec Zero_nat f .
                     shows_string ['['] .
                       shows_prec_nat Zero_nat n .
                         shows_string [']', ')', ' ', '=', ' '] .
                           shows_prec_nat Zero_nat pr . shows_nl)
            b)
        prs .
        shows_nl .
          shows_string
            ['p', 'r', 'e', 'c', 'e', 'd', 'e', 'n', 'c', 'e', '(', '_', ')',
              ' ', '=', ' ', '0'] .
            shows_nl .
              shows_string
                ['a', 'n', 'd', ' ', 't', 'h', 'e', ' ', 'f', 'o', 'l', 'l',
                  'o', 'w', 'i', 'n', 'g', ' ', 's', 't', 'a', 't', 'u', 's'] .
                shows_nl .
                  shows_map
                    (\ (a, b) ->
                      let {
                        (f, n) = a;
                      } in (\ (_, s) ->
                             shows_string ['s', 't', 'a', 't', 'u', 's', '('] .
                               shows_prec Zero_nat f .
                                 shows_string ['['] .
                                   shows_prec_nat Zero_nat n .
                                     shows_string [']', ')', ' ', '=', ' '] .
                                       shows_string
 (case s of {
   Lex -> ['l', 'e', 'x'];
   Mul -> ['m', 'u', 'l'];
 }) .
 shows_nl)
                        b)
                    prs .
                    shows_nl .
                      shows_string
                        ['s', 't', 'a', 't', 'u', 's', '(', '_', ')', ' ', '=',
                          ' ', 'l', 'e', 'x'] .
                        shows_nl;

class (Order a) => Dense_order a where {
};

instance Dense_order Rat where {
};

instance Semiring_char_0 Rat where {
};

instance Ring_char_0 Rat where {
};

class (Ab_group_add a, Ordered_ab_semigroup_add_imp_le a,
        Ordered_comm_monoid_add a) => Ordered_ab_group_add a where {
};

class (Ordered_ab_group_add a, Ordered_cancel_semiring a,
        Ring a) => Ordered_ring a where {
};

scnp_af_to_af ::
  forall a.
    ((a, Nat) -> [(Nat, Nat)]) ->
      ((a, Nat) -> Nat -> Bool) -> (a, Nat) -> Nat -> Bool;
scnp_af_to_af pia pi =
  (\ (f, n) ->
    let {
      is = map fst (pia (f, n));
    } in (if any (less_eq_nat n) is
           then let {
                  isa = pi (f, n);
                } in (\ i -> isa i || membera is i)
           else membera is));

shows_list_term ::
  forall a b.
    (Showa a, Showa b) => [Term a b] -> [Prelude.Char] -> [Prelude.Char];
shows_list_term = shows_list_aux (shows_prec_term Zero_nat);

instance (Showa a, Showa b) => Showa (Term a b) where {
  shows_prec = shows_prec_term;
  shows_list = shows_list_term;
};

corder_term ::
  forall a b.
    (Eq a, Linorder a, Eq b,
      Linorder b) => Maybe (Term a b -> Term a b -> Bool,
                             Term a b -> Term a b -> Bool);
corder_term = Just (less_eq_term, less_term);

instance (Eq a, Linorder a, Eq b, Linorder b) => Corder (Term a b) where {
  corder = corder_term;
};

mk_subst_domain ::
  forall a b. (Eq a, Eq b) => [(a, Term b a)] -> [(a, Term b a)];
mk_subst_domain sigma =
  let {
    tau = mk_subst Var sigma;
  } in remdups
         (filter (\ (x, t) -> not (equal_term (Var x) t))
           (map (\ (x, _) -> (x, tau x)) sigma));

cEnum_term ::
  forall a b.
    Maybe ([Term a b],
            ((Term a b -> Bool) -> Bool, (Term a b -> Bool) -> Bool));
cEnum_term = Nothing;

instance Cenum (Term a b) where {
  cEnum = cEnum_term;
};

cEnum_prod ::
  forall a b.
    (Cenum a,
      Cenum b) => Maybe ([(a, b)],
                          (((a, b) -> Bool) -> Bool, ((a, b) -> Bool) -> Bool));
cEnum_prod =
  (case cEnum of {
    Nothing -> Nothing;
    Just (enum_a, (enum_all_a, enum_ex_a)) ->
      (case cEnum of {
        Nothing -> Nothing;
        Just (enum_b, (enum_all_b, enum_ex_b)) ->
          Just (product enum_a enum_b,
                 ((\ p -> enum_all_a (\ x -> enum_all_b (\ y -> p (x, y)))),
                   (\ p -> enum_ex_a (\ x -> enum_ex_b (\ y -> p (x, y))))));
      });
  });

instance (Cenum a, Cenum b) => Cenum (a, b) where {
  cEnum = cEnum_prod;
};

ceq_term :: forall a b. (Eq a, Eq b) => Maybe (Term a b -> Term a b -> Bool);
ceq_term = Just equal_term;

instance (Eq a, Eq b) => Ceq (Term a b) where {
  ceq = ceq_term;
};

list_all2_fusion ::
  forall a b c d.
    (a -> b -> Bool) -> Generator a c -> Generator b d -> c -> d -> Bool;
list_all2_fusion p g1 g2 s1 s2 =
  (if has_next g1 s1
    then has_next g2 s2 &&
           let {
             (x, s1a) = next g1 s1;
             (y, s2a) = next g2 s2;
           } in p x y && list_all2_fusion p g1 g2 s1a s2a
    else not (has_next g2 s2));

set_eq :: forall a. (Cenum a, Ceq a, Corder a) => Set a -> Set a -> Bool;
set_eq (RBT_set rbt1) (RBT_set rbt2) =
  (case corder of {
    Nothing ->
      error "set_eq RBT_set RBT_set: corder = None"
        (\ _ -> set_eq (RBT_set rbt1) (RBT_set rbt2));
    Just (le, _) ->
      (case ceq of {
        Nothing ->
          list_all2_fusion (mk_eq le) rbt_keys_generator rbt_keys_generator
            (init rbt1) (init rbt2);
        Just eq ->
          list_all2_fusion eq rbt_keys_generator rbt_keys_generator (init rbt1)
            (init rbt2);
      });
  });
set_eq (Complement a) (Complement b) = set_eq a b;
set_eq a b = less_eq_set a b && less_eq_set b a;

subst_eq ::
  forall a b.
    (Cenum a, Ceq a, Corder a, Eq a, Linorder a, Eq b,
      Linorder b) => [(a, Term b a)] -> [(a, Term b a)] -> Bool;
subst_eq sigma tau =
  let {
    sigmaa = mk_subst_domain sigma;
    taua = mk_subst_domain tau;
  } in set_eq (set sigmaa) (set taua);

full_af :: forall a. (a, Nat) -> Nat -> Bool;
full_af fn i = True;

data Root_redtriple_ext a b c =
  Root_redtriple_ext (Sum ([Prelude.Char] -> [Prelude.Char]) ())
    ((Term a b, Term a b) -> Sum ([Prelude.Char] -> [Prelude.Char]) ())
    ((Term a b, Term a b) -> Sum ([Prelude.Char] -> [Prelude.Char]) ())
    ((Term a b, Term a b) -> Sum ([Prelude.Char] -> [Prelude.Char]) ())
    ((a, Nat) -> Nat -> Bool) ((a, Nat) -> Nat -> Bool)
    ([Prelude.Char] -> [Prelude.Char]) c;

af :: forall a b c. Root_redtriple_ext a b c -> (a, Nat) -> Nat -> Bool;
af (Root_redtriple_ext valid s ns nst af aft desc more) = af;

ns :: forall a b c.
        Redtriple_ext a b c ->
          (Term a b, Term a b) -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
ns (Redtriple_ext valid s ns nst af mono desc cpx more) = ns;

sa :: forall a b c.
        Root_redtriple_ext a b c ->
          (Term a b, Term a b) -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
sa (Root_redtriple_ext valid s ns nst af aft desc more) = s;

defs_list :: forall a b. (Eq a) => [(Term a b, Term a b)] -> [(a, Nat)];
defs_list [] = [];
defs_list ((Fun f ss, r) : ts) =
  let {
    fs = defs_list ts;
    n = size_list ss;
  } in (if membera fs (f, n) then fs else (f, n) : fs);
defs_list ((Var x, r) : ts) = defs_list ts;

shows_rule ::
  forall a b.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      (b -> [Prelude.Char] -> [Prelude.Char]) ->
        [Prelude.Char] ->
          (Term a b, Term a b) -> [Prelude.Char] -> [Prelude.Char];
shows_rule fun var arr (l, r) =
  shows_term fun var l . shows_string arr . shows_term fun var r;

shows_rules ::
  forall a b.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      (b -> [Prelude.Char] -> [Prelude.Char]) ->
        [Prelude.Char] ->
          [(Term a b, Term a b)] -> [Prelude.Char] -> [Prelude.Char];
shows_rules fun var arr trs =
  shows_list_gen (shows_rule fun var arr) [] [] [newline] [] trs . shows_nl;

shows_trs ::
  forall a b.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      (b -> [Prelude.Char] -> [Prelude.Char]) ->
        [Prelude.Char] ->
          [Prelude.Char] ->
            [(Term a b, Term a b)] -> [Prelude.Char] -> [Prelude.Char];
shows_trs fun var name arr r =
  shows_string name . shows_nl . shows_nl . shows_rules fun var arr r;

apply_args :: forall a b. a -> Term a b -> [Term a b] -> Term a b;
apply_args a t [] = t;
apply_args a t (s : ss) = apply_args a (Fun a [t, s]) ss;

get_symbol :: forall a. (a -> Nat -> [a]) -> a -> Nat -> Nat -> a;
get_symbol sm f n i = nth (sm f n) i;

xml2nd_choice ::
  forall a b c.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        [Prelude.Char] ->
          (Xml -> Sum_bot [Prelude.Char] b) ->
            (a -> Maybe b -> c) -> Xml -> Sum_bot [Prelude.Char] c;
xml2nd_choice tag p1 cn p2 f (Xml name atts cs text) =
  let {
    l = size_list cs;
  } in (if name == tag &&
             null atts && less_eq_nat (Nat_of_num (Bit0 One)) l && is_none text
         then binda (p1 (nth cs Zero_nat))
                (\ x1 ->
                  binda (bool cn (nth cs (Nat_of_num One)))
                    (\ b ->
                      (if b then binda (p2
 (nth cs (minus_nat l (Nat_of_num One))))
                                   (\ x2 -> returna (f x1 (Just x2)))
                        else returna (f x1 Nothing))))
         else fail tag (Xml name atts cs text));

sum_lpoly ::
  forall a.
    Partial_object_ext a (Monoid_ext a (Ring_ext a ())) -> [a] -> [a] -> [a];
sum_lpoly c [] ys = ys;
sum_lpoly c (v : va) [] = v : va;
sum_lpoly c (x : xs) (y : ys) = add c x y : sum_lpoly c xs ys;

lpoly_of ::
  forall a.
    (Eq a) => Partial_object_ext a (Monoid_ext a (Ring_ext a ())) ->
                Tpoly Nat a -> Sum_bot [Prelude.Char] (a, [a]);
lpoly_of c (PNum i) = returna (i, []);
lpoly_of c (PVar x) = returna (zero c, replicate x (zero c) ++ [one c]);
lpoly_of c (PSum []) = returna (zero c, []);
lpoly_of c (PSum (p : ps)) =
  binda (lpoly_of c p)
    (\ (cp, ncp) ->
      binda (lpoly_of c (PSum ps))
        (\ (cq, ncq) -> returna (add c cp cq, sum_lpoly c ncp ncq)));
lpoly_of c (PMult []) = returna (one c, []);
lpoly_of c (PMult (p : ps)) =
  binda (lpoly_of c p)
    (\ (cp, ncp) ->
      binda (lpoly_of c (PMult ps))
        (\ (cq, ncq) ->
          (if all (\ a -> zero c == a) ncp
            then returna (mult c cp cq, map (mult c cp) ncq)
            else (if all (\ a -> zero c == a) ncq
                   then returna (mult c cp cq, map (\ x -> mult c x cq) ncp)
                   else errora
                          ['c', 'a', 'n', 'n', 'o', 't', ' ', 't', 'r', 'a',
                            'n', 's', 'f', 'o', 'r', 'm', ' ', 'n', 'o', 'n',
                            '-', 'l', 'i', 'n', 'e', 'a', 'r', ' ', 'p', 'o',
                            'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 't',
                            'o', ' ', 'l', 'i', 'n', 'e', 'a', 'r', ' ', 'p',
                            'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l']))));

p :: Rat;
p = of_int (Pos (Bit0 One));

times_mini_alg_number :: Mini_alg_number -> Mini_alg_number -> Mini_alg_number;
times_mini_alg_number (Sp c1 d1) (Sp c2 d2) =
  Sp (plus_rat (times_rat c1 c2) (times_rat (times_rat p d1) d2))
    (plus_rat (times_rat c1 d2) (times_rat c2 d1));

plus_mini_alg_number :: Mini_alg_number -> Mini_alg_number -> Mini_alg_number;
plus_mini_alg_number (Sp c1 d1) (Sp c2 d2) =
  Sp (plus_rat c1 c2) (plus_rat d1 d2);

mini_of_rat :: Rat -> Mini_alg_number;
mini_of_rat x = Sp x zero_rat;

shows_prec_int :: Nat -> Int -> [Prelude.Char] -> [Prelude.Char];
shows_prec_int d i =
  (if less_int i Zero_int
    then shows_prec_char Zero_nat '-' .
           shows_prec_nat Zero_nat (nat (uminus_int i))
    else shows_prec_nat Zero_nat (nat i));

show_rat :: Rat -> [Prelude.Char];
show_rat x =
  let {
    (den, num) = quotient_of x;
  } in (if equal_int num (Pos One) then shows_prec_int Zero_nat den []
         else ((shows_prec_int Zero_nat den . shows_prec_char Zero_nat '/') .
                shows_prec_int Zero_nat num)
                []);

shows_prec_rat :: Nat -> Rat -> [Prelude.Char] -> [Prelude.Char];
shows_prec_rat d x = shows_string (show_rat x);

sqrtp :: Mini_alg_number;
sqrtp = Sp zero_rat one_rat;

mini_alg :: Xml -> Sum_bot [Prelude.Char] Mini_alg_number;
mini_alg x =
  catch (change rat mini_of_rat x)
    (\ _ ->
      binda (triple ['a', 'l', 'g', 'e', 'b', 'r', 'a', 'i', 'c'] rat rat rat
              (\ a b ->
                (\ c ->
                  (plus_mini_alg_number (mini_of_rat a)
                     (times_mini_alg_number (mini_of_rat b) sqrtp),
                    c)))
              x)
        (\ (r, c) ->
          (if equal_rat c p then returna r
            else fail (((shows_prec_list Zero_nat
                           ['o', 'n', 'l', 'y', ' ', 's', 'q', 'r', 't', '('] .
                          shows_prec_rat Zero_nat p) .
                         shows_prec_list Zero_nat
                           [')', ' ', 'a', 'l', 'l', 'o', 'w', 'e', 'd', ' ',
                             'i', 'n', ' ', 'i', 'r', 'r', 'a', 't', 'i', 'o',
                             'n', 'a', 'l', ' ', 'p', 'a', 'r', 't'])
                        [])
                   x)));

innermostLhss ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] [Term a [Prelude.Char]];
innermostLhss xml2name =
  many ['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't', 'L', 'h', 's', 's']
    (term xml2name) id;

strategy ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Strategy a [Prelude.Char]);
strategy xml2name =
  singleton ['s', 't', 'r', 'a', 't', 'e', 'g', 'y']
    (options
      [(['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't'],
         leaf ['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't'] Innermost),
        (['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't', 'L', 'h', 's', 's'],
          change (innermostLhss xml2name) Innermost_Q)])
    id;

xml_rule ::
  forall a b c.
    (Showa a, Showa b,
      Showa c) => (Term (Lab a [b]) c, Term (Lab a [b]) c) -> Xml;
xml_rule =
  (\ (l, r) ->
    Xml ['r', 'u', 'l', 'e'] []
      [Xml ['l', 'h', 's'] [] [xml_term l] Nothing,
        Xml ['r', 'h', 's'] [] [xml_term r] Nothing]
      Nothing);

class Countable a where {
};

icap_impl ::
  forall a.
    (Eq a) => Bool ->
                (Term a [Prelude.Char] -> Bool) ->
                  [Term a [Prelude.Char]] ->
                    [Term a [Prelude.Char]] ->
                      ([Prelude.Char] -> Bool) ->
                        Term a [Prelude.Char] -> Term a (Sum () [Prelude.Char]);
icap_impl nf isQnf ls s sx (Var x) =
  (if nf && sx x then Var (Inr x) else Var (Inl ()));
icap_impl nf isQnf ls s sx (Fun f ts) =
  let {
    t = Fun f (map (icap_impl nf isQnf ls s sx) ts);
  } in (if any (\ l ->
                 (case mgu_class t l of {
                   Nothing -> False;
                   Just mu ->
                     all (\ u ->
                           isQnf (subst_apply_term (map_vars (\ a -> 'y' : a) u)
                                   mu))
                       (args l) &&
                       all (\ u -> isQnf (subst_apply_term u mu)) s;
                 }))
             ls
         then Var (Inl ()) else t);

nF_subset :: forall a b. (Eq a, Eq b) => [Term a b] -> [Term a b] -> Bool;
nF_subset ls q =
  all (\ l -> any (\ t -> any (\ u -> matches u t) (supteq_list l)) q) ls;

kbo_strict ::
  forall a b.
    (Showa a, Eq b,
      Showa b) => ((a, Nat) -> Nat) ->
                    ((a, Nat) -> Nat) ->
                      Nat ->
                        (a -> Bool) ->
                          ((a, Nat) -> Nat -> Nat) ->
                            (Term a b, Term a b) ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ();
kbo_strict pr w w0 least scf =
  (\ (s, t) ->
    check (fst (kbo_impl w w0 pr least scf s t))
      (shows_string
         ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'o', 'r', 'i', 'e',
           'n', 't', ' '] .
        shows_prec_term Zero_nat s .
          shows_string [' ', '>', 'K', 'B', 'O', ' '] .
            shows_prec_term Zero_nat t . shows_nl));

data Ordered_semiring_ext a b =
  Ordered_semiring_ext (a -> a -> Bool) (a -> a -> Bool) (a -> a -> a) b;

gt :: forall a b.
        Partial_object_ext a
          (Monoid_ext a (Ring_ext a (Ordered_semiring_ext a b))) ->
          a -> a -> Bool;
gt (Partial_object_ext carrier
     (Monoid_ext mult one
       (Ring_ext zero add (Ordered_semiring_ext geq gt max more))))
  = gt;

poly_vars_list :: forall a b. (Eq a) => [([(a, Nat)], b)] -> [a];
poly_vars_list p = remdups (concatMap (map fst . fst) p);

concat_lists :: forall a. [[a]] -> [[a]];
concat_lists [] = [[]];
concat_lists (asa : xs) =
  let {
    a = concat_lists xs;
  } in concatMap (\ vec -> map (\ aa -> aa : vec) asa) a;

square_possibilities ::
  forall a b.
    (Eq a, Poly_carrier a,
      Eq b) => (a -> [a]) -> [([(b, Nat)], a)] -> [[([(b, Nat)], a)]];
square_possibilities sqrt p =
  let {
    roots =
      map (\ x ->
            map (\ a -> (x, a))
              (sqrt (fst (poly_split [(x, Nat_of_num (Bit0 One))] p))))
        (poly_vars_list p);
    choices = (if membera roots [] then [] else concat_lists roots);
    polys =
      map (\ xas ->
            poly_of (PSum (map (\ (x, a) -> PMult [PVar x, PNum a]) xas)))
        choices;
  } in polys;

check_poly_eq ::
  forall a b.
    (Eq a, Eq b,
      Semiring_0 b) => [([(a, Nat)], b)] -> [([(a, Nat)], b)] -> Bool;
check_poly_eq [] q = null q;
check_poly_eq ((m, c) : p) q =
  (case extracta (\ nd -> eq_monom (fst nd) m) q of {
    Nothing -> False;
    Just (q1, ((_, d), q2)) -> c == d && check_poly_eq p (q1 ++ q2);
  });

monom_degree :: forall a. [(a, Nat)] -> Nat;
monom_degree xps = listsum (map snd xps);

poly_degree :: forall a b. [([(a, Nat)], b)] -> Nat;
poly_degree p = max_list (map (\ (m, _) -> monom_degree m) p);

check_quadratic ::
  forall a.
    (Eq a,
      Poly_carrier a) => (a -> [a]) ->
                           [([(Nat, Nat)], a)] ->
                             Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_quadratic sqrt p =
  bindb (check (equal_nat (poly_degree p) (Nat_of_num (Bit0 One)))
          (shows_prec_list Zero_nat
            ['n', 'o', 't', ' ', 'q', 'u', 'a', 'd', 'r', 'a', 't', 'i', 'c']))
    (\ _ ->
      let {
        polys = square_possibilities sqrt p;
      } in check (any (\ q -> check_poly_eq (poly_mult q q) p) polys)
             (shows_prec_list Zero_nat
               ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'f', 'i', 'n',
                 'd', ' ', 'q', 'u', 'a', 'd', 'r', 'a', 't', 'i', 'c', ' ',
                 'p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l']));

check_quadratic_ge_const ::
  forall a b c.
    (Eq a, Poly_carrier a,
      Eq c) => (a -> [a]) ->
                 ((b, Nat) -> [([(Nat, Nat)], a)]) ->
                   (Term b c, Term b c) ->
                     Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_quadratic_ge_const sq i st =
  let {
    (s, t) = st;
  } in bindb (check (not (is_Var s))
               (shows_prec_list Zero_nat
                 ['r', 'e', 'q', 'u', 'i', 'r', 'e', ' ', 'n', 'o', 'n', '-',
                   'v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 's', ' ', 'a', 's',
                   ' ', 'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's']))
         (\ _ ->
           let {
             pt = eval_term i t;
             (c, p0) = poly_split [] pt;
           } in bindb (check (p0 == zero_poly)
                        (shows_prec_list Zero_nat
                          ['r', 'h', 's', ' ', 'm', 'u', 's', 't', ' ', 'e',
                            'v', 'a', 'l', 'u', 'a', 't', 'e', ' ', 't', 'o',
                            ' ', 'c', 'o', 'n', 's', 't', 'a', 'n', 't']))
                  (\ _ ->
                    let {
                      ps = i (the (root s));
                      (d, psx) = poly_split [] ps;
                    } in bindb (check (less_eq c d)
                                 (shows_prec_list Zero_nat
                                   ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i',
                                     'n', ' ', 'c', 'o', 'm', 'p', 'a', 'r',
                                     'i', 'n', 'g', ' ', 'c', 'o', 'n', 's',
                                     't', 'a', 'n', 't', 's']))
                           (\ _ -> check_quadratic sq psx)));

data C_constraint a b =
  Conditional_C Bool (Term a b, Term a b) (Term a b, Term a b)
  | Unconditional_C Bool (Term a b, Term a b);

check_ns ::
  forall a b c.
    (Showa a, Eq b, Poly_carrier b, Showa b, Eq c,
      Showa c) => ((a, Nat) -> [([(Nat, Nat)], b)]) ->
                    (Term a c, Term a c) ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_ns i =
  (\ (s, t) ->
    let {
      p = eval_term i s;
      q = eval_term i t;
    } in check (check_poly_ge p q)
           (shows_string
              ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'n', 's',
                'u', 'r', 'e', ' '] .
             shows_prec_term Zero_nat s .
               shows_string [' ', '>', '=', ' '] .
                 shows_prec_term Zero_nat t .
                   shows_string
                     [' ', 's', 'i', 'n', 'c', 'e', ' ', 'w', 'e', ' '] .
                     shows_nl .
                       shows_string
                         ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e',
                           'n', 's', 'u', 'r', 'e', ' '] .
                         shows_poly p .
                           shows_string [' ', '>', '=', ' '] . shows_poly q));

check_cc ::
  forall a b c.
    (Eq a, Poly_carrier a, Showa a, Showa b, Eq c,
      Showa c) => (a -> [a]) ->
                    (a -> a -> Bool) ->
                      ((b, Nat) -> [([(Nat, Nat)], a)]) ->
                        C_constraint b c ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_cc sq gt i (Unconditional_C False st) =
  (if isOK (check_quadratic_ge_const sq i st) then Inr () else check_ns i st);
check_cc sq gt i (Unconditional_C True st) = check_s gt i st;
check_cc sq gt i (Conditional_C True (u, v) (s, t)) =
  let {
    ss = eval_term i s;
    tt = eval_term i t;
    uu = eval_term i u;
    vv = eval_term i v;
  } in (if check_poly_gt gt ss tt then Inr ()
         else check (check_poly_ge (poly_add ss vv) (poly_add tt uu))
                (shows_string
                   ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'n',
                     's', 'u', 'r', 'e', ' '] .
                  shows_prec_term Zero_nat u .
                    shows_string [' ', '>', ' '] .
                      shows_prec_term Zero_nat v .
                        shows_string [' ', '=', '=', '>', ' '] .
                          shows_prec_term Zero_nat s .
                            shows_string [' ', '>', ' '] .
                              shows_prec_term Zero_nat t));
check_cc sq gt i (Conditional_C False (u, v) (s, t)) =
  (if isOK (check_quadratic_ge_const sq i (s, t)) then Inr ()
    else let {
           ss = eval_term i s;
           tt = eval_term i t;
           uu = eval_term i u;
           vv = eval_term i v;
         } in (if check_poly_ge ss tt then Inr ()
                else check (check_poly_ge (poly_add ss vv) (poly_add tt uu))
                       (shows_string
                          ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ',
                            'e', 'n', 's', 'u', 'r', 'e', ' '] .
                         shows_prec_term Zero_nat u .
                           shows_string [' ', '>', '=', ' '] .
                             shows_prec_term Zero_nat v .
                               shows_string [' ', '=', '=', '>', ' '] .
                                 shows_prec_term Zero_nat s .
                                   shows_string [' ', '>', '=', ' '] .
                                     shows_prec_term Zero_nat t)));

pos_prefix :: Pos -> Pos -> Maybe Pos;
pos_prefix Empty q = Just q;
pos_prefix (PCons i p) q =
  (case q of {
    Empty -> Nothing;
    PCons j qa -> (if equal_nat i j then pos_prefix p qa else Nothing);
  });

pos_suffix :: Pos -> Pos -> Maybe Pos;
pos_suffix p q =
  (case pos_prefix (rev p) (rev q) of {
    Nothing -> Nothing;
    Just qa -> Just (rev qa);
  });

data Cert_result = Certified [Prelude.Char] | Unsupported [Prelude.Char]
  | Error [Prelude.Char];

rs_empty :: forall a. (Linorder a) => () -> Rbt a ();
rs_empty = rm_empty;

rs_union :: forall a. (Linorder a) => Rbt a () -> Rbt a () -> Rbt a ();
rs_union = rm_add;

instance Field_char_0 Rat where {
};

instance Ordered_ab_semigroup_add Rat where {
};

instance Ordered_semiring Rat where {
};

instance Ordered_cancel_semiring Rat where {
};

instance Ordered_cancel_ab_semigroup_add Rat where {
};

instance Ordered_ab_semigroup_add_imp_le Rat where {
};

instance Ordered_comm_monoid_add Rat where {
};

instance Ordered_ab_group_add Rat where {
};

instance Ordered_ring Rat where {
};

instance Non_strict_order Rat where {
};

instance Ordered_ab_semigroup Rat where {
};

instance Ordered_semiring_0 Rat where {
};

instance Ordered_semiring_1 Rat where {
};

instance Poly_carrier Rat where {
};

rules_with ::
  forall a b c.
    (Eq b,
      Linorder b) => (a -> Bool) ->
                       Rbt (b, Nat) [(a, (Term b c, Term b c))] ->
                         [(Term b c, Term b c)];
rules_with p m =
  map_filter (\ x -> (if (p . fst) x then Just (snd x) else Nothing))
    (values m);

scnp_desc ::
  forall a.
    (Showa a) => [((a, Nat), [(Nat, Nat)])] ->
                   [Prelude.Char] -> [Prelude.Char] -> [Prelude.Char];
scnp_desc af mu =
  shows_prec_list Zero_nat
    ['S', 'C', 'N', 'P', '-', 'v', 'e', 'r', 's', 'i', 'o', 'n', ' ', 'w', 'i',
      't', 'h', ' ', 'm', 'u', ' ', '=', ' '] .
    shows_prec_list Zero_nat mu .
      shows_prec_list Zero_nat
        [' ', 'a', 'n', 'd', ' ', 't', 'h', 'e', ' ', 'l', 'e', 'v', 'e', 'l',
          ' ', 'm', 'a', 'p', 'p', 'i', 'n', 'g', ' ', 'd', 'e', 'f', 'i', 'n',
          'e', 'd', ' ', 'b', 'y', ' '] .
        shows_nl .
          shows_sep
            (\ (a, b) ->
              let {
                (f, n) = a;
              } in (\ asa ->
                     shows_prec_list Zero_nat ['p', 'i', '('] .
                       shows_prec Zero_nat f .
                         shows_prec_list Zero_nat [')', ' ', '=', ' '] .
                           shows_list_aux
                             (\ (p, l) ->
                               shows_prec_list Zero_nat ['('] .
                                 (if less_nat p n
                                   then shows_prec_nat Zero_nat
  (plus_nat p (Nat_of_num One))
                                   else shows_prec_list Zero_nat
  ['e', 'p', 's', 'i', 'l', 'o', 'n']) .
                                   shows_prec_list Zero_nat [','] .
                                     shows_prec_nat Zero_nat l .
                                       shows_prec_list Zero_nat [')'])
                             asa)
                b)
            shows_nl af .
            shows_nl;

s_iteratei ::
  forall a b c.
    (a -> (b -> Bool) -> ((c, ()) -> b -> b) -> b -> b) ->
      a -> (b -> Bool) -> (c -> b -> b) -> b -> b;
s_iteratei it s c f = it s c (\ x -> f (fst x));

split_rulesa ::
  forall a b c d.
    Tp_ops_ext a b c d ->
      a -> [(Term b c, Term b c)] ->
             ([(Term b c, Term b c)], [(Term b c, Term b c)]);
split_rulesa
  (Tp_ops_ext qreltrs q r rw rules q_empty is_QNF nFQ_subset_NF_rules rules_map
    delete_R_Rw split_rules mk nfs more)
  = split_rules;

delete_R_Rwa ::
  forall a b c d.
    Tp_ops_ext a b c d ->
      a -> [(Term b c, Term b c)] -> [(Term b c, Term b c)] -> a;
delete_R_Rwa
  (Tp_ops_ext qreltrs q r rw rules q_empty is_QNF nFQ_subset_NF_rules rules_map
    delete_R_Rw split_rules mk nfs more)
  = delete_R_Rw;

nfsa :: forall a b c d. Tp_ops_ext a b c d -> a -> Bool;
nfsa (Tp_ops_ext qreltrs q r rw rules q_empty is_QNF nFQ_subset_NF_rules
       rules_map delete_R_Rw split_rules mk nfs more)
  = nfs;

qa :: forall a b c d. Tp_ops_ext a b c d -> a -> [Term b c];
qa (Tp_ops_ext qreltrs q r rw rules q_empty is_QNF nFQ_subset_NF_rules rules_map
     delete_R_Rw split_rules mk nfs more)
  = q;

split_tt ::
  forall a b c.
    (Showa b,
      Showa c) => Tp_ops_ext a b c () -> a -> [(Term b c, Term b c)] -> (a, a);
split_tt i tp r_remove =
  let {
    (r, rw) = split_rulesa i tp r_remove;
    tp1 = mka i (nfsa i tp) (qa i tp) r rw;
    a = delete_R_Rwa i tp r_remove r_remove;
  } in (tp1, a);

supt_impl :: forall a b. (Eq a, Eq b) => Term a b -> Term a b -> Bool;
supt_impl (Var x) t = False;
supt_impl (Fun f ss) t = membera ss t || any (\ s -> supt_impl s t) ss;

afa :: forall a b c. Redtriple_ext a b c -> (a, Nat) -> Nat -> Bool;
afa (Redtriple_ext valid s ns nst af mono desc cpx more) = af;

aft :: forall a b c. Root_redtriple_ext a b c -> (a, Nat) -> Nat -> Bool;
aft (Root_redtriple_ext valid s ns nst af aft desc more) = aft;

cpx ::
  forall a b c.
    Redtriple_ext a b c ->
      Complexity_measure a b ->
        Sum ([Prelude.Char] -> [Prelude.Char]) Complexity_class;
cpx (Redtriple_ext valid s ns nst af mono desc cpx more) = cpx;

nsa ::
  forall a b c.
    Root_redtriple_ext a b c ->
      (Term a b, Term a b) -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
nsa (Root_redtriple_ext valid s ns nst af aft desc more) = ns;

nst ::
  forall a b c.
    Redtriple_ext a b c ->
      (Term a b, Term a b) -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
nst (Redtriple_ext valid s ns nst af mono desc cpx more) = nst;

r_rhs :: forall a b. Ta_rule a b -> a;
r_rhs (TA_rule f qs q) = q;

aarity_term ::
  forall a b. (Eq a) => a -> (a -> Nat -> [a]) -> Term a b -> Maybe Nat;
aarity_term a sm t =
  (case unapp a t of {
    (Var _, ts) -> Nothing;
    (Fun f ss, ts) ->
      Just (minus_nat (aarity sm f (size_list ss)) (size_list ts));
  });

uncurry_top ::
  forall a b. (Eq a) => a -> Nat -> (a -> Nat -> [a]) -> Term a b -> Term a b;
uncurry_top a n sm (Fun f ts) =
  let {
    mt = map (map_term_wa (\ fa na -> get_symbol sm fa na Zero_nat));
    (h, m) = the (root (hd ts));
  } in (if f == a &&
             equal_nat (size_list ts) n &&
               not (is_Var (hd ts)) && not (equal_nat (aarity sm h m) Zero_nat)
         then let {
                (Fun g ss) = hd ts;
              } in Fun (get_symbol sm g (size_list ss) (Nat_of_num One))
                     (mt (ss ++ tl ts))
         else Fun (get_symbol sm f (size_list ts) Zero_nat) (mt ts));
uncurry_top a n sm (Var x) = Var x;

arith_fun :: Xml -> Sum_bot [Prelude.Char] ArithFun;
arith_fun xml =
  singleton ['a', 'r', 'i', 't', 'h', 'F', 'u', 'n', 'c', 't', 'i', 'o', 'n']
    (options
      [(['n', 'a', 't', 'u', 'r', 'a', 'l'],
         change (nata ['n', 'a', 't', 'u', 'r', 'a', 'l']) Const),
        (['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e'],
          change (nata ['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e'])
            (\ n -> Arg (minus_nat n (Nat_of_num One)))),
        (['s', 'u', 'm'], many ['s', 'u', 'm'] arith_fun Sum),
        (['p', 'r', 'o', 'd', 'u', 'c', 't'],
          many ['p', 'r', 'o', 'd', 'u', 'c', 't'] arith_fun Prod),
        (['m', 'i', 'n'], many ['m', 'i', 'n'] arith_fun Min),
        (['m', 'a', 'x'], many ['m', 'a', 'x'] arith_fun Max),
        (['i', 'f', 'E', 'q', 'u', 'a', 'l'],
          tuple4 ['i', 'f', 'E', 'q', 'u', 'a', 'l'] arith_fun arith_fun
            arith_fun arith_fun IfEqual)])
    id xml;

int_coeff :: Xml -> Sum_bot [Prelude.Char] Int;
int_coeff = int ['i', 'n', 't', 'e', 'g', 'e', 'r'];

vec_coeff ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) -> Xml -> Sum_bot [Prelude.Char] [a];
vec_coeff xml2coeff =
  many ['v', 'e', 'c', 't', 'o', 'r']
    (singleton ['c', 'o', 'e', 'f', 'f', 'i', 'c', 'i', 'e', 'n', 't'] xml2coeff
      id)
    id;

mat_coeff ::
  forall a.
    a -> (Xml -> Sum_bot [Prelude.Char] a) ->
           Xml -> Sum_bot [Prelude.Char] [[a]];
mat_coeff ze xml2coeff =
  options
    [(['m', 'a', 't', 'r', 'i', 'x'],
       many ['m', 'a', 't', 'r', 'i', 'x'] (vec_coeff xml2coeff) id),
      (['v', 'e', 'c', 't', 'o', 'r'],
        change (vec_coeff xml2coeff)
          (\ v ->
            v : replicate (minus_nat (size_list v) (Nat_of_num One))
                  (replicate (size_list v) ze)))];

precedence_weight ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          (Nat -> ([((a, Nat), (Nat, (Nat, Maybe [Nat])))], Nat));
precedence_weight xml2name =
  many ['p', 'r', 'e', 'c', 'e', 'd', 'e', 'n', 'c', 'e', 'W', 'e', 'i', 'g',
         'h', 't']
    (guard (\ x -> equal_nat (num_children x) (Nat_of_num (Bit0 (Bit0 One))))
      (tuple4
        ['p', 'r', 'e', 'c', 'e', 'd', 'e', 'n', 'c', 'e', 'W', 'e', 'i', 'g',
          'h', 't', 'E', 'n', 't', 'r', 'y']
        xml2name (nata ['a', 'r', 'i', 't', 'y'])
        (nata ['p', 'r', 'e', 'c', 'e', 'd', 'e', 'n', 'c', 'e'])
        (nata ['w', 'e', 'i', 'g', 'h', 't'])
        (\ f a p w -> ((f, a), (p, (w, Nothing)))))
      (tuple5
        ['p', 'r', 'e', 'c', 'e', 'd', 'e', 'n', 'c', 'e', 'W', 'e', 'i', 'g',
          'h', 't', 'E', 'n', 't', 'r', 'y']
        xml2name (nata ['a', 'r', 'i', 't', 'y'])
        (nata ['p', 'r', 'e', 'c', 'e', 'd', 'e', 'n', 'c', 'e'])
        (nata ['w', 'e', 'i', 'g', 'h', 't'])
        (many ['s', 'u', 'b', 't', 'e', 'r', 'm', 'C', 'o', 'e', 'f', 'f', 'i',
                'c', 'i', 'e', 'n', 't', 'E', 'n', 't', 'r', 'i', 'e', 's']
          (nata ['e', 'n', 't', 'r', 'y']) id)
        (\ f a p w e -> ((f, a), (p, (w, Just e))))))
    (\ a b -> (a, b));

xml2to3elements ::
  forall a b c d.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (Xml -> Sum_bot [Prelude.Char] b) ->
          (Xml -> Sum_bot [Prelude.Char] c) ->
            (a -> b -> Maybe c -> d) -> Xml -> Sum_bot [Prelude.Char] d;
xml2to3elements tag p1 p2 p3 f (Xml name atts cs text) =
  let {
    l = size_list cs;
  } in (if name == tag &&
             null atts &&
               less_eq_nat (Nat_of_num (Bit0 One)) l &&
                 less_eq_nat l (Nat_of_num (Bit1 One)) && is_none text
         then binda (p1 (nth cs Zero_nat))
                (\ x1 ->
                  binda (p2 (nth cs (Nat_of_num One)))
                    (\ x2 ->
                      (if equal_nat l (Nat_of_num (Bit1 One))
                        then binda (p3 (nth cs (Nat_of_num (Bit0 One))))
                               (\ x3 -> returna (f x1 x2 (Just x3)))
                        else returna (f x1 x2 Nothing))))
         else fail tag (Xml name atts cs text));

knuth_bendix_order ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Redtriple_impl a);
knuth_bendix_order xml2name =
  xml2to3elements
    ['k', 'n', 'u', 't', 'h', 'B', 'e', 'n', 'd', 'i', 'x', 'O', 'r', 'd', 'e',
      'r']
    (nata ['w', '0']) (precedence_weight xml2name) (afs xml2name)
    (\ w0 prw afo ->
      let {
        a = (case afo of {
              Nothing -> [];
              Just af -> af;
            });
      } in Kbo (prw w0) a);

instance Times Mini_alg_number where {
  times = times_mini_alg_number;
};

instance Semigroup_mult Mini_alg_number where {
};

instance Ab_semigroup_mult Mini_alg_number where {
};

one_mini_alg_number :: Mini_alg_number;
one_mini_alg_number = Sp one_rat zero_rat;

instance One Mini_alg_number where {
  onea = one_mini_alg_number;
};

instance Power Mini_alg_number where {
};

instance Monoid_mult Mini_alg_number where {
};

instance Comm_monoid_mult Mini_alg_number where {
};

instance Plus Mini_alg_number where {
  plus = plus_mini_alg_number;
};

instance Semigroup_add Mini_alg_number where {
};

instance Ab_semigroup_add Mini_alg_number where {
};

instance Semiring Mini_alg_number where {
};

instance Comm_semiring Mini_alg_number where {
};

zero_mini_alg_number :: Mini_alg_number;
zero_mini_alg_number = Sp zero_rat zero_rat;

instance Zero Mini_alg_number where {
  zeroa = zero_mini_alg_number;
};

instance Monoid_add Mini_alg_number where {
};

instance Comm_monoid_add Mini_alg_number where {
};

instance Mult_zero Mini_alg_number where {
};

instance Semiring_0 Mini_alg_number where {
};

instance Comm_semiring_0 Mini_alg_number where {
};

instance Numeral Mini_alg_number where {
};

instance Semiring_numeral Mini_alg_number where {
};

instance Zero_neq_one Mini_alg_number where {
};

instance Semiring_1 Mini_alg_number where {
};

instance Dvd Mini_alg_number where {
};

instance Comm_semiring_1 Mini_alg_number where {
};

class (Dense_order a, Linorder a) => Dense_linorder a where {
};

class (Dense_linorder a, No_bot a,
        No_top a) => Unbounded_dense_linorder a where {
};

class (Linordered_semiring a, Semiring_1 a) => Linordered_semiring_1 a where {
};

class (Linordered_semiring_1 a,
        Linordered_semiring_strict a) => Linordered_semiring_1_strict a where {
};

class (Abs a, Ordered_ab_group_add a) => Ordered_ab_group_add_abs a where {
};

class (Linordered_cancel_ab_semigroup_add a,
        Ordered_ab_group_add a) => Linordered_ab_group_add a where {
};

class (Abs_if a, Linordered_ab_group_add a, Ordered_ab_group_add_abs a,
        Linordered_semiring a, Ordered_ring a) => Linordered_ring a where {
};

class (Linordered_ring a, Linordered_semiring_strict a,
        Ring_no_zero_divisors a) => Linordered_ring_strict a where {
};

class (Comm_ring a, Ordered_cancel_comm_semiring a,
        Ordered_ring a) => Ordered_comm_ring a where {
};

class (Ordered_ab_group_add_abs a, Ordered_ring a) => Ordered_ring_abs a where {
};

class (Sgn_if a, Ring_char_0 a, Idom a, Linordered_ring_strict a,
        Linordered_semidom a, Linordered_semiring_1_strict a,
        Ordered_comm_ring a, Ordered_ring_abs a) => Linordered_idom a where {
};

class (Unbounded_dense_linorder a, Field_char_0 a,
        Linordered_idom a) => Linordered_field a where {
};

equal_mini_alg_number :: Mini_alg_number -> Mini_alg_number -> Bool;
equal_mini_alg_number (Sp rat1a rat2a) (Sp rat1 rat2) =
  equal_rat rat1a rat1 && equal_rat rat2a rat2;

instance Eq Mini_alg_number where {
  a == b = equal_mini_alg_number a b;
};

set_impl_mini_alg_number :: Phantom Mini_alg_number Set_impl;
set_impl_mini_alg_number = Phantom Set_RBT;

instance Set_impla Mini_alg_number where {
  set_impl = set_impl_mini_alg_number;
};

mini_alg_number_rec :: forall a. (Rat -> Rat -> a) -> Mini_alg_number -> a;
mini_alg_number_rec f1 (Sp rat1 rat2) = f1 rat1 rat2;

corder_mini_alg_number ::
  Maybe (Mini_alg_number -> Mini_alg_number -> Bool,
          Mini_alg_number -> Mini_alg_number -> Bool);
corder_mini_alg_number =
  Just ((\ x y ->
          mini_alg_number_rec
            (\ x_0 x_1 (Sp y_0 y_1) ->
              less_rat x_0 y_0 || equal_rat x_0 y_0 && less_rat x_1 y_1)
            x y ||
            equal_mini_alg_number x y),
         mini_alg_number_rec
           (\ x_0 x_1 (Sp y_0 y_1) ->
             less_rat x_0 y_0 || equal_rat x_0 y_0 && less_rat x_1 y_1));

instance Corder Mini_alg_number where {
  corder = corder_mini_alg_number;
};

set_impl_arctic_delta :: forall a. Phantom (Arctic_delta a) Set_impl;
set_impl_arctic_delta = Phantom Set_RBT;

instance Set_impla (Arctic_delta a) where {
  set_impl = set_impl_arctic_delta;
};

data Interpretation a = Int_linear_poly ((a, Nat), (Int, [Int]))
  | Rat_linear_poly ((a, Nat), (Rat, [Rat]))
  | Arctic_linear_poly ((a, Nat), (Arctic, [Arctic]))
  | Arctic_rat_linear_poly ((a, Nat), (Arctic_delta Rat, [Arctic_delta Rat]))
  | Mini_alg_linear_poly ((a, Nat), (Mini_alg_number, [Mini_alg_number]))
  | Int_matrix ((a, Nat), ([[Int]], [[[Int]]]))
  | Rat_matrix ((a, Nat), ([[Rat]], [[[Rat]]]))
  | Arctic_matrix ((a, Nat), ([[Arctic]], [[[Arctic]]]))
  | Arctic_rat_matrix ((a, Nat), ([[Arctic_delta Rat]], [[[Arctic_delta Rat]]]))
  | Mini_alg_matrix ((a, Nat), ([[Mini_alg_number]], [[[Mini_alg_number]]]))
  | Int_non_linear_poly ((a, Nat), [([(Nat, Nat)], Int)])
  | Rat_non_linear_poly ((a, Nat), [([(Nat, Nat)], Rat)])
  | Mini_alg_non_linear_poly ((a, Nat), [([(Nat, Nat)], Mini_alg_number)]);

mini_alg_non_linear_polya ::
  forall a. Interpretation a -> ((a, Nat), [([(Nat, Nat)], Mini_alg_number)]);
mini_alg_non_linear_polya (Mini_alg_non_linear_poly x) = x;

times_arctic_delta ::
  forall a.
    (Linordered_field a) => Arctic_delta a -> Arctic_delta a -> Arctic_delta a;
times_arctic_delta MinInfty_delta y = MinInfty_delta;
times_arctic_delta (Num_arc_delta v) MinInfty_delta = MinInfty_delta;
times_arctic_delta (Num_arc_delta x) (Num_arc_delta y) =
  Num_arc_delta (plus x y);

instance (Linordered_field a) => Times (Arctic_delta a) where {
  times = times_arctic_delta;
};

equal_arctic_delta ::
  forall a. (Eq a) => Arctic_delta a -> Arctic_delta a -> Bool;
equal_arctic_delta (Num_arc_delta a) MinInfty_delta = False;
equal_arctic_delta MinInfty_delta (Num_arc_delta a) = False;
equal_arctic_delta (Num_arc_delta aa) (Num_arc_delta a) = aa == a;
equal_arctic_delta MinInfty_delta MinInfty_delta = True;

instance (Eq a) => Eq (Arctic_delta a) where {
  a == b = equal_arctic_delta a b;
};

arctic_delta_rec :: forall a b. a -> (b -> a) -> Arctic_delta b -> a;
arctic_delta_rec f1 f2 MinInfty_delta = f1;
arctic_delta_rec f1 f2 (Num_arc_delta a) = f2 a;

corder_arctic_delta ::
  forall a.
    (Eq a,
      Linorder a) => Maybe (Arctic_delta a -> Arctic_delta a -> Bool,
                             Arctic_delta a -> Arctic_delta a -> Bool);
corder_arctic_delta =
  Just ((\ x y ->
          arctic_delta_rec
            (\ a ->
              (case a of {
                MinInfty_delta -> False;
                Num_arc_delta _ -> True;
              }))
            (\ x_0 a ->
              (case a of {
                MinInfty_delta -> False;
                Num_arc_delta aa -> less x_0 aa;
              }))
            x y ||
            equal_arctic_delta x y),
         arctic_delta_rec
           (\ a ->
             (case a of {
               MinInfty_delta -> False;
               Num_arc_delta _ -> True;
             }))
           (\ x_0 a ->
             (case a of {
               MinInfty_delta -> False;
               Num_arc_delta aa -> less x_0 aa;
             })));

instance (Eq a, Linorder a) => Corder (Arctic_delta a) where {
  corder = corder_arctic_delta;
};

ceq_mini_alg_number :: Maybe (Mini_alg_number -> Mini_alg_number -> Bool);
ceq_mini_alg_number = Just equal_mini_alg_number;

instance Ceq Mini_alg_number where {
  ceq = ceq_mini_alg_number;
};

arctic_rat_linear_polya ::
  forall a.
    Interpretation a -> ((a, Nat), (Arctic_delta Rat, [Arctic_delta Rat]));
arctic_rat_linear_polya (Arctic_rat_linear_poly x) = x;

zero_arctic_delta :: forall a. (Linordered_field a) => Arctic_delta a;
zero_arctic_delta = MinInfty_delta;

instance (Linordered_field a) => Zero (Arctic_delta a) where {
  zeroa = zero_arctic_delta;
};

plus_arctic_delta ::
  forall a.
    (Linordered_field a) => Arctic_delta a -> Arctic_delta a -> Arctic_delta a;
plus_arctic_delta MinInfty_delta y = y;
plus_arctic_delta (Num_arc_delta v) MinInfty_delta = Num_arc_delta v;
plus_arctic_delta (Num_arc_delta x) (Num_arc_delta y) = Num_arc_delta (max x y);

instance (Linordered_field a) => Plus (Arctic_delta a) where {
  plus = plus_arctic_delta;
};

one_arctic_delta :: forall a. (Linordered_field a) => Arctic_delta a;
one_arctic_delta = Num_arc_delta zeroa;

instance (Linordered_field a) => One (Arctic_delta a) where {
  onea = one_arctic_delta;
};

mini_alg_linear_polya ::
  forall a.
    Interpretation a -> ((a, Nat), (Mini_alg_number, [Mini_alg_number]));
mini_alg_linear_polya (Mini_alg_linear_poly x) = x;

class_semiring ::
  forall a b.
    (Ceq a, Corder a, One a, Plus a, Times a, Zero a,
      Set_impla a) => Itself a ->
                        b -> Partial_object_ext a (Monoid_ext a (Ring_ext a b));
class_semiring uu b =
  Partial_object_ext top_set (Monoid_ext times onea (Ring_ext zeroa plus b));

ceq_arctic_delta ::
  forall a. (Eq a) => Maybe (Arctic_delta a -> Arctic_delta a -> Bool);
ceq_arctic_delta = Just equal_arctic_delta;

instance (Eq a) => Ceq (Arctic_delta a) where {
  ceq = ceq_arctic_delta;
};

rat_non_linear_polya ::
  forall a. Interpretation a -> ((a, Nat), [([(Nat, Nat)], Rat)]);
rat_non_linear_polya (Rat_non_linear_poly x) = x;

int_non_linear_polya ::
  forall a. Interpretation a -> ((a, Nat), [([(Nat, Nat)], Int)]);
int_non_linear_polya (Int_non_linear_poly x) = x;

set_impl_arctic :: Phantom Arctic Set_impl;
set_impl_arctic = Phantom Set_RBT;

instance Set_impla Arctic where {
  set_impl = set_impl_arctic;
};

mini_alg_domain :: Xml -> Sum_bot [Prelude.Char] Mini_alg_number;
mini_alg_domain =
  singleton
    ['a', 'l', 'g', 'e', 'b', 'r', 'a', 'i', 'c', 'N', 'u', 'm', 'b', 'e', 'r',
      's']
    (singleton ['d', 'e', 'l', 't', 'a'] mini_alg id) id;

rat_domain :: Xml -> Sum_bot [Prelude.Char] Rat;
rat_domain =
  singleton ['r', 'a', 't', 'i', 'o', 'n', 'a', 'l', 's']
    (singleton ['d', 'e', 'l', 't', 'a'] rat id) id;

basic_domain :: Xml -> Sum_bot [Prelude.Char] (Nat -> Domain);
basic_domain =
  options
    [(['n', 'a', 't', 'u', 'r', 'a', 'l', 's'],
       leaf ['n', 'a', 't', 'u', 'r', 'a', 'l', 's'] Natural),
      (['i', 'n', 't', 'e', 'g', 'e', 'r', 's'],
        leaf ['i', 'n', 't', 'e', 'g', 'e', 'r', 's'] (\ _ -> Integera)),
      (['a', 'r', 'c', 't', 'i', 'c'],
        singleton ['a', 'r', 'c', 't', 'i', 'c']
          (singleton ['d', 'o', 'm', 'a', 'i', 'n']
            (options
              [(['n', 'a', 't', 'u', 'r', 'a', 'l', 's'],
                 leaf ['n', 'a', 't', 'u', 'r', 'a', 'l', 's'] (\ _ -> Arctic)),
                (['i', 'n', 't', 'e', 'g', 'e', 'r', 's'],
                  leaf ['i', 'n', 't', 'e', 'g', 'e', 'r', 's']
                    (\ _ -> Arctic)),
                (['r', 'a', 't', 'i', 'o', 'n', 'a', 'l', 's'],
                  change rat_domain (\ _ _ -> Arctic_rat))])
            id)
          id),
      (['r', 'a', 't', 'i', 'o', 'n', 'a', 'l', 's'],
        change rat_domain Rational),
      (['a', 'l', 'g', 'e', 'b', 'r', 'a', 'i', 'c', 'N', 'u', 'm', 'b', 'e',
         'r', 's'],
        change mini_alg_domain Mini_Alg)];

interpretation_type :: Xml -> Sum_bot [Prelude.Char] Domain;
interpretation_type =
  singleton ['t', 'y', 'p', 'e']
    (options
      [(['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l'],
         pair ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l']
           (singleton ['d', 'o', 'm', 'a', 'i', 'n']
             (options
               [(['n', 'a', 't', 'u', 'r', 'a', 'l', 's'], basic_domain),
                 (['i', 'n', 't', 'e', 'g', 'e', 'r', 's'], basic_domain),
                 (['a', 'r', 'c', 't', 'i', 'c'], basic_domain),
                 (['r', 'a', 't', 'i', 'o', 'n', 'a', 'l', 's'], basic_domain),
                 (['a', 'l', 'g', 'e', 'b', 'r', 'a', 'i', 'c', 'N', 'u', 'm',
                    'b', 'e', 'r', 's'],
                   basic_domain),
                 (['m', 'a', 't', 'r', 'i', 'c', 'e', 's'],
                   triple ['m', 'a', 't', 'r', 'i', 'c', 'e', 's']
                     (nata ['d', 'i', 'm', 'e', 'n', 's', 'i', 'o', 'n'])
                     (nata ['s', 't', 'r', 'i', 'c', 't', 'D', 'i', 'm', 'e',
                             'n', 's', 'i', 'o', 'n'])
                     (singleton ['d', 'o', 'm', 'a', 'i', 'n'] basic_domain id)
                     (\ di sd domain d ->
                       (case domain d of {
                         Natural _ -> Int_mat di sd;
                         Integera -> Int_mat di sd;
                         Arctic -> Arc_mat di;
                         Arctic_rat -> Arc_rat_mat di;
                         Rational _ _ -> Rat_mat di sd;
                         Mini_Alg _ _ -> Mini_Alg_mat di sd;
                       })))])
             id)
           (nata ['d', 'e', 'g', 'r', 'e', 'e']) (\ typea -> typea)),
        (['m', 'a', 't', 'r', 'i', 'x', 'I', 'n', 't', 'e', 'r', 'p', 'r', 'e',
           't', 'a', 't', 'i', 'o', 'n'],
          triple
            ['m', 'a', 't', 'r', 'i', 'x', 'I', 'n', 't', 'e', 'r', 'p', 'r',
              'e', 't', 'a', 't', 'i', 'o', 'n']
            (singleton ['d', 'o', 'm', 'a', 'i', 'n'] basic_domain id)
            (nata ['d', 'i', 'm', 'e', 'n', 's', 'i', 'o', 'n'])
            (nata ['s', 't', 'r', 'i', 'c', 't', 'D', 'i', 'm', 'e', 'n', 's',
                    'i', 'o', 'n'])
            (\ domain di sd ->
              (case domain Zero_nat of {
                Natural _ -> Int_mat di sd;
                Integera -> Int_mat di sd;
                Arctic -> Arc_mat di;
                Arctic_rat -> Arc_rat_mat di;
                Rational _ _ -> Rat_mat di sd;
                Mini_Alg _ _ -> Mini_Alg_mat di sd;
              })))])
    id;

arctic_linear_polya ::
  forall a. Interpretation a -> ((a, Nat), (Arctic, [Arctic]));
arctic_linear_polya (Arctic_linear_poly x) = x;

arctic_rat_matrixa ::
  forall a.
    Interpretation a ->
      ((a, Nat), ([[Arctic_delta Rat]], [[[Arctic_delta Rat]]]));
arctic_rat_matrixa (Arctic_rat_matrix x) = x;

times_arctic :: Arctic -> Arctic -> Arctic;
times_arctic MinInfty y = MinInfty;
times_arctic (Num_arc v) MinInfty = MinInfty;
times_arctic (Num_arc x) (Num_arc y) = Num_arc (plus_int x y);

instance Times Arctic where {
  times = times_arctic;
};

equal_arctic :: Arctic -> Arctic -> Bool;
equal_arctic (Num_arc int) MinInfty = False;
equal_arctic MinInfty (Num_arc int) = False;
equal_arctic (Num_arc inta) (Num_arc int) = equal_int inta int;
equal_arctic MinInfty MinInfty = True;

instance Eq Arctic where {
  a == b = equal_arctic a b;
};

arctic_rec :: forall a. a -> (Int -> a) -> Arctic -> a;
arctic_rec f1 f2 MinInfty = f1;
arctic_rec f1 f2 (Num_arc int) = f2 int;

corder_arctic :: Maybe (Arctic -> Arctic -> Bool, Arctic -> Arctic -> Bool);
corder_arctic =
  Just ((\ x y ->
          arctic_rec
            (\ a -> (case a of {
                      MinInfty -> False;
                      Num_arc _ -> True;
                    }))
            (\ x_0 a ->
              (case a of {
                MinInfty -> False;
                Num_arc aa -> less_int x_0 aa;
              }))
            x y ||
            equal_arctic x y),
         arctic_rec
           (\ a -> (case a of {
                     MinInfty -> False;
                     Num_arc _ -> True;
                   }))
           (\ x_0 a ->
             (case a of {
               MinInfty -> False;
               Num_arc aa -> less_int x_0 aa;
             })));

instance Corder Arctic where {
  corder = corder_arctic;
};

zero_arctic :: Arctic;
zero_arctic = MinInfty;

instance Zero Arctic where {
  zeroa = zero_arctic;
};

plus_arctic :: Arctic -> Arctic -> Arctic;
plus_arctic MinInfty y = y;
plus_arctic (Num_arc v) MinInfty = Num_arc v;
plus_arctic (Num_arc x) (Num_arc y) = Num_arc (max x y);

instance Plus Arctic where {
  plus = plus_arctic;
};

set_impl_rat :: Phantom Rat Set_impl;
set_impl_rat = Phantom Set_RBT;

instance Set_impla Rat where {
  set_impl = set_impl_rat;
};

rat_linear_polya :: forall a. Interpretation a -> ((a, Nat), (Rat, [Rat]));
rat_linear_polya (Rat_linear_poly x) = x;

mini_alg_matrixa ::
  forall a.
    Interpretation a ->
      ((a, Nat), ([[Mini_alg_number]], [[[Mini_alg_number]]]));
mini_alg_matrixa (Mini_alg_matrix x) = x;

int_linear_polya :: forall a. Interpretation a -> ((a, Nat), (Int, [Int]));
int_linear_polya (Int_linear_poly x) = x;

arctic_rat_coeff :: Xml -> Sum_bot [Prelude.Char] (Arctic_delta Rat);
arctic_rat_coeff =
  options
    [(['i', 'n', 't', 'e', 'g', 'e', 'r'], change rat Num_arc_delta),
      (['r', 'a', 't', 'i', 'o', 'n', 'a', 'l'], change rat Num_arc_delta),
      (['m', 'i', 'n', 'u', 's', 'I', 'n', 'f', 'i', 'n', 'i', 't', 'y'],
        leaf ['m', 'i', 'n', 'u', 's', 'I', 'n', 'f', 'i', 'n', 'i', 't', 'y']
          MinInfty_delta)];

one_arctic :: Arctic;
one_arctic = Num_arc Zero_int;

instance One Arctic where {
  onea = one_arctic;
};

corder_int :: Maybe (Int -> Int -> Bool, Int -> Int -> Bool);
corder_int = Just (less_eq_int, less_int);

instance Corder Int where {
  corder = corder_int;
};

corder_rat :: Maybe (Rat -> Rat -> Bool, Rat -> Rat -> Bool);
corder_rat = Just (less_eq_rat, less_rat);

instance Corder Rat where {
  corder = corder_rat;
};

ceq_arctic :: Maybe (Arctic -> Arctic -> Bool);
ceq_arctic = Just equal_arctic;

instance Ceq Arctic where {
  ceq = ceq_arctic;
};

arctic_matrixa ::
  forall a. Interpretation a -> ((a, Nat), ([[Arctic]], [[[Arctic]]]));
arctic_matrixa (Arctic_matrix x) = x;

instance Dense_linorder Rat where {
};

instance Unbounded_dense_linorder Rat where {
};

instance Linordered_ab_semigroup_add Rat where {
};

instance Linordered_cancel_ab_semigroup_add Rat where {
};

instance Linordered_semiring Rat where {
};

instance Linordered_semiring_strict Rat where {
};

instance Linordered_semiring_1 Rat where {
};

instance Linordered_semiring_1_strict Rat where {
};

instance Ordered_ab_group_add_abs Rat where {
};

instance Linordered_ab_group_add Rat where {
};

instance Linordered_ring Rat where {
};

instance Linordered_ring_strict Rat where {
};

instance Ordered_comm_semiring Rat where {
};

instance Ordered_cancel_comm_semiring Rat where {
};

instance Linordered_comm_semiring_strict Rat where {
};

instance Linordered_semidom Rat where {
};

instance Ordered_comm_ring Rat where {
};

instance Ordered_ring_abs Rat where {
};

instance Linordered_idom Rat where {
};

instance Linordered_field Rat where {
};

arctic_coeff :: Xml -> Sum_bot [Prelude.Char] Arctic;
arctic_coeff =
  options
    [(['i', 'n', 't', 'e', 'g', 'e', 'r'],
       change (int ['i', 'n', 't', 'e', 'g', 'e', 'r']) Num_arc),
      (['m', 'i', 'n', 'u', 's', 'I', 'n', 'f', 'i', 'n', 'i', 't', 'y'],
        leaf ['m', 'i', 'n', 'u', 's', 'I', 'n', 'f', 'i', 'n', 'i', 't', 'y']
          MinInfty)];

ceq_rat :: Maybe (Rat -> Rat -> Bool);
ceq_rat = Just equal_rat;

instance Ceq Rat where {
  ceq = ceq_rat;
};

rat_matrixa :: forall a. Interpretation a -> ((a, Nat), ([[Rat]], [[[Rat]]]));
rat_matrixa (Rat_matrix x) = x;

int_matrixa :: forall a. Interpretation a -> ((a, Nat), ([[Int]], [[[Int]]]));
int_matrixa (Int_matrix x) = x;

cEnum_list ::
  forall a. Maybe ([[a]], (([a] -> Bool) -> Bool, ([a] -> Bool) -> Bool));
cEnum_list = Nothing;

instance Cenum [a] where {
  cEnum = cEnum_list;
};

vec_plusI :: forall a. (a -> a -> a) -> [a] -> [a] -> [a];
vec_plusI pl v w = map (\ xy -> pl (fst xy) (snd xy)) (zip v w);

mat_plusI :: forall a. (a -> a -> a) -> [[a]] -> [[a]] -> [[a]];
mat_plusI pl m1 m2 = map (\ uv -> vec_plusI pl (fst uv) (snd uv)) (zip m1 m2);

scalar_prodI ::
  forall a. a -> (a -> a -> a) -> (a -> a -> a) -> [a] -> [a] -> a;
scalar_prodI ze pl ti v w = foldr (\ (x, y) -> pl (ti x y)) (zip v w) ze;

matT_vec_multI ::
  forall a. a -> (a -> a -> a) -> (a -> a -> a) -> [[a]] -> [a] -> [a];
matT_vec_multI ze pl ti m v = map (\ w -> scalar_prodI ze pl ti w v) m;

transpose :: forall a. Nat -> [[a]] -> [[a]];
transpose nr [] = replicate nr [];
transpose nr (v : m) = map (\ (a, b) -> a : b) (zip v (transpose nr m));

mat_multI ::
  forall a.
    a -> (a -> a -> a) -> (a -> a -> a) -> Nat -> [[a]] -> [[a]] -> [[a]];
mat_multI ze pl ti nr m1 m2 =
  map (matT_vec_multI ze pl ti (transpose nr m1)) m2;

mat_ring ::
  forall a b.
    (One b, Plus b, Times b,
      Zero b) => Nat ->
                   a -> Partial_object_ext [[b]]
                          (Monoid_ext [[b]] (Ring_ext [[b]] a));
mat_ring n b =
  Partial_object_ext (collect (mat n n))
    (Monoid_ext (mat_multI zeroa plus times n) (mat1I zeroa onea n)
      (Ring_ext (mat0I zeroa n n) (mat_plusI plus) b));

polynomial ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Tpoly Nat a);
polynomial xml2coeff x =
  singleton ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l']
    (options
      [(['c', 'o', 'e', 'f', 'f', 'i', 'c', 'i', 'e', 'n', 't'],
         singleton ['c', 'o', 'e', 'f', 'f', 'i', 'c', 'i', 'e', 'n', 't']
           xml2coeff PNum),
        (['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e'],
          change (nata ['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e'])
            (\ n -> PVar (minus_nat n (Nat_of_num One)))),
        (['s', 'u', 'm'], many ['s', 'u', 'm'] (polynomial xml2coeff) PSum),
        (['p', 'r', 'o', 'd', 'u', 'c', 't'],
          many ['p', 'r', 'o', 'd', 'u', 'c', 't'] (polynomial xml2coeff)
            PMult)])
    id x;

fit_length ::
  forall a.
    Partial_object_ext a (Monoid_ext a (Ring_ext a ())) -> Nat -> [a] -> [a];
fit_length c n uu =
  (if equal_nat n Zero_nat then []
    else (case uu of {
           [] -> replicate
                   (plus_nat (minus_nat n (Nat_of_num One)) (Nat_of_num One))
                   (zero c);
           b : bs -> b : fit_length c (minus_nat n (Nat_of_num One)) bs;
         }));

set_impl_int :: Phantom Int Set_impl;
set_impl_int = Phantom Set_RBT;

instance Set_impla Int where {
  set_impl = set_impl_int;
};

ceq_int :: Maybe (Int -> Int -> Bool);
ceq_int = Just equal_int;

instance Ceq Int where {
  ceq = ceq_int;
};

interpretation ::
  forall a.
    Bool ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        Xml -> Sum_bot [Prelude.Char] (Redtriple_impl a);
interpretation bi xml2name =
  many1_gen
    ['i', 'n', 't', 'e', 'r', 'p', 'r', 'e', 't', 'a', 't', 'i', 'o', 'n']
    interpretation_type
    (\ a ->
      (case a of {
        Natural deg ->
          (if less_eq_nat deg (Nat_of_num One) && not bi
            then triple ['i', 'n', 't', 'e', 'r', 'p', 'r', 'e', 't'] xml2name
                   (nata ['a', 'r', 'i', 't', 'y'])
                   (\ x ->
                     binda (polynomial int_coeff x)
                       (lpoly_of (class_semiring Type ())))
                   (\ f aa poly ->
                     Int_linear_poly
                       ((f, aa),
                         (fst poly,
                           fit_length (class_semiring Type ()) aa (snd poly))))
            else triple ['i', 'n', 't', 'e', 'r', 'p', 'r', 'e', 't'] xml2name
                   (nata ['a', 'r', 'i', 't', 'y'])
                   (\ x ->
                     binda (polynomial int_coeff x)
                       (\ p -> returna (poly_of p)))
                   (\ f aa poly -> Int_non_linear_poly ((f, aa), poly)));
        Integera ->
          triple ['i', 'n', 't', 'e', 'r', 'p', 'r', 'e', 't'] xml2name
            (nata ['a', 'r', 'i', 't', 'y'])
            (\ x -> binda (polynomial int_coeff x) (\ p -> returna (poly_of p)))
            (\ f aa poly -> Int_non_linear_poly ((f, aa), poly));
        Arctic ->
          triple ['i', 'n', 't', 'e', 'r', 'p', 'r', 'e', 't'] xml2name
            (nata ['a', 'r', 'i', 't', 'y'])
            (\ x ->
              binda (polynomial arctic_coeff x)
                (lpoly_of (class_semiring Type ())))
            (\ f aa poly ->
              Arctic_linear_poly
                ((f, aa),
                  (fst poly,
                    fit_length (class_semiring Type ()) aa (snd poly))));
        Arctic_rat ->
          triple ['i', 'n', 't', 'e', 'r', 'p', 'r', 'e', 't'] xml2name
            (nata ['a', 'r', 'i', 't', 'y'])
            (\ x ->
              binda (polynomial arctic_rat_coeff x)
                (lpoly_of (class_semiring Type ())))
            (\ f aa poly ->
              Arctic_rat_linear_poly
                ((f, aa),
                  (fst poly,
                    fit_length (class_semiring Type ()) aa (snd poly))));
        Int_mat n _ ->
          triple ['i', 'n', 't', 'e', 'r', 'p', 'r', 'e', 't'] xml2name
            (nata ['a', 'r', 'i', 't', 'y'])
            (\ x ->
              binda (polynomial (mat_coeff Zero_int int_coeff) x)
                (lpoly_of (mat_ring n ())))
            (\ f aa poly ->
              Int_matrix
                ((f, aa),
                  (fst poly, fit_length (mat_ring n ()) aa (snd poly))));
        Arc_mat n ->
          triple ['i', 'n', 't', 'e', 'r', 'p', 'r', 'e', 't'] xml2name
            (nata ['a', 'r', 'i', 't', 'y'])
            (\ x ->
              binda (polynomial (mat_coeff MinInfty arctic_coeff) x)
                (lpoly_of (mat_ring n ())))
            (\ f aa poly ->
              Arctic_matrix
                ((f, aa),
                  (fst poly, fit_length (mat_ring n ()) aa (snd poly))));
        Arc_rat_mat n ->
          triple ['i', 'n', 't', 'e', 'r', 'p', 'r', 'e', 't'] xml2name
            (nata ['a', 'r', 'i', 't', 'y'])
            (\ x ->
              binda (polynomial (mat_coeff MinInfty_delta arctic_rat_coeff) x)
                (lpoly_of (mat_ring n ())))
            (\ f aa poly ->
              Arctic_rat_matrix
                ((f, aa),
                  (fst poly, fit_length (mat_ring n ()) aa (snd poly))));
        Rational _ deg ->
          (if less_eq_nat deg (Nat_of_num One) && not bi
            then triple ['i', 'n', 't', 'e', 'r', 'p', 'r', 'e', 't'] xml2name
                   (nata ['a', 'r', 'i', 't', 'y'])
                   (\ x ->
                     binda (polynomial rat x)
                       (lpoly_of (class_semiring Type ())))
                   (\ f aa poly ->
                     Rat_linear_poly
                       ((f, aa),
                         (fst poly,
                           fit_length (class_semiring Type ()) aa (snd poly))))
            else triple ['i', 'n', 't', 'e', 'r', 'p', 'r', 'e', 't'] xml2name
                   (nata ['a', 'r', 'i', 't', 'y'])
                   (\ x ->
                     binda (polynomial rat x) (\ p -> returna (poly_of p)))
                   (\ f aa poly -> Rat_non_linear_poly ((f, aa), poly)));
        Rat_mat n _ ->
          triple ['i', 'n', 't', 'e', 'r', 'p', 'r', 'e', 't'] xml2name
            (nata ['a', 'r', 'i', 't', 'y'])
            (\ x ->
              binda (polynomial (mat_coeff zero_rat rat) x)
                (lpoly_of (mat_ring n ())))
            (\ f aa poly ->
              Rat_matrix
                ((f, aa),
                  (fst poly, fit_length (mat_ring n ()) aa (snd poly))));
        Mini_Alg _ deg ->
          (if less_eq_nat deg (Nat_of_num One) && not bi
            then triple ['i', 'n', 't', 'e', 'r', 'p', 'r', 'e', 't'] xml2name
                   (nata ['a', 'r', 'i', 't', 'y'])
                   (\ x ->
                     binda (polynomial mini_alg x)
                       (lpoly_of (class_semiring Type ())))
                   (\ f aa poly ->
                     Mini_alg_linear_poly
                       ((f, aa),
                         (fst poly,
                           fit_length (class_semiring Type ()) aa (snd poly))))
            else triple ['i', 'n', 't', 'e', 'r', 'p', 'r', 'e', 't'] xml2name
                   (nata ['a', 'r', 'i', 't', 'y'])
                   (\ x ->
                     binda (polynomial mini_alg x) (\ p -> returna (poly_of p)))
                   (\ f aa poly -> Mini_alg_non_linear_poly ((f, aa), poly)));
        Mini_Alg_mat n _ ->
          triple ['i', 'n', 't', 'e', 'r', 'p', 'r', 'e', 't'] xml2name
            (nata ['a', 'r', 'i', 't', 'y'])
            (\ x ->
              binda (polynomial (mat_coeff zero_mini_alg_number mini_alg) x)
                (lpoly_of (mat_ring n ())))
            (\ f aa poly ->
              Mini_alg_matrix
                ((f, aa),
                  (fst poly, fit_length (mat_ring n ()) aa (snd poly))));
      }))
    (\ typea pi ->
      (case typea of {
        Natural deg ->
          (if less_eq_nat deg (Nat_of_num One) && not bi
            then Int_carrier (map int_linear_polya pi)
            else Int_nl_carrier (map int_non_linear_polya pi));
        Integera -> Int_nl_carrier (map int_non_linear_polya pi);
        Arctic -> Arctic_carrier (map arctic_linear_polya pi);
        Arctic_rat -> Arctic_rat_carrier (map arctic_rat_linear_polya pi);
        Int_mat n sd -> Int_mat_carrier n sd (map int_matrixa pi);
        Arc_mat n -> Arc_mat_carrier n (map arctic_matrixa pi);
        Arc_rat_mat n -> Arc_rat_mat_carrier n (map arctic_rat_matrixa pi);
        Rational d deg ->
          (if less_eq_nat deg (Nat_of_num One) && not bi
            then Rat_carrier (map rat_linear_polya pi)
            else Rat_nl_carrier d (map rat_non_linear_polya pi));
        Rat_mat n sd -> Rat_mat_carrier n sd (map rat_matrixa pi);
        Mini_Alg d deg ->
          (if less_eq_nat deg (Nat_of_num One) && not bi
            then Mini_alg_carrier (map mini_alg_linear_polya pi)
            else Mini_alg_nl_carrier d (map mini_alg_non_linear_polya pi));
        Mini_Alg_mat n sd ->
          Mini_alg_mat_carrier n sd (map mini_alg_matrixa pi);
      }));

status_precedence ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] [((a, Nat), (Nat, Order_tag))];
status_precedence xml2name =
  many ['s', 't', 'a', 't', 'u', 's', 'P', 'r', 'e', 'c', 'e', 'd', 'e', 'n',
         'c', 'e']
    (tuple4
      ['s', 't', 'a', 't', 'u', 's', 'P', 'r', 'e', 'c', 'e', 'd', 'e', 'n',
        'c', 'e', 'E', 'n', 't', 'r', 'y']
      xml2name (nata ['a', 'r', 'i', 't', 'y'])
      (nata ['p', 'r', 'e', 'c', 'e', 'd', 'e', 'n', 'c', 'e'])
      (options
        [(['l', 'e', 'x'], leaf ['l', 'e', 'x'] Lex),
          (['m', 'u', 'l'], leaf ['m', 'u', 'l'] Mul)])
      (\ f a p s -> ((f, a), (p, s))))
    id;

xml1to2elements ::
  forall a b c.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (Xml -> Sum_bot [Prelude.Char] b) ->
          (a -> Maybe b -> c) -> Xml -> Sum_bot [Prelude.Char] c;
xml1to2elements tag p1 p2 f (Xml name atts cs text) =
  let {
    l = size_list cs;
  } in (if name == tag &&
             null atts &&
               less_eq_nat (Nat_of_num One) l &&
                 less_eq_nat l (Nat_of_num (Bit0 One)) && is_none text
         then binda (p1 (nth cs Zero_nat))
                (\ x1 ->
                  (if equal_nat l (Nat_of_num (Bit0 One))
                    then binda (p2 (nth cs (Nat_of_num One)))
                           (\ x2 -> returna (f x1 (Just x2)))
                    else returna (f x1 Nothing)))
         else fail tag (Xml name atts cs text));

path_order ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Redtriple_impl a);
path_order xml2name =
  xml1to2elements ['p', 'a', 't', 'h', 'O', 'r', 'd', 'e', 'r']
    (status_precedence xml2name) (afs xml2name)
    (\ prec_tau afo ->
      let {
        a = (case afo of {
              Nothing -> [];
              Just af -> af;
            });
      } in Rpo prec_tau a);

redtriple ::
  forall a.
    Bool ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        Xml -> Sum_bot [Prelude.Char] (Redtriple_impl a);
redtriple bi xml2name =
  singleton ['r', 'e', 'd', 'P', 'a', 'i', 'r']
    (options
      [(['i', 'n', 't', 'e', 'r', 'p', 'r', 'e', 't', 'a', 't', 'i', 'o', 'n'],
         interpretation bi xml2name),
        (['p', 'a', 't', 'h', 'O', 'r', 'd', 'e', 'r'], path_order xml2name),
        (['k', 'n', 'u', 't', 'h', 'B', 'e', 'n', 'd', 'i', 'x', 'O', 'r', 'd',
           'e', 'r'],
          knuth_bendix_order xml2name)])
    id;

signature ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] [(a, Nat)];
signature xml2name =
  many ['s', 'i', 'g', 'n', 'a', 't', 'u', 'r', 'e']
    (pair ['s', 'y', 'm', 'b', 'o', 'l'] xml2name
      (nata ['a', 'r', 'i', 't', 'y']) (\ a b -> (a, b)))
    id;

joinable_critical_pairs ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          [(Term a [Prelude.Char],
             ([(Pos, ((Term a [Prelude.Char], Term a [Prelude.Char]),
                       Term a [Prelude.Char]))],
               (Term a [Prelude.Char],
                 [(Pos, ((Term a [Prelude.Char], Term a [Prelude.Char]),
                          Term a [Prelude.Char]))])))];
joinable_critical_pairs xml2name =
  let {
    rew = rsteps xml2name;
  } in many ['j', 'o', 'i', 'n', 'a', 'b', 'l', 'e', 'C', 'r', 'i', 't', 'i',
              'c', 'a', 'l', 'P', 'a', 'i', 'r', 's']
         (pair ['j', 'o', 'i', 'n', 'a', 'b', 'l', 'e', 'C', 'r', 'i', 't', 'i',
                 'c', 'a', 'l', 'P', 'a', 'i', 'r']
           rew rew (\ (s, sseq) (t, tseq) -> (s, (sseq, (t, tseq)))))
         id;

wcr_proof ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Join_info a);
wcr_proof xml2name =
  singleton ['w', 'c', 'r', 'P', 'r', 'o', 'o', 'f']
    (options
      [(['j', 'o', 'i', 'n', 'a', 'b', 'l', 'e', 'C', 'r', 'i', 't', 'i', 'c',
          'a', 'l', 'P', 'a', 'i', 'r', 's'],
         change (joinable_critical_pairs xml2name) Guided),
        (['j', 'o', 'i', 'n', 'a', 'b', 'l', 'e', 'C', 'r', 'i', 't', 'i', 'c',
           'a', 'l', 'P', 'a', 'i', 'r', 's', 'B', 'F', 'S'],
          change
            (nata ['j', 'o', 'i', 'n', 'a', 'b', 'l', 'e', 'C', 'r', 'i', 't',
                    'i', 'c', 'a', 'l', 'P', 'a', 'i', 'r', 's', 'B', 'F', 'S'])
            Join_BFS),
        (['j', 'o', 'i', 'n', 'a', 'b', 'l', 'e', 'C', 'r', 'i', 't', 'i', 'c',
           'a', 'l', 'P', 'a', 'i', 'r', 's', 'A', 'u', 't', 'o'],
          leaf ['j', 'o', 'i', 'n', 'a', 'b', 'l', 'e', 'C', 'r', 'i', 't', 'i',
                 'c', 'a', 'l', 'P', 'a', 'i', 'r', 's', 'A', 'u', 't', 'o']
            Join_NF)])
    id;

xml2equational_input ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          ([(Term a [Prelude.Char], Term a [Prelude.Char])],
            (Term a [Prelude.Char], Term a [Prelude.Char]));
xml2equational_input xml2name =
  pair ['e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 'a', 'l', 'R', 'e', 'a', 's',
         'o', 'n', 'i', 'n', 'g', 'I', 'n', 'p', 'u', 't']
    (singleton ['e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 's'] (rules xml2name)
      id)
    (pair ['e', 'q', 'u', 'a', 't', 'i', 'o', 'n'] (term xml2name)
      (term xml2name) (\ a b -> (a, b)))
    (\ a b -> (a, b));

complexity_measure ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Complexity_measure a [Prelude.Char]);
complexity_measure xml2name =
  options
    [(['d', 'e', 'r', 'i', 'v', 'a', 't', 'i', 'o', 'n', 'a', 'l', 'C', 'o',
        'm', 'p', 'l', 'e', 'x', 'i', 't', 'y'],
       singleton
         ['d', 'e', 'r', 'i', 'v', 'a', 't', 'i', 'o', 'n', 'a', 'l', 'C', 'o',
           'm', 'p', 'l', 'e', 'x', 'i', 't', 'y']
         (signature xml2name) Derivational_Complexity),
      (['r', 'u', 'n', 't', 'i', 'm', 'e', 'C', 'o', 'm', 'p', 'l', 'e', 'x',
         'i', 't', 'y'],
        pair ['r', 'u', 'n', 't', 'i', 'm', 'e', 'C', 'o', 'm', 'p', 'l', 'e',
               'x', 'i', 't', 'y']
          (signature xml2name) (signature xml2name) Runtime_Complexity)];

complexity_class :: Xml -> Sum_bot [Prelude.Char] Complexity_class;
complexity_class =
  change (nata ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l']) Comp_Poly;

i_o_strategy ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          (Sum (Strategy a [Prelude.Char]) (Ostrategy a [Prelude.Char]));
i_o_strategy xml2name =
  singleton ['s', 't', 'r', 'a', 't', 'e', 'g', 'y']
    (options
      [(['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't'],
         leaf ['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't'] (Inl Innermost)),
        (['o', 'u', 't', 'e', 'r', 'm', 'o', 's', 't'],
          leaf ['o', 'u', 't', 'e', 'r', 'm', 'o', 's', 't'] (Inr Outermost)),
        (['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't', 'L', 'h', 's', 's'],
          change (innermostLhss xml2name) (\ q -> Inl (Innermost_Q q)))])
    id;

xml2i_o_trs_input ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          (Sum (Strategy a [Prelude.Char]) (Ostrategy a [Prelude.Char]),
            ([(Term a [Prelude.Char], Term a [Prelude.Char])],
              Maybe [(Term a [Prelude.Char], Term a [Prelude.Char])]));
xml2i_o_trs_input xml2name =
  (\ x ->
    let {
      e = fail ['t', 'r', 's', 'I', 'n', 'p', 'u', 't'] x;
    } in (case x of {
           Xml taga [] [] option -> e;
           Xml taga [] (c : cs) Nothing ->
             (if less_eq_nat (size_list cs) (Nat_of_num (Bit0 One)) &&
                   taga == ['t', 'r', 's', 'I', 'n', 'p', 'u', 't']
               then binda (singleton ['t', 'r', 's'] (rules xml2name) id c)
                      (\ r ->
                        binda (if null cs ||
                                    not (tag (hd cs) ==
  ['s', 't', 'r', 'a', 't', 'e', 'g', 'y'])
                                then returna (Inl No_Strategy, cs)
                                else binda (i_o_strategy xml2name (hd cs))
                                       (\ s -> returna (s, tl cs)))
                          (\ (str, csa) ->
                            binda (if null csa ||
not (tag (hd csa) ==
      ['r', 'e', 'l', 'a', 't', 'i', 'v', 'e', 'R', 'u', 'l', 'e', 's'])
                                    then returna (Nothing, csa)
                                    else binda
   (singleton ['r', 'e', 'l', 'a', 't', 'i', 'v', 'e', 'R', 'u', 'l', 'e', 's']
     (rules xml2name) id (hd csa))
   (\ s -> returna (Just s, tl csa)))
                              (\ (s_opt, csb) ->
                                (if null csb then returna (str, (r, s_opt))
                                  else e))))
               else e);
           Xml taga [] (c : cs) (Just _) -> e;
           Xml taga (_ : _) list3 option -> e;
         }));

xml2trs_input ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          (Strategy a [Prelude.Char],
            ([(Term a [Prelude.Char], Term a [Prelude.Char])],
              Maybe [(Term a [Prelude.Char], Term a [Prelude.Char])]));
xml2trs_input xml2name x =
  binda (xml2i_o_trs_input xml2name x)
    (\ a ->
      (case a of {
        (Inl is, (r, s)) -> returna (is, (r, s));
        (Inr _, (r, s)) ->
          errora
            ['o', 'u', 't', 'e', 'r', 'm', 'o', 's', 't', ' ', 's', 't', 'r',
              'a', 't', 'e', 'g', 'y', ' ', 'n', 'o', 't', ' ', 's', 'u', 'p',
              'p', 'o', 'r', 't', 'e', 'd', ' ', 'a', 't', ' ', 't', 'h', 'i',
              's', ' ', 'p', 'o', 'i', 'n', 't'];
      }));

xml2complexity_input ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          (Strategy a [Prelude.Char],
            ([(Term a [Prelude.Char], Term a [Prelude.Char])],
              (Maybe [(Term a [Prelude.Char], Term a [Prelude.Char])],
                (Complexity_measure a [Prelude.Char], Complexity_class))));
xml2complexity_input xml2name =
  triple
    ['c', 'o', 'm', 'p', 'l', 'e', 'x', 'i', 't', 'y', 'I', 'n', 'p', 'u', 't']
    (xml2trs_input xml2name) (complexity_measure xml2name) complexity_class
    (\ (q, (r, s)) cm cc -> (q, (r, (s, (cm, cc)))));

xml2completion_input ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          ([(Term a [Prelude.Char], Term a [Prelude.Char])],
            [(Term a [Prelude.Char], Term a [Prelude.Char])]);
xml2completion_input xml2name =
  pair ['c', 'o', 'm', 'p', 'l', 'e', 't', 'i', 'o', 'n', 'I', 'n', 'p', 'u',
         't']
    (singleton ['e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 's'] (rules xml2name)
      id)
    (singleton ['t', 'r', 's'] (rules xml2name) id) (\ a b -> (a, b));

forbidden_pattern ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          (Ctxt a [Prelude.Char], (Term a [Prelude.Char], Location));
forbidden_pattern xml2name xml =
  binda (triple
          ['f', 'o', 'r', 'b', 'i', 'd', 'd', 'e', 'n', 'P', 'a', 't', 't', 'e',
            'r', 'n']
          (term xml2name) pos
          (options
            [(['h', 'e', 'r', 'e'], leaf ['h', 'e', 'r', 'e'] H),
              (['a', 'b', 'o', 'v', 'e'], leaf ['a', 'b', 'o', 'v', 'e'] A),
              (['b', 'e', 'l', 'o', 'w'], leaf ['b', 'e', 'l', 'o', 'w'] Ba)])
          (\ t p l -> (t, (p, l))) xml)
    (\ (t, (p, l)) ->
      (if in_poss p t then returna (ctxt_of_pos_term p t, (subt_at t p, l))
        else errora
               ['p', 'o', 's', 'i', 't', 'i', 'o', 'n', ' ', 'd', 'o', 'e', 's',
                 ' ', 'n', 'o', 't', ' ', 'e', 'x', 'i', 's', 't', ' ', 'i',
                 'n', ' ', 't', 'e', 'r', 'm']));

forbidden_patterns ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          [(Ctxt a [Prelude.Char], (Term a [Prelude.Char], Location))];
forbidden_patterns xml2name =
  many ['f', 'o', 'r', 'b', 'i', 'd', 'd', 'e', 'n', 'P', 'a', 't', 't', 'e',
         'r', 'n', 's']
    (forbidden_pattern xml2name) id;

xml2fptrs_input ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          ([(Term a [Prelude.Char], Term a [Prelude.Char])],
            [(Ctxt a [Prelude.Char], (Term a [Prelude.Char], Location))]);
xml2fptrs_input xml2name =
  pair ['t', 'r', 's', 'I', 'n', 'p', 'u', 't']
    (singleton ['t', 'r', 's'] (rules xml2name) id)
    (singleton ['s', 't', 'r', 'a', 't', 'e', 'g', 'y']
      (forbidden_patterns xml2name) id)
    (\ a b -> (a, b));

xml2otrs_input ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          (Ostrategy a [Prelude.Char],
            [(Term a [Prelude.Char], Term a [Prelude.Char])]);
xml2otrs_input xml2name x =
  binda (xml2i_o_trs_input xml2name x)
    (\ (ios, (r, s)) ->
      (case (ios, s) of {
        (Inl _, b) ->
          errora
            ['n', 'o', 't', ' ', 'a', 'n', ' ', 'o', 'u', 't', 'e', 'r', 'm',
              'o', 's', 't', ' ', 's', 't', 'r', 'a', 't', 'e', 'g', 'y', ' ',
              'o', 'r', ' ', 'r', 'e', 'l', 'a', 't', 'i', 'v', 'e', ' ', 'r',
              'u', 'l', 'e', 's', ' ', 'p', 'r', 'e', 's', 'e', 'n', 't'];
        (Inr os, Nothing) -> returna (os, r);
        (Inr os, Just _) ->
          errora
            ['n', 'o', 't', ' ', 'a', 'n', ' ', 'o', 'u', 't', 'e', 'r', 'm',
              'o', 's', 't', ' ', 's', 't', 'r', 'a', 't', 'e', 'g', 'y', ' ',
              'o', 'r', ' ', 'r', 'e', 'l', 'a', 't', 'i', 'v', 'e', ' ', 'r',
              'u', 'l', 'e', 's', ' ', 'p', 'r', 'e', 's', 'e', 'n', 't'];
      }));

xml2ctrs_input ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          [((Term a [Prelude.Char], Term a [Prelude.Char]),
             [(Term a [Prelude.Char], Term a [Prelude.Char])])];
xml2ctrs_input xml2name =
  singleton ['c', 't', 'r', 's', 'I', 'n', 'p', 'u', 't'] (crules xml2name) id;

xml2dp_input ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          (Bool,
            ([(Term a [Prelude.Char], Term a [Prelude.Char])],
              (Strategy a [Prelude.Char],
                [(Term a [Prelude.Char], Term a [Prelude.Char])])));
xml2dp_input xml2name =
  guard (\ x -> equal_nat (num_children x) (Nat_of_num (Bit0 (Bit0 One))))
    (tuple4 ['d', 'p', 'I', 'n', 'p', 'u', 't']
      (singleton ['t', 'r', 's'] (rules xml2name) id)
      (singleton ['d', 'p', 's'] (rules xml2name) id) (strategy xml2name)
      (bool ['m', 'i', 'n', 'i', 'm', 'a', 'l'])
      (\ r p s m -> (m, (p, (s, r)))))
    (triple ['d', 'p', 'I', 'n', 'p', 'u', 't']
      (singleton ['t', 'r', 's'] (rules xml2name) id)
      (singleton ['d', 'p', 's'] (rules xml2name) id)
      (bool ['m', 'i', 'n', 'i', 'm', 'a', 'l'])
      (\ r p m -> (m, (p, (No_Strategy, r)))));

xml2input ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Input a [Prelude.Char]);
xml2input xml2name =
  singleton ['i', 'n', 'p', 'u', 't']
    (choice ['i', 'n', 'p', 'u', 't']
      [change (xml2dp_input xml2name) DP_input,
        change (xml2trs_input xml2name) TRS_input,
        change (xml2completion_input xml2name) COMP_input,
        change (xml2equational_input xml2name) EQ_input,
        change (xml2complexity_input xml2name) CPX_input,
        change (xml2otrs_input xml2name) OTRS_input,
        change (xml2fptrs_input xml2name) FPTRS_input,
        change (xml2ctrs_input xml2name) CTRS_input])
    id;

xml_crule ::
  forall a b c.
    (Showa a, Showa b,
      Showa c) => ((Term (Lab a [b]) c, Term (Lab a [b]) c),
                    [(Term (Lab a [b]) c, Term (Lab a [b]) c)]) ->
                    Xml;
xml_crule =
  (\ (c, rs) ->
    Xml ['c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n', 'a', 'l', 'R', 'u', 'l',
          'e']
      [] (map xml_rule (c : rs)) Nothing);

xml_rules ::
  forall a b c.
    (Showa a, Showa b,
      Showa c) => [Prelude.Char] ->
                    [(Term (Lab a [b]) c, Term (Lab a [b]) c)] -> Xml;
xml_rules tag rls =
  Xml tag [] [Xml ['r', 'u', 'l', 'e', 's'] [] (map xml_rule rls) Nothing]
    Nothing;

gen_list_to_set_aux :: forall a b. (a -> b -> b) -> b -> [a] -> b;
gen_list_to_set_aux ins accs [] = accs;
gen_list_to_set_aux ins accs (x : l) = gen_list_to_set_aux ins (ins x accs) l;

gen_list_to_set :: forall a b. (() -> a) -> (b -> a -> a) -> [b] -> a;
gen_list_to_set empt ins = gen_list_to_set_aux ins (empt ());

list_to_rs :: forall a. (Linorder a) => [a] -> Rbt a ();
list_to_rs = gen_list_to_set rs_empty rs_ins;

ceta_set_of :: forall a. (Key a) => [a] -> a -> Bool;
ceta_set_of ps = let {
                   tree = list_to_rs ps;
                 } in (\ a -> rs_memb a tree);

icap_impla ::
  forall a.
    (Eq a,
      Key a) => [(Term a [Prelude.Char], Term a [Prelude.Char])] ->
                  [Term a [Prelude.Char]] ->
                    [Term a [Prelude.Char]] ->
                      Term a [Prelude.Char] -> Term a (Sum () [Prelude.Char]);
icap_impla r q =
  let {
    ls = map fst r;
    isnf = is_NF (any is_Var q) q (term_map q);
    nf = nF_subset ls q;
    ic = icap_impl nf isnf ls;
  } in (\ s ->
         let {
           sa = map (map_vars (\ a -> 'x' : a)) s;
           sx = ceta_set_of (concatMap vars_term_lista sa);
         } in (\ t -> ic sa sx (map_vars (\ a -> 'x' : a) t)));

newtype Subst_incr f v = Abs_subst_incr
  (v -> Term f v, (Set v, Term f v -> [v]));

rep_subst_incr ::
  forall f v. Subst_incr f v -> (v -> Term f v, (Set v, Term f v -> [v]));
rep_subst_incr (Abs_subst_incr x) = x;

si_W :: forall a b. Subst_incr a b -> Term a b -> [b];
si_W x = snd (snd (rep_subst_incr x));

kbo_nstrict ::
  forall a b.
    (Showa a, Eq b,
      Showa b) => ((a, Nat) -> Nat) ->
                    ((a, Nat) -> Nat) ->
                      Nat ->
                        (a -> Bool) ->
                          ((a, Nat) -> Nat -> Nat) ->
                            (Term a b, Term a b) ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ();
kbo_nstrict pr w w0 least scf =
  (\ (s, t) ->
    check (snd (kbo_impl w w0 pr least scf s t))
      (shows_string
         ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'o', 'r', 'i', 'e',
           'n', 't', ' '] .
        shows_prec_term Zero_nat s .
          shows_string [' ', '>', '=', 'K', 'B', 'O', ' '] .
            shows_prec_term Zero_nat t . shows_nl));

sub_vec :: forall a. Nat -> [a] -> [a];
sub_vec = take;

sub_mat :: forall a. Nat -> Nat -> [[a]] -> [[a]];
sub_mat nr nc m = map (sub_vec nr) (take nc m);

geq ::
  forall a b.
    Partial_object_ext a
      (Monoid_ext a (Ring_ext a (Ordered_semiring_ext a b))) ->
      a -> a -> Bool;
geq (Partial_object_ext carrier
      (Monoid_ext mult one
        (Ring_ext zero add (Ordered_semiring_ext geq gt max more))))
  = geq;

maxa ::
  forall a b.
    Partial_object_ext a
      (Monoid_ext a (Ring_ext a (Ordered_semiring_ext a b))) ->
      a -> a -> a;
maxa (Partial_object_ext carrier
       (Monoid_ext mult one
         (Ring_ext zero add (Ordered_semiring_ext geq gt max more))))
  = max;

default_I :: forall a. (Poly_carrier a) => a -> Nat -> [([(Nat, Nat)], a)];
default_I def n =
  ([], def) : map (\ i -> ([(i, Nat_of_num One)], onea)) (upt Zero_nat n);

eval_monom :: forall a b. (Comm_semiring_1 b) => (a -> b) -> [(a, Nat)] -> b;
eval_monom alpha [] = onea;
eval_monom alpha ((x, p) : m) = times (eval_monom alpha m) (power (alpha x) p);

eval_poly ::
  forall a b. (Comm_semiring_1 b) => (a -> b) -> [([(a, Nat)], b)] -> b;
eval_poly alpha [] = zeroa;
eval_poly alpha (mc : p) =
  plus (times (eval_monom alpha (fst mc)) (snd mc)) (eval_poly alpha p);

poly_vars :: forall a b. [([(a, Nat)], b)] -> Set a;
poly_vars p = set (concatMap (map fst . fst) p);

proper_prefix_list :: Pos -> [Pos];
proper_prefix_list Empty = [];
proper_prefix_list (PCons i p) = Empty : map (PCons i) (proper_prefix_list p);

prefix_list :: Pos -> [Pos];
prefix_list p = p : proper_prefix_list p;

rm_delete :: forall a b. (Linorder a) => a -> Rbt a b -> Rbt a b;
rm_delete = delete;

rs_delete :: forall a. (Linorder a) => a -> Rbt a () -> Rbt a ();
rs_delete = rm_delete;

class (Poly_carrier a) => Large_ordered_semiring_1 a where {
};

class (Linordered_field a) => Archimedean_field a where {
};

class (Archimedean_field a,
        Large_ordered_semiring_1 a) => Floor_ceiling a where {
  floor :: a -> Int;
};

instance Large_ordered_semiring_1 Rat where {
};

instance Archimedean_field Rat where {
};

instance Floor_ceiling Rat where {
  floor = floor_rat;
};

scnp_arity :: forall a. [((a, Nat), [(Nat, Nat)])] -> Nat;
scnp_arity af = max_list (map (\ (_, a) -> size_list a) af);

it_set_to_list ::
  forall a b.
    (a -> ([b] -> Bool) -> (b -> [b] -> [b]) -> [b] -> [b]) -> a -> [b];
it_set_to_list iti s = iti s (\ _ -> True) (\ a b -> a : b) [];

check_supt ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => Term a b ->
                    Term a b -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_supt s t =
  check (supt_impl s t)
    (shows_prec_term Zero_nat t .
      shows_string
        [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'p', 'r', 'o', 'p',
          'e', 'r', ' ', 's', 'u', 'b', 't', 'e', 'r', 'm', ' ', 'o', 'f',
          ' '] .
        shows_prec_term Zero_nat s);

shows_ctxt ::
  forall a b.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      (b -> [Prelude.Char] -> [Prelude.Char]) ->
        Ctxt a b -> [Prelude.Char] -> [Prelude.Char];
shows_ctxt fun var Hole = shows_string ['[', ']'];
shows_ctxt fun var (More f ss1 d ss2) =
  fun f .
    shows_string ['('] .
      shows_list_gen (shows_term fun var) [] [] [',', ' '] [',', ' '] ss1 .
        shows_ctxt fun var d .
          shows_list_gen (shows_term fun var) [')'] [',', ' '] [',', ' '] [')']
            ss2;

desca :: forall a b c. Redtriple_ext a b c -> [Prelude.Char] -> [Prelude.Char];
desca (Redtriple_ext valid s ns nst af mono desc cpx more) = desc;

mono ::
  forall a b c.
    Redtriple_ext a b c ->
      [(Term a b, Term a b)] -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
mono (Redtriple_ext valid s ns nst af mono desc cpx more) = mono;

nsta ::
  forall a b c.
    Root_redtriple_ext a b c ->
      (Term a b, Term a b) -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
nsta (Root_redtriple_ext valid s ns nst af aft desc more) = nst;

eq_rule_mod_vars ::
  forall a b.
    (Eq a, Eq b) => (Term a b, Term a b) -> (Term a b, Term a b) -> Bool;
eq_rule_mod_vars lr st = instance_rule lr st && instance_rule st lr;

generate_var :: Nat -> [Prelude.Char];
generate_var i = 'x' : shows_prec_nat Zero_nat i [];

uncurry_term ::
  forall a b. (Eq a) => a -> (a -> Nat -> [a]) -> Term a b -> Term a b;
uncurry_term a sm t =
  (case unapp a t of {
    (Var x, ts) -> apply_args a (Var x) (map (uncurry_term a sm) ts);
    (Fun f ss, ts) ->
      let {
        n = size_list ss;
        uss = map (uncurry_term a sm) ss;
        uts = map (uncurry_term a sm) ts;
        aa = aarity sm f n;
        m = min (size_list ts) aa;
        fm = get_symbol sm f n m;
      } in apply_args a (Fun fm (uss ++ take m uts)) (drop m uts);
  });

data Filtered a = FPair a Nat;

conversion ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          [(Pos, ((Term a [Prelude.Char], Term a [Prelude.Char]),
                   (Bool, Term a [Prelude.Char])))];
conversion xml2name =
  many1 ['c', 'o', 'n', 'v', 'e', 'r', 's', 'i', 'o', 'n']
    (singleton ['s', 't', 'a', 'r', 't', 'T', 'e', 'r', 'm'] (term xml2name) id)
    (estep xml2name) (\ _ x -> x);

plain_name :: Xml -> Sum_bot [Prelude.Char] (Lab [Prelude.Char] [Nat]);
plain_name x =
  options
    [(['n', 'a', 'm', 'e'], change (text ['n', 'a', 'm', 'e']) UnLab),
      (['s', 'h', 'a', 'r', 'p'],
        singleton ['s', 'h', 'a', 'r', 'p'] plain_name Sharp),
      (['l', 'a', 'b', 'e', 'l', 'e', 'd', 'S', 'y', 'm', 'b', 'o', 'l'],
        pair ['l', 'a', 'b', 'e', 'l', 'e', 'd', 'S', 'y', 'm', 'b', 'o', 'l']
          plain_name
          (options
            [(['n', 'u', 'm', 'b', 'e', 'r', 'L', 'a', 'b', 'e', 'l'],
               many ['n', 'u', 'm', 'b', 'e', 'r', 'L', 'a', 'b', 'e', 'l']
                 (nata ['n', 'u', 'm', 'b', 'e', 'r']) Inl),
              (['s', 'y', 'm', 'b', 'o', 'l', 'L', 'a', 'b', 'e', 'l'],
                many ['s', 'y', 'm', 'b', 'o', 'l', 'L', 'a', 'b', 'e', 'l']
                  plain_name Inr)])
          (\ f a ->
            (case a of {
              Inl aa -> Lab f aa;
              Inr aa -> FunLab f aa;
            })))]
    x;

xml1or2many_elements ::
  forall a b c d.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (Xml -> Sum_bot [Prelude.Char] b) ->
          (Xml -> Sum_bot [Prelude.Char] c) ->
            (a -> Maybe b -> [c] -> d) -> Xml -> Sum_bot [Prelude.Char] d;
xml1or2many_elements tag p1 p2 p3 f (Xml name atts cs text) =
  (if name == tag && null atts && is_none text && not (null cs)
    then let {
           (cs0 : tt) = cs;
         } in binda (p1 cs0)
                (\ x ->
                  (case tt of {
                    [] -> returna (f x Nothing []);
                    cs1 : t ->
                      catch (binda (p2 cs1)
                              (\ y ->
                                binda (map_sum_bot p3 t)
                                  (\ xs -> returna (f x (Just y) xs))))
                        (\ _ ->
                          binda (map_sum_bot p3 tt)
                            (\ xs -> returna (f x Nothing xs)));
                  }))
    else fail tag (Xml name atts cs text));

sl_variant ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Sl_variant a [Prelude.Char]);
sl_variant xml2name =
  singleton ['m', 'o', 'd', 'e', 'l']
    (options
      [(['f', 'i', 'n', 'i', 't', 'e', 'M', 'o', 'd', 'e', 'l'],
         xml1or2many_elements
           ['f', 'i', 'n', 'i', 't', 'e', 'M', 'o', 'd', 'e', 'l']
           (change
             (nata ['c', 'a', 'r', 'r', 'i', 'e', 'r', 'S', 'i', 'z', 'e'])
             (\ n -> minus_nat n (Nat_of_num One)))
           (singleton ['t', 'u', 'p', 'l', 'e', 'O', 'r', 'd', 'e', 'r']
             (leaf ['p', 'o', 'i', 'n', 't', 'W', 'i', 's', 'e'] ()) id)
           (triple ['i', 'n', 't', 'e', 'r', 'p', 'r', 'e', 't'] xml2name
             (nata ['a', 'r', 'i', 't', 'y']) arith_fun
             (\ f a -> (\ b -> ((f, a), b))))
           (\ n model xs ->
             (if is_none model then Finitelab (SL_Inter n xs)
               else QuasiFinitelab (SL_Inter n xs) []))),
        (['r', 'o', 'o', 't', 'L', 'a', 'b', 'e', 'l', 'i', 'n', 'g'],
          guard (\ x -> equal_nat (num_children x) Zero_nat)
            (leaf ['r', 'o', 'o', 't', 'L', 'a', 'b', 'e', 'l', 'i', 'n', 'g']
              (Rootlab Nothing))
            (singleton
              ['r', 'o', 'o', 't', 'L', 'a', 'b', 'e', 'l', 'i', 'n', 'g']
              xml2name (\ f -> Rootlab (Just (f, Nat_of_num One)))))])
    id;

transition_lhs ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          (Sum ((a, Nat), [[Prelude.Char]]) [Prelude.Char]);
transition_lhs xml2name x =
  (if let {
        (Xml _ _ cs _) = x;
      } in equal_nat (size_list cs) (Nat_of_num One)
    then singleton ['l', 'h', 's'] state Inr x
    else many2 ['l', 'h', 's'] xml2name (nata ['h', 'e', 'i', 'g', 'h', 't'])
           state (\ f h qs -> Inl ((f, h), qs)) x);

transition ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          (Sum (Ta_rule [Prelude.Char] (a, Nat))
            ([Prelude.Char], [Prelude.Char]));
transition xml2name =
  pair ['t', 'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n']
    (transition_lhs xml2name) (singleton ['r', 'h', 's'] state id)
    (\ lhs q ->
      (case lhs of {
        Inl (f, qs) -> Inl (TA_rule f qs q);
        Inr qa -> Inr (qa, q);
      }));

max_tag :: Nat;
max_tag = Nat_of_num (Bit1 (Bit0 (Bit1 (Bit1 One))));

ceq_char :: Maybe (Prelude.Char -> Prelude.Char -> Bool);
ceq_char = Just (\ a b -> a == b);

instance Ceq Prelude.Char where {
  ceq = ceq_char;
};

ceq_list :: forall a. (Ceq a) => Maybe ([a] -> [a] -> Bool);
ceq_list =
  (case ceq of {
    Nothing -> Nothing;
    Just eq_0 ->
      Just (list_rec (\ a -> (case a of {
                               [] -> True;
                               _ : _ -> False;
                             }))
             (\ x_0 _ res_0 a ->
               (case a of {
                 [] -> False;
                 y_0 : y_1 -> eq_0 x_0 y_0 && res_0 y_1;
               })));
  });

instance (Ceq a) => Ceq [a] where {
  ceq = ceq_list;
};

all_interval_nat :: (Nat -> Bool) -> Nat -> Nat -> Bool;
all_interval_nat p i j =
  less_eq_nat j i || p i && all_interval_nat p (plus_nat i (Nat_of_num One)) j;

gen_list_to_map_aux :: forall a b c. (a -> b -> c -> c) -> c -> [(a, b)] -> c;
gen_list_to_map_aux upd accs [] = accs;
gen_list_to_map_aux upd accs ((k, v) : l) =
  gen_list_to_map_aux upd (upd k v accs) l;

gen_list_to_map ::
  forall a b c. (() -> a) -> (b -> c -> a -> a) -> [(b, c)] -> a;
gen_list_to_map empt upd l = gen_list_to_map_aux upd (empt ()) (reverse l);

delete_value ::
  forall a b.
    (Eq a, Linorder b) => (a -> Maybe b) -> a -> Rbt b [a] -> Rbt b [a];
delete_value key v m =
  (case key v of {
    Nothing -> m;
    Just k ->
      (case rm_lookup k m of {
        Nothing -> m;
        Just vs -> rm_update k (removeAll v vs) m;
      });
  });

insert_value ::
  forall a b.
    (Eq a, Linorder b) => (a -> Maybe b) -> a -> Rbt b [a] -> Rbt b [a];
insert_value key v m =
  (case key v of {
    Nothing -> m;
    Just k ->
      (case rm_lookup k m of {
        Nothing -> rm_update_dj k [v] m;
        Just vs -> rm_update k (insertb v vs) m;
      });
  });

data Non_inf_order_ext a b c =
  Non_inf_order_ext (Sum ([Prelude.Char] -> [Prelude.Char]) ())
    ((Term a b, Term a b) -> Sum ([Prelude.Char] -> [Prelude.Char]) ())
    (C_constraint a b -> Sum ([Prelude.Char] -> [Prelude.Char]) ())
    ((a, Nat) -> Nat -> Dependance) ([Prelude.Char] -> [Prelude.Char]) c;

afb :: forall a b c. Non_inf_order_ext a b c -> (a, Nat) -> Nat -> Dependance;
afb (Non_inf_order_ext valid ns cc af desc more) = af;

cc :: forall a b c.
        Non_inf_order_ext a b c ->
          C_constraint a b -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
cc (Non_inf_order_ext valid ns cc af desc more) = cc;

nsb ::
  forall a b c.
    Non_inf_order_ext a b c ->
      (Term a b, Term a b) -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
nsb (Non_inf_order_ext valid ns cc af desc more) = ns;

check_ge_v :: forall a. (Poly_carrier a) => a -> [([(Nat, Nat)], a)] -> Bool;
check_ge_v v p =
  (case p of {
    [] -> True;
    [([], c)] -> less_eq c v;
    ([], c) : _ : _ -> False;
    (_ : _, c) : list -> False;
  });

check_poly_weak_anti_mono_discrete ::
  forall a b. (Eq a, Eq b, Poly_carrier b) => [([(a, Nat)], b)] -> a -> Bool;
check_poly_weak_anti_mono_discrete p v =
  check_poly_ge p
    (poly_subst
      (\ w -> poly_of (if w == v then PSum [PNum onea, PVar v] else PVar w)) p);

check_poly_weak_anti_mono ::
  forall a b.
    (Ceq a, Corder a, Set_impla a,
      Ordered_semiring_0 b) => [([(a, Nat)], b)] -> a -> Bool;
check_poly_weak_anti_mono p v =
  all (\ (m, c) -> less_eq c zeroa || not (member v (image fst (set m)))) p;

check_poly_weak_anti_mono_smart ::
  forall a b.
    (Ceq a, Corder a, Eq a, Set_impla a, Eq b,
      Poly_carrier b) => Bool -> [([(a, Nat)], b)] -> a -> Bool;
check_poly_weak_anti_mono_smart discrete =
  (if discrete then check_poly_weak_anti_mono_discrete
    else check_poly_weak_anti_mono);

check_poly_weak_mono_discrete ::
  forall a b. (Eq a, Eq b, Poly_carrier b) => [([(a, Nat)], b)] -> a -> Bool;
check_poly_weak_mono_discrete p v =
  check_poly_ge
    (poly_subst
      (\ w -> poly_of (if w == v then PSum [PNum onea, PVar v] else PVar w)) p)
    p;

check_poly_weak_mono ::
  forall a b.
    (Ceq a, Corder a, Set_impla a,
      Ordered_semiring_0 b) => [([(a, Nat)], b)] -> a -> Bool;
check_poly_weak_mono p v =
  all (\ (m, c) -> less_eq zeroa c || not (member v (image fst (set m)))) p;

check_poly_weak_mono_smart ::
  forall a b.
    (Ceq a, Corder a, Eq a, Set_impla a, Eq b,
      Poly_carrier b) => Bool -> [([(a, Nat)], b)] -> a -> Bool;
check_poly_weak_mono_smart discrete =
  (if discrete then check_poly_weak_mono_discrete else check_poly_weak_mono);

fun_of_map_fun :: forall a b. (a -> Maybe b) -> (a -> b) -> a -> b;
fun_of_map_fun m d a = (case m a of {
                         Nothing -> d a;
                         Just b -> b;
                       });

list_to_rm :: forall a b. (Linorder a) => [(a, b)] -> Rbt a b;
list_to_rm = gen_list_to_map rm_empty rm_update;

ceta_map_of :: forall a b. (Key a) => [(a, b)] -> a -> Maybe b;
ceta_map_of ps = rm_alpha (list_to_rm ps);

poly_inter_list_to_inter ::
  forall a b.
    (Poly_carrier a, Eq b,
      Key b) => a -> [((b, Nat), [([(Nat, Nat)], a)])] ->
                       (b, Nat) -> [([(Nat, Nat)], a)];
poly_inter_list_to_inter def i =
  fun_of_map_fun (ceta_map_of i) (\ fn -> default_I def (snd fn));

fun_of_map_funa ::
  forall a b c. (a -> Maybe b) -> (a -> c) -> (b -> c) -> a -> c;
fun_of_map_funa m d f a = (case m a of {
                            Nothing -> d a;
                            Just aa -> f aa;
                          });

create_dep ::
  forall a b.
    (Eq a, Poly_carrier a, Eq b,
      Key b) => Bool ->
                  a -> [((b, Nat), [([(Nat, Nat)], a)])] ->
                         (b, Nat) -> Nat -> Dependance;
create_dep discrete def i =
  let {
    fs = remdups (map fst i);
    ii = poly_inter_list_to_inter def i;
    fsres =
      map (\ fn ->
            let {
              p = ii fn;
              vars = poly_vars_list p;
              is = upt Zero_nat (snd fn);
              a = map (\ ia ->
                        (if membera vars ia
                          then (if check_poly_weak_mono_smart discrete p ia
                                 then Increase
                                 else (if check_poly_weak_anti_mono_smart
    discrete p ia
then Decrease else Wild))
                          else Ignore))
                    is;
            } in (fn, a))
        fs;
    iii = fun_of_map_funa (ceta_map_of fsres) (\ _ _ -> Increase) nth;
  } in iii;

data Outermost_nontermination_proof a b =
  OTRS_Loop (Term a b) [(Pos, ((Term a b, Term a b), Term a b))] [(b, Term a b)]
    (Ctxt a b)
  | OTRS_Rule_Removal [(Term a b, Term a b)]
      (Outermost_nontermination_proof a b);

data Dp_nontermination_proof a b =
  DP_Loop (Term a b) [(Pos, ((Term a b, Term a b), (Bool, Term a b)))]
    [(b, Term a b)] (Ctxt a b)
  | DP_Nonloop (Non_loop_prf a b)
  | DP_Rule_Removal (Maybe [(Term a b, Term a b)])
      (Maybe [(Term a b, Term a b)]) (Dp_nontermination_proof a b)
  | DP_Q_Increase [Term a b] (Dp_nontermination_proof a b)
  | DP_Q_Reduction [Term a b] (Dp_nontermination_proof a b)
  | DP_Termination_Switch (Join_info a) (Dp_nontermination_proof a b)
  | DP_Instantiation [(Term a b, Term a b)] (Dp_nontermination_proof a b)
  | DP_Rewriting (Maybe [(Term a b, Term a b)]) (Term a b, Term a b)
      (Term a b, Term a b) (Term a b, Term a b) (Term a b, Term a b) Pos
      (Dp_nontermination_proof a b)
  | DP_Narrowing (Term a b, Term a b) Pos [(Term a b, Term a b)]
      (Dp_nontermination_proof a b);

data Trs_nontermination_proof a b =
  TRS_Loop (Term a b) [(Pos, ((Term a b, Term a b), Term a b))] [(b, Term a b)]
    (Ctxt a b)
  | TRS_Not_Well_Formed
  | TRS_Rule_Removal [(Term a b, Term a b)] (Trs_nontermination_proof a b)
  | TRS_String_Reversal (Trs_nontermination_proof a b)
  | TRS_DP_Trans [(Term a b, Term a b)] (Dp_nontermination_proof a b)
  | TRS_Nonloop (Non_loop_prf a b)
  | TRS_Q_Increase [Term a b] (Trs_nontermination_proof a b);

data Reltrs_nontermination_proof a b =
  Rel_Loop (Term a b) [(Pos, ((Term a b, Term a b), (Bool, Term a b)))]
    [(b, Term a b)] (Ctxt a b)
  | Rel_Not_Well_Formed
  | Rel_Rule_Removal (Maybe [(Term a b, Term a b)])
      (Maybe [(Term a b, Term a b)]) (Reltrs_nontermination_proof a b)
  | Rel_R_Not_SN (Trs_nontermination_proof a b);

data Fp_nontermination_proof a b =
  FPTRS_Loop (Term a b) [(Pos, ((Term a b, Term a b), Term a b))]
    [(b, Term a b)] (Ctxt a b);

data Quasi_reductive_proof a b c =
  Unravel
    [(((Term (Lab a b) c, Term (Lab a b) c),
        [(Term (Lab a b) c, Term (Lab a b) c)]),
       [(Term (Lab a b) c, Term (Lab a b) c)])]
    (Trs_termination_proof a b c);

data Completion_proof a b c =
  SN_WCR_Eq (Join_info (Lab a b)) (Trs_termination_proof a b c)
    [((Term (Lab a b) c, Term (Lab a b) c),
       [(Pos, ((Term (Lab a b) c, Term (Lab a b) c),
                (Bool, Term (Lab a b) c)))])]
    (Maybe [((Term (Lab a b) c, Term (Lab a b) c),
              [(Pos, ((Term (Lab a b) c, Term (Lab a b) c),
                       (Bool, Term (Lab a b) c)))])]);

data Equational_disproof a b c =
  Completion_and_Normalization_Different [(Term (Lab a b) c, Term (Lab a b) c)]
    (Completion_proof a b c);

data Eq_proof a b = Refl (Term a b) | Sym (Eq_proof a b)
  | Trans (Eq_proof a b) (Eq_proof a b)
  | Assm (Term a b, Term a b) (b -> Term a b) | Cong a [Eq_proof a b];

data Equational_proof a b c = Equational_Proof_Tree (Eq_proof (Lab a b) c)
  | Completion_and_Normalization [(Term (Lab a b) c, Term (Lab a b) c)]
      (Completion_proof a b c)
  | Conversion
      [(Pos, ((Term (Lab a b) c, Term (Lab a b) c), (Bool, Term (Lab a b) c)))];

data Complexity_proof a b =
  Rule_Shift_Complexity (Redtriple_impl a) [(Term a b, Term a b)]
    (Complexity_proof a b)
  | RisEmpty_Complexity
  | Remove_Nonapplicable_Rules_Complexity [(Term a b, Term a b)]
      (Complexity_proof a b);

data Cert_problem a b c =
  TRS_Termination_Proof Bool (Strategy (Lab a b) c)
    [(Term (Lab a b) c, Term (Lab a b) c)]
    (Maybe [(Term (Lab a b) c, Term (Lab a b) c)]) (Trs_termination_proof a b c)
  | Complexity_Proof (Strategy (Lab a b) c)
      [(Term (Lab a b) c, Term (Lab a b) c)]
      (Maybe [(Term (Lab a b) c, Term (Lab a b) c)])
      (Complexity_measure (Lab a b) c) Complexity_class
      (Complexity_proof (Lab a b) c)
  | DP_Termination_Proof Bool Bool [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Strategy (Lab a b) c)
      [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Dp_termination_proof a b c)
  | DP_Nontermination_Proof Bool Bool [(Term (Lab a b) c, Term (Lab a b) c)]
      (Strategy (Lab a b) c) [(Term (Lab a b) c, Term (Lab a b) c)]
      (Dp_nontermination_proof (Lab a b) c)
  | TRS_Nontermination_Proof Bool (Strategy (Lab a b) c)
      [(Term (Lab a b) c, Term (Lab a b) c)]
      (Trs_nontermination_proof (Lab a b) c)
  | Outermost_Nontermination_Proof (Ostrategy (Lab a b) c)
      [(Term (Lab a b) c, Term (Lab a b) c)]
      (Outermost_nontermination_proof (Lab a b) c)
  | FP_Nontermination_Proof [(Ctxt (Lab a b) c, (Term (Lab a b) c, Location))]
      [(Term (Lab a b) c, Term (Lab a b) c)]
      (Fp_nontermination_proof (Lab a b) c)
  | Relative_TRS_Nontermination_Proof Bool (Strategy (Lab a b) c)
      [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)]
      (Reltrs_nontermination_proof (Lab a b) c)
  | TRS_Confluence_Proof Bool [(Term (Lab a b) c, Term (Lab a b) c)]
      (Cr_proof a b c)
  | TRS_Non_Confluence_Proof Bool [(Term (Lab a b) c, Term (Lab a b) c)]
      (Ncr_proof a b c)
  | Completion_Proof [(Term (Lab a b) c, Term (Lab a b) c)]
      [(Term (Lab a b) c, Term (Lab a b) c)] (Completion_proof a b c)
  | Equational_Proof [(Term (Lab a b) c, Term (Lab a b) c)]
      (Term (Lab a b) c, Term (Lab a b) c) (Equational_proof a b c)
  | Equational_Disproof [(Term (Lab a b) c, Term (Lab a b) c)]
      (Term (Lab a b) c, Term (Lab a b) c) (Equational_disproof a b c)
  | Quasi_Reductive_Proof
      [((Term (Lab a b) c, Term (Lab a b) c),
         [(Term (Lab a b) c, Term (Lab a b) c)])]
      (Quasi_reductive_proof a b c);

xml_tag :: forall a b c. Cert_problem a b c -> [Prelude.Char];
xml_tag (TRS_Termination_Proof uu uv uw (Just ux) uy) =
  ['<', 'r', 'e', 'l', 'a', 't', 'i', 'v', 'e', 'T', 'e', 'r', 'm', 'i', 'n',
    'a', 't', 'i', 'o', 'n', 'P', 'r', 'o', 'o', 'f', '>'];
xml_tag (TRS_Termination_Proof uz va vb Nothing vc) =
  ['<', 't', 'r', 's', 'T', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i', 'o', 'n',
    'P', 'r', 'o', 'o', 'f', '>'];
xml_tag (Complexity_Proof vd ve vf vg vh vi) =
  ['<', 'c', 'o', 'm', 'p', 'l', 'e', 'x', 'i', 't', 'y', 'P', 'r', 'o', 'o',
    'f', '>'];
xml_tag (TRS_Nontermination_Proof vj vk vl vm) =
  ['<', 't', 'r', 's', 'N', 'o', 'n', 't', 'e', 'r', 'm', 'i', 'n', 'a', 't',
    'i', 'o', 'n', 'P', 'r', 'o', 'o', 'f', '>'];
xml_tag (Outermost_Nontermination_Proof vn vo vp) =
  ['<', 't', 'r', 's', 'N', 'o', 'n', 't', 'e', 'r', 'm', 'i', 'n', 'a', 't',
    'i', 'o', 'n', 'P', 'r', 'o', 'o', 'f', '>'];
xml_tag (FP_Nontermination_Proof vq vr vs) =
  ['<', 't', 'r', 's', 'N', 'o', 'n', 't', 'e', 'r', 'm', 'i', 'n', 'a', 't',
    'i', 'o', 'n', 'P', 'r', 'o', 'o', 'f', '>'];
xml_tag (Relative_TRS_Nontermination_Proof vt vu vv vw vx) =
  ['<', 'r', 'e', 'l', 'a', 't', 'i', 'v', 'e', 'N', 'o', 'n', 't', 'e', 'r',
    'm', 'i', 'n', 'a', 't', 'i', 'o', 'n', 'P', 'r', 'o', 'o', 'f', '>'];
xml_tag (DP_Termination_Proof vy vz wa wb wc wd we wf) =
  ['<', 'd', 'p', 'P', 'r', 'o', 'o', 'f', '>'];
xml_tag (DP_Nontermination_Proof wg wh wi wj wk wl) =
  ['<', 'd', 'p', 'N', 'o', 'n', 't', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i',
    'o', 'n', 'P', 'r', 'o', 'o', 'f', '>'];
xml_tag (TRS_Confluence_Proof wm wn wo) =
  ['<', 'c', 'r', 'P', 'r', 'o', 'o', 'f', '>'];
xml_tag (TRS_Non_Confluence_Proof wp wq wr) =
  ['<', 'c', 'r', 'D', 'i', 's', 'p', 'r', 'o', 'o', 'f', '>'];
xml_tag (Completion_Proof ws wt wu) =
  ['<', 'c', 'o', 'm', 'p', 'l', 'e', 't', 'i', 'o', 'n', 'P', 'r', 'o', 'o',
    'f', '>'];
xml_tag (Equational_Proof wv ww wx) =
  ['<', 'e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 'a', 'l', 'P', 'r', 'o', 'o',
    'f', '>'];
xml_tag (Equational_Disproof wy wz xa) =
  ['<', 'e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 'a', 'l', 'D', 'i', 's', 'p',
    'r', 'o', 'o', 'f', '>'];
xml_tag (Quasi_Reductive_Proof xb xc) =
  ['<', 'q', 'u', 'a', 's', 'i', 'R', 'e', 'd', 'u', 'c', 't', 'i', 'v', 'e',
    'P', 'r', 'o', 'o', 'f', '>'];

rm_isEmpty :: forall a b. (Eq a, Linorder a, Eq b) => Rbt a b -> Bool;
rm_isEmpty m = m == empty;

rs_isEmpty :: forall a. (Eq a, Linorder a) => Rbt a () -> Bool;
rs_isEmpty = rm_isEmpty;

rs_reverse_iterateoi ::
  forall a b.
    (Linorder a) => Rbt a () -> (b -> Bool) -> (a -> b -> b) -> b -> b;
rs_reverse_iterateoi = s_iteratei rm_reverse_iterateoia;

rs_to_list :: forall a. (Linorder a) => Rbt a () -> [a];
rs_to_list = it_set_to_list rs_reverse_iterateoi;

delete_values ::
  forall a b.
    (Eq a, Linorder b) => (a -> Maybe b) -> [a] -> Rbt b [a] -> Rbt b [a];
delete_values uu [] m = m;
delete_values key (v : vs) m = delete_value key v (delete_values key vs m);

delete_rules ::
  forall a b c.
    (Eq a, Eq b, Linorder b,
      Eq c) => a -> [(Term b c, Term b c)] ->
                      Rbt (b, Nat) [(a, (Term b c, Term b c))] ->
                        Rbt (b, Nat) [(a, (Term b c, Term b c))];
delete_rules a rs = delete_values key (map (\ b -> (a, b)) rs);

insert_values ::
  forall a b.
    (Eq a, Linorder b) => (a -> Maybe b) -> [a] -> Rbt b [a] -> Rbt b [a];
insert_values uu [] m = m;
insert_values key (v : vs) m = insert_value key v (insert_values key vs m);

insert_rules ::
  forall a b c.
    (Eq a, Eq b, Linorder b,
      Eq c) => a -> [(Term b c, Term b c)] ->
                      Rbt (b, Nat) [(a, (Term b c, Term b c))] ->
                        Rbt (b, Nat) [(a, (Term b c, Term b c))];
insert_rules a rs = insert_values key (map (\ b -> (a, b)) rs);

set_impl_list :: forall a. Phantom [a] Set_impl;
set_impl_list = Phantom Set_Choose;

instance Set_impla [a] where {
  set_impl = set_impl_list;
};

split_rulesc ::
  forall a b c d.
    Dpp_ops_ext a b c d ->
      a -> [(Term b c, Term b c)] ->
             ([(Term b c, Term b c)], [(Term b c, Term b c)]);
split_rulesc
  (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
    rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
    intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
    split_pairs split_rules mk minimal nfs wwf_rules more)
  = split_rules;

split_pairsa ::
  forall a b c d.
    Dpp_ops_ext a b c d ->
      a -> [(Term b c, Term b c)] ->
             ([(Term b c, Term b c)], [(Term b c, Term b c)]);
split_pairsa
  (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
    rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
    intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
    split_pairs split_rules mk minimal nfs wwf_rules more)
  = split_pairs;

delete_R_Rwc ::
  forall a b c d.
    Dpp_ops_ext a b c d ->
      a -> [(Term b c, Term b c)] -> [(Term b c, Term b c)] -> a;
delete_R_Rwc
  (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
    rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
    intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
    split_pairs split_rules mk minimal nfs wwf_rules more)
  = delete_R_Rw;

delete_P_Pwa ::
  forall a b c d.
    Dpp_ops_ext a b c d ->
      a -> [(Term b c, Term b c)] -> [(Term b c, Term b c)] -> a;
delete_P_Pwa
  (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
    rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
    intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
    split_pairs split_rules mk minimal nfs wwf_rules more)
  = delete_P_Pw;

minimal :: forall a b c d. Dpp_ops_ext a b c d -> a -> Bool;
minimal
  (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
    rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
    intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
    split_pairs split_rules mk minimal nfs wwf_rules more)
  = minimal;

nfsc :: forall a b c d. Dpp_ops_ext a b c d -> a -> Bool;
nfsc (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
       rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map
       reverse_rules_map intersect_pairs replace_pair intersect_rules
       delete_P_Pw delete_R_Rw split_pairs split_rules mk minimal nfs wwf_rules
       more)
  = nfs;

qc :: forall a b c d. Dpp_ops_ext a b c d -> a -> [Term b c];
qc (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
     rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
     intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
     split_pairs split_rules mk minimal nfs wwf_rules more)
  = q;

split_proc ::
  forall a b c.
    (Showa b,
      Showa c) => Dpp_ops_ext a b c () ->
                    a -> [(Term b c, Term b c)] ->
                           [(Term b c, Term b c)] -> (a, a);
split_proc i d p_remove r_remove =
  let {
    (p, pw) = split_pairsa i d p_remove;
    (r, rw) = split_rulesc i d r_remove;
    dpp1 = mkc i (nfsc i d) (minimal i d) p pw (qc i d) r rw;
    a = delete_R_Rwc i (delete_P_Pwa i d p_remove p_remove) r_remove r_remove;
  } in (dpp1, a);

map_subst_domain ::
  forall a b c d. (a -> b) -> (b -> Term c d) -> a -> Term c d;
map_subst_domain m sigma = (\ v -> sigma (m v));

subst_apply_ctxt :: forall a b c. Ctxt a b -> (b -> Term a c) -> Ctxt a c;
subst_apply_ctxt Hole sigma = Hole;
subst_apply_ctxt (More f ss1 d ss2) sigma =
  More f (map (\ t -> subst_apply_term t sigma) ss1) (subst_apply_ctxt d sigma)
    (map (\ t -> subst_apply_term t sigma) ss2);

descaa ::
  forall a b c. Root_redtriple_ext a b c -> [Prelude.Char] -> [Prelude.Char];
descaa (Root_redtriple_ext valid s ns nst af aft desc more) = desc;

valid ::
  forall a b c.
    Redtriple_ext a b c -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
valid (Redtriple_ext valid s ns nst af mono desc cpx more) = valid;

check_subseteq :: forall a. (Eq a) => [a] -> [a] -> Sum a ();
check_subseteq xs ys =
  catcha (forallM (\ x -> (if membera ys x then Inr () else Inl x)) xs)
    (\ x -> Inl (snd x));

check_wf_trs ::
  forall a b.
    (Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_wf_trs r =
  catcha
    (catcha
      (forallM
        (\ rule ->
          catcha
            (bindb
              (check (not (is_Var (fst rule)))
                (shows_string
                  ['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', ' ', 'l', 'e', 'f',
                    't', '-', 'h', 'a', 'n', 'd', ' ', 's', 'i', 'd', 'e', ' ',
                    'i', 'n']))
              (\ _ ->
                catcha
                  (check_subseteq (vars_term_lista (snd rule))
                    (vars_term_lista (fst rule)))
                  (\ x ->
                    Inl (shows_string
                           ['f', 'r', 'e', 'e', ' ', 'v', 'a', 'r', 'i', 'a',
                             'b', 'l', 'e', ' '] .
                          shows_prec Zero_nat x .
                            shows_string
                              [' ', 'i', 'n', ' ', 'r', 'i', 'g', 'h', 't', '-',
                                'h', 'a', 'n', 'd', ' ', 's', 'i', 'd', 'e',
                                ' ', 'o', 'f']))))
            (\ x ->
              Inl (x . shows_string [' ', 'r', 'u', 'l', 'e', ' '] .
                         shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                           [' ', '-', '>', ' '] rule .
                           shows_nl)))
        r)
      (\ x -> Inl (snd x)))
    (\ x ->
      Inl (shows_string
             ['t', 'h', 'e', ' ', 'T', 'R', 'S', ' ', 'i', 's', ' ', 'n', 'o',
               't', ' ', 'w', 'e', 'l', 'l', '-', 'f', 'o', 'r', 'm', 'e',
               'd'] .
            shows_nl . x));

map_rules_wa ::
  forall a b c.
    (a -> Nat -> b) -> [(Term a c, Term a c)] -> [(Term b c, Term b c)];
map_rules_wa fg r = map (\ (l, ra) -> (map_term_wa fg l, map_term_wa fg ra)) r;

generate_f_xs :: forall a. a -> Nat -> Term a [Prelude.Char];
generate_f_xs f n = Fun f (map (\ i -> Var (generate_var i)) (upt Zero_nat n));

final_states :: Xml -> Sum_bot [Prelude.Char] [[Prelude.Char]];
final_states =
  many ['f', 'i', 'n', 'a', 'l', 'S', 't', 'a', 't', 'e', 's'] state id;

transitions ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          ([Ta_rule [Prelude.Char] (a, Nat)],
            [([Prelude.Char], [Prelude.Char])]);
transitions xml2name =
  many ['t', 'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n', 's']
    (transition xml2name)
    (\ rls ->
      let {
        (rules, eps) =
          partition (\ a -> (case a of {
                              Inl _ -> True;
                              Inr _ -> False;
                            }))
            rls;
        ruls = map (\ (Inl r) -> r) rules;
        a = map (\ (Inr e) -> e) eps;
      } in (ruls, a));

bounds_tree_automaton ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Tree_automaton [Prelude.Char] (a, Nat));
bounds_tree_automaton xml2name =
  pair ['t', 'r', 'e', 'e', 'A', 'u', 't', 'o', 'm', 'a', 't', 'o', 'n']
    final_states (transitions xml2name) (\ f (a, b) -> Tree_Automaton f a b);

bounds_bound :: Xml -> Sum_bot [Prelude.Char] Nat;
bounds_bound = nata ['b', 'o', 'u', 'n', 'd'];

bounds_type :: Xml -> Sum_bot [Prelude.Char] Boundstype;
bounds_type =
  singleton ['t', 'y', 'p', 'e']
    (options
      [(['r', 'o', 'o', 'f'], leaf ['r', 'o', 'o', 'f'] Roof),
        (['m', 'a', 't', 'c', 'h'], leaf ['m', 'a', 't', 'c', 'h'] Match)])
    id;

bounds_info ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Bounds_info a [Prelude.Char]);
bounds_info xml2name =
  guard (\ x -> equal_nat (num_children x) (Nat_of_num (Bit0 (Bit0 One))))
    (tuple4 ['b', 'o', 'u', 'n', 'd', 's'] bounds_type bounds_bound final_states
      (bounds_tree_automaton xml2name)
      (\ a b c d -> Bounds_Info a b c d Id_Relation))
    (tuple5 ['b', 'o', 'u', 'n', 'd', 's'] bounds_type bounds_bound final_states
      (bounds_tree_automaton xml2name)
      (many ['r', 'e', 'l', 'a', 't', 'i', 'o', 'n']
        (pair ['e', 'n', 't', 'r', 'y'] state state (\ a b -> (a, b)))
        Some_Relation)
      Bounds_Info);

unlab_of_trs ::
  forall a b c.
    (Eq a, Eq b,
      Eq c) => [(Term (Lab a b) c, Term (Lab a b) c)] ->
                 [(Term (Lab a b) c, Term (Lab a b) c)];
unlab_of_trs r = map (map_rule unlab) (no_decr r);

ceq_lab :: forall a b. (Eq a, Eq b) => Maybe (Lab a b -> Lab a b -> Bool);
ceq_lab = Just equal_lab;

instance (Eq a, Eq b) => Ceq (Lab a b) where {
  ceq = ceq_lab;
};

label_decomp :: forall a b. Lab a b -> (Lab a b, Sum b [Lab a b]);
label_decomp (Lab f l) = (f, Inl l);
label_decomp (FunLab f l) = (f, Inr l);

shows_lab ::
  forall a b.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      (b -> [Prelude.Char] -> [Prelude.Char]) ->
        Lab a b -> [Prelude.Char] -> [Prelude.Char];
shows_lab fun lab (UnLab f) = fun f;
shows_lab fun lab (Lab f l) =
  shows_lab fun lab f . shows_string ['['] . lab l . shows_string [']'];
shows_lab fun lab (Sharp f) = shows_lab fun lab f . shows_string ['#'];
shows_lab fun lab (FunLab f l) =
  shows_lab fun lab f .
    shows_string ['['] . shows_map (shows_lab fun lab) l . shows_string [']'];

shows_prec_lab ::
  forall a b.
    (Showa a, Showa b) => Nat -> Lab a b -> [Prelude.Char] -> [Prelude.Char];
shows_prec_lab d l = shows_lab (shows_prec Zero_nat) (shows_prec Zero_nat) l;

shows_list_lab ::
  forall a b.
    (Showa a, Showa b) => [Lab a b] -> [Prelude.Char] -> [Prelude.Char];
shows_list_lab = shows_list_aux (shows_prec_lab Zero_nat);

instance (Showa a, Showa b) => Showa (Lab a b) where {
  shows_prec = shows_prec_lab;
  shows_list = shows_list_lab;
};

is_partition_impl ::
  forall a.
    (Card_UNIV a, Ceq a, Cproper_interval a,
      Set_impla a) => [Set a] -> Maybe (Set a);
is_partition_impl [] = Just bot_set;
is_partition_impl (asa : rest) =
  bind (is_partition_impl rest)
    (\ alla ->
      (if is_empty (inf_set asa alla) then Just (sup_set alla asa)
        else Nothing));

is_partition ::
  forall a.
    (Card_UNIV a, Ceq a, Cproper_interval a, Set_impla a) => [Set a] -> Bool;
is_partition asa = not (is_none (is_partition_impl asa));

shows_arctic :: Arctic -> [Prelude.Char] -> [Prelude.Char];
shows_arctic (Num_arc i) = shows_prec_int Zero_nat i;
shows_arctic MinInfty = shows_string ['-', 'i', 'n', 'f'];

shows_prec_arctic :: Nat -> Arctic -> [Prelude.Char] -> [Prelude.Char];
shows_prec_arctic d ai = shows_arctic ai;

shows_list_arctic :: [Arctic] -> [Prelude.Char] -> [Prelude.Char];
shows_list_arctic = shows_list_aux (shows_prec_arctic Zero_nat);

instance Showa Arctic where {
  shows_prec = shows_prec_arctic;
  shows_list = shows_list_arctic;
};

rs_iteratei ::
  forall a b.
    (Linorder a) => Rbt a () -> (b -> Bool) -> (a -> b -> b) -> b -> b;
rs_iteratei = s_iteratei rm_iteratei;

set_ext :: forall a. (a -> a -> (Bool, Bool)) -> [a] -> [a] -> (Bool, Bool);
set_ext s_ns =
  (\ asa bs ->
    (not (null asa) && all (\ b -> any (\ a -> fst (s_ns a b)) asa) bs,
      all (\ b -> any (\ a -> snd (s_ns a b)) asa) bs));

shows_list_int :: [Int] -> [Prelude.Char] -> [Prelude.Char];
shows_list_int = shows_list_aux (shows_prec_int Zero_nat);

instance Showa Int where {
  shows_prec = shows_prec_int;
  shows_list = shows_list_int;
};

shows_list_nat :: [Nat] -> [Prelude.Char] -> [Prelude.Char];
shows_list_nat = shows_list_aux (shows_prec_nat Zero_nat);

instance Showa Nat where {
  shows_prec = shows_prec_nat;
  shows_list = shows_list_nat;
};

shows_list_rat :: [Rat] -> [Prelude.Char] -> [Prelude.Char];
shows_list_rat = shows_list_aux (shows_prec_rat Zero_nat);

instance Showa Rat where {
  shows_prec = shows_prec_rat;
  shows_list = shows_list_rat;
};

check_no_var ::
  forall a b.
    (Showa a, Showa b) => Term a b -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_no_var t =
  check (not (is_Var t))
    (shows_string
       ['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', ' ', 'f', 'o', 'u', 'n', 'd'] .
      shows_nl);

check_supteq ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => Term a b ->
                    Term a b -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_supteq s t =
  check (equal_term s t || supt_impl s t)
    (shows_prec_term Zero_nat t .
      shows_string
        [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 's', 'u', 'b', 't',
          'e', 'r', 'm', ' ', 'o', 'f', ' '] .
        shows_prec_term Zero_nat s);

valida ::
  forall a b c.
    Root_redtriple_ext a b c -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
valida (Root_redtriple_ext valid s ns nst af aft desc more) = valid;

compute_NF :: forall a. (a -> Maybe a) -> a -> Maybe a;
compute_NF f a =
  (case f a of {
    Nothing -> Just a;
    Just aa -> compute_NF f aa;
  });

first_rewrite ::
  forall a b.
    (Eq a, Eq b) => [(Term a b, Term a b)] -> Term a b -> Maybe (Term a b);
first_rewrite r s = (case rewrite r s of {
                      [] -> Nothing;
                      t : _ -> Just t;
                    });

compute_rstep_NF ::
  forall a b.
    (Eq a, Eq b) => [(Term a b, Term a b)] -> Term a b -> Maybe (Term a b);
compute_rstep_NF r s = compute_NF (first_rewrite r) s;

check_join_NF ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    Term a b ->
                      Term a b -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_join_NF r s t =
  (case (compute_rstep_NF r s, compute_rstep_NF r t) of {
    (Nothing, b) ->
      Inl (shows_prec_list Zero_nat
            ['s', 't', 'r', 'a', 'n', 'g', 'e', ' ', 'e', 'r', 'r', 'o', 'r',
              ' ', 'i', 'n', ' ', 'n', 'o', 'r', 'm', 'a', 'l', ' ', 'f', 'o',
              'r', 'm', ' ', 'c', 'o', 'm', 'p', 'u', 't', 'a', 't', 'i', 'o',
              'n']);
    (Just sa, Nothing) ->
      Inl (shows_prec_list Zero_nat
            ['s', 't', 'r', 'a', 'n', 'g', 'e', ' ', 'e', 'r', 'r', 'o', 'r',
              ' ', 'i', 'n', ' ', 'n', 'o', 'r', 'm', 'a', 'l', ' ', 'f', 'o',
              'r', 'm', ' ', 'c', 'o', 'm', 'p', 'u', 't', 'a', 't', 'i', 'o',
              'n']);
    (Just sa, Just ta) ->
      check (equal_term sa ta)
        (shows_string
           ['t', 'h', 'e', ' ', 'n', 'o', 'r', 'm', 'a', 'l', ' ', 'f', 'o',
             'r', 'm', ' '] .
          shows_prec_term Zero_nat sa .
            shows_prec_list Zero_nat [' ', 'o', 'f', ' '] .
              shows_prec_term Zero_nat s .
                shows_prec_list Zero_nat
                  [' ', 'd', 'i', 'f', 'f', 'e', 'r', 's', ' ', 'f', 'r', 'o',
                    'm', ' '] .
                  shows_nl .
                    shows_prec_list Zero_nat
                      ['t', 'h', 'e', ' ', 'n', 'o', 'r', 'm', 'a', 'l', ' ',
                        'f', 'o', 'r', 'm', ' '] .
                      shows_prec_term Zero_nat ta .
                        shows_prec_list Zero_nat [' ', 'o', 'f', ' '] .
                          shows_prec_term Zero_nat t);
  });

reverse_rules :: forall a b. [(Term a b, Term a b)] -> [(Term a b, Term a b)];
reverse_rules rs = map (\ lr -> (snd lr, fst lr)) rs;

vars_rule_lista :: forall a b. (Term a b, Term a b) -> [b];
vars_rule_lista r = vars_term_list (fst r) ++ vars_term_list (snd r);

vars_trs_list :: forall a b. (Eq b) => [(Term a b, Term a b)] -> [b];
vars_trs_list trs = remdups (concatMap vars_rule_lista trs);

wf_rules_impl ::
  forall a b. (Eq b) => [(Term a b, Term a b)] -> [(Term a b, Term a b)];
wf_rules_impl r = filter wf_rule r;

shows_prec_prod ::
  forall a b.
    (Showa a, Showa b) => Nat -> (a, b) -> [Prelude.Char] -> [Prelude.Char];
shows_prec_prod d p =
  shows_paren
    (shows_prec Zero_nat (fst p) .
      shows_prec_char Zero_nat ',' . shows_prec Zero_nat (snd p));

check_pairwise :: forall a b. (a -> a -> Sum b ()) -> [a] -> Sum b ();
check_pairwise c [] = Inr ();
check_pairwise c (x : xs) =
  bindb (catcha (forallM (c x) xs) (\ xa -> Inl (snd xa)))
    (\ _ -> check_pairwise c xs);

check_disjoint :: forall a. (Eq a) => [a] -> [a] -> Sum a ();
check_disjoint xs ys =
  catcha (forallM (\ x -> (if not (membera ys x) then Inr () else Inl x)) xs)
    (\ x -> Inl (snd x));

check_partition :: forall a. (Eq a) => [[a]] -> Sum a ();
check_partition xss = check_pairwise check_disjoint xss;

check_inj ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => Lab a b ->
                    Nat ->
                      [((Lab a b, Nat), [Lab a b])] ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_inj a nn sml =
  let {
    symbols =
      map (\ (aa, b) ->
            let {
              (_, n) = aa;
            } in (\ fs ->
                   map (\ (g, i) ->
                         (g, plus_nat n
                               (times_nat i (minus_nat nn (Nat_of_num One)))))
                     (zip fs (upt Zero_nat (size_list fs))))
              b)
        sml;
    fsymbols = concat symbols;
  } in bindb (catcha (check_partition symbols)
               (\ x ->
                 Inl (shows_prec_list Zero_nat
                        ['s', 'y', 'm', 'b', 'o', 'l', ' '] .
                       shows_prec_prod Zero_nat x .
                         shows_prec_list Zero_nat
                           [' ', 'o', 'c', 'c', 'u', 'r', 's', ' ', 't', 'w',
                             'i', 'c', 'e', ')'])))
         (\ _ ->
           bindb (check (not (membera fsymbols (a, nn)))
                   (shows_prec_list Zero_nat
                      ['a', 'p', 'p', 'l', 'i', 'c', 'a', 't', 'i', 'o', 'n',
                        ' ', 's', 'y', 'm', 'b', 'o', 'l'] .
                     shows_prec_lab Zero_nat a .
                       shows_prec_list Zero_nat
                         [' ', 'm', 'u', 's', 't', ' ', 'n', 'o', 't', ' ', 'o',
                           'c', 'c', 'u', 'r', ' ', 'a', 's', ' ', 'n', 'e',
                           'w', ' ', 's', 'y', 'm', 'b', 'o', 'l']))
             (\ _ ->
               bindb (check (not (membera (map fst sml) (a, nn)))
                       (shows_prec_list Zero_nat
                          ['a', 'p', 'p', 'l', 'i', 'c', 'a', 't', 'i', 'o',
                            'n', ' ', 's', 'y', 'm', 'b', 'o', 'l'] .
                         shows_prec_lab Zero_nat a .
                           shows_prec_list Zero_nat
                             [' ', 'm', 'u', 's', 't', ' ', 'n', 'o', 't', ' ',
                               'b', 'e', ' ', 'u', 'n', 'c', 'u', 'r', 'r', 'i',
                               'e', 'd']))
                 (\ _ ->
                   (if less_eq_nat nn (Nat_of_num One)
                     then catcha
                            (forallM
                              (check_pairwise
                                (\ gn1 gn2 ->
                                  check (not (gn1 == gn2))
                                    (shows_prec_list Zero_nat
                                       ['s', 'y', 'm', 'b', 'o', 'l', ' '] .
                                      shows_prec_prod Zero_nat gn1 .
shows_prec_list Zero_nat
  [' ', 'o', 'c', 'c', 'u', 'r', 's', ' ', 't', 'w', 'i', 'c', 'e'])))
                              symbols)
                            (\ x -> Inl (snd x))
                     else Inr ()))));

uncurry_info ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          (a, ([((a, Nat), [a])],
                ([(Term a [Prelude.Char], Term a [Prelude.Char])],
                  [(Term a [Prelude.Char], Term a [Prelude.Char])])));
uncurry_info xml2name =
  tuple4
    ['u', 'n', 'c', 'u', 'r', 'r', 'y', 'I', 'n', 'f', 'o', 'r', 'm', 'a', 't',
      'i', 'o', 'n']
    xml2name
    (many ['u', 'n', 'c', 'u', 'r', 'r', 'i', 'e', 'd', 'S', 'y', 'm', 'b', 'o',
            'l', 's']
      (many2
        ['u', 'n', 'c', 'u', 'r', 'r', 'i', 'e', 'd', 'S', 'y', 'm', 'b', 'o',
          'l', 'E', 'n', 't', 'r', 'y']
        xml2name (nata ['a', 'r', 'i', 't', 'y']) xml2name
        (\ f n -> (\ a -> ((f, n), a))))
      id)
    (singleton ['u', 'n', 'c', 'u', 'r', 'r', 'y', 'R', 'u', 'l', 'e', 's']
      (rules xml2name) id)
    (singleton ['e', 't', 'a', 'R', 'u', 'l', 'e', 's'] (rules xml2name) id)
    (\ a sml u e -> (a, (sml, (u, e))));

ordering_constraint_proofa ::
  forall a.
    Bool ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        Xml -> Sum_bot [Prelude.Char] (Redtriple_impl a);
ordering_constraint_proofa bi xml2name =
  singleton
    ['o', 'r', 'd', 'e', 'r', 'i', 'n', 'g', 'C', 'o', 'n', 's', 't', 'r', 'a',
      'i', 'n', 't', 'P', 'r', 'o', 'o', 'f']
    (redtriple bi xml2name) id;

level_mapping ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] [((a, Nat), [(Nat, Nat)])];
level_mapping xml2name =
  many ['l', 'e', 'v', 'e', 'l', 'M', 'a', 'p', 'p', 'i', 'n', 'g']
    (many2
      ['l', 'e', 'v', 'e', 'l', 'M', 'a', 'p', 'p', 'i', 'n', 'g', 'E', 'n',
        't', 'r', 'y']
      xml2name (nata ['a', 'r', 'i', 't', 'y'])
      (pair ['p', 'o', 's', 'i', 't', 'i', 'o', 'n', 'L', 'e', 'v', 'e', 'l',
              'E', 'n', 't', 'r', 'y']
        (nata ['p', 'o', 's', 'i', 't', 'i', 'o', 'n'])
        (nata ['l', 'e', 'v', 'e', 'l']) (\ a b -> (a, b)))
      (\ f a ps ->
        ((f, a),
          map (\ (p, b) ->
                ((if equal_nat p Zero_nat then a
                   else minus_nat p (Nat_of_num One)),
                  b))
            ps)))
    id;

root_redtriple ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Root_redtriple_impl a);
root_redtriple xml2name =
  singleton ['r', 'e', 'd', 'P', 'a', 'i', 'r']
    (triple ['s', 'c', 'n', 'p']
      (singleton ['s', 't', 'a', 't', 'u', 's']
        (options
          [(['m', 's'], leaf ['m', 's'] MS_Ext),
            (['m', 'i', 'n'], leaf ['m', 'i', 'n'] Min_Ext),
            (['d', 'm', 's'], leaf ['d', 'm', 's'] Dms_Ext),
            (['m', 'a', 'x'], leaf ['m', 'a', 'x'] Max_Ext)])
        id)
      (level_mapping xml2name) (redtriple False xml2name) Scnp)
    id;

root_ordering_constraint_proof ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Root_redtriple_impl a);
root_ordering_constraint_proof xml2name =
  singleton
    ['o', 'r', 'd', 'e', 'r', 'i', 'n', 'g', 'C', 'o', 'n', 's', 't', 'r', 'a',
      'i', 'n', 't', 'P', 'r', 'o', 'o', 'f']
    (root_redtriple xml2name) id;

ordering_constraint_proof ::
  forall a.
    Bool ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        Xml ->
          Sum_bot [Prelude.Char]
            (Sum (Root_redtriple_impl a) (Redtriple_impl a));
ordering_constraint_proof bi xml2name =
  choice ['r', 'e', 'd', 'u', 'c', 't', 'i', 'o', 'n', ' ', 'p', 'a', 'i', 'r']
    [change (ordering_constraint_proofa bi xml2name) Inr,
      change (root_ordering_constraint_proof xml2name) Inl];

create_proj :: forall a. (Eq a, Key a) => ProjL a -> (a, Nat) -> Nat;
create_proj (Projection p) =
  let {
    i = ceta_map_of p;
  } in (\ f -> (case i f of {
                 Nothing -> Zero_nat;
                 Just n -> n;
               }));

xml2cond_constraint ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Cond_constraint a [Prelude.Char]);
xml2cond_constraint xml2name x =
  singleton
    ['c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n', 'a', 'l', 'C', 'o', 'n', 's',
      't', 'r', 'a', 'i', 'n', 't']
    (options
      [(['a', 'l', 'l'],
         pair ['a', 'l', 'l'] (text ['v', 'a', 'r'])
           (xml2cond_constraint xml2name) CC_all),
        (['i', 'm', 'p', 'l', 'i', 'c', 'a', 't', 'i', 'o', 'n'],
          many1 ['i', 'm', 'p', 'l', 'i', 'c', 'a', 't', 'i', 'o', 'n']
            (xml2cond_constraint xml2name) (xml2cond_constraint xml2name)
            (\ c cs ->
              let {
                ccs = c : cs;
              } in CC_impl (take (size_list cs) ccs) (last ccs))),
        (['c', 'o', 'n', 's', 't', 'r', 'a', 'i', 'n', 't'],
          triple ['c', 'o', 'n', 's', 't', 'r', 'a', 'i', 'n', 't']
            (term xml2name)
            (options
              [(['r', 'e', 'w', 'r', 'i', 't', 'e'],
                 leaf ['r', 'e', 'w', 'r', 'i', 't', 'e'] Nothing),
                (['s', 't', 'r', 'i', 'c', 't'],
                  leaf ['s', 't', 'r', 'i', 'c', 't'] (Just True)),
                (['n', 'o', 'n', 'S', 't', 'r', 'i', 'c', 't'],
                  leaf ['n', 'o', 'n', 'S', 't', 'r', 'i', 'c', 't']
                    (Just False))])
            (term xml2name)
            (\ s rel t ->
              (case rel of {
                Nothing -> CC_rewr s t;
                Just stri -> CC_cond stri (s, t);
              })))])
    id x;

xml2cond_constraint_prf ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Cond_constraint_prf a [Prelude.Char]);
xml2cond_constraint_prf xml2name x =
  let {
    cc = xml2cond_constraint xml2name;
  } in singleton
         ['c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n', 'a', 'l', 'C', 'o', 'n',
           's', 't', 'r', 'a', 'i', 'n', 't', 'P', 'r', 'o', 'o', 'f']
         (options
           [(['f', 'i', 'n', 'a', 'l'], leaf ['f', 'i', 'n', 'a', 'l'] Final),
             (['d', 'i', 'f', 'f', 'e', 'r', 'e', 'n', 't', 'C', 'o', 'n', 's',
                't', 'r', 'u', 'c', 't', 'o', 'r'],
               singleton
                 ['d', 'i', 'f', 'f', 'e', 'r', 'e', 'n', 't', 'C', 'o', 'n',
                   's', 't', 'r', 'u', 'c', 't', 'o', 'r']
                 cc Different_Constructor),
             (['s', 'a', 'm', 'e', 'C', 'o', 'n', 's', 't', 'r', 'u', 'c', 't',
                'o', 'r'],
               triple
                 ['s', 'a', 'm', 'e', 'C', 'o', 'n', 's', 't', 'r', 'u', 'c',
                   't', 'o', 'r']
                 cc cc (xml2cond_constraint_prf xml2name) Same_Constructor),
             (['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 'E', 'q', 'u', 'a', 't',
                'i', 'o', 'n'],
               tuple4
                 ['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 'E', 'q', 'u', 'a',
                   't', 'i', 'o', 'n']
                 (text ['v', 'a', 'r']) (term xml2name) cc
                 (xml2cond_constraint_prf xml2name) Variable_Equation),
             (['f', 'u', 'n', 'a', 'r', 'g', 'I', 'n', 't', 'o', 'V', 'a', 'r'],
               tuple5
                 ['f', 'u', 'n', 'a', 'r', 'g', 'I', 'n', 't', 'o', 'V', 'a',
                   'r']
                 cc position (text ['v', 'a', 'r']) cc
                 (xml2cond_constraint_prf xml2name) Funarg_Into_Var),
             (['s', 'i', 'm', 'p', 'l', 'i', 'f', 'y', 'C', 'o', 'n', 'd', 'i',
                't', 'i', 'o', 'n'],
               tuple4
                 ['s', 'i', 'm', 'p', 'l', 'i', 'f', 'y', 'C', 'o', 'n', 'd',
                   'i', 't', 'i', 'o', 'n']
                 cc (substa xml2name) cc (xml2cond_constraint_prf xml2name)
                 Simplify_Condition),
             (['i', 'n', 'd', 'u', 'c', 't', 'i', 'o', 'n'],
               triple ['i', 'n', 'd', 'u', 'c', 't', 'i', 'o', 'n'] cc
                 (many ['c', 'o', 'n', 'j', 'u', 'n', 'c', 't', 's'] cc id)
                 (many ['r', 'u', 'l', 'e', 'C', 'o', 'n', 's', 't', 'r', 'a',
                         'i', 'n', 't', 'P', 'r', 'o', 'o', 'f', 's']
                   (tuple4
                     ['r', 'u', 'l', 'e', 'C', 'o', 'n', 's', 't', 'r', 'a',
                       'i', 'n', 't', 'P', 'r', 'o', 'o', 'f']
                     (rule xml2name)
                     (many ['s', 'u', 'b', 't', 'e', 'r', 'm', 'V', 'a', 'r',
                             'E', 'n', 't', 'r', 'i', 'e', 's']
                       (many1
                         ['s', 'u', 'b', 't', 'e', 'r', 'm', 'V', 'a', 'r', 'E',
                           'n', 't', 'r', 'y']
                         (term xml2name) (text ['v', 'a', 'r'])
                         (\ a b -> (a, b)))
                       id)
                     cc (xml2cond_constraint_prf xml2name)
                     (\ lr rys cca p -> (lr, (rys, (cca, p)))))
                   id)
                 Induction),
             (['d', 'e', 'l', 'e', 't', 'e', 'C', 'o', 'n', 'd', 'i', 't', 'i',
                'o', 'n'],
               pair ['d', 'e', 'l', 'e', 't', 'e', 'C', 'o', 'n', 'd', 'i', 't',
                      'i', 'o', 'n']
                 cc (xml2cond_constraint_prf xml2name) Delete_Condition)])
         id x;

xml2cond_red_pair_proof ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Cond_red_pair_prf a [Prelude.Char]);
xml2cond_red_pair_proof xml2name =
  tuple4
    ['c', 'o', 'n', 'd', 'R', 'e', 'd', 'P', 'a', 'i', 'r', 'P', 'r', 'o', 'o',
      'f']
    xml2name (nata ['b', 'e', 'f', 'o', 'r', 'e'])
    (nata ['a', 'f', 't', 'e', 'r'])
    (many ['c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n', 's']
      (triple ['c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n']
        (xml2cond_constraint xml2name)
        (singleton ['d', 'p', 'S', 'e', 'q', 'u', 'e', 'n', 'c', 'e']
          (rules xml2name) id)
        (xml2cond_constraint_prf xml2name) (\ c s p -> (c, (s, p))))
      id)
    (\ c b a ccs -> Cond_Red_Pair_Prf c ccs b a);

xml1many2elements_gen ::
  forall a b c d e.
    [Prelude.Char] ->
      (Xml -> Sum_bot [Prelude.Char] a) ->
        (a -> Xml -> Sum_bot [Prelude.Char] b) ->
          (Xml -> Sum_bot [Prelude.Char] c) ->
            (Xml -> Sum_bot [Prelude.Char] d) ->
              (a -> [b] -> c -> d -> e) -> Xml -> Sum_bot [Prelude.Char] e;
xml1many2elements_gen tag p1 p2 p3 p4 f (Xml name atts cs text) =
  let {
    ds = reverse cs;
    l = size_list cs;
  } in (if name == tag &&
             null atts && is_none text && less_eq_nat (Nat_of_num (Bit1 One)) l
         then binda (p1 (nth cs Zero_nat))
                (\ x ->
                  binda (map_sum_bot (p2 x)
                          (tl (take (minus_nat l (Nat_of_num (Bit0 One))) cs)))
                    (\ xs ->
                      binda (p3 (nth ds (Nat_of_num One)))
                        (\ y ->
                          binda (p4 (nth ds Zero_nat))
                            (\ z -> returna (f x xs y z)))))
         else fail tag (Xml name atts cs text));

projected_rseq ::
  forall a.
    (Eq a) => (Xml -> Sum_bot [Prelude.Char] a) ->
                ((a, Nat) -> Nat) ->
                  Xml ->
                    Sum_bot [Prelude.Char]
                      ((Term a [Prelude.Char], Term a [Prelude.Char]),
                        [(Pos, ((Term a [Prelude.Char], Term a [Prelude.Char]),
                                 Term a [Prelude.Char]))]);
projected_rseq xml2name pi (Xml name atts cs text) =
  let {
    tag = ['p', 'r', 'o', 'j', 'e', 'c', 't', 'e', 'd', 'R', 'e', 'w', 'r', 'i',
            't', 'e', 'S', 'e', 'q', 'u', 'e', 'n', 'c', 'e'];
  } in (if name == tag &&
             null atts &&
               is_none text && equal_nat (size_list cs) (Nat_of_num (Bit0 One))
         then binda (rule xml2name (nth cs Zero_nat))
                (\ r -> rseq xml2name pi r (nth cs (Nat_of_num One)))
         else fail tag (Xml name atts cs text));

strategy_to_Q ::
  forall a b.
    (Eq a, Eq b) => Strategy a b -> [(Term a b, Term a b)] -> [Term a b];
strategy_to_Q No_Strategy uu = [];
strategy_to_Q Innermost r = remdups (map fst r);
strategy_to_Q (Innermost_Q q) uv = q;

xml2dp_inputa ::
  forall a b.
    (Eq a,
      Eq b) => (Xml -> Sum_bot [Prelude.Char] (Lab a b)) ->
                 Xml ->
                   Sum_bot [Prelude.Char]
                     (Bool,
                       (Bool,
                         ([(Term (Lab a b) [Prelude.Char],
                             Term (Lab a b) [Prelude.Char])],
                           ([(Term (Lab a b) [Prelude.Char],
                               Term (Lab a b) [Prelude.Char])],
                             ([Term (Lab a b) [Prelude.Char]],
                               ([(Term (Lab a b) [Prelude.Char],
                                   Term (Lab a b) [Prelude.Char])],
                                 [(Term (Lab a b) [Prelude.Char],
                                    Term (Lab a b) [Prelude.Char])]))))));
xml2dp_inputa xml2name =
  change (xml2dp_input xml2name)
    (\ (m, (p, (q, r))) ->
      (False, (m, (p, ([], (strategy_to_Q q r, ([], r)))))));

flat_contexts ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] [Ctxt a [Prelude.Char]];
flat_contexts xml2name =
  many ['f', 'l', 'a', 't', 'C', 'o', 'n', 't', 'e', 'x', 't', 's']
    (ctxt xml2name) id;

xml2dp_termination_proof ::
  forall a b.
    (Eq a, Key a, Eq b,
      Key b) => (Xml -> Sum_bot [Prelude.Char] (Lab a b)) ->
                  Xml ->
                    Sum_bot [Prelude.Char]
                      (Dp_termination_proof a b [Prelude.Char]);
xml2dp_termination_proof xml2name x =
  singleton ['d', 'p', 'P', 'r', 'o', 'o', 'f']
    (options
      [(['p', 'I', 's', 'E', 'm', 'p', 't', 'y'],
         leaf ['p', 'I', 's', 'E', 'm', 'p', 't', 'y'] P_is_Empty),
        (['d', 'e', 'p', 'G', 'r', 'a', 'p', 'h', 'P', 'r', 'o', 'c'],
          many ['d', 'e', 'p', 'G', 'r', 'a', 'p', 'h', 'P', 'r', 'o', 'c']
            (xml2nd_choice ['c', 'o', 'm', 'p', 'o', 'n', 'e', 'n', 't']
              (singleton ['d', 'p', 's'] (rules xml2name) id)
              ['r', 'e', 'a', 'l', 'S', 'c', 'c']
              (xml2dp_termination_proof xml2name)
              (\ dps prfOpt -> (prfOpt, dps)))
            Dep_Graph_Proc),
        (['r', 'e', 'd', 'P', 'a', 'i', 'r', 'P', 'r', 'o', 'c'],
          triple ['r', 'e', 'd', 'P', 'a', 'i', 'r', 'P', 'r', 'o', 'c']
            (ordering_constraint_proof False xml2name)
            (singleton ['d', 'p', 's'] (rules xml2name) id)
            (xml2dp_termination_proof xml2name) Redpair_Proc),
        (['u', 's', 'a', 'b', 'l', 'e', 'R', 'u', 'l', 'e', 's', 'P', 'r', 'o',
           'c'],
          pair ['u', 's', 'a', 'b', 'l', 'e', 'R', 'u', 'l', 'e', 's', 'P', 'r',
                 'o', 'c']
            (singleton ['u', 's', 'a', 'b', 'l', 'e', 'R', 'u', 'l', 'e', 's']
              (rules xml2name) id)
            (xml2dp_termination_proof xml2name) Usable_Rules_Proc),
        (['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't', 'L', 'h', 's', 's', 'R',
           'e', 'm', 'o', 'v', 'a', 'l', 'P', 'r', 'o', 'c'],
          pair ['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't', 'L', 'h', 's', 's',
                 'R', 'e', 'm', 'o', 'v', 'a', 'l', 'P', 'r', 'o', 'c']
            (innermostLhss xml2name) (xml2dp_termination_proof xml2name)
            Q_Reduction_Proc),
        (['r', 'e', 'w', 'r', 'i', 't', 'i', 'n', 'g', 'P', 'r', 'o', 'c'],
          guard (\ xa -> equal_nat (num_children xa) (Nat_of_num (Bit1 One)))
            (triple
              ['r', 'e', 'w', 'r', 'i', 't', 'i', 'n', 'g', 'P', 'r', 'o', 'c']
              (rule xml2name) (rstep xml2name)
              (xml2dp_termination_proof xml2name)
              (\ (s, t) (p, (lr, ta)) ->
                Rewriting_Proc Nothing (s, t) (s, ta) (s, ta) lr p))
            (guard
              (\ xa ->
                equal_nat (num_children xa) (Nat_of_num (Bit0 (Bit0 One))))
              (guard
                (\ xa ->
                  tag (nth (children xa) (Nat_of_num (Bit0 One))) ==
                    ['u', 's', 'a', 'b', 'l', 'e', 'R', 'u', 'l', 'e', 's'])
                (tuple4
                  ['r', 'e', 'w', 'r', 'i', 't', 'i', 'n', 'g', 'P', 'r', 'o',
                    'c']
                  (rule xml2name) (rstep xml2name)
                  (singleton
                    ['u', 's', 'a', 'b', 'l', 'e', 'R', 'u', 'l', 'e', 's']
                    (rules xml2name) id)
                  (xml2dp_termination_proof xml2name)
                  (\ (s, t) (p, (lr, ta)) u ->
                    Rewriting_Proc (Just u) (s, t) (s, ta) (s, ta) lr p))
                (tuple4
                  ['r', 'e', 'w', 'r', 'i', 't', 'i', 'n', 'g', 'P', 'r', 'o',
                    'c']
                  (rule xml2name) (rstep xml2name) (rule xml2name)
                  (xml2dp_termination_proof xml2name)
                  (\ (s, t) (p, (lr, ta)) st ->
                    Rewriting_Proc Nothing (s, t) (s, ta) st lr p)))
              (tuple5
                ['r', 'e', 'w', 'r', 'i', 't', 'i', 'n', 'g', 'P', 'r', 'o',
                  'c']
                (rule xml2name) (rstep xml2name) (rule xml2name)
                (singleton
                  ['u', 's', 'a', 'b', 'l', 'e', 'R', 'u', 'l', 'e', 's']
                  (rules xml2name) id)
                (xml2dp_termination_proof xml2name)
                (\ (s, t) (p, (lr, ta)) st u ->
                  Rewriting_Proc (Just u) (s, t) (s, ta) st lr p)))),
        (['n', 'a', 'r', 'r', 'o', 'w', 'i', 'n', 'g', 'P', 'r', 'o', 'c'],
          tuple4
            ['n', 'a', 'r', 'r', 'o', 'w', 'i', 'n', 'g', 'P', 'r', 'o', 'c']
            (rule xml2name) pos
            (singleton ['n', 'a', 'r', 'r', 'o', 'w', 'i', 'n', 'g', 's']
              (rules xml2name) id)
            (xml2dp_termination_proof xml2name) Narrowing_Proc),
        (['i', 'n', 's', 't', 'a', 'n', 't', 'i', 'a', 't', 'i', 'o', 'n', 'P',
           'r', 'o', 'c'],
          triple
            ['i', 'n', 's', 't', 'a', 'n', 't', 'i', 'a', 't', 'i', 'o', 'n',
              'P', 'r', 'o', 'c']
            (rule xml2name)
            (singleton
              ['i', 'n', 's', 't', 'a', 'n', 't', 'i', 'a', 't', 'i', 'o', 'n',
                's']
              (rules xml2name) id)
            (xml2dp_termination_proof xml2name) Instantiation_Proc),
        (['f', 'o', 'r', 'w', 'a', 'r', 'd', 'I', 'n', 's', 't', 'a', 'n', 't',
           'i', 'a', 't', 'i', 'o', 'n', 'P', 'r', 'o', 'c'],
          xml3to4elements
            ['f', 'o', 'r', 'w', 'a', 'r', 'd', 'I', 'n', 's', 't', 'a', 'n',
              't', 'i', 'a', 't', 'i', 'o', 'n', 'P', 'r', 'o', 'c']
            (rule xml2name)
            (singleton
              ['i', 'n', 's', 't', 'a', 'n', 't', 'i', 'a', 't', 'i', 'o', 'n',
                's']
              (rules xml2name) id)
            (singleton ['u', 's', 'a', 'b', 'l', 'e', 'R', 'u', 'l', 'e', 's']
              (rules xml2name) id)
            (xml2dp_termination_proof xml2name) Forward_Instantiation_Proc),
        (['s', 'e', 'm', 'l', 'a', 'b', 'P', 'r', 'o', 'c'],
          guard (\ xa ->
                  equal_nat (num_children xa) (Nat_of_num (Bit0 (Bit0 One))))
            (tuple4 ['s', 'e', 'm', 'l', 'a', 'b', 'P', 'r', 'o', 'c']
              (sl_variant xml2name)
              (singleton ['d', 'p', 's'] (rules xml2name) id)
              (singleton ['t', 'r', 's'] (rules xml2name) id)
              (xml2dp_termination_proof xml2name)
              (\ sli lp -> Semlab_Proc sli lp []))
            (tuple5 ['s', 'e', 'm', 'l', 'a', 'b', 'P', 'r', 'o', 'c']
              (sl_variant xml2name)
              (singleton ['d', 'p', 's'] (rules xml2name) id)
              (singleton ['t', 'r', 's'] (rules xml2name) id)
              (innermostLhss xml2name) (xml2dp_termination_proof xml2name)
              (\ sli lp lr lq -> Semlab_Proc sli lp lq lr))),
        (['s', 'u', 'b', 't', 'e', 'r', 'm', 'P', 'r', 'o', 'c'],
          xml1many2elements_gen
            ['s', 'u', 'b', 't', 'e', 'r', 'm', 'P', 'r', 'o', 'c']
            (proj xml2name) (\ pi -> projected_rseq xml2name (create_proj pi))
            (singleton ['d', 'p', 's'] (rules xml2name) id)
            (xml2dp_termination_proof xml2name) Subterm_Criterion_Proc),
        (['r', 'e', 'd', 'P', 'a', 'i', 'r', 'U', 'r', 'P', 'r', 'o', 'c'],
          tuple4
            ['r', 'e', 'd', 'P', 'a', 'i', 'r', 'U', 'r', 'P', 'r', 'o', 'c']
            (ordering_constraint_proof False xml2name)
            (singleton ['d', 'p', 's'] (rules xml2name) id)
            (singleton ['u', 's', 'a', 'b', 'l', 'e', 'R', 'u', 'l', 'e', 's']
              (rules xml2name) id)
            (xml2dp_termination_proof xml2name) Redpair_UR_Proc),
        (['m', 'o', 'n', 'o', 'R', 'e', 'd', 'P', 'a', 'i', 'r', 'U', 'r', 'P',
           'r', 'o', 'c'],
          tuple5
            ['m', 'o', 'n', 'o', 'R', 'e', 'd', 'P', 'a', 'i', 'r', 'U', 'r',
              'P', 'r', 'o', 'c']
            (ordering_constraint_proofa False xml2name)
            (singleton ['d', 'p', 's'] (rules xml2name) id)
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (singleton ['u', 's', 'a', 'b', 'l', 'e', 'R', 'u', 'l', 'e', 's']
              (rules xml2name) id)
            (xml2dp_termination_proof xml2name) Mono_Redpair_UR_Proc),
        (['m', 'o', 'n', 'o', 'R', 'e', 'd', 'P', 'a', 'i', 'r', 'P', 'r', 'o',
           'c'],
          tuple4
            ['m', 'o', 'n', 'o', 'R', 'e', 'd', 'P', 'a', 'i', 'r', 'P', 'r',
              'o', 'c']
            (ordering_constraint_proofa False xml2name)
            (singleton ['d', 'p', 's'] (rules xml2name) id)
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (xml2dp_termination_proof xml2name) Mono_Redpair_Proc),
        (['u', 'n', 'c', 'u', 'r', 'r', 'y', 'P', 'r', 'o', 'c'],
          guard (\ xa ->
                  equal_nat (num_children xa) (Nat_of_num (Bit0 (Bit0 One))))
            (tuple4 ['u', 'n', 'c', 'u', 'r', 'r', 'y', 'P', 'r', 'o', 'c']
              (uncurry_info xml2name)
              (singleton ['d', 'p', 's'] (rules xml2name) id)
              (singleton ['t', 'r', 's'] (rules xml2name) id)
              (xml2dp_termination_proof xml2name) (Uncurry_Proc Nothing))
            (tuple5 ['u', 'n', 'c', 'u', 'r', 'r', 'y', 'P', 'r', 'o', 'c']
              (nata ['a', 'p', 'p', 'l', 'i', 'c', 'a', 't', 'i', 'v', 'e', 'T',
                      'o', 'p'])
              (uncurry_info xml2name)
              (singleton ['d', 'p', 's'] (rules xml2name) id)
              (singleton ['t', 'r', 's'] (rules xml2name) id)
              (xml2dp_termination_proof xml2name)
              (\ n -> Uncurry_Proc (Just n)))),
        (['f', 'l', 'a', 't', 'C', 'o', 'n', 't', 'e', 'x', 't', 'C', 'l', 'o',
           's', 'u', 'r', 'e', 'P', 'r', 'o', 'c'],
          tuple5
            ['f', 'l', 'a', 't', 'C', 'o', 'n', 't', 'e', 'x', 't', 'C', 'l',
              'o', 's', 'u', 'r', 'e', 'P', 'r', 'o', 'c']
            (singleton ['f', 'r', 'e', 's', 'h', 'S', 'y', 'm', 'b', 'o', 'l']
              xml2name id)
            (flat_contexts xml2name)
            (singleton ['d', 'p', 's'] (rules xml2name) id)
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (xml2dp_termination_proof xml2name) Fcc_Proc),
        (['s', 'w', 'i', 't', 'c', 'h', 'I', 'n', 'n', 'e', 'r', 'm', 'o', 's',
           't', 'P', 'r', 'o', 'c'],
          pair ['s', 'w', 'i', 't', 'c', 'h', 'I', 'n', 'n', 'e', 'r', 'm', 'o',
                 's', 't', 'P', 'r', 'o', 'c']
            (wcr_proof xml2name) (xml2dp_termination_proof xml2name)
            Switch_Innermost_Proc),
        (['s', 'p', 'l', 'i', 't', 'P', 'r', 'o', 'c'],
          tuple4 ['s', 'p', 'l', 'i', 't', 'P', 'r', 'o', 'c']
            (singleton ['d', 'p', 's'] (rules xml2name) id)
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (xml2dp_termination_proof xml2name)
            (xml2dp_termination_proof xml2name) Split_Proc),
        (['f', 'i', 'n', 'i', 't', 'e', 'n', 'e', 's', 's', 'A', 's', 's', 'u',
           'm', 'p', 't', 'i', 'o', 'n'],
          singleton
            ['f', 'i', 'n', 'i', 't', 'e', 'n', 'e', 's', 's', 'A', 's', 's',
              'u', 'm', 'p', 't', 'i', 'o', 'n']
            (xml2dp_inputa xml2name) (\ dpp -> Assume_Finite dpp [])),
        (['u', 'n', 'k', 'n', 'o', 'w', 'n', 'P', 'r', 'o', 'o', 'f'],
          many2 ['u', 'n', 'k', 'n', 'o', 'w', 'n', 'P', 'r', 'o', 'o', 'f']
            (text ['d', 'e', 's', 'c', 'r', 'i', 'p', 't', 'i', 'o', 'n'])
            (xml2dp_inputa xml2name)
            (pair ['s', 'u', 'b', 'P', 'r', 'o', 'o', 'f']
              (xml2dp_inputa xml2name) (xml2dp_termination_proof xml2name)
              (\ a b -> (a, b)))
            (\ _ -> Assume_Finite)),
        (['u', 'n', 'l', 'a', 'b', 'P', 'r', 'o', 'c'],
          triple ['u', 'n', 'l', 'a', 'b', 'P', 'r', 'o', 'c']
            (singleton ['d', 'p', 's'] (rules xml2name) id)
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (xml2dp_termination_proof xml2name) Unlab_Proc),
        (['g', 'e', 'n', 'e', 'r', 'a', 'l', 'R', 'e', 'd', 'P', 'a', 'i', 'r',
           'P', 'r', 'o', 'c'],
          guard (\ xa ->
                  equal_nat (num_children xa) (Nat_of_num (Bit1 (Bit0 One))))
            (tuple5
              ['g', 'e', 'n', 'e', 'r', 'a', 'l', 'R', 'e', 'd', 'P', 'a', 'i',
                'r', 'P', 'r', 'o', 'c']
              (ordering_constraint_proofa True xml2name)
              (singleton ['s', 't', 'r', 'i', 'c', 't'] (rules xml2name) id)
              (singleton ['b', 'o', 'u', 'n', 'd'] (rules xml2name) id)
              (xml2cond_red_pair_proof xml2name)
              (xml2dp_termination_proof xml2name)
              (\ rp s b c p -> General_Redpair_Proc rp s b c [p]))
            (tuple6
              ['g', 'e', 'n', 'e', 'r', 'a', 'l', 'R', 'e', 'd', 'P', 'a', 'i',
                'r', 'P', 'r', 'o', 'c']
              (ordering_constraint_proofa True xml2name)
              (singleton ['s', 't', 'r', 'i', 'c', 't'] (rules xml2name) id)
              (singleton ['b', 'o', 'u', 'n', 'd'] (rules xml2name) id)
              (xml2cond_red_pair_proof xml2name)
              (xml2dp_termination_proof xml2name)
              (xml2dp_termination_proof xml2name)
              (\ rp s b c ps pb -> General_Redpair_Proc rp s b c [ps, pb]))),
        (['c', 'o', 'm', 'p', 'l', 'e', 'x', 'C', 'o', 'n', 's', 't', 'a', 'n',
           't', 'R', 'e', 'm', 'o', 'v', 'a', 'l', 'P', 'r', 'o', 'c'],
          triple
            ['c', 'o', 'm', 'p', 'l', 'e', 'x', 'C', 'o', 'n', 's', 't', 'a',
              'n', 't', 'R', 'e', 'm', 'o', 'v', 'a', 'l', 'P', 'r', 'o', 'c']
            (term xml2name)
            (many ['r', 'u', 'l', 'e', 'M', 'a', 'p']
              (pair ['r', 'u', 'l', 'e', 'M', 'a', 'p', 'E', 'n', 't', 'r', 'y']
                (rule xml2name) (rule xml2name) (\ a b -> (a, b)))
              id)
            (xml2dp_termination_proof xml2name)
            (\ t rls ->
              Complex_Constant_Removal_Proc
                (Complex_Constant_Removal_Proof t rls))),
        (['s', 'i', 'z', 'e', 'C', 'h', 'a', 'n', 'g', 'e', 'P', 'r', 'o', 'c'],
          many1 ['s', 'i', 'z', 'e', 'C', 'h', 'a', 'n', 'g', 'e', 'P', 'r',
                  'o', 'c']
            (options
              [(['s', 'u', 'b', 't', 'e', 'r', 'm', 'C', 'r', 'i', 't', 'e',
                  'r', 'i', 'o', 'n'],
                 leaf ['s', 'u', 'b', 't', 'e', 'r', 'm', 'C', 'r', 'i', 't',
                        'e', 'r', 'i', 'o', 'n']
                   Nothing),
                (['r', 'e', 'd', 'u', 'c', 't', 'i', 'o', 'n', 'P', 'a', 'i',
                   'r'],
                  xml1to2elements
                    ['r', 'e', 'd', 'u', 'c', 't', 'i', 'o', 'n', 'P', 'a', 'i',
                      'r']
                    (ordering_constraint_proofa False xml2name)
                    (singleton
                      ['u', 's', 'a', 'b', 'l', 'e', 'R', 'u', 'l', 'e', 's']
                      (rules xml2name) id)
                    (\ redp ur -> Just (redp, ur)))])
            (scg xml2name)
            (\ a ->
              (case a of {
                Nothing -> Size_Change_Subterm_Proc;
                Just redp_ur ->
                  Size_Change_Redpair_Proc (fst redp_ur) (snd redp_ur);
              })))])
    id x;

xml2trs_inputa ::
  forall a b.
    (Eq a,
      Eq b) => (Xml -> Sum_bot [Prelude.Char] (Lab a b)) ->
                 Xml ->
                   Sum_bot [Prelude.Char]
                     (Bool,
                       ([Term (Lab a b) [Prelude.Char]],
                         ([(Term (Lab a b) [Prelude.Char],
                             Term (Lab a b) [Prelude.Char])],
                           [(Term (Lab a b) [Prelude.Char],
                              Term (Lab a b) [Prelude.Char])])));
xml2trs_inputa xml2name =
  change (xml2trs_input xml2name)
    (\ (q, (r, so)) ->
      (False,
        (strategy_to_Q q r,
          (r, (case so of {
                Nothing -> [];
                Just s -> s;
              })))));

xml2trs_termination_proof ::
  forall a.
    (Eq a,
      Key a) => (Xml -> Sum_bot [Prelude.Char] (Lab a [Nat])) ->
                  Xml ->
                    Sum_bot [Prelude.Char]
                      (Trs_termination_proof a [Nat] [Prelude.Char]);
xml2trs_termination_proof xml2name x =
  singleton
    ['t', 'r', 's', 'T', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i', 'o', 'n', 'P',
      'r', 'o', 'o', 'f']
    (options
      [(['r', 'I', 's', 'E', 'm', 'p', 't', 'y'],
         leaf ['r', 'I', 's', 'E', 'm', 'p', 't', 'y'] R_is_Empty),
        (['s', 'e', 'm', 'l', 'a', 'b'],
          guard (\ xa -> equal_nat (num_children xa) (Nat_of_num (Bit1 One)))
            (triple ['s', 'e', 'm', 'l', 'a', 'b'] (sl_variant xml2name)
              (singleton ['t', 'r', 's'] (rules xml2name) id)
              (xml2trs_termination_proof xml2name) (\ sli -> Semlab sli []))
            (tuple4 ['s', 'e', 'm', 'l', 'a', 'b'] (sl_variant xml2name)
              (singleton ['t', 'r', 's'] (rules xml2name) id)
              (innermostLhss xml2name) (xml2trs_termination_proof xml2name)
              (\ sli lr lq -> Semlab sli lq lr))),
        (['s', 'p', 'l', 'i', 't'],
          triple ['s', 'p', 'l', 'i', 't']
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (xml2trs_termination_proof xml2name)
            (xml2trs_termination_proof xml2name) Split),
        (['d', 'p', 'T', 'r', 'a', 'n', 's'],
          triple ['d', 'p', 'T', 'r', 'a', 'n', 's']
            (singleton ['d', 'p', 's'] (rules xml2name) id)
            (bool ['m', 'a', 'r', 'k', 'e', 'd', 'S', 'y', 'm', 'b', 'o', 'l',
                    's'])
            (xml2dp_termination_proof xml2name)
            (\ dps _ -> DP_Trans False True dps)),
        (['r', 'u', 'l', 'e', 'R', 'e', 'm', 'o', 'v', 'a', 'l'],
          triple ['r', 'u', 'l', 'e', 'R', 'e', 'm', 'o', 'v', 'a', 'l']
            (ordering_constraint_proofa False xml2name)
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (xml2trs_termination_proof xml2name) Rule_Removal),
        (['b', 'o', 'u', 'n', 'd', 's'],
          (\ xml -> binda (bounds_info xml2name xml) (returna . Bounds))),
        (['s', 't', 'r', 'i', 'n', 'g', 'R', 'e', 'v', 'e', 'r', 's', 'a', 'l'],
          pair ['s', 't', 'r', 'i', 'n', 'g', 'R', 'e', 'v', 'e', 'r', 's', 'a',
                 'l']
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (xml2trs_termination_proof xml2name) (\ _ -> String_Reversal)),
        (['r', 'e', 'm', 'o', 'v', 'e', 'N', 'o', 'n', 'A', 'p', 'p', 'l', 'i',
           'c', 'a', 'b', 'l', 'e', 'R', 'u', 'l', 'e', 's'],
          pair ['r', 'e', 'm', 'o', 'v', 'e', 'N', 'o', 'n', 'A', 'p', 'p', 'l',
                 'i', 'c', 'a', 'b', 'l', 'e', 'R', 'u', 'l', 'e', 's']
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (xml2trs_termination_proof xml2name) Remove_Nonapplicable_Rules),
        (['u', 'n', 'c', 'u', 'r', 'r', 'y'],
          triple ['u', 'n', 'c', 'u', 'r', 'r', 'y'] (uncurry_info xml2name)
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (xml2trs_termination_proof xml2name) Uncurry),
        (['f', 'l', 'a', 't', 'C', 'o', 'n', 't', 'e', 'x', 't', 'C', 'l', 'o',
           's', 'u', 'r', 'e'],
          triple
            ['f', 'l', 'a', 't', 'C', 'o', 'n', 't', 'e', 'x', 't', 'C', 'l',
              'o', 's', 'u', 'r', 'e']
            (flat_contexts xml2name)
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (xml2trs_termination_proof xml2name) Fcc),
        (['s', 'w', 'i', 't', 'c', 'h', 'I', 'n', 'n', 'e', 'r', 'm', 'o', 's',
           't'],
          pair ['s', 'w', 'i', 't', 'c', 'h', 'I', 'n', 'n', 'e', 'r', 'm', 'o',
                 's', 't']
            (wcr_proof xml2name) (xml2trs_termination_proof xml2name)
            Switch_Innermost),
        (['t', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i', 'o', 'n', 'A', 's', 's',
           'u', 'm', 'p', 't', 'i', 'o', 'n'],
          singleton
            ['t', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i', 'o', 'n', 'A', 's',
              's', 'u', 'm', 'p', 't', 'i', 'o', 'n']
            (xml2trs_inputa xml2name) (\ qtrs -> Assume_SN qtrs [])),
        (['u', 'n', 'k', 'n', 'o', 'w', 'n', 'P', 'r', 'o', 'o', 'f'],
          many2 ['u', 'n', 'k', 'n', 'o', 'w', 'n', 'P', 'r', 'o', 'o', 'f']
            (text ['d', 'e', 's', 'c', 'r', 'i', 'p', 't', 'i', 'o', 'n'])
            (xml2trs_inputa xml2name)
            (pair ['s', 'u', 'b', 'P', 'r', 'o', 'o', 'f']
              (xml2trs_inputa xml2name) (xml2trs_termination_proof xml2name)
              (\ a b -> (a, b)))
            (\ _ -> Assume_SN))])
    id x;

xml2cr_proof ::
  forall a.
    (Eq a,
      Key a) => (Xml -> Sum_bot [Prelude.Char] (Lab a [Nat])) ->
                  Xml ->
                    Sum_bot [Prelude.Char] (Cr_proof a [Nat] [Prelude.Char]);
xml2cr_proof xml2name x =
  singleton ['c', 'r', 'P', 'r', 'o', 'o', 'f']
    (options
      [(['w', 'c', 'r', 'A', 'n', 'd', 'S', 'N'],
         pair ['w', 'c', 'r', 'A', 'n', 'd', 'S', 'N'] (wcr_proof xml2name)
           (xml2trs_termination_proof xml2name) SN_WCR),
        (['o', 'r', 't', 'h', 'o', 'g', 'o', 'n', 'a', 'l'],
          leaf ['o', 'r', 't', 'h', 'o', 'g', 'o', 'n', 'a', 'l']
            Weakly_Orthogonal),
        (['s', 't', 'r', 'o', 'n', 'g', 'l', 'y', 'C', 'l', 'o', 's', 'e', 'd'],
          change
            (nata ['s', 't', 'r', 'o', 'n', 'g', 'l', 'y', 'C', 'l', 'o', 's',
                    'e', 'd'])
            Strongly_Closed)])
    id x;

xml2eq_proof ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Eq_proof a [Prelude.Char]);
xml2eq_proof xml2name x =
  options
    [(['r', 'e', 'f', 'l'],
       singleton ['r', 'e', 'f', 'l'] (term xml2name) Refl),
      (['s', 'y', 'm'], singleton ['s', 'y', 'm'] (xml2eq_proof xml2name) Sym),
      (['t', 'r', 'a', 'n', 's'],
        pair ['t', 'r', 'a', 'n', 's'] (xml2eq_proof xml2name)
          (xml2eq_proof xml2name) Trans),
      (['a', 's', 's', 'm'],
        pair ['a', 's', 's', 'm'] (rule xml2name) (substa xml2name)
          (\ r s -> Assm r (mk_subst Var s))),
      (['c', 'o', 'n', 'g'],
        many1 ['c', 'o', 'n', 'g'] xml2name (xml2eq_proof xml2name) Cong)]
    x;

ceq_ctxt :: forall a b. (Eq a, Eq b) => Maybe (Ctxt a b -> Ctxt a b -> Bool);
ceq_ctxt = Just equal_ctxt;

instance (Eq a, Eq b) => Ceq (Ctxt a b) where {
  ceq = ceq_ctxt;
};

instance (Countable a) => Countable [a] where {
};

nFQ_subset_NF_rulesb :: forall a b c d. Dpp_ops_ext a b c d -> a -> Bool;
nFQ_subset_NF_rulesb
  (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
    rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
    intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
    split_pairs split_rules mk minimal nfs wwf_rules more)
  = nFQ_subset_NF_rules;

is_QNFc :: forall a b c d. Dpp_ops_ext a b c d -> a -> Term b c -> Bool;
is_QNFc
  (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
    rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
    intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
    split_pairs split_rules mk minimal nfs wwf_rules more)
  = is_QNF;

rulesd :: forall a b c d. Dpp_ops_ext a b c d -> a -> [(Term b c, Term b c)];
rulesd
  (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
    rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
    intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
    split_pairs split_rules mk minimal nfs wwf_rules more)
  = rules;

icap_impl_dpp ::
  forall a b.
    (Eq b) => Dpp_ops_ext a b [Prelude.Char] () ->
                a -> [Term b [Prelude.Char]] ->
                       Term b [Prelude.Char] -> Term b (Sum () [Prelude.Char]);
icap_impl_dpp i d =
  let {
    qr = nFQ_subset_NF_rulesb i d;
    qnf = is_QNFc i d;
    r = rulesd i d;
    ic = icap_impl qr qnf (map fst r);
  } in (\ s ->
         let {
           a = ceta_set_of (concatMap vars_term_lista s);
         } in ic s a);

shows_kbo_repr ::
  forall a.
    (Showa a) => ([((a, Nat), (Nat, (Nat, Maybe [Nat])))], Nat) ->
                   [Prelude.Char] -> [Prelude.Char];
shows_kbo_repr (prs, w0) =
  shows_string
    ['K', 'B', 'O', ' ', 'w', 'i', 't', 'h', ' ', 't', 'h', 'e', ' ', 'f', 'o',
      'l', 'l', 'o', 'w', 'i', 'n', 'g', ' ', 'p', 'r', 'e', 'c', 'e', 'd', 'e',
      'n', 'c', 'e', ' ', 'a', 'n', 'd', ' ', 'w', 'e', 'i', 'g', 'h', 't', ' ',
      'f', 'u', 'n', 'c', 't', 'i', 'o', 'n'] .
    shows_nl .
      shows_map
        (\ (a, b) ->
          let {
            (f, n) = a;
          } in (\ (pr, (_, _)) ->
                 shows_string
                   ['p', 'r', 'e', 'c', 'e', 'd', 'e', 'n', 'c', 'e', '('] .
                   shows_prec Zero_nat f .
                     shows_string ['['] .
                       shows_prec_nat Zero_nat n .
                         shows_string [']', ')', ' ', '=', ' '] .
                           shows_prec_nat Zero_nat pr . shows_nl)
            b)
        prs .
        shows_nl .
          shows_string
            ['p', 'r', 'e', 'c', 'e', 'd', 'e', 'n', 'c', 'e', '(', '_', ')',
              ' ', '=', ' ', '0'] .
            shows_nl .
              shows_string
                ['a', 'n', 'd', ' ', 't', 'h', 'e', ' ', 'f', 'o', 'l', 'l',
                  'o', 'w', 'i', 'n', 'g', ' ', 'w', 'e', 'i', 'g', 'h', 't'] .
                shows_nl .
                  shows_map
                    (\ (a, b) ->
                      let {
                        (f, n) = a;
                      } in (\ (_, (w, _)) ->
                             shows_string ['w', 'e', 'i', 'g', 'h', 't', '('] .
                               shows_prec Zero_nat f .
                                 shows_string ['['] .
                                   shows_prec_nat Zero_nat n .
                                     shows_string [']', ')', ' ', '=', ' '] .
                                       shows_prec_nat Zero_nat w . shows_nl)
                        b)
                    prs .
                    shows_nl .
                      shows_string
                        ['w', 'e', 'i', 'g', 'h', 't', '(', '_', ')', ' ', '=',
                          ' '] .
                        shows_prec_nat Zero_nat (plus_nat w0 (Nat_of_num One)) .
                          shows_nl .
                            shows_prec_list Zero_nat ['w', '0', ' ', '=', ' '] .
                              shows_prec_nat Zero_nat w0 .
                                shows_string
                                  (shows_nl
                                    ['a', 'n', 'd', ' ', 't', 'h', 'e', ' ',
                                      'f', 'o', 'l', 'l', 'o', 'w', 'i', 'n',
                                      'g', ' ', 's', 'u', 'b', 't', 'e', 'r',
                                      'm', ' ', 'c', 'o', 'e', 'f', 'f', 'i',
                                      'c', 'i', 'e', 'n', 't', ' ', 'f', 'u',
                                      'n', 'c', 't', 'i', 'o', 'n', 's']) .
                                  shows_nl .
                                    shows_map
                                      (\ (a, b) ->
let {
  (f, n) = a;
} in (\ (_, (_, scf)) ->
       shows_string ['s', 'c', 'f', '('] .
         shows_prec Zero_nat f .
           shows_string ['['] .
             shows_prec_nat Zero_nat n .
               shows_string [']', ')', ' ', '=', ' '] .
                 (if is_none scf
                   then shows_prec_list Zero_nat ['a', 'l', 'l', ' ', '1']
                   else shows_prec_list Zero_nat (the scf)) .
                   shows_nl)
  b)
                                      prs .
                                      shows_nl .
shows_prec_list Zero_nat
  ['s', 'c', 'f', '(', '_', ')', ' ', '=', ' ', 'a', 'l', 'l', ' ', '1'] .
  shows_nl;

data L_poly a b = LPoly b [(a, b)];

sym_collect :: forall a b. (Term a b -> Bool) -> Term a b -> [a];
sym_collect p (Var x) = [];
sym_collect p (Fun f ts) =
  (if p (Fun f ts) then [f] else []) ++ concatMap (sym_collect p) ts;

descb ::
  forall a b c. Non_inf_order_ext a b c -> [Prelude.Char] -> [Prelude.Char];
descb (Non_inf_order_ext valid ns cc af desc more) = desc;

shows_prec_pos :: Nat -> Pos -> [Prelude.Char] -> [Prelude.Char];
shows_prec_pos d p = shows_pos p;

mk_rtrancl_list_main ::
  forall a. (a -> a -> Bool) -> (a -> [a]) -> [a] -> [a] -> [a];
mk_rtrancl_list_main subsumes r todo fin =
  (case todo of {
    [] -> fin;
    a : tod ->
      (if any (\ b -> subsumes b a) fin
        then mk_rtrancl_list_main subsumes r tod fin
        else mk_rtrancl_list_main subsumes r (r a ++ tod) (a : fin));
  });

mk_rtrancl_list :: forall a. (a -> a -> Bool) -> (a -> [a]) -> [a] -> [a];
mk_rtrancl_list subsumes r init = mk_rtrancl_list_main subsumes r init [];

shows_list_prod ::
  forall a b.
    (Showa a, Showa b) => [(a, b)] -> [Prelude.Char] -> [Prelude.Char];
shows_list_prod = shows_list_aux (shows_prec_prod Zero_nat);

instance (Showa a, Showa b) => Showa (a, b) where {
  shows_prec = shows_prec_prod;
  shows_list = shows_list_prod;
};

subst_compose_impl ::
  forall a b.
    (Eq a, Eq b) => [(a, Term b a)] -> [(a, Term b a)] -> [(a, Term b a)];
subst_compose_impl sigma tau =
  let {
    sigmaa = mk_subst_domain sigma;
    taua = mk_subst_domain tau;
    d_sigma = map fst sigmaa;
  } in map (\ (x, t) -> (x, subst_apply_term t (mk_subst Var taua))) sigmaa ++
         filter (\ (x, _) -> not (membera d_sigma x)) taua;

commutes_impl ::
  forall a b.
    (Cenum a, Ceq a, Corder a, Eq a, Linorder a, Eq b,
      Linorder b) => [(a, Term b a)] -> [(a, Term b a)] -> Bool;
commutes_impl sigma mu =
  subst_eq (subst_compose_impl sigma mu) (subst_compose_impl mu sigma);

mk_subst_case ::
  forall a b.
    (Eq a,
      Eq b) => [a] -> (a -> Term b a) -> [(a, Term b a)] -> [(a, Term b a)];
mk_subst_case xs sigma tau =
  subst_compose_impl (map (\ x -> (x, sigma x)) xs) tau;

funas_term_list :: forall a b. Term a b -> [(a, Nat)];
funas_term_list (Var uu) = [];
funas_term_list (Fun f ts) = (f, size_list ts) : concatMap funas_term_list ts;

funas_rule_list :: forall a b. (Term a b, Term a b) -> [(a, Nat)];
funas_rule_list r = funas_term_list (fst r) ++ funas_term_list (snd r);

funas_trs_list :: forall a b. (Eq a) => [(Term a b, Term a b)] -> [(a, Nat)];
funas_trs_list r = remdups (concatMap funas_rule_list r);

add_funs_term_list :: forall a b. Term a b -> [a] -> [a];
add_funs_term_list =
  folda (const id) (\ f xs -> (\ a -> f : a) . foldr (\ a b -> a . b) xs id);

funs_term_list :: forall a b. Term a b -> [a];
funs_term_list t = add_funs_term_list t [];

funs_rule_lista :: forall a b. (Term a b, Term a b) -> [a];
funs_rule_lista r = funs_term_list (fst r) ++ funs_term_list (snd r);

funs_rule_list :: forall a b. (Eq a) => (Term a b, Term a b) -> [a];
funs_rule_list r = remdups (funs_rule_lista r);

vars_rule_list :: forall a b. (Eq b) => (Term a b, Term a b) -> [b];
vars_rule_list r = remdups (vars_rule_lista r);

uncurry_of_sig_list ::
  forall a.
    a -> [((a, Nat), [a])] ->
           (a -> Nat -> [a]) ->
             [(Term a [Prelude.Char], Term a [Prelude.Char])];
uncurry_of_sig_list a sml sm =
  concatMap
    (\ (b, c) ->
      let {
        (f, n) = b;
      } in (\ _ ->
             let {
               g = get_symbol sm f n;
             } in map (\ i ->
                        (Fun a [generate_f_xs (g i) (plus_nat n i),
                                 Var (generate_var (plus_nat n i))],
                          generate_f_xs (g (plus_nat i (Nat_of_num One)))
                            (plus_nat n (plus_nat i (Nat_of_num One)))))
                    (upt Zero_nat (aarity sm f n)))
        c)
    sml;

sig_list_to_sig_map ::
  forall a.
    (Eq a) => a -> [((a, Nat), [a])] ->
                     ([((a, Nat), [a])] -> a -> Nat -> a) -> a -> Nat -> [a];
sig_list_to_sig_map a sml fmap =
  let {
    fm = fmap sml;
  } in (\ f n ->
         (case map_of sml (f, n) of {
           Nothing -> [fm f n];
           Just xs -> (if null xs then [fm f n] else xs);
         }));

uncurry_eta_split ::
  forall a b.
    (Eq a,
      Eq b) => [(Term a b, Term a b)] ->
                 [(Term a b, Term a b)] ->
                   ([(Term a b, Term a b)], [(Term a b, Term a b)]);
uncurry_eta_split eboth rtest =
  let {
    test =
      (\ (l, r) ->
        less_nat Zero_nat (num_args l) &&
          less_nat Zero_nat (num_args r) &&
            any (eq_rule_mod_vars (hd (args l), hd (args r))) rtest);
  } in partition test eboth;

eta_closed_rules ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => a -> (a -> Nat -> [a]) ->
                         [(Term a b, Term a b)] ->
                           [(Term a b, Term a b)] ->
                             Sum ([Prelude.Char] -> [Prelude.Char]) ();
eta_closed_rules a sm ra r =
  catcha
    (forallM
      (\ (l, raa) ->
        (case aarity_term a sm l of {
          Nothing -> Inr ();
          Just ab ->
            (if equal_nat ab Zero_nat then Inr ()
              else check (any (\ (lll, rrr) ->
                                (case (lll, rrr) of {
                                  (Var _, b) -> False;
                                  (Fun f [], b) -> False;
                                  (Fun f [ll], b) -> False;
                                  (Fun f [ll, Var x], Var _) -> False;
                                  (Fun f [ll, Var x], Fun g []) -> False;
                                  (Fun f [ll, Var x], Fun g [rr]) -> False;
                                  (Fun f [ll, Var x], Fun g [rr, Var y]) ->
                                    f == a &&
                                      g == a &&
x == y &&
  not (membera (vars_rule_list (ll, rr)) x) && instance_rule (l, raa) (ll, rr);
                                  (Fun f [ll, Var x],
                                    Fun g (rr : Var y : _ : _))
                                    -> False;
                                  (Fun f [ll, Var x],
                                    Fun g (rr : Fun _ _ : list))
                                    -> False;
                                  (Fun f (ll : Var x : _ : _), b) -> False;
                                  (Fun f (ll : Fun _ _ : list), b) -> False;
                                }))
                           r)
                     (shows_prec_list Zero_nat
                        ['e', 't', 'a', ' ', 'e', 'x', 'p', 'a', 'n', 's', 'i',
                          'o', 'n', ' ', 'o', 'f', ' '] .
                       shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                         [' ', '-', '>', ' '] (l, raa) .
                         shows_prec_list Zero_nat
                           [' ', 'm', 'i', 's', 's', 'i', 'n', 'g']));
        }))
      ra)
    (\ x -> Inl (snd x));

rwa :: forall a b c d. Tp_ops_ext a b c d -> a -> [(Term b c, Term b c)];
rwa (Tp_ops_ext qreltrs q r rw rules q_empty is_QNF nFQ_subset_NF_rules
      rules_map delete_R_Rw split_rules mk nfs more)
  = rw;

uncurry_rules ::
  forall a b.
    (Eq a) => a -> (a -> Nat -> [a]) ->
                     [(Term a b, Term a b)] -> [(Term a b, Term a b)];
uncurry_rules a sm =
  map (\ (l, r) -> (uncurry_term a sm l, uncurry_term a sm r));

check_CS_subseteq ::
  forall a b.
    (Eq a,
      Eq b) => [(Term a b, Term a b)] ->
                 [(Term a b, Term a b)] -> Sum (Term a b, Term a b) ();
check_CS_subseteq r s =
  catcha
    (forallM (\ (l, ra) -> check (any (instance_rule (l, ra)) s) (l, ra)) r)
    (\ x -> Inl (snd x));

ra :: forall a b c d. Tp_ops_ext a b c d -> a -> [(Term b c, Term b c)];
ra (Tp_ops_ext qreltrs q r rw rules q_empty is_QNF nFQ_subset_NF_rules rules_map
     delete_R_Rw split_rules mk nfs more)
  = r;

uncurry_tt ::
  forall a b.
    (Eq b,
      Showa b) => Tp_ops_ext a b [Prelude.Char] () ->
                    (b, ([((b, Nat), [b])],
                          ([(Term b [Prelude.Char], Term b [Prelude.Char])],
                            [(Term b [Prelude.Char],
                               Term b [Prelude.Char])]))) ->
                      [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                        a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
uncurry_tt i info r tp =
  let {
    (a, (sml, (u, eb))) = info;
    raa = ra i tp;
    rw = rwa i tp;
    (e, ew) = uncurry_eta_split eb raa;
    r_eta = e ++ raa;
    rw_eta = ew ++ rw;
    rb_eta = r_eta ++ rw_eta;
    fmap = (\ _ f _ -> f);
    sm = sig_list_to_sig_map a sml fmap;
    uR = uncurry_rules a sm r_eta;
    uRw = uncurry_rules a sm rw_eta;
  } in (case let {
               s = uncurry_of_sig_list a sml sm;
             } in bindb (catcha
                          (forallM
                            (\ (l, _) ->
                              check (hvf_term a l)
                                (shows_prec_list Zero_nat
                                   ['h', 'e', 'a', 'd', ' ', 'v', 'a', 'r', 'i',
                                     'a', 'b', 'l', 'e', ' ', 'i', 'n', ' ',
                                     'l', 'h', 's', ' '] .
                                  shows_term (shows_prec Zero_nat)
                                    (shows_prec_list Zero_nat) l .
                                    shows_prec_list Zero_nat
                                      [' ', 'n', 'o', 't', ' ', 'a', 'l', 'l',
'o', 'w', 'e', 'd']))
                            r_eta)
                          (\ x -> Inl (snd x)))
                    (\ _ ->
                      bindb (catcha
                              (forallM
                                (\ (l, _) ->
                                  check (hvf_term a l)
                                    (shows_prec_list Zero_nat
                                       ['h', 'e', 'a', 'd', ' ', 'v', 'a', 'r',
 'i', 'a', 'b', 'l', 'e', ' ', 'i', 'n', ' ', 'l', 'h', 's', ' '] .
                                      shows_term (shows_prec Zero_nat)
(shows_prec_list Zero_nat) l .
shows_prec_list Zero_nat
  [' ', 'n', 'o', 't', ' ', 'a', 'l', 'l', 'o', 'w', 'e', 'd']))
                                rw_eta)
                              (\ x -> Inl (snd x)))
                        (\ _ ->
                          bindb (eta_closed_rules a sm r_eta r_eta)
                            (\ _ ->
                              bindb (eta_closed_rules a sm rb_eta rb_eta)
                                (\ _ ->
                                  bindb (catcha
  (forallM
    (\ (l, rb) ->
      check (not (is_Var l))
        (shows_prec_list Zero_nat
           ['l', 'h', 's', ' ', 'm', 'u', 's', 't', ' ', 'n', 'o', 't', ' ',
             'b', 'e', ' ', 'a', ' ', 'v', 'a', 'r', 'i', 'a', 'b', 'l', 'e',
             ' ', 'i', 'n', ' ', 'r', 'u', 'l', 'e', ' '] .
          shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
            [' ', '-', '>', ' '] (l, rb)))
    rw_eta)
  (\ x -> Inl (snd x)))
                                    (\ _ ->
                                      bindb
(catcha (check_subseteq uR r)
  (\ x ->
    Inl (shows_prec_list Zero_nat
           ['u', 'n', 'c', 'u', 'r', 'r', 'i', 'e', 'd', ' ', 'r', 'u', 'l',
             'e', ' '] .
          shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
            [' ', '-', '>', ' '] x .
            shows_prec_list Zero_nat
              [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n', 'g'])))
(\ _ ->
  bindb (catcha (check_subseteq uRw r)
          (\ x ->
            Inl (shows_prec_list Zero_nat
                   ['u', 'n', 'c', 'u', 'r', 'r', 'i', 'e', 'd', ' ', 'r', 'u',
                     'l', 'e', ' '] .
                  shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
                    [' ', '-', '>', ' '] x .
                    shows_prec_list Zero_nat
                      [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n', 'g'])))
    (\ _ ->
      bindb (catcha (check_CS_subseteq s u)
              (\ x ->
                Inl (shows_prec_list Zero_nat
                       ['u', 'n', 'c', 'u', 'r', 'r', 'y', ' ', 'r', 'u', 'l',
                         'e', ' '] .
                      shows_rule (shows_prec Zero_nat)
                        (shows_prec_list Zero_nat) [' ', '-', '>', ' '] x .
                        shows_prec_list Zero_nat
                          [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n',
                            'g'])))
        (\ _ ->
          catcha (check_subseteq u r)
            (\ x ->
              Inl (shows_prec_list Zero_nat
                     ['u', 'n', 'c', 'u', 'r', 'r', 'y', ' ', 'r', 'u', 'l',
                       'e', ' '] .
                    shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
                      [' ', '-', '>', ' '] x .
                      shows_prec_list Zero_nat
                        [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n', 'g',
                          ' ', 'i', 'n', ' ', 'n', 'e', 'w', ' ', 'T', 'R',
                          'S']))))))))))
         of {
         Inl aa -> Inl aa;
         Inr _ -> Inr (mka i (nfsa i tp) [] uR (uRw ++ u));
       });

apply_af_entry :: forall a b. a -> Af_entry -> [Term a b] -> Term a b;
apply_af_entry uu (Collapse i) ts = nth ts i;
apply_af_entry f (AFList is) ts = Fun f (map (nth ts) is);

afs_term ::
  forall a b. ((a, Nat) -> Af_entry) -> Term a b -> Term (Filtered a) b;
afs_term pi (Fun f ts) =
  let {
    l = size_list ts;
  } in apply_af_entry (FPair f l) (pi (f, l)) (map (afs_term pi) ts);
afs_term pi (Var x) = Var x;

afs_rule ::
  forall a b.
    ((a, Nat) -> Af_entry) ->
      (Term a b, Term a b) -> (Term (Filtered a) b, Term (Filtered a) b);
afs_rule pi lr = (afs_term pi (fst lr), afs_term pi (snd lr));

doc_of_stringa :: [Prelude.Char] -> Sum [Prelude.Char] Xmldoc;
doc_of_stringa =
  debug ['0']
    ['p', 'a', 'r', 's', 'i', 'n', 'g', ' ', 't', 'x', 't', ' ', 't', 'o', ' ',
      'x', 'm', 'l']
    doc_of_string;

default_grd_fun ::
  forall a.
    (Eq a) => Term (Lab [Prelude.Char] a) [Prelude.Char] ->
                Term (Lab [Prelude.Char] a) [Prelude.Char] ->
                  [Prelude.Char] -> Term (Lab [Prelude.Char] a) [Prelude.Char];
default_grd_fun s t =
  let {
    f = funs_rule_list (s, t);
    m = fold (\ fa m ->
               (case fa of {
                 Lab _ _ -> m;
                 FunLab _ _ -> m;
                 UnLab _ -> m;
                 Sharp (Lab _ _) -> m;
                 Sharp (FunLab _ _) -> m;
                 Sharp (UnLab g) -> max (size_list g) m;
                 Sharp (Sharp _) -> m;
               }))
          f Zero_nat;
    suffix = replicate (plus_nat m (Nat_of_num One)) 'a';
  } in (\ x -> Fun (Sharp (UnLab (x ++ suffix))) []);

xml2nwcr_proof :: Xml -> Sum_bot [Prelude.Char] ();
xml2nwcr_proof =
  singleton ['w', 'c', 'r', 'D', 'i', 's', 'p', 'r', 'o', 'o', 'f']
    (leaf ['n', 'o', 'n', 'J', 'o', 'i', 'n', 'a', 'b', 'l', 'e', 'C', 'r', 'i',
            't', 'i', 'c', 'a', 'l', 'P', 'a', 'i', 'r', 's', 'A', 'u', 't',
            'o']
      ())
    (\ _ -> ());

xml2ncr_proof ::
  (Xml -> Sum_bot [Prelude.Char] (Lab [Prelude.Char] [Nat])) ->
    Xml ->
      Sum_bot [Prelude.Char] (Ncr_proof [Prelude.Char] [Nat] [Prelude.Char]);
xml2ncr_proof xml2name x =
  let {
    rew = rsteps xml2name;
  } in singleton ['c', 'r', 'D', 'i', 's', 'p', 'r', 'o', 'o', 'f']
         (options
           [(['n', 'o', 'n', 'W', 'c', 'r', 'A', 'n', 'd', 'S', 'N'],
              pair ['n', 'o', 'n', 'W', 'c', 'r', 'A', 'n', 'd', 'S', 'N']
                xml2nwcr_proof (xml2trs_termination_proof xml2name)
                (\ _ -> SN_NWCR)),
             (['n', 'o', 'n', 'J', 'o', 'i', 'n', 'a', 'b', 'l', 'e', 'F', 'o',
                'r', 'k'],
               triple
                 ['n', 'o', 'n', 'J', 'o', 'i', 'n', 'a', 'b', 'l', 'e', 'F',
                   'o', 'r', 'k']
                 rew rew
                 (options
                   [(['d', 'i', 's', 't', 'i', 'n', 'c', 't', 'N', 'o', 'r',
                       'm', 'a', 'l', 'F', 'o', 'r', 'm', 's'],
                      leaf ['d', 'i', 's', 't', 'i', 'n', 'c', 't', 'N', 'o',
                             'r', 'm', 'a', 'l', 'F', 'o', 'r', 'm', 's']
                        Diff_NFs),
                     (['c', 'a', 'p', 'N', 'o', 't', 'U', 'n', 'i', 'f'],
                       leaf ['c', 'a', 'p', 'N', 'o', 't', 'U', 'n', 'i', 'f']
                         (Tcap_Non_Unif default_grd_fun))])
                 (\ (s, seq1) (_, a) -> Non_Join s seq1 a))])
         id x;

xml_signature :: forall a b. (Showa a, Showa b) => [(Lab a [b], Nat)] -> Xml;
xml_signature fs =
  Xml ['s', 'i', 'g', 'n', 'a', 't', 'u', 'r', 'e'] []
    (map (\ (f, n) ->
           Xml ['s', 'y', 'm', 'b', 'o', 'l'] []
             [xml_lab f,
               Xml ['a', 'r', 'i', 't', 'y'] [] []
                 (Just (shows_prec_nat Zero_nat n []))]
             Nothing)
      fs)
    Nothing;

xml_trs_input ::
  forall a b c.
    (Showa a, Showa b,
      Showa c) => Sum (Strategy (Lab a [b]) c) (Ostrategy (Lab a [b]) c) ->
                    [(Term (Lab a [b]) c, Term (Lab a [b]) c)] ->
                      Maybe [(Term (Lab a [b]) c, Term (Lab a [b]) c)] -> Xml;
xml_trs_input q r Nothing =
  Xml ['t', 'r', 's', 'I', 'n', 'p', 'u', 't'] []
    ([xml_rules ['t', 'r', 's'] r] ++ xml_Q q) Nothing;
xml_trs_input q r (Just s) =
  Xml ['t', 'r', 's', 'I', 'n', 'p', 'u', 't'] []
    (xml_rules ['t', 'r', 's'] r :
      xml_Q q ++
        [xml_rules
           ['r', 'e', 'l', 'a', 't', 'i', 'v', 'e', 'R', 'u', 'l', 'e', 's'] s])
    Nothing;

search_len ::
  [Prelude.Char] ->
    [Prelude.Char] -> Nat -> Maybe ([Prelude.Char], [Prelude.Char]);
search_len t s n =
  (if take n t == s then Just ([], drop n t)
    else (case t of {
           [] -> Nothing;
           h : tt ->
             (case search_len tt s n of {
               Nothing -> Nothing;
               Just (bef, aft) -> Just (h : bef, aft);
             });
         }));

check_linear_trs ::
  forall a b.
    (Showa a, Ceq b, Corder b, Set_impla b,
      Showa b) => [(Term a b, Term a b)] ->
                    Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_linear_trs r =
  catcha
    (catcha
      (forallM
        (\ x ->
          (if let {
                (l, ra) = x;
              } in linear_term l && linear_term ra
            then Inr () else Inl x))
        r)
      (\ x -> Inl (snd x)))
    (\ _ ->
      Inl (shows_prec_list Zero_nat r .
            shows_nl .
              shows_string
                ['i', 's', ' ', 'n', 'o', 't', ' ', 'l', 'i', 'n', 'e', 'a',
                  'r'] .
                shows_nl));

mgu_var_disjoint_generic ::
  forall a b c d.
    (Eq b,
      Eq d) => (a -> b) ->
                 (c -> b) ->
                   Term d a -> Term d c -> Maybe (a -> Term d b, c -> Term d b);
mgu_var_disjoint_generic vu wu s t =
  (case mgu (map_vars vu s) (map_vars wu t) of {
    Nothing -> Nothing;
    Just gamma -> Just (map_subst_domain vu gamma, map_subst_domain wu gamma);
  });

critical_pairs_impl ::
  forall a.
    (Eq a) => [(Term a [Prelude.Char], Term a [Prelude.Char])] ->
                [(Term a [Prelude.Char], Term a [Prelude.Char])] ->
                  [(Bool, (Term a [Prelude.Char], Term a [Prelude.Char]))];
critical_pairs_impl p r =
  concatMap
    (\ (l, ra) ->
      concatMap
        (\ pa ->
          let {
            c = ctxt_of_pos_term pa l;
            la = subt_at l pa;
            b = equal_ctxt c Hole;
          } in (if is_Var la then []
                 else concatMap
                        (\ (laa, rb) ->
                          (case mgu_var_disjoint_generic (\ a -> 'x' : a)
                                  (\ a -> 'y' : a) la laa
                            of {
                            Nothing -> [];
                            Just (sigma, tau) ->
                              [(b, (subst_apply_term ra sigma,
                                     ctxt_apply (subst_apply_ctxt c sigma)
                                       (subst_apply_term rb tau)))];
                          }))
                        r))
        (poss_list l))
    p;

lexord_eq :: forall a. (a -> a -> Bool) -> [a] -> [a] -> Bool;
lexord_eq less (x : xs) (y : ys) =
  less x y || not (less y x) && lexord_eq less xs ys;
lexord_eq less (x : xs) [] = False;
lexord_eq less xs [] = null xs;
lexord_eq less [] ys = True;

lexord :: forall a. (a -> a -> Bool) -> [a] -> [a] -> Bool;
lexord less (x : xs) (y : ys) = less x y || not (less y x) && lexord less xs ys;
lexord less xs [] = False;
lexord less [] ys = not (null ys);

corder_list ::
  forall a. (Corder a) => Maybe ([a] -> [a] -> Bool, [a] -> [a] -> Bool);
corder_list = mapa (\ (_, lt) -> (lexord_eq lt, lexord lt)) corder;

instance (Corder a) => Corder [a] where {
  corder = corder_list;
};

corder_char ::
  Maybe (Prelude.Char -> Prelude.Char -> Bool,
          Prelude.Char -> Prelude.Char -> Bool);
corder_char = Just ((\ a b -> a <= b), (\ a b -> a < b));

instance Corder Prelude.Char where {
  corder = corder_char;
};

indent ::
  ([Prelude.Char] -> [Prelude.Char]) -> [Prelude.Char] -> [Prelude.Char];
indent p s =
  concatMap (\ c -> (if c == newline then [newline, ' '] else [c])) (p s);

reachable_terms ::
  forall a b.
    (Eq a, Eq b) => [(Term a b, Term a b)] -> Term a b -> Nat -> [Term a b];
reachable_terms r s n =
  (if equal_nat n Zero_nat then [s]
    else let {
           ts = reachable_terms r s (minus_nat n (Nat_of_num One));
         } in remdups (ts ++ concatMap (rewrite r) ts));

check_strongly_closed ::
  forall a.
    (Eq a,
      Showa a) => [(Term a [Prelude.Char], Term a [Prelude.Char])] ->
                    Nat -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_strongly_closed r n =
  catcha
    (bindb (check_linear_trs r)
      (\ _ ->
        catcha
          (forallM
            (\ (_, (s, t)) ->
              check (not (is_none
                           (find (membera (reachable_terms r s n))
                             (reachable_terms r t
                               (plus_nat Zero_nat (Nat_of_num One))))) &&
                      not (is_none
                            (find (membera (reachable_terms r t n))
                              (reachable_terms r s
                                (plus_nat Zero_nat (Nat_of_num One))))))
                (shows_prec_list Zero_nat
                   ['t', 'h', 'e', 'r', 'e', ' ', 'i', 's', ' ', 'a', ' ', 'c',
                     'r', 'i', 't', 'i', 'c', 'a', 'l', ' ', 'p', 'a', 'i', 'r',
                     ' ', 't', 'h', 'a', 't', ' ', 'i', 's', ' ', 'n', 'o', 't',
                     ' ', 's', 't', 'r', 'o', 'n', 'g', 'l', 'y', ' ', 'c', 'l',
                     'o', 's', 'e', 'd', ':', ' '] .
                  shows_term (shows_prec Zero_nat) (shows_prec_list Zero_nat)
                    s .
                    shows_prec_list Zero_nat
                      [' ', '<', '-', ' ', '.', ' ', '-', '>', ' '] .
                      shows_term (shows_prec Zero_nat)
                        (shows_prec_list Zero_nat) t))
            (critical_pairs_impl r r))
          (\ x -> Inl (snd x))))
    (\ x ->
      Inl (x . shows_nl .
                 shows_prec_list Zero_nat
                   ['h', 'e', 'n', 'c', 'e', ',', ' ', 't', 'h', 'e', ' ', 'f',
                     'o', 'l', 'l', 'o', 'w', 'i', 'n', 'g', ' ', 'T', 'R', 'S',
                     ' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 's', 't', 'r', 'o',
                     'n', 'g', 'l', 'y', ' ', 'c', 'l', 'o', 's', 'e', 'd',
                     ' '] .
                   shows_nl .
                     shows_trs (shows_prec Zero_nat) (shows_prec_list Zero_nat)
                       ['r', 'e', 'w', 'r', 'i', 't', 'e', ' ', 's', 'y', 's',
                         't', 'e', 'm', ':']
                       [' ', '-', '>', ' '] r .
                       indent x));

check_left_linear_trs ::
  forall a b.
    (Showa a, Ceq b, Corder b, Set_impla b,
      Showa b) => [(Term a b, Term a b)] ->
                    Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_left_linear_trs trs =
  catcha
    (catcha
      (forallM (\ x -> (if linear_term (fst x) then Inr () else Inl x)) trs)
      (\ x -> Inl (snd x)))
    (\ _ ->
      Inl (shows_prec_list Zero_nat trs .
            shows_nl .
              shows_string
                ['i', 's', ' ', 'n', 'o', 't', ' ', 'l', 'e', 'f', 't', '-',
                  'l', 'i', 'n', 'e', 'a', 'r'] .
                shows_nl));

check_weakly_orthogonal ::
  forall a.
    (Eq a,
      Showa a) => [(Term a [Prelude.Char], Term a [Prelude.Char])] ->
                    Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_weakly_orthogonal r =
  catcha
    (bindb (check_left_linear_trs r)
      (\ _ ->
        bindb (catcha
                (forallM
                  (\ (l, _) ->
                    check (not (is_Var l))
                      (shows_prec_list Zero_nat
                        ['t', 'h', 'e', ' ', 'T', 'R', 'S', ' ', 'h', 'a', 's',
                          ' ', 'v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 's', ' ',
                          'a', 's', ' ', 'l', 'e', 'f', 't', '-', 'h', 'a', 'n',
                          'd', ' ', 's', 'i', 'd', 'e', 's']))
                  r)
                (\ x -> Inl (snd x)))
          (\ _ ->
            catcha
              (forallM
                (\ (_, (s, t)) ->
                  check (equal_term s t)
                    (shows_prec_list Zero_nat
                       ['t', 'h', 'e', 'r', 'e', ' ', 'i', 's', ' ', 'a', ' ',
                         'n', 'o', 'n', '-', 't', 'r', 'i', 'v', 'i', 'a', 'l',
                         ' ', 'c', 'r', 'i', 't', 'i', 'c', 'a', 'l', ' ', 'p',
                         'a', 'i', 'r', ':', ' '] .
                      shows_term (shows_prec Zero_nat)
                        (shows_prec_list Zero_nat) s .
                        shows_prec_list Zero_nat
                          [' ', '<', '-', ' ', '.', ' ', '-', '>', ' '] .
                          shows_term (shows_prec Zero_nat)
                            (shows_prec_list Zero_nat) t))
                (critical_pairs_impl r r))
              (\ x -> Inl (snd x)))))
    (\ x ->
      Inl (x . shows_nl .
                 shows_prec_list Zero_nat
                   ['h', 'e', 'n', 'c', 'e', ',', ' ', 't', 'h', 'e', ' ', 'f',
                     'o', 'l', 'l', 'o', 'w', 'i', 'n', 'g', ' ', 'T', 'R', 'S',
                     ' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'w', 'e', 'a', 'k',
                     'l', 'y', ' ', 'o', 'r', 't', 'h', 'o', 'g', 'o', 'n', 'a',
                     'l', ' '] .
                   shows_nl .
                     shows_trs (shows_prec Zero_nat) (shows_prec_list Zero_nat)
                       ['r', 'e', 'w', 'r', 'i', 't', 'e', ' ', 's', 'y', 's',
                         't', 'e', 'm', ':']
                       [' ', '-', '>', ' '] r .
                       indent x));

show_crit_pair ::
  forall a b.
    (Showa a,
      Showa b) => (Term a b, Term a b) -> [Prelude.Char] -> [Prelude.Char];
show_crit_pair lr =
  shows_prec_list Zero_nat ['('] .
    shows_prec_term Zero_nat (fst lr) .
      shows_prec_list Zero_nat [',', ' '] .
        shows_prec_term Zero_nat (snd lr) . shows_prec_list Zero_nat [')'];

check_prop_rstep_rule ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => Bool ->
                    (Term a b -> Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                      Pos ->
                        (Term a b, Term a b) ->
                          Term a b ->
                            Term a b ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_prop_rstep_rule nfs pa p rule s t =
  bindb (check (in_poss p s)
          (shows_prec_pos Zero_nat p .
            shows_string
              [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'p', 'o', 's',
                'i', 't', 'i', 'o', 'n', ' ', 'o', 'f', ' '] .
              shows_prec_term Zero_nat s . shows_nl))
    (\ _ ->
      bindb (check (in_poss p t)
              (shows_prec_pos Zero_nat p .
                shows_string
                  [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'p', 'o',
                    's', 'i', 't', 'i', 'o', 'n', ' ', 'o', 'f', ' '] .
                  shows_prec_term Zero_nat t . shows_nl))
        (\ _ ->
          let {
            c = ctxt_of_pos_term p s;
            d = ctxt_of_pos_term p t;
            u = subt_at s p;
            v = subt_at t p;
          } in (case match_list [(u, fst rule), (v, snd rule)] of {
                 Nothing ->
                   Inl (shows_string
                          ['t', 'h', 'e', ' ', 't', 'e', 'r', 'm', ' '] .
                         shows_prec_term Zero_nat t .
                           shows_string
                             [' ', 'd', 'o', 'e', 's', ' ', 'n', 'o', 't', ' ',
                               'r', 'e', 's', 'u', 'l', 't', ' ', 'f', 'r', 'o',
                               'm', ' ', 'a', ' ', 'p', 'r', 'o', 'p', 'e', 'r',
                               ' ', 'a', 'p', 'p', 'l', 'i', 'c', 'a', 't', 'i',
                               'o', 'n', ' ', 'o', 'f', ' ', 'r', 'u', 'l', 'e',
                               ' '] .
                             shows_nl .
                               shows_rule (shows_prec Zero_nat)
                                 (shows_prec Zero_nat) [' ', '-', '>', ' ']
                                 rule .
                                 shows_string
                                   [' ', 'a', 't', ' ', 'p', 'o', 's', 'i', 't',
                                     'i', 'o', 'n', ' '] .
                                   shows_prec_pos Zero_nat p . shows_nl);
                 Just sigma ->
                   let {
                     tau = mk_subst Var sigma;
                   } in bindb (catcha
                                (forallM pa
                                  (args u ++
                                    (if nfs then map tau (vars_rule_list rule)
                                      else [])))
                                (\ x -> Inl (snd x)))
                          (\ _ ->
                            check (equal_ctxt c d)
                              (shows_string
                                 ['t', 'h', 'e', ' ', 't', 'e', 'r', 'm', ' '] .
                                shows_prec_term Zero_nat t .
                                  shows_string
                                    [' ', 'd', 'o', 'e', 's', ' ', 'n', 'o',
                                      't', ' ', 'r', 'e', 's', 'u', 'l', 't',
                                      ' ', 'f', 'r', 'o', 'm', ' ', 'a', ' ',
                                      'p', 'r', 'o', 'p', 'e', 'r', ' ', 'a',
                                      'p', 'p', 'l', 'i', 'c', 'a', 't', 'i',
                                      'o', 'n', ' ', 'o', 'f', ' ', 'r', 'u',
                                      'l', 'e', ' '] .
                                    shows_nl .
                                      shows_rule (shows_prec Zero_nat)
(shows_prec Zero_nat) [' ', '-', '>', ' '] rule .
shows_string [' ', 'a', 't', ' ', 'p', 'o', 's', 'i', 't', 'i', 'o', 'n', ' '] .
  shows_prec_pos Zero_nat p . shows_nl));
               })));

check_prop_rstep ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => Bool ->
                    (Term a b -> Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                      [(Term a b, Term a b)] ->
                        Pos ->
                          (Term a b, Term a b) ->
                            Term a b ->
                              Term a b ->
                                Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_prop_rstep nfs pa r p rule s t =
  check (any (\ ra ->
               eq_rule_mod_vars rule ra &&
                 isOK (check_prop_rstep_rule nfs pa p ra s t))
          r)
    (shows_prec_list Zero_nat
       ['t', 'h', 'e', ' ', 's', 't', 'e', 'p', ' ', 'f', 'r', 'o', 'm', ' '] .
      shows_prec_term Zero_nat s .
        shows_prec_list Zero_nat [' ', 't', 'o', ' '] .
          shows_prec_term Zero_nat t .
            shows_prec_list Zero_nat
              [' ', 'v', 'i', 'a', ' ', 'r', 'u', 'l', 'e', ' '] .
              shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                [' ', '-', '>', ' '] rule .
                shows_prec_list Zero_nat
                  [' ', 'a', 't', ' ', 'p', 'o', 's', 'i', 't', 'i', 'o', 'n',
                    ' '] .
                  shows_prec_pos Zero_nat p .
                    shows_prec_list Zero_nat
                      [' ', 'i', 's', ' ', 'p', 'r', 'o', 'b', 'l', 'e', 'm',
                        'a', 't', 'i', 'c'] .
                      shows_nl);

check_qrstep ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => (Term a b -> Bool) ->
                    Bool ->
                      [(Term a b, Term a b)] ->
                        Pos ->
                          (Term a b, Term a b) ->
                            Term a b ->
                              Term a b ->
                                Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_qrstep nf nfs =
  check_prop_rstep nfs
    (\ t ->
      check (nf t)
        (shows_prec_term Zero_nat t .
          shows_prec_list Zero_nat
            [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'i', 'n', ' ', 'Q', '-',
              'n', 'o', 'r', 'm', 'a', 'l', ' ', 'f', 'o', 'r', 'm']));

check_rqrstep ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => (Term a b -> Bool) ->
                    Bool ->
                      [(Term a b, Term a b)] ->
                        (Term a b, Term a b) ->
                          Term a b ->
                            Term a b ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_rqrstep nf nfs r rule s t = check_qrstep nf nfs r Empty rule s t;

check_qsteps ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => (Term a b -> Bool) ->
                    Bool ->
                      [(Term a b, Term a b)] ->
                        [(Term a b, Term a b)] ->
                          [(Pos, ((Term a b, Term a b), (Bool, Term a b)))] ->
                            Term a b ->
                              Term a b ->
                                Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_qsteps nf nfs p r [] s u =
  check (equal_term s u)
    (shows_string
       ['t', 'h', 'e', ' ', 'l', 'a', 's', 't', ' ', 't', 'e', 'r', 'm', ' ',
         'o', 'f', ' ', 't', 'h', 'e', ' ', 'r', 'e', 'w', 'r', 'i', 't', 'e',
         ' ', 's', 'e', 'q', 'u', 'e', 'n', 'c', 'e'] .
      shows_nl .
        shows_prec_term Zero_nat s .
          shows_nl .
            shows_string
              ['d', 'o', 'e', 's', ' ', 'n', 'o', 't', ' ', 'c', 'o', 'r', 'r',
                'e', 's', 'p', 'o', 'n', 'd', ' ', 't', 'o', ' ', 't', 'h', 'e',
                ' ', 'g', 'o', 'a', 'l', ' ', 't', 'e', 'r', 'm'] .
              shows_nl . shows_prec_term Zero_nat u . shows_nl);
check_qsteps nf nfs p ra ((uu, (r, (True, t))) : prts) s u =
  bindb (check_rqrstep nf nfs p r s t)
    (\ _ -> check_qsteps nf nfs p ra prts t u);
check_qsteps nf nfs pa ra ((p, (r, (False, t))) : prts) s u =
  bindb (check_qrstep nf nfs ra p r s t)
    (\ _ -> check_qsteps nf nfs pa ra prts t u);

check_qrsteps ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => (Term a b -> Bool) ->
                    Bool ->
                      [(Term a b, Term a b)] ->
                        [(Pos, ((Term a b, Term a b), Term a b))] ->
                          Term a b ->
                            Term a b ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_qrsteps nf nfs r prts s u =
  check_qsteps nf nfs [] r (map (\ (p, (ra, t)) -> (p, (ra, (False, t)))) prts)
    s u;

check_rsteps ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    [(Pos, ((Term a b, Term a b), Term a b))] ->
                      Term a b ->
                        Term a b -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_rsteps = check_qrsteps (\ _ -> True) False;

rseq_last ::
  forall a b. Term a b -> [(Pos, ((Term a b, Term a b), Term a b))] -> Term a b;
rseq_last s steps = last (s : map (\ (_, (_, sa)) -> sa) steps);

check_rsteps_last ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    Term a b ->
                      [(Pos, ((Term a b, Term a b), Term a b))] ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_rsteps_last = (\ r s steps -> check_rsteps r steps s (rseq_last s steps));

check_join ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    Term a b ->
                      [(Pos, ((Term a b, Term a b), Term a b))] ->
                        Term a b ->
                          [(Pos, ((Term a b, Term a b), Term a b))] ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_join r s sseq t tseq =
  let {
    chk = check_rsteps_last r;
  } in bindb (chk s sseq)
         (\ _ ->
           bindb (chk t tseq)
             (\ _ ->
               let {
                 u = rseq_last s sseq;
                 v = rseq_last t tseq;
               } in check (equal_term u v)
                      (shows_prec_list Zero_nat
                         ['t', 'h', 'e', ' ', 'r', 'e', 'w', 'r', 'i', 't', 'e',
                           ' ', 's', 'e', 'q', 'u', 'e', 'n', 'c', 'e', 's',
                           ' ', 'e', 'n', 'd', ' ', 'i', 'n', ' ', 'd', 'i',
                           'f', 'f', 'e', 'r', 'e', 'n', 't', ' ', 't', 'e',
                           'r', 'm', 's', ' '] .
                        shows_prec_term Zero_nat u .
                          shows_prec_list Zero_nat [' ', 'a', 'n', 'd', ' '] .
                            shows_prec_term Zero_nat v)));

check_critical_pairs_guided ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    [(Bool, (Term a b, Term a b))] ->
                      [(Term a b,
                         ([(Pos, ((Term a b, Term a b), Term a b))],
                           (Term a b,
                             [(Pos, ((Term a b, Term a b), Term a b))])))] ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_critical_pairs_guided r cp joins =
  bindb (catcha
          (forallM (\ (s, (sseq, (a, b))) -> check_join r s sseq a b) joins)
          (\ x -> Inl (snd x)))
    (\ _ ->
      let {
        cpa = map (\ (s, (_, (t, _))) -> (s, t)) joins;
      } in catcha
             (forallM
               (\ (_, (s, t)) ->
                 check (equal_term s t ||
                         any (\ st ->
                               instance_rule (s, t) st ||
                                 instance_rule (t, s) st)
                           cpa)
                   (shows_prec_list Zero_nat
                      ['c', 'r', 'i', 't', 'i', 'c', 'a', 'l', ' ', 'p', 'a',
                        'i', 'r', ' '] .
                     show_crit_pair (s, t) .
                       shows_prec_list Zero_nat
                         [' ', 'm', 'i', 's', 's', 'i', 'n', 'g']))
               cp)
             (\ x -> Inl (snd x)));

iterative_join_search_main ::
  forall a b.
    (Eq a,
      Eq b) => [(Term a b, Term a b)] ->
                 Term a b -> Term a b -> Nat -> Nat -> Bool;
iterative_join_search_main r s t i n =
  (if less_eq_nat i n
    then not (null (list_inter (reachable_terms r s i)
                     (reachable_terms r t i))) ||
           iterative_join_search_main r s t (plus_nat i (Nat_of_num One)) n
    else False);

iterative_join_search ::
  forall a b.
    (Eq a,
      Eq b) => [(Term a b, Term a b)] -> Term a b -> Term a b -> Nat -> Bool;
iterative_join_search r s t n = iterative_join_search_main r s t Zero_nat n;

check_join_BFS_limit ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => Nat ->
                    [(Term a b, Term a b)] ->
                      Term a b ->
                        Term a b -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_join_BFS_limit n r s t =
  check (iterative_join_search r s t n)
    (shows_prec_list Zero_nat
       ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'f', 'i', 'n', 'd',
         ' ', 'a', ' ', 'j', 'o', 'i', 'n', 'i', 'n', 'g', ' ', 's', 'e', 'q',
         'u', 'e', 'n', 'c', 'e', ' ', 'o', 'f', ' ', 'l', 'e', 'n', 'g', 't',
         'h', ' ', 'a', 't', ' ', 'm', 'o', 's', 't', ' '] .
      shows_prec_nat Zero_nat n .
        shows_prec_list Zero_nat
          [' ', 'f', 'o', 'r', ' ', 't', 'h', 'e', ' ', 't', 'e', 'r', 'm', 's',
            ' '] .
          shows_prec_term Zero_nat s .
            shows_prec_list Zero_nat [' ', 'a', 'n', 'd', ' '] .
              shows_prec_term Zero_nat t . shows_nl);

check_critical_pairs_BFS ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => Nat ->
                    [(Term a b, Term a b)] ->
                      [(Bool, (Term a b, Term a b))] ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_critical_pairs_BFS n r cp =
  catcha
    (forallM
      (\ (_, (s, t)) ->
        (if equal_term s t then Inr ()
          else catcha (check_join_BFS_limit n r s t)
                 (\ x ->
                   Inl (shows_prec_list Zero_nat
                          ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h',
                            'e', 'n', ' ', 'j', 'o', 'i', 'n', 'i', 'n', 'g',
                            ' ', 'c', 'r', 'i', 't', 'i', 'c', 'a', 'l', ' ',
                            'p', 'a', 'i', 'r', ' '] .
                         show_crit_pair (s, t) . shows_nl . x))))
      cp)
    (\ x -> Inl (snd x));

check_critical_pairs_NF ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    [(Bool, (Term a b, Term a b))] ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_critical_pairs_NF r cp =
  catcha
    (forallM
      (\ (_, (s, t)) ->
        (if equal_term s t then Inr ()
          else catcha (check_join_NF r s t)
                 (\ x ->
                   Inl (shows_prec_list Zero_nat
                          ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h',
                            'e', 'n', ' ', 'j', 'o', 'i', 'n', 'i', 'n', 'g',
                            ' ', 'c', 'r', 'i', 't', 'i', 'c', 'a', 'l', ' ',
                            'p', 'a', 'i', 'r', ' '] .
                         show_crit_pair (s, t) . shows_nl . x))))
      cp)
    (\ x -> Inl (snd x));

check_critical_pairs ::
  forall a.
    (Eq a,
      Showa a) => [(Term a [Prelude.Char], Term a [Prelude.Char])] ->
                    [(Bool, (Term a [Prelude.Char], Term a [Prelude.Char]))] ->
                      Join_info a -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_critical_pairs r cp join_info =
  (case join_info of {
    Guided a -> check_critical_pairs_guided r cp a;
    Join_NF -> check_critical_pairs_NF r cp;
    Join_BFS n -> check_critical_pairs_BFS n r cp;
  });

applicable_rule_implb ::
  forall a b. (Term a b -> Bool) -> (Term a b, Term a b) -> Bool;
applicable_rule_implb isNF = (\ (l, _) -> all isNF (args l));

check_non_applicable_rules ::
  forall a b.
    (Term a b -> Bool) -> [(Term a b, Term a b)] -> Sum (Term a b, Term a b) ();
check_non_applicable_rules isNF r =
  catcha
    (forallM
      (\ x -> (if not (applicable_rule_implb isNF x) then Inr () else Inl x)) r)
    (\ x -> Inl (snd x));

is_ur_closed_term_af_impl ::
  forall a b c.
    (Eq a,
      Eq c) => (Term a [Prelude.Char] -> Bool) ->
                 (Term a b -> Term a (Sum () [Prelude.Char])) ->
                   ((a, Nat) -> Nat -> Bool) ->
                     [(Term a [Prelude.Char], c)] ->
                       [(Term a [Prelude.Char], c)] ->
                         [Term a [Prelude.Char]] -> Term a b -> Bool;
is_ur_closed_term_af_impl nfq e_cap pi r u s (Var x) = True;
is_ur_closed_term_af_impl nfq e_cap pi r u s (Fun f ts) =
  let {
    n = size_list ts;
    pi_f = pi (f, n);
  } in all (\ (i, t) ->
             (if pi_f i then is_ur_closed_term_af_impl nfq e_cap pi r u s t
               else True))
         (zip (upt Zero_nat n) ts) &&
         all (\ (l, ra) ->
               membera u (l, ra) ||
                 (case mgu_class (Fun f (map e_cap ts)) l of {
                   Nothing -> True;
                   Just mu ->
                     not (all (\ ua ->
                                nfq (subst_apply_term
                                      (map_vars (\ a -> 'y' : a) ua) mu))
                           (args l)) ||
                       not (all (\ ua -> nfq (subst_apply_term ua mu)) s);
                 }))
           r;

is_ur_closed_af_impl_dpp_mv ::
  forall a b.
    (Eq b, Key b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    a -> ((b, Nat) -> Nat -> Bool) ->
                           [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                             [Term b [Prelude.Char]] ->
                               Term b [Prelude.Char] -> Bool;
is_ur_closed_af_impl_dpp_mv i d pi =
  let {
    ic = icap_impl_dpp i d;
    qnf = is_QNFc i d;
    r = rulesd i d;
    urc = (\ s -> is_ur_closed_term_af_impl qnf (ic s) pi r);
  } in (\ u s ->
         let {
           sa = map (map_vars (\ a -> 'x' : a)) s;
         } in (\ t -> urc sa u sa (map_vars (\ a -> 'x' : a) t)));

matchCapRMBelow ::
  forall a b.
    (Eq a,
      Eq b) => ((a, Nat) -> [(Term a b, Term a b)]) ->
                 Term a b -> Term a b -> Bool;
matchCapRMBelow rm l (Fun f ts) = matchb (GCFun f (map (capRM2 rm) ts)) l;

forallM_index_aux ::
  forall a b. (a -> Nat -> Sum b ()) -> Nat -> [a] -> Sum ((a, Nat), b) ();
forallM_index_aux p i [] = Inr ();
forallM_index_aux p i (x : xs) =
  bindb (catcha (p x i) (\ xa -> Inl ((x, i), xa)))
    (\ _ -> forallM_index_aux p (plus_nat i (Nat_of_num One)) xs);

forallM_index ::
  forall a b. (a -> Nat -> Sum b ()) -> [a] -> Sum ((a, Nat), b) ();
forallM_index p xs = forallM_index_aux p Zero_nat xs;

check_ur_closed_term_rm_af ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => ((a, Nat) -> [(Term a b, Term a b)]) ->
                    [(Term a b, Term a b)] ->
                      ((a, Nat) -> Nat -> Bool) ->
                        Term a b -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_ur_closed_term_rm_af uu uv uw (Var x) = Inr ();
check_ur_closed_term_rm_af rm ur pi (Fun f ts) =
  let {
    n = size_list ts;
    pia = pi (f, n);
  } in bindb (catcha
               (forallM_index
                 (\ t i ->
                   (if pia i then check_ur_closed_term_rm_af rm ur pi t
                     else Inr ()))
                 ts)
               (\ x -> Inl (snd x)))
         (\ _ ->
           catcha
             (forallM
               (\ lr ->
                 check (membera ur lr ||
                         not (matchCapRMBelow rm (fst lr) (Fun f ts)))
                   (shows_string
                      ['d', 'u', 'e', ' ', 't', 'o', ' ', 't', 'h', 'e', ' ',
                        's', 'u', 'b', 't', 'e', 'r', 'm', ' '] .
                     shows_prec_term Zero_nat (Fun f ts) .
                       shows_string
                         [' ', 'o', 'f', ' ', 's', 'o', 'm', 'e', ' ', 'u', 's',
                           'a', 'b', 'l', 'e', ' ', 'r', 'h', 's', ',', ' ',
                           'r', 'u', 'l', 'e', ' '] .
                         shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                           [' ', '-', '>', ' '] lr .
                           shows_string
                             [' ', 's', 'h', 'o', 'u', 'l', 'd', ' ', 'b', 'e',
                               ' ', 'u', 's', 'a', 'b', 'l', 'e', '.']))
               (rm (f, n)))
             (\ x -> Inl (snd x)));

check_ur_P_closed_rm_af ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => ((a, Nat) -> [(Term a b, Term a b)]) ->
                    [(Term a b, Term a b)] ->
                      [(Term a b, Term a b)] ->
                        ((a, Nat) -> Nat -> Bool) ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_ur_P_closed_rm_af rm ur p pi =
  bindb (catcha
          (catcha
            (forallM (\ lr -> check_ur_closed_term_rm_af rm ur pi (snd lr)) ur)
            (\ x -> Inl (snd x)))
          (\ x ->
            Inl (shows_string
                   ['e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e', 'n', ' ', 'c',
                     'h', 'e', 'c', 'k', 'i', 'n', 'g', ' ', 'c', 'l', 'o', 's',
                     'u', 'r', 'e', ' ', 'p', 'r', 'o', 'p', 'e', 'r', 't', 'i',
                     'e', 's', ' ', 'o', 'f', ' ', 'r', 'h', 's', ' ', 'o', 'f',
                     ' ', 'u', 's', 'a', 'b', 'l', 'e', ' ', 'r', 'u', 'l', 'e',
                     's'] .
                  shows_nl . x)))
    (\ _ ->
      catcha
        (catcha
          (forallM (\ st -> check_ur_closed_term_rm_af rm ur pi (snd st)) p)
          (\ x -> Inl (snd x)))
        (\ x ->
          Inl (shows_string
                 ['e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e', 'n', ' ', 'c',
                   'h', 'e', 'c', 'k', 'i', 'n', 'g', ' ', 'c', 'l', 'o', 's',
                   'u', 'r', 'e', ' ', 'p', 'r', 'o', 'p', 'e', 'r', 't', 'i',
                   'e', 's', ' ', 'o', 'f', ' ', 'r', 'h', 's', ' ', 'o', 'f',
                   ' ', 'D', 'P', 's'] .
                shows_nl . x)));

wwf_rulesa :: forall a b c d. Dpp_ops_ext a b c d -> a -> Bool;
wwf_rulesa
  (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
    rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
    intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
    split_pairs split_rules mk minimal nfs wwf_rules more)
  = wwf_rules;

q_emptyc :: forall a b c d. Dpp_ops_ext a b c d -> a -> Bool;
q_emptyc
  (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
    rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
    intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
    split_pairs split_rules mk minimal nfs wwf_rules more)
  = q_empty;

smart_usable_rules_checker_impl ::
  forall a b.
    (Eq b, Key b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    a -> ((b, Nat) -> Nat -> Bool) ->
                           Maybe [(Term b [Prelude.Char],
                                    Term b [Prelude.Char])] ->
                             [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                               Sum ([Prelude.Char] -> [Prelude.Char])
                                 [(Term b [Prelude.Char],
                                    Term b [Prelude.Char])];
smart_usable_rules_checker_impl i d pi u_opt sts =
  let {
    nfs = nfsc i d;
    m = minimal i d;
    wwf = wwf_rulesa i d;
    qempty = q_emptyc i d;
  } in (case u_opt of {
         Nothing -> Inr (rulesd i d);
         Just u ->
           (if nFQ_subset_NF_rulesb i d &&
                 (nfs ||
                   all (\ (s, t) ->
                         isOK (check_subseteq (vars_term_lista t)
                                (vars_term_lista s)))
                     sts) &&
                   (nfs || (m || wwf))
             then let {
                    urc = is_ur_closed_af_impl_dpp_mv i d pi u;
                    check_urc =
                      (\ s t ->
                        check (urc s t)
                          (shows_prec_list Zero_nat ['t', 'e', 'r', 'm', ' '] .
                            shows_prec_term Zero_nat t .
                              shows_prec_list Zero_nat
                                [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'c',
                                  'l', 'o', 's', 'e', 'd', ' ', 'u', 'n', 'd',
                                  'e', 'r', ' ', 'u', 's', 'a', 'b', 'l', 'e',
                                  ' ', 'r', 'u', 'l', 'e', 's']));
                  } in bindb (catcha (forallM (\ (s, a) -> check_urc [s] a) sts)
                               (\ x -> Inl (snd x)))
                         (\ _ ->
                           bindb (catcha
                                   (forallM (\ (l, a) -> check_urc (args l) a)
                                     u)
                                   (\ x -> Inl (snd x)))
                             (\ _ -> Inr u))
             else bindb (check (m && (if nfs then qempty || wwf else True))
                          (shows_prec_list Zero_nat
                            ['m', 'i', 'n', 'i', 'm', 'a', 'l', 'i', 't', 'y',
                              ' ', 'a', 'n', 'd', ' ', 'w', 'e', 'l', 'l', ' ',
                              'f', 'o', 'r', 'm', 'e', 'd', 'n', 'e', 's', 's',
                              ' ', 'r', 'e', 'q', 'u', 'i', 'r', 'e', 'd']))
                    (\ _ ->
                      bindb (catcha
                              (forallM
                                (\ (l, _) ->
                                  check (not (is_Var l))
                                    (shows_prec_list Zero_nat
                                      ['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e',
's', ' ', 'a', 's', ' ', 'l', 'h', 's', 's', ' ', 'n', 'o', 't', ' ', 'a', 'l',
'l', 'o', 'w', 'e', 'd']))
                                (rulesd i d))
                              (\ x -> Inl (snd x)))
                        (\ _ ->
                          let {
                            rm = rules_mapb i d;
                          } in bindb (check_ur_P_closed_rm_af rm u sts pi)
                                 (\ _ -> Inr u))));
       });

root_aft_to_entry ::
  forall a b c. a -> Term b c -> ((b, Nat) -> Nat -> Bool) -> [(a, Term b c)];
root_aft_to_entry s t pi =
  let {
    rt = the (root t);
    pi_t = pi rt;
    ts = args t;
  } in map_filter (\ x -> (if pi_t x then Just (s, nth ts x) else Nothing))
         (upt Zero_nat (snd rt));

check_no_defined_root ::
  forall a b.
    (Showa a,
      Showa b) => ((a, Nat) -> Bool) ->
                    Term a b -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_no_defined_root isdef t =
  check (not (isdef (the (root t))))
    (shows_string ['t', 'h', 'e', ' ', 'r', 'o', 'o', 't', ' ', 'o', 'f', ' '] .
      shows_prec_term Zero_nat t .
        shows_string [' ', 'i', 's', ' ', 'd', 'e', 'f', 'i', 'n', 'e', 'd']);

pairsa :: forall a b c d. Dpp_ops_ext a b c d -> a -> [(Term b c, Term b c)];
pairsa
  (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
    rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
    intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
    split_pairs split_rules mk minimal nfs wwf_rules more)
  = pairs;

generic_ur_af_root_redtriple_proc ::
  forall a b.
    (Eq b, Key b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    Root_redtriple_ext b [Prelude.Char] () ->
                      Maybe [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                        [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                          a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
generic_ur_af_root_redtriple_proc i rp u_opt premove dpp =
  (case catcha
          (bindb (valida rp)
            (\ _ ->
              let {
                (ps, pns) = split_pairsa i dpp premove;
                p = pairsa i dpp;
                pi = af rp;
                pia = aft rp;
                is_def = (\ fn -> not (null (rules_mapb i dpp fn)));
              } in bindb (catcha
                           (forallM
                             (\ (l, r) ->
                               bindb (check_no_var l)
                                 (\ _ ->
                                   bindb (check_no_var r)
                                     (\ _ -> check_no_defined_root is_def r)))
                             p)
                           (\ x -> Inl (snd x)))
                     (\ _ ->
                       bindb (catcha
                               (forallM (\ (l, _) -> check_no_var l)
                                 (rulesd i dpp))
                               (\ x -> Inl (snd x)))
                         (\ _ ->
                           bindb (smart_usable_rules_checker_impl i dpp pi u_opt
                                   (concatMap
                                     (\ (s, t) -> root_aft_to_entry s t pia) p))
                             (\ u ->
                               bindb (catcha
                                       (catcha (forallM (nsa rp) u)
 (\ x -> Inl (snd x)))
                                       (\ x ->
 Inl (shows_string
        ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ', 'o',
          'r', 'i', 'e', 'n', 't', 'i', 'n', 'g', ' ', '(', 'u', 's', 'a', 'b',
          'l', 'e', ')', ' ', 'r', 'u', 'l', 'e', 's'] .
       shows_nl . x)))
                                 (\ _ ->
                                   bindb (catcha
   (catcha (forallM (nsta rp) pns) (\ x -> Inl (snd x)))
   (\ x ->
     Inl (shows_string
            ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ',
              'o', 'r', 'i', 'e', 'n', 't', 'i', 'n', 'g', ' ', 'D', 'P', 's'] .
           shows_nl . x)))
                                     (\ _ ->
                                       catcha
 (catcha (forallM (sa rp) ps) (\ x -> Inl (snd x)))
 (\ x ->
   Inl (shows_string
          ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ', 'o',
            'r', 'i', 'e', 'n', 't', 'i', 'n', 'g', ' ', 'D', 'P', 's'] .
         shows_nl . x)))))))))
          (\ x ->
            Inl (shows_string
                   ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'a', 'p',
                     'p', 'l', 'y', ' ', 't', 'h', 'e', ' ', 'g', 'e', 'n', 'e',
                     'r', 'i', 'c', ' ', 'r', 'o', 'o', 't', ' ', 'r', 'e', 'd',
                     'u', 'c', 't', 'i', 'o', 'n', ' ', 'p', 'a', 'i', 'r', ' ',
                     'p', 'r', 'o', 'c', 'e', 's', 's', 'o', 'r', ' ', 'w', 'i',
                     't', 'h', ' ', 't', 'h', 'e', ' ', 'f', 'o', 'l', 'l', 'o',
                     'w', 'i', 'n', 'g'] .
                  shows_nl . descaa rp . shows_nl . x))
    of {
    Inl a -> Inl a;
    Inr _ -> Inr (delete_P_Pwa i dpp premove premove);
  });

generic_ur_af_redtriple_proc ::
  forall a b.
    (Eq b, Key b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    Redtriple_ext b [Prelude.Char] () ->
                      Maybe [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                        [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                          a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
generic_ur_af_redtriple_proc i rp u_opt premove dpp =
  (case catcha
          (bindb (valid rp)
            (\ _ ->
              let {
                (ps, pns) = split_pairsa i dpp premove;
                p = pairsa i dpp;
              } in bindb (smart_usable_rules_checker_impl i dpp (afa rp) u_opt
                           p)
                     (\ u ->
                       bindb (catcha
                               (catcha (forallM (ns rp) u) (\ x -> Inl (snd x)))
                               (\ x ->
                                 Inl (shows_string
['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ', 'o', 'r', 'i',
  'e', 'n', 't', 'i', 'n', 'g', ' ', '(', 'u', 's', 'a', 'b', 'l', 'e', ')',
  ' ', 'r', 'u', 'l', 'e', 's'] .
                                       shows_nl . x)))
                         (\ _ ->
                           bindb (catcha
                                   (catcha (forallM (nst rp) pns)
                                     (\ x -> Inl (snd x)))
                                   (\ x ->
                                     Inl (shows_string
    ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ', 'o', 'r',
      'i', 'e', 'n', 't', 'i', 'n', 'g', ' ', 'D', 'P', 's'] .
   shows_nl . x)))
                             (\ _ ->
                               catcha
                                 (catcha (forallM (s rp) ps)
                                   (\ x -> Inl (snd x)))
                                 (\ x ->
                                   Inl (shows_string
  ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ', 'o', 'r',
    'i', 'e', 'n', 't', 'i', 'n', 'g', ' ', 'D', 'P', 's'] .
 shows_nl . x)))))))
          (\ x ->
            Inl (shows_string
                   ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'a', 'p',
                     'p', 'l', 'y', ' ', 't', 'h', 'e', ' ', 'g', 'e', 'n', 'e',
                     'r', 'i', 'c', ' ', 'r', 'e', 'd', 'u', 'c', 't', 'i', 'o',
                     'n', ' ', 'p', 'a', 'i', 'r', ' ', 'p', 'r', 'o', 'c', 'e',
                     's', 's', 'o', 'r', ' ', 'w', 'i', 't', 'h', ' ', 't', 'h',
                     'e', ' ', 'f', 'o', 'l', 'l', 'o', 'w', 'i', 'n', 'g'] .
                  shows_nl . desca rp . shows_nl . x))
    of {
    Inl a -> Inl a;
    Inr _ -> Inr (delete_P_Pwa i dpp premove premove);
  });

compat_roota :: forall a b. (Eq a) => Term a b -> Maybe (a, Nat) -> Bool;
compat_roota uu Nothing = False;
compat_roota (Var uv) (Just v) = False;
compat_roota (Fun va vb) (Just v) = root (Fun va vb) == Just v;

usable_rules_gen2 ::
  forall a b.
    (Eq a) => [(Term a b, Term a b)] ->
                (Maybe (a, Nat), Bool) -> [(Term a b, Term a b)];
usable_rules_gen2 r (fn, b) =
  let {
    rr = concatMap (\ (l, ra) -> (if compat_roota l fn then [(l, ra)] else []))
           r;
  } in (if b then rr else map (\ (l, ra) -> (ra, l)) rr);

rel_dep_prod :: Bool -> Dependance -> [Bool];
rel_dep_prod uu Ignore = [];
rel_dep_prod b Increase = [b];
rel_dep_prod b Decrease = [not b];
rel_dep_prod uv Wild = [True, False];

compat_root :: forall a b c. (Eq a) => Term a b -> Term a c -> Bool;
compat_root uu (Var uv) = False;
compat_root (Var uw) (Fun v va) = False;
compat_root (Fun vb vc) (Fun v va) = root (Fun vb vc) == root (Fun v va);

usable_rules_gen1 ::
  forall a b.
    (Eq a) => ((a, Nat) -> Nat -> Dependance) ->
                [(Term a b, Term a b)] ->
                  (Term a b, Bool) -> [(Term a b, Bool)];
usable_rules_gen1 pi r (Var uu, uv) = [];
usable_rules_gen1 pi r (Fun f ts, b) =
  let {
    n = size_list ts;
  } in concatMap
         (\ (l, ra) -> (if compat_root l (Fun f ts) then [(ra, b)] else []))
         r ++
         concatMap
           (\ i -> map (\ a -> (nth ts i, a)) (rel_dep_prod b (pi (f, n) i)))
           (upt Zero_nat n);

usable_rules_gen ::
  forall a b.
    (Eq a,
      Eq b) => ((a, Nat) -> Nat -> Dependance) ->
                 [(Term a b, Term a b)] ->
                   [(Term a b, Term a b)] -> [(Term a b, Term a b)];
usable_rules_gen pi r p =
  concatMap (usable_rules_gen2 r)
    (remdups
      (map (\ (t, a) -> (root t, a))
        (mk_rtrancl_list (\ a b -> a == b) (usable_rules_gen1 pi r)
          (map (\ (_, t) -> (t, True)) p))));

generate_lists :: forall a. Nat -> [a] -> [[a]];
generate_lists n xs = concat_lists (map (\ _ -> xs) (upt Zero_nat n));

initial_conditions_gen_impl ::
  forall a. (a -> a -> Bool) -> Nat -> Nat -> [a] -> a -> [[a]];
initial_conditions_gen_impl pa bef_len aft_len p st =
  let {
    pairs = (\ n -> generate_lists n p);
    a = concatMap (\ bef -> map (\ aft -> bef ++ st : aft) (pairs aft_len))
          (pairs bef_len);
  } in filter
         (\ bef_st_aft ->
           all_interval_nat
             (\ i ->
               pa (nth bef_st_aft i)
                 (nth bef_st_aft (plus_nat i (Nat_of_num One))))
             Zero_nat (plus_nat bef_len aft_len))
         a;

data Condition_type = Bound | Strict | Non_Strict;

disjoint_variant ::
  forall a b.
    (Eq a, Card_UNIV b, Ceq b, Cproper_interval b, Eq b,
      Set_impla b) => [(Term a b, Term a b)] -> [(Term a b, Term a b)] -> Bool;
disjoint_variant sts uvs =
  equal_nat (size_list sts) (size_list uvs) &&
    all_interval_nat (\ i -> eq_rule_mod_vars (nth sts i) (nth uvs i)) Zero_nat
      (size_list sts) &&
      is_partition (map vars_rule uvs);

condition_of ::
  forall a b.
    a -> Condition_type -> (Term a b, Term a b) -> Cond_constraint a b;
condition_of c Bound (s, uu) = CC_cond False (s, Fun c []);
condition_of c Strict st = CC_cond True st;
condition_of c Non_Strict st = CC_cond False st;

constraint_of ::
  forall a b.
    a -> Condition_type -> [(Term a b, Term a b)] -> Nat -> Cond_constraint a b;
constraint_of c ctype uvs bef =
  CC_impl
    (map (\ i ->
           CC_rewr (snd (nth uvs i))
             (fst (nth uvs (plus_nat i (Nat_of_num One)))))
      (upt Zero_nat (minus_nat (size_list uvs) (Nat_of_num One))))
    (condition_of c ctype (nth uvs bef));

ur_term_impl ::
  forall a b c.
    (Eq a,
      Eq c) => (Term a [Prelude.Char] -> Bool) ->
                 (Term a b -> Term a (Sum () [Prelude.Char])) ->
                   [(Term a [Prelude.Char], c)] ->
                     ((a, Nat) -> Nat -> Bool) ->
                       [Term a [Prelude.Char]] ->
                         Term a b -> [(Term a [Prelude.Char], c)];
ur_term_impl nfq e_cap r pi s (Var x) = [];
ur_term_impl nfq e_cap r pi s (Fun f ts) =
  let {
    n = size_list ts;
    rec = map (ur_term_impl nfq e_cap r pi s) ts;
  } in remdups
         (concatMap (\ (i, urs) -> (if pi (f, n) i then urs else []))
            (zip (upt Zero_nat n) rec) ++
           filter
             (\ (l, _) ->
               (case mgu_class (Fun f (map e_cap ts)) l of {
                 Nothing -> False;
                 Just mu ->
                   all (\ u -> nfq (subst_apply_term u mu))
                     (s ++ map (map_vars (\ a -> 'y' : a)) (args l));
               }))
             r);

usable_rules_calculator ::
  forall a.
    (Eq a,
      Key a) => (Term a [Prelude.Char] -> Bool) ->
                  ([Term a [Prelude.Char]] ->
                    Term a [Prelude.Char] -> Term a (Sum () [Prelude.Char])) ->
                    [(Term a [Prelude.Char], Term a [Prelude.Char])] ->
                      ((a, Nat) -> Nat -> Bool) ->
                        (Term a [Prelude.Char], Term a [Prelude.Char]) ->
                          [(Term a [Prelude.Char], Term a [Prelude.Char])];
usable_rules_calculator nfq e_cap r pi =
  let {
    urt = (\ s ->
            let {
              sa = map (map_vars (\ a -> 'x' : a)) s;
            } in ur_term_impl nfq (e_cap sa) r pi sa);
    urules =
      map (\ (l, ra) -> ((l, ra), urt (args l) (map_vars (\ a -> 'x' : a) ra)))
        r;
    ufun = fun_of_map (ceta_map_of urules) [];
    rtran = mk_rtrancl_list (\ a b -> a == b) ufun;
  } in (\ (s, t) -> rtran (urt [s] (map_vars (\ a -> 'x' : a) t)));

get_ur_calc_impl_dpp ::
  forall a b.
    (Eq b,
      Key b) => Dpp_ops_ext a b [Prelude.Char] () ->
                  a -> ((b, Nat) -> Nat -> Bool) ->
                         (Term b [Prelude.Char], Term b [Prelude.Char]) ->
                           [(Term b [Prelude.Char], Term b [Prelude.Char])];
get_ur_calc_impl_dpp i d pi =
  let {
    ic = icap_impl_dpp i d;
    qnf = is_QNFc i d;
    r = rulesd i d;
  } in usable_rules_calculator qnf ic r pi;

finite_UNIV_list :: forall a. Phantom [a] Bool;
finite_UNIV_list = Phantom False;

instance Finite_UNIV [a] where {
  finite_UNIV = finite_UNIV_list;
};

card_UNIV_list :: forall a. Phantom [a] Nat;
card_UNIV_list = Phantom Zero_nat;

instance Card_UNIV [a] where {
  card_UNIV = card_UNIV_list;
};

inn_usable_rules_pair ::
  forall a b.
    (Eq b,
      Key b) => Dpp_ops_ext a b [Prelude.Char] () ->
                  a -> (Term b [Prelude.Char], Term b [Prelude.Char]) ->
                         [(Term b [Prelude.Char], Term b [Prelude.Char])];
inn_usable_rules_pair i d =
  let {
    inn = nFQ_subset_NF_rulesb i d;
    r = rulesd i d;
    _ = is_QNFc i d;
    calc = get_ur_calc_impl_dpp i d full_af;
    nfs = nfsc i d;
    wwf = wwf_rulesa i d;
    m = minimal i d;
  } in (\ (s, t) ->
         (if inn &&
               (nfs || subset (vars_term t) (vars_term s)) &&
                 (nfs || (m || wwf))
           then calc (s, t) else r));

icap_impl_dpp_mv ::
  forall a b.
    (Eq b) => Dpp_ops_ext a b [Prelude.Char] () ->
                a -> [Term b [Prelude.Char]] ->
                       Term b [Prelude.Char] -> Term b (Sum () [Prelude.Char]);
icap_impl_dpp_mv i d =
  let {
    qr = nFQ_subset_NF_rulesb i d;
    qnf = is_QNFc i d;
    r = rulesd i d;
    ic = icap_impl qr qnf (map fst r);
  } in (\ s ->
         let {
           sa = map (map_vars (\ a -> 'x' : a)) s;
           sx = ceta_set_of (concatMap vars_term_lista sa);
         } in (\ t -> ic sa sx (map_vars (\ a -> 'x' : a) t)));

is_iedg_edge_dpp ::
  forall a b.
    (Eq b, Key b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    a -> (Term b [Prelude.Char], Term b [Prelude.Char]) ->
                           Term b [Prelude.Char] -> Bool;
is_iedg_edge_dpp i d =
  let {
    qnf = is_QNFc i d;
    ic = icap_impl_dpp_mv i d;
    _ = rulesd i d;
    urules = inn_usable_rules_pair i d;
  } in (\ (s, t) ->
         let {
           cst = ic [s] t;
           urls = reverse_rules (urules (s, t));
           ica = icap_impla urls [];
         } in (\ u ->
                (case mgu_class cst u of {
                  Nothing -> False;
                  Just mu ->
                    qnf (subst_apply_term (map_vars (\ a -> 'x' : a) s) mu) &&
                      qnf (subst_apply_term (map_vars (\ a -> 'y' : a) u) mu);
                }) &&
                  let {
                    cu = ica [] u;
                  } in (case mgu_class cu t of {
                         Nothing -> False;
                         Just mu ->
                           qnf (subst_apply_term (map_vars (\ a -> 'y' : a) s)
                                 mu);
                       })));

cproper_interval_list :: forall a. (Corder a) => Maybe [a] -> Maybe [a] -> Bool;
cproper_interval_list xso yso = error "undefined";

instance (Corder a) => Cproper_interval [a] where {
  cproper_interval = cproper_interval_list;
};

deep_normalize_cca :: forall a b. Cond_constraint a b -> Cond_constraint a b;
deep_normalize_cca (CC_impl [] c) = deep_normalize_cca c;
deep_normalize_cca (CC_impl (v : va) c) =
  CC_impl (map deep_normalize_cca (v : va)) (deep_normalize_cca c);
deep_normalize_cca (CC_cond s c) = CC_cond s c;
deep_normalize_cca (CC_all s c) = CC_all s (deep_normalize_cca c);
deep_normalize_cca (CC_rewr s c) = CC_rewr s c;

vars_cc_list :: forall a b. (Eq b) => Cond_constraint a b -> [b];
vars_cc_list (CC_cond ct (s, t)) = vars_term_lista s ++ vars_term_lista t;
vars_cc_list (CC_rewr s t) = vars_term_lista s ++ vars_term_lista t;
vars_cc_list (CC_impl c1 c2) = concatMap vars_cc_list c1 ++ vars_cc_list c2;
vars_cc_list (CC_all x c) =
  concatMap (\ y -> (if not (y == x) then [y] else [])) (vars_cc_list c);

cc_subst_apply ::
  forall a b.
    (Eq a) => ([a] -> a) ->
                Cond_constraint b a ->
                  (a -> Term b a, [a]) -> Cond_constraint b a;
cc_subst_apply fresh (CC_all x c) (sigma, vs) =
  let {
    y = fresh (vs ++ vars_cc_list (CC_all x c));
  } in CC_all y (cc_subst_apply fresh c (fun_upd sigma x (Var y), y : vs));
cc_subst_apply fresh (CC_impl c1 c2) sigma =
  CC_impl (map (\ c -> cc_subst_apply fresh c sigma) c1)
    (cc_subst_apply fresh c2 sigma);
cc_subst_apply fresh (CC_rewr s t) (sigma, uv) =
  CC_rewr (subst_apply_term s sigma) (subst_apply_term t sigma);
cc_subst_apply fresh (CC_cond ct (s, t)) (sigma, uu) =
  CC_cond ct (subst_apply_term s sigma, subst_apply_term t sigma);

normalize_alpha ::
  forall a b.
    (Eq a) => ([a] -> a) -> Cond_constraint b a -> Cond_constraint b a;
normalize_alpha fresh c = cc_subst_apply fresh c (Var, []);

deep_normalize_cc ::
  forall a b.
    (Eq a) => ([a] -> a) -> Cond_constraint b a -> Cond_constraint b a;
deep_normalize_cc fresh c = normalize_alpha fresh (deep_normalize_cca c);

equal_cond_constraint ::
  forall a b.
    (Eq a, Eq b) => Cond_constraint a b -> Cond_constraint a b -> Bool;
equal_cond_constraint (CC_all v cond_constrainta) (CC_impl list cond_constraint)
  = False;
equal_cond_constraint (CC_impl list cond_constrainta) (CC_all v cond_constraint)
  = False;
equal_cond_constraint (CC_all v cond_constraint) (CC_rewr term1 term2) = False;
equal_cond_constraint (CC_rewr term1 term2) (CC_all v cond_constraint) = False;
equal_cond_constraint (CC_impl list cond_constraint) (CC_rewr term1 term2) =
  False;
equal_cond_constraint (CC_rewr term1 term2) (CC_impl list cond_constraint) =
  False;
equal_cond_constraint (CC_all v cond_constraint) (CC_cond bool prod) = False;
equal_cond_constraint (CC_cond bool prod) (CC_all v cond_constraint) = False;
equal_cond_constraint (CC_impl list cond_constraint) (CC_cond bool prod) =
  False;
equal_cond_constraint (CC_cond bool prod) (CC_impl list cond_constraint) =
  False;
equal_cond_constraint (CC_rewr term1 term2) (CC_cond bool prod) = False;
equal_cond_constraint (CC_cond bool prod) (CC_rewr term1 term2) = False;
equal_cond_constraint (CC_all va cond_constrainta) (CC_all v cond_constraint) =
  va == v && equal_cond_constraint cond_constrainta cond_constraint;
equal_cond_constraint (CC_impl lista cond_constrainta)
  (CC_impl list cond_constraint) =
  lista == list && equal_cond_constraint cond_constrainta cond_constraint;
equal_cond_constraint (CC_rewr term1a term2a) (CC_rewr term1 term2) =
  equal_term term1a term1 && equal_term term2a term2;
equal_cond_constraint (CC_cond boola proda) (CC_cond bool prod) =
  boola == bool && proda == prod;

instance (Eq a, Eq b) => Eq (Cond_constraint a b) where {
  a == b = equal_cond_constraint a b;
};

check_subsumesa ::
  forall a b.
    (Eq a, Eq b) => Cond_constraint a b -> Cond_constraint a b -> Bool;
check_subsumesa (CC_impl cs c) (CC_impl ds d) =
  check_subsumesa c d &&
    all (\ ca -> any (\ da -> check_subsumesa da ca) ds) cs;
check_subsumesa (CC_cond v va) (CC_impl ds d) =
  check_subsumesa (CC_cond v va) d;
check_subsumesa (CC_rewr v va) (CC_impl ds d) =
  check_subsumesa (CC_rewr v va) d;
check_subsumesa (CC_all v va) (CC_impl ds d) = check_subsumesa (CC_all v va) d;
check_subsumesa (CC_all x c) (CC_all y d) = x == y && check_subsumesa c d;
check_subsumesa (CC_cond v va) (CC_cond vb vc) =
  equal_cond_constraint (CC_cond v va) (CC_cond vb vc);
check_subsumesa (CC_cond v va) (CC_rewr vb vc) =
  equal_cond_constraint (CC_cond v va) (CC_rewr vb vc);
check_subsumesa (CC_cond v va) (CC_all vb vc) =
  equal_cond_constraint (CC_cond v va) (CC_all vb vc);
check_subsumesa (CC_rewr v va) (CC_cond vb vc) =
  equal_cond_constraint (CC_rewr v va) (CC_cond vb vc);
check_subsumesa (CC_rewr v va) (CC_rewr vb vc) =
  equal_cond_constraint (CC_rewr v va) (CC_rewr vb vc);
check_subsumesa (CC_rewr v va) (CC_all vb vc) =
  equal_cond_constraint (CC_rewr v va) (CC_all vb vc);
check_subsumesa (CC_all v va) (CC_cond vb vc) =
  equal_cond_constraint (CC_all v va) (CC_cond vb vc);
check_subsumesa (CC_all v va) (CC_rewr vb vc) =
  equal_cond_constraint (CC_all v va) (CC_rewr vb vc);
check_subsumesa c (CC_cond v va) = equal_cond_constraint c (CC_cond v va);
check_subsumesa c (CC_rewr v va) = equal_cond_constraint c (CC_rewr v va);
check_subsumesa (CC_impl vb vc) (CC_all v va) =
  equal_cond_constraint (CC_impl vb vc) (CC_all v va);

check_subsumes ::
  forall a b.
    (Eq a,
      Eq b) => ([a] -> a) -> Cond_constraint b a -> Cond_constraint b a -> Bool;
check_subsumes fresh c d =
  let {
    n = deep_normalize_cc fresh;
  } in check_subsumesa (n c) (n d);

check_constraint_present ::
  forall a b.
    (Eq b, Key b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    a -> b -> [(Term b [Prelude.Char],
                                 Term b [Prelude.Char])] ->
                                Nat ->
                                  Nat ->
                                    [(Cond_constraint b [Prelude.Char],
                                       [(Term b [Prelude.Char],
  Term b [Prelude.Char])])] ->
                                      Condition_type ->
(Term b [Prelude.Char], Term b [Prelude.Char]) ->
  Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_constraint_present i dpp constant p bef aft ccs =
  let {
    edg = is_iedg_edge_dpp i dpp;
    init_conds =
      initial_conditions_gen_impl (\ st uv -> edg st (fst uv)) bef aft p;
  } in (\ ct st ->
         catcha
           (forallM
             (\ sts ->
               check (any (\ (c, uvs) ->
                            disjoint_variant sts uvs &&
                              check_subsumes (fresh_string ['x', 'x']) c
                                (constraint_of constant ct uvs bef))
                       ccs)
                 (shows_prec_list Zero_nat
                    ['d', 'i', 'd', ' ', 'n', 'o', 't', ' ', 'f', 'i', 'n', 'd',
                      ' '] .
                   shows_prec_list Zero_nat
                     (case ct of {
                       Bound -> ['b', 'o', 'u', 'n', 'd'];
                       Strict -> ['s', 't', 'r', 'i', 'c', 't'];
                       Non_Strict ->
                         ['n', 'o', 'n', '-', 's', 't', 'r', 'i', 'c', 't'];
                     }) .
                     shows_prec_list Zero_nat
                       [' ', 'c', 'o', 'n', 's', 't', 'r', 'a', 'i', 'n', 't',
                         ' ', 'f', 'o', 'r', ' ', 's', 'e', 'q', 'u', 'e', 'n',
                         'c', 'e', ' '] .
                       shows_rules (shows_prec Zero_nat)
                         (shows_prec_list Zero_nat) [' ', '-', '>', ' '] sts))
             (init_conds st))
           (\ x -> Inl (snd x)));

range_vars_impl :: forall a b. (Eq a, Eq b) => [(a, Term b a)] -> [a];
range_vars_impl sigma =
  let {
    a = mk_subst_domain sigma;
  } in concatMap (vars_term_lista . snd) a;

cc_bound :: forall a b. [a] -> Cond_constraint b a -> Cond_constraint b a;
cc_bound [] c = c;
cc_bound (x : xs) c = CC_all x (cc_bound xs c);

cc_ih_prems ::
  forall a b.
    (Eq a,
      Eq b) => ([a] -> a) ->
                 b -> Term b a ->
                        [a] ->
                          [Cond_constraint b a] ->
                            Cond_constraint b a ->
                              [(Term b a, [a])] -> [Cond_constraint b a];
cc_ih_prems fresh f q xs phi psi rs_ys_list =
  map (\ (r, ys) ->
        let {
          rs = args r;
          mu = mk_subst Var (zip xs rs);
          vs = range_vars_impl (zip xs rs);
          mua = (\ c -> cc_subst_apply fresh c (mu, vs));
          a = CC_impl (CC_rewr r (subst_apply_term q mu) : map mua phi)
                (mua psi);
        } in cc_bound ys a)
    rs_ys_list;

cc_rule_constraint ::
  forall a b.
    (Eq a,
      Eq b) => ([a] -> a) ->
                 b -> [Term b a] ->
                        Term b a ->
                          Term b a ->
                            [a] ->
                              [Cond_constraint b a] ->
                                Cond_constraint b a ->
                                  [(Term b a, [a])] -> Cond_constraint b a;
cc_rule_constraint fresh f ls r q xs phi psi rs_ys_list =
  let {
    sigma = mk_subst Var (zip xs ls);
    vs = range_vars_impl (zip xs ls);
    rew = CC_rewr r (subst_apply_term q sigma);
    phi_sig = map (\ c -> cc_subst_apply fresh c (sigma, vs)) phi;
    psi_sig = cc_subst_apply fresh psi (sigma, vs);
    ihs = cc_ih_prems fresh f q xs phi psi rs_ys_list;
  } in CC_impl (rew : phi_sig ++ ihs) psi_sig;

cc_unbound :: forall a b. Cond_constraint a b -> ([b], Cond_constraint a b);
cc_unbound (CC_all x c) = let {
                            (xs, a) = cc_unbound c;
                          } in (x : xs, a);
cc_unbound (CC_cond v va) = ([], CC_cond v va);
cc_unbound (CC_rewr v va) = ([], CC_rewr v va);
cc_unbound (CC_impl v va) = ([], CC_impl v va);

funas_args_term_list :: forall a b. Term a b -> [(a, Nat)];
funas_args_term_list t = concatMap funas_term_list (args t);

funas_args_term_lista :: forall a b. (Eq a) => Term a b -> [(a, Nat)];
funas_args_term_lista = remdups . funas_args_term_list;

check_rys ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => ((a, Nat) -> Bool) ->
                    Maybe (a, Nat) ->
                      Term a b ->
                        (Term a b, [b]) ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_rys d rt r rys =
  let {
    (ra, ys) = rys;
  } in bindb (check (root ra == rt)
               (shows_string ['r', 'o', 'o', 't', ' ', 'o', 'f', ' '] .
                 shows_prec_term Zero_nat ra .
                   shows_string [' ', 'i', 's', ' ', 'n', 'o', 't', ' '] .
                     shows_prec_prod Zero_nat (the rt)))
         (\ _ ->
           bindb (check (equal_term r ra || supt_impl r ra)
                   (shows_prec_term Zero_nat ra .
                     shows_string
                       [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 's',
                         'u', 'b', 't', 'e', 'r', 'm', ' ', 'o', 'f', ' '] .
                       shows_prec_term Zero_nat r))
             (\ _ ->
               bindb (catcha
                       (forallM
                         (\ f ->
                           check (not (d f))
                             (shows_string
                                ['t', 'h', 'e', ' ', 'd', 'e', 'f', 'i', 'n',
                                  'e', 'd', ' ', 's', 'y', 'm', 'b', 'o', 'l',
                                  ' '] .
                               shows_prec_prod Zero_nat f .
                                 shows_string
                                   [' ', 'o', 'c', 'c', 'u', 'r', 's', ' ', 'i',
                                     'n', ' ', 't', 'h', 'e', ' ', 's', 'u',
                                     'b', 't', 'e', 'r', 'm', ' '] .
                                   shows_prec_term Zero_nat ra .
                                     shows_prec_list Zero_nat
                                       [' ', 'o', 'f', ' ', 't', 'h', 'e', ' ',
 'r', 'h', 's']))
                         (funas_args_term_lista ra))
                       (\ x -> Inl (snd x)))
                 (\ _ ->
                   catcha (check_disjoint ys (vars_term_lista r))
                     (\ x ->
                       Inl (shows_prec Zero_nat x .
                             shows_string
                               [' ', 'o', 'c', 'c', 'u', 'r', 's', ' ', 'i',
                                 'n', ' '] .
                               shows_prec_term Zero_nat r)))));

shows_cc_aux ::
  forall a b.
    (Showa a,
      Showa b) => Bool ->
                    Cond_constraint a b -> [Prelude.Char] -> [Prelude.Char];
shows_cc_aux b (CC_rewr s t) =
  shows_prec_term Zero_nat s .
    shows_prec_list Zero_nat [' ', '=', ' '] . shows_prec_term Zero_nat t;
shows_cc_aux b (CC_cond stri (s, t)) =
  shows_prec_term Zero_nat s .
    shows_prec_list Zero_nat
      (if stri then [' ', '>', ' '] else [' ', '>', '=', ' ']) .
      shows_prec_term Zero_nat t;
shows_cc_aux b (CC_all x c) =
  let {
    s = shows_prec_list Zero_nat ['A', 'L', 'L', ' '] .
          shows_prec Zero_nat x .
            shows_prec_list Zero_nat ['.', ' '] . shows_cc_aux False c;
  } in (if b then shows_prec_list Zero_nat ['('] .
                    s . shows_prec_list Zero_nat [')']
         else s);
shows_cc_aux b (CC_impl cs c2) =
  shows_string ['('] .
    shows_list_gen (shows_cc_aux True) ['T', 'r', 'u', 'e'] []
      [' ', 'a', 'n', 'd', ' '] [] cs .
      shows_prec_list Zero_nat [' ', '=', '>', ' '] .
        shows_cc_aux True c2 . shows_prec_list Zero_nat [')'];

shows_cc ::
  forall a b.
    (Showa a,
      Showa b) => Cond_constraint a b -> [Prelude.Char] -> [Prelude.Char];
shows_cc = shows_cc_aux False;

prems_of :: forall a b. Cond_constraint a b -> [Cond_constraint a b];
prems_of (CC_impl c1 c2) = c1;
prems_of (CC_cond v va) = [];
prems_of (CC_rewr v va) = [];
prems_of (CC_all v va) = [];

concl_of :: forall a b. Cond_constraint a b -> Cond_constraint a b;
concl_of (CC_impl c1 c2) = c2;
concl_of (CC_cond v va) = CC_cond v va;
concl_of (CC_rewr v va) = CC_rewr v va;
concl_of (CC_all v va) = CC_all v va;

normalize_cc :: forall a b. Cond_constraint a b -> Cond_constraint a b;
normalize_cc c = CC_impl (prems_of c) (concl_of c);

funas_term_lista :: forall a b. (Eq a) => Term a b -> [(a, Nat)];
funas_term_lista = remdups . funas_term_list;

check_cc_prf ::
  forall a.
    (Ceq a, Corder a, Eq a, Set_impla a,
      Showa a) => [(Term a [Prelude.Char], Term a [Prelude.Char])] ->
                    ((a, Nat) -> Bool) ->
                      [(a, Nat)] ->
                        Bool ->
                          Cond_constraint a [Prelude.Char] ->
                            Cond_constraint_prf a [Prelude.Char] ->
                              Sum ([Prelude.Char] -> [Prelude.Char])
                                [C_constraint a [Prelude.Char]];
check_cc_prf r d f m_ortho cc Final =
  (case normalize_cc cc of {
    CC_cond _ _ ->
      Inl (shows_prec_list Zero_nat
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'f', 'i',
               'n', 'a', 'l', ' ', 'c', 'o', 'n', 's', 't', 'r', 'a', 'i', 'n',
               't', ':', ' ', 'i', 't', ' ', 'i', 's', ' ', 'n', 'e', 'i', 't',
               'h', 'e', 'r', ' ', 'a', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
               'o', 'n', ' ', 'n', 'o', 'r', ' ', 'a', 'n', ' ', 'i', 'm', 'p',
               'l', 'i', 'f', 'i', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f',
               ' ', 't', 'w', 'o', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o',
               'n', 's', ',', ' ', 'b', 'u', 't', ' ', 'i', 't', ' ', 'i', 's',
               ' '] .
            shows_nl . shows_cc cc);
    CC_rewr _ _ ->
      Inl (shows_prec_list Zero_nat
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'f', 'i',
               'n', 'a', 'l', ' ', 'c', 'o', 'n', 's', 't', 'r', 'a', 'i', 'n',
               't', ':', ' ', 'i', 't', ' ', 'i', 's', ' ', 'n', 'e', 'i', 't',
               'h', 'e', 'r', ' ', 'a', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
               'o', 'n', ' ', 'n', 'o', 'r', ' ', 'a', 'n', ' ', 'i', 'm', 'p',
               'l', 'i', 'f', 'i', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f',
               ' ', 't', 'w', 'o', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o',
               'n', 's', ',', ' ', 'b', 'u', 't', ' ', 'i', 't', ' ', 'i', 's',
               ' '] .
            shows_nl . shows_cc cc);
    CC_impl [] (CC_cond stri st) -> Inr [Unconditional_C stri st];
    CC_impl [] (CC_rewr _ _) ->
      Inl (shows_prec_list Zero_nat
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'f', 'i',
               'n', 'a', 'l', ' ', 'c', 'o', 'n', 's', 't', 'r', 'a', 'i', 'n',
               't', ':', ' ', 'i', 't', ' ', 'i', 's', ' ', 'n', 'e', 'i', 't',
               'h', 'e', 'r', ' ', 'a', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
               'o', 'n', ' ', 'n', 'o', 'r', ' ', 'a', 'n', ' ', 'i', 'm', 'p',
               'l', 'i', 'f', 'i', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f',
               ' ', 't', 'w', 'o', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o',
               'n', 's', ',', ' ', 'b', 'u', 't', ' ', 'i', 't', ' ', 'i', 's',
               ' '] .
            shows_nl . shows_cc cc);
    CC_impl [] (CC_impl _ _) ->
      Inl (shows_prec_list Zero_nat
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'f', 'i',
               'n', 'a', 'l', ' ', 'c', 'o', 'n', 's', 't', 'r', 'a', 'i', 'n',
               't', ':', ' ', 'i', 't', ' ', 'i', 's', ' ', 'n', 'e', 'i', 't',
               'h', 'e', 'r', ' ', 'a', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
               'o', 'n', ' ', 'n', 'o', 'r', ' ', 'a', 'n', ' ', 'i', 'm', 'p',
               'l', 'i', 'f', 'i', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f',
               ' ', 't', 'w', 'o', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o',
               'n', 's', ',', ' ', 'b', 'u', 't', ' ', 'i', 't', ' ', 'i', 's',
               ' '] .
            shows_nl . shows_cc cc);
    CC_impl [] (CC_all _ _) ->
      Inl (shows_prec_list Zero_nat
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'f', 'i',
               'n', 'a', 'l', ' ', 'c', 'o', 'n', 's', 't', 'r', 'a', 'i', 'n',
               't', ':', ' ', 'i', 't', ' ', 'i', 's', ' ', 'n', 'e', 'i', 't',
               'h', 'e', 'r', ' ', 'a', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
               'o', 'n', ' ', 'n', 'o', 'r', ' ', 'a', 'n', ' ', 'i', 'm', 'p',
               'l', 'i', 'f', 'i', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f',
               ' ', 't', 'w', 'o', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o',
               'n', 's', ',', ' ', 'b', 'u', 't', ' ', 'i', 't', ' ', 'i', 's',
               ' '] .
            shows_nl . shows_cc cc);
    CC_impl [CC_cond stri uv] (CC_cond stria st) ->
      (if stri == stria then Inr [Conditional_C stri uv st]
        else Inl (shows_prec_list Zero_nat
                    ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'f',
                      'i', 'n', 'a', 'l', ' ', 'c', 'o', 'n', 's', 't', 'r',
                      'a', 'i', 'n', 't', ':', ' ', 'd', 'i', 'f', 'f', 'e',
                      'r', 'e', 'n', 't', ' ', 'r', 'e', 'l', 'a', 't', 'i',
                      'o', 'n', 's', ' ', 'f', 'o', 'r', ' ', 'f', 'i', 'n',
                      'a', 'l', 'i', 'z', 'i', 'n', 'g', ' '] .
                   shows_cc cc));
    CC_impl [CC_cond stri uv] (CC_rewr _ _) ->
      Inl (shows_prec_list Zero_nat
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'f', 'i',
               'n', 'a', 'l', ' ', 'c', 'o', 'n', 's', 't', 'r', 'a', 'i', 'n',
               't', ':', ' ', 'i', 't', ' ', 'i', 's', ' ', 'n', 'e', 'i', 't',
               'h', 'e', 'r', ' ', 'a', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
               'o', 'n', ' ', 'n', 'o', 'r', ' ', 'a', 'n', ' ', 'i', 'm', 'p',
               'l', 'i', 'f', 'i', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f',
               ' ', 't', 'w', 'o', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o',
               'n', 's', ',', ' ', 'b', 'u', 't', ' ', 'i', 't', ' ', 'i', 's',
               ' '] .
            shows_nl . shows_cc cc);
    CC_impl [CC_cond stri uv] (CC_impl _ _) ->
      Inl (shows_prec_list Zero_nat
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'f', 'i',
               'n', 'a', 'l', ' ', 'c', 'o', 'n', 's', 't', 'r', 'a', 'i', 'n',
               't', ':', ' ', 'i', 't', ' ', 'i', 's', ' ', 'n', 'e', 'i', 't',
               'h', 'e', 'r', ' ', 'a', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
               'o', 'n', ' ', 'n', 'o', 'r', ' ', 'a', 'n', ' ', 'i', 'm', 'p',
               'l', 'i', 'f', 'i', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f',
               ' ', 't', 'w', 'o', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o',
               'n', 's', ',', ' ', 'b', 'u', 't', ' ', 'i', 't', ' ', 'i', 's',
               ' '] .
            shows_nl . shows_cc cc);
    CC_impl [CC_cond stri uv] (CC_all _ _) ->
      Inl (shows_prec_list Zero_nat
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'f', 'i',
               'n', 'a', 'l', ' ', 'c', 'o', 'n', 's', 't', 'r', 'a', 'i', 'n',
               't', ':', ' ', 'i', 't', ' ', 'i', 's', ' ', 'n', 'e', 'i', 't',
               'h', 'e', 'r', ' ', 'a', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
               'o', 'n', ' ', 'n', 'o', 'r', ' ', 'a', 'n', ' ', 'i', 'm', 'p',
               'l', 'i', 'f', 'i', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f',
               ' ', 't', 'w', 'o', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o',
               'n', 's', ',', ' ', 'b', 'u', 't', ' ', 'i', 't', ' ', 'i', 's',
               ' '] .
            shows_nl . shows_cc cc);
    CC_impl (CC_cond stri uv : _ : _) cond_constraint ->
      Inl (shows_prec_list Zero_nat
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'f', 'i',
               'n', 'a', 'l', ' ', 'c', 'o', 'n', 's', 't', 'r', 'a', 'i', 'n',
               't', ':', ' ', 'i', 't', ' ', 'i', 's', ' ', 'n', 'e', 'i', 't',
               'h', 'e', 'r', ' ', 'a', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
               'o', 'n', ' ', 'n', 'o', 'r', ' ', 'a', 'n', ' ', 'i', 'm', 'p',
               'l', 'i', 'f', 'i', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f',
               ' ', 't', 'w', 'o', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o',
               'n', 's', ',', ' ', 'b', 'u', 't', ' ', 'i', 't', ' ', 'i', 's',
               ' '] .
            shows_nl . shows_cc cc);
    CC_impl (CC_rewr _ _ : lista) cond_constraint ->
      Inl (shows_prec_list Zero_nat
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'f', 'i',
               'n', 'a', 'l', ' ', 'c', 'o', 'n', 's', 't', 'r', 'a', 'i', 'n',
               't', ':', ' ', 'i', 't', ' ', 'i', 's', ' ', 'n', 'e', 'i', 't',
               'h', 'e', 'r', ' ', 'a', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
               'o', 'n', ' ', 'n', 'o', 'r', ' ', 'a', 'n', ' ', 'i', 'm', 'p',
               'l', 'i', 'f', 'i', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f',
               ' ', 't', 'w', 'o', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o',
               'n', 's', ',', ' ', 'b', 'u', 't', ' ', 'i', 't', ' ', 'i', 's',
               ' '] .
            shows_nl . shows_cc cc);
    CC_impl (CC_impl _ _ : lista) cond_constraint ->
      Inl (shows_prec_list Zero_nat
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'f', 'i',
               'n', 'a', 'l', ' ', 'c', 'o', 'n', 's', 't', 'r', 'a', 'i', 'n',
               't', ':', ' ', 'i', 't', ' ', 'i', 's', ' ', 'n', 'e', 'i', 't',
               'h', 'e', 'r', ' ', 'a', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
               'o', 'n', ' ', 'n', 'o', 'r', ' ', 'a', 'n', ' ', 'i', 'm', 'p',
               'l', 'i', 'f', 'i', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f',
               ' ', 't', 'w', 'o', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o',
               'n', 's', ',', ' ', 'b', 'u', 't', ' ', 'i', 't', ' ', 'i', 's',
               ' '] .
            shows_nl . shows_cc cc);
    CC_impl (CC_all _ _ : lista) cond_constraint ->
      Inl (shows_prec_list Zero_nat
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'f', 'i',
               'n', 'a', 'l', ' ', 'c', 'o', 'n', 's', 't', 'r', 'a', 'i', 'n',
               't', ':', ' ', 'i', 't', ' ', 'i', 's', ' ', 'n', 'e', 'i', 't',
               'h', 'e', 'r', ' ', 'a', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
               'o', 'n', ' ', 'n', 'o', 'r', ' ', 'a', 'n', ' ', 'i', 'm', 'p',
               'l', 'i', 'f', 'i', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f',
               ' ', 't', 'w', 'o', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o',
               'n', 's', ',', ' ', 'b', 'u', 't', ' ', 'i', 't', ' ', 'i', 's',
               ' '] .
            shows_nl . shows_cc cc);
    CC_all _ _ ->
      Inl (shows_prec_list Zero_nat
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'f', 'i',
               'n', 'a', 'l', ' ', 'c', 'o', 'n', 's', 't', 'r', 'a', 'i', 'n',
               't', ':', ' ', 'i', 't', ' ', 'i', 's', ' ', 'n', 'e', 'i', 't',
               'h', 'e', 'r', ' ', 'a', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
               'o', 'n', ' ', 'n', 'o', 'r', ' ', 'a', 'n', ' ', 'i', 'm', 'p',
               'l', 'i', 'f', 'i', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f',
               ' ', 't', 'w', 'o', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o',
               'n', 's', ',', ' ', 'b', 'u', 't', ' ', 'i', 't', ' ', 'i', 's',
               ' '] .
            shows_nl . shows_cc cc);
  });
check_cc_prf r da f m_ortho c (Delete_Condition d prf) =
  bindb (check (check_subsumes (fresh_string ['x', 'x']) d c)
          (shows_string
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'd', 'e',
               'l', 'e', 't', 'e', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o',
               'n', 's', ' ', 'w', 'h', 'e', 'n', ' ', 's', 'w', 'i', 't', 'c',
               'h', 'i', 'n', 'g', ' ', 'f', 'r', 'o', 'm', ' '] .
            shows_nl .
              shows_cc c .
                shows_string [' ', 't', 'o', ' '] . shows_nl . shows_cc d))
    (\ _ -> check_cc_prf r da f m_ortho d prf);
check_cc_prf r da f m_ortho c (Different_Constructor d) =
  let {
    (CC_impl cs _) = normalize_cc c;
  } in catcha
         (bindb
           (check (membera cs d)
             (shows_cc d .
               shows_nl .
                 shows_string
                   ['i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'p', 'r', 'e',
                     'm', 'i', 's', 'e', ' ', 'o', 'f', ' '] .
                   shows_cc c))
           (\ _ ->
             (case d of {
               CC_cond _ _ ->
                 Inl (shows_cc d .
                       shows_prec_list Zero_nat
                         [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'r',
                           'e', 'w', 'r', 'i', 't', 'e', ' ', 'c', 'o', 'n',
                           'd', 'i', 't', 'i', 'o', 'n', ' ', 'o', 'f', ' ',
                           't', 'h', 'e', ' ', 'c', 'o', 'r', 'r', 'e', 'c',
                           't', ' ', 's', 'h', 'a', 'p', 'e']);
               CC_rewr (Var _) term2 ->
                 Inl (shows_cc d .
                       shows_prec_list Zero_nat
                         [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'r',
                           'e', 'w', 'r', 'i', 't', 'e', ' ', 'c', 'o', 'n',
                           'd', 'i', 't', 'i', 'o', 'n', ' ', 'o', 'f', ' ',
                           't', 'h', 'e', ' ', 'c', 'o', 'r', 'r', 'e', 'c',
                           't', ' ', 's', 'h', 'a', 'p', 'e']);
               CC_rewr (Fun fa ss) (Var _) ->
                 Inl (shows_cc d .
                       shows_prec_list Zero_nat
                         [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'r',
                           'e', 'w', 'r', 'i', 't', 'e', ' ', 'c', 'o', 'n',
                           'd', 'i', 't', 'i', 'o', 'n', ' ', 'o', 'f', ' ',
                           't', 'h', 'e', ' ', 'c', 'o', 'r', 'r', 'e', 'c',
                           't', ' ', 's', 'h', 'a', 'p', 'e']);
               CC_rewr (Fun fa ss) (Fun g ts) ->
                 bindb (check (not (da (fa, size_list ss)))
                         (shows_prec Zero_nat fa .
                           shows_prec_list Zero_nat
                             [' ', 'i', 's', ' ', 'd', 'e', 'f', 'i', 'n', 'e',
                               'd']))
                   (\ _ ->
                     bindb (check
                             (not ((fa, size_list ss) == (g, size_list ts)))
                             (shows_string
                                ['t', 'h', 'e', ' ', 'r', 'o', 'o', 't', ' '] .
                               shows_prec Zero_nat fa .
                                 shows_prec_list Zero_nat
                                   [' ', 'i', 's', ' ', 'i', 'd', 'e', 'n', 't',
                                     'i', 'c', 'a', 'l', ' ', 'o', 'n', ' ',
                                     'b', 'o', 't', 'h', ' ', 's', 'i', 'd',
                                     'e', 's']))
                       (\ _ -> Inr []));
               CC_impl _ _ ->
                 Inl (shows_cc d .
                       shows_prec_list Zero_nat
                         [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'r',
                           'e', 'w', 'r', 'i', 't', 'e', ' ', 'c', 'o', 'n',
                           'd', 'i', 't', 'i', 'o', 'n', ' ', 'o', 'f', ' ',
                           't', 'h', 'e', ' ', 'c', 'o', 'r', 'r', 'e', 'c',
                           't', ' ', 's', 'h', 'a', 'p', 'e']);
               CC_all _ _ ->
                 Inl (shows_cc d .
                       shows_prec_list Zero_nat
                         [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'r',
                           'e', 'w', 'r', 'i', 't', 'e', ' ', 'c', 'o', 'n',
                           'd', 'i', 't', 'i', 'o', 'n', ' ', 'o', 'f', ' ',
                           't', 'h', 'e', ' ', 'c', 'o', 'r', 'r', 'e', 'c',
                           't', ' ', 's', 'h', 'a', 'p', 'e']);
             })))
         (\ x ->
           Inl (shows_string
                  ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'D',
                    'i', 'f', 'f', 'e', 'r', 'e', 'n', 't', ' ', 'C', 'o', 'n',
                    's', 't', 'r', 'u', 'c', 't', 'o', 'r', ' ', 'w', 'i', 't',
                    'h', ' ', 'r', 'e', 'w', 'r', 'i', 't', 'e', ' ', 'c', 'o',
                    'n', 'd', 'i', 't', 'i', 'o', 'n', ' '] .
                 shows_cc d .
                   shows_nl .
                     shows_string
                       ['o', 'n', ' ', 'i', 'n', 'p', 'u', 't', ' ', 'c', 'o',
                         'n', 's', 't', 'r', 'a', 'i', 'n', 't', ' '] .
                       shows_nl . shows_cc c . shows_nl . x));
check_cc_prf r da f m_ortho ca (Same_Constructor d c p) =
  let {
    (CC_impl cs con) = normalize_cc ca;
  } in bindb (catcha
               (bindb
                 (check (membera cs d)
                   (shows_cc d .
                     shows_nl .
                       shows_string
                         ['i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'p', 'r',
                           'e', 'm', 'i', 's', 'e', ' ', 'o', 'f', ' '] .
                         shows_cc ca))
                 (\ _ ->
                   (case d of {
                     CC_cond _ _ ->
                       Inl (shows_cc d .
                             shows_prec_list Zero_nat
                               [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a',
                                 ' ', 'r', 'e', 'w', 'r', 'i', 't', 'e', ' ',
                                 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n',
                                 ' ', 'o', 'f', ' ', 't', 'h', 'e', ' ', 'c',
                                 'o', 'r', 'r', 'e', 'c', 't', ' ', 's', 'h',
                                 'a', 'p', 'e']);
                     CC_rewr (Var _) term2 ->
                       Inl (shows_cc d .
                             shows_prec_list Zero_nat
                               [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a',
                                 ' ', 'r', 'e', 'w', 'r', 'i', 't', 'e', ' ',
                                 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n',
                                 ' ', 'o', 'f', ' ', 't', 'h', 'e', ' ', 'c',
                                 'o', 'r', 'r', 'e', 'c', 't', ' ', 's', 'h',
                                 'a', 'p', 'e']);
                     CC_rewr (Fun fa ss) (Var _) ->
                       Inl (shows_cc d .
                             shows_prec_list Zero_nat
                               [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a',
                                 ' ', 'r', 'e', 'w', 'r', 'i', 't', 'e', ' ',
                                 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n',
                                 ' ', 'o', 'f', ' ', 't', 'h', 'e', ' ', 'c',
                                 'o', 'r', 'r', 'e', 'c', 't', ' ', 's', 'h',
                                 'a', 'p', 'e']);
                     CC_rewr (Fun fa ss) (Fun g ts) ->
                       bindb (check (not (da (fa, size_list ss)))
                               (shows_prec Zero_nat fa .
                                 shows_prec_list Zero_nat
                                   [' ', 'i', 's', ' ', 'd', 'e', 'f', 'i', 'n',
                                     'e', 'd']))
                         (\ _ ->
                           bindb (check
                                   ((fa, size_list ss) == (g, size_list ts))
                                   (shows_prec Zero_nat fa .
                                     shows_string [' ', 'a', 'n', 'd', ' '] .
                                       shows_prec Zero_nat g .
 shows_prec_list Zero_nat
   [' ', 'a', 'r', 'e', ' ', 'n', 'o', 't', ' ', 'i', 'd', 'e', 'n', 't', 'i',
     'c', 'a', 'l']))
                             (\ _ ->
                               let {
                                 ds = cs ++
map (\ (a, b) -> CC_rewr a b) (zip ss ts);
                                 db = CC_impl ds con;
                               } in check (check_subsumes
    (fresh_string ['x', 'x']) c db)
                                      (shows_string
 ['n', 'e', 'w', ' ', 'c', 'o', 'n', 's', 't', 'r', 'a', 'i', 'n', 't', ' ',
   'i', 's', ' '] .
shows_cc c .
  shows_nl .
    shows_string
      ['b', 'u', 't', ' ', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'w',
        'a', 's', ' '] .
      shows_cc db)));
                     CC_impl _ _ ->
                       Inl (shows_cc d .
                             shows_prec_list Zero_nat
                               [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a',
                                 ' ', 'r', 'e', 'w', 'r', 'i', 't', 'e', ' ',
                                 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n',
                                 ' ', 'o', 'f', ' ', 't', 'h', 'e', ' ', 'c',
                                 'o', 'r', 'r', 'e', 'c', 't', ' ', 's', 'h',
                                 'a', 'p', 'e']);
                     CC_all _ _ ->
                       Inl (shows_cc d .
                             shows_prec_list Zero_nat
                               [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a',
                                 ' ', 'r', 'e', 'w', 'r', 'i', 't', 'e', ' ',
                                 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n',
                                 ' ', 'o', 'f', ' ', 't', 'h', 'e', ' ', 'c',
                                 'o', 'r', 'r', 'e', 'c', 't', ' ', 's', 'h',
                                 'a', 'p', 'e']);
                   })))
               (\ x ->
                 Inl (shows_prec_list Zero_nat
                        ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ',
                          'S', 'a', 'm', 'e', ' ', 'C', 'o', 'n', 's', 't', 'r',
                          'u', 'c', 't', 'o', 'r', ' ', 'w', 'i', 't', 'h', ' ',
                          'r', 'e', 'w', 'r', 'i', 't', 'e', ' ', 'c', 'o', 'n',
                          'd', 'i', 't', 'i', 'o', 'n', ' '] .
                       shows_cc d .
                         shows_nl .
                           shows_string
                             [' ', 'w', 'h', 'e', 'n', ' ', 's', 'w', 'i', 't',
                               'c', 'h', 'i', 'n', 'g', ' ', 'f', 'r', 'o', 'm',
                               ' '] .
                             shows_nl .
                               shows_cc ca .
                                 shows_string [' ', 't', 'o', ' '] .
                                   shows_nl . shows_cc c . shows_nl . x)))
         (\ _ -> check_cc_prf r da f m_ortho c p);
check_cc_prf r da f m_ortho c (Variable_Equation x t d p) =
  let {
    (CC_impl cs _) = normalize_cc c;
  } in bindb (catcha
               (bindb
                 (check
                   (membera cs (CC_rewr (Var x) t) ||
                     membera cs (CC_rewr t (Var x)) &&
                       ball (funas_term t) (\ fa -> not (da fa)))
                   (shows_string
                      ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'f',
                        'i', 'n', 'd', ' '] .
                     shows_cc (CC_rewr (Var x) t) .
                       shows_string
                         [' ', 'o', 'r', ' ', 'r', 'e', 'v', 'e', 'r', 's', 'e',
                           'd', ' ', 'a', 's', ' ', 'a', ' ', 'p', 'r', 'e',
                           'm', 'i', 's', 'e', ' ', 'o', 'f', ' '] .
                         shows_nl . shows_cc c))
                 (\ _ ->
                   let {
                     ca = cc_subst_apply (fresh_string ['x', 'x']) c
                            (fun_upd Var x t, vars_term_lista t);
                   } in check (check_subsumes (fresh_string ['x', 'x']) d ca)
                          (shows_string
                             ['n', 'e', 'w', ' ', 'c', 'o', 'n', 's', 't', 'r',
                               'a', 'i', 'n', 't', ' ', 'i', 's', ' '] .
                            shows_cc d .
                              shows_nl .
                                shows_string
                                  ['b', 'u', 't', ' ', 'e', 'x', 'p', 'e', 'c',
                                    't', 'e', 'd', ' ', 'w', 'a', 's', ' '] .
                                  shows_cc ca)))
               (\ xa ->
                 Inl (shows_prec_list Zero_nat
                        ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ',
                          'V', 'a', 'r', 'i', 'a', 'b', 'l', 'e', ' ', 'E', 'q',
                          'u', 'a', 't', 'i', 'o', 'n', ' ', 'w', 'i', 't', 'h',
                          ' ', 's', 'u', 'b', 's', 't', 'i', 't', 'u', 't', 'i',
                          'o', 'n', ' '] .
                       shows_prec_list Zero_nat x .
                         shows_prec_list Zero_nat ['/'] .
                           shows_prec_term Zero_nat t .
                             shows_string
                               [' ', 't', 'o', ' ', 's', 'w', 'i', 't', 'c',
                                 'h', ' ', 'f', 'r', 'o', 'm'] .
                               shows_nl .
                                 shows_cc c .
                                   shows_nl .
                                     shows_string ['t', 'o'] .
                                       shows_nl . shows_cc d . shows_nl . xa)))
         (\ _ -> check_cc_prf r da f m_ortho d p);
check_cc_prf r da f m_ortho ca (Funarg_Into_Var c i x d p) =
  let {
    (CC_impl cs con) = normalize_cc ca;
  } in bindb (catcha
               (bindb
                 (check (membera cs c)
                   (shows_cc c .
                     shows_nl .
                       shows_string
                         ['i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'p', 'r',
                           'e', 'm', 'i', 's', 'e', ' ', 'o', 'f', ' '] .
                         shows_cc ca))
                 (\ _ ->
                   bindb (check (not (membera (vars_cc_list ca) x))
                           (shows_string
                              ['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', ' '] .
                             shows_prec_list Zero_nat x .
                               shows_prec_list Zero_nat
                                 [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'f',
                                   'r', 'e', 's', 'h']))
                     (\ _ ->
                       (case c of {
                         CC_cond _ _ ->
                           Inl (shows_cc c .
                                 shows_prec_list Zero_nat
                                   [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a',
                                     ' ', 'r', 'e', 'w', 'r', 'i', 't', 'e',
                                     ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
                                     'o', 'n', ' ', 'o', 'f', ' ', 't', 'h',
                                     'e', ' ', 'c', 'o', 'r', 'r', 'e', 'c',
                                     't', ' ', 's', 'h', 'a', 'p', 'e']);
                         CC_rewr (Var _) q ->
                           Inl (shows_cc c .
                                 shows_prec_list Zero_nat
                                   [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a',
                                     ' ', 'r', 'e', 'w', 'r', 'i', 't', 'e',
                                     ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
                                     'o', 'n', ' ', 'o', 'f', ' ', 't', 'h',
                                     'e', ' ', 'c', 'o', 'r', 'r', 'e', 'c',
                                     't', ' ', 's', 'h', 'a', 'p', 'e']);
                         CC_rewr (Fun fa ss) q ->
                           bindb (check (less_nat i (size_list ss))
                                   (shows_prec_list Zero_nat
                                     ['i', 'n', 'v', 'a', 'l', 'i', 'd', ' ',
                                       'p', 'o', 's', 'i', 't', 'i', 'o', 'n']))
                             (\ _ ->
                               let {
                                 (bef, (pa, aft)) =
                                   (take i ss,
                                     (nth ss i,
                                       drop (plus_nat i (Nat_of_num One)) ss));
                               } in bindb (catcha
    (check_subseteq (funas_term_lista pa) f)
    (\ xa ->
      Inl (shows_string
             ['f', 'u', 'n', 'c', 't', 'i', 'o', 'n', ' ', 's', 'y', 'm', 'b',
               'o', 'l', ' '] .
            shows_prec_prod Zero_nat xa .
              shows_prec_list Zero_nat
                [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', 'l', 'l', 'o',
                  'w', 'e', 'd', ' ', 'i', 'n', ' ', 'a', 'r', 'g', 'u', 'm',
                  'e', 'n', 't'])))
                                      (\ _ ->
let {
  px = CC_rewr pa (Var x);
  fq = CC_rewr (Fun fa (bef ++ Var x : aft)) q;
  ds = px : fq : cs;
  daa = CC_impl ds con;
} in check (check_subsumes (fresh_string ['x', 'x']) d daa)
       (shows_string
          ['n', 'e', 'w', ' ', 'c', 'o', 'n', 's', 't', 'r', 'a', 'i', 'n', 't',
            ' ', 'i', 's', ' '] .
         shows_cc d .
           shows_nl .
             shows_string
               ['b', 'u', 't', ' ', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ',
                 'w', 'a', 's', ' '] .
               shows_cc daa)));
                         CC_impl _ _ ->
                           Inl (shows_cc c .
                                 shows_prec_list Zero_nat
                                   [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a',
                                     ' ', 'r', 'e', 'w', 'r', 'i', 't', 'e',
                                     ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
                                     'o', 'n', ' ', 'o', 'f', ' ', 't', 'h',
                                     'e', ' ', 'c', 'o', 'r', 'r', 'e', 'c',
                                     't', ' ', 's', 'h', 'a', 'p', 'e']);
                         CC_all _ _ ->
                           Inl (shows_cc c .
                                 shows_prec_list Zero_nat
                                   [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a',
                                     ' ', 'r', 'e', 'w', 'r', 'i', 't', 'e',
                                     ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
                                     'o', 'n', ' ', 'o', 'f', ' ', 't', 'h',
                                     'e', ' ', 'c', 'o', 'r', 'r', 'e', 'c',
                                     't', ' ', 's', 'h', 'a', 'p', 'e']);
                       }))))
               (\ xa ->
                 Inl (shows_prec_list Zero_nat
                        ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ',
                          'i', 'n', 't', 'r', 'o', 'd', 'u', 'c', 'i', 'n', 'g',
                          ' ', 'f', 'r', 'e', 's', 'h', ' ', 'v', 'a', 'r', 'i',
                          'a', 'b', 'l', 'e', ' '] .
                       shows_prec_list Zero_nat x .
                         shows_string [' ', 'o', 'n', ' '] .
                           shows_prec_nat Zero_nat
                             (plus_nat i (Nat_of_num One)) .
                             shows_string
                               ['-', 't', 'h', ' ', 'a', 'r', 'g', 'u', 'm',
                                 'e', 'n', 't', ' ', 'o', 'f', ' ', 'l', 'h',
                                 's', ' ', 'o', 'f', ' '] .
                               shows_cc c .
                                 shows_string
                                   [' ', 't', 'o', ' ', 's', 'w', 'i', 't', 'c',
                                     'h', ' ', 'f', 'r', 'o', 'm', ' '] .
                                   shows_cc ca .
                                     shows_string ['t', 'o'] .
                                       shows_nl . shows_cc d . shows_nl . xa)))
         (\ _ -> check_cc_prf r da f m_ortho d p);
check_cc_prf r da f m_ortho c (Simplify_Condition bc sigma d p) =
  let {
    (CC_impl cs psi) = normalize_cc c;
  } in bindb (catcha
               (bindb
                 (check (membera cs bc)
                   (shows_cc bc .
                     shows_nl .
                       shows_string
                         ['i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'p', 'r',
                           'e', 'm', 'i', 's', 'e', ' ', 'o', 'f', ' '] .
                         shows_cc c))
                 (\ _ ->
                   let {
                     (ys, cc) = cc_unbound bc;
                     (phi, psia) =
                       let {
                         (CC_impl a b) = normalize_cc cc;
                       } in (a, b);
                     dom_ran = mk_subst_domain sigma;
                   } in bindb (catcha (check_subseteq (map fst dom_ran) ys)
                                (\ x ->
                                  Inl (shows_prec_list Zero_nat x .
shows_prec_list Zero_nat
  [' ', 'i', 's', ' ', 'i', 'n', ' ', 't', 'h', 'e', ' ', 'd', 'o', 'm', 'a',
    'i', 'n', ' ', 'o', 'f', ' ', 's', 'i', 'g', 'm', 'a', ',', ' ', 'b', 'u',
    't', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'b', 'o', 'u', 'n', 'd', ' ', 'v',
    'a', 'r', 'i', 'a', 'b', 'l', 'e', ' '])))
                          (\ _ ->
                            bindb (catcha
                                    (forallM
                                      (\ fn ->
bindb (check (not (da fn))
        (shows_string ['s', 'y', 'm', 'b', 'o', 'l', ' '] .
          shows_prec_prod Zero_nat fn .
            shows_prec_list Zero_nat
              [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', 'l', 'l', 'o', 'w',
                'e', 'd', ' ', 'i', 'n', ' ', 'r', 'a', 'n', 'g', 'e', ' ', 'o',
                'f', ' ', 's', 'i', 'g', 'm', 'a', ',', ' ', 'a', 's', ' ', 'i',
                't', ' ', 'i', 's', ' ', 'd', 'e', 'f', 'i', 'n', 'e', 'd']))
  (\ _ ->
    check (membera f fn)
      (shows_string ['s', 'y', 'm', 'b', 'o', 'l', ' '] .
        shows_prec_prod Zero_nat fn .
          shows_prec_list Zero_nat
            [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', 'l', 'l', 'o', 'w',
              'e', 'd', ' ', 'i', 'n', ' ', 'r', 'a', 'n', 'g', 'e', ' ', 'o',
              'f', ' ', 's', 'i', 'g', 'm', 'a', ',', ' ', 'a', 's', ' ', 'i',
              't', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'i', 'n', ' ',
              'F'])))
                                      (concatMap
(\ x_t -> funas_term_lista (snd x_t)) dom_ran))
                                    (\ x -> Inl (snd x)))
                              (\ _ ->
                                let {
                                  vs = remdups
 (concatMap (\ x_t -> vars_term_lista (snd x_t)) dom_ran);
                                  sigmaa =
                                    (\ ca ->
                                      cc_subst_apply (fresh_string ['x', 'x'])
ca (mk_subst Var sigma, vs));
                                } in bindb (catcha
     (forallM
       (\ ca ->
         check (any (\ caa ->
                      check_subsumes (fresh_string ['x', 'x']) caa (sigmaa ca))
                 cs)
           (shows_cc (sigmaa ca) .
             shows_nl .
               shows_prec_list Zero_nat
                 ['i', 's', ' ', 'n', 'o', 't', ' ', 'c', 'o', 'n', 't', 'a',
                   'i', 'n', 'e', 'd', ' ', 'a', 's', ' ', 'p', 'r', 'e', 'm',
                   'i', 's', 'e', ' ', 'o', 'f', ' ', 't', 'h', 'e', ' ', 'i',
                   'n', 'p', 'u', 't', ' ', 'i', 'm', 'p', 'l', 'i', 'c', 'a',
                   't', 'i', 'o', 'n']))
       phi)
     (\ x -> Inl (snd x)))
                                       (\ _ ->
 let {
   daa = CC_impl (sigmaa psia : cs) psi;
 } in check (check_subsumes (fresh_string ['x', 'x']) d daa)
        (shows_string
           ['n', 'e', 'w', ' ', 'c', 'o', 'n', 's', 't', 'r', 'a', 'i', 'n',
             't', ' ', 'i', 's', ' '] .
          shows_cc d .
            shows_nl .
              shows_string
                ['b', 'u', 't', ' ', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd',
                  ' ', 'w', 'a', 's', ' '] .
                shows_cc daa))))))
               (\ x ->
                 Inl (shows_prec_list Zero_nat
                        ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ',
                          'S', 'i', 'm', 'p', 'l', 'i', 'f', 'y', ' ', 'C', 'o',
                          'n', 'd', 'i', 't', 'i', 'o', 'n', ' ', 'w', 'i', 't',
                          'h', ' ', 's', 'u', 'b', 's', 't', 'i', 't', 'u', 't',
                          'i', 'o', 'n', ' '] .
                       shows_prec_list Zero_nat sigma .
                         shows_string [' ', 'o', 'n', ' ', 'I', 'H'] .
                           shows_nl .
                             shows_cc bc .
                               shows_nl .
                                 shows_string
                                   ['t', 'o', ' ', 's', 'w', 'i', 't', 'c', 'h',
                                     ' ', 'f', 'r', 'o', 'm'] .
                                   shows_nl .
                                     shows_cc c .
                                       shows_nl .
 shows_string ['t', 'o'] . shows_nl . shows_cc d . shows_nl . x)))
         (\ _ -> check_cc_prf r da f m_ortho d p);
check_cc_prf r da f m_ortho c (Induction d ccs ihs) =
  let {
    (CC_impl cs ca) = normalize_cc c;
  } in bindb (catcha
               (bindb
                 (check m_ortho
                   (shows_prec_list Zero_nat
                     ['C', 'R', ' ', 'o', 'r', ' ', 'm', 'i', 'n', 'i', 'm',
                       'a', 'l', 'i', 't', 'y', ' ', 'r', 'e', 'q', 'u', 'i',
                       'r', 'e', 'd']))
                 (\ _ ->
                   bindb (catcha
                           (forallM
                             (\ cc ->
                               check (membera cs cc)
                                 (shows_cc cc .
                                   shows_nl .
                                     shows_string
                                       ['i', 's', ' ', 'n', 'o', 't', ' ', 'a',
 ' ', 'p', 'r', 'e', 'm', 'i', 's', 'e', ' ', 'o', 'f', ' '] .
                                       shows_cc c))
                             (d : ccs))
                           (\ x -> Inl (snd x)))
                     (\ _ ->
                       (case d of {
                         CC_cond _ _ ->
                           Inl (shows_cc d .
                                 shows_prec_list Zero_nat
                                   [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a',
                                     ' ', 'r', 'e', 'w', 'r', 'i', 't', 'e',
                                     ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
                                     'o', 'n', ' ', 'o', 'f', ' ', 't', 'h',
                                     'e', ' ', 'c', 'o', 'r', 'r', 'e', 'c',
                                     't', ' ', 's', 'h', 'a', 'p', 'e']);
                         CC_rewr (Var _) q ->
                           Inl (shows_cc d .
                                 shows_prec_list Zero_nat
                                   [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a',
                                     ' ', 'r', 'e', 'w', 'r', 'i', 't', 'e',
                                     ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
                                     'o', 'n', ' ', 'o', 'f', ' ', 't', 'h',
                                     'e', ' ', 'c', 'o', 'r', 'r', 'e', 'c',
                                     't', ' ', 's', 'h', 'a', 'p', 'e']);
                         CC_rewr (Fun fa xs) q ->
                           let {
                             csa = vars_cc_list
                                     (CC_impl (CC_rewr (Fun fa xs) q : ccs) ca);
                           } in bindb (check
(all is_Var xs && distinct (map the_Var xs))
(shows_prec_list Zero_nat
   ['a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's', ' ', 'o', 'f', ' '] .
  shows_prec_term Zero_nat (Fun fa xs) .
    shows_prec_list Zero_nat
      [' ', 'a', 'r', 'e', ' ', 'n', 'o', 't', ' ', 'd', 'i', 'f', 'f', 'e',
        'r', 'e', 'n', 't', ' ', 'v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 's']))
                                  (\ _ ->
                                    let {
                                      xsa = map the_Var xs;
                                      rt = root (Fun fa xs);
                                    } in bindb
   (check (is_none (mgu (Fun fa xs) q))
     (shows_prec_list Zero_nat
       ['l', 'h', 's', ' ', 'a', 'n', 'd', ' ', 'r', 'h', 's', ' ', 'u', 'n',
         'i', 'f', 'y']))
   (\ _ ->
     bindb (catcha
             (forallM
               (\ lr ->
                 check (if root (fst lr) == rt
                         then any (\ lra ->
                                    eq_rule_mod_vars lr lra &&
                                      isOK
(check_disjoint csa (vars_rule_list lra)))
                                (map (\ (ra, _) -> ra) ihs)
                         else True)
                   (shows_prec_list Zero_nat
                      ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'f',
                        'i', 'n', 'd', ' ', 'v', 'a', 'r', 'i', 'a', 'b', 'l',
                        'e', ' ', 'r', 'e', 'n', 'a', 'm', 'e', 'd', ' ', 'v',
                        'e', 'r', 's', 'i', 'o', 'n', ' ', 'o', 'f', ' ', 'r',
                        'u', 'l', 'e', ' '] .
                     shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
                       [' ', '-', '>', ' '] lr))
               r)
             (\ x -> Inl (snd x)))
       (\ _ ->
         catcha
           (forallM
             (\ (a, b) ->
               let {
                 (l, ra) = a;
               } in (\ (rys, (cc, _)) ->
                      catcha
                        (let {
                           cca = cc_rule_constraint (fresh_string ['x', 'x']) fa
                                   (args l) ra q xsa ccs ca rys;
                         } in bindb (catcha (forallM (check_rys da rt ra) rys)
                                      (\ x -> Inl (snd x)))
                                (\ _ ->
                                  check (check_subsumes
  (fresh_string ['x', 'x']) cc cca)
                                    (shows_string
                                       ['n', 'e', 'w', ' ', 'c', 'o', 'n', 's',
 't', 'r', 'a', 'i', 'n', 't', ' ', 'i', 's', ' '] .
                                      shows_cc cc .
shows_nl .
  shows_string
    ['b', 'u', 't', ' ', 'e', 'x', 'p', 'e', 'c', 't', 'e', 'd', ' ', 'w', 'a',
      's', ' '] .
    shows_cc cca)))
                        (\ x ->
                          Inl (shows_string
                                 ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i',
                                   'n', ' ', 'c', 'o', 'n', 's', 't', 'r', 'a',
                                   'i', 'n', 't', ' ', 'f', 'o', 'r', ' ', 'r',
                                   'u', 'l', 'e', ' '] .
                                shows_rule (shows_prec Zero_nat)
                                  (shows_prec_list Zero_nat)
                                  [' ', '-', '>', ' '] (l, ra) .
                                  shows_nl . x)))
                 b)
             ihs)
           (\ x -> Inl (snd x)))));
                         CC_impl _ _ ->
                           Inl (shows_cc d .
                                 shows_prec_list Zero_nat
                                   [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a',
                                     ' ', 'r', 'e', 'w', 'r', 'i', 't', 'e',
                                     ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
                                     'o', 'n', ' ', 'o', 'f', ' ', 't', 'h',
                                     'e', ' ', 'c', 'o', 'r', 'r', 'e', 'c',
                                     't', ' ', 's', 'h', 'a', 'p', 'e']);
                         CC_all _ _ ->
                           Inl (shows_cc d .
                                 shows_prec_list Zero_nat
                                   [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a',
                                     ' ', 'r', 'e', 'w', 'r', 'i', 't', 'e',
                                     ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i',
                                     'o', 'n', ' ', 'o', 'f', ' ', 't', 'h',
                                     'e', ' ', 'c', 'o', 'r', 'r', 'e', 'c',
                                     't', ' ', 's', 'h', 'a', 'p', 'e']);
                       }))))
               (\ x ->
                 Inl (shows_prec_list Zero_nat
                        ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ',
                          'I', 'n', 'd', 'u', 'c', 't', 'i', 'o', 'n', ' ', 'r',
                          'u', 'l', 'e', ' ', 'w', 'i', 't', 'h', ' ', 'r', 'e',
                          'w', 'r', 'i', 't', 'e', ' ', 'c', 'o', 'n', 'd', 'i',
                          't', 'i', 'o', 'n', ' '] .
                       shows_cc d .
                         shows_string
                           [' ', 't', 'o', ' ', 's', 'w', 'i', 't', 'c', 'h',
                             ' ', 'f', 'r', 'o', 'm'] .
                           shows_nl .
                             shows_cc c .
                               shows_nl .
                                 shows_string ['t', 'o'] .
                                   shows_nl .
                                     shows_list_gen
                                       (\ (_, (_, (cb, _))) ->
 shows_cc cb . shows_nl)
                                       [] [] [] [] ihs .
                                       x)))
         (\ _ ->
           bindb (mapM (\ (_, (_, (a, b))) -> check_cc_prf r da f m_ortho a b)
                   ihs)
             (\ fcss -> Inr (concat fcss)));

check_cc_prfs ::
  forall a b.
    (Ceq a, Corder a, Eq a, Set_impla a,
      Showa a) => [(Term a [Prelude.Char], Term a [Prelude.Char])] ->
                    ((a, Nat) -> Bool) ->
                      [(a, Nat)] ->
                        Bool ->
                          [(Cond_constraint a [Prelude.Char],
                             (b, Cond_constraint_prf a [Prelude.Char]))] ->
                            Sum ([Prelude.Char] -> [Prelude.Char])
                              [C_constraint a [Prelude.Char]];
check_cc_prfs r d f m_ortho [] = Inr [];
check_cc_prfs r d f m_ortho ((c, (uu, prf)) : cpfs) =
  bindb (check_cc_prf r d f m_ortho c prf)
    (\ l1 -> bindb (check_cc_prfs r d f m_ortho cpfs) (\ l2 -> Inr (l1 ++ l2)));

funas_args_rule_list :: forall a b. (Term a b, Term a b) -> [(a, Nat)];
funas_args_rule_list r =
  funas_args_term_list (fst r) ++ funas_args_term_list (snd r);

funas_args_trs_list ::
  forall a b. (Eq a) => [(Term a b, Term a b)] -> [(a, Nat)];
funas_args_trs_list r = remdups (concatMap funas_args_rule_list r);

validb ::
  forall a b c.
    Non_inf_order_ext a b c -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
validb (Non_inf_order_ext valid ns cc af desc more) = valid;

conditional_general_reduction_pair_proc ::
  forall a b.
    (Ceq b, Corder b, Eq b, Key b, Set_impla b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    ([(b, Nat)] -> Non_inf_order_ext b [Prelude.Char] ()) ->
                      [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                        [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                          Cond_red_pair_prf b [Prelude.Char] ->
                            Bool ->
                              a -> Sum ([Prelude.Char] -> [Prelude.Char]) [a];
conditional_general_reduction_pair_proc i grp pstrict pbound prof merge dpp =
  let {
    (Cond_Red_Pair_Prf c ccs bef aft) = prof;
    p = pairsa i dpp;
    r = rulesd i dpp;
    f = remdups
          (funas_trs_list r ++
            funas_args_trs_list p ++ concatMap funas_term_lista (qc i dpp));
    rp = grp f;
  } in (case catcha
               (bindb (validb rp)
                 (\ _ ->
                   bindb (check (wwf_rulesa i dpp)
                           (shows_prec_list Zero_nat
                             ['r', 'e', 'q', 'u', 'i', 'r', 'e', ' ', 'w', 'e',
                               'l', 'l', '-', 'f', 'o', 'r', 'm', 'e', 'd', 'n',
                               'e', 's', 's', ' ', 'o', 'f', ' ', 'T', 'R',
                               'S']))
                     (\ _ ->
                       let {
                         is_def = (\ fn -> not (null (rules_mapb i dpp fn)));
                       } in bindb (catcha
                                    (forallM
                                      (\ (l, ra) ->
bindb (check_no_var l)
  (\ _ ->
    bindb (check_no_var ra)
      (\ _ ->
        bindb (check_no_defined_root is_def ra)
          (\ _ ->
            catcha (check_subseteq (vars_term_lista ra) (vars_term_lista l))
              (\ _ ->
                Inl (shows_prec_list Zero_nat
                       ['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', ' ', 'c', 'o',
                         'n', 'd', 'i', 't', 'i', 'o', 'n', ' ', 'v', 'i', 'o',
                         'l', 'a', 't', 'e', 'd', ' ', 'i', 'n', ' ', 'p', 'a',
                         'i', 'r', ' '] .
                      shows_rule (shows_prec Zero_nat)
                        (shows_prec_list Zero_nat) [' ', '-', '>', ' ']
                        (l, ra)))))))
                                      p)
                                    (\ x -> Inl (snd x)))
                              (\ _ ->
                                let {
                                  ccsa =
                                    map (\ (ca, (uvs, _)) -> (ca, uvs)) ccs;
                                  check_present =
                                    check_constraint_present i dpp c p bef aft
                                      ccsa;
                                  (ps, pns) = split_pairsa i dpp pstrict;
                                  (pb, _) = split_pairsa i dpp pbound;
                                  pi = afb rp;
                                  us = usable_rules_gen pi r p;
                                } in bindb (catcha
     (forallM (check_present Strict) ps) (\ x -> Inl (snd x)))
                                       (\ _ ->
 bindb (catcha (forallM (check_present Non_Strict) pns) (\ x -> Inl (snd x)))
   (\ _ ->
     bindb (catcha (forallM (check_present Bound) pb) (\ x -> Inl (snd x)))
       (\ _ ->
         bindb (check (nFQ_subset_NF_rulesb i dpp)
                 (shows_prec_list Zero_nat
                   ['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't', ' ', 'r', 'e',
                     'q', 'u', 'i', 'r', 'e', 'd']))
           (\ _ ->
             bindb (catcha (catcha (forallM (nsb rp) us) (\ x -> Inl (snd x)))
                     (\ x ->
                       Inl (shows_string
                              ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h',
                                'e', 'n', ' ', 'o', 'r', 'i', 'e', 'n', 't',
                                'i', 'n', 'g', ' ', 'u', 's', 'a', 'b', 'l',
                                'e', ' ', 'r', 'u', 'l', 'e', 's'] .
                             shows_nl . x)))
               (\ _ ->
                 let {
                   m = minimal i dpp;
                   ortho = isOK (check_weakly_orthogonal r);
                 } in bindb (catcha
                              (check_cc_prfs r
                                (\ fn -> not (null (rules_mapb i dpp fn))) f
                                (m || ortho) ccs)
                              (\ x ->
                                Inl (shows_string
                                       ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ',
 'w', 'h', 'e', 'n', ' ', 's', 'i', 'm', 'p', 'l', 'i', 'f', 'y', 'i', 'n', 'g',
 ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n', 'a', 'l', ' ', 'c', 'o', 'n',
 's', 't', 'r', 'a', 'i', 'n', 't', 's'] .
                                      shows_nl . x)))
                        (\ fcs ->
                          catcha
                            (catcha (forallM (cc rp) fcs) (\ x -> Inl (snd x)))
                            (\ x ->
                              Inl (shows_string
                                     ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ',
                                       'w', 'h', 'e', 'n', ' ', 'o', 'r', 'i',
                                       'e', 'n', 't', 'i', 'n', 'g', ' ', 'f',
                                       'i', 'n', 'a', 'l', ' ', '(', 'c', 'o',
                                       'n', 'd', 'i', 't', 'i', 'o', 'n', 'a',
                                       'l', ')', ' ', 'c', 'o', 'n', 's', 't',
                                       'r', 'a', 'i', 'n', 't', 's', ' ', 'f',
                                       'o', 'r', ' ', 'p', 'a', 'i', 'r', 's'] .
                                    shows_nl . x))))))))))))
               (\ x ->
                 Inl (shows_string
                        ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'a',
                          'p', 'p', 'l', 'y', ' ', 't', 'h', 'e', ' ', 'b', 'o',
                          'u', 'n', 'd', 'e', 'd', ' ', 'i', 'n', 'c', 'r', 'e',
                          'a', 's', 'e', ' ', 'p', 'r', 'o', 'c', 'e', 's', 's',
                          'o', 'r', ' ', 'w', 'i', 't', 'h', ' ', 't', 'h', 'e',
                          ' ', 'f', 'o', 'l', 'l', 'o', 'w', 'i', 'n', 'g'] .
                       shows_nl . descb rp . shows_nl . x))
         of {
         Inl a -> Inl a;
         Inr _ ->
           Inr (if merge
                 then [delete_P_Pwa i dpp (list_inter pstrict pbound)
                         (list_inter pstrict pbound)]
                 else [delete_P_Pwa i dpp pstrict pstrict,
                        delete_P_Pwa i dpp pbound pbound]);
       });

critical_pairs_top_impl ::
  forall a.
    (Eq a) => [(Term a [Prelude.Char], Term a [Prelude.Char])] ->
                [(Term a [Prelude.Char], Term a [Prelude.Char])] ->
                  [(Term a [Prelude.Char], Term a [Prelude.Char])];
critical_pairs_top_impl p r =
  concatMap
    (\ (l, ra) ->
      (if is_Var l then []
        else concatMap
               (\ (la, rb) ->
                 (case mgu_var_disjoint_generic (\ a -> 'x' : a)
                         (\ a -> 'y' : a) l la
                   of {
                   Nothing -> [];
                   Just (sigma, tau) ->
                     [(subst_apply_term ra sigma, subst_apply_term rb tau)];
                 }))
               r))
    p;

check_critical_pairs_innermost ::
  forall a.
    (Eq a,
      Showa a) => [(Term a [Prelude.Char], Term a [Prelude.Char])] ->
                    Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_critical_pairs_innermost r =
  catcha
    (forallM
      (\ (l, ra) ->
        check (equal_term l ra)
          (shows_prec_list Zero_nat
             ['t', 'h', 'e', 'r', 'e', ' ', 'i', 's', ' ', 'a', ' ', 'n', 'o',
               'n', '-', 't', 'r', 'i', 'v', 'i', 'a', 'l', ' ', 'c', 'r', 'i',
               't', 'i', 'c', 'a', 'l', ' ', 'p', 'a', 'i', 'r', ' '] .
            show_crit_pair (l, ra)))
      (critical_pairs_top_impl r r))
    (\ x -> Inl (snd x));

extract_fresh_var ::
  forall a b.
    [((Term a b, Term a b), (Term a b, Term a b))] ->
      Sum ([Prelude.Char] -> [Prelude.Char]) b;
extract_fresh_var sts =
  (case (case sts of {
          [] -> Nothing;
          (_, (Var _, _)) : _ -> Nothing;
          (_, (Fun _ ss, _)) : _ ->
            (if null ss then Nothing
              else (case last ss of {
                     Var a -> Just a;
                     Fun _ _ -> Nothing;
                   }));
        })
    of {
    Nothing ->
      Inl (shows_prec_list Zero_nat
            ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'x', 't',
              'r', 'a', 'c', 't', ' ', 'f', 'r', 'e', 's', 'h', ' ', 'v', 'a',
              'r', 'i', 'a', 'b', 'l', 'e', ' ', '(', 'a', 's', ' ', 'l', 'a',
              's', 't', ' ', 'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', ' ', 'f',
              'r', 'o', 'm', ' ', 's', 'o', 'm', 'e', ' ', 'l', 'h', 's', ' ',
              'o', 'f', ' ', 'n', 'e', 'w', ' ', 'p', 'a', 'i', 'r', 's', ')']);
    Just a -> Inr a;
  });

extract_ren ::
  forall a b.
    (Eq a) => [((Term a b, Term a b), (Term a b, Term a b))] ->
                Sum ([Prelude.Char] -> [Prelude.Char]) ((a, Nat) -> a);
extract_ren ps_ps =
  bindb (check
          (all (\ (a, b) ->
                 let {
                   (s, t) = a;
                 } in (\ (sa, ta) ->
                        not (is_Var s) &&
                          not (is_Var t) && not (is_Var sa) && not (is_Var ta))
                   b)
            ps_ps)
          (shows_prec_list Zero_nat
            ['a', 'l', 'l', ' ', 'l', 'h', 's', 's', ' ', 'a', 'n', 'd', ' ',
              'r', 'h', 's', 's', ' ', 'o', 'f', ' ', 'p', 'a', 'i', 'r', 's',
              ' ', 'm', 'u', 's', 't', ' ', 'b', 'e', ' ', 'n', 'o', 'n', '-',
              'v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 's']))
    (\ _ ->
      let {
        rt = (\ t -> the (root t));
        pair = (\ s sa -> (rt s, fst (rt sa)));
        pairs =
          (\ (st, sta) -> [pair (fst st) (fst sta), pair (snd st) (snd sta)]);
        ren = map_of (remdups (concatMap pairs ps_ps));
        a = (\ fn -> (case ren fn of {
                       Nothing -> fst fn;
                       Just f -> f;
                     }));
      } in Inr a);

check_drop ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => a -> Term b a ->
                         ((b, Nat) -> b) ->
                           ((Term b a, Term b a), (Term b a, Term b a)) ->
                             Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_drop x c ren st_st =
  let {
    ((s, t), (sa, ta)) = st_st;
    (Fun f ss) = s;
    (Fun g ts) = t;
  } in bindb (check
               (equal_term sa (Fun (ren (f, size_list ss)) (ss ++ [Var x])))
               (shows_prec_list Zero_nat
                  ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'r', 'e',
                    'l', 'a', 't', 'e', ' '] .
                 shows_prec_term Zero_nat s .
                   shows_prec_list Zero_nat [' ', 'w', 'i', 't', 'h', ' '] .
                     shows_prec_term Zero_nat sa))
         (\ _ ->
           let {
             tsa = args ta;
             tsaa = take (minus_nat (size_list tsa) (Nat_of_num One)) tsa;
           } in check (equal_term ta
                         (Fun (ren (g, size_list ts)) (tsaa ++ [Var x])) &&
                        ts == map (\ tb -> subst_apply_term tb (subst x c))
                                tsaa)
                  (shows_prec_list Zero_nat
                     ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'r',
                       'e', 'l', 'a', 't', 'e', ' '] .
                    shows_prec_term Zero_nat t .
                      shows_prec_list Zero_nat [' ', 'w', 'i', 't', 'h', ' '] .
                        shows_prec_term Zero_nat ta));

rwc :: forall a b c d. Dpp_ops_ext a b c d -> a -> [(Term b c, Term b c)];
rwc (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
      rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map
      reverse_rules_map intersect_pairs replace_pair intersect_rules delete_P_Pw
      delete_R_Rw split_pairs split_rules mk minimal nfs wwf_rules more)
  = rw;

pwa :: forall a b c d. Dpp_ops_ext a b c d -> a -> [(Term b c, Term b c)];
pwa (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
      rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map
      reverse_rules_map intersect_pairs replace_pair intersect_rules delete_P_Pw
      delete_R_Rw split_pairs split_rules mk minimal nfs wwf_rules more)
  = pw;

rc :: forall a b c d. Dpp_ops_ext a b c d -> a -> [(Term b c, Term b c)];
rc (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
     rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
     intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
     split_pairs split_rules mk minimal nfs wwf_rules more)
  = r;

pb :: forall a b c d. Dpp_ops_ext a b c d -> a -> [(Term b c, Term b c)];
pb (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
     rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
     intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
     split_pairs split_rules mk minimal nfs wwf_rules more)
  = p;

nF_terms_list ::
  forall a b c. (Eq a, Eq b, Eq c) => [Term a b] -> Term a c -> Bool;
nF_terms_list ls t =
  all (\ s -> all (\ l -> not (matches s l)) ls) (supteq_list t);

complex_constant_removal_proc ::
  forall a b.
    (Eq b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    Complex_constant_removal_prf b [Prelude.Char] ->
                      a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
complex_constant_removal_proc i (Complex_Constant_Removal_Proof c ps) dpp =
  catcha
    (let {
       p = pb i dpp;
       pw = pwa i dpp;
       r = rwc i dpp;
       q = qc i dpp;
       pairs = pairsa i dpp;
     } in bindb (extract_fresh_var ps)
            (\ x ->
              bindb (extract_ren ps)
                (\ ren ->
                  let {
                    is_def = (\ fn -> not (null (rules_mapb i dpp fn)));
                    rQs = remdups (map root q);
                  } in bindb (catcha
                               (forallM
                                 (\ (s, t) ->
                                   bindb (check_no_var s)
                                     (\ _ ->
                                       bindb (check_no_var t)
 (\ _ ->
   bindb (check_no_defined_root is_def t)
     (\ _ ->
       bindb (check (not (membera (vars_rule_list (s, t)) x))
               (shows_prec_list Zero_nat x .
                 shows_prec_list Zero_nat
                   [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'f', 'r', 'e', 's',
                     'h', ' ', 'f', 'o', 'r', ' ', 'p', 'a', 'i', 'r', ' '] .
                   shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
                     [' ', '-', '>', ' '] (s, t)))
         (\ _ ->
           let {
             f = the (root s);
             fa = (ren f, plus_nat (snd f) (Nat_of_num One));
           } in bindb (check (not (membera rQs (Just fa)))
                        (shows_prec_list Zero_nat
                          ['r', 'e', 'n', 'a', 'm', 'i', 'n', 'g', ' ', 'd',
                            'e', 'l', 'i', 'v', 'e', 'r', 's', ' ', 'd', 'e',
                            'f', 'i', 'n', 'e', 'd', ' ', 's', 'y', 'm', 'b',
                            'o', 'l', ' ', 'o', 'f', ' ', 'Q']))
                  (\ _ ->
                    check (not (is_def fa))
                      (shows_prec_list Zero_nat
                        ['r', 'e', 'n', 'a', 'm', 'i', 'n', 'g', ' ', 'd', 'e',
                          'l', 'i', 'v', 'e', 'r', 's', ' ', 'd', 'e', 'f', 'i',
                          'n', 'e', 'd', ' ', 's', 'y', 'm', 'b', 'o', 'l', ' ',
                          'o', 'f', ' ', 'R'])))))))
                                 pairs)
                               (\ xa -> Inl (snd xa)))
                         (\ _ ->
                           let {
                             pps = filter (\ st_st -> membera p (fst st_st)) ps;
                             pwps =
                               filter (\ st_st -> membera pw (fst st_st)) ps;
                           } in bindb (catcha
(forallM
  (\ st ->
    check (membera (map fst pps) st)
      (shows_prec_list Zero_nat
         ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'f', 'i', 'n', 'd',
           ' ', 'e', 'n', 't', 'r', 'y', ' ', 'f', 'o', 'r', ' ', 'p', 'a', 'i',
           'r', ' '] .
        shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
          [' ', '-', '>', ' '] st))
  p)
(\ xa -> Inl (snd xa)))
                                  (\ _ ->
                                    bindb (catcha
    (forallM
      (\ st ->
        check (membera (map fst pwps) st)
          (shows_prec_list Zero_nat
             ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'f', 'i', 'n',
               'd', ' ', 'e', 'n', 't', 'r', 'y', ' ', 'f', 'o', 'r', ' ', 'p',
               'a', 'i', 'r', ' '] .
            shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
              [' ', '-', '>', ' '] st))
      pw)
    (\ xa -> Inl (snd xa)))
                                      (\ _ ->
bindb (check (ground c)
        (shows_prec_list Zero_nat
           ['t', 'h', 'e', ' ', 't', 'e', 'r', 'm', ' '] .
          shows_prec_term Zero_nat c .
            shows_prec_list Zero_nat
              [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'g', 'r', 'o', 'u', 'n',
                'd']))
  (\ _ ->
    bindb (check (nFQ_subset_NF_rulesb i dpp)
            (shows_prec_list Zero_nat
              ['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't', ' ', 'r', 'e', 'q',
                'u', 'i', 'r', 'e', 'd']))
      (\ _ ->
        bindb (check (null (rc i dpp))
                (shows_prec_list Zero_nat
                  ['s', 't', 'r', 'i', 'c', 't', ' ', 'r', 'u', 'l', 'e', 's',
                    ' ', 'n', 'o', 't', ' ', 'a', 'l', 'l', 'o', 'w', 'e',
                    'd']))
          (\ _ ->
            bindb (check (rules_no_left_vara i dpp)
                    (shows_prec_list Zero_nat
                      ['r', 'u', 'l', 'e', 's', ' ', 'm', 'a', 'y', ' ', 'n',
                        'o', 't', ' ', 'h', 'a', 'v', 'e', ' ', 'v', 'a', 'r',
                        'i', 'a', 'b', 'l', 'e', 's', ' ', 'a', 's', ' ', 'l',
                        'h', 's', 's']))
              (\ _ ->
                bindb (if nF_terms_list (map fst r) c then Inr ()
                        else catcha (check_critical_pairs_innermost r)
                               (\ xa ->
                                 Inl (shows_prec_list Zero_nat
['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'n', 's', 'u', 'r', 'e',
  ' ', 'c', 'o', 'n', 'f', 'l', 'u', 'e', 'n', 'c', 'e'] .
                                       shows_nl . xa)))
                  (\ _ ->
                    bindb (catcha
                            (forallM
                              (\ st_st ->
                                catcha (check_drop x c ren st_st)
                                  (\ xa ->
                                    Inl (shows_prec_list Zero_nat
   ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'f', 'i', 'n', 'd',
     'i', 'n', 'g', ' ', 'c', 'o', 'r', 'r', 'e', 's', 'p', 'o', 'n', 'd', 'e',
     'n', 'c', 'e', ' ', 'b', 'e', 't', 'w', 'e', 'e', 'n', ' ', 'r', 'u', 'l',
     'e', ' '] .
  shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
    [' ', '-', '>', ' '] (fst st_st) .
    shows_prec_list Zero_nat
      [' ', 'a', 'n', 'd', ' ', 'r', 'u', 'l', 'e', ' '] .
      shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
        [' ', '-', '>', ' '] (snd st_st) .
        shows_nl . xa)))
                              ps)
                            (\ xa -> Inl (snd xa)))
                      (\ _ ->
                        Inr (mkc i (nfsc i dpp) (minimal i dpp) (map snd pps)
                              (map snd pwps) q [] r)))))))))))))
    (\ x ->
      Inl (shows_prec_list Zero_nat
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'c', 'o',
               'm', 'p', 'l', 'e', 'x', ' ', 'c', 'o', 'n', 's', 't', 'a', 'n',
               't', ' ', 'r', 'e', 'm', 'o', 'v', 'a', 'l', ' ', 'p', 'r', 'o',
               'c', ':', ' '] .
            shows_nl . x));

get_arg :: forall a b. Term a b -> Nat -> Term a b;
get_arg t n =
  (if equal_nat n Zero_nat then t
    else nth (args t) (minus_nat n (Nat_of_num One)));

data Scg a b = Null | Scg a a [(b, b)] [(b, b)];

equal_scg :: forall a b. (Eq a, Eq b) => Scg a b -> Scg a b -> Bool;
equal_scg (Scg pp1 pp2 list1 list2) Null = False;
equal_scg Null (Scg pp1 pp2 list1 list2) = False;
equal_scg (Scg pp1a pp2a list1a list2a) (Scg pp1 pp2 list1 list2) =
  pp1a == pp1 && pp2a == pp2 && list1a == list1 && list2a == list2;
equal_scg Null Null = True;

subtract_list :: forall a. (Eq a) => [a] -> [a] -> [a];
subtract_list xs ys = filter (\ x -> not (membera ys x)) xs;

comp :: forall a. (Eq a) => [(a, a)] -> [(a, a)] -> [(a, a)];
comp esa es =
  remdups
    (concatMap
      (\ (x, y) ->
        concatMap (\ (ya, z) -> (if y == ya then [(x, z)] else [])) es)
      esa);

scg_comp ::
  forall a b. (Eq b) => (a -> a -> Bool) -> Scg a b -> Scg a b -> Scg a b;
scg_comp conn (Scg pa qa stra wka) (Scg p q str wk) =
  (if not (conn qa p) then Null
    else let {
           strs = remdups (comp stra str ++ comp stra wk ++ comp wka str);
           a = subtract_list (remdups (comp wka wk)) strs;
         } in Scg pa q strs a);
scg_comp conn Null g = Null;
scg_comp conn (Scg v va vb vc) Null = Null;

generate_scgs ::
  forall a b.
    (Eq a, Eq b) => (a -> a -> Bool) -> [Scg a b] -> Scg a b -> [Scg a b];
generate_scgs conn base g =
  filter (\ ga -> not (equal_scg ga Null)) (map (scg_comp conn g) base);

subsumes :: forall a b. (Eq a, Eq b) => Scg a b -> Scg a b -> Bool;
subsumes (Scg pa qa stra wka) (Scg p q str wk) =
  pa == p && qa == q && all (membera str) stra && all (membera (str ++ wk)) wka;
subsumes g Null = True;
subsumes Null (Scg v va vb vc) = False;

in_situ :: forall a b. (Eq b) => Scg a b -> Bool;
in_situ Null = True;
in_situ (Scg p q str wk) = any (\ (a, b) -> a == b) str;

combinea :: forall a b. (Eq b) => Scg a b -> Scg a b -> Scg a b;
combinea (Scg pa qa stra wka) (Scg p q str wk) =
  Scg pa qa (remdups (stra ++ str)) (remdups (wka ++ wk));
combinea Null s = Null;
combinea (Scg v va vb vc) Null = Null;

sagiv :: forall a b. (Eq a, Eq b) => (a -> a -> Bool) -> Scg a b -> Bool;
sagiv conn g =
  (if in_situ g then True
    else let {
           gg = scg_comp conn g g;
         } in (if subsumes gg g then False else sagiv conn (combinea g gg)));

check_SCT :: forall a b. (Eq a, Eq b) => (a -> a -> Bool) -> [Scg a b] -> Bool;
check_SCT conn gs =
  let {
    a = mk_rtrancl_list subsumes (generate_scgs conn gs) gs;
  } in all (sagiv conn) a;

sct_subterm_proc ::
  forall a b.
    (Eq b, Key b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    [((Term b [Prelude.Char], Term b [Prelude.Char]),
                       ([(Nat, Nat)], [(Nat, Nat)]))] ->
                      a -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
sct_subterm_proc i gs dpp =
  catcha
    (let {
       p = pairsa i dpp;
       is_def = (\ fn -> not (null (rules_mapb i dpp fn)));
       eidg = is_iedg_edge_dpp i dpp;
     } in bindb (catcha (check_subseteq p (map fst gs))
                  (\ x ->
                    Inl (shows_string
                           ['t', 'h', 'e', 'r', 'e', ' ', 'i', 's', ' ', 'n',
                             'o', ' ', 's', 'i', 'z', 'e', '-', 'c', 'h', 'a',
                             'n', 'g', 'e', ' ', 'g', 'r', 'a', 'p', 'h', ' ',
                             'f', 'o', 'r', ' ', 't', 'h', 'e', ' ', 'p', 'a',
                             'i', 'r', ' '] .
                          shows_rule (shows_prec Zero_nat)
                            (shows_prec_list Zero_nat) [' ', '-', '>', ' '] x)))
            (\ _ ->
              bindb (check (minimal i dpp)
                      (shows_prec_list Zero_nat
                        ['m', 'i', 'n', 'i', 'm', 'a', 'l', 'i', 't', 'y', ' ',
                          'r', 'e', 'q', 'u', 'i', 'r', 'e', 'd']))
                (\ _ ->
                  bindb (catcha
                          (forallM (\ (l, _) -> check_no_var l) (rulesd i dpp))
                          (\ x -> Inl (snd x)))
                    (\ _ ->
                      bindb (catcha
                              (forallM
                                (\ (a, b) ->
                                  let {
                                    (s, t) = a;
                                  } in (\ (stri, nstri) ->
 catcha
   (bindb (check_no_var s)
     (\ _ ->
       bindb (check_no_var t)
         (\ _ ->
           bindb (check_no_defined_root is_def t)
             (\ _ ->
               let {
                 m = num_args t;
                 n = num_args s;
               } in bindb (catcha
                            (forallM
                              (\ (ia, j) ->
                                check (less_eq_nat ia n &&
less_eq_nat j m && isOK (check_supt (get_arg s ia) (get_arg t j)))
                                  (shows_string
                                     ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ',
                                       'w', 'i', 't', 'h', ' ', 'e', 'd', 'g',
                                       'e', ' '] .
                                    shows_prec_nat Zero_nat ia .
                                      shows_string [' ', '|', '>', ' '] .
shows_prec_nat Zero_nat j . shows_nl))
                              stri)
                            (\ x -> Inl (snd x)))
                      (\ _ ->
                        catcha
                          (forallM
                            (\ (ia, j) ->
                              check (less_eq_nat ia n &&
                                      less_eq_nat j m &&
isOK (check_supteq (get_arg s ia) (get_arg t j)))
                                (shows_string
                                   ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w',
                                     'i', 't', 'h', ' ', 'e', 'd', 'g', 'e',
                                     ' '] .
                                  shows_prec_nat Zero_nat ia .
                                    shows_string [' ', '|', '>', '=', ' '] .
                                      shows_prec_nat Zero_nat j . shows_nl))
                            nstri)
                          (\ x -> Inl (snd x)))))))
   (\ x ->
     Inl (shows_string
            ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'i', 't', 'h', ' ',
              'p', 'a', 'i', 'r', ' '] .
           shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
             [' ', '-', '>', ' '] (s, t) .
             shows_nl . x)))
                                    b)
                                gs)
                              (\ x -> Inl (snd x)))
                        (\ _ ->
                          check (check_SCT
                                  (\ (_, (_, succs)) (u, (v, _)) ->
                                    membera succs (u, v))
                                  (map (\ (a, b) ->
 let {
   (s, t) = a;
 } in (\ (stri, nstri) ->
        let {
          eidg_st = eidg (s, t);
          e = (s, (t, filter (eidg_st . fst) p));
        } in Scg e e stri nstri)
   b)
                                    gs))
                            (shows_string
                               ['s', 'i', 'z', 'e', '-', 'c', 'h', 'a', 'n',
                                 'g', 'e', ' ', 'a', 'n', 'a', 'l', 'y', 's',
                                 'i', 's', ' ', 'f', 'a', 'i', 'l', 'e', 'd'] .
                              shows_nl))))))
    (\ x ->
      Inl (shows_string
             ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'a', 'p', 'p',
               'l', 'y', ' ', 't', 'h', 'e', ' ', 's', 'i', 'z', 'e', '-', 'c',
               'h', 'a', 'n', 'g', 'e', ' ', 'p', 'r', 'o', 'c', 'e', 's', 's',
               'o', 'r', ' ', 'b', 'a', 's', 'e', 'd', ' ', 'o', 'n', ' ', 't',
               'h', 'e', ' ', 's', 'u', 'b', 't', 'e', 'r', 'm', '-', 'r', 'e',
               'l', 'a', 't', 'i', 'o', 'n'] .
            shows_nl . x));

sct_entry_to_sts ::
  forall a b c d. a -> Term b c -> [(d, Nat)] -> [(d, Nat)] -> [(a, Term b c)];
sct_entry_to_sts s t stri nstri =
  let {
    a = remdups (map snd (stri ++ nstri));
  } in map (\ j -> (s, get_arg t j)) a;

check_sct_entry ::
  forall a b c d e f.
    (Showa a,
      Showa b) => ((a, Nat) -> Bool) ->
                    ((Term a b, Term a b) -> Sum c d) ->
                      ((Term a b, Term a b) -> Sum e f) ->
                        Term a b ->
                          Term a b ->
                            [(Nat, Nat)] ->
                              [(Nat, Nat)] ->
                                Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_sct_entry is_def sa nst s t stri nstri =
  catcha
    (bindb (check_no_var s)
      (\ _ ->
        bindb (check_no_var t)
          (\ _ ->
            bindb (check_no_defined_root is_def t)
              (\ _ ->
                let {
                  m = num_args t;
                  n = num_args s;
                } in bindb (catcha
                             (forallM
                               (\ i ->
                                 check (less_eq_nat i n)
                                   (shows_string
                                      ['l', 'e', 'f', 't', '-', 'i', 'n', 'd',
'e', 'x', ' ', 't', 'o', ' ', 'l', 'a', 'r', 'g', 'e'] .
                                     shows_prec_nat Zero_nat i . shows_nl))
                               (remdups (map fst (stri ++ nstri))))
                             (\ x -> Inl (snd x)))
                       (\ _ ->
                         bindb (catcha
                                 (forallM
                                   (\ j ->
                                     check (less_eq_nat j m)
                                       (shows_string
  ['r', 'i', 'g', 'h', 't', '-', 'i', 'n', 'd', 'e', 'x', ' ', 't', 'o', ' ',
    'l', 'a', 'r', 'g', 'e', ' ', 'o', 'r', ' ', 'a', 'r', 'g', 'u', 'm', 'e',
    'n', 't', ' ', 'v', 'i', 'o', 'l', 'a', 't', 'e', 's', ' ', 'u', 's', 'a',
    'b', 'l', 'e', '-', 'r', 'u', 'l', 'e', 's', ' ', 'c', 'o', 'n', 'd', 'i',
    't', 'i', 'o', 'n'] .
 shows_prec_nat Zero_nat j))
                                   (remdups (map snd (stri ++ nstri))))
                                 (\ x -> Inl (snd x)))
                           (\ _ ->
                             let {
                               _ = args s;
                               _ = args t;
                             } in bindb (catcha
  (forallM
    (\ (i, j) ->
      check (isOK (sa (get_arg s i, get_arg t j)))
        (shows_string
           ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'i', 't', 'h', ' ',
             'e', 'd', 'g', 'e', ' '] .
          shows_prec_nat Zero_nat i .
            shows_string [' ', '-', 'S', '-', '>', ' '] .
              shows_prec_nat Zero_nat j))
    stri)
  (\ x -> Inl (snd x)))
                                    (\ _ ->
                                      catcha
(forallM
  (\ (i, j) ->
    check (isOK (nst (get_arg s i, get_arg t j)))
      (shows_string
         ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'i', 't', 'h', ' ', 'e',
           'd', 'g', 'e', ' '] .
        shows_prec_nat Zero_nat i .
          shows_string [' ', '-', 'N', 'S', '-', '>', ' '] .
            shows_prec_nat Zero_nat j))
  nstri)
(\ x -> Inl (snd x)))))))))
    (\ x ->
      Inl (shows_string
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', 's', ' ', 'w', 'i', 't', 'h',
               ' ', 'D', 'P', ' '] .
            shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
              [' ', '-', '>', ' '] (s, t) .
              shows_nl . x));

sct_ur_af_proc ::
  forall a b.
    (Eq b, Key b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    Redtriple_ext b [Prelude.Char] () ->
                      [((Term b [Prelude.Char], Term b [Prelude.Char]),
                         ([(Nat, Nat)], [(Nat, Nat)]))] ->
                        Maybe [(Term b [Prelude.Char],
                                 Term b [Prelude.Char])] ->
                          a -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
sct_ur_af_proc i rp gs u_opt dpp =
  catcha
    (bindb (valid rp)
      (\ _ ->
        let {
          is_def = (\ fn -> not (null (rules_mapb i dpp fn)));
          pi = afa rp;
          sa = s rp;
          nsa = ns rp;
          nsta = nst rp;
        } in bindb (catcha (forallM (\ (l, _) -> check_no_var l) (rulesd i dpp))
                     (\ x -> Inl (snd x)))
               (\ _ ->
                 bindb (catcha
                         (forallM
                           (\ (a, b) ->
                             let {
                               (saa, t) = a;
                             } in (\ (aa, ba) ->
                                    check_sct_entry is_def sa nsta saa t aa ba)
                               b)
                           gs)
                         (\ x -> Inl (snd x)))
                   (\ _ ->
                     let {
                       sts = concatMap
                               (\ (a, b) ->
                                 let {
                                   (sb, t) = a;
                                 } in (\ (aa, ba) ->
sct_entry_to_sts sb t aa ba)
                                   b)
                               gs;
                     } in bindb (smart_usable_rules_checker_impl i dpp pi u_opt
                                  sts)
                            (\ u ->
                              bindb (catcha
                                      (catcha (forallM nsa u)
(\ x -> Inl (snd x)))
                                      (\ x ->
Inl (shows_string
       ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ', 'o',
         'r', 'i', 'e', 'n', 't', 'i', 'n', 'g', ' ', 'u', 's', 'a', 'b', 'l',
         'e', ' ', 'r', 'u', 'l', 'e', 's'] .
      shows_nl . x)))
                                (\ _ ->
                                  let {
                                    p = pairsa i dpp;
                                    eidg = is_iedg_edge_dpp i dpp;
                                  } in bindb
 (catcha (check_subseteq p (map fst gs))
   (\ x ->
     Inl (shows_string
            ['t', 'h', 'e', 'r', 'e', ' ', 'i', 's', ' ', 'n', 'o', ' ', 's',
              'i', 'z', 'e', '-', 'c', 'h', 'a', 'n', 'g', 'e', ' ', 'g', 'r',
              'a', 'p', 'h', ' ', 'f', 'o', 'r', ' ', 'D', 'P', ' '] .
           shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
             [' ', '-', '>', ' '] x)))
 (\ _ ->
   check (check_SCT (\ (_, (_, succs)) (ua, (v, _)) -> membera succs (ua, v))
           (map (\ (a, b) ->
                  let {
                    (sb, t) = a;
                  } in (\ (stri, nstri) ->
                         let {
                           eidg_st = eidg (sb, t);
                           e = (sb, (t, filter (eidg_st . fst) p));
                         } in Scg e e stri nstri)
                    b)
             gs))
     (shows_string
        ['s', 'i', 'z', 'e', '-', 'c', 'h', 'a', 'n', 'g', 'e', ' ', 'a', 'n',
          'a', 'l', 'y', 's', 'i', 's', ' ', 'f', 'a', 'i', 'l', 'e', 'd'] .
       shows_nl))))))))
    (\ x ->
      Inl (shows_string
             ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'a', 'p', 'p',
               'l', 'y', ' ', 't', 'h', 'e', ' ', 's', 'i', 'z', 'e', '-', 'c',
               'h', 'a', 'n', 'g', 'e', ' ', 'p', 'r', 'o', 'c', 'e', 's', 's',
               'o', 'r', ' ', 'w', 'i', 't', 'h', ' ', 't', 'h', 'e', ' ', 'f',
               'o', 'l', 'l', 'o', 'w', 'i', 'n', 'g', ' '] .
            shows_nl .
              desca rp .
                shows_nl .
                  shows_string
                    ['f', 'o', 'r', ' ', 't', 'h', 'e', ' ', 'f', 'o', 'l', 'l',
                      'o', 'w', 'i', 'n', 'g', ' ', 'r', 'e', 'a', 's', 'o',
                      'n'] .
                    shows_nl . x));

minus_mini_alg_number :: Mini_alg_number -> Mini_alg_number -> Mini_alg_number;
minus_mini_alg_number (Sp c1 d1) (Sp c2 d2) =
  Sp (minus_rat c1 c2) (minus_rat d1 d2);

geqa :: Mini_alg_number -> Mini_alg_number -> Bool;
geqa x y =
  let {
    (Sp c d) = minus_mini_alg_number x y;
  } in less_eq_rat zero_rat c &&
         less_eq_rat (times_rat (times_rat p d) d) (times_rat c c) ||
         less_eq_rat zero_rat d &&
           less_eq_rat (times_rat c c) (times_rat (times_rat p d) d);

less_eq_mini_alg_number :: Mini_alg_number -> Mini_alg_number -> Bool;
less_eq_mini_alg_number x y = geqa y x;

gta :: Mini_alg_number -> Mini_alg_number -> Bool;
gta x y = geqa x y && not (equal_mini_alg_number x y);

less_mini_alg_number :: Mini_alg_number -> Mini_alg_number -> Bool;
less_mini_alg_number x y = gta y x;

instance Ord Mini_alg_number where {
  less_eq = less_eq_mini_alg_number;
  less = less_mini_alg_number;
};

instance Non_strict_order Mini_alg_number where {
};

instance Ordered_ab_semigroup Mini_alg_number where {
};

instance Ordered_semiring_0 Mini_alg_number where {
};

instance Ordered_semiring_1 Mini_alg_number where {
};

filter_prec_weight_repr ::
  forall a.
    ((a, Nat) -> Af_entry) ->
      ([((a, Nat), (Nat, (Nat, Maybe [Nat])))], Nat) ->
        ([((Filtered a, Nat), (Nat, (Nat, Maybe [Nat])))], Nat);
filter_prec_weight_repr pi (prw, w0) =
  let {
    fprw =
      filter
        (\ (fn, _) ->
          (case pi fn of {
            Collapse _ -> False;
            AFList _ -> True;
          }))
        prw;
    mprw =
      map (\ (a, b) ->
            let {
              (f, n) = a;
            } in (\ aa ->
                   ((FPair f n,
                      (case pi (f, n) of {
                        Collapse _ -> Zero_nat;
                        AFList ab -> size_list ab;
                      })),
                     aa))
              b)
        fprw;
  } in (mprw, w0);

instance Poly_carrier Mini_alg_number where {
};

instance Large_ordered_semiring_1 Mini_alg_number where {
};

instance Preorder Mini_alg_number where {
};

instance Order Mini_alg_number where {
};

instance Dense_order Mini_alg_number where {
};

instance Linorder Mini_alg_number where {
};

instance Dense_linorder Mini_alg_number where {
};

instance No_top Mini_alg_number where {
};

instance No_bot Mini_alg_number where {
};

instance Unbounded_dense_linorder Mini_alg_number where {
};

instance Ordered_ab_semigroup_add Mini_alg_number where {
};

instance Cancel_semigroup_add Mini_alg_number where {
};

instance Cancel_ab_semigroup_add Mini_alg_number where {
};

instance Ordered_cancel_ab_semigroup_add Mini_alg_number where {
};

instance Ordered_ab_semigroup_add_imp_le Mini_alg_number where {
};

instance Linordered_ab_semigroup_add Mini_alg_number where {
};

instance Linordered_cancel_ab_semigroup_add Mini_alg_number where {
};

instance Ordered_comm_monoid_add Mini_alg_number where {
};

instance Cancel_comm_monoid_add Mini_alg_number where {
};

instance Semiring_0_cancel Mini_alg_number where {
};

instance Ordered_semiring Mini_alg_number where {
};

instance Ordered_cancel_semiring Mini_alg_number where {
};

instance Linordered_semiring Mini_alg_number where {
};

instance Linordered_semiring_strict Mini_alg_number where {
};

instance Linordered_semiring_1 Mini_alg_number where {
};

instance Linordered_semiring_1_strict Mini_alg_number where {
};

instance No_zero_divisors Mini_alg_number where {
};

uminus_mini_alg_number :: Mini_alg_number -> Mini_alg_number;
uminus_mini_alg_number (Sp c1 d1) = Sp (uminus_rat c1) (uminus_rat d1);

instance Uminus Mini_alg_number where {
  uminus = uminus_mini_alg_number;
};

instance Minus Mini_alg_number where {
  minus = minus_mini_alg_number;
};

instance Group_add Mini_alg_number where {
};

instance Ab_group_add Mini_alg_number where {
};

instance Ring Mini_alg_number where {
};

instance Ring_no_zero_divisors Mini_alg_number where {
};

instance Ordered_ab_group_add Mini_alg_number where {
};

abs_mini_alg_number :: Mini_alg_number -> Mini_alg_number;
abs_mini_alg_number x =
  (if geqa x zero_mini_alg_number then x else uminus_mini_alg_number x);

instance Abs Mini_alg_number where {
  absa = abs_mini_alg_number;
};

instance Ordered_ab_group_add_abs Mini_alg_number where {
};

instance Linordered_ab_group_add Mini_alg_number where {
};

instance Ordered_ring Mini_alg_number where {
};

instance Abs_if Mini_alg_number where {
};

instance Linordered_ring Mini_alg_number where {
};

instance Linordered_ring_strict Mini_alg_number where {
};

instance Comm_semiring_0_cancel Mini_alg_number where {
};

instance Ordered_comm_semiring Mini_alg_number where {
};

instance Ordered_cancel_comm_semiring Mini_alg_number where {
};

instance Linordered_comm_semiring_strict Mini_alg_number where {
};

instance Semiring_1_cancel Mini_alg_number where {
};

instance Comm_semiring_1_cancel Mini_alg_number where {
};

instance Semiring_char_0 Mini_alg_number where {
};

instance Linordered_semidom Mini_alg_number where {
};

instance Comm_ring Mini_alg_number where {
};

instance Ordered_comm_ring Mini_alg_number where {
};

instance Ordered_ring_abs Mini_alg_number where {
};

instance Neg_numeral Mini_alg_number where {
};

instance Ring_1 Mini_alg_number where {
};

instance Ring_char_0 Mini_alg_number where {
};

sgn_mini_alg_number :: Mini_alg_number -> Mini_alg_number;
sgn_mini_alg_number x =
  (if equal_mini_alg_number x zero_mini_alg_number then zero_mini_alg_number
    else (if geqa x zero_mini_alg_number then one_mini_alg_number
           else uminus_mini_alg_number one_mini_alg_number));

instance Sgn Mini_alg_number where {
  sgn = sgn_mini_alg_number;
};

instance Sgn_if Mini_alg_number where {
};

instance Comm_semiring_1_cancel_crossproduct Mini_alg_number where {
};

instance Ring_1_no_zero_divisors Mini_alg_number where {
};

instance Comm_ring_1 Mini_alg_number where {
};

instance Idom Mini_alg_number where {
};

instance Linordered_idom Mini_alg_number where {
};

inverse_mini_alg_number :: Mini_alg_number -> Mini_alg_number;
inverse_mini_alg_number (Sp a b) =
  let {
    d = inverse_rat (minus_rat (times_rat a a) (times_rat (times_rat p b) b));
  } in Sp (times_rat a d) (times_rat (uminus_rat b) d);

divide_mini_alg_number :: Mini_alg_number -> Mini_alg_number -> Mini_alg_number;
divide_mini_alg_number x (Sp a b) =
  times_mini_alg_number x
    (let {
       d = inverse_rat
             (minus_rat (times_rat a a) (times_rat (times_rat p b) b));
     } in Sp (times_rat a d) (times_rat (uminus_rat b) d));

instance Inverse Mini_alg_number where {
  inverse = inverse_mini_alg_number;
  divide = divide_mini_alg_number;
};

instance Division_ring Mini_alg_number where {
};

instance Field Mini_alg_number where {
};

instance Field_char_0 Mini_alg_number where {
};

instance Linordered_field Mini_alg_number where {
};

instance Archimedean_field Mini_alg_number where {
};

floor_mini_alg_number :: Mini_alg_number -> Int;
floor_mini_alg_number =
  error "floor for mini-alg not impl." (\ _ -> floor_mini_alg_number);

instance Floor_ceiling Mini_alg_number where {
  floor = floor_mini_alg_number;
};

prec_repr_to_status ::
  forall a.
    (Eq a,
      Key a) => [((a, Nat), (Nat, Order_tag))] ->
                  Filtered a -> Nat -> Order_tag;
prec_repr_to_status prs =
  let {
    m = ceta_map_of prs;
  } in (\ fp _ ->
         let {
           (FPair f a) = fp;
         } in (case m (f, a) of {
                Nothing -> Lex;
                Just aa -> snd aa;
              }));

less_eq_arctic_delta ::
  forall a. (Ord a) => Arctic_delta a -> Arctic_delta a -> Bool;
less_eq_arctic_delta MinInfty_delta x = True;
less_eq_arctic_delta (Num_arc_delta uu) MinInfty_delta = False;
less_eq_arctic_delta (Num_arc_delta y) (Num_arc_delta x) = less_eq y x;

less_arctic_delta ::
  forall a. (Ord a) => Arctic_delta a -> Arctic_delta a -> Bool;
less_arctic_delta MinInfty_delta x = True;
less_arctic_delta (Num_arc_delta uu) MinInfty_delta = False;
less_arctic_delta (Num_arc_delta y) (Num_arc_delta x) = less y x;

instance (Ord a) => Ord (Arctic_delta a) where {
  less_eq = less_eq_arctic_delta;
  less = less_arctic_delta;
};

instance (Linordered_field a) => Non_strict_order (Arctic_delta a) where {
};

instance (Linordered_field a) => Semigroup_add (Arctic_delta a) where {
};

instance (Linordered_field a) => Ab_semigroup_add (Arctic_delta a) where {
};

instance (Linordered_field a) => Monoid_add (Arctic_delta a) where {
};

instance (Linordered_field a) => Ordered_ab_semigroup (Arctic_delta a) where {
};

instance (Linordered_field a) => Comm_monoid_add (Arctic_delta a) where {
};

instance (Linordered_field a) => Mult_zero (Arctic_delta a) where {
};

instance (Linordered_field a) => Semigroup_mult (Arctic_delta a) where {
};

instance (Linordered_field a) => Semiring (Arctic_delta a) where {
};

instance (Linordered_field a) => Semiring_0 (Arctic_delta a) where {
};

instance (Linordered_field a) => Ordered_semiring_0 (Arctic_delta a) where {
};

instance (Linordered_field a) => Power (Arctic_delta a) where {
};

instance (Linordered_field a) => Monoid_mult (Arctic_delta a) where {
};

instance (Linordered_field a) => Numeral (Arctic_delta a) where {
};

instance (Linordered_field a) => Semiring_numeral (Arctic_delta a) where {
};

instance (Linordered_field a) => Zero_neq_one (Arctic_delta a) where {
};

instance (Linordered_field a) => Semiring_1 (Arctic_delta a) where {
};

instance (Linordered_field a) => Ordered_semiring_1 (Arctic_delta a) where {
};

prec_repr_to_pr ::
  forall a.
    (Eq a, Key a) => [((a, Nat), (Nat, Order_tag))] -> Filtered a -> Nat -> Nat;
prec_repr_to_pr prs =
  let {
    m = ceta_map_of prs;
  } in (\ fp _ ->
         let {
           (FPair f a) = fp;
         } in (case m (f, a) of {
                Nothing -> Zero_nat;
                Just aa -> fst aa;
              }));

data Lpoly_order_semiring_ext a b =
  Lpoly_order_semiring_ext Bool a (a -> Bool) (a -> Bool) (a -> Nat)
    (a -> Sum ([Prelude.Char] -> [Prelude.Char]) Nat) [Prelude.Char] b;

show_mini_alg_number :: Mini_alg_number -> [Prelude.Char];
show_mini_alg_number x =
  let {
    sp = (shows_prec_list Zero_nat ['*', 's', 'q', 'r', 't', '('] .
           shows_prec_rat Zero_nat p) .
           shows_prec_list Zero_nat [')'];
    (Sp r i) = x;
  } in (if equal_rat i zero_rat then shows_prec_rat Zero_nat r []
         else (if equal_rat r zero_rat then (shows_prec_rat Zero_nat i . sp) []
                else (if less_rat i zero_rat
                       then ((((shows_prec_list Zero_nat ['('] .
                                 shows_prec_rat Zero_nat r) .
                                shows_prec_rat Zero_nat i) .
                               sp) .
                              shows_prec_list Zero_nat [')'])
                              []
                       else (((((shows_prec_list Zero_nat ['('] .
                                  shows_prec_rat Zero_nat r) .
                                 shows_prec_list Zero_nat ['+']) .
                                shows_prec_rat Zero_nat i) .
                               sp) .
                              shows_prec_list Zero_nat [')'])
                              [])));

shows_prec_mini_alg_number ::
  Nat -> Mini_alg_number -> [Prelude.Char] -> [Prelude.Char];
shows_prec_mini_alg_number d x = shows_string (show_mini_alg_number x);

shows_list_mini_alg_number ::
  [Mini_alg_number] -> [Prelude.Char] -> [Prelude.Char];
shows_list_mini_alg_number =
  shows_list_aux (shows_prec_mini_alg_number Zero_nat);

instance Showa Mini_alg_number where {
  shows_prec = shows_prec_mini_alg_number;
  shows_list = shows_list_mini_alg_number;
};

less_eq_arctic :: Arctic -> Arctic -> Bool;
less_eq_arctic MinInfty x = True;
less_eq_arctic (Num_arc uu) MinInfty = False;
less_eq_arctic (Num_arc y) (Num_arc x) = less_eq_int y x;

less_arctic :: Arctic -> Arctic -> Bool;
less_arctic MinInfty x = True;
less_arctic (Num_arc uu) MinInfty = False;
less_arctic (Num_arc y) (Num_arc x) = less_int y x;

instance Ord Arctic where {
  less_eq = less_eq_arctic;
  less = less_arctic;
};

instance Non_strict_order Arctic where {
};

instance Semigroup_add Arctic where {
};

instance Ab_semigroup_add Arctic where {
};

instance Monoid_add Arctic where {
};

instance Ordered_ab_semigroup Arctic where {
};

instance Comm_monoid_add Arctic where {
};

instance Mult_zero Arctic where {
};

instance Semigroup_mult Arctic where {
};

instance Semiring Arctic where {
};

instance Semiring_0 Arctic where {
};

instance Ordered_semiring_0 Arctic where {
};

instance Power Arctic where {
};

instance Monoid_mult Arctic where {
};

instance Numeral Arctic where {
};

instance Semiring_numeral Arctic where {
};

instance Zero_neq_one Arctic where {
};

instance Semiring_1 Arctic where {
};

instance Ordered_semiring_1 Arctic where {
};

poly_c_max_inter_bcoeff ::
  forall a b c.
    Partial_object_ext a
      (Monoid_ext a (Ring_ext a (Ordered_semiring_ext a b))) ->
      [(c, Nat)] -> ((c, Nat) -> (a, [a])) -> a;
poly_c_max_inter_bcoeff r f pi =
  foldr (maxa r)
    (concatMap (\ fn -> filter (\ b -> not (geq r (one r) b)) (snd (pi fn))) f)
    (zero r);

derive_complexity ::
  forall a b.
    Partial_object_ext a
      (Monoid_ext a
        (Ring_ext a (Ordered_semiring_ext a (Lpoly_order_semiring_ext a b)))) ->
      a -> Sum ([Prelude.Char] -> [Prelude.Char]) Nat;
derive_complexity
  (Partial_object_ext carrier
    (Monoid_ext mult one
      (Ring_ext zero add
        (Ordered_semiring_ext geq gt max
          (Lpoly_order_semiring_ext plus_single_mono defaulta arcpos checkmono
            bound derive_complexity description more)))))
  = derive_complexity;

smaller_one_complexity ::
  forall a b.
    Partial_object_ext a
      (Monoid_ext a
        (Ring_ext a (Ordered_semiring_ext a (Lpoly_order_semiring_ext a b)))) ->
      a -> Sum ([Prelude.Char] -> [Prelude.Char]) Nat;
smaller_one_complexity r bc =
  (if geq r (one r) bc then Inr Zero_nat else derive_complexity r bc);

convert_lpoly_complexity ::
  forall a b c d.
    Partial_object_ext a
      (Monoid_ext a
        (Ring_ext a (Ordered_semiring_ext a (Lpoly_order_semiring_ext a b)))) ->
      ((c, Nat) -> (a, [a])) ->
        Complexity_measure c d ->
          Sum ([Prelude.Char] -> [Prelude.Char]) Complexity_class;
convert_lpoly_complexity r pi cc =
  let {
    f = (case cc of {
          Derivational_Complexity f -> f;
          Runtime_Complexity c _ -> c;
        });
    bc = poly_c_max_inter_bcoeff r f pi;
  } in sum_map (\ x -> x) (\ deg -> Comp_Poly (plus_nat deg (Nat_of_num One)))
         (smaller_one_complexity r bc);

plus_single_mono ::
  forall a b.
    Partial_object_ext a
      (Monoid_ext a
        (Ring_ext a (Ordered_semiring_ext a (Lpoly_order_semiring_ext a b)))) ->
      Bool;
plus_single_mono
  (Partial_object_ext carrier
    (Monoid_ext mult one
      (Ring_ext zero add
        (Ordered_semiring_ext geq gt max
          (Lpoly_order_semiring_ext plus_single_mono defaulta arcpos checkmono
            bound derive_complexity description more)))))
  = plus_single_mono;

check_poly_mono_npsm ::
  forall a b c.
    (Eq a, Showa a, Eq c,
      Showa c) => Partial_object_ext a
                    (Monoid_ext a
                      (Ring_ext a
                        (Ordered_semiring_ext a
                          (Lpoly_order_semiring_ext a b)))) ->
                    [(c, Nat)] ->
                      [((c, Nat), (a, [a]))] ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_poly_mono_npsm r f pi =
  bindb (catcha
          (forallM
            (\ (a, b) ->
              let {
                (fa, n) = a;
              } in (\ (c, cs) ->
                     catcha
                       (bindb
                         (check
                           (if equal_nat n (plus_nat Zero_nat (Nat_of_num One))
                             then c == zero r else True)
                           (shows_string
                              ['c', 'o', 'n', 's', 't', 'a', 'n', 't', ' ', 'p',
                                'a', 'r', 't', ' '] .
                             shows_prec Zero_nat c .
                               shows_string
                                 [' ', 'm', 'u', 's', 't', ' ', 'b', 'e', ' ',
                                   '0', ' '] .
                                 shows_nl))
                         (\ _ ->
                           bindb (check (equal_nat n (size_list cs))
                                   (shows_string
                                      ['t', 'h', 'e', ' ', 'a', 'r', 'i', 't',
'y', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 't', 'h', 'e', ' ', 's', 'a', 'm',
'e', ' ', 'a', 's', ' ', 't', 'h', 'e', ' ', 'n', 'u', 'm', 'b', 'e', 'r', ' ',
'o', 'f', ' ', 'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's'] .
                                     shows_nl))
                             (\ _ ->
                               check (less_eq_nat n
                                       (plus_nat Zero_nat (Nat_of_num One)))
                                 (shows_string
                                    ['s', 'y', 'm', 'b', 'o', 'l', ' ', 'h',
                                      'a', 's', ' ', 'a', 'r', 'i', 't', 'y',
                                      ' ', 'l', 'a', 'r', 'g', 'e', 'r', ' ',
                                      't', 'h', 'a', 'n', ' ', '1'] .
                                   shows_nl))))
                       (\ x ->
                         Inl (shows_string
                                ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w',
                                  'i', 't', 'h', ' ', 'm', 'o', 'n', 'o', 't',
                                  'o', 'n', 'i', 'c', 'i', 't', 'y', ' ', 'd',
                                  'u', 'e', ' ', 't', 'o', ' ', 'i', 'n', 't',
                                  'e', 'r', 'p', 'r', 'e', 't', 'a', 't', 'i',
                                  'o', 'n', ' ', 'o', 'f', ' '] .
                               shows_prec Zero_nat fa .
                                 shows_string ['/'] .
                                   shows_prec_nat Zero_nat n . shows_nl . x)))
                b)
            pi)
          (\ x -> Inl (snd x)))
    (\ _ ->
      catcha (check_subseteq f (map fst pi))
        (\ x ->
          Inl (shows_string
                 ['u', 'n', 'k', 'n', 'o', 'w', 'n', ' ', 'i', 'n', 't', 'e',
                   'r', 'p', 'r', 'e', 't', 'a', 't', 'i', 'o', 'n', ' ', 'f',
                   'o', 'r', ' '] .
                shows_prec_prod Zero_nat x . shows_nl)));

arcpos ::
  forall a b.
    Partial_object_ext a
      (Monoid_ext a
        (Ring_ext a (Ordered_semiring_ext a (Lpoly_order_semiring_ext a b)))) ->
      a -> Bool;
arcpos
  (Partial_object_ext carrier
    (Monoid_ext mult one
      (Ring_ext zero add
        (Ordered_semiring_ext geq gt max
          (Lpoly_order_semiring_ext plus_single_mono defaulta arcpos checkmono
            bound derive_complexity description more)))))
  = arcpos;

check_lpoly_coeffs ::
  forall a b c.
    (Ceq a, Corder a, Showa a,
      Showa c) => Partial_object_ext a
                    (Monoid_ext a
                      (Ring_ext a
                        (Ordered_semiring_ext a
                          (Lpoly_order_semiring_ext a b)))) ->
                    [((c, Nat), (a, [a]))] ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_lpoly_coeffs r i =
  catcha
    (forallM
      (\ (a, b) ->
        let {
          (f, n) = a;
        } in (\ (c, cs) ->
               catcha
                 (bindb
                   (check (member c (carrier r))
                     (shows_string
                        ['c', 'o', 'n', 's', 't', 'a', 'n', 't', ' ', 'p', 'a',
                          'r', 't', ' '] .
                       shows_prec Zero_nat c .
                         shows_string
                           [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'w', 'e',
                             'l', 'l', '-', 'f', 'o', 'r', 'm', 'e', 'd'] .
                           shows_nl))
                   (\ _ ->
                     bindb (check (arcpos r c || any (arcpos r) (take n cs))
                             (shows_string
                                ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't',
                                  ' ', 'f', 'i', 'n', 'd', ' ', 'p', 'o', 's',
                                  'i', 't', 'i', 'v', 'e', ' ', 'e', 'n', 't',
                                  'r', 'y', ' ', 'w', 'h', 'i', 'c', 'h', ' ',
                                  'i', 's', ' ', 'r', 'e', 'q', 'u', 'i', 'r',
                                  'e', 'd', ' ', 'f', 'o', 'r', ' ', 'a', 'r',
                                  'c', 't', 'i', 'c', ' ', 'i', 'n', 't', 'e',
                                  'r', 'p', 'r', 'e', 't', 'a', 't', 'i', 'o',
                                  'n', 's'] .
                               shows_nl))
                       (\ _ ->
                         catcha
                           (forallM
                             (\ aa ->
                               check (geq r aa (zero r) &&
                                       member aa (carrier r))
                                 (shows_string
                                    ['c', 'o', 'e', 'f', 'f', 'i', 'c', 'i',
                                      'e', 'n', 't', ' '] .
                                   shows_prec Zero_nat aa .
                                     shows_string
                                       [' ', 'i', 's', ' ', 'n', 'o', 't', ' ',
 'a', 'l', 'l', 'o', 'w', 'e', 'd'] .
                                       shows_nl))
                             cs)
                           (\ x -> Inl (snd x)))))
                 (\ x ->
                   Inl (shows_string
                          ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'i',
                            't', 'h', ' ', 'i', 'n', 't', 'e', 'r', 'p', 'r',
                            'e', 't', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f',
                            ' '] .
                         shows_prec Zero_nat f .
                           shows_string ['/'] .
                             shows_prec_nat Zero_nat n . shows_nl . x)))
          b)
      i)
    (\ x -> Inl (snd x));

description ::
  forall a b.
    Partial_object_ext a
      (Monoid_ext a
        (Ring_ext a (Ordered_semiring_ext a (Lpoly_order_semiring_ext a b)))) ->
      [Prelude.Char];
description
  (Partial_object_ext carrier
    (Monoid_ext mult one
      (Ring_ext zero add
        (Ordered_semiring_ext geq gt max
          (Lpoly_order_semiring_ext plus_single_mono defaulta arcpos checkmono
            bound derive_complexity description more)))))
  = description;

defaulta ::
  forall a b.
    Partial_object_ext a
      (Monoid_ext a
        (Ring_ext a (Ordered_semiring_ext a (Lpoly_order_semiring_ext a b)))) ->
      a;
defaulta
  (Partial_object_ext carrier
    (Monoid_ext mult one
      (Ring_ext zero add
        (Ordered_semiring_ext geq gt max
          (Lpoly_order_semiring_ext plus_single_mono defaulta arcpos checkmono
            bound derive_complexity description more)))))
  = defaulta;

to_lpoly_inter ::
  forall a b c.
    (Eq c,
      Key c) => Partial_object_ext a
                  (Monoid_ext a
                    (Ring_ext a
                      (Ordered_semiring_ext a
                        (Lpoly_order_semiring_ext a b)))) ->
                  [((c, Nat), (a, [a]))] -> (c, Nat) -> (a, [a]);
to_lpoly_inter r i =
  fun_of_map_fun (ceta_map_of i)
    (\ fn -> (defaulta r, replicate (snd fn) (one r)));

show_pvars ::
  forall a b c.
    (Eq a, Showa a,
      Showa c) => Partial_object_ext a (Monoid_ext a (Ring_ext a b)) ->
                    [(c, a)] -> [[Prelude.Char]];
show_pvars r [] = [];
show_pvars r ((x, c) : vas) =
  (if c == one r then id else shows_prec Zero_nat c)
    (shows_prec Zero_nat x []) :
    show_pvars r vas;

shows_lpoly ::
  forall a b c.
    (Eq a, Showa a,
      Showa c) => Partial_object_ext a (Monoid_ext a (Ring_ext a b)) ->
                    L_poly c a -> [Prelude.Char] -> [Prelude.Char];
shows_lpoly r (LPoly c cs) =
  (case show_pvars r cs of {
    [] -> shows_prec Zero_nat c;
    a : list ->
      (if c == zero r then id
        else shows_prec Zero_nat c . shows_string [' ', '+', ' ']) .
        shows_list_gen (shows_prec_list Zero_nat) [] [] [' ', '+', ' '] []
          (a : list);
  });

add_var ::
  forall a b c.
    (Eq a,
      Eq c) => Partial_object_ext a (Monoid_ext a (Ring_ext a b)) ->
                 c -> a -> [(c, a)] -> [(c, a)];
add_var r x a [] = [(x, a)];
add_var r x a ((y, b) : vas) =
  (if x == y
    then let {
           s = add r a b;
         } in (if s == zero r then vas else (x, s) : vas)
    else (y, b) : add_var r x a vas);

sum_pvars ::
  forall a b c.
    (Eq a,
      Eq c) => Partial_object_ext a (Monoid_ext a (Ring_ext a b)) ->
                 [(c, a)] -> [(c, a)] -> [(c, a)];
sum_pvars r [] vbs = vbs;
sum_pvars r ((x, a) : vas) vbs =
  (if a == zero r then sum_pvars r vas vbs
    else sum_pvars r vas (add_var r x a vbs));

sum_lpolya ::
  forall a b c.
    (Eq a,
      Eq c) => Partial_object_ext a (Monoid_ext a (Ring_ext a b)) ->
                 L_poly c a -> L_poly c a -> L_poly c a;
sum_lpolya r (LPoly a vas) (LPoly b vbs) =
  LPoly (add r a b) (sum_pvars r vas vbs);

mul_pvars ::
  forall a b c.
    (Eq a) => Partial_object_ext a (Monoid_ext a (Ring_ext a b)) ->
                a -> [(c, a)] -> [(c, a)];
mul_pvars r a [] = [];
mul_pvars r a ((x, b) : vas) =
  let {
    p = mult r a b;
    res = mul_pvars r a vas;
  } in (if p == zero r then res else (x, p) : res);

mul_lpoly ::
  forall a b c.
    (Eq a) => Partial_object_ext a (Monoid_ext a (Ring_ext a b)) ->
                a -> L_poly c a -> L_poly c a;
mul_lpoly r a (LPoly b vas) = LPoly (mult r a b) (mul_pvars r a vas);

list_prod :: forall a b. Partial_object_ext a (Monoid_ext a b) -> [a] -> a;
list_prod r [] = one r;
list_prod r (x : xs) = mult r x (list_prod r xs);

cEnum_l_poly ::
  forall a b.
    Maybe ([L_poly a b],
            ((L_poly a b -> Bool) -> Bool, (L_poly a b -> Bool) -> Bool));
cEnum_l_poly = Nothing;

instance Cenum (L_poly a b) where {
  cEnum = cEnum_l_poly;
};

wf_pvars ::
  forall a b c.
    (Cenum a, Ceq a, Corder a) => Partial_object_ext a b -> [(c, a)] -> Bool;
wf_pvars r vas = less_eq_set (set (map snd vas)) (carrier r);

wf_lpoly ::
  forall a b c.
    (Cenum a, Ceq a, Corder a) => Partial_object_ext a b -> L_poly c a -> Bool;
wf_lpoly r (LPoly a vas) = member a (carrier r) && wf_pvars r vas;

pleftI ::
  forall a b c d.
    (Cenum a, Ceq a, Corder a, Eq a,
      Eq d) => Partial_object_ext a
                 (Monoid_ext a (Ring_ext a (Ordered_semiring_ext a b))) ->
                 ((c, Nat) -> (a, [a])) -> Term c d -> L_poly d a;
pleftI r pi (Var x) = LPoly (zero r) [(x, one r)];
pleftI r pi (Fun f ts) =
  let {
    (c, asa) = pi (f, size_list ts);
  } in (case sum_lpolya r (LPoly c [])
               (list_prod
                 (Partial_object_ext (collect (wf_lpoly r))
                   (Monoid_ext (sum_lpolya r) (LPoly (zero r) []) ()))
                 (map (\ at -> mul_lpoly r (fst at) (pleftI r pi (snd at)))
                   (zip asa ts)))
         of {
         LPoly d [] -> LPoly (maxa r (zero r) d) [];
         LPoly d (ab : lista) -> LPoly d (ab : lista);
       });

create_lpoly_repr ::
  forall a b.
    (Cenum a, Ceq a, Corder a, Eq a, Showa a, Eq b, Key b,
      Showa b) => Partial_object_ext a
                    (Monoid_ext a
                      (Ring_ext a
                        (Ordered_semiring_ext a
                          (Lpoly_order_semiring_ext a ())))) ->
                    [((b, Nat), (a, [a]))] -> [Prelude.Char] -> [Prelude.Char];
create_lpoly_repr c i =
  let {
    pi = to_lpoly_inter c i;
  } in shows_string
         ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'i', 'n', 't',
           'e', 'r', 'p', 'r', 'e', 't', 'r', 'a', 't', 'i', 'o', 'n', ' ', 'o',
           'v', 'e', 'r', ' '] .
         shows_string (description c) .
           shows_nl .
             shows_sep
               (\ (f, n) ->
                 let {
                   t = Fun f (map Var
                               (fresh_strings_list ['x', '_'] (Nat_of_num One)
                                 [] n));
                 } in shows_string ['P', 'o', 'l', '('] .
                        shows_prec_term Zero_nat t .
                          shows_string [')', ' ', '=', ' '] .
                            shows_lpoly c (pleftI c pi t))
               shows_nl (remdups (map fst i));

checkmono ::
  forall a b.
    Partial_object_ext a
      (Monoid_ext a
        (Ring_ext a (Ordered_semiring_ext a (Lpoly_order_semiring_ext a b)))) ->
      a -> Bool;
checkmono
  (Partial_object_ext carrier
    (Monoid_ext mult one
      (Ring_ext zero add
        (Ordered_semiring_ext geq gt max
          (Lpoly_order_semiring_ext plus_single_mono defaulta arcpos checkmono
            bound derive_complexity description more)))))
  = checkmono;

check_poly_mono ::
  forall a b c.
    (Showa a,
      Showa c) => Partial_object_ext a
                    (Monoid_ext a
                      (Ring_ext a
                        (Ordered_semiring_ext a
                          (Lpoly_order_semiring_ext a b)))) ->
                    [((c, Nat), (a, [a]))] ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_poly_mono r =
  (\ xs ->
    catcha
      (forallM
        (\ (a, b) ->
          let {
            (f, n) = a;
          } in (\ (c, cs) ->
                 catcha
                   (bindb
                     (check (geq r c (zero r))
                       (shows_string
                          ['c', 'o', 'n', 's', 't', 'a', 'n', 't', ' ', 'p',
                            'a', 'r', 't', ' '] .
                         shows_prec Zero_nat c .
                           shows_string
                             [' ', 'm', 'u', 's', 't', ' ', 'b', 'e', ' ', 'a',
                               't', ' ', 'l', 'e', 'a', 's', 't', ' '] .
                             shows_prec Zero_nat (zero r) . shows_nl))
                     (\ _ ->
                       bindb (check (less_eq_nat n (size_list cs))
                               (shows_string
                                  ['t', 'h', 'e', ' ', 'l', 'a', 's', 't', ' ',
                                    'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', ' ',
                                    'i', 's', ' ', 'i', 'g', 'n', 'o', 'r', 'e',
                                    'd'] .
                                 shows_nl))
                         (\ _ ->
                           catcha
                             (forallM
                               (\ d ->
                                 check (checkmono r d)
                                   (shows_string
                                      ['c', 'o', 'e', 'f', 'f', 'i', 'c', 'i',
'e', 'n', 't', ' '] .
                                     shows_prec Zero_nat d .
                                       shows_string
 [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', 'l', 'l', 'o', 'w', 'e', 'd'] .
 shows_nl))
                               cs)
                             (\ x -> Inl (snd x)))))
                   (\ x ->
                     Inl (shows_string
                            ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'i',
                              't', 'h', ' ', 'm', 'o', 'n', 'o', 't', 'o', 'n',
                              'i', 'c', 'i', 't', 'y', ' ', 'd', 'u', 'e', ' ',
                              't', 'o', ' ', 'i', 'n', 't', 'e', 'r', 'p', 'r',
                              'e', 't', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f',
                              ' '] .
                           shows_prec Zero_nat f .
                             shows_string ['/'] .
                               shows_prec_nat Zero_nat n . shows_nl . x)))
            b)
        xs)
      (\ x -> Inl (snd x)));

lookup_rest :: forall a b. (Eq a) => a -> [(a, b)] -> Maybe (b, [(a, b)]);
lookup_rest x [] = Nothing;
lookup_rest x ((y, c) : ycs) =
  (if x == y then Just (c, ycs)
    else (case lookup_rest x ycs of {
           Nothing -> Nothing;
           Just (d, yccs) -> Just (d, (y, c) : yccs);
         }));

check_pvars ::
  forall a b c.
    (Showa a,
      Eq c) => Partial_object_ext a (Monoid_ext a (Ring_ext a b)) ->
                 (a -> a -> Bool) -> [(c, a)] -> [(c, a)] -> Sum c ();
check_pvars r rel vas [] =
  catcha (forallM (\ va -> check (rel (snd va) (zero r)) (fst va)) vas)
    (\ x -> Inl (snd x));
check_pvars r rel vas ((x, b) : vbs) =
  let {
    (a, vasa) =
      (case lookup_rest x vas of {
        Nothing -> (zero r, vas);
        Just (a, ba) -> (a, ba);
      });
  } in bindb (check (rel a b) x) (\ _ -> check_pvars r rel vasa vbs);

check_lpoly_ns ::
  forall a b c.
    (Eq a, Showa a, Eq c,
      Showa c) => Partial_object_ext a
                    (Monoid_ext a (Ring_ext a (Ordered_semiring_ext a b))) ->
                    L_poly c a ->
                      L_poly c a -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_lpoly_ns r (LPoly a vas) (LPoly b vbs) =
  catcha
    (bindb
      (check (geq r a b)
        (shows_string
          ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ', 'c',
            'o', 'm', 'p', 'a', 'r', 'i', 'n', 'g', ' ', 'c', 'o', 'n', 's',
            't', 'a', 'n', 't', ' ', 'p', 'a', 'r', 't', 's']))
      (\ _ ->
        catcha (check_pvars r (geq r) vas vbs)
          (\ x ->
            Inl (shows_string
                   ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n',
                     ' ', 'c', 'o', 'm', 'p', 'a', 'r', 'i', 'n', 'g', ' ', 'c',
                     'o', 'e', 'f', 'f', 'i', 'c', 'i', 'e', 'n', 't', 's', ' ',
                     'o', 'f', ' ', 'v', 'a', 'r', 'i', 'a', 'b', 'l', 'e',
                     ' '] .
                  shows_prec Zero_nat x))))
    (\ x ->
      Inl (shows_string
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ',
               'c', 'o', 'm', 'p', 'a', 'r', 'i', 'n', 'g', ' '] .
            shows_lpoly r (LPoly a vas) .
              shows_string [' ', '>', '=', ' '] .
                shows_lpoly r (LPoly b vbs) . shows_nl . x));

prightI ::
  forall a b c d.
    (Cenum a, Ceq a, Corder a, Eq a,
      Eq d) => Partial_object_ext a
                 (Monoid_ext a (Ring_ext a (Ordered_semiring_ext a b))) ->
                 ((c, Nat) -> (a, [a])) -> Term c d -> L_poly d a;
prightI r pi (Var x) = LPoly (zero r) [(x, one r)];
prightI r pi (Fun f ts) =
  let {
    (c, asa) = pi (f, size_list ts);
    (LPoly d a) =
      sum_lpolya r (LPoly c [])
        (list_prod
          (Partial_object_ext (collect (wf_lpoly r))
            (Monoid_ext (sum_lpolya r) (LPoly (zero r) []) ()))
          (map (\ at -> mul_lpoly r (fst at) (prightI r pi (snd at)))
            (zip asa ts)));
  } in LPoly (maxa r (zero r) d) a;

check_polo_ns ::
  forall a b c d.
    (Cenum a, Ceq a, Corder a, Eq a, Showa a, Showa c, Eq d,
      Showa d) => Partial_object_ext a
                    (Monoid_ext a
                      (Ring_ext a
                        (Ordered_semiring_ext a
                          (Lpoly_order_semiring_ext a b)))) ->
                    ((c, Nat) -> (a, [a])) ->
                      (Term c d, Term c d) ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_polo_ns r pi (s, t) =
  let {
    left = pleftI r pi s;
    right = prightI r pi t;
  } in catcha (check_lpoly_ns r left right)
         (\ x ->
           Inl (shows_string
                  ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'n',
                    's', 'u', 'r', 'e', ' '] .
                 shows_prec_term Zero_nat s .
                   shows_string [' ', '>', '=', ' '] .
                     shows_prec_term Zero_nat t . shows_nl . x));

check_lpoly_s ::
  forall a b c.
    (Eq a, Showa a, Eq c,
      Showa c) => Partial_object_ext a
                    (Monoid_ext a
                      (Ring_ext a
                        (Ordered_semiring_ext a
                          (Lpoly_order_semiring_ext a b)))) ->
                    L_poly c a ->
                      L_poly c a -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_lpoly_s r (LPoly a vas) (LPoly b vbs) =
  catcha
    (bindb
      (check (gt r a b)
        (shows_string
          ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ', 'c',
            'o', 'm', 'p', 'a', 'r', 'i', 'n', 'g', ' ', 'c', 'o', 'n', 's',
            't', 'a', 'n', 't', ' ', 'p', 'a', 'r', 't']))
      (\ _ ->
        catcha
          (check_pvars r (if plus_single_mono r then geq r else gt r) vas vbs)
          (\ x ->
            Inl (shows_string
                   ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n',
                     ' ', 'c', 'o', 'm', 'p', 'a', 'r', 'i', 'n', 'g', ' ', 'c',
                     'o', 'e', 'f', 'f', 'i', 'c', 'i', 'e', 'n', 't', 's', ' ',
                     'o', 'f', ' ', 'v', 'a', 'r', 'i', 'a', 'b', 'l', 'e',
                     ' '] .
                  shows_prec Zero_nat x))))
    (\ x ->
      Inl (shows_string
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ',
               'c', 'o', 'm', 'p', 'a', 'r', 'i', 'n', 'g', ' '] .
            shows_lpoly r (LPoly a vas) .
              shows_string [' ', '>', ' '] .
                shows_lpoly r (LPoly b vbs) . shows_nl . x));

check_polo_s ::
  forall a b c d.
    (Cenum a, Ceq a, Corder a, Eq a, Showa a, Showa c, Eq d,
      Showa d) => Partial_object_ext a
                    (Monoid_ext a
                      (Ring_ext a
                        (Ordered_semiring_ext a
                          (Lpoly_order_semiring_ext a b)))) ->
                    ((c, Nat) -> (a, [a])) ->
                      (Term c d, Term c d) ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_polo_s r pi (s, t) =
  let {
    left = pleftI r pi s;
    right = prightI r pi t;
  } in catcha (check_lpoly_s r left right)
         (\ x ->
           Inl (shows_string
                  ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'n',
                    's', 'u', 'r', 'e', ' '] .
                 shows_prec_term Zero_nat s .
                   shows_string [' ', '>', ' '] .
                     shows_prec_term Zero_nat t . shows_nl . x));

create_af ::
  forall a b c.
    (Eq a, Eq c,
      Key c) => Partial_object_ext a
                  (Monoid_ext a
                    (Ring_ext a
                      (Ordered_semiring_ext a
                        (Lpoly_order_semiring_ext a b)))) ->
                  [((c, Nat), (a, [a]))] -> (c, Nat) -> Nat -> Bool;
create_af r i =
  fun_of_map_funa (ceta_map_of i) (\ _ _ -> True)
    (\ (_, coeffs) ->
      let {
        len = size_list coeffs;
      } in (\ ia -> less_nat ia len && not (nth coeffs ia == zero r)));

create_poly_redtriple ::
  forall a b c.
    (Cenum a, Ceq a, Corder a, Eq a, Showa a, Eq b, Key b, Showa b, Eq c,
      Showa c) => Partial_object_ext a
                    (Monoid_ext a
                      (Ring_ext a
                        (Ordered_semiring_ext a
                          (Lpoly_order_semiring_ext a ())))) ->
                    Sum ([Prelude.Char] -> [Prelude.Char]) () ->
                      [((b, Nat), (a, [a]))] -> Redtriple_ext b c ();
create_poly_redtriple c cI i =
  let {
    pi = to_lpoly_inter c i;
    ns = check_polo_ns c pi;
  } in Redtriple_ext (bindb cI (\ _ -> check_lpoly_coeffs c i))
         (check_polo_s c pi) ns ns (create_af c i)
         (\ s_ns_nst ->
           (if plus_single_mono c then check_poly_mono c i
             else check_poly_mono_npsm c (funas_trs_list s_ns_nst) i))
         (create_lpoly_repr c i)
         (if plus_single_mono c then convert_lpoly_complexity c pi
           else (\ _ ->
                  Inl (shows_prec_list Zero_nat
                        ['c', 'o', 'm', 'p', 'l', 'e', 'x', 'i', 't', 'y', ' ',
                          'a', 'n', 'a', 'l', 'y', 's', 'i', 's', ' ', 'u', 'n',
                          's', 'u', 'p', 'p', 'o', 'r', 't', 'e', 'd'])))
         ();

instance Non_strict_order Int where {
};

instance Ordered_ab_semigroup Int where {
};

instance Ordered_semiring_0 Int where {
};

instance Ordered_semiring_1 Int where {
};

weak_gt_arctic_delta ::
  forall a. (Floor_ceiling a) => Arctic_delta a -> Arctic_delta a -> Bool;
weak_gt_arctic_delta uu MinInfty_delta = True;
weak_gt_arctic_delta MinInfty_delta (Num_arc_delta uv) = False;
weak_gt_arctic_delta (Num_arc_delta x) (Num_arc_delta y) = less y x;

cEnum_mini_alg_number ::
  Maybe ([Mini_alg_number],
          ((Mini_alg_number -> Bool) -> Bool,
            (Mini_alg_number -> Bool) -> Bool));
cEnum_mini_alg_number = Nothing;

instance Cenum Mini_alg_number where {
  cEnum = cEnum_mini_alg_number;
};

check_poly_strict_mono_discrete ::
  forall a b.
    (Eq a, Poly_carrier a,
      Eq b) => (a -> a -> Bool) -> [([(b, Nat)], a)] -> b -> Bool;
check_poly_strict_mono_discrete gt p v =
  check_poly_gt gt
    (poly_subst
      (\ w -> poly_of (if w == v then PSum [PNum onea, PVar v] else PVar w)) p)
    p;

check_monom_strict_mono :: forall a. (Eq a) => Bool -> [(a, Nat)] -> a -> Bool;
check_monom_strict_mono pm m v =
  not (null m) &&
    null (tl m) &&
      fst (hd m) == v &&
        (if pm then less_eq_nat (Nat_of_num One) (snd (hd m))
          else equal_nat (snd (hd m)) (Nat_of_num One));

check_poly_strict_mono ::
  forall a b. (Eq a, Poly_carrier b) => Bool -> [([(a, Nat)], b)] -> a -> Bool;
check_poly_strict_mono pm p v =
  any (\ (m, c) -> less_eq onea c && check_monom_strict_mono pm m v) p;

check_poly_strict_mono_smart ::
  forall a b.
    (Eq a, Poly_carrier a,
      Eq b) => Bool ->
                 Bool -> (a -> a -> Bool) -> [([(b, Nat)], a)] -> b -> Bool;
check_poly_strict_mono_smart discrete pm gt p v =
  (if discrete then check_poly_strict_mono_discrete gt p v
    else check_poly_strict_mono pm p v);

check_poly_weak_mono_all ::
  forall a b. (Ordered_semiring_0 b) => [([(a, Nat)], b)] -> Bool;
check_poly_weak_mono_all p = all (\ (_, a) -> less_eq zeroa a) p;

check_poly_weak_mono_and_pos ::
  forall a b. (Eq a, Eq b, Poly_carrier b) => Bool -> [([(a, Nat)], b)] -> Bool;
check_poly_weak_mono_and_pos discrete p =
  (if discrete
    then all (check_poly_weak_mono_discrete p) (poly_vars_list p) &&
           less_eq zeroa (eval_poly (\ _ -> zeroa) p)
    else check_poly_weak_mono_all p);

check_poly_inter_list ::
  forall a b.
    (Eq b,
      Poly_carrier b) => Bool ->
                           [((a, Nat), [([(Nat, Nat)], b)])] ->
                             Sum (a, [([(Nat, Nat)], b)]) ();
check_poly_inter_list discrete i =
  catcha
    (catcha
      (forallM
        (\ x ->
          (if let {
                (_, a) = x;
              } in check_poly_weak_mono_and_pos discrete a
            then Inr () else Inl x))
        i)
      (\ x -> Inl (snd x)))
    (\ x ->
      Inl (let {
             (a, b) = x;
           } in let {
                  (f, _) = a;
                } in (\ aa -> (f, aa))
                  b));

strongly_linear ::
  forall a. (Poly_carrier a) => Nat -> [([(Nat, Nat)], a)] -> a -> Bool;
strongly_linear x p v =
  (if equal_nat x Zero_nat then check_ge_v v p
    else let {
           (a, pa) =
             poly_split
               [(minus_nat x (Nat_of_num One),
                  plus_nat Zero_nat (Nat_of_num One))]
               p;
         } in less_eq a onea &&
                strongly_linear (minus_nat x (Nat_of_num One)) pa v);

sl_complexity_sig_check ::
  forall a b.
    (Poly_carrier b) => ((a, Nat) -> [([(Nat, Nat)], b)]) ->
                          b -> [(a, Nat)] -> Sum (a, Nat) ();
sl_complexity_sig_check i v f =
  catcha
    (forallM (\ (fa, n) -> check (strongly_linear n (i (fa, n)) v) (fa, n)) f)
    (\ x -> Inl (snd x));

sl_complexity_check ::
  forall a b.
    (Poly_carrier a,
      Showa b) => a -> ((b, Nat) -> [([(Nat, Nat)], a)]) ->
                         [(b, Nat)] ->
                           Sum ([Prelude.Char] -> [Prelude.Char]) ();
sl_complexity_check v i f =
  let {
    w = max_v v i f;
  } in catcha (sl_complexity_sig_check i w f)
         (\ x ->
           Inl (let {
                  (fa, _) = x;
                } in shows_string ['s', 'y', 'm', 'b', 'o', 'l', ' '] .
                       shows_prec Zero_nat fa .
                         shows_prec_list Zero_nat
                           [' ', 'd', 'o', 'e', 's', ' ', 'n', 'o', 't', ' ',
                             'p', 'o', 's', 's', 'e', 's', 's', ' ', 'a', ' ',
                             's', 't', 'r', 'o', 'n', 'g', 'l', 'y', ' ', 'l',
                             'i', 'n', 'e', 'a', 'r', ' ', 'i', 'n', 't', 'e',
                             'r', 'p', 'r', 'e', 't', 'a', 't', 'i', 'o',
                             'n']));

nl_complexity_check ::
  forall a b c.
    (Showa a,
      Poly_carrier b) => ((a, Nat) -> [([(Nat, Nat)], b)]) ->
                           Complexity_measure a c ->
                             Sum ([Prelude.Char] -> [Prelude.Char])
                               Complexity_class;
nl_complexity_check i (Derivational_Complexity f) =
  bindb (sl_complexity_check zeroa i f)
    (\ _ -> Inr (Comp_Poly (Nat_of_num One)));
nl_complexity_check i (Runtime_Complexity c d) =
  bindb (sl_complexity_check onea i c)
    (\ _ ->
      let {
        deg = max_list (map (\ f -> poly_degree (i f)) d);
      } in Inr (Comp_Poly deg));

poly_inter_to_af ::
  forall a b. ((a, Nat) -> [([(Nat, Nat)], b)]) -> (a, Nat) -> Nat -> Bool;
poly_inter_to_af i fn = (\ ia -> member ia (poly_vars (i fn)));

create_nlpoly_redtriple ::
  forall a b c.
    (Eq a, Poly_carrier a, Showa a, Eq b, Key b, Showa b, Eq c,
      Showa c) => Sum ([Prelude.Char] -> [Prelude.Char]) () ->
                    a -> (a -> a -> Bool) ->
                           Bool ->
                             Bool ->
                               [((b, Nat), [([(Nat, Nat)], a)])] ->
                                 Redtriple_ext b c ();
create_nlpoly_redtriple cI def gt power_mono discrete i =
  let {
    j = poly_inter_list_to_inter def i;
    x = poly_subst
          (\ n -> poly_of (PVar (['x', '_'] ++ shows_prec_nat Zero_nat n [])));
  } in Redtriple_ext
         (bindb cI
           (\ _ ->
             catcha (check_poly_inter_list discrete i)
               (\ xa ->
                 Inl (let {
                        (f, p) = xa;
                      } in shows_string
                             ['i', 'n', 't', 'e', 'r', 'p', 'r', 'e', 't', 'a',
                               't', 'i', 'o', 'n', ' '] .
                             shows_poly (x p) .
                               shows_string [' ', 'o', 'f', ' '] .
                                 shows_prec Zero_nat f .
                                   shows_string
                                     [' ', 'i', 'n', 'v', 'a', 'l', 'i', 'd',
                                       ' ']))))
         (check_s gt j) (check_ns j) (check_ns j) (poly_inter_to_af j)
         (\ _ ->
           catcha
             (catcha
               (forallM
                 (\ xa ->
                   (if let {
                         (a, b) = xa;
                       } in let {
                              (_, n) = a;
                            } in (\ p ->
                                   all_interval_nat
                                     (check_poly_strict_mono_smart discrete
                                       power_mono gt p)
                                     Zero_nat n)
                              b
                     then Inr () else Inl xa))
                 i)
               (\ xa -> Inl (snd xa)))
             (\ xa ->
               Inl (let {
                      (a, b) = xa;
                    } in let {
                           (f, _) = a;
                         } in (\ p ->
                                shows_string
                                  ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't',
                                    ' ', 'e', 'n', 's', 'u', 'r', 'e', ' ', 'm',
                                    'o', 'n', 'o', 't', 'o', 'n', 'i', 'c', 't',
                                    'y', ' ', 'o', 'f', ' '] .
                                  shows_poly (x p) .
                                    shows_string
                                      [' ', 'a', 's', ' ', 'i', 'n', 't', 'e',
'r', 'p', 'r', 'e', 't', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f', ' '] .
                                      shows_prec Zero_nat f)
                           b)))
         (shows_string
            ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'i', 'n',
              't', 'e', 'r', 'p', 'r', 'e', 't', 'a', 't', 'i', 'o', 'n'] .
           shows_nl .
             shows_sep
               (\ (a, b) ->
                 let {
                   (f, n) = a;
                 } in (\ p ->
                        shows_string ['P', 'o', 'l', '('] .
                          shows_prec Zero_nat f .
                            shows_string ['/'] .
                              shows_prec_nat Zero_nat n .
                                shows_string [')', ' ', '=', ' '] .
                                  shows_poly (x p))
                   b)
               shows_nl i)
         (nl_complexity_check j) ();

pos_arctic_delta :: forall a. (Floor_ceiling a) => Arctic_delta a -> Bool;
pos_arctic_delta MinInfty_delta = False;
pos_arctic_delta (Num_arc_delta n) = less_eq zeroa n;

class_ordered_semiring ::
  forall a b.
    (Ceq a, Corder a, Ordered_semiring_1 a,
      Set_impla a) => Itself a ->
                        (a -> a -> Bool) ->
                          b -> Partial_object_ext a
                                 (Monoid_ext a
                                   (Ring_ext a (Ordered_semiring_ext a b)));
class_ordered_semiring a gt b =
  class_semiring a (Ordered_semiring_ext (\ x y -> less_eq y x) gt max b);

class_arc_complexity ::
  forall a. a -> Sum ([Prelude.Char] -> [Prelude.Char]) Nat;
class_arc_complexity a =
  Inl (shows_prec_list Zero_nat
        ['c', 'o', 'm', 'p', 'l', 'e', 'x', 'i', 't', 'y', ' ', 'f', 'o', 'r',
          ' ', 'a', 'r', 'c', 't', 'i', 'c', ' ', 's', 'e', 'm', 'i', 'r', 'i',
          'n', 'g', 's', ' ', 'n', 'o', 't', ' ', 's', 'u', 'p', 'p', 'o', 'r',
          't', 'e', 'd']);

class_arc_lpoly_order ::
  forall a.
    (Ceq a, Corder a, Ordered_semiring_1 a,
      Set_impla a) => a -> (a -> Bool) ->
                             (a -> a -> Bool) ->
                               Partial_object_ext a
                                 (Monoid_ext a
                                   (Ring_ext a
                                     (Ordered_semiring_ext a
                                       (Lpoly_order_semiring_ext a ()))));
class_arc_lpoly_order def apos gt =
  class_ordered_semiring Type gt
    (Lpoly_order_semiring_ext False def apos (\ _ -> False) (\ _ -> Zero_nat)
      class_arc_complexity
      ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'i', 'n', 't',
        'e', 'r', 'p', 'r', 'e', 't', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'v',
        'e', 'r', ' ', 'a', 'r', 'c', 't', 'i', 'c', ' ', 's', 'e', 'm', 'i',
        'r', 'i', 'n', 'g']
      ());

cEnum_arctic_delta ::
  forall a.
    Maybe ([Arctic_delta a],
            ((Arctic_delta a -> Bool) -> Bool,
              (Arctic_delta a -> Bool) -> Bool));
cEnum_arctic_delta = Nothing;

instance Cenum (Arctic_delta a) where {
  cEnum = cEnum_arctic_delta;
};

instance Poly_carrier Int where {
};

vec_comp_all :: forall a. (a -> a -> Bool) -> [a] -> [a] -> Bool;
vec_comp_all r v w = all (\ (a, b) -> r a b) (zip v w);

mat_comp_all :: forall a. (a -> a -> Bool) -> [[a]] -> [[a]] -> Bool;
mat_comp_all r m1 m2 = all (\ (a, b) -> vec_comp_all r a b) (zip m1 m2);

mat_ge :: forall a. (Non_strict_order a) => [[a]] -> [[a]] -> Bool;
mat_ge = mat_comp_all (\ x y -> less_eq y x);

mat_both_ordered_semiring ::
  forall a b.
    (Ordered_semiring_1 a) => Nat ->
                                (a -> a -> Bool) ->
                                  b -> Partial_object_ext [[a]]
 (Monoid_ext [[a]] (Ring_ext [[a]] (Ordered_semiring_ext [[a]] b)));
mat_both_ordered_semiring n gt b =
  mat_ring n (Ordered_semiring_ext mat_ge (mat_comp_all gt) (mat_plusI max) b);

mat_arc_complexity :: forall a. a -> Sum ([Prelude.Char] -> [Prelude.Char]) Nat;
mat_arc_complexity m =
  Inl (shows_prec_list Zero_nat
        ['c', 'o', 'm', 'p', 'l', 'e', 'x', 'i', 't', 'y', ' ', 'f', 'o', 'r',
          ' ', 'a', 'r', 'c', 't', 'i', 'c', ' ', 'm', 'a', 't', 'r', 'i', 'c',
          'e', 's', ' ', 'n', 'o', 't', ' ', 's', 'u', 'p', 'p', 'o', 'r', 't',
          'e', 'd']);

mat_arc_posI :: forall a. (a -> Bool) -> [[a]] -> Bool;
mat_arc_posI ap m = ap (nth (nth m Zero_nat) Zero_nat);

mat_arc_lpoly_order ::
  forall a.
    (Ordered_semiring_1 a) => Nat ->
                                a -> (a -> Bool) ->
                                       (a -> a -> Bool) ->
 Partial_object_ext [[a]]
   (Monoid_ext [[a]]
     (Ring_ext [[a]]
       (Ordered_semiring_ext [[a]] (Lpoly_order_semiring_ext [[a]] ()))));
mat_arc_lpoly_order n def apos gt =
  mat_both_ordered_semiring n gt
    (Lpoly_order_semiring_ext False (mat1I zeroa def n) (mat_arc_posI apos)
      (\ _ -> False) (\ _ -> Zero_nat) mat_arc_complexity
      ['a', 'r', 'c', 't', 'i', 'c', ' ', 'm', 'a', 't', 'r', 'i', 'x', ' ',
        'i', 'n', 't', 'e', 'r', 'p', 'r', 'e', 't', 'a', 't', 'i', 'o', 'n']
      ());

check_arc_dimension :: Nat -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_arc_dimension n =
  check (less_nat Zero_nat n)
    (shows_prec_list Zero_nat
      ['d', 'i', 'm', 'e', 'n', 's', 'i', 'o', 'n', ' ', 'm', 'u', 's', 't',
        ' ', 'b', 'e', ' ', 'a', 't', ' ', 'l', 'e', 'a', 's', 't', ' ', '1']);

default_af_entry :: Nat -> Af_entry;
default_af_entry n = AFList (upt Zero_nat n);

afs_list_to_afs ::
  forall a. (Eq a, Key a) => [((a, Nat), Af_entry)] -> (a, Nat) -> Af_entry;
afs_list_to_afs pi =
  fun_of_map_fun (ceta_map_of pi) (\ fn -> default_af_entry (snd fn));

class_complexity ::
  forall a.
    (Ordered_semiring_1 a) => a -> Sum ([Prelude.Char] -> [Prelude.Char]) Nat;
class_complexity a =
  (if less_eq a onea then Inr Zero_nat
    else Inl (shows_prec_list Zero_nat
               ['v', 'a', 'l', 'u', 'e', ' ', 'i', 's', ' ', 'l', 'a', 'r', 'g',
                 'e', 'r', ' ', 't', 'h', 'a', 'n', ' ', '1']));

class_lpoly_order ::
  forall a.
    (Ceq a, Corder a, Ordered_semiring_1 a,
      Set_impla a) => a -> (a -> Bool) ->
                             (a -> a -> Bool) ->
                               Partial_object_ext a
                                 (Monoid_ext a
                                   (Ring_ext a
                                     (Ordered_semiring_ext a
                                       (Lpoly_order_semiring_ext a ()))));
class_lpoly_order def mon gt =
  class_ordered_semiring Type gt
    (Lpoly_order_semiring_ext True def (\ _ -> True) mon (\ _ -> Zero_nat)
      class_complexity
      ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'i', 'n', 't',
        'e', 'r', 'p', 'r', 'e', 't', 'a', 't', 'i', 'o', 'n']
      ());

scf_repr_to_scf ::
  forall a. ((a, Nat) -> Maybe [Nat]) -> (a, Nat) -> Nat -> Nat;
scf_repr_to_scf scf fn i =
  (case scf fn of {
    Nothing -> Nat_of_num One;
    Just xs -> nth xs i;
  });

check_scf_entry ::
  forall a.
    (Showa a) => (a, Nat) ->
                   Maybe [Nat] -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_scf_entry fn Nothing = Inr ();
check_scf_entry (f, n) (Just es) =
  catcha
    (bindb
      (check (equal_nat (size_list es) n)
        (shows_prec_list Zero_nat
           ['n', 'r', ' ', 'o', 'f', ' ', 'e', 'n', 't', 'r', 'i', 'e', 's',
             ' ', 's', 'h', 'o', 'u', 'l', 'd', ' ', 'b', 'e', ' '] .
          shows_prec_nat Zero_nat n))
      (\ _ ->
        check (all (less_nat Zero_nat) es)
          (shows_prec_list Zero_nat
            ['a', 'l', 'l', ' ', 'e', 'n', 't', 'r', 'i', 'e', 's', ' ', 'm',
              'u', 's', 't', ' ', 'b', 'e', ' ', 'n', 'o', 'n', '-', 'z', 'e',
              'r', 'o'])))
    (\ x ->
      Inl (shows_prec_list Zero_nat
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'i', 't', 'h', ' ',
               's', 'u', 'b', 't', 'e', 'r', 'm', ' ', 'c', 'o', 'e', 'f', 'f',
               'i', 'c', 'i', 'e', 'n', 't', 's', ' ', 'f', 'o', 'r', ' '] .
            shows_prec_prod Zero_nat (f, n) .
              shows_prec_list Zero_nat [':', ' '] . x . shows_nl));

prec_weight_repr_to_prec_weight ::
  forall a.
    (Eq a, Key a,
      Showa a) => ([((a, Nat), (Nat, (Nat, Maybe [Nat])))], Nat) ->
                    (Sum ([Prelude.Char] -> [Prelude.Char]) (),
                      ((a, Nat) -> Nat,
                        ((a, Nat) -> Nat,
                          (Nat, (a -> Bool, (a, Nat) -> Nat -> Nat)))));
prec_weight_repr_to_prec_weight prw_w0 =
  let {
    (prw, w0) = prw_w0;
    prwm = ceta_map_of prw;
    w_fun =
      fun_of_map_funa prwm (\ _ -> plus_nat w0 (Nat_of_num One)) (fst . snd);
    p_fun = fun_of_map_funa prwm (\ _ -> Zero_nat) fst;
    scf_fun = fun_of_map_funa prwm (\ _ -> Nothing) (snd . snd);
    fs = map fst prw;
    p_max = max_list (map p_fun fs);
    cw_okay =
      catcha
        (forallM
          (\ fn ->
            check (if equal_nat (snd fn) Zero_nat then less_eq_nat w0 (w_fun fn)
                    else True)
              (shows_prec_list Zero_nat
                 ['w', 'e', 'i', 'g', 'h', 't', ' ', 'o', 'f', ' ', 'c', 'o',
                   'n', 's', 't', 'a', 'n', 't', ' '] .
                shows_prec Zero_nat (fst fn) .
                  shows_prec_list Zero_nat
                    [' ', 'm', 'u', 's', 't', ' ', 'b', 'e', ' ', 'a', 't', ' ',
                      'l', 'e', 'a', 's', 't', ' ', 'w', '0']))
          (map fst prw))
        (\ x -> Inl (snd x));
    adm = catcha
            (forallM
              (\ fn ->
                check (if equal_nat (snd fn) (Nat_of_num One)
                        then (if equal_nat (w_fun fn) Zero_nat
                               then equal_nat (p_fun fn) p_max else True)
                        else True)
                  (shows_prec_list Zero_nat
                     ['u', 'n', 'a', 'r', 'y', ' ', 's', 'y', 'm', 'b', 'o',
                       'l', ' '] .
                    shows_prec Zero_nat (fst fn) .
                      shows_prec_list Zero_nat
                        [' ', 'w', 'i', 't', 'h', ' ', 'w', 'e', 'i', 'g', 'h',
                          't', ' ', '0', ' ', 'd', 'o', 'e', 's', ' ', 'n', 'o',
                          't', ' ', 'h', 'a', 'v', 'e', ' ', 'm', 'a', 'x', 'i',
                          'm', 'a', 'l', ' ', 'p', 'r', 'e', 'c', 'e', 'd', 'e',
                          'n', 'c', 'e']))
              (map fst prw))
            (\ x -> Inl (snd x));
    scf_ok =
      catcha (forallM (\ fn -> check_scf_entry fn (scf_fun fn)) (map fst prw))
        (\ x -> Inl (snd x));
    cs = map_filter
           (\ x ->
             (if equal_nat (snd x) Zero_nat && equal_nat (w_fun x) w0
               then Just (fst x) else Nothing))
           fs;
    p_min = min_list (map (\ c -> p_fun (c, Zero_nat)) cs);
    lcs = filter (\ c -> equal_nat (p_fun (c, Zero_nat)) p_min) cs;
    least = membera lcs;
    ok = bindb (check (less_nat Zero_nat w0)
                 (shows_prec_list Zero_nat
                   ['w', '0', ' ', 'm', 'u', 's', 't', ' ', 'b', 'e', ' ', 'l',
                     'a', 'r', 'g', 'e', 'r', ' ', 't', 'h', 'a', 'n', ' ',
                     '0']))
           (\ _ -> bindb adm (\ _ -> bindb cw_okay (\ _ -> scf_ok)));
  } in (ok, (p_fun, (w_fun, (w0, (least, scf_repr_to_scf scf_fun)))));

create_KBO_redtriple ::
  forall a b c.
    (Showa a, Eq b, Key b, Showa b, Eq c,
      Showa c) => (([((a, Nat), (Nat, (Nat, Maybe [Nat])))], Nat) ->
                    ([((b, Nat), (Nat, (Nat, Maybe [Nat])))], Nat)) ->
                    ([((a, Nat), (Nat, (Nat, Maybe [Nat])))], Nat) ->
                      Redtriple_ext b c ();
create_KBO_redtriple f_to_g pr =
  let {
    (ch, (p, (w, (w0, (least, scf))))) =
      prec_weight_repr_to_prec_weight (f_to_g pr);
    ns = kbo_nstrict p w w0 least scf;
    s = kbo_strict p w w0 least scf;
  } in Redtriple_ext ch s ns ns full_af (\ _ -> Inr ()) (shows_kbo_repr pr)
         (\ _ ->
           Inl (shows_prec_list Zero_nat
                 ['c', 'o', 'm', 'p', 'l', 'e', 'x', 'i', 't', 'y', ' ', 'a',
                   'n', 'a', 'l', 'y', 's', 'i', 's', ' ', 'u', 'n', 's', 'u',
                   'p', 'p', 'o', 'r', 't', 'e', 'd']))
         ();

equal_filtered :: forall a. (Eq a) => Filtered a -> Filtered a -> Bool;
equal_filtered (FPair fa nata) (FPair f nat) = fa == f && equal_nat nata nat;

instance (Eq a) => Eq (Filtered a) where {
  a == b = equal_filtered a b;
};

shows_arctic_delta ::
  forall a. (Showa a) => Arctic_delta a -> [Prelude.Char] -> [Prelude.Char];
shows_arctic_delta (Num_arc_delta i) = shows_prec Zero_nat i;
shows_arctic_delta MinInfty_delta = shows_string ['-', 'i', 'n', 'f'];

shows_prec_arctic_delta ::
  forall a.
    (Showa a) => Nat -> Arctic_delta a -> [Prelude.Char] -> [Prelude.Char];
shows_prec_arctic_delta d ari = shows_arctic_delta ari;

shows_list_arctic_delta ::
  forall a. (Showa a) => [Arctic_delta a] -> [Prelude.Char] -> [Prelude.Char];
shows_list_arctic_delta = shows_list_aux (shows_prec_arctic_delta Zero_nat);

instance (Showa a) => Showa (Arctic_delta a) where {
  shows_prec = shows_prec_arctic_delta;
  shows_list = shows_list_arctic_delta;
};

check_dimensions ::
  Nat ->
    Nat ->
      Sum ([Prelude.Char] -> [Prelude.Char]) () ->
        Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_dimensions n sd c =
  bindb c
    (\ _ ->
      check (less_eq_nat sd n && less_nat Zero_nat sd)
        (shows_prec_list Zero_nat
          ['s', 't', 'r', 'i', 'c', 't', ' ', 'd', 'i', 'm', 'e', 'n', 's', 'i',
            'o', 'n', ' ', 'm', 'u', 's', 't', ' ', 'b', 'e', ' ', 'a', 't',
            ' ', 'l', 'e', 'a', 's', 't', ' ', '1', ' ', 'a', 'n', 'd', ' ',
            'l', 'e', 's', 's', ' ', 't', 'h', 'a', 'n', ' ', 't', 'o', 't',
            'a', 'l', ' ', 'd', 'i', 'm', 'e', 'n', 's', 'i', 'o', 'n']));

filtered_fun :: forall a. Filtered a -> a;
filtered_fun (FPair f n) = f;

shows_prec_filtered ::
  forall a. (Showa a) => Nat -> Filtered a -> [Prelude.Char] -> [Prelude.Char];
shows_prec_filtered d ff = shows_prec Zero_nat (filtered_fun ff);

shows_list_filtered ::
  forall a. (Showa a) => [Filtered a] -> [Prelude.Char] -> [Prelude.Char];
shows_list_filtered = shows_list_aux (shows_prec_filtered Zero_nat);

instance (Showa a) => Showa (Filtered a) where {
  shows_prec = shows_prec_filtered;
  shows_list = shows_list_filtered;
};

check_mono_afs_help ::
  forall a b c. (Showa a) => ((a, b), c) -> [Prelude.Char] -> [Prelude.Char];
check_mono_afs_help ((f, a), e) =
  shows_string ['e', 'n', 't', 'r', 'y', ' ', 'f', 'o', 'r', ' '] .
    shows_prec Zero_nat f .
      shows_string
        [' ', 'n', 'o', 't', ' ', 'm', 'o', 'n', 'o', 't', 'o', 'n', 'i', 'c'] .
        shows_nl;

mono_af_entry :: Nat -> Af_entry -> Bool;
mono_af_entry n (Collapse i) = less_eq_nat n (Nat_of_num One);
mono_af_entry n (AFList ids) = all_interval_nat (membera ids) Zero_nat n;

check_mono_afs ::
  forall a.
    (Showa a) => [((a, Nat), Af_entry)] ->
                   Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_mono_afs pi =
  catcha
    (catcha
      (forallM
        (\ x -> (if mono_af_entry (snd (fst x)) (snd x) then Inr () else Inl x))
        pi)
      (\ x -> Inl (snd x)))
    (\ x -> Inl (check_mono_afs_help x));

afs_list_to_af ::
  forall a. (Eq a, Key a) => [((a, Nat), Af_entry)] -> (a, Nat) -> Nat -> Bool;
afs_list_to_af pi =
  fun_of_map_funa (ceta_map_of pi) (\ _ _ -> True)
    (\ a ->
      (case a of {
        Collapse aa -> equal_nat aa;
        AFList aa -> membera aa;
      }));

check_wf_afs ::
  forall a.
    (Showa a) => [((a, Nat), Af_entry)] ->
                   Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_wf_afs pi =
  catcha
    (forallM
      (\ (a, b) ->
        let {
          (f, n) = a;
        } in (\ e ->
               catcha
                 (case e of {
                   Collapse i -> check (less_nat i n) i;
                   AFList ids ->
                     catcha
                       (forallM
                         (\ x -> (if less_nat x n then Inr () else Inl x)) ids)
                       (\ x -> Inl (snd x));
                 })
                 (\ x ->
                   Inl (shows_string ['i', 'n', 'd', 'e', 'x', ' '] .
                         shows_prec_nat Zero_nat x .
                           shows_string
                             [' ', 't', 'o', 'o', ' ', 'h', 'i', 'g', 'h', ' ',
                               'f', 'o', 'r', ' ', 'A', 'F', '-', 'e', 'n', 't',
                               'r', 'y', ' ', 'o', 'f'] .
                             shows_prec_prod Zero_nat (f, n) . shows_nl)))
          b)
      pi)
    (\ x -> Inl (snd x));

shows_afs ::
  forall a.
    (Showa a) => [((a, Nat), Af_entry)] -> [Prelude.Char] -> [Prelude.Char];
shows_afs af =
  shows_map
    (\ (a, b) ->
      let {
        (f, n) = a;
      } in (\ e ->
             shows_string ['p', 'i', '('] .
               shows_prec Zero_nat f .
                 shows_string ['/'] .
                   shows_prec_nat Zero_nat n .
                     shows_string [')', ' ', '=', ' '] .
                       (case e of {
                         Collapse i ->
                           shows_prec_nat Zero_nat
                             (plus_nat i (Nat_of_num One));
                         AFList ids -> shows_prec_list Zero_nat (map suc ids);
                       }) .
                         shows_nl)
        b)
    af;

afs_check ::
  forall a b.
    (Showa a,
      Showa b) => ([Prelude.Char] -> [Prelude.Char]) ->
                    ((a, Nat) -> Af_entry) ->
                      ((Term (Filtered a) b, Term (Filtered a) b) ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                        (Term a b, Term a b) ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ();
afs_check r pi g lr =
  let {
    pl = afs_term pi (fst lr);
    pr = afs_term pi (snd lr);
  } in catcha (g (pl, pr))
         (\ x ->
           Inl (shows_string
                  ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'o', 'r',
                    'i', 'e', 'n', 't', ' '] .
                 shows_prec_term Zero_nat (fst lr) .
                   shows_string [' '] .
                     r . shows_string [' '] .
                           shows_prec_term Zero_nat (snd lr) .
                             shows_nl .
                               shows_string ['p', 'i', '(', ' '] .
                                 shows_prec_term Zero_nat (fst lr) .
                                   shows_string [' ', ')', ' ', '=', ' '] .
                                     shows_prec_term Zero_nat pl .
                                       shows_nl .
 shows_string ['p', 'i', '(', ' '] .
   shows_prec_term Zero_nat (snd lr) .
     shows_string [' ', ')', ' ', '=', ' '] .
       shows_prec_term Zero_nat pr . shows_nl . x));

af_redtriple ::
  forall a b.
    (Eq a, Key a, Showa a,
      Showa b) => [((a, Nat), Af_entry)] ->
                    Redtriple_ext (Filtered a) b () -> Redtriple_ext a b ();
af_redtriple pi rp =
  let {
    af = afs_list_to_af pi;
    afs = afs_list_to_afs pi;
  } in Redtriple_ext (bindb (check_wf_afs pi) (\ _ -> valid rp))
         (afs_check (shows_string ['>']) afs (s rp))
         (afs_check (shows_string ['>', '=']) afs (ns rp))
         (afs_check (shows_string ['>', '=']) afs (nst rp)) af
         (\ cs ->
           bindb (check_mono_afs pi) (\ _ -> mono rp (map (afs_rule afs) cs)))
         (shows_string
            ['A', 'r', 'g', 'u', 'm', 'e', 'n', 't', ' ', 'F', 'i', 'l', 't',
              'e', 'r', ':', ' '] .
           shows_nl . shows_afs pi . shows_nl . desca rp)
         (\ _ ->
           Inl (shows_prec_list Zero_nat
                 ['c', 'o', 'm', 'p', 'l', 'e', 'x', 'i', 't', 'y', ' ', 'a',
                   'n', 'a', 'l', 'y', 's', 'i', 's', ' ', 'u', 'n', 's', 'u',
                   'p', 'p', 'o', 'r', 't', 'e', 'd']))
         ();

pos_arctic :: Arctic -> Bool;
pos_arctic MinInfty = False;
pos_arctic (Num_arc n) = less_eq_int Zero_int n;

delta_mono :: forall a. (Floor_ceiling a) => a -> Bool;
delta_mono x = less_eq onea x;

vec_pre_gtI :: forall a. (a -> a -> Bool) -> [a] -> [a] -> Bool;
vec_pre_gtI gt v w = any (\ (a, b) -> gt a b) (zip v w);

mat_pre_gtI :: forall a. (a -> a -> Bool) -> [[a]] -> [[a]] -> Bool;
mat_pre_gtI gt m1 m2 = any (\ (a, b) -> vec_pre_gtI gt a b) (zip m1 m2);

mat_gtI ::
  forall a.
    (Non_strict_order a) => (a -> a -> Bool) -> Nat -> [[a]] -> [[a]] -> Bool;
mat_gtI gt sd m1 m2 =
  mat_ge m1 m2 && mat_pre_gtI gt (sub_mat sd sd m1) (sub_mat sd sd m2);

mat_ordered_semiring ::
  forall a b.
    (Ordered_semiring_1 a) => Nat ->
                                Nat ->
                                  (a -> a -> Bool) ->
                                    b -> Partial_object_ext [[a]]
   (Monoid_ext [[a]] (Ring_ext [[a]] (Ordered_semiring_ext [[a]] b)));
mat_ordered_semiring n sd gt b =
  mat_ring n (Ordered_semiring_ext mat_ge (mat_gtI gt sd) (mat_plusI max) b);

mat_monoI :: forall a. (a -> Bool) -> Nat -> [[a]] -> Bool;
mat_monoI geq1 sd m = all (any geq1) (sub_mat sd sd m);

upper_triangular :: forall a. (One a, Zero a, Eq a, Ord a) => [[a]] -> Bool;
upper_triangular [] = True;
upper_triangular ((a : asa) : m) =
  less_eq a onea && all (\ b -> b == zeroa) asa && upper_triangular (map tl m);
upper_triangular ([] : m) = False;

mat_complexity ::
  forall a.
    (Eq a,
      Ordered_semiring_1 a) => Nat ->
                                 [[a]] ->
                                   Sum ([Prelude.Char] -> [Prelude.Char]) Nat;
mat_complexity n m =
  (if upper_triangular m then Inr (minus_nat n (Nat_of_num One))
    else Inl (shows_prec_list Zero_nat
               ['m', 'a', 't', 'r', 'i', 'x', ' ', 'i', 's', ' ', 'n', 'o', 't',
                 ' ', 'u', 'p', 'p', 'e', 'r', ' ', 't', 'r', 'i', 'a', 'n',
                 'g', 'u', 'l', 'a', 'r']));

mat_lpoly_order ::
  forall a.
    (Eq a,
      Ordered_semiring_1 a) => Nat ->
                                 Nat ->
                                   a -> (a -> Bool) ->
  (a -> a -> Bool) ->
    Partial_object_ext [[a]]
      (Monoid_ext [[a]]
        (Ring_ext [[a]]
          (Ordered_semiring_ext [[a]] (Lpoly_order_semiring_ext [[a]] ()))));
mat_lpoly_order n sd def mon gt =
  mat_ordered_semiring n sd gt
    (Lpoly_order_semiring_ext True (mat1I zeroa def n) (\ _ -> True)
      (mat_monoI mon sd) (\ _ -> Zero_nat) (mat_complexity n)
      ['m', 'a', 't', 'r', 'i', 'x', ' ', 'i', 'n', 't', 'e', 'r', 'p', 'r',
        'e', 't', 'a', 't', 'i', 'o', 'n']
      ());

cEnum_arctic ::
  Maybe ([Arctic], ((Arctic -> Bool) -> Bool, (Arctic -> Bool) -> Bool));
cEnum_arctic = Nothing;

instance Cenum Arctic where {
  cEnum = cEnum_arctic;
};

filtered_rec :: forall a b. (a -> Nat -> b) -> Filtered a -> b;
filtered_rec f1 (FPair f nat) = f1 f nat;

less_eq_filtered :: forall a. (Eq a, Ord a) => Filtered a -> Filtered a -> Bool;
less_eq_filtered =
  (\ x y ->
    filtered_rec
      (\ x_0 x_1 (FPair y_0 y_1) ->
        less x_0 y_0 || x_0 == y_0 && less_nat x_1 y_1)
      x y ||
      equal_filtered x y);

less_filtered :: forall a. (Eq a, Ord a) => Filtered a -> Filtered a -> Bool;
less_filtered =
  filtered_rec
    (\ x_0 x_1 (FPair y_0 y_1) ->
      less x_0 y_0 || x_0 == y_0 && less_nat x_1 y_1);

instance (Eq a, Ord a) => Ord (Filtered a) where {
  less_eq = less_eq_filtered;
  less = less_filtered;
};

instance (Eq a, Order a) => Preorder (Filtered a) where {
};

instance (Eq a, Order a) => Order (Filtered a) where {
};

instance (Eq a, Linorder a) => Linorder (Filtered a) where {
};

instance (Eq a, Key a) => Key (Filtered a) where {
};

int_mono :: Int -> Bool;
int_mono x = less_eq_int (Pos One) x;

delta_gt :: forall a. (Floor_ceiling a) => a -> a -> a -> Bool;
delta_gt delta = (\ x y -> less_eq delta (minus x y));

check_def_pos ::
  forall a. (Zero a, Ord a) => a -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_def_pos d =
  check (less zeroa d)
    (shows_prec_list Zero_nat
      ['d', 'e', 'f', 'a', 'u', 'l', 't', ' ', 'v', 'a', 'l', 'u', 'e', ' ',
        'm', 'u', 's', 't', ' ', 'b', 'e', ' ', 'p', 'o', 's', 'i', 't', 'i',
        'v', 'e']);

rpo_nstrict_unbounded ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => (a -> Nat -> a -> Nat -> (Bool, Bool), a -> Bool) ->
                    (a -> Nat -> Order_tag) ->
                      (Term a b, Term a b) ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ();
rpo_nstrict_unbounded pr c =
  (\ (s, t) ->
    check (snd (rpo_unbounded pr c s t))
      (shows_string
         ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'o', 'r', 'i', 'e',
           'n', 't', ' '] .
        shows_prec_term Zero_nat s .
          shows_string [' ', '>', '=', 'R', 'P', 'O', ' '] .
            shows_prec_term Zero_nat t . shows_nl));

rpo_strict_unbounded ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => (a -> Nat -> a -> Nat -> (Bool, Bool), a -> Bool) ->
                    (a -> Nat -> Order_tag) ->
                      (Term a b, Term a b) ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ();
rpo_strict_unbounded pr c =
  (\ (s, t) ->
    check (fst (rpo_unbounded pr c s t))
      (shows_string
         ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'o', 'r', 'i', 'e',
           'n', 't', ' '] .
        shows_prec_term Zero_nat s .
          shows_string [' ', '>', 'R', 'P', 'O', ' '] .
            shows_prec_term Zero_nat t . shows_nl));

create_RPO_redtriple ::
  forall a b c.
    (Showa a, Eq b, Showa b, Eq c,
      Showa c) => ([((a, Nat), (Nat, Order_tag))] ->
                    (b -> Nat -> Nat, b -> Nat -> Order_tag)) ->
                    [((a, Nat), (Nat, Order_tag))] -> Redtriple_ext b c ();
create_RPO_redtriple prec_repr_to_pr pr =
  let {
    (p, tau) = prec_repr_to_pr pr;
    ns = rpo_nstrict_unbounded (prc_nat p, prl_nat p) tau;
  } in Redtriple_ext (Inr ()) (rpo_strict_unbounded (prc_nat p, prl_nat p) tau)
         ns ns full_af (\ _ -> Inr ()) (shows_rpo_repr pr)
         (\ _ ->
           Inl (shows_prec_list Zero_nat
                 ['c', 'o', 'm', 'p', 'l', 'e', 'x', 'i', 't', 'y', ' ', 'a',
                   'n', 'a', 'l', 'y', 's', 'i', 's', ' ', 'u', 'n', 's', 'u',
                   'p', 'p', 'o', 'r', 't', 'e', 'd']))
         ();

cEnum_rat :: Maybe ([Rat], ((Rat -> Bool) -> Bool, (Rat -> Bool) -> Bool));
cEnum_rat = Nothing;

instance Cenum Rat where {
  cEnum = cEnum_rat;
};

cEnum_int :: Maybe ([Int], ((Int -> Bool) -> Bool, (Int -> Bool) -> Bool));
cEnum_int = Nothing;

instance Cenum Int where {
  cEnum = cEnum_int;
};

get_redtriple ::
  forall a b.
    (Eq a, Key a, Showa a, Eq b,
      Showa b) => Redtriple_impl a -> Redtriple_ext a b ();
get_redtriple (Int_carrier i) =
  create_poly_redtriple
    (class_lpoly_order (Pos One) int_mono (\ x y -> less_int y x)) (Inr ()) i;
get_redtriple (Int_nl_carrier i) =
  create_nlpoly_redtriple (Inr ()) (Pos One) (\ x y -> less_int y x) True True
    i;
get_redtriple (Rat_carrier i) =
  create_poly_redtriple
    (class_lpoly_order one_rat delta_mono (\ x y -> less_rat y x))
    (check_def_pos one_rat) i;
get_redtriple (Rat_nl_carrier d i) =
  create_nlpoly_redtriple (check_def_pos d) d (delta_gt d)
    (less_eq_rat one_rat d) False i;
get_redtriple (Mini_alg_carrier i) =
  create_poly_redtriple (class_lpoly_order one_mini_alg_number delta_mono gta)
    (check_def_pos one_mini_alg_number) i;
get_redtriple (Mini_alg_nl_carrier d i) =
  create_nlpoly_redtriple (check_def_pos d) d (delta_gt d)
    (geqa d one_mini_alg_number) False i;
get_redtriple (Arctic_carrier i) =
  create_poly_redtriple
    (class_arc_lpoly_order one_arctic pos_arctic (\ x y -> less_arctic y x))
    (Inr ()) i;
get_redtriple (Arctic_rat_carrier i) =
  create_poly_redtriple
    (class_arc_lpoly_order one_arctic_delta pos_arctic_delta
      weak_gt_arctic_delta)
    (Inr ()) i;
get_redtriple (Int_mat_carrier n sd i) =
  create_poly_redtriple
    (mat_lpoly_order n sd (Pos One) int_mono (\ x y -> less_int y x))
    (check_dimensions n sd (Inr ())) i;
get_redtriple (Rat_mat_carrier n sd i) =
  create_poly_redtriple
    (mat_lpoly_order n sd one_rat delta_mono (\ x y -> less_rat y x))
    (check_dimensions n sd (check_def_pos one_rat)) i;
get_redtriple (Mini_alg_mat_carrier n sd i) =
  create_poly_redtriple
    (mat_lpoly_order n sd one_mini_alg_number delta_mono gta)
    (check_dimensions n sd (check_def_pos one_mini_alg_number)) i;
get_redtriple (Arc_mat_carrier n i) =
  create_poly_redtriple
    (mat_arc_lpoly_order n one_arctic pos_arctic (\ x y -> less_arctic y x))
    (check_arc_dimension n) i;
get_redtriple (Arc_rat_mat_carrier n i) =
  create_poly_redtriple
    (mat_arc_lpoly_order n one_arctic_delta pos_arctic_delta
      weak_gt_arctic_delta)
    (check_arc_dimension n) i;
get_redtriple (Rpo prec_tau pi) =
  af_redtriple pi
    (create_RPO_redtriple (\ pr -> (prec_repr_to_pr pr, prec_repr_to_status pr))
      prec_tau);
get_redtriple (Kbo precw pi) =
  af_redtriple pi
    (create_KBO_redtriple (filter_prec_weight_repr (afs_list_to_afs pi)) precw);

list_ext_name :: List_order_type -> [Prelude.Char];
list_ext_name MS_Ext = ['M', 'S'];
list_ext_name Dms_Ext = ['D', 'M', 'S'];
list_ext_name Min_Ext = ['M', 'I', 'N'];
list_ext_name Max_Ext = ['M', 'A', 'X'];

lifta :: (Bool, Bool) -> (Bool, Bool);
lifta (uu, b) = (b, b);

or2 :: (Bool, Bool) -> (Bool, Bool) -> (Bool, Bool);
or2 (b1, b2) (b3, b4) = (b1 || b3, b2 || b4);

mul_ext_impl ::
  forall a. (Eq a) => (a -> a -> (Bool, Bool)) -> [a] -> [a] -> (Bool, Bool);
mul_ext_impl f [] [] = (False, True);
mul_ext_impl f [] (v : va) = (False, False);
mul_ext_impl f (v : va) [] = (True, True);
mul_ext_impl f (v : va) (y : ys) = ex_dominating f y (v : va) (v : va) ys;

ex_dominating ::
  forall a.
    (Eq a) => (a -> a -> (Bool, Bool)) ->
                a -> [a] -> [a] -> [a] -> (Bool, Bool);
ex_dominating f y [] uw ux = (False, False);
ex_dominating f y (b : bs) xs ys =
  (case f b y of {
    (True, ns) ->
      or2 (lifta
            (mul_ext_impl f (remove1 b xs)
              (filter (\ ya -> not (fst (f b ya))) ys)))
        (ex_dominating f y bs xs ys);
    (False, True) ->
      or2 (mul_ext_impl f (remove1 b xs) ys) (ex_dominating f y bs xs ys);
    (False, False) -> ex_dominating f y bs xs ys;
  });

dms_preprocess :: [[(Nat, (Bool, Bool))]] -> [[(Nat, (Bool, Bool))]];
dms_preprocess p = map (filter (\ (_, (a, b)) -> a || b)) p;

dms_simplify ::
  Bool -> [Nat] -> [[(Nat, (Bool, Bool))]] -> [[(Nat, (Bool, Bool))]];
dms_simplify stri is p = (if any (\ i -> null (nth p i)) is then [[]] else p);

dms_decide_singletons :: Bool -> Nat -> [(Nat, (Bool, Bool))] -> Bool;
dms_decide_singletons stri n p =
  all_interval_nat
    (\ i ->
      let {
        (j, (s, ns)) = nth p i;
      } in s && not (membera (drop (plus_nat i (Nat_of_num One)) p)
                      (j, (False, True))) ||
             ns && not (membera (map fst (drop (plus_nat i (Nat_of_num One)) p))
                         j))
    Zero_nat (size_list p) &&
    (if stri
      then not (all_interval_nat
                 (not . (\ j -> not (membera p (j, (False, True))))) Zero_nat n)
      else True);

dms_select :: Bool -> [[(Nat, (Bool, Bool))]] -> Nat;
dms_select stri p =
  snd (hd (sort_key fst
            (filter (\ (l, _) -> less_nat (Nat_of_num One) l)
              (zip (map size_list p) (upt Zero_nat (size_list p))))));

dms_solve_or_select :: Bool -> Nat -> [[(Nat, (Bool, Bool))]] -> Sum Bool Nat;
dms_solve_or_select stri n p =
  (if all (\ jsns -> less_eq_nat (size_list jsns) (Nat_of_num One)) p
    then Inl (if membera p [] then False
               else dms_decide_singletons stri n (map hd p))
    else Inr (dms_select stri p));

dms_solve :: Bool -> Nat -> [[(Nat, (Bool, Bool))]] -> Bool;
dms_solve stri n p =
  (case dms_solve_or_select stri n p of {
    Inl res -> res;
    Inr k ->
      let {
        ksns = nth p k;
      } in dms_solve stri n
             (dms_simplify stri [k] (list_update p k [hd ksns])) ||
             dms_solve stri n
               (dms_simplify stri [k] (list_update p k (tl ksns)));
  });

dms_bool_ex_idx_impl :: Bool -> Nat -> [[(Nat, (Bool, Bool))]] -> Bool;
dms_bool_ex_idx_impl stri n p =
  dms_solve stri n
    (dms_simplify stri (upt Zero_nat (size_list p)) (dms_preprocess p));

dms_bool_ex_idx :: Bool -> Nat -> [[(Nat, (Bool, Bool))]] -> Bool;
dms_bool_ex_idx = dms_bool_ex_idx_impl;

dms_convert ::
  forall a. (a -> a -> (Bool, Bool)) -> [a] -> [a] -> [[(Nat, (Bool, Bool))]];
dms_convert f asa bs =
  let {
    jbs = zip (upt Zero_nat (size_list bs)) bs;
  } in map (\ a -> map (\ (j, b) -> (j, f a b)) jbs) asa;

dms_order_ext ::
  forall a. Nat -> (a -> a -> (Bool, Bool)) -> [a] -> [a] -> (Bool, Bool);
dms_order_ext n f asa bs =
  let {
    p = dms_convert f asa bs;
    lts = size_list bs;
    len = less_eq_nat lts n || equal_nat (size_list asa) lts;
  } in (len && dms_bool_ex_idx True lts p, len && dms_bool_ex_idx False lts p);

min_set_ext :: forall a. (a -> a -> (Bool, Bool)) -> [a] -> [a] -> (Bool, Bool);
min_set_ext s_ns =
  (\ asa bs ->
    (not (null bs) && all (\ a -> any (\ b -> fst (s_ns a b)) bs) asa,
      all (\ a -> any (\ b -> snd (s_ns a b)) bs) asa));

list_ext ::
  forall a.
    (Eq a) => Nat ->
                List_order_type ->
                  (a -> a -> (Bool, Bool)) -> [a] -> [a] -> (Bool, Bool);
list_ext uu MS_Ext = mul_ext_impl;
list_ext uv Max_Ext = set_ext;
list_ext uw Min_Ext = min_set_ext;
list_ext n Dms_Ext = dms_order_ext n;

label_s_ns_impl ::
  forall a b.
    (Showa a,
      Showa b) => ((Term a b, Term a b) ->
                    Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                    ((Term a b, Term a b) ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                      (Term a b, Nat) -> (Term a b, Nat) -> (Bool, Bool);
label_s_ns_impl cS cNS s t =
  let {
    (sa, i) = s;
    (ta, j) = t;
  } in (if isOK (cS (sa, ta)) then (True, True)
         else (if isOK (cNS (sa, ta)) then (less_nat j i, less_eq_nat j i)
                else (False, False)));

nST_label_mul_impl ::
  forall a b.
    (Showa a,
      Showa b) => (((Term a b, Nat) -> (Term a b, Nat) -> (Bool, Bool)) ->
                    [(Term a b, Nat)] -> [(Term a b, Nat)] -> (Bool, Bool)) ->
                    ((a, Nat) -> [(Nat, Nat)]) ->
                      ((Term a b, Term a b) ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                        ((Term a b, Term a b) ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                          (Term a b, Term a b) ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ();
nST_label_mul_impl list_ext af cS cNS st =
  (case st of {
    (Var _, b) ->
      Inl (shows_prec_list Zero_nat
             ['r', 'o', 'o', 't', 's', ' ', 'o', 'f', ' '] .
            shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
              [' ', '-', '>', ' '] st .
              shows_prec_list Zero_nat
                [' ', 'm', 'u', 's', 't', ' ', 'b', 'e', ' ', 'n', 'o', 'n',
                  '-', 'v', 'a', 'r', 'i', 'a', 'b', 'l', 'e']);
    (Fun f ss, Var _) ->
      Inl (shows_prec_list Zero_nat
             ['r', 'o', 'o', 't', 's', ' ', 'o', 'f', ' '] .
            shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
              [' ', '-', '>', ' '] st .
              shows_prec_list Zero_nat
                [' ', 'm', 'u', 's', 't', ' ', 'b', 'e', ' ', 'n', 'o', 'n',
                  '-', 'v', 'a', 'r', 'i', 'a', 'b', 'l', 'e']);
    (Fun f ss, Fun g ts) ->
      check (snd (list_ext (label_s_ns_impl cS cNS) (lterms af (Fun f ss))
                   (lterms af (Fun g ts))))
        (shows_prec_list Zero_nat
           ['c', 'a', 'n', 'n', 'o', 't', ' ', 'o', 'r', 'i', 'e', 'n', 't',
             ' ', 'p', 'a', 'i', 'r', ' '] .
          shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
            [' ', '-', '>', ' '] st .
            shows_prec_list Zero_nat [' ', 'w', 'e', 'a', 'k', 'l', 'y', ':'] .
              shows_nl .
                shows_prec_list Zero_nat (lterms af (Fun f ss)) .
                  shows_prec_list Zero_nat [' ', '>', '=', 'm', 'u', ' '] .
                    shows_prec_list Zero_nat (lterms af (Fun g ts)) .
                      shows_prec_list Zero_nat
                        [' ', 'c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ',
                          'b', 'e', ' ', 'e', 'n', 's', 'u', 'r', 'e', 'd']);
  });

s_label_mul_impl ::
  forall a b.
    (Showa a,
      Showa b) => (((Term a b, Nat) -> (Term a b, Nat) -> (Bool, Bool)) ->
                    [(Term a b, Nat)] -> [(Term a b, Nat)] -> (Bool, Bool)) ->
                    ((a, Nat) -> [(Nat, Nat)]) ->
                      ((Term a b, Term a b) ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                        ((Term a b, Term a b) ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                          (Term a b, Term a b) ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ();
s_label_mul_impl list_ext af cS cNS st =
  (case st of {
    (Var _, b) ->
      Inl (shows_prec_list Zero_nat
             ['r', 'o', 'o', 't', 's', ' ', 'o', 'f', ' '] .
            shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
              [' ', '-', '>', ' '] st .
              shows_prec_list Zero_nat
                [' ', 'm', 'u', 's', 't', ' ', 'b', 'e', ' ', 'n', 'o', 'n',
                  '-', 'v', 'a', 'r', 'i', 'a', 'b', 'l', 'e']);
    (Fun f ss, Var _) ->
      Inl (shows_prec_list Zero_nat
             ['r', 'o', 'o', 't', 's', ' ', 'o', 'f', ' '] .
            shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
              [' ', '-', '>', ' '] st .
              shows_prec_list Zero_nat
                [' ', 'm', 'u', 's', 't', ' ', 'b', 'e', ' ', 'n', 'o', 'n',
                  '-', 'v', 'a', 'r', 'i', 'a', 'b', 'l', 'e']);
    (Fun f ss, Fun g ts) ->
      check (fst (list_ext (label_s_ns_impl cS cNS) (lterms af (Fun f ss))
                   (lterms af (Fun g ts))))
        (shows_prec_list Zero_nat
           ['c', 'a', 'n', 'n', 'o', 't', ' ', 'o', 'r', 'i', 'e', 'n', 't',
             ' ', 'p', 'a', 'i', 'r', ' '] .
          shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
            [' ', '-', '>', ' '] st .
            shows_prec_list Zero_nat
              [' ', 's', 't', 'r', 'i', 'c', 't', 'l', 'y', ':'] .
              shows_nl .
                shows_prec_list Zero_nat (lterms af (Fun f ss)) .
                  shows_prec_list Zero_nat [' ', '>', 'm', 'u', ' '] .
                    shows_prec_list Zero_nat (lterms af (Fun g ts)) .
                      shows_prec_list Zero_nat
                        [' ', 'c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ',
                          'b', 'e', ' ', 'e', 'n', 's', 'u', 'r', 'e', 'd']);
  });

generate_scnp_rp ::
  forall a b c.
    (Eq a, Key a, Showa a,
      Showa b) => (((Term a b, Nat) -> (Term a b, Nat) -> (Bool, Bool)) ->
                    [(Term a b, Nat)] -> [(Term a b, Nat)] -> (Bool, Bool)) ->
                    [Prelude.Char] ->
                      [((a, Nat), [(Nat, Nat)])] ->
                        (c -> Redtriple_ext a b ()) ->
                          c -> Root_redtriple_ext a b ();
generate_scnp_rp list_ext list_ext_name af rti x =
  let {
    rt = rti x;
    afaa = fun_of_map (ceta_map_of af) [];
    pi = afa rt;
    cS = s rt;
    cNS = ns rt;
  } in Root_redtriple_ext (valid rt) (s_label_mul_impl list_ext afaa cS cNS)
         (ns rt) (nST_label_mul_impl list_ext afaa cS cNS) pi
         (scnp_af_to_af afaa pi) (scnp_desc af list_ext_name . desca rt) ();

get_root_redtriple ::
  forall a b.
    (Eq a, Key a, Showa a, Eq b,
      Showa b) => Root_redtriple_impl a -> Root_redtriple_ext a b ();
get_root_redtriple (Scnp typea af rp) =
  generate_scnp_rp (list_ext (scnp_arity af) typea) (list_ext_name typea) af
    get_redtriple rp;

faulty_non_inf_order ::
  forall a b c.
    (Showa b, Showa c) => [Prelude.Char] -> a -> Non_inf_order_ext b c ();
faulty_non_inf_order s f =
  Non_inf_order_ext (Inl (shows_string s)) (\ _ -> Inr ()) (\ _ -> Inr ())
    (\ _ _ -> Wild) id ();

check_non_inf_poly_inter_list ::
  forall a b.
    (Eq a, Eq b,
      Poly_carrier b) => Bool ->
                           [(a, Nat)] ->
                             [((a, Nat), [([(Nat, Nat)], b)])] ->
                               Sum (a, [([(Nat, Nat)], b)]) ();
check_non_inf_poly_inter_list discrete f i =
  catcha
    (catcha
      (forallM
        (\ x ->
          (if let {
                (_, a) = x;
              } in check_poly_weak_mono_and_pos discrete a
            then Inr () else Inl x))
        (filter (\ (fn, _) -> membera f fn) i))
      (\ x -> Inl (snd x)))
    (\ x ->
      Inl (let {
             (a, b) = x;
           } in let {
                  (fa, _) = a;
                } in (\ aa -> (fa, aa))
                  b));

create_nlpoly_non_inf_order ::
  forall a b c.
    (Eq a, Poly_carrier a, Showa a, Eq b, Key b, Showa b, Eq c,
      Showa c) => Sum ([Prelude.Char] -> [Prelude.Char]) () ->
                    a -> (a -> a -> Bool) ->
                           Bool ->
                             Bool ->
                               (a -> [a]) ->
                                 [((b, Nat), [([(Nat, Nat)], a)])] ->
                                   [(b, Nat)] -> Non_inf_order_ext b c ();
create_nlpoly_non_inf_order cI def gt power_mono discrete sqrt i f =
  let {
    j = poly_inter_list_to_inter def i;
    x = poly_subst
          (\ n -> poly_of (PVar (['x', '_'] ++ shows_prec_nat Zero_nat n [])));
  } in Non_inf_order_ext
         (bindb cI
           (\ _ ->
             catcha (check_non_inf_poly_inter_list discrete f i)
               (\ xa ->
                 Inl (let {
                        (fa, p) = xa;
                      } in shows_string
                             ['i', 'n', 't', 'e', 'r', 'p', 'r', 'e', 't', 'a',
                               't', 'i', 'o', 'n', ' '] .
                             shows_poly (x p) .
                               shows_string [' ', 'o', 'f', ' '] .
                                 shows_prec Zero_nat fa .
                                   shows_string
                                     [' ', 'i', 'n', 'v', 'a', 'l', 'i', 'd',
                                       ' ']))))
         (check_ns j) (check_cc sqrt gt j) (create_dep discrete def i)
         (shows_string
            ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'i', 'n',
              't', 'e', 'r', 'p', 'r', 'e', 't', 'a', 't', 'i', 'o', 'n'] .
           shows_nl .
             shows_sep
               (\ (a, b) ->
                 let {
                   (fa, n) = a;
                 } in (\ p ->
                        shows_string ['P', 'o', 'l', '('] .
                          shows_prec Zero_nat fa .
                            shows_string ['/'] .
                              shows_prec_nat Zero_nat n .
                                shows_string [')', ' ', '=', ' '] .
                                  shows_poly (x p))
                   b)
               shows_nl i)
         ();

sqrt_int_main :: Int -> Int -> (Int, Bool);
sqrt_int_main x n =
  let {
    x2 = times_int x x;
  } in (if less_eq_int x2 n then (x, equal_int x2 n)
         else sqrt_int_main
                (div_int (plus_int (div_int n x) x) (Pos (Bit0 One))) n);

sqrt_int :: Int -> [Int];
sqrt_int x =
  (if less_int x Zero_int then []
    else (case sqrt_int_main x x of {
           (y, True) ->
             (if equal_int y Zero_int then [Zero_int] else [y, uminus_int y]);
           (y, False) -> [];
         }));

sqrt_rat :: Rat -> [Rat];
sqrt_rat x =
  let {
    (z, n) = quotient_of x;
  } in (case sqrt_int n of {
         [] -> [];
         sn : _ ->
           map (\ sz -> divide_rat (of_int sz) (of_int sn)) (sqrt_int z);
       });

sqrt_mini_alg :: Mini_alg_number -> [Mini_alg_number];
sqrt_mini_alg (Sp q r) =
  (if equal_rat r zero_rat then map (\ x -> Sp x zero_rat) (sqrt_rat q)
    else []);

get_non_inf_order ::
  forall a b.
    (Eq a, Key a, Showa a, Eq b,
      Showa b) => Redtriple_impl a -> [(a, Nat)] -> Non_inf_order_ext a b ();
get_non_inf_order (Int_nl_carrier i) =
  create_nlpoly_non_inf_order (Inr ()) (Pos One) (\ x y -> less_int y x) True
    True sqrt_int i;
get_non_inf_order (Rat_nl_carrier d i) =
  create_nlpoly_non_inf_order (check_def_pos d) d (delta_gt d)
    (less_eq_rat one_rat d) False sqrt_rat i;
get_non_inf_order (Mini_alg_nl_carrier d i) =
  create_nlpoly_non_inf_order (check_def_pos d) d (delta_gt d)
    (geqa d one_mini_alg_number) False sqrt_mini_alg i;
get_non_inf_order (Int_carrier v) =
  faulty_non_inf_order
    ['o', 'n', 'l', 'y', ' ', 'i', 'n', 't', 'e', 'g', 'e', 'r', 's', ',', ' ',
      'r', 'a', 't', 'i', 'o', 'n', 'a', 'l', 's', ' ', 'a', 'n', 'd', ' ', 'm',
      'i', 'n', 'i', '-', 'a', 'l', 'g', '-', 'n', 'u', 'm', 'b', 'e', 'r', 's',
      ' ', 's', 'u', 'p', 'p', 'o', 'r', 't', 'e', 'd', ' ', 'f', 'o', 'r', ' ',
      'n', 'o', 'n', '-', 'i', 'n', 'f', ' ', 'o', 'r', 'd', 'e', 'r', 's'];
get_non_inf_order (Rat_carrier v) =
  faulty_non_inf_order
    ['o', 'n', 'l', 'y', ' ', 'i', 'n', 't', 'e', 'g', 'e', 'r', 's', ',', ' ',
      'r', 'a', 't', 'i', 'o', 'n', 'a', 'l', 's', ' ', 'a', 'n', 'd', ' ', 'm',
      'i', 'n', 'i', '-', 'a', 'l', 'g', '-', 'n', 'u', 'm', 'b', 'e', 'r', 's',
      ' ', 's', 'u', 'p', 'p', 'o', 'r', 't', 'e', 'd', ' ', 'f', 'o', 'r', ' ',
      'n', 'o', 'n', '-', 'i', 'n', 'f', ' ', 'o', 'r', 'd', 'e', 'r', 's'];
get_non_inf_order (Mini_alg_carrier v) =
  faulty_non_inf_order
    ['o', 'n', 'l', 'y', ' ', 'i', 'n', 't', 'e', 'g', 'e', 'r', 's', ',', ' ',
      'r', 'a', 't', 'i', 'o', 'n', 'a', 'l', 's', ' ', 'a', 'n', 'd', ' ', 'm',
      'i', 'n', 'i', '-', 'a', 'l', 'g', '-', 'n', 'u', 'm', 'b', 'e', 'r', 's',
      ' ', 's', 'u', 'p', 'p', 'o', 'r', 't', 'e', 'd', ' ', 'f', 'o', 'r', ' ',
      'n', 'o', 'n', '-', 'i', 'n', 'f', ' ', 'o', 'r', 'd', 'e', 'r', 's'];
get_non_inf_order (Arctic_carrier v) =
  faulty_non_inf_order
    ['o', 'n', 'l', 'y', ' ', 'i', 'n', 't', 'e', 'g', 'e', 'r', 's', ',', ' ',
      'r', 'a', 't', 'i', 'o', 'n', 'a', 'l', 's', ' ', 'a', 'n', 'd', ' ', 'm',
      'i', 'n', 'i', '-', 'a', 'l', 'g', '-', 'n', 'u', 'm', 'b', 'e', 'r', 's',
      ' ', 's', 'u', 'p', 'p', 'o', 'r', 't', 'e', 'd', ' ', 'f', 'o', 'r', ' ',
      'n', 'o', 'n', '-', 'i', 'n', 'f', ' ', 'o', 'r', 'd', 'e', 'r', 's'];
get_non_inf_order (Arctic_rat_carrier v) =
  faulty_non_inf_order
    ['o', 'n', 'l', 'y', ' ', 'i', 'n', 't', 'e', 'g', 'e', 'r', 's', ',', ' ',
      'r', 'a', 't', 'i', 'o', 'n', 'a', 'l', 's', ' ', 'a', 'n', 'd', ' ', 'm',
      'i', 'n', 'i', '-', 'a', 'l', 'g', '-', 'n', 'u', 'm', 'b', 'e', 'r', 's',
      ' ', 's', 'u', 'p', 'p', 'o', 'r', 't', 'e', 'd', ' ', 'f', 'o', 'r', ' ',
      'n', 'o', 'n', '-', 'i', 'n', 'f', ' ', 'o', 'r', 'd', 'e', 'r', 's'];
get_non_inf_order (Int_mat_carrier v va vb) =
  faulty_non_inf_order
    ['o', 'n', 'l', 'y', ' ', 'i', 'n', 't', 'e', 'g', 'e', 'r', 's', ',', ' ',
      'r', 'a', 't', 'i', 'o', 'n', 'a', 'l', 's', ' ', 'a', 'n', 'd', ' ', 'm',
      'i', 'n', 'i', '-', 'a', 'l', 'g', '-', 'n', 'u', 'm', 'b', 'e', 'r', 's',
      ' ', 's', 'u', 'p', 'p', 'o', 'r', 't', 'e', 'd', ' ', 'f', 'o', 'r', ' ',
      'n', 'o', 'n', '-', 'i', 'n', 'f', ' ', 'o', 'r', 'd', 'e', 'r', 's'];
get_non_inf_order (Rat_mat_carrier v va vb) =
  faulty_non_inf_order
    ['o', 'n', 'l', 'y', ' ', 'i', 'n', 't', 'e', 'g', 'e', 'r', 's', ',', ' ',
      'r', 'a', 't', 'i', 'o', 'n', 'a', 'l', 's', ' ', 'a', 'n', 'd', ' ', 'm',
      'i', 'n', 'i', '-', 'a', 'l', 'g', '-', 'n', 'u', 'm', 'b', 'e', 'r', 's',
      ' ', 's', 'u', 'p', 'p', 'o', 'r', 't', 'e', 'd', ' ', 'f', 'o', 'r', ' ',
      'n', 'o', 'n', '-', 'i', 'n', 'f', ' ', 'o', 'r', 'd', 'e', 'r', 's'];
get_non_inf_order (Mini_alg_mat_carrier v va vb) =
  faulty_non_inf_order
    ['o', 'n', 'l', 'y', ' ', 'i', 'n', 't', 'e', 'g', 'e', 'r', 's', ',', ' ',
      'r', 'a', 't', 'i', 'o', 'n', 'a', 'l', 's', ' ', 'a', 'n', 'd', ' ', 'm',
      'i', 'n', 'i', '-', 'a', 'l', 'g', '-', 'n', 'u', 'm', 'b', 'e', 'r', 's',
      ' ', 's', 'u', 'p', 'p', 'o', 'r', 't', 'e', 'd', ' ', 'f', 'o', 'r', ' ',
      'n', 'o', 'n', '-', 'i', 'n', 'f', ' ', 'o', 'r', 'd', 'e', 'r', 's'];
get_non_inf_order (Arc_mat_carrier v va) =
  faulty_non_inf_order
    ['o', 'n', 'l', 'y', ' ', 'i', 'n', 't', 'e', 'g', 'e', 'r', 's', ',', ' ',
      'r', 'a', 't', 'i', 'o', 'n', 'a', 'l', 's', ' ', 'a', 'n', 'd', ' ', 'm',
      'i', 'n', 'i', '-', 'a', 'l', 'g', '-', 'n', 'u', 'm', 'b', 'e', 'r', 's',
      ' ', 's', 'u', 'p', 'p', 'o', 'r', 't', 'e', 'd', ' ', 'f', 'o', 'r', ' ',
      'n', 'o', 'n', '-', 'i', 'n', 'f', ' ', 'o', 'r', 'd', 'e', 'r', 's'];
get_non_inf_order (Arc_rat_mat_carrier v va) =
  faulty_non_inf_order
    ['o', 'n', 'l', 'y', ' ', 'i', 'n', 't', 'e', 'g', 'e', 'r', 's', ',', ' ',
      'r', 'a', 't', 'i', 'o', 'n', 'a', 'l', 's', ' ', 'a', 'n', 'd', ' ', 'm',
      'i', 'n', 'i', '-', 'a', 'l', 'g', '-', 'n', 'u', 'm', 'b', 'e', 'r', 's',
      ' ', 's', 'u', 'p', 'p', 'o', 'r', 't', 'e', 'd', ' ', 'f', 'o', 'r', ' ',
      'n', 'o', 'n', '-', 'i', 'n', 'f', ' ', 'o', 'r', 'd', 'e', 'r', 's'];
get_non_inf_order (Rpo v va) =
  faulty_non_inf_order
    ['o', 'n', 'l', 'y', ' ', 'i', 'n', 't', 'e', 'g', 'e', 'r', 's', ',', ' ',
      'r', 'a', 't', 'i', 'o', 'n', 'a', 'l', 's', ' ', 'a', 'n', 'd', ' ', 'm',
      'i', 'n', 'i', '-', 'a', 'l', 'g', '-', 'n', 'u', 'm', 'b', 'e', 'r', 's',
      ' ', 's', 'u', 'p', 'p', 'o', 'r', 't', 'e', 'd', ' ', 'f', 'o', 'r', ' ',
      'n', 'o', 'n', '-', 'i', 'n', 'f', ' ', 'o', 'r', 'd', 'e', 'r', 's'];
get_non_inf_order (Kbo v va) =
  faulty_non_inf_order
    ['o', 'n', 'l', 'y', ' ', 'i', 'n', 't', 'e', 'g', 'e', 'r', 's', ',', ' ',
      'r', 'a', 't', 'i', 'o', 'n', 'a', 'l', 's', ' ', 'a', 'n', 'd', ' ', 'm',
      'i', 'n', 'i', '-', 'a', 'l', 'g', '-', 'n', 'u', 'm', 'b', 'e', 'r', 's',
      ' ', 's', 'u', 'p', 'p', 'o', 'r', 't', 'e', 'd', ' ', 'f', 'o', 'r', ' ',
      'n', 'o', 'n', '-', 'i', 'n', 'f', ' ', 'o', 'r', 'd', 'e', 'r', 's'];

check_strict_one_rstep ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    ((Term a b, Term a b) ->
                      Maybe [(Pos, ((Term a b, Term a b), Term a b))]) ->
                      ((a, Nat) -> Nat) ->
                        (Term a b, Term a b) ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_strict_one_rstep ra rseqm p r =
  let {
    s = proj_term p (fst r);
    t = proj_term p (snd r);
  } in (case rseqm r of {
         Nothing -> check_supt s t;
         Just [] ->
           Inl (shows_string
                 ['m', 'o', 'r', 'e', ' ', 't', 'h', 'a', 'n', ' ', 'a', ' ',
                   's', 'i', 'n', 'g', 'l', 'e', ' ', 'r', 'e', 'w', 'r', 'i',
                   't', 'e', ' ', 's', 't', 'e', 'p', ' ', 'i', 's', ' ', 'n',
                   'o', 't', ' ', 'a', 'l', 'l', 'o', 'w', 'e', 'd']);
         Just [(pos, (rule, u))] ->
           bindb (check_qrstep (\ _ -> True) False ra pos rule s u)
             (\ _ -> check_supteq u t);
         Just ((pos, (rule, u)) : _ : _) ->
           Inl (shows_string
                 ['m', 'o', 'r', 'e', ' ', 't', 'h', 'a', 'n', ' ', 'a', ' ',
                   's', 'i', 'n', 'g', 'l', 'e', ' ', 'r', 'e', 'w', 'r', 'i',
                   't', 'e', ' ', 's', 't', 'e', 'p', ' ', 'i', 's', ' ', 'n',
                   'o', 't', ' ', 'a', 'l', 'l', 'o', 'w', 'e', 'd']);
       });

check_strict_rstep ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    ((Term a b, Term a b) ->
                      Maybe [(Pos, ((Term a b, Term a b), Term a b))]) ->
                      ((a, Nat) -> Nat) ->
                        (Term a b, Term a b) ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_strict_rstep ra rseqm p r =
  let {
    s = proj_term p (fst r);
    t = proj_term p (snd r);
  } in (case rseqm r of {
         Nothing -> check_supt s t;
         Just rseq ->
           (if equal_nat (size_list rseq) Zero_nat then check_supt s t
             else bindb (check_rsteps_last ra s rseq)
                    (\ _ -> check_supteq (rseq_last s rseq) t));
       });

create_rseq_map ::
  forall a b.
    (Eq a, Key a, Eq b,
      Key b) => [((Term a b, Term a b),
                   [(Pos, ((Term a b, Term a b), Term a b))])] ->
                  (Term a b, Term a b) ->
                    Maybe [(Pos, ((Term a b, Term a b), Term a b))];
create_rseq_map rseqs = ceta_map_of rseqs;

check_weak ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => ((a, Nat) -> Nat) ->
                    (Term a b, Term a b) ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_weak p r =
  catcha
    (check (equal_term (proj_term p (fst r)) (proj_term p (snd r)))
      (shows_string
         ['t', 'h', 'e', ' ', 'p', 'r', 'o', 'j', 'e', 'c', 't', 'e', 'd', ' ',
           'l', 'h', 's', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'e', 'q', 'u',
           'a', 'l', ' ', 't', 'o', ' ', 't', 'h', 'e', ' ', 'p', 'r', 'o', 'j',
           'e', 'c', 't', 'e', 'd', ' ', 'r', 'h', 's'] .
        shows_nl))
    (\ x ->
      Inl (shows_string
             ['C', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'o', 'r', 'i',
               'e', 'n', 't', ' ', 'r', 'u', 'l', 'e', ' '] .
            shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
              [' ', '-', '>', ' '] r .
              shows_string [',', ' ', 's', 'i', 'n', 'c', 'e'] .
                shows_nl .
                  shows_prec_term Zero_nat (proj_term p (fst r)) .
                    shows_string [' ', '!', '=', ' '] .
                      shows_prec_term Zero_nat (proj_term p (snd r)) .
                        shows_nl . x));

subterm_criterion_proc ::
  forall a b c.
    (Eq b, Key b, Showa b, Eq c, Key c,
      Showa c) => Dpp_ops_ext a b c () ->
                    ProjL b ->
                      [((Term b c, Term b c),
                         [(Pos, ((Term b c, Term b c), Term b c))])] ->
                        [(Term b c, Term b c)] ->
                          a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
subterm_criterion_proc i pL rseqmL prm dpp =
  (case let {
          p = create_proj pL;
          rseqm = create_rseq_map rseqmL;
          pa = pairsa i dpp;
          _ = nfsc i dpp;
          r = rulesd i dpp;
          pb = snd (split_pairsa i dpp prm);
          wfR = wf_rules_impl r;
        } in bindb (catcha
                     (forallM
                       (\ (l, ra) ->
                         bindb (check_no_var l)
                           (\ _ ->
                             bindb (check_no_var ra)
                               (\ _ ->
                                 check_no_defined_root
                                   (\ fn -> not (null (rules_mapb i dpp fn)))
                                   ra)))
                       pa)
                     (\ x -> Inl (snd x)))
               (\ _ ->
                 bindb (check (minimal i dpp)
                         (shows_prec_list Zero_nat
                           ['m', 'i', 'n', 'i', 'm', 'a', 'l', 'i', 't', 'y',
                             ' ', 'r', 'e', 'q', 'u', 'i', 'r', 'e', 'd']))
                   (\ _ ->
                     bindb (catcha (forallM (\ (l, _) -> check_no_var l) r)
                             (\ x -> Inl (snd x)))
                       (\ _ ->
                         bindb (if q_emptyc i dpp
                                 then catcha
(forallM (check_strict_rstep r rseqm p) prm) (\ x -> Inl (snd x))
                                 else catcha
(forallM (check_strict_one_rstep wfR rseqm p) prm) (\ x -> Inl (snd x)))
                           (\ _ ->
                             catcha (forallM (check_weak p) pb)
                               (\ x -> Inl (snd x))))))
    of {
    Inl a -> Inl a;
    Inr _ -> Inr (delete_P_Pwa i dpp prm prm);
  });

is_ur_closed_term_impl ::
  forall a b c.
    (Eq a,
      Eq c) => (Term a [Prelude.Char] -> Bool) ->
                 (Term a b -> Term a (Sum () [Prelude.Char])) ->
                   [(Term a [Prelude.Char], c)] ->
                     [(Term a [Prelude.Char], c)] ->
                       [Term a [Prelude.Char]] -> Term a b -> Bool;
is_ur_closed_term_impl nfq e_cap r u s (Var x) = True;
is_ur_closed_term_impl nfq e_cap r u s (Fun f ts) =
  all (is_ur_closed_term_impl nfq e_cap r u s) ts &&
    all (\ (l, ra) ->
          membera u (l, ra) ||
            (case mgu_class (Fun f (map e_cap ts)) l of {
              Nothing -> True;
              Just mu ->
                not (all (\ ua ->
                           nfq (subst_apply_term (map_vars (\ a -> 'y' : a) ua)
                                 mu))
                      (args l)) ||
                  not (all (\ ua -> nfq (subst_apply_term ua mu)) s);
            }))
      r;

is_ur_closed_impl_dpp_mv ::
  forall a b.
    (Eq b, Key b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    a -> [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                           [Term b [Prelude.Char]] ->
                             Term b [Prelude.Char] -> Bool;
is_ur_closed_impl_dpp_mv i d =
  let {
    ic = icap_impl_dpp i d;
    qnf = is_QNFc i d;
    r = rulesd i d;
    urc = (\ s -> is_ur_closed_term_impl qnf (ic s) r);
  } in (\ u s ->
         let {
           sa = map (map_vars (\ a -> 'x' : a)) s;
         } in (\ t -> urc sa u sa (map_vars (\ a -> 'x' : a) t)));

replace_paira ::
  forall a b c d.
    Dpp_ops_ext a b c d ->
      a -> (Term b c, Term b c) -> [(Term b c, Term b c)] -> a;
replace_paira
  (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
    rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
    intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
    split_pairs split_rules mk minimal nfs wwf_rules more)
  = replace_pair;

forward_instantiation_proc ::
  forall a b.
    (Eq b, Key b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    (Term b [Prelude.Char], Term b [Prelude.Char]) ->
                      [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                        Maybe [(Term b [Prelude.Char],
                                 Term b [Prelude.Char])] ->
                          a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
forward_instantiation_proc i st sts u_opt dpp =
  (case let {
          isnf = is_QNFc i dpp;
          (s, t) = st;
          iedg = is_iedg_edge_dpp i dpp (s, t);
          sy = map_vars (\ a -> 'y' : a) s;
          ty = map_vars (\ a -> 'y' : a) t;
          u = (case u_opt of {
                Nothing -> rulesd i dpp;
                Just u -> u;
              });
        } in bindb (if is_none u_opt then Inr ()
                     else let {
                            urc = is_ur_closed_impl_dpp_mv i dpp u;
                            check_urc =
                              (\ sa ta ->
                                check (urc sa ta)
                                  (shows_prec_list Zero_nat
                                     ['t', 'e', 'r', 'm', ' '] .
                                    shows_prec_term Zero_nat ta .
                                      shows_prec_list Zero_nat
[' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'c', 'l', 'o', 's', 'e', 'd', ' ', 'u',
  'n', 'd', 'e', 'r', ' ', 'u', 's', 'a', 'b', 'l', 'e', ' ', 'r', 'u', 'l',
  'e', 's']));
                          } in bindb (check (nfsc i dpp || minimal i dpp)
                                       (shows_prec_list Zero_nat
 ['m', 'i', 'n', 'i', 'm', 'a', 'l', 'i', 't', 'y', ' ', 'o', 'r', ' ', 'n',
   'o', 'r', 'm', 'a', 'l', ' ', 's', 'u', 'b', 's', 't', ' ', 'r', 'e', 'q',
   'u', 'i', 'r', 'e', 'd']))
                                 (\ _ ->
                                   bindb (check (nFQ_subset_NF_rulesb i dpp)
   (shows_prec_list Zero_nat
     ['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't', ' ', 'r', 'e', 'w', 'r', 'i',
       't', 'i', 'n', 'g', ' ', 'r', 'e', 'q', 'u', 'i', 'r', 'e', 'd']))
                                     (\ _ ->
                                       bindb
 (catcha (forallM (\ (l, a) -> check_urc (args l) a) u) (\ x -> Inl (snd x)))
 (\ _ ->
   bindb (check_urc [s] t)
     (\ _ ->
       (if nfsc i dpp then Inr ()
         else catcha (check_subseteq (vars_term_lista t) (vars_term_lista s))
                (\ _ ->
                  Inl (shows_prec_list Zero_nat
                        ['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', ' ', 'c', 'o',
                          'n', 'd', 'i', 't', 'i', 'o', 'n', ' ', 'i', 'n', ' ',
                          'p', 'a', 'i', 'r', ' ', 'v', 'i', 'o', 'l', 'a', 't',
                          'e', 'd']))))))))
               (\ _ ->
                 let {
                   ur = map (\ (l, r) -> (r, l)) u;
                   ic = icap_impla ur [] [];
                 } in catcha
                        (forallM
                          (\ (ua, v) ->
                            (case mgu_class (ic ua) t of {
                              Nothing -> Inr ();
                              Just mu ->
                                check (not (isnf (subst_apply_term sy mu)) ||
(not (isnf (subst_apply_term (map_vars (\ a -> 'x' : a) ua) mu)) ||
  any (\ sta ->
        instance_rule sta st &&
          instance_rule (subst_apply_term sy mu, subst_apply_term ty mu) sta)
    sts))
                                  (shows_prec_list Zero_nat
                                     ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o',
                                       't', ' ', 'f', 'i', 'n', 'd', ' ', 'i',
                                       'n', 's', 't', 'a', 'n', 'c', 'e', ' ',
                                       'o', 'f', ' ', 'p', 'a', 'i', 'r', ' '] .
                                    shows_rule (shows_prec Zero_nat)
                                      (shows_prec_list Zero_nat)
                                      [' ', '-', '>', ' ']
                                      (subst_apply_term sy mu,
subst_apply_term ty mu) .
                                      shows_nl .
shows_prec_list Zero_nat
  ['w', 'h', 'i', 'c', 'h', ' ', 'r', 'e', 's', 'u', 'l', 't', 'e', 'd', ' ',
    'f', 'r', 'o', 'm', ' ', 'D', 'P', ' '] .
  shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
    [' ', '-', '>', ' '] (ua, v));
                            }))
                          (filter (\ (ua, _) -> iedg ua) (pairsa i dpp)))
                        (\ x -> Inl (snd x)))
    of {
    Inl a -> Inl a;
    Inr _ -> Inr (replace_paira i dpp st sts);
  });

intersect_rulesb ::
  forall a b c d. Dpp_ops_ext a b c d -> a -> [(Term b c, Term b c)] -> a;
intersect_rulesb
  (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
    rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
    intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
    split_pairs split_rules mk minimal nfs wwf_rules more)
  = intersect_rules;

usable_rules_proc ::
  forall a b.
    (Eq b, Key b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                      a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
usable_rules_proc i u dpp =
  (case bindb (check (nFQ_subset_NF_rulesb i dpp)
                (shows_prec_list Zero_nat
                  ['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't', ' ', 'r', 'e',
                    'w', 'r', 'i', 't', 'i', 'n', 'g', ' ', 'r', 'e', 'q', 'u',
                    'i', 'r', 'e', 'd']))
          (\ _ ->
            bindb (check (nfsc i dpp || (minimal i dpp || wwf_rulesa i dpp))
                    (shows_prec_list Zero_nat
                      ['n', 'o', 'r', 'm', 'a', 'l', ' ', 'f', 'o', 'r', 'm',
                        ' ', 's', 'u', 'b', 's', 't', ',', ' ', 'm', 'i', 'n',
                        'i', 'm', 'a', 'l', 'i', 't', 'y', ' ', 'o', 'r', ' ',
                        'w', 'e', 'l', 'l', '-', 'f', 'o', 'r', 'm', 'e', 'd',
                        'n', 'e', 's', 's', ' ', 'r', 'e', 'q', 'u', 'i', 'r',
                        'e', 'd']))
              (\ _ ->
                let {
                  p = pairsa i dpp;
                  urc = is_ur_closed_impl_dpp_mv i dpp u;
                  check_urc =
                    (\ s t ->
                      check (urc s t)
                        (shows_prec_list Zero_nat ['t', 'e', 'r', 'm', ' '] .
                          shows_prec_term Zero_nat t .
                            shows_prec_list Zero_nat
                              [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'c', 'l',
                                'o', 's', 'e', 'd', ' ', 'u', 'n', 'd', 'e',
                                'r', ' ', 'u', 's', 'a', 'b', 'l', 'e', ' ',
                                'r', 'u', 'l', 'e', 's']));
                  nfs = nfsc i dpp;
                } in bindb (catcha
                             (forallM
                               (\ (l, r) ->
                                 bindb (if nfs then Inr ()
 else catcha (check_subseteq (vars_term_lista r) (vars_term_lista l))
        (\ _ ->
          Inl (shows_prec_list Zero_nat
                ['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', ' ', 'c', 'o', 'n',
                  'd', 'i', 't', 'i', 'o', 'n', ' ', 'i', 'n', ' ', 'P', ' ',
                  'v', 'i', 'o', 'l', 'a', 't', 'e', 'd'])))
                                   (\ _ -> check_urc [l] r))
                               p)
                             (\ x -> Inl (snd x)))
                       (\ _ ->
                         catcha (forallM (\ (l, a) -> check_urc (args l) a) u)
                           (\ x -> Inl (snd x)))))
    of {
    Inl a -> Inl a;
    Inr _ -> Inr (intersect_rulesb i dpp u);
  });

switch_innermost_proc ::
  forall a b.
    (Eq b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    Join_info b ->
                      a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
switch_innermost_proc i joins_i dpp =
  let {
    r = rwc i dpp;
    p = pb i dpp;
    pw = pwa i dpp;
    nfs = nfsc i dpp;
  } in (case bindb (catcha
                     (forallM
                       (\ (l, _) ->
                         check (not (is_Var l))
                           (shows_prec_list Zero_nat
                             ['l', 'e', 'f', 't', ' ', 'v', 'a', 'r', 'i', 'a',
                               'b', 'l', 'e', 's', ' ', 'i', 'n', ' ', 'R', ' ',
                               'f', 'o', 'r', 'b', 'i', 'd', 'd', 'e', 'n']))
                       (if nfs then r else []))
                     (\ x -> Inl (snd x)))
               (\ _ ->
                 bindb (check (minimal i dpp)
                         (shows_prec_list Zero_nat
                           ['m', 'i', 'n', 'i', 'm', 'a', 'l', 'i', 't', 'y',
                             ' ', 'r', 'e', 'q', 'u', 'i', 'r', 'e', 'd']))
                   (\ _ ->
                     bindb (check (null (qc i dpp))
                             (shows_prec_list Zero_nat
                               ['n', 'o', 'n', '-', 'e', 'm', 'p', 't', 'y',
                                 ' ', 'Q', ' ', 'n', 'o', 't', ' ', 'y', 'e',
                                 't', ' ', 's', 'u', 'p', 'p', 'o', 'r', 't',
                                 'e', 'd']))
                       (\ _ ->
                         bindb (check (null (rc i dpp))
                                 (shows_prec_list Zero_nat
                                   ['s', 't', 'r', 'i', 'c', 't', ' ', 'r', 'u',
                                     'l', 'e', 's', ' ', 'n', 'o', 't', ' ',
                                     'a', 'l', 'l', 'o', 'w', 'e', 'd']))
                           (\ _ ->
                             bindb (check
                                     (null (critical_pairs_impl (p ++ pw) r))
                                     (shows_prec_list Zero_nat
                                       ['o', 'v', 'e', 'r', 'l', 'a', 'p', 's',
 ' ', 'b', 'e', 't', 'w', 'e', 'e', 'n', ' ', 'P', ' ', 'a', 'n', 'd', ' ', 'R',
 ' ', 'n', 'o', 't', ' ', 'a', 'l', 'l', 'o', 'w', 'e', 'd']))
                               (\ _ ->
                                 check_critical_pairs r
                                   (critical_pairs_impl r r) joins_i)))))
         of {
         Inl a -> Inl a;
         Inr _ -> Inr (mkc i nfs True p pw (map fst r) [] r);
       });

quasi_splitter ::
  forall a b c.
    (Eq a,
      Eq c) => (a -> (a, b)) ->
                 [(Term a c, Term a c)] ->
                   [(Term a c, Term a c)] ->
                     ([(Term a c, Term a c)],
                       ([(Term a c, Term a c)], [(Term a c, Term a c)]));
quasi_splitter ld lAll uRw =
  let {
    unlab = (\ lf -> fst (ld lf));
    la = map (\ r -> (r, map_rule unlab r)) lAll;
    (d, nD) =
      partition
        (\ (r, ur) ->
          equal_term (fst ur) (snd ur) && not (equal_term (fst r) (snd r)))
        la;
    (rw, r) = partition (\ (_, a) -> membera uRw a) nD;
  } in (map fst r, (map fst rw, map fst d));

model_splitter ::
  forall a b c.
    (Eq a,
      Eq c) => (a -> (a, b)) ->
                 [(Term a c, Term a c)] ->
                   [(Term a c, Term a c)] ->
                     ([(Term a c, Term a c)],
                       ([(Term a c, Term a c)], [(Term a c, Term a c)]));
model_splitter ld lAll uRw =
  let {
    unlab = (\ lf -> fst (ld lf));
    la = map (\ r -> (r, map_rule unlab r)) lAll;
    (rw, r) = partition (\ (_, a) -> membera uRw a) la;
  } in (map fst r, (map fst rw, []));

check_sl_Qa ::
  forall a b c.
    (Eq a, Showa a, Eq c,
      Showa c) => (a -> (a, b)) ->
                    [Term a c] ->
                      [Term a c] -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_sl_Qa ld lQ q =
  let {
    u = (\ l -> fst (ld l));
  } in catcha
         (forallM
           (\ lq ->
             check (let {
                      mlq = map_term u lq;
                    } in any (\ qa -> matches mlq qa && matches qa mlq) q)
               (shows_prec_list Zero_nat
                  ['u', 'n', 'l', 'a', 'b', 'e', 'l', 'i', 'n', 'g', ' '] .
                 shows_term (shows_prec Zero_nat) (shows_prec Zero_nat) lq .
                   shows_prec_list Zero_nat
                     [' ', 'y', 'i', 'e', 'l', 'd', 's', ' ', 'a', ' ', 't',
                       'e', 'r', 'm', ' ', 'n', 'o', 't', ' ', 'i', 'n', ' ',
                       'Q']))
           lQ)
         (\ x -> Inl (snd x));

sem_lab_quasi_root_proc ::
  forall a b c d.
    (Eq a, Showa a, Ceq d, Corder d, Eq d, Set_impla d,
      Showa d) => (a -> (a, b)) ->
                    Dpp_ops_ext c a d () ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) () ->
                        ([(Term a d, Term a d)] ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                          ([(Term a d, Term a d)] ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                            ([Term a d] ->
                              [Term a d] ->
                                Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                              ([(Term a d, Term a d)] ->
                                [(Term a d, Term a d)] ->
                                  Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                                ([(Term a d, Term a d)] ->
                                  [(Term a d, Term a d)] ->
                                    Sum ([Prelude.Char] -> [Prelude.Char])
                                      ()) ->
                                  ([(Term a d, Term a d)] ->
                                    [(Term a d, Term a d)] ->
                                      Sum ([Prelude.Char] -> [Prelude.Char])
()) ->
                                    [(Term a d, Term a d)] ->
                                      [Term a d] ->
[(Term a d, Term a d)] -> c -> Sum ([Prelude.Char] -> [Prelude.Char]) c;
sem_lab_quasi_root_proc ld i valid check_decra check_decr check_lhss_more
  check_lab_all check_lab_all_trs check_model_lab lPAll lQ lRAll dpp =
  let {
    r = rc i dpp;
    rw = rwc i dpp;
    pw = pwa i dpp;
    p = pb i dpp;
    nfs = nfsc i dpp;
    m = minimal i dpp;
    (lP, (lPw, _)) = model_splitter ld lPAll pw;
    (lR, (lRw, d)) = quasi_splitter ld lRAll rw;
    qempty = q_emptyc i dpp;
  } in (case bindb valid
               (\ _ ->
                 bindb (check
                         (if nfs
                           then (if not qempty then wwf_rulesa i dpp else True)
                           else True)
                         (shows_prec_list Zero_nat
                           ['w', 'e', 'l', 'l', ' ', 'f', 'o', 'r', 'm', 'e',
                             'd', 'n', 'e', 's', 's', ' ', 'r', 'e', 'q', 'u',
                             'i', 'r', 'e', 'd']))
                   (\ _ ->
                     bindb (catcha
                             (forallM
                               (\ (l, ra) ->
                                 bindb (check_no_var l)
                                   (\ _ ->
                                     bindb (check_no_var ra)
                                       (\ _ ->
 check_no_defined_root (\ fn -> not (null (rules_mapb i dpp fn))) ra)))
                               (pairsa i dpp))
                             (\ x -> Inl (snd x)))
                       (\ _ ->
                         bindb (catcha
                                 (forallM (\ (l, _) -> check_no_var l)
                                   (rulesd i dpp))
                                 (\ x -> Inl (snd x)))
                           (\ _ ->
                             let {
                               q = qc i dpp;
                             } in bindb (if nfs && not qempty
  then check_wf_trs d else Inr ())
                                    (\ _ ->
                                      bindb (check_decra d)
(\ _ ->
  bindb (check_decr d)
    (\ _ ->
      bindb (catcha
              (forallM
                (\ qa ->
                  check (linear_term qa)
                    (shows_prec_list Zero_nat
                      ['Q', ' ', 'm', 'u', 's', 't', ' ', 'n', 'o', 't', ' ',
                        'c', 'o', 'n', 't', 'a', 'i', 'n', ' ', 'n', 'o', 'n',
                        '-', 'l', 'i', 'n', 'e', 'a', 'r', ' ', 't', 'e', 'r',
                        'm', 's']))
                q)
              (\ x -> Inl (snd x)))
        (\ _ ->
          catcha
            (bindb (check_lhss_more lQ q)
              (\ _ ->
                bindb (check_sl_Qa ld lQ q)
                  (\ _ ->
                    bindb (check_lab_all lP p)
                      (\ _ ->
                        bindb (check_lab_all lPw pw)
                          (\ _ ->
                            bindb (check_model_lab lR r)
                              (\ _ ->
                                bindb (check_model_lab lRw rw)
                                  (\ _ ->
                                    bindb (check_lab_all_trs lR r)
                                      (\ _ -> check_lab_all_trs lRw rw))))))))
            (\ x ->
              Inl (shows_string
                     ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'd', 'u', 'r',
                       'i', 'n', 'g', ' ', 'l', 'a', 'b', 'e', 'l', 'i', 'n',
                       'g', ':'] .
                    shows_nl . x))))))))))
         of {
         Inl a -> Inl a;
         Inr _ -> Inr (mkc i nfs m lP lPw lQ lR (lRw ++ d));
       });

eval_lab ::
  forall a b c d e.
    (a -> [b] -> b) ->
      (a -> [b] -> c) ->
        (a -> Nat -> c -> d) -> (e -> b) -> Term a e -> (b, Term d e);
eval_lab i l lc alpha (Var x) = (alpha x, Var x);
eval_lab i l lc alpha (Fun f ts) =
  let {
    clts = map (eval_lab i l lc alpha) ts;
    cs = map fst clts;
    c = i f cs;
    lts = map snd clts;
  } in (c, Fun (lc f (size_list ts) (l f cs)) lts);

check_sl_rule_ass ::
  forall a b c d e.
    (Showa a, Showa b, Eq d, Showa d, Eq e,
      Showa e) => Bool ->
                    (a -> [b] -> b) ->
                      (a -> [b] -> c) ->
                        (a -> Nat -> c -> d) ->
                          (b -> b -> Bool) ->
                            [(Term d e, Term d e)] ->
                              (e -> b) ->
                                (Term a e, Term a e) ->
                                  Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_sl_rule_ass mc i la lc cge lR alpha (l, r) =
  let {
    cl_ll = eval_lab i la lc alpha l;
    cr_lr = eval_lab i la lc alpha r;
  } in bindb (check (if mc then cge (fst cl_ll) (fst cr_lr) else True)
               (shows_string ['r', 'u', 'l', 'e', ' '] .
                 shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                   [' ', '-', '>', ' '] (l, r) .
                   shows_string
                     [' ', 'v', 'i', 'o', 'l', 'a', 't', 'e', 's', ' ', 't',
                       'h', 'e', ' ', 'm', 'o', 'd', 'e', 'l', ' ', 'c', 'o',
                       'n', 'd', 'i', 't', 'i', 'o', 'n', ',', ' ', '[', 'l',
                       'h', 's', ']', ' ', '=', ' '] .
                     shows_prec Zero_nat (fst cl_ll) .
                       shows_string
                         [',', ' ', '[', 'r', 'h', 's', ']', ' ', '=', ' '] .
                         shows_prec Zero_nat (fst cr_lr)))
         (\ _ ->
           check (membera lR (snd cl_ll, snd cr_lr))
             (shows_string
                ['l', 'a', 'b', 'e', 'l', 'e', 'd', ' ', 'r', 'u', 'l', 'e',
                  ' '] .
               shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                 [' ', '-', '>', ' '] (snd cl_ll, snd cr_lr) .
                 shows_string [' ', 'm', 'i', 's', 's', 'i', 'n', 'g']));

check_sl_rule ::
  forall a b c d e.
    (Showa a, Showa b, Eq d, Showa d, Eq e,
      Showa e) => (a -> [b] -> b) ->
                    (a -> [b] -> c) ->
                      (a -> Nat -> c -> d) ->
                        [b] ->
                          (b -> b -> Bool) ->
                            Bool ->
                              [(Term d e, Term d e)] ->
                                (Term a e, Term a e) ->
                                  Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_sl_rule i l lc c cge mc lR lr =
  catcha
    (forallM (\ alpha -> check_sl_rule_ass mc i l lc cge lR alpha lr)
      (map fun_of (enum_vectors c (vars_rule_list lr))))
    (\ x -> Inl (snd x));

check_sl_model_lab_trs ::
  forall a b c d.
    (Eq a, Showa a, Showa b, Eq d,
      Showa d) => (a -> [b] -> b) ->
                    (a -> [b] -> c) ->
                      [b] ->
                        (b -> b -> Bool) ->
                          (a -> Nat -> c -> a) ->
                            [(Term a d, Term a d)] ->
                              [(Term a d, Term a d)] ->
                                Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_sl_model_lab_trs i l c cge label lR r =
  catcha (forallM (check_sl_rule i l label c cge True lR) r)
    (\ x -> Inl (snd x));

check_NF_vars_subset ::
  forall a b. (Eq a, Eq b) => [Term a b] -> [Term a b] -> Sum (Term a b) ();
check_NF_vars_subset qa q =
  catcha (forallM (\ qaa -> check (any (matches qaa) q) qaa) qa)
    (\ x -> Inl (snd x));

flatten_term_enum :: forall a b. Term [a] b -> [Term a b];
flatten_term_enum (Var x) = [Var x];
flatten_term_enum (Fun fs ts) =
  let {
    lts = map flatten_term_enum ts;
    ss = concat_lists lts;
  } in concatMap (\ f -> map (Fun f) ss) fs;

lab_lhss_more_impl ::
  forall a b c d.
    (a -> Nat -> b -> c) -> (a -> Nat -> [b]) -> [Term a d] -> [Term c d];
lab_lhss_more_impl lc lS_gen q =
  let {
    f_all = (\ f n -> map (lc f n) (lS_gen f n));
  } in concatMap (\ qa -> flatten_term_enum (map_term_wa f_all qa)) q;

check_sl_lab_lhss_more ::
  forall a b c.
    (Eq a, Showa a, Eq c,
      Showa c) => (a -> Nat -> b -> a) ->
                    (a -> Nat -> [b]) ->
                      [Term a c] ->
                        [Term a c] -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_sl_lab_lhss_more lc lS_gen lQ q =
  catcha (check_NF_vars_subset (lab_lhss_more_impl lc lS_gen q) lQ)
    (\ x ->
      Inl (shows_term (shows_prec Zero_nat) (shows_prec Zero_nat) x .
            shows_prec_list Zero_nat
              [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n', 'g', ' ', 'i',
                'n', ' ', 'l', 'a', 'b', 'e', 'l', 'e', 'd', ' ', 'Q']));

lab_root ::
  forall a b c d e.
    (a -> [b] -> b) ->
      (a -> [b] -> c) ->
        (a -> [b] -> c) ->
          (a -> Nat -> c -> d) -> (e -> b) -> Term a e -> Term d e;
lab_root i la l lc alpha (Fun f ts) =
  let {
    clts = map (eval_lab i la lc alpha) ts;
    cs = map fst clts;
    a = map snd clts;
  } in Fun (lc f (size_list ts) (l f cs)) a;
lab_root uu uv uw ux uy (Var x) = Var x;

check_sl_rule_all_ass ::
  forall a b c d e.
    (Showa a, Showa b, Eq d, Showa d, Eq e,
      Showa e) => (a -> [b] -> b) ->
                    (a -> [b] -> c) ->
                      (a -> [b] -> c) ->
                        (a -> Nat -> c -> d) ->
                          (c -> [c]) ->
                            [(Term d e, Term d e)] ->
                              (e -> b) ->
                                (Term a e, Term a e) ->
                                  Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_sl_rule_all_ass i lb la lc gen_smaller lR alpha (l, Fun f ts) =
  let {
    ll = lab_root i lb la lc alpha l;
    clts = map (eval_lab i lb lc alpha) ts;
    lts = map snd clts;
    ld = la f (map fst clts);
    n = size_list ts;
    small = gen_smaller ld;
  } in catcha
         (forallM
           (\ le ->
             check (membera lR (ll, Fun (lc f n le) lts))
               (shows_string
                  ['l', 'a', 'b', 'e', 'l', 'e', 'd', ' ', 'r', 'u', 'l', 'e',
                    ' '] .
                 shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                   [' ', '-', '>', ' '] (ll, Fun (lc f n le) lts) .
                   shows_string [' ', 'm', 'i', 's', 's', 'i', 'n', 'g']))
           small)
         (\ x -> Inl (snd x));
check_sl_rule_all_ass i lb la lc gen_smaller lR alpha (l, Var x) =
  let {
    ll = lab_root i lb la lc alpha l;
    lr = lab_root i lb la lc alpha (Var x);
  } in check (membera lR (ll, lr))
         (shows_string
            ['l', 'a', 'b', 'e', 'l', 'e', 'd', ' ', 'r', 'u', 'l', 'e', ' '] .
           shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
             [' ', '-', '>', ' '] (ll, lr) .
             shows_string [' ', 'm', 'i', 's', 's', 'i', 'n', 'g']);

check_sl_rule_all ::
  forall a b c d e.
    (Showa a, Showa b, Eq d, Showa d, Eq e,
      Showa e) => (a -> [b] -> b) ->
                    (a -> [b] -> c) ->
                      (a -> [b] -> c) ->
                        (a -> Nat -> c -> d) ->
                          [b] ->
                            (c -> [c]) ->
                              [(Term d e, Term d e)] ->
                                (Term a e, Term a e) ->
                                  Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_sl_rule_all i la l lc c gen_smaller lR lr =
  catcha
    (forallM
      (\ alpha -> check_sl_rule_all_ass i la l lc gen_smaller lR alpha lr)
      (map fun_of (enum_vectors c (vars_rule_list lr))))
    (\ x -> Inl (snd x));

check_sl_lab_all_trs ::
  forall a b c d e.
    (Showa a, Showa b, Eq d, Showa d, Eq e,
      Showa e) => (a -> [b] -> b) ->
                    (a -> [b] -> c) ->
                      (a -> [b] -> c) ->
                        [b] ->
                          (c -> [c]) ->
                            (a -> Nat -> c -> d) ->
                              [(Term d e, Term d e)] ->
                                [(Term a e, Term a e)] ->
                                  Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_sl_lab_all_trs i la l c gen label lP p =
  catcha (forallM (check_sl_rule_all i la l label c gen lP) p)
    (\ x -> Inl (snd x));

check_wf_sym_F_all ::
  forall a b c.
    (Eq c,
      Showa c) => (a -> Nat -> b -> c) ->
                    (c -> (a, b)) ->
                      (a -> Nat -> b -> Bool) ->
                        (c, Nat) -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_wf_sym_F_all lc ld ls =
  (\ (lf, n) ->
    let {
      (f, l) = ld lf;
    } in check (ls f n l && lf == lc f n l)
           (shows_prec_list Zero_nat
              ['l', 'a', 'b', 'e', 'l', 'e', 'd', ' ', 's', 'y', 'm', 'b', 'o',
                'l', ' '] .
             shows_prec Zero_nat lf .
               shows_prec_list Zero_nat
                 [' ', 'n', 'o', 't', ' ', 'a', 'l', 'l', 'o', 'w', 'e', 'd']));

check_wf_terms_F_all ::
  forall a b c d.
    (Eq c,
      Showa c) => (a -> Nat -> b -> c) ->
                    (c -> (a, b)) ->
                      (a -> Nat -> b -> Bool) ->
                        Term c d -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_wf_terms_F_all lc ld ls lt =
  let {
    lfs = funas_term_lista lt;
  } in catcha (forallM (check_wf_sym_F_all lc ld ls) lfs) (\ x -> Inl (snd x));

check_Lab_all_trs ::
  forall a b c.
    (Eq a, Showa a, Eq c,
      Showa c) => (a -> Nat -> b -> a) ->
                    (a -> (a, b)) ->
                      (a -> Nat -> b -> Bool) ->
                        [(Term a c, Term a c)] ->
                          [(Term a c, Term a c)] ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_Lab_all_trs lc ld ls lR r =
  catcha
    (forallM
      (\ (l, ra) ->
        catcha
          (bindb (check_wf_terms_F_all lc ld ls ra)
            (\ _ ->
              check (membera r (map_rule (\ lf -> fst (ld lf)) (l, ra)))
                (shows_prec_list Zero_nat
                  ['u', 'n', 'l', 'a', 'b', 'e', 'l', 'i', 'n', 'g', ' ', 'o',
                    'f', ' ', 't', 'h', 'e', ' ', 'r', 'u', 'l', 'e', ' ', 'd',
                    'o', 'e', 's', ' ', 'n', 'o', 't', ' ', 'y', 'i', 'e', 'l',
                    'd', ' ', 'o', 'r', 'i', 'g', 'i', 'n', 'a', 'l', ' ', 'r',
                    'u', 'l', 'e'])))
          (\ x ->
            Inl (shows_prec_list Zero_nat
                   ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'i', 't', 'h',
                     ' ', 'l', 'a', 'b', 'e', 'l', 'e', 'd', ' ', 'r', 'u', 'l',
                     'e'] .
                  shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                    [' ', '-', '>', ' '] (l, ra) .
                    shows_nl . x)))
      lR)
    (\ x -> Inl (snd x));

data Sl_ops_ext a b c d e =
  Sl_ops_ext (a -> [b] -> c) (a -> Nat -> c -> Bool) (a -> [b] -> b) [b] b
    ([(Term a d, Term a d)] -> Sum ([Prelude.Char] -> [Prelude.Char]) ())
    (a -> [b] -> c) (a -> Nat -> c -> Bool) (c -> [c]) (a -> Nat -> [c]) e;

sl_check_decr ::
  forall a b c d e.
    Sl_ops_ext a b c d e ->
      [(Term a d, Term a d)] -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
sl_check_decr
  (Sl_ops_ext sl_La sl_LSa sl_I sl_C sl_c sl_check_decr sl_L sl_LS sl_lgen
    sl_LS_gen more)
  = sl_check_decr;

lge_to_lgr ::
  forall a b.
    (Eq b) => (a -> Nat -> b -> b -> Bool) ->
                (a -> Nat -> b -> Bool) -> a -> Nat -> b -> b -> Bool;
lge_to_lgr lge ls f n =
  let {
    lSfn = ls f n;
    lgefn = lge f n;
  } in (\ l la -> not (l == la) && lSfn l && lSfn la && lgefn l la);

check_sl_decr_rule ::
  forall a b c d.
    (Eq a, Eq b, Eq c,
      Eq d) => (a -> Nat -> b -> c) ->
                 (c -> (a, b)) ->
                   (a -> Nat -> b -> Bool) ->
                     (a -> Nat -> b -> b -> Bool) ->
                       (Term c d, Term c d) -> Bool;
check_sl_decr_rule lc ld ls lge (Fun lf ts, Fun lg us) =
  let {
    (f, l1) = ld lf;
    (g, l2) = ld lg;
    n = size_list ts;
  } in f == g &&
         ts == us &&
           lf == lc f n l1 &&
             lg == lc f n l2 &&
               ls f n l1 && ls f n l2 && lge_to_lgr lge ls f n l1 l2;
check_sl_decr_rule uu uv uw ux (Var vb, va) = False;
check_sl_decr_rule uu uv uw ux (v, Var vb) = False;

check_sl_decr ::
  forall a b c d.
    (Eq a, Eq b, Eq c, Showa c, Eq d,
      Showa d) => (a -> Nat -> b -> c) ->
                    (c -> (a, b)) ->
                      (a -> Nat -> b -> Bool) ->
                        (a -> Nat -> b -> b -> Bool) ->
                          [(Term c d, Term c d)] ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_sl_decr lc ld ls lge d =
  catcha
    (forallM
      (\ lr ->
        check (check_sl_decr_rule lc ld ls lge lr)
          (shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
             [' ', '-', '>', ' '] lr .
            shows_prec_list Zero_nat
              [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'd', 'e', 'c',
                'r', 'e', 'a', 's', 'i', 'n', 'g', ' ', 'r', 'u', 'l', 'e']))
      d)
    (\ x -> Inl (snd x));

sl_LS_gen :: forall a b c d e. Sl_ops_ext a b c d e -> a -> Nat -> [c];
sl_LS_gen
  (Sl_ops_ext sl_La sl_LSa sl_I sl_C sl_c sl_check_decr sl_L sl_LS sl_lgen
    sl_LS_gen more)
  = sl_LS_gen;

option_to_list :: forall a. Maybe a -> [a];
option_to_list (Just a) = [a];
option_to_list Nothing = [];

funas_root_rule_list ::
  forall a b. (Eq a) => (Term a b, Term a b) -> [(a, Nat)];
funas_root_rule_list r =
  remdups (option_to_list (root (fst r)) ++ option_to_list (root (snd r)));

funas_root_rules_list ::
  forall a b. (Eq a) => [(Term a b, Term a b)] -> [(a, Nat)];
funas_root_rules_list r = remdups (concatMap funas_root_rule_list r);

sl_lgen :: forall a b c d e. Sl_ops_ext a b c d e -> c -> [c];
sl_lgen
  (Sl_ops_ext sl_La sl_LSa sl_I sl_C sl_c sl_check_decr sl_L sl_LS sl_lgen
    sl_LS_gen more)
  = sl_lgen;

sl_La :: forall a b c d e. Sl_ops_ext a b c d e -> a -> [b] -> c;
sl_La (Sl_ops_ext sl_La sl_LSa sl_I sl_C sl_c sl_check_decr sl_L sl_LS sl_lgen
        sl_LS_gen more)
  = sl_L;

sl_LS :: forall a b c d e. Sl_ops_ext a b c d e -> a -> Nat -> c -> Bool;
sl_LS (Sl_ops_ext sl_La sl_LSa sl_I sl_C sl_c sl_check_decr sl_L sl_LS sl_lgen
        sl_LS_gen more)
  = sl_LSa;

sl_L :: forall a b c d e. Sl_ops_ext a b c d e -> a -> [b] -> c;
sl_L (Sl_ops_ext sl_La sl_LSa sl_I sl_C sl_c sl_check_decr sl_L sl_LS sl_lgen
       sl_LS_gen more)
  = sl_La;

sl_I :: forall a b c d e. Sl_ops_ext a b c d e -> a -> [b] -> b;
sl_I (Sl_ops_ext sl_La sl_LSa sl_I sl_C sl_c sl_check_decr sl_L sl_LS sl_lgen
       sl_LS_gen more)
  = sl_I;

sl_C :: forall a b c d e. Sl_ops_ext a b c d e -> [b];
sl_C (Sl_ops_ext sl_La sl_LSa sl_I sl_C sl_c sl_check_decr sl_L sl_LS sl_lgen
       sl_LS_gen more)
  = sl_C;

sem_lab_fin_quasi_root_proc ::
  forall a b c d e.
    (Eq a, Showa a, Eq b, Showa c, Ceq e, Corder e, Eq e, Set_impla e,
      Showa e) => (a -> Nat -> b -> a) ->
                    (a -> (a, b)) ->
                      (c -> c -> Bool) ->
                        (a -> Nat -> b -> b -> Bool) ->
                          Dpp_ops_ext d a e () ->
                            ([(a, Nat)] ->
                              [(a, Nat)] ->
                                Sum ([Prelude.Char] -> [Prelude.Char])
                                  (Sl_ops_ext a c b e ())) ->
                              [(Term a e, Term a e)] ->
                                [Term a e] ->
                                  [(Term a e, Term a e)] ->
                                    d -> Sum ([Prelude.Char] -> [Prelude.Char])
   d;
sem_lab_fin_quasi_root_proc lc ld cge lge i gen lPAll lQ lRAll dp =
  let {
    pairs = pairsa i dp;
  } in bindb (gen (list_union (funas_trs_list (rulesd i dp))
                    (funas_args_trs_list pairs))
               (funas_root_rules_list pairs))
         (\ ops ->
           let {
             check_d = sl_check_decr ops;
             check_da = check_sl_decr lc ld (sl_LS ops) lge;
             check_q = check_sl_lab_lhss_more lc (sl_LS_gen ops);
             check_ml =
               check_sl_model_lab_trs (sl_I ops) (sl_L ops) (sl_C ops) cge lc;
             check_l =
               check_sl_lab_all_trs (sl_I ops) (sl_L ops) (sl_La ops) (sl_C ops)
                 (sl_lgen ops) lc;
             check_la = check_Lab_all_trs lc ld (sl_LS ops);
           } in sem_lab_quasi_root_proc ld i (Inr ()) check_d check_da check_q
                  check_l check_la check_ml lPAll lQ lRAll dp);

check_sl_rule_root ::
  forall a b c d e.
    (Showa a, Showa b, Eq d, Showa d, Eq e,
      Showa e) => (a -> [b] -> b) ->
                    (a -> [b] -> c) ->
                      (a -> [b] -> c) ->
                        (a -> Nat -> c -> d) ->
                          [b] ->
                            [(Term d e, Term d e)] ->
                              (Term a e, Term a e) ->
                                Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_sl_rule_root i la l lc c lR lr =
  catcha
    (forallM
      (\ alpha ->
        let {
          laa = lab_root i la l lc alpha;
          lb = laa (fst lr);
          r = laa (snd lr);
        } in check (membera lR (lb, r))
               (shows_prec_list Zero_nat
                  ['l', 'a', 'b', 'e', 'l', 'e', 'd', ' ', 'r', 'u', 'l', 'e',
                    ' '] .
                 shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                   [' ', '-', '>', ' '] (lb, r) .
                   shows_prec_list Zero_nat
                     [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n', 'g']))
      (map fun_of (enum_vectors c (vars_rule_list lr))))
    (\ x -> Inl (snd x));

check_sl_lab_root_trs ::
  forall a b c d e.
    (Showa a, Showa b, Eq d, Showa d, Eq e,
      Showa e) => (a -> [b] -> b) ->
                    (a -> [b] -> c) ->
                      (a -> [b] -> c) ->
                        [b] ->
                          (a -> Nat -> c -> d) ->
                            [(Term d e, Term d e)] ->
                              [(Term a e, Term a e)] ->
                                Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_sl_lab_root_trs i la l c label lP p =
  catcha (forallM (check_sl_rule_root i la l label c lP) p)
    (\ x -> Inl (snd x));

sem_lab_root_proc ::
  forall a b c d.
    (Eq a, Showa a, Eq d,
      Showa d) => (a -> (a, b)) ->
                    Dpp_ops_ext c a d () ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) () ->
                        ([Term a d] ->
                          [Term a d] ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                          ([(Term a d, Term a d)] ->
                            [(Term a d, Term a d)] ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                            ([(Term a d, Term a d)] ->
                              [(Term a d, Term a d)] ->
                                Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                              ([(Term a d, Term a d)] ->
                                [(Term a d, Term a d)] ->
                                  Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                                [(Term a d, Term a d)] ->
                                  [Term a d] ->
                                    [(Term a d, Term a d)] ->
                                      c ->
Sum ([Prelude.Char] -> [Prelude.Char]) c;
sem_lab_root_proc ld i valid check_Q check_laba check_lab check_model_lab lPAll
  lQ lRAll dpp =
  let {
    r = rc i dpp;
    rw = rwc i dpp;
    pw = pwa i dpp;
    p = pb i dpp;
    nfs = nfsc i dpp;
    m = minimal i dpp;
    (lP, (lPw, _)) = model_splitter ld lPAll pw;
    (lR, (lRw, _)) = model_splitter ld lRAll rw;
  } in (case bindb valid
               (\ _ ->
                 bindb (catcha
                         (forallM
                           (\ (l, ra) ->
                             bindb (check_no_var l)
                               (\ _ ->
                                 bindb (check_no_var ra)
                                   (\ _ ->
                                     check_no_defined_root
                                       (\ fn ->
 not (null (rules_mapb i dpp fn)))
                                       ra)))
                           (pairsa i dpp))
                         (\ x -> Inl (snd x)))
                   (\ _ ->
                     bindb (catcha
                             (forallM (\ (l, _) -> check_no_var l)
                               (rulesd i dpp))
                             (\ x -> Inl (snd x)))
                       (\ _ ->
                         let {
                           q = qc i dpp;
                         } in catcha
                                (bindb
                                  (check
                                    (if nfs
                                      then (if not (q_emptyc i dpp)
     then wwf_rulesa i dpp else True)
                                      else True)
                                    (shows_prec_list Zero_nat
                                      ['w', 'e', 'l', 'l', ' ', 'f', 'o', 'r',
'm', 'e', 'd', 'n', 'e', 's', 's', ' ', 'r', 'e', 'q', 'u', 'i', 'r', 'e',
'd']))
                                  (\ _ ->
                                    bindb (check_Q lQ q)
                                      (\ _ ->
bindb (check_sl_Qa ld lQ q)
  (\ _ ->
    bindb (check_laba lP p)
      (\ _ ->
        bindb (check_laba lPw pw)
          (\ _ ->
            bindb (check_model_lab lR r)
              (\ _ ->
                bindb (check_model_lab lRw rw)
                  (\ _ ->
                    bindb (check_lab lR r) (\ _ -> check_lab lRw rw)))))))))
                                (\ x ->
                                  Inl (shows_string
 ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'd', 'u', 'r', 'i', 'n', 'g', ' ',
   'l', 'a', 'b', 'e', 'l', 'i', 'n', 'g', ':'] .
shows_nl . x)))))
         of {
         Inl a -> Inl a;
         Inr _ -> Inr (mkc i nfs m lP lPw lQ lR lRw);
       });

lab_rule_ass ::
  forall a b c d e.
    (a -> [b] -> b) ->
      (a -> [b] -> c) ->
        (a -> Nat -> c -> d) ->
          (e -> b) -> (Term a e, Term a e) -> (Term d e, Term d e);
lab_rule_ass i l lc alpha rule =
  (snd (eval_lab i l lc alpha (fst rule)),
    snd (eval_lab i l lc alpha (snd rule)));

lab_rule_list ::
  forall a b c d e.
    (Eq e) => (a -> [b] -> b) ->
                (a -> [b] -> c) ->
                  (a -> Nat -> c -> d) ->
                    [b] -> (Term a e, Term a e) -> [(Term d e, Term d e)];
lab_rule_list i l lc c lr =
  map (\ alpha -> lab_rule_ass i l lc alpha lr)
    (map fun_of (enum_vectors c (vars_rule_list lr)));

lab_trs_list ::
  forall a b c d e.
    (Eq e) => (a -> [b] -> b) ->
                (a -> [b] -> c) ->
                  (a -> Nat -> c -> d) ->
                    [b] -> [(Term a e, Term a e)] -> [(Term d e, Term d e)];
lab_trs_list i l lc c r = concatMap (lab_rule_list i l lc c) r;

check_sl_lab ::
  forall a b c d.
    (Eq a, Showa a, Eq d,
      Showa d) => (a -> [b] -> b) ->
                    (a -> [b] -> c) ->
                      (a -> Nat -> c -> a) ->
                        [b] ->
                          [(Term a d, Term a d)] ->
                            [(Term a d, Term a d)] ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_sl_lab i l lc c lR r =
  bindb (check (not (null c))
          (shows_prec_list Zero_nat
            ['c', 'a', 'r', 'r', 'i', 'e', 'r', ' ', 'm', 'u', 's', 't', ' ',
              'b', 'e', ' ', 'n', 'o', 'n', '-', 'e', 'm', 'p', 't', 'y']))
    (\ _ ->
      catcha (check_subseteq lR (lab_trs_list i l lc c r))
        (\ x ->
          Inl (shows_prec_list Zero_nat
                 ['l', 'a', 'b', 'e', 'l', 'e', 'd', ' ', 'r', 'u', 'l', 'e',
                   ' '] .
                shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                  [' ', '-', '>', ' '] x .
                  shows_prec_list Zero_nat
                    [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', 'l', 'l', 'o',
                      'w', 'e', 'd'])));

lab_lhs_list ::
  forall a b c d e.
    (Eq e) => (a -> [b] -> b) ->
                (a -> [b] -> c) ->
                  (a -> Nat -> c -> d) -> [b] -> Term a e -> [Term d e];
lab_lhs_list i l lc c t =
  map (\ alpha -> snd (eval_lab i l lc alpha t))
    (map fun_of (enum_vectors c (vars_term_lista t)));

lab_lhss_list ::
  forall a b c d e.
    (Eq e) => (a -> [b] -> b) ->
                (a -> [b] -> c) ->
                  (a -> Nat -> c -> d) -> [b] -> [Term a e] -> [Term d e];
lab_lhss_list i l lc c q = concatMap (lab_lhs_list i l lc c) q;

check_sl_Q ::
  forall a b c d.
    (Eq a, Showa a, Eq d,
      Showa d) => (a -> [b] -> b) ->
                    (a -> [b] -> c) ->
                      (a -> Nat -> c -> a) ->
                        [b] ->
                          [Term a d] ->
                            [Term a d] ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_sl_Q i l lc c lQ q =
  bindb (check (not (null c))
          (shows_prec_list Zero_nat
            ['c', 'a', 'r', 'r', 'i', 'e', 'r', ' ', 'm', 'u', 's', 't', ' ',
              'b', 'e', ' ', 'n', 'o', 'n', '-', 'e', 'm', 'p', 't', 'y']))
    (\ _ ->
      catcha (check_NF_vars_subset (lab_lhss_list i l lc c q) lQ)
        (\ x ->
          Inl (shows_prec_list Zero_nat
                 ['l', 'a', 'b', 'e', 'l', 'e', 'd', ' ', 't', 'e', 'r', 'm',
                   ' '] .
                shows_term (shows_prec Zero_nat) (shows_prec Zero_nat) x .
                  shows_prec_list Zero_nat
                    [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n', 'g'])));

sem_lab_fin_root_proc ::
  forall a b c d e.
    (Eq a, Showa a, Eq d, Showa d, Eq e,
      Showa e) => (a -> Nat -> b -> a) ->
                    (a -> (a, b)) ->
                      Dpp_ops_ext c a d () ->
                        ([(a, Nat)] ->
                          [(a, Nat)] ->
                            Sum ([Prelude.Char] -> [Prelude.Char])
                              (Sl_ops_ext a e b d ())) ->
                          [(Term a d, Term a d)] ->
                            [Term a d] ->
                              [(Term a d, Term a d)] ->
                                c -> Sum ([Prelude.Char] -> [Prelude.Char]) c;
sem_lab_fin_root_proc lc ld i gen lPAll lQ lRAll dp =
  let {
    pairs = pairsa i dp;
  } in bindb (gen (list_union (funas_trs_list (rulesd i dp))
                    (funas_args_trs_list pairs))
               (funas_root_rules_list pairs))
         (\ ops ->
           let {
             check_q = check_sl_Q (sl_I ops) (sl_L ops) lc (sl_C ops);
             check_ml =
               check_sl_model_lab_trs (sl_I ops) (sl_L ops) (sl_C ops)
                 (\ a b -> a == b) lc;
             check_l =
               check_sl_lab_root_trs (sl_I ops) (sl_L ops) (sl_La ops)
                 (sl_C ops) lc;
             check_la = check_sl_lab (sl_I ops) (sl_L ops) lc (sl_C ops);
           } in sem_lab_root_proc ld i (Inr ()) check_q check_l check_la
                  check_ml lPAll lQ lRAll dp);

data Slm_ops_ext a b c d =
  Slm_ops_ext (a -> [b] -> c) (a -> [b] -> b) [b] b (a -> [b] -> c) d;

slm_La :: forall a b c d. Slm_ops_ext a b c d -> a -> [b] -> c;
slm_La (Slm_ops_ext slm_La slm_I slm_C slm_c slm_L more) = slm_L;

slm_c :: forall a b c d. Slm_ops_ext a b c d -> b;
slm_c (Slm_ops_ext slm_La slm_I slm_C slm_c slm_L more) = slm_c;

slm_L :: forall a b c d. Slm_ops_ext a b c d -> a -> [b] -> c;
slm_L (Slm_ops_ext slm_La slm_I slm_C slm_c slm_L more) = slm_La;

slm_I :: forall a b c d. Slm_ops_ext a b c d -> a -> [b] -> b;
slm_I (Slm_ops_ext slm_La slm_I slm_C slm_c slm_L more) = slm_I;

slm_C :: forall a b c d. Slm_ops_ext a b c d -> [b];
slm_C (Slm_ops_ext slm_La slm_I slm_C slm_c slm_L more) = slm_C;

slm_to_sl :: forall a b c d. Slm_ops_ext a b c () -> Sl_ops_ext a b c d ();
slm_to_sl ops =
  Sl_ops_ext (slm_L ops) (\ _ _ _ -> True) (slm_I ops) (slm_C ops) (slm_c ops)
    (\ _ -> Inr ()) (slm_La ops) (\ _ _ _ -> True) (\ l -> [l]) (\ _ _ -> [])
    ();

slm_gen_to_sl_gen ::
  forall a b c d.
    ([(a, Nat)] ->
      [(a, Nat)] ->
        Sum ([Prelude.Char] -> [Prelude.Char]) (Slm_ops_ext a b c ())) ->
      [(a, Nat)] ->
        [(a, Nat)] ->
          Sum ([Prelude.Char] -> [Prelude.Char]) (Sl_ops_ext a b c d ());
slm_gen_to_sl_gen gen =
  (\ f g -> bindb (gen f g) (\ ops -> Inr (slm_to_sl ops)));

check_sl_lab_trs ::
  forall a b c d.
    (Eq a, Showa a, Showa b, Eq d,
      Showa d) => (a -> [b] -> b) ->
                    (a -> [b] -> c) ->
                      [b] ->
                        (b -> b -> Bool) ->
                          (a -> Nat -> c -> a) ->
                            [(Term a d, Term a d)] ->
                              [(Term a d, Term a d)] ->
                                Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_sl_lab_trs i l c cge label lP p =
  catcha (forallM (check_sl_rule i l label c cge False lP) p)
    (\ x -> Inl (snd x));

sem_lab_proc ::
  forall a b c d.
    (Eq a, Showa a, Eq d,
      Showa d) => (a -> (a, b)) ->
                    Dpp_ops_ext c a d () ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) () ->
                        ([Term a d] ->
                          [Term a d] ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                          ([(Term a d, Term a d)] ->
                            [(Term a d, Term a d)] ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                            ([(Term a d, Term a d)] ->
                              [(Term a d, Term a d)] ->
                                Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                              ([(Term a d, Term a d)] ->
                                [(Term a d, Term a d)] ->
                                  Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                                [(Term a d, Term a d)] ->
                                  [Term a d] ->
                                    [(Term a d, Term a d)] ->
                                      c ->
Sum ([Prelude.Char] -> [Prelude.Char]) c;
sem_lab_proc ld i valid check_Q check_laba check_lab check_model_lab lPAll lQ
  lRAll dpp =
  let {
    r = rc i dpp;
    rw = rwc i dpp;
    pw = pwa i dpp;
    p = pb i dpp;
    nfs = nfsc i dpp;
    m = minimal i dpp;
    (lP, (lPw, _)) = model_splitter ld lPAll pw;
    (lR, (lRw, _)) = model_splitter ld lRAll rw;
  } in (case bindb valid
               (\ _ ->
                 let {
                   q = qc i dpp;
                 } in catcha
                        (bindb
                          (check
                            (if nfs
                              then (if not (q_emptyc i dpp)
                                     then wwf_rulesa i dpp else True)
                              else True)
                            (shows_prec_list Zero_nat
                              ['w', 'e', 'l', 'l', ' ', 'f', 'o', 'r', 'm', 'e',
                                'd', 'n', 'e', 's', 's', ' ', 'r', 'e', 'q',
                                'u', 'i', 'r', 'e', 'd']))
                          (\ _ ->
                            bindb (check_Q lQ q)
                              (\ _ ->
                                bindb (check_sl_Qa ld lQ q)
                                  (\ _ ->
                                    bindb (check_laba lP p)
                                      (\ _ ->
bindb (check_laba lPw pw)
  (\ _ ->
    bindb (check_model_lab lR r)
      (\ _ ->
        bindb (check_model_lab lRw rw)
          (\ _ -> bindb (check_lab lR r) (\ _ -> check_lab lRw rw)))))))))
                        (\ x ->
                          Inl (shows_string
                                 ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'd',
                                   'u', 'r', 'i', 'n', 'g', ' ', 'l', 'a', 'b',
                                   'e', 'l', 'i', 'n', 'g', ':'] .
                                shows_nl . x)))
         of {
         Inl a -> Inl a;
         Inr _ -> Inr (mkc i nfs m lP lPw lQ lR lRw);
       });

sem_lab_fin_proc ::
  forall a b c d e.
    (Eq a, Showa a, Eq d, Showa d, Eq e,
      Showa e) => (a -> Nat -> b -> a) ->
                    (a -> (a, b)) ->
                      Dpp_ops_ext c a d () ->
                        ([(a, Nat)] ->
                          [(a, Nat)] ->
                            Sum ([Prelude.Char] -> [Prelude.Char])
                              (Sl_ops_ext a e b d ())) ->
                          [(Term a d, Term a d)] ->
                            [Term a d] ->
                              [(Term a d, Term a d)] ->
                                c -> Sum ([Prelude.Char] -> [Prelude.Char]) c;
sem_lab_fin_proc lc ld i gen lPAll lQ lRAll dp =
  bindb (gen (list_union (funas_trs_list (rulesd i dp))
               (funas_args_trs_list (pairsa i dp)))
          [])
    (\ ops ->
      let {
        check_q = check_sl_Q (sl_I ops) (sl_L ops) lc (sl_C ops);
        check_ml =
          check_sl_model_lab_trs (sl_I ops) (sl_L ops) (sl_C ops)
            (\ a b -> a == b) lc;
        check_l =
          check_sl_lab_trs (sl_I ops) (sl_L ops) (sl_C ops) (\ a b -> a == b)
            lc;
        check_la = check_sl_lab (sl_I ops) (sl_L ops) lc (sl_C ops);
      } in sem_lab_proc ld i (Inr ()) check_q check_l check_la check_ml lPAll lQ
             lRAll dp);

get_largest_element :: forall a. Sl_inter a -> Nat;
get_largest_element (SL_Inter n uu) = n;

take_default :: forall a. a -> [a] -> Nat -> a;
take_default def [] uu = def;
take_default uv (x : xs) i =
  (if equal_nat i Zero_nat then x
    else take_default uv xs (minus_nat i (Nat_of_num One)));

eval_arithFun :: Nat -> [Nat] -> ArithFun -> Nat;
eval_arithFun c nats f = mod_nat (eval_arithFun_unbound c nats f) c;

eval_arithFun_unbound :: Nat -> [Nat] -> ArithFun -> Nat;
eval_arithFun_unbound c nats (Arg i) = take_default Zero_nat nats i;
eval_arithFun_unbound c nats (Const n) = n;
eval_arithFun_unbound c nats (Sum []) = Zero_nat;
eval_arithFun_unbound c nats (Sum (f : fs)) =
  plus_nat (eval_arithFun c nats f) (eval_arithFun c nats (Sum fs));
eval_arithFun_unbound c nats (Prod []) = Nat_of_num One;
eval_arithFun_unbound c nats (Prod (f : fs)) =
  times_nat (eval_arithFun c nats f) (eval_arithFun c nats (Prod fs));
eval_arithFun_unbound c nats (Max [f]) = eval_arithFun c nats f;
eval_arithFun_unbound c nats (Max (f : v : va)) =
  max (eval_arithFun c nats f) (eval_arithFun c nats (Max (v : va)));
eval_arithFun_unbound c nats (Min [f]) = eval_arithFun c nats f;
eval_arithFun_unbound c nats (Min (f : v : va)) =
  min (eval_arithFun c nats f) (eval_arithFun c nats (Min (v : va)));
eval_arithFun_unbound c nats (IfEqual f1 f2 ft fe) =
  (if equal_nat (eval_arithFun c nats f1) (eval_arithFun c nats f2)
    then eval_arithFun c nats ft else eval_arithFun c nats fe);

sl_inter_to_inter :: forall a. (Eq a) => Sl_inter a -> a -> [Nat] -> Nat;
sl_inter_to_inter (SL_Inter c ls) fl cs =
  (case map_of ls (fl, size_list cs) of {
    Nothing -> Zero_nat;
    Just a -> eval_arithFun (plus_nat c (Nat_of_num One)) cs a;
  });

sli_to_slm ::
  forall a.
    (Eq a) => Sl_inter (Lab a [Nat]) ->
                Slm_ops_ext (Lab a [Nat]) Nat (Sum [Nat] [Lab a [Nat]]) ();
sli_to_slm sli =
  let {
    c = get_largest_element sli;
  } in Slm_ops_ext (\ _ -> Inl) (sl_inter_to_inter sli)
         (upt Zero_nat (plus_nat c (Nat_of_num One))) c (\ _ -> Inl) ();

enum_vectors_nat :: forall a. [a] -> Nat -> [[a]];
enum_vectors_nat c n =
  (if equal_nat n Zero_nat then [[]]
    else let {
           a = enum_vectors_nat c (minus_nat n (Nat_of_num One));
         } in concatMap (\ vec -> map (\ ca -> ca : vec) c) a);

qmodel_check_interpretation ::
  ArithFun -> Nat -> Nat -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
qmodel_check_interpretation f n c =
  let {
    ca = upt Zero_nat (plus_nat c (Nat_of_num One));
    css = enum_vectors_nat ca n;
  } in catcha
         (forallM
           (\ cs ->
             catcha
               (forallM
                 (\ i ->
                   catcha
                     (forallM
                       (\ l ->
                         check (less_eq_nat
                                 (eval_arithFun (plus_nat c (Nat_of_num One)) cs
                                   f)
                                 (eval_arithFun (plus_nat c (Nat_of_num One))
                                   (list_update cs i l) f))
                           (shows_prec_list Zero_nat
                              ['n', 'o', 't', ' ', 'm', 'o', 'n', 'o', 't', 'o',
                                'n', 'e', ' ', 'i', 'n', ' '] .
                             shows_prec_nat Zero_nat
                               (plus_nat i (Nat_of_num One)) .
                               shows_prec_list Zero_nat
                                 ['.', ' ', 'a', 'r', 'g', 'u', 'm', 'e', 'n',
                                   't']))
                       (upt (nth cs i) (plus_nat c (Nat_of_num One))))
                     (\ x -> Inl (snd x)))
                 (upt Zero_nat n))
               (\ x -> Inl (snd x)))
           css)
         (\ x -> Inl (snd x));

qmodel_check_valid ::
  forall a.
    (Showa a) => Sl_inter a -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
qmodel_check_valid (SL_Inter c ls) =
  catcha
    (forallM
      (\ (a, b) ->
        let {
          (f, n) = a;
        } in (\ g ->
               catcha (qmodel_check_interpretation g n c)
                 (\ x ->
                   Inl (shows_prec_list Zero_nat
                          ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n',
                            ' ', 'w', 'e', 'a', 'k', '-', 'm', 'o', 'n', 'o',
                            't', 'o', 'n', 'i', 'c', 'i', 't', 'y', ' ', 'o',
                            'f', ' ', 'i', 'n', 't', 'e', 'r', 'p', 'r', 'e',
                            't', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f', ' '] .
                         shows_prec Zero_nat f . shows_nl . x)))
          b)
      ls)
    (\ x -> Inl (snd x));

check_decr_present_aux_1 ::
  forall a b.
    (Eq a,
      Eq b) => [(Term a (b, Nat), Term a (b, Nat))] ->
                 b -> a -> a -> Nat ->
                                  Sum (Term a (b, Nat), Term a (b, Nat)) ();
check_decr_present_aux_1 r v f1 f2 n =
  let {
    vs = map (\ na -> Var (v, na)) (upt Zero_nat n);
    rule = (Fun f1 vs, Fun f2 vs);
  } in check (not (is_none (find (instance_rule rule) r))) rule;

check_decr_present_aux_2 ::
  forall a b.
    (Eq a,
      Eq b) => [(Term a b, Term a b)] ->
                 b -> [(a, (a, Nat))] ->
                        Sum (Term a (b, Nat), Term a (b, Nat)) ();
check_decr_present_aux_2 r v req =
  let {
    add_nats = map_vars (\ va -> (va, Zero_nat));
    ra = map (\ (l, ra) -> (add_nats l, add_nats ra)) r;
  } in catcha
         (forallM (\ (f1, (a, b)) -> check_decr_present_aux_1 ra v f1 a b) req)
         (\ x -> Inl (snd x));

check_decr_present ::
  forall a b.
    (Eq a,
      Eq b) => [(a, Nat)] ->
                 (a -> [Nat] -> a) ->
                   b -> Nat ->
                          [(Term a b, Term a b)] ->
                            Sum (Term a (b, Nat), Term a (b, Nat)) ();
check_decr_present sig l v c r =
  let {
    ca = upt Zero_nat (plus_nat c (Nat_of_num One));
    ls = (\ (f, n) ->
           concatMap
             (\ cs ->
               concatMap
                 (\ i ->
                   let {
                     ci = nth cs i;
                   } in (if less_nat ci c
                          then [(l f (list_update cs i
                                       (plus_nat ci (Nat_of_num One))),
                                  (l f cs, n))]
                          else []))
                 (upt Zero_nat n))
             (enum_vectors_nat ca n));
  } in check_decr_present_aux_2 r v (concatMap ls sig);

qmodel_check_decr ::
  forall a b.
    (Eq a, Showa a,
      Eq b) => [(Lab a [Nat], Nat)] ->
                 b -> Nat ->
                        [(Term (Lab a [Nat]) b, Term (Lab a [Nat]) b)] ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ();
qmodel_check_decr sig v c =
  (\ lR ->
    catcha (check_decr_present sig Lab v c lR)
      (\ x ->
        Inl (let {
               display =
                 map_vars
                   (\ (_, n) ->
                     (shows_prec_list Zero_nat ['x'] .
                       shows_prec_nat Zero_nat n)
                       []);
             } in shows_prec_list Zero_nat
                    ['d', 'e', 'c', 'r', 'e', 'a', 's', 'i', 'n', 'g', ' ', 'r',
                      'u', 'l', 'e', ' '] .
                    shows_rule (shows_prec_lab Zero_nat)
                      (shows_prec_list Zero_nat) [' ', '-', '>', ' ']
                      (display (fst x), display (snd x)) .
                      shows_prec_list Zero_nat
                        [' ', 'm', 'i', 's', 's', 'i', 'n', 'g'])));

qmodel_LS_gen ::
  forall a b c. (Eq a) => [(a, Nat)] -> [b] -> a -> Nat -> [Sum [b] c];
qmodel_LS_gen sig ls =
  (\ f n ->
    (if membera sig (f, n) then map Inl (enum_vectors_nat ls n) else [Inl []]));

pointwise_lgen :: [Nat] -> [[Nat]];
pointwise_lgen ns =
  concat_lists (map (\ n -> upt Zero_nat (plus_nat n (Nat_of_num One))) ns);

qmodel_lgen :: forall a. Sum [Nat] a -> [Sum [Nat] a];
qmodel_lgen l =
  (case l of {
    Inl ns -> map Inl (pointwise_lgen ns);
    Inr _ -> [];
  });

qmodel_LSa :: forall a. Lab a [Nat] -> Nat -> Sum [Nat] [Lab a [Nat]] -> Bool;
qmodel_LSa = (\ _ _ a -> (case a of {
                           Inl _ -> True;
                           Inr _ -> False;
                         }));

qmodel_LS ::
  forall a b c.
    (Eq a, Eq b, Eq c) => [(a, Nat)] -> [b] -> a -> Nat -> Sum [b] c -> Bool;
qmodel_LS sig ls = (\ f n -> membera (qmodel_LS_gen sig ls f n));

qmodel_L ::
  forall a b c d.
    (Eq a, Eq b) => [(Lab a b, Nat)] -> Lab a b -> [c] -> Sum [c] d;
qmodel_L sig =
  (\ f cs -> (if membera sig (f, size_list cs) then Inl cs else Inl []));

qsli_to_sl_unsafe ::
  forall a b.
    (Eq a, Eq b,
      Showa b) => a -> [(Lab b [Nat], Nat)] ->
                         [(Lab b [Nat], Nat)] ->
                           Sl_inter (Lab b [Nat]) ->
                             Sl_ops_ext (Lab b [Nat]) Nat
                               (Sum [Nat] [Lab b [Nat]]) a ();
qsli_to_sl_unsafe v f g sli =
  let {
    c = get_largest_element sli;
    ca = upt Zero_nat (plus_nat c (Nat_of_num One));
  } in Sl_ops_ext (qmodel_L f) (qmodel_LS f ca) (sl_inter_to_inter sli) ca c
         (qmodel_check_decr f v c) (qmodel_L g) qmodel_LSa qmodel_lgen
         (qmodel_LS_gen f ca) ();

qsli_to_sl ::
  forall a b.
    (Eq a, Eq b,
      Showa b) => a -> [(Lab b [Nat], Nat)] ->
                         [(Lab b [Nat], Nat)] ->
                           Sl_inter (Lab b [Nat]) ->
                             Sum ([Prelude.Char] -> [Prelude.Char])
                               (Sl_ops_ext (Lab b [Nat]) Nat
                                 (Sum [Nat] [Lab b [Nat]]) a ());
qsli_to_sl v f g sli =
  bindb (qmodel_check_valid sli) (\ _ -> Inr (qsli_to_sl_unsafe v f g sli));

pointwise_ext ::
  forall a. (a -> a -> (Bool, Bool)) -> [a] -> [a] -> (Bool, Bool);
pointwise_ext f [] [] = (False, True);
pointwise_ext f (uu : uv) [] = (False, False);
pointwise_ext f [] (uw : ux) = (False, False);
pointwise_ext f (a : asa) (b : bs) =
  (case f a b of {
    (stri, True) ->
      (case pointwise_ext f asa bs of {
        (strir, True) -> (stri || strir, True);
        (strir, False) -> (False, False);
      });
    (stri, False) -> (False, False);
  });

qmodel_lge :: forall a b c d. a -> b -> Sum [Nat] c -> Sum [Nat] d -> Bool;
qmodel_lge f n =
  (\ l r ->
    (case (l, r) of {
      (Inl cs1, Inl cs2) ->
        snd (pointwise_ext (\ x y -> (less_nat y x, less_eq_nat y x)) cs1 cs2);
      (Inl cs1, Inr _) -> False;
      (Inr _, b) -> False;
    }));

qmodel_cge :: Nat -> Nat -> Bool;
qmodel_cge = (\ x y -> less_eq_nat y x);

rl_slm ::
  forall a b.
    (Eq a,
      Eq b) => Maybe (Lab a b, Nat) ->
                 [(Lab a b, Nat)] ->
                   [(Lab a b, Nat)] ->
                     Sum ([Prelude.Char] -> [Prelude.Char])
                       (Slm_ops_ext (Lab a b) (Lab a b) (Sum b [Lab a b]) ());
rl_slm delt_opt pre_fs g =
  let {
    fs = (if is_none delt_opt then pre_fs
           else filter (\ f -> not (f == the delt_opt)) pre_fs);
  } in bindb (check (not (null fs))
               (shows_string
                  ['r', 'o', 'o', 't', '-', 'l', 'a', 'b', 'e', 'l', 'i', 'n',
                    'g', ' ', 'r', 'e', 'q', 'u', 'i', 'r', 'e', 's', ' ', 'a',
                    't', ' ', 'l', 'e', 'a', 's', 't', ' ', 'o', 'n', 'e', ' ',
                    'f', 'u', 'n', 'c', 't', 'i', 'o', 'n', ' ', 's', 'y', 'm',
                    'b', 'o', 'l', ' ', 'i', 'n', ' ', 't', 'h', 'e', ' ', 's',
                    'i', 'g', 'n', 'a', 't', 'u', 'r', 'e'] .
                 shows_nl))
         (\ _ ->
           let {
             f = fst (hd fs);
           } in Inr (Slm_ops_ext (\ _ -> Inr)
                      (\ ga cs ->
                        (if membera fs (ga, size_list cs) then ga else f))
                      (map fst fs) f
                      (if is_none delt_opt then (\ _ -> Inr)
                        else (\ _ gs ->
                               Inr (replicate (size_list gs)
                                     (fst (the delt_opt)))))
                      ()));

semlab_fin_proc ::
  forall a b c.
    (Eq b, Showa b, Ceq c, Corder c, Eq c, Set_impla c,
      Showa c) => Dpp_ops_ext a (Lab b [Nat]) c () ->
                    Sl_variant (Lab b [Nat]) c ->
                      [(Term (Lab b [Nat]) c, Term (Lab b [Nat]) c)] ->
                        [Term (Lab b [Nat]) c] ->
                          [(Term (Lab b [Nat]) c, Term (Lab b [Nat]) c)] ->
                            a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
semlab_fin_proc j (Rootlab Nothing) =
  sem_lab_fin_proc label label_decomp j (slm_gen_to_sl_gen (rl_slm Nothing));
semlab_fin_proc j (Rootlab (Just d)) =
  sem_lab_fin_root_proc label label_decomp j
    (slm_gen_to_sl_gen (rl_slm (Just d)));
semlab_fin_proc j (Finitelab sli) =
  sem_lab_fin_proc label label_decomp j
    (slm_gen_to_sl_gen (\ _ _ -> Inr (sli_to_slm sli)));
semlab_fin_proc j (QuasiFinitelab sli v) =
  sem_lab_fin_quasi_root_proc label label_decomp qmodel_cge qmodel_lge j
    (\ f g -> qsli_to_sl v f g sli);

partition_rules ::
  forall a b.
    (Eq a,
      Eq b) => [Ctxt a b] ->
                 [(Term a b, Term a b)] ->
                   [(Term a b, Term a b)] ->
                     ([(Term a b, Term a b)], [(Term a b, Term a b)]);
partition_rules cs r =
  partition
    (\ lr ->
      any (\ (u, v) ->
            any (\ c -> lr == (ctxt_apply c u, ctxt_apply c v)) (Hole : cs))
        r);

strip_unary_root :: forall a b. (Eq a) => a -> Term a b -> Term a b;
strip_unary_root f (Fun g [t]) = (if f == g then t else Fun g [t]);
strip_unary_root f (Var v) = Var v;
strip_unary_root f (Fun v []) = Fun v [];
strip_unary_root f (Fun v (vb : vd : ve)) = Fun v (vb : vd : ve);

has_unary_root :: forall a b. (Eq a) => a -> Term a b -> Bool;
has_unary_root f (Fun g [t]) = f == g;
has_unary_root f (Var v) = False;
has_unary_root f (Fun v []) = False;
has_unary_root f (Fun v (vb : vd : ve)) = False;

unblock_term :: forall a b. (Eq a) => a -> Term a b -> Term a b;
unblock_term f (Fun g ts) =
  (if all (has_unary_root f) ts then Fun g (map (strip_unary_root f) ts)
    else Fun g ts);
unblock_term f (Var v) = Var v;

unblock_rule ::
  forall a b. (Eq a) => a -> (Term a b, Term a b) -> (Term a b, Term a b);
unblock_rule f r = (unblock_term f (fst r), unblock_term f (snd r));

partition_pairs ::
  forall a b.
    (Eq a,
      Eq b) => a -> [(Term a b, Term a b)] ->
                      [(Term a b, Term a b)] ->
                        ([(Term a b, Term a b)], [(Term a b, Term a b)]);
partition_pairs f p = partition (\ r -> membera p (unblock_rule f r));

check_no_defined_root_defs ::
  forall a b.
    (Eq a, Showa a,
      Showa b) => [(a, Nat)] ->
                    Term a b -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_no_defined_root_defs f t =
  check (not (membera f (the (root t))))
    (shows_string ['t', 'h', 'e', ' ', 'r', 'o', 'o', 't', ' ', 'o', 'f', ' '] .
      shows_prec_term Zero_nat t .
        shows_string [' ', 'i', 's', ' ', 'd', 'e', 'f', 'i', 'n', 'e', 'd']);

block_term :: forall a b. a -> Term a b -> Term a b;
block_term f (Var x) = Var x;
block_term f (Fun g ts) = Fun g (map (\ t -> Fun f [t]) ts);

block_rule :: forall a b. a -> (Term a b, Term a b) -> (Term a b, Term a b);
block_rule f r = (block_term f (fst r), block_term f (snd r));

check_superset_of_blocked ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => a -> [(Term a b, Term a b)] ->
                         [(Term a b, Term a b)] ->
                           Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_superset_of_blocked f pa p =
  catcha
    (catcha
      (catcha
        (forallM
          (\ x -> (if membera pa (block_rule f x) then Inr () else Inl x)) p)
        (\ x -> Inl (snd x)))
      (\ x ->
        Inl (shows_string ['t', 'h', 'e', ' ', 'r', 'u', 'l', 'e', ' '] .
              shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                [' ', '-', '>', ' '] (block_rule f x) .
                shows_string
                  [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n', 'g'] .
                  shows_nl)))
    (\ x ->
      Inl (shows_trs (shows_prec Zero_nat) (shows_prec Zero_nat)
             ['r', 'e', 'w', 'r', 'i', 't', 'e', ' ', 's', 'y', 's', 't', 'e',
               'm', ':']
             [' ', '-', '>', ' '] p .
            shows_string
              ['i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 's', 'u', 'b', 's',
                'e', 't', ' ', 'o', 'f'] .
              shows_trs (shows_prec Zero_nat) (shows_prec Zero_nat)
                ['r', 'e', 'w', 'r', 'i', 't', 'e', ' ', 's', 'y', 's', 't',
                  'e', 'm', ':']
                [' ', '-', '>', ' '] pa .
                x . shows_nl));

hole_at :: forall a b. (Eq a) => Nat -> Nat -> a -> Ctxt a b -> Bool;
hole_at n i f (More g ss1 Hole ss2) =
  g == f &&
    equal_nat (size_list ss1) i &&
      equal_nat (size_list ss2) (minus_nat (minus_nat n i) (Nat_of_num One));
hole_at n i f Hole = False;
hole_at n i f (More v va (More vd ve vf vg) vc) = False;

check_flat_ctxt_complete ::
  forall a b.
    (Eq a, Showa a,
      Showa b) => [Ctxt a b] ->
                    (a, Nat) -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_flat_ctxt_complete fcs fa =
  check (all_interval_nat (\ i -> any (hole_at (snd fa) i (fst fa)) fcs)
          Zero_nat (snd fa))
    (shows_string
       ['t', 'h', 'e', ' ', 'l', 'i', 's', 't', ' ', 'o', 'f', ' ', 'f', 'l',
         'a', 't', ' ', 'c', 'o', 'n', 't', 'e', 'x', 't', 's', ' ', 'i', 's',
         ' ', 'i', 'n', 'c', 'o', 'm', 'p', 'l', 'e', 't', 'e'] .
      shows_nl);

check_rule_reflecting ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [Ctxt a b] ->
                    [(Term a b, Term a b)] ->
                      (Term a b, Term a b) ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_rule_reflecting fcs rs rule =
  check (any (\ (l, r) ->
               any (\ c ->
                     equal_term (fst rule) (ctxt_apply c l) &&
                       equal_term (snd rule) (ctxt_apply c r))
                 (Hole : fcs))
          rs)
    (shows_string ['t', 'h', 'e', ' ', 'r', 'u', 'l', 'e', ' '] .
      shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
        [' ', '-', '>', ' '] rule .
        shows_string
          [' ', 'i', 's', ' ', 'n', 'e', 'i', 't', 'h', 'e', 'r', ' ', 'c', 'o',
            'n', 't', 'a', 'i', 'n', 'e', 'd', ' ', 'i', 'n', ' ', 't', 'h',
            'e', ' ', 'o', 'r', 'i', 'g', 'i', 'n', 'a', 'l', ' ', 's', 'e',
            't', ' ', 'o', 'f', ' ', 'r', 'u', 'l', 'e', 's', ' ', 'n', 'o',
            'r', ' ', 'o', 'b', 't', 'a', 'i', 'n', 'e', 'd', ' ', 'b', 'y',
            ' ', 'a', 'p', 'p', 'l', 'y', 'i', 'n', 'g', ' ', 'a', ' ', 'f',
            'l', 'a', 't', ' ', 'c', 'o', 'n', 't', 'e', 'x', 't'] .
          shows_nl);

check_rule_preserving ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [Ctxt a b] ->
                    [(Term a b, Term a b)] ->
                      (Term a b, Term a b) ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_rule_preserving fcs rs rule =
  check (membera rs rule ||
          all (\ c ->
                membera rs (ctxt_apply c (fst rule), ctxt_apply c (snd rule)))
            fcs)
    (shows_string ['t', 'h', 'e', ' ', 'r', 'u', 'l', 'e', ' '] .
      shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
        [' ', '-', '>', ' '] rule .
        shows_string
          [' ', 'i', 's', ' ', 'n', 'e', 'i', 't', 'h', 'e', 'r', ' ', 'c', 'o',
            'n', 't', 'a', 'i', 'n', 'e', 'd', ' ', 'i', 'n', ' ', 't', 'h',
            'e', ' ', 'r', 'e', 's', 'u', 'l', 't', 'i', 'n', 'g', ' ', 's',
            'e', 't', ' ', 'o', 'f', ' ', 'r', 'u', 'l', 'e', 's', ' ', 'n',
            'o', 'r', ' ', 'c', 'l', 'o', 's', 'e', 'd', ' ', 'u', 'n', 'd',
            'e', 'r', ' ', 'a', 'l', 'l', ' ', 'f', 'l', 'a', 't', ' ', 'c',
            'o', 'n', 't', 'e', 'x', 't', 's'] .
          shows_nl);

is_flat_ctxt_list ::
  forall a b. (Eq a, Eq b) => [a] -> [(b, Nat)] -> Ctxt b a -> Bool;
is_flat_ctxt_list vs fas (More f ss1 Hole ss2) =
  let {
    ss = ss1 ++ ss2;
  } in membera fas (f, plus_nat (size_list ss) (Nat_of_num One)) &&
         all is_Var ss && distinct ss && null (list_inter (map the_Var ss) vs);
is_flat_ctxt_list vs fas Hole = False;
is_flat_ctxt_list vs fas (More v va (More vd ve vf vg) vc) = False;

shows_prec_ctxt ::
  forall a b.
    (Showa a, Showa b) => Nat -> Ctxt a b -> [Prelude.Char] -> [Prelude.Char];
shows_prec_ctxt d c = shows_ctxt (shows_prec Zero_nat) (shows_prec Zero_nat) c;

check_is_flat_ctxt ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [a] ->
                    [(b, Nat)] ->
                      Ctxt b a -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_is_flat_ctxt vs fas c =
  check (is_flat_ctxt_list vs fas c)
    (shows_prec_ctxt Zero_nat c .
      shows_string
        [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'f', 'l', 'a', 't',
          ' ', 'c', 'o', 'n', 't', 'e', 'x', 't'] .
        shows_nl);

check_flat_ctxt ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [a] -> Ctxt b a -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_flat_ctxt vs c =
  (case c of {
    Hole ->
      Inl (shows_prec_ctxt Zero_nat c .
            shows_string
              [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'f', 'l', 'a',
                't', ' ', 'c', 'o', 'n', 't', 'e', 'x', 't'] .
              shows_nl);
    More _ ss1 Hole ss2 ->
      let {
        ss = ss1 ++ ss2;
      } in bindb (check (distinct ss)
                   (shows_prec_ctxt Zero_nat c .
                     shows_string
                       [' ', 'c', 'o', 'n', 't', 'a', 'i', 'n', 's', ' ', 'd',
                         'u', 'p', 'l', 'i', 'c', 'a', 't', 'e', ' ', 'v', 'a',
                         'r', 'i', 'a', 'b', 'l', 'e', 's'] .
                       shows_nl))
             (\ _ ->
               bindb (check (all is_Var ss)
                       (shows_prec_ctxt Zero_nat c .
                         shows_string
                           [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'f', 'l',
                             'a', 't', ',', ' ', 'i', '.', 'e', '.', ',', ' ',
                             'h', 'a', 's', ' ', 'd', 'e', 'p', 't', 'h', ' ',
                             'g', 'r', 'e', 'a', 't', 'e', 'r', ' ', 't', 'h',
                             'a', 'n', ' ', 'o', 'n', 'e'] .
                           shows_nl))
                 (\ _ ->
                   check (all (\ t -> not (membera vs (the_Var t)))
                           (ss1 ++ ss2))
                     (shows_prec_ctxt Zero_nat c .
                       shows_string
                         [' ', 'h', 'a', 's', ' ', 't', 'o', ' ', 'c', 'o', 'n',
                           't', 'a', 'i', 'n', ' ', 'o', 'n', 'l', 'y', ' ',
                           'f', 'r', 'e', 's', 'h', ' ', 'v', 'a', 'r', 'i',
                           'a', 'b', 'l', 'e', 's'] .
                         shows_nl)));
    More _ ss1 (More _ _ _ _) ss2 ->
      Inl (shows_prec_ctxt Zero_nat c .
            shows_string
              [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'f', 'l', 'a',
                't', ' ', 'c', 'o', 'n', 't', 'e', 'x', 't'] .
              shows_nl);
  });

shows_terms ::
  forall a b.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      (b -> [Prelude.Char] -> [Prelude.Char]) ->
        [Prelude.Char] -> [Term a b] -> [Prelude.Char] -> [Prelude.Char];
shows_terms fun var name ts =
  shows_string name .
    shows_nl .
      shows_list_gen (shows_term fun var) [] [] [newline] [] ts . shows_nl;

shows_dpp ::
  forall a b c.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      (b -> [Prelude.Char] -> [Prelude.Char]) ->
        Dpp_ops_ext c a b () -> c -> [Prelude.Char] -> [Prelude.Char];
shows_dpp fun var i d =
  let {
    m = minimal i d;
    nfs = nfsc i d;
    p = pb i d;
    pw = pwa i d;
    r = rc i d;
    rw = rwc i d;
    q = qc i d;
  } in shows_trs fun var ['p', 'a', 'i', 'r', 's', ':'] [' ', '-', '>', ' '] p .
         (if null pw then id
           else shows_trs fun var
                  ['w', 'e', 'a', 'k', ' ', 'p', 'a', 'i', 'r', 's', ':']
                  [' ', '-', '>', '=', ' '] pw) .
           (if null r then id
             else shows_trs fun var
                    ['s', 't', 'r', 'i', 'c', 't', ' ', 'r', 'u', 'l', 'e', 's',
                      ':']
                    [' ', '-', '>', '!', ' '] r) .
             shows_trs fun var ['r', 'u', 'l', 'e', 's', ':']
               [' ', '-', '>', ' '] rw .
               (if null q then id
                 else shows_terms fun var
                        ['Q', '-', 'c', 'o', 'm', 'p', 'o', 'n', 'e', 'n', 't',
                          ':']
                        q) .
                 (if m then shows_nl .
                              shows_prec_list Zero_nat
                                ['(', 'm', 'i', 'n', 'i', 'm', 'a', 'l', ')']
                   else id) .
                   (if nfs && not (null q)
                     then shows_nl .
                            shows_prec_list Zero_nat
                              ['(', 'n', 'o', 'r', 'm', 'a', 'l', ' ', 'f', 'o',
                                'r', 'm', ' ', 's', 'u', 'b', 's', 't', 'i',
                                't', 'u', 't', 'i', 'o', 'n', 's', ')']
                     else id);

fcc_proc_cond ::
  forall a b c.
    (Eq b, Showa b, Eq c,
      Showa c) => Dpp_ops_ext a b c () ->
                    b -> [Ctxt b c] ->
                           [(Term b c, Term b c)] ->
                             [(Term b c, Term b c)] ->
                               [(Term b c, Term b c)] ->
                                 [(Term b c, Term b c)] ->
                                   a -> Sum ([Prelude.Char] -> [Prelude.Char])
  a;
fcc_proc_cond i f fcs p pw r rw dpp =
  let {
    pa = pb i dpp;
    pwaa = pwa i dpp;
    ra = rc i dpp;
    rwa = rwc i dpp;
    nfs = nfsc i dpp;
    m = minimal i dpp;
    new_dpp = mkc i nfs m p pw [] r rw;
  } in (case catcha
               (let {
                  pba = list_union pa pwaa;
                  rb = list_union ra rwa;
                  rba = list_union r rw;
                  fa = (f, Nat_of_num One);
                  cf = More f [] Hole [];
                  fcsa = cf : fcs;
                  vs = vars_trs_list rb;
                  fs = list_union (funas_trs_list rb) (funas_args_trs_list pba);
                  fas = fa : fs;
                  ds = defs_list rb;
                } in bindb (check (not (membera ds fa))
                             (shows_prec Zero_nat f .
                               shows_string
                                 ['i', 's', ' ', 'n', 'o', 't', ' ', 'f', 'r',
                                   'e', 's', 'h'] .
                                 shows_nl))
                       (\ _ ->
                         bindb (check_wf_trs rb)
                           (\ _ ->
                             bindb (catcha
                                     (forallM
                                       (\ rd ->
 bindb (check_no_var (fst rd))
   (\ _ ->
     bindb (check_no_var (snd rd))
       (\ _ -> check_no_defined_root_defs ds (snd rd))))
                                       pba)
                                     (\ x -> Inl (snd x)))
                               (\ _ ->
                                 bindb (catcha
 (forallM (check_flat_ctxt vs) fcsa) (\ x -> Inl (snd x)))
                                   (\ _ ->
                                     bindb (catcha
     (forallM (check_is_flat_ctxt vs fas) fcsa) (\ x -> Inl (snd x)))
                                       (\ _ ->
 bindb (catcha (forallM (check_flat_ctxt_complete fcsa) fas)
         (\ x -> Inl (snd x)))
   (\ _ ->
     bindb (catcha (forallM (check_rule_preserving fcsa r) ra)
             (\ x -> Inl (snd x)))
       (\ _ ->
         bindb (catcha (forallM (check_rule_preserving fcsa rba) rwa)
                 (\ x -> Inl (snd x)))
           (\ _ ->
             bindb (catcha (forallM (check_rule_reflecting fcsa rb) rba)
                     (\ x -> Inl (snd x)))
               (\ _ ->
                 bindb (check_superset_of_blocked f p pa)
                   (\ _ -> check_superset_of_blocked f pw pwaa)))))))))))
               (\ x ->
                 Inl (shows_prec_list Zero_nat
                        ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e',
                          'n', ' ', 'c', 'h', 'e', 'c', 'k', 'i', 'n', 'g', ' ',
                          'f', 'l', 'a', 't', ' ', 'c', 'o', 'n', 't', 'e', 'x',
                          't', ' ', 'c', 'l', 'o', 's', 'u', 'r', 'e', ' ', 'c',
                          'o', 'n', 'd', 'i', 't', 'i', 'o', 'n', 's', ' ', 't',
                          'o', ' ', 's', 'w', 'i', 't', 'c', 'h', ' ', 'f', 'r',
                          'o', 'm', ' '] .
                       shows_nl .
                         shows_dpp (shows_prec Zero_nat) (shows_prec Zero_nat) i
                           dpp .
                           shows_nl .
                             shows_prec_list Zero_nat
                               ['t', 'o', ' ', 't', 'h', 'e', ' ', 'D', 'P',
                                 ' ', 'p', 'r', 'o', 'b', 'l', 'e', 'm', ' '] .
                               shows_nl .
                                 shows_dpp (shows_prec Zero_nat)
                                   (shows_prec Zero_nat) i new_dpp .
                                   shows_nl . x))
         of {
         Inl a -> Inl a;
         Inr _ -> Inr new_dpp;
       });

ceta_list_diff :: forall a. (Key a) => [a] -> [a] -> [a];
ceta_list_diff xs ys =
  rs_to_list (foldl (\ a b -> rs_delete b a) (list_to_rs xs) ys);

fcc_split_proc ::
  forall a b c.
    (Eq b, Key b, Showa b, Ceq c, Corder c, Eq c, Key c, Set_impla c,
      Showa c) => Dpp_ops_ext a b c () ->
                    b -> [Ctxt b c] ->
                           [(Term b c, Term b c)] ->
                             [(Term b c, Term b c)] ->
                               [(Term b c, Term b c)] ->
                                 [(Term b c, Term b c)] ->
                                   a -> Sum ([Prelude.Char] -> [Prelude.Char])
  (a, a);
fcc_split_proc i f fcs pba rb ps rs dpp =
  let {
    p = pb i dpp;
    pw = pwa i dpp;
    r = rc i dpp;
    rw = rwc i dpp;
    q = qc i dpp;
    nfs = nfsc i dpp;
    m = minimal i dpp;
    pbaa = list_union p pw;
    rba = rw;
    pns = ceta_list_diff pbaa ps;
    rns = ceta_list_diff rba rs;
    (pa, pwaa) = partition_pairs f ps pba;
    (ra, rwa) = partition_rules (More f [] Hole [] : fcs) rs rb;
    two = mkc i nfs m (ceta_list_diff p ps) (ceta_list_diff pw ps) [] [] rns;
    dpp_mid = mkc i nfs m ps pns [] rs rns;
  } in bindb (bindb
               (catcha (check_subseteq ps pbaa)
                 (\ x ->
                   Inl (shows_prec_list Zero_nat ['p', 'a', 'i', 'r', ' '] .
                         shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                           [' ', '-', '>', ' '] x .
                           shows_prec_list Zero_nat
                             [' ', 's', 'h', 'o', 'u', 'l', 'd', ' ', 'b', 'e',
                               ' ', 'd', 'e', 'l', 'e', 't', 'e', 'd', ' ', 'b',
                               'u', 't', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ',
                               'p', 'r', 'e', 's', 'e', 'n', 't'])))
               (\ _ ->
                 bindb (catcha (check_subseteq rs rba)
                         (\ x ->
                           Inl (shows_prec_list Zero_nat
                                  ['r', 'u', 'l', 'e', ' '] .
                                 shows_rule (shows_prec Zero_nat)
                                   (shows_prec Zero_nat) [' ', '-', '>', ' ']
                                   x .
                                   shows_prec_list Zero_nat
                                     [' ', 's', 'h', 'o', 'u', 'l', 'd', ' ',
                                       'b', 'e', ' ', 'd', 'e', 'l', 'e', 't',
                                       'e', 'd', ' ', 'b', 'u', 't', ' ', 'i',
                                       's', ' ', 'n', 'o', 't', ' ', 'p', 'r',
                                       'e', 's', 'e', 'n', 't'])))
                   (\ _ ->
                     bindb (check (null q)
                             (shows_string
                                ['Q', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ',
                                  'e', 'm', 'p', 't', 'y'] .
                               shows_nl))
                       (\ _ ->
                         bindb (check (null r)
                                 (shows_prec_list Zero_nat
                                   ['s', 't', 'r', 'i', 'c', 't', ' ', 'r', 'u',
                                     'l', 'e', 's', ' ', 'n', 'o', 't', ' ',
                                     'a', 'l', 'l', 'o', 'w', 'e', 'd']))
                           (\ _ ->
                             bindb (check_left_linear_trs rw)
                               (\ _ ->
                                 fcc_proc_cond i f fcs pa pwaa ra rwa
                                   dpp_mid))))))
         (\ one -> Inr (one, two));

mono_ur_redpair_proc ::
  forall a b c.
    (Ceq b, Corder b, Eq b, Set_impla b, Showa b, Eq c,
      Showa c) => Dpp_ops_ext a b c () ->
                    Redtriple_ext b c () ->
                      [(Term b c, Term b c)] ->
                        [(Term b c, Term b c)] ->
                          [(Term b c, Term b c)] ->
                            a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
mono_ur_redpair_proc i rp premove rremove ur dpp =
  (case catcha
          (bindb
            (check (minimal i dpp)
              (shows_prec_list Zero_nat
                ['m', 'i', 'n', 'i', 'm', 'a', 'l', 'i', 't', 'y', ' ', 'r',
                  'e', 'q', 'u', 'i', 'r', 'e', 'd']))
            (\ _ ->
              bindb (check
                      (if nfsc i dpp
                        then (if not (q_emptyc i dpp) then wwf_rulesa i dpp
                               else True)
                        else True)
                      (shows_prec_list Zero_nat
                        ['w', 'e', 'l', 'l', ' ', 'f', 'o', 'r', 'm', 'e', 'd',
                          'n', 'e', 's', 's', ' ', 'r', 'e', 'q', 'u', 'i', 'r',
                          'e', 'd']))
                (\ _ ->
                  let {
                    p = pairsa i dpp;
                    us = foldr (sup_set . funas_term . snd) (p ++ ur) bot_set;
                    filt =
                      (\ lr -> ball (funas_term (fst lr)) (\ f -> member f us));
                    (pms, pns) = split_pairsa i dpp premove;
                    (ps, pnwf) = partition filt pms;
                    (urms, urns) = partition (membera rremove) ur;
                    (urs, urnwf) = partition filt urms;
                    rm = rules_mapb i dpp;
                  } in bindb (valid rp)
                         (\ _ ->
                           bindb (mono rp
                                   (ps ++ urs ++ urns ++ urnwf ++ pns ++ pnwf))
                             (\ _ ->
                               bindb (check_ur_P_closed_rm_af rm ur p full_af)
                                 (\ _ ->
                                   bindb (catcha
   (forallM
     (\ (l, _) ->
       check (not (is_Var l))
         (shows_prec_list Zero_nat
           ['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 's', ' ', 'a', 's', ' ',
             'l', 'h', 's', 's', ' ', 'n', 'o', 't', ' ', 'a', 'l', 'l', 'o',
             'w', 'e', 'd']))
     (rulesd i dpp))
   (\ x -> Inl (snd x)))
                                     (\ _ ->
                                       bindb
 (catcha (catcha (forallM (ns rp) (urns ++ urnwf)) (\ x -> Inl (snd x)))
   (\ x ->
     Inl (shows_string
            ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ',
              'o', 'r', 'i', 'e', 'n', 't', 'i', 'n', 'g', ' ', 'u', 's', 'a',
              'b', 'l', 'e', ' ', 'r', 'u', 'l', 'e', 's'] .
           shows_nl . x)))
 (\ _ ->
   bindb (catcha (catcha (forallM (s rp) urs) (\ x -> Inl (snd x)))
           (\ x ->
             Inl (shows_string
                    ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n',
                      ' ', 'o', 'r', 'i', 'e', 'n', 't', 'i', 'n', 'g', ' ',
                      'u', 's', 'a', 'b', 'l', 'e', ' ', 'r', 'u', 'l', 'e',
                      's'] .
                   shows_nl . x)))
     (\ _ ->
       bindb (catcha
               (catcha (forallM (ns rp) (pns ++ pnwf)) (\ x -> Inl (snd x)))
               (\ x ->
                 Inl (shows_string
                        ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e',
                          'n', ' ', 'o', 'r', 'i', 'e', 'n', 't', 'i', 'n', 'g',
                          ' ', 'D', 'P', 's'] .
                       shows_nl . x)))
         (\ _ ->
           catcha (catcha (forallM (s rp) ps) (\ x -> Inl (snd x)))
             (\ x ->
               Inl (shows_string
                      ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e',
                        'n', ' ', 'o', 'r', 'i', 'e', 'n', 't', 'i', 'n', 'g',
                        ' ', 'D', 'P', 's'] .
                     shows_nl . x))))))))))))
          (\ x ->
            Inl (shows_string
                   ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'a', 'p',
                     'p', 'l', 'y', ' ', 't', 'h', 'e', ' ', 'r', 'e', 'd', 'u',
                     'c', 't', 'i', 'o', 'n', ' ', 'p', 'a', 'i', 'r', ' ', 'p',
                     'r', 'o', 'c', 'e', 's', 's', 'o', 'r', ' ', 'w', 'i', 't',
                     'h', ' ', 't', 'h', 'e', ' ', 'f', 'o', 'l', 'l', 'o', 'w',
                     'i', 'n', 'g'] .
                  shows_nl . desca rp . shows_nl . x))
    of {
    Inl a -> Inl a;
    Inr _ ->
      Inr (delete_R_Rwc i (delete_P_Pwa i dpp premove premove) rremove rremove);
  });

mono_redpair_proc ::
  forall a b c.
    (Showa b,
      Showa c) => Dpp_ops_ext a b c () ->
                    Redtriple_ext b c () ->
                      [(Term b c, Term b c)] ->
                        [(Term b c, Term b c)] ->
                          a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
mono_redpair_proc i rp premove rremove dpp =
  (case catcha
          (let {
             (ps, pns) = split_pairsa i dpp premove;
             (rs, rns) = split_rulesc i dpp rremove;
           } in bindb (valid rp)
                  (\ _ ->
                    bindb (catcha (mono rp (ps ++ rs ++ pns ++ rns))
                            (\ x ->
                              Inl (shows_string
                                     ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ',
                                       'w', 'i', 't', 'h', ' ', 'm', 'o', 'n',
                                       'o', 't', 'o', 'n', 'i', 'c', 'i', 't',
                                       'y', ' ', 'o', 'f', ' ', 's', 't', 'r',
                                       'i', 'c', 't', ' ', 'o', 'r', 'd', 'e',
                                       'r'] .
                                    shows_nl . x)))
                      (\ _ ->
                        bindb (catcha
                                (catcha (forallM (ns rp) rns)
                                  (\ x -> Inl (snd x)))
                                (\ x ->
                                  Inl (shows_string
 ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ', 'o', 'r',
   'i', 'e', 'n', 't', 'i', 'n', 'g', ' ', 'T', 'R', 'S'] .
shows_nl . x)))
                          (\ _ ->
                            bindb (catcha
                                    (catcha (forallM (s rp) rs)
                                      (\ x -> Inl (snd x)))
                                    (\ x ->
                                      Inl
(shows_string
   ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ', 'o', 'r',
     'i', 'e', 'n', 't', 'i', 'n', 'g', ' ', 'T', 'R', 'S'] .
  shows_nl . x)))
                              (\ _ ->
                                bindb (catcha
(catcha (forallM (ns rp) pns) (\ x -> Inl (snd x)))
(\ x ->
  Inl (shows_string
         ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ', 'o',
           'r', 'i', 'e', 'n', 't', 'i', 'n', 'g', ' ', 'D', 'P', 's'] .
        shows_nl . x)))
                                  (\ _ ->
                                    catcha
                                      (catcha (forallM (s rp) ps)
(\ x -> Inl (snd x)))
                                      (\ x ->
Inl (shows_string
       ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ', 'o',
         'r', 'i', 'e', 'n', 't', 'i', 'n', 'g', ' ', 'D', 'P', 's'] .
      shows_nl . x))))))))
          (\ x ->
            Inl (shows_string
                   ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'a', 'p',
                     'p', 'l', 'y', ' ', 't', 'h', 'e', ' ', 'r', 'e', 'd', 'u',
                     'c', 't', 'i', 'o', 'n', ' ', 'p', 'a', 'i', 'r', ' ', 'p',
                     'r', 'o', 'c', 'e', 's', 's', 'o', 'r', ' ', 'w', 'i', 't',
                     'h', ' ', 't', 'h', 'e', ' ', 'f', 'o', 'l', 'l', 'o', 'w',
                     'i', 'n', 'g'] .
                  shows_nl . desca rp . shows_nl . x))
    of {
    Inl a -> Inl a;
    Inr _ ->
      Inr (delete_R_Rwc i (delete_P_Pwa i dpp premove premove) rremove rremove);
  });

instantiation_proc ::
  forall a b.
    (Eq b, Key b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    (Term b [Prelude.Char], Term b [Prelude.Char]) ->
                      [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                        a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
instantiation_proc i st sts dpp =
  (case let {
          ic = icap_impl_dpp_mv i dpp;
          isnf = is_QNFc i dpp;
          (s, t) = st;
          sy = map_vars (\ a -> 'y' : a) s;
          ty = map_vars (\ a -> 'y' : a) t;
          iedg = is_iedg_edge_dpp i dpp;
        } in catcha
               (forallM
                 (\ (u, v) ->
                   (case mgu_class (ic [u] v) s of {
                     Nothing -> Inr ();
                     Just mu ->
                       check (not (isnf (subst_apply_term sy mu)) ||
                               (not (isnf (subst_apply_term
    (map_vars (\ a -> 'x' : a) u) mu)) ||
                                 any (\ sta ->
                                       instance_rule sta st &&
 instance_rule (subst_apply_term sy mu, subst_apply_term ty mu) sta)
                                   sts))
                         (shows_prec_list Zero_nat
                            ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ',
                              'f', 'i', 'n', 'd', ' ', 'i', 'n', 's', 't', 'a',
                              'n', 'c', 'e', ' ', 'o', 'f', ' ', 'p', 'a', 'i',
                              'r', ' '] .
                           shows_rule (shows_prec Zero_nat)
                             (shows_prec_list Zero_nat) [' ', '-', '>', ' ']
                             (subst_apply_term sy mu, subst_apply_term ty mu) .
                             shows_nl .
                               shows_prec_list Zero_nat
                                 ['w', 'h', 'i', 'c', 'h', ' ', 'r', 'e', 's',
                                   'u', 'l', 't', 'e', 'd', ' ', 'f', 'r', 'o',
                                   'm', ' ', 'D', 'P', ' '] .
                                 shows_rule (shows_prec Zero_nat)
                                   (shows_prec_list Zero_nat)
                                   [' ', '-', '>', ' '] (u, v));
                   }))
                 (filter (\ (u, v) -> iedg (u, v) s) (pairsa i dpp)))
               (\ x -> Inl (snd x))
    of {
    Inl a -> Inl a;
    Inr _ -> Inr (replace_paira i dpp st sts);
  });

intersect_pairsa ::
  forall a b c d. Dpp_ops_ext a b c d -> a -> [(Term b c, Term b c)] -> a;
intersect_pairsa
  (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
    rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
    intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
    split_pairs split_rules mk minimal nfs wwf_rules more)
  = intersect_pairs;

rules_non_collapsinga :: forall a b c d. Dpp_ops_ext a b c d -> a -> Bool;
rules_non_collapsinga
  (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
    rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
    intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
    split_pairs split_rules mk minimal nfs wwf_rules more)
  = rules_non_collapsing;

reverse_rules_mapa ::
  forall a b c d.
    Dpp_ops_ext a b c d -> a -> (b, Nat) -> [(Term b c, Term b c)];
reverse_rules_mapa
  (Dpp_ops_ext dpp p pw pairs q r rw rules q_empty rules_no_left_var
    rules_non_collapsing is_QNF nFQ_subset_NF_rules rules_map reverse_rules_map
    intersect_pairs replace_pair intersect_rules delete_P_Pw delete_R_Rw
    split_pairs split_rules mk minimal nfs wwf_rules more)
  = reverse_rules_map;

reverse_capRM_dpp ::
  forall a b c.
    (Eq b, Eq c) => Dpp_ops_ext a b c () -> a -> Term b c -> Gctxt b c;
reverse_capRM_dpp i dpp =
  capRM (rules_non_collapsinga i dpp) (reverse_rules_mapa i dpp);

check_graph_decomp ::
  forall a.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      ((a, a) -> Bool) ->
        [(Bool, [a])] -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_graph_decomp ss g rcs =
  bindb (check_pairwise (check_edges ss g) (map snd rcs))
    (\ _ ->
      catcha
        (forallM (\ c -> check_edges ss g c c)
          (map_filter (\ x -> (if not (fst x) then Just (snd x) else Nothing))
            rcs))
        (\ x -> Inl (snd x)));

check_dep_graph_proc ::
  forall a b c.
    (Eq b, Key b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    a -> [(Maybe c,
                            [(Term b [Prelude.Char],
                               Term b [Prelude.Char])])] ->
                           Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_dep_graph_proc i dpp dps =
  let {
    c = capRM_dpp i dpp;
    rc = reverse_capRM_dpp i dpp;
    _ = nFQ_subset_NF_rulesb i dpp;
    _ = is_QNFc i dpp;
    _ = map fst (rulesd i dpp);
    iedg = is_iedg_edge_dpp i dpp;
    p = pairsa i dpp;
  } in bindb (catcha (check_subseteq p (concatMap snd dps))
               (\ x ->
                 Inl (shows_string
                        ['D', 'e', 'p', 'e', 'n', 'd', 'e', 'n', 'c', 'y', ' ',
                          'P', 'a', 'i', 'r', ' '] .
                       shows_rule (shows_prec Zero_nat)
                         (shows_prec_list Zero_nat) [' ', '-', '>', ' '] x .
                         shows_string
                           [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n',
                             'g', ' ', 'i', 'n', ' ', 'd', 'e', 'c', 'o', 'm',
                             'p', 'o', 's', 'i', 't', 'i', 'o', 'n'] .
                           shows_nl)))
         (\ _ ->
           catcha
             (check_graph_decomp (shows_prec_prod Zero_nat . fst)
               (\ (a, b) ->
                 let {
                   (aa, ba) = a;
                 } in let {
                        (_, t) = aa;
                      } in (\ (_, (ct, ict)) (ab, bb) ->
                             let {
                               (u, _) = ab;
                             } in (\ (cu, (_, _)) ->
                                    matchb ct u && matchb cu t && ict u)
                               bb)
                        ba
                   b)
               (map (\ (real, cs) ->
                      (not (is_none real),
                        map (\ (s, t) -> ((s, t), (rc s, (c t, iedg (s, t)))))
                          cs))
                 dps))
             (\ x ->
               Inl (shows_string
                      ['o', 'u', 'r', ' ', 'e', 's', 't', 'i', 'm', 'a', 't',
                        'i', 'o', 'n', ' ', '(', 'E', 'D', 'G', '*', '*', '*',
                        ' ', '+', ' ', 'I', 'E', 'D', 'G', '*', '*', '*', ')',
                        ' ', 'c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ',
                        's', 'h', 'o', 'w', ' ', 't', 'h', 'a', 't', ' ', 'y',
                        'o', 'u', ' ', 'h', 'a', 'v', 'e', ' ', 'a', ' ', 'v',
                        'a', 'l', 'i', 'd', ' ', 'd', 'e', 'c', 'o', 'm', 'p',
                        'o', 's', 'i', 't', 'i', 'o', 'n', ' '] .
                     shows_string
                       ['d', 'u', 'e', ' ', 't', 'o', ' ', 't', 'h', 'e', ' ',
                         'f', 'o', 'l', 'l', 'o', 'w', 'i', 'n', 'g', ' ', 'r',
                         'e', 'a', 's', 'o', 'n'] .
                       shows_nl . x)));

dep_graph_proc ::
  forall a b c.
    (Eq b, Key b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    a -> [(Maybe c,
                            [(Term b [Prelude.Char],
                               Term b [Prelude.Char])])] ->
                           Sum ([Prelude.Char] -> [Prelude.Char]) [(c, a)];
dep_graph_proc i d dps =
  (case check_dep_graph_proc i d dps of {
    Inl a -> Inl a;
    Inr _ ->
      Inr (map_filter
            (\ x ->
              (if not (is_none (fst x))
                then Just (the (fst x), intersect_pairsa i d (snd x))
                else Nothing))
            dps);
  });

fcc_proc ::
  forall a b c.
    (Eq b, Showa b, Ceq c, Corder c, Eq c, Set_impla c,
      Showa c) => Dpp_ops_ext a b c () ->
                    b -> [Ctxt b c] ->
                           [(Term b c, Term b c)] ->
                             [(Term b c, Term b c)] ->
                               a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
fcc_proc i f fcs pba rw dpp =
  let {
    p = pb i dpp;
    q = qc i dpp;
    r = rc i dpp;
    (pa, pw) = partition_pairs f p pba;
  } in bindb (check (null q)
               (shows_string
                  ['Q', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'e', 'm', 'p',
                    't', 'y'] .
                 shows_nl))
         (\ _ ->
           bindb (check (null r)
                   (shows_prec_list Zero_nat
                     ['s', 't', 'r', 'i', 'c', 't', ' ', 'r', 'u', 'l', 'e',
                       's', ' ', 'n', 'o', 't', ' ', 'a', 'l', 'l', 'o', 'w',
                       'e', 'd']))
             (\ _ ->
               bindb (check_left_linear_trs (rwc i dpp))
                 (\ _ -> fcc_proc_cond i f fcs pa pw [] rw dpp)));

check_NF_terms_subset ::
  forall a b. (Eq a, Eq b) => [Term a b] -> [Term a b] -> Sum (Term a b) ();
check_NF_terms_subset qa q =
  catcha
    (forallM (\ x -> (if not (nF_terms_list qa x) then Inr () else Inl x)) q)
    (\ x -> Inl (snd x));

q_reduction_proc ::
  forall a b c.
    (Eq b, Showa b, Eq c,
      Showa c) => Dpp_ops_ext a b c () ->
                    [Term b c] -> a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
q_reduction_proc i q dpp =
  let {
    pba = pairsa i dpp;
    rb = rulesd i dpp;
    f = map Just (funas_trs_list (pba ++ rb));
    qa = qc i dpp;
    isnf = is_QNFc i dpp;
    qq = filter (\ qb -> all isnf (args qb)) qa;
    rQ = filter (\ qb -> membera f (root qb)) qq;
  } in (case catcha
               (bindb
                 (check (nFQ_subset_NF_rulesb i dpp)
                   (shows_prec_list Zero_nat
                     ['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't', ' ', 'r',
                       'e', 'w', 'r', 'i', 't', 'i', 'n', 'g', ' ', 'r', 'e',
                       'q', 'u', 'i', 'r', 'e', 'd']))
                 (\ _ ->
                   bindb (check_wf_trs rb)
                     (\ _ ->
                       bindb (catcha (check_NF_terms_subset q rQ)
                               (\ x ->
                                 Inl (shows_prec_list Zero_nat
['t', 'h', 'e', ' ', 't', 'e', 'r', 'm', ' '] .
                                       shows_prec_term Zero_nat x .
 shows_prec_list Zero_nat
   [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n', 'g', ' ', 'i', 'n', ' ',
     'Q', '\'', ' '])))
                         (\ _ ->
                           bindb (catcha (check_NF_terms_subset qq q)
                                   (\ x ->
                                     Inl (shows_prec_list Zero_nat
    ['t', 'h', 'e', ' ', 't', 'e', 'r', 'm', ' '] .
   shows_prec_term Zero_nat x .
     shows_prec_list Zero_nat
       [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', 'l', 'l', 'o', 'w', 'e',
         'd', ' ', 'i', 'n', ' ', 'Q', '\'', ' '])))
                             (\ _ ->
                               (if nfsc i dpp then Inr ()
                                 else catcha
(forallM
  (\ lr ->
    catcha
      (check_subseteq (vars_term_lista (snd lr)) (vars_term_lista (fst lr)))
      (\ _ ->
        Inl (shows_prec_list Zero_nat
              ['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', ' ', 'c', 'o', 'n', 'd',
                'i', 't', 'i', 'o', 'n', ' ', 'i', 'n', ' ', 'r', 'u', 'l', 'e',
                ' ', 'v', 'i', 'o', 'l', 'a', 't', 'e', 'd'])))
  pba)
(\ x -> Inl (snd x))))))))
               (\ x ->
                 Inl (shows_prec_list Zero_nat
                        ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e',
                          'n', ' ', 'r', 'e', 'd', 'u', 'c', 'i', 'n', 'g', ' ',
                          'Q', ' ', 'i', 'n', ' ', 't', 'h', 'e', ' ', 'D', 'P',
                          ' ', 'p', 'r', 'o', 'b', 'l', 'e', 'm', ' '] .
                       shows_nl .
                         shows_dpp (shows_prec Zero_nat) (shows_prec Zero_nat) i
                           dpp .
                           shows_nl .
                             shows_prec_list Zero_nat
                               ['t', 'o', ' ', 't', 'h', 'e', ' ', 's', 'e',
                                 't', ' '] .
                               shows_nl .
                                 shows_terms (shows_prec Zero_nat)
                                   (shows_prec Zero_nat) ['Q', '\'', ':'] q .
                                   shows_nl . x))
         of {
         Inl a -> Inl a;
         Inr _ ->
           Inr (mkc i (nfsc i dpp) (minimal i dpp) (pb i dpp) (pwa i dpp) q
                 (rc i dpp) (rwc i dpp));
       });

uncurry_of_top_sig_list ::
  forall a.
    a -> Nat ->
           [((a, Nat), [a])] ->
             (a -> Nat -> [a]) ->
               [(Term a [Prelude.Char], Term a [Prelude.Char])];
uncurry_of_top_sig_list a m sml sm =
  concatMap
    (\ (b, c) ->
      let {
        (f, n) = b;
      } in (\ _ ->
             let {
               g = get_symbol sm f n;
             } in map (\ i ->
                        (Fun a (generate_f_xs (g i) (plus_nat n i) :
                                 map (\ ia -> Var (generate_var ia))
                                   (upt (plus_nat n i)
                                     (plus_nat (plus_nat n i)
                                       (minus_nat m (Nat_of_num One))))),
                          generate_f_xs (g (plus_nat i (Nat_of_num One)))
                            (plus_nat (plus_nat n i)
                              (minus_nat m (Nat_of_num One)))))
                    (upt Zero_nat (aarity sm f n)))
        c)
    sml;

eta_closed_top_rules ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => a -> Nat ->
                         (a -> Nat -> [a]) ->
                           [(Term a b, Term a b)] ->
                             [(Term a b, Term a b)] ->
                               Sum ([Prelude.Char] -> [Prelude.Char]) ();
eta_closed_top_rules a n sm r p =
  catcha
    (forallM
      (\ (l, ra) ->
        (case l of {
          Var _ -> Inr ();
          Fun ff ls ->
            check (equal_nat (aarity sm ff (size_list ls)) Zero_nat ||
                    any (\ (lll, rrr) ->
                          (case (lll, rrr) of {
                            (Var _, b) -> False;
                            (Fun f [], b) -> False;
                            (Fun f (ll : yy), Var _) -> False;
                            (Fun f (ll : yy), Fun g []) -> False;
                            (Fun f (ll : yy), Fun g (rr : zz)) ->
                              f == a &&
                                g == a &&
                                  zz == yy &&
                                    equal_nat (size_list yy)
                                      (minus_nat n (Nat_of_num One)) &&
                                      distinct yy &&
all is_Var yy &&
  null (list_inter (map the_Var yy) (vars_rule_list (ll, rr))) &&
    instance_rule (l, ra) (ll, rr);
                          }))
                      p)
              (shows_prec_list Zero_nat
                 ['e', 't', 'a', ' ', 'e', 'x', 'p', 'a', 'n', 's', 'i', 'o',
                   'n', ' ', 'o', 'f', ' '] .
                shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                  [' ', '-', '>', ' '] (l, ra) .
                  shows_prec_list Zero_nat
                    [' ', 'm', 'i', 's', 's', 'i', 'n', 'g']);
        }))
      r)
    (\ x -> Inl (snd x));

uncurry_top_rules ::
  forall a b.
    (Eq a) => a -> Nat ->
                     (a -> Nat -> [a]) ->
                       [(Term a b, Term a b)] -> [(Term a b, Term a b)];
uncurry_top_rules a n sm =
  map (\ (l, r) -> (uncurry_top a n sm l, uncurry_top a n sm r));

equal_gctxt :: forall a b. (Eq a) => Gctxt a b -> Gctxt a b -> Bool;
equal_gctxt (GCFun f list) GCHole = False;
equal_gctxt GCHole (GCFun f list) = False;
equal_gctxt (GCFun fa lista) (GCFun f list) = fa == f && lista == list;
equal_gctxt GCHole GCHole = True;

instance (Eq a) => Eq (Gctxt a b) where {
  a == b = equal_gctxt a b;
};

uncurry_top_proc ::
  forall a b.
    (Eq b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    (b, ([((b, Nat), [b])],
                          ([(Term b [Prelude.Char], Term b [Prelude.Char])],
                            [(Term b [Prelude.Char],
                               Term b [Prelude.Char])]))) ->
                      Nat ->
                        ([((b, Nat), [b])] -> b -> Nat -> b) ->
                          (b -> Nat ->
                                  [((b, Nat), [b])] ->
                                    Sum ([Prelude.Char] -> [Prelude.Char])
                                      ()) ->
                            [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                              [(Term b [Prelude.Char],
                                 Term b [Prelude.Char])] ->
                                a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
uncurry_top_proc i info n fmap check_inj p r dpp =
  let {
    (a, (sml, (u, eb))) = info;
    pa = pb i dpp;
    pw = pwa i dpp;
    ra = rc i dpp;
    rw = rwc i dpp;
    nfs = nfsc i dpp;
    m = minimal i dpp;
    (e, ew) = uncurry_eta_split eb ra;
    sm = sig_list_to_sig_map a sml fmap;
    p_eta = e ++ pa;
    pw_eta = ew ++ pw;
    uP = uncurry_top_rules a n sm p_eta;
    uPw = uncurry_top_rules a n sm pw_eta;
    uR = map_rules_wa (\ f na -> get_symbol sm f na Zero_nat) ra;
    uRw = map_rules_wa (\ f na -> get_symbol sm f na Zero_nat) rw;
  } in (case bindb (check (null (qc i dpp))
                     (shows_prec_list Zero_nat
                       ['s', 't', 'r', 'a', 't', 'e', 'g', 'y', ' ', 'c', 'u',
                         'r', 'r', 'e', 'n', 't', 'l', 'y', ' ', 'u', 'n', 's',
                         'u', 'p', 'p', 'o', 'r', 't', 'e', 'd']))
               (\ _ ->
                 bindb (check (not (equal_nat n Zero_nat))
                         (shows_prec_list Zero_nat
                           ['t', 'h', 'e', ' ', 'a', 'r', 'i', 't', 'y', ' ',
                             'o', 'f', ' ', 't', 'h', 'e', ' ', 'u', 'n', 'c',
                             'u', 'r', 'r', 'i', 'e', 'd', ' ', 's', 'y', 'm',
                             'b', 'o', 'l', ' ', 'm', 'u', 's', 't', ' ', 'b',
                             'e', ' ', 'a', 't', ' ', 'l', 'e', 'a', 's', 't',
                             ' ', '1']))
                   (\ _ ->
                     bindb (check_inj a n sml)
                       (\ _ ->
                         let {
                           pba = pairsa i dpp;
                           is_def = (\ fn -> not (null (rules_mapb i dpp fn)));
                           rm = rules_mapb i dpp;
                         } in bindb (catcha
                                      (forallM
(\ (l, _) ->
  check (not (is_Var l))
    (shows_prec_list Zero_nat
      ['l', 'h', 's', ' ', 'a', 's', ' ', 'v', 'a', 'r', 'i', 'a', 'b', 'l',
        'e', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', 'l', 'l', 'o', 'w',
        'e', 'd']))
(ra ++ rw))
                                      (\ x -> Inl (snd x)))
                                (\ _ ->
                                  bindb (catcha
  (forallM
    (\ (l, rb) ->
      bindb (check (hvf_top a n l)
              (shows_prec_list Zero_nat
                 ['h', 'e', 'a', 'd', ' ', 'v', 'a', 'r', 'i', 'a', 'b', 'l',
                   'e', ' ', 'i', 'n', ' ', 'l', 'h', 's', ' '] .
                shows_term (shows_prec Zero_nat) (shows_prec_list Zero_nat) l .
                  shows_prec_list Zero_nat
                    [' ', 'n', 'o', 't', ' ', 'a', 'l', 'l', 'o', 'w', 'e',
                      'd']))
        (\ _ -> check_no_var rb))
    (pw_eta ++ p_eta))
  (\ x -> Inl (snd x)))
                                    (\ _ ->
                                      bindb
(catcha
  (forallM
    (\ (_, rb) ->
      check (not (is_def (the (root rb))))
        (shows_prec_list Zero_nat ['r', 'o', 'o', 't', ' ', 'o', 'f', ' '] .
          shows_term (shows_prec Zero_nat) (shows_prec_list Zero_nat) rb .
            shows_prec_list Zero_nat
              [' ', 'm', 'u', 's', 't', ' ', 'n', 'o', 't', ' ', 'b', 'e', ' ',
                'd', 'e', 'f', 'i', 'n', 'e', 'd']))
    pba)
  (\ x -> Inl (snd x)))
(\ _ ->
  bindb (check (not (is_def (a, n)))
          (shows_prec_list Zero_nat
             ['a', 'p', 'p', 'l', 'i', 'c', 'a', 't', 'i', 'o', 'n', ' ', 's',
               'y', 'm', 'b', 'o', 'l', ' '] .
            shows_prec Zero_nat a .
              shows_prec_list Zero_nat
                [' ', 'm', 'u', 's', 't', ' ', 'n', 'o', 't', ' ', 'b', 'e',
                  ' ', 'd', 'e', 'f', 'i', 'n', 'e', 'd', ' ', 'i', 'n', ' ',
                  'R']))
    (\ _ ->
      bindb (if any (\ (_, rb) ->
                      the (root rb) == (a, n) &&
                        equal_gctxt (capRM2 rm (hd (args rb))) GCHole)
                  pba
              then bindb (catcha
                           (check_CS_subseteq
                             (uncurry_of_top_sig_list a n sml sm) u)
                           (\ x ->
                             Inl (shows_prec_list Zero_nat
                                    ['u', 'n', 'c', 'u', 'r', 'r', 'y', 'i',
                                      'n', 'g', ' ', 'p', 'a', 'i', 'r', ' '] .
                                   shows_rule (shows_prec Zero_nat)
                                     (shows_prec_list Zero_nat)
                                     [' ', '-', '>', ' '] x .
                                     shows_prec_list Zero_nat
                                       [' ', 'i', 's', ' ', 'm', 'i', 's', 's',
 'i', 'n', 'g', ' ', 'i', 'n'] .
                                       shows_nl .
 shows_rules (shows_prec Zero_nat) (shows_prec_list Zero_nat)
   [' ', '-', '>', ' '] u)))
                     (\ _ ->
                       bindb (eta_closed_top_rules a n sm ra p_eta)
                         (\ _ -> eta_closed_top_rules a n sm rw pw_eta))
              else Inr ())
        (\ _ ->
          bindb (catcha (check_subseteq uP p)
                  (\ x ->
                    Inl (shows_prec_list Zero_nat
                           ['u', 'n', 'c', 'u', 'r', 'r', 'i', 'e', 'd', ' ',
                             'p', 'a', 'i', 'r', ' '] .
                          shows_rule (shows_prec Zero_nat)
                            (shows_prec_list Zero_nat) [' ', '-', '>', ' '] x .
                            shows_prec_list Zero_nat
                              [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n',
                                'g'])))
            (\ _ ->
              bindb (catcha (check_subseteq uPw p)
                      (\ x ->
                        Inl (shows_prec_list Zero_nat
                               ['u', 'n', 'c', 'u', 'r', 'r', 'i', 'e', 'd',
                                 ' ', 'p', 'a', 'i', 'r', ' '] .
                              shows_rule (shows_prec Zero_nat)
                                (shows_prec_list Zero_nat) [' ', '-', '>', ' ']
                                x .
                                shows_prec_list Zero_nat
                                  [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i',
                                    'n', 'g'])))
                (\ _ ->
                  bindb (catcha (check_subseteq u p)
                          (\ x ->
                            Inl (shows_prec_list Zero_nat
                                   ['u', 'n', 'c', 'u', 'r', 'r', 'y', 'i', 'n',
                                     'g', ' ', 'p', 'a', 'i', 'r', ' '] .
                                  shows_rule (shows_prec Zero_nat)
                                    (shows_prec_list Zero_nat)
                                    [' ', '-', '>', ' '] x .
                                    shows_prec_list Zero_nat
                                      [' ', 'i', 's', ' ', 'm', 'i', 's', 's',
'i', 'n', 'g', ' ', 'i', 'n', ' ', 'n', 'e', 'w', ' ', 'p', 'a', 'i', 'r',
's'])))
                    (\ _ ->
                      bindb (catcha (check_subseteq uR r)
                              (\ x ->
                                Inl (shows_prec_list Zero_nat
                                       ['r', 'u', 'l', 'e', ' '] .
                                      shows_rule (shows_prec Zero_nat)
(shows_prec_list Zero_nat) [' ', '-', '>', ' '] x .
shows_prec_list Zero_nat
  [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n', 'g', ' ', 'i', 'n', ' ',
    'n', 'e', 'w', ' ', 'r', 'u', 'l', 'e', 's'])))
                        (\ _ ->
                          catcha (check_subseteq uRw r)
                            (\ x ->
                              Inl (shows_prec_list Zero_nat
                                     ['r', 'u', 'l', 'e', ' '] .
                                    shows_rule (shows_prec Zero_nat)
                                      (shows_prec_list Zero_nat)
                                      [' ', '-', '>', ' '] x .
                                      shows_prec_list Zero_nat
[' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n', 'g', ' ', 'i', 'n', ' ', 'n',
  'e', 'w', ' ', 'r', 'u', 'l', 'e', 's']))))))))))))))
         of {
         Inl aa -> Inl aa;
         Inr _ -> Inr (mkc i nfs m uP (uPw ++ u) [] uR uRw);
       });

only_eta_rules ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    [(Term a b, Term a b)] ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) ();
only_eta_rules e r_eta =
  catcha
    (forallM
      (\ (l, r) ->
        check (case (l, r) of {
                (Var _, b) -> False;
                (Fun f ls, Var _) -> False;
                (Fun f ls, Fun g rs) ->
                  f == g &&
                    equal_nat (size_list ls) (Nat_of_num (Bit0 One)) &&
                      equal_nat (size_list rs) (Nat_of_num (Bit0 One)) &&
                        equal_term (nth ls (Nat_of_num One))
                          (nth rs (Nat_of_num One)) &&
                          any (\ (la, ra) ->
                                instance_rule (hd ls, hd rs) (la, ra))
                            r_eta;
              })
          (shows_prec_list Zero_nat ['r', 'u', 'l', 'e', ' '] .
            shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
              [' ', '-', '>', ' '] (l, r) .
              shows_prec_list Zero_nat
                [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', 'n', ' ', '(',
                  'e', 't', 'a', '-', 'e', 'x', 'p', 'a', 'n', 'd', 'e', 'd',
                  ')', ' ', 'o', 'r', 'i', 'g', 'i', 'n', 'a', 'l', ' ', 'r',
                  'u', 'l', 'e']))
      e)
    (\ x -> Inl (snd x));

uncurry_proc ::
  forall a b.
    (Eq b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    (b, ([((b, Nat), [b])],
                          ([(Term b [Prelude.Char], Term b [Prelude.Char])],
                            [(Term b [Prelude.Char],
                               Term b [Prelude.Char])]))) ->
                      ([((b, Nat), [b])] -> b -> Nat -> b) ->
                        (b -> Nat ->
                                [((b, Nat), [b])] ->
                                  Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                          [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                            [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                              a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
uncurry_proc i info fmap check_inj p r dpp =
  let {
    (a, (sml, (u, eb))) = info;
    pa = pb i dpp;
    pw = pwa i dpp;
    ra = rc i dpp;
    rw = rwc i dpp;
    nfs = nfsc i dpp;
    m = minimal i dpp;
    (e, ew) = uncurry_eta_split eb ra;
    sm = sig_list_to_sig_map a sml fmap;
    uP = uncurry_rules a sm pa;
    uPw = uncurry_rules a sm pw;
    r_eta = e ++ ra;
    rw_eta = ew ++ rw;
    uR = uncurry_rules a sm r_eta;
    uRw = uncurry_rules a sm rw_eta;
  } in (case let {
               s = uncurry_of_sig_list a sml sm;
             } in bindb (check (null (qc i dpp))
                          (shows_prec_list Zero_nat
                            ['s', 't', 'r', 'a', 't', 'e', 'g', 'y', ' ', 'n',
                              'o', 't', ' ', 's', 'u', 'p', 'p', 'o', 'r', 't',
                              'e', 'd', ' ', 'f', 'o', 'r', ' ', 'u', 'n', 'c',
                              'u', 'r', 'r', 'y', 'i', 'n', 'g']))
                    (\ _ ->
                      bindb (only_eta_rules e r_eta)
                        (\ _ ->
                          bindb (only_eta_rules ew rw_eta)
                            (\ _ ->
                              bindb (check_inj a (Nat_of_num (Bit0 One)) sml)
                                (\ _ ->
                                  bindb (catcha
  (forallM
    (\ (l, _) ->
      check (not (is_Var l))
        (shows_prec_list Zero_nat
          ['l', 'h', 's', ' ', 'a', 's', ' ', 'v', 'a', 'r', 'i', 'a', 'b', 'l',
            'e', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', 'l', 'l', 'o',
            'w', 'e', 'd']))
    (ra ++ rw))
  (\ x -> Inl (snd x)))
                                    (\ _ ->
                                      bindb
(catcha
  (forallM
    (\ (l, _) ->
      check (hvf_term a l)
        (shows_prec_list Zero_nat
           ['h', 'e', 'a', 'd', ' ', 'v', 'a', 'r', 'i', 'a', 'b', 'l', 'e',
             ' ', 'i', 'n', ' ', 'l', 'h', 's', ' '] .
          shows_term (shows_prec Zero_nat) (shows_prec_list Zero_nat) l .
            shows_prec_list Zero_nat
              [' ', 'n', 'o', 't', ' ', 'a', 'l', 'l', 'o', 'w', 'e', 'd']))
    pa)
  (\ x -> Inl (snd x)))
(\ _ ->
  bindb (catcha
          (forallM
            (\ (l, _) ->
              check (hvf_term a l)
                (shows_prec_list Zero_nat
                   ['h', 'e', 'a', 'd', ' ', 'v', 'a', 'r', 'i', 'a', 'b', 'l',
                     'e', ' ', 'i', 'n', ' ', 'l', 'h', 's', ' '] .
                  shows_term (shows_prec Zero_nat) (shows_prec_list Zero_nat)
                    l .
                    shows_prec_list Zero_nat
                      [' ', 'n', 'o', 't', ' ', 'a', 'l', 'l', 'o', 'w', 'e',
                        'd']))
            pw)
          (\ x -> Inl (snd x)))
    (\ _ ->
      bindb (catcha
              (forallM
                (\ (l, _) ->
                  check (hvf_term a l)
                    (shows_prec_list Zero_nat
                       ['h', 'e', 'a', 'd', ' ', 'v', 'a', 'r', 'i', 'a', 'b',
                         'l', 'e', ' ', 'i', 'n', ' ', 'l', 'h', 's', ' '] .
                      shows_term (shows_prec Zero_nat)
                        (shows_prec_list Zero_nat) l .
                        shows_prec_list Zero_nat
                          [' ', 'n', 'o', 't', ' ', 'a', 'l', 'l', 'o', 'w',
                            'e', 'd']))
                r_eta)
              (\ x -> Inl (snd x)))
        (\ _ ->
          bindb (catcha
                  (forallM
                    (\ (l, _) ->
                      check (hvf_term a l)
                        (shows_prec_list Zero_nat
                           ['h', 'e', 'a', 'd', ' ', 'v', 'a', 'r', 'i', 'a',
                             'b', 'l', 'e', ' ', 'i', 'n', ' ', 'l', 'h', 's',
                             ' '] .
                          shows_term (shows_prec Zero_nat)
                            (shows_prec_list Zero_nat) l .
                            shows_prec_list Zero_nat
                              [' ', 'n', 'o', 't', ' ', 'a', 'l', 'l', 'o', 'w',
                                'e', 'd']))
                    rw_eta)
                  (\ x -> Inl (snd x)))
            (\ _ ->
              bindb (eta_closed_rules a sm r_eta r_eta)
                (\ _ ->
                  bindb (eta_closed_rules a sm rw_eta rw_eta)
                    (\ _ ->
                      bindb (catcha (check_subseteq uP p)
                              (\ x ->
                                Inl (shows_prec_list Zero_nat
                                       ['u', 'n', 'c', 'u', 'r', 'r', 'i', 'e',
 'd', ' ', 'p', 'a', 'i', 'r', ' '] .
                                      shows_rule (shows_prec Zero_nat)
(shows_prec_list Zero_nat) [' ', '-', '>', ' '] x .
shows_prec_list Zero_nat
  [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n', 'g'])))
                        (\ _ ->
                          bindb (catcha (check_subseteq uPw p)
                                  (\ x ->
                                    Inl (shows_prec_list Zero_nat
   ['u', 'n', 'c', 'u', 'r', 'r', 'i', 'e', 'd', ' ', 'p', 'a', 'i', 'r', ' '] .
  shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
    [' ', '-', '>', ' '] x .
    shows_prec_list Zero_nat
      [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n', 'g'])))
                            (\ _ ->
                              bindb (catcha (check_subseteq uR r)
                                      (\ x ->
Inl (shows_prec_list Zero_nat
       ['u', 'n', 'c', 'u', 'r', 'r', 'i', 'e', 'd', ' ', 'r', 'u', 'l', 'e',
         ' '] .
      shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
        [' ', '-', '>', ' '] x .
        shows_prec_list Zero_nat
          [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n', 'g'])))
                                (\ _ ->
                                  bindb (catcha (check_subseteq uRw r)
  (\ x ->
    Inl (shows_prec_list Zero_nat
           ['u', 'n', 'c', 'u', 'r', 'r', 'i', 'e', 'd', ' ', 'r', 'u', 'l',
             'e', ' '] .
          shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
            [' ', '-', '>', ' '] x .
            shows_prec_list Zero_nat
              [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n', 'g'])))
                                    (\ _ ->
                                      bindb
(catcha (check_CS_subseteq s u)
  (\ x ->
    Inl (shows_prec_list Zero_nat
           ['u', 'n', 'c', 'u', 'r', 'r', 'y', ' ', 'r', 'u', 'l', 'e', ' '] .
          shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
            [' ', '-', '>', ' '] x .
            shows_prec_list Zero_nat
              [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n', 'g'])))
(\ _ ->
  bindb (catcha (check_CS_subseteq u s)
          (\ x ->
            Inl (shows_prec_list Zero_nat ['r', 'u', 'l', 'e', ' '] .
                  shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
                    [' ', '-', '>', ' '] x .
                    shows_prec_list Zero_nat
                      [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', 'n', ' ',
                        'u', 'n', 'c', 'u', 'r', 'r', 'y', ' ', 'r', 'u', 'l',
                        'e'])))
    (\ _ ->
      catcha (check_subseteq u r)
        (\ x ->
          Inl (shows_prec_list Zero_nat
                 ['u', 'n', 'c', 'u', 'r', 'r', 'y', ' ', 'r', 'u', 'l', 'e',
                   ' '] .
                shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
                  [' ', '-', '>', ' '] x .
                  shows_prec_list Zero_nat
                    [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n', 'g', ' ',
                      'i', 'n', ' ', 'n', 'e', 'w', ' ', 'T', 'R',
                      'S'])))))))))))))))))))
         of {
         Inl aa -> Inl aa;
         Inr _ -> Inr (mkc i nfs m uP uPw [] uR (uRw ++ u));
       });

uncurry_proc_both ::
  forall a b c.
    (Eq b, Showa b, Eq c,
      Showa c) => Dpp_ops_ext a (Lab b c) [Prelude.Char] () ->
                    Maybe Nat ->
                      (Lab b c,
                        ([((Lab b c, Nat), [Lab b c])],
                          ([(Term (Lab b c) [Prelude.Char],
                              Term (Lab b c) [Prelude.Char])],
                            [(Term (Lab b c) [Prelude.Char],
                               Term (Lab b c) [Prelude.Char])]))) ->
                        [(Term (Lab b c) [Prelude.Char],
                           Term (Lab b c) [Prelude.Char])] ->
                          [(Term (Lab b c) [Prelude.Char],
                             Term (Lab b c) [Prelude.Char])] ->
                            a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
uncurry_proc_both i Nothing (a, (sml, (u, eb))) =
  uncurry_proc i (a, (sml, (u, eb))) (fmap a (Nat_of_num (Bit0 One))) check_inj;
uncurry_proc_both i (Just n) (a, (sml, (u, eb))) =
  uncurry_top_proc i (a, (sml, (u, eb))) n (fmap a n) check_inj;

check_rewrite_common_preconditions ::
  forall a b c.
    (Eq b, Key b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    Maybe [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                      (Term b [Prelude.Char], Term b [Prelude.Char]) ->
                        [Term b [Prelude.Char]] ->
                          c -> (Term b [Prelude.Char], Term b [Prelude.Char]) ->
                                 Pos ->
                                   Bool ->
                                     a -> Sum ([Prelude.Char] -> [Prelude.Char])
    ();
check_rewrite_common_preconditions i u_opt st ss t lr p sound dpp =
  let {
    r = rulesd i dpp;
    s = fst st;
    ta = snd st;
    tp = subt_at ta p;
    u = (case u_opt of {
          Nothing -> inn_usable_rules_pair i dpp (s, tp);
          Just u -> u;
        });
  } in bindb (catcha (check_subseteq u r)
               (\ x ->
                 Inl (shows_rule (shows_prec Zero_nat)
                        (shows_prec_list Zero_nat) [' ', '-', '>', ' '] x .
                       shows_prec_list Zero_nat
                         [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'r',
                           'u', 'l', 'e', ' ', 'o', 'f', ' ', 't', 'h', 'e',
                           ' ', 'r', 'e', 'w', 'r', 'i', 't', 'e', ' ', 's',
                           'y', 's', 't', 'e', 'm', ' '])))
         (\ _ ->
           let {
             urc = is_ur_closed_impl_dpp_mv i dpp u;
             check_urc =
               (\ sa tb ->
                 check (urc sa tb)
                   (shows_prec_list Zero_nat ['t', 'e', 'r', 'm', ' '] .
                     shows_prec_term Zero_nat tb .
                       shows_prec_list Zero_nat
                         [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'c', 'l', 'o',
                           's', 'e', 'd', ' ', 'u', 'n', 'd', 'e', 'r', ' ',
                           'u', 's', 'a', 'b', 'l', 'e', ' ', 'r', 'u', 'l',
                           'e', 's']));
             nfs = nfsc i dpp;
           } in bindb (catcha
                        (forallM
                          (\ (l, _) ->
                            check (not (is_Var l))
                              (shows_prec_list Zero_nat
                                ['l', 'h', 's', 's', ' ', 'm', 'u', 's', 't',
                                  ' ', 'n', 'o', 't', ' ', 'b', 'e', ' ', 'v',
                                  'a', 'r', 'i', 'a', 'b', 'l', 'e', 's']))
                          u)
                        (\ x -> Inl (snd x)))
                  (\ _ ->
                    bindb (check (wf_rule lr)
                            (shows_rule (shows_prec Zero_nat)
                               (shows_prec_list Zero_nat) [' ', '-', '>', ' ']
                               lr .
                              shows_prec_list Zero_nat
                                [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a',
                                  ' ', 'w', 'e', 'l', 'l', ' ', 'f', 'o', 'r',
                                  'm', 'e', 'd', ' ', 'r', 'u', 'l', 'e']))
                      (\ _ ->
                        bindb (if nfs && sound then Inr ()
                                else catcha
                                       (check_subseteq (vars_term_lista tp)
 (vars_term_lista s))
                                       (\ _ ->
 Inl (shows_prec_list Zero_nat
       ['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', ' ', 'c', 'o', 'n', 'd', 'i',
         't', 'i', 'o', 'n', ' ', 'i', 'n', ' ', 'p', 'a', 'i', 'r', ' ', 'v',
         'i', 'o', 'l', 'a', 't', 'e', 'd'])))
                          (\ _ ->
                            bindb (check_urc ss tp)
                              (\ _ ->
                                bindb (catcha
(forallM (\ (l, a) -> check_urc (args l) a) u) (\ x -> Inl (snd x)))
                                  (\ _ ->
                                    bindb (catcha
    (check_critical_pairs_innermost u)
    (\ x ->
      Inl (shows_prec_list Zero_nat
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 's', 'h',
               'o', 'w', 'i', 'n', 'g', ' ', 'U', 'N', 'F', ' ', 'o', 'f', ' ',
               'u', 's', 'a', 'b', 'l', 'e', ' ', 'r', 'u', 'l', 'e', 's'] .
            shows_nl . x)))
                                      (\ _ ->
catcha
  (forallM
    (\ (_, (sa, tb)) ->
      check (equal_term sa tb)
        (shows_prec_list Zero_nat
          ['n', 'o', 'n', '-', 't', 'r', 'i', 'v', 'i', 'a', 'l', ' ', 'c', 'r',
            'i', 't', 'i', 'c', 'a', 'l', ' ', 'p', 'a', 'i', 'r', ' ', 'b',
            'e', 't', 'w', 'e', 'e', 'n', ' ', 'r', 'u', 'l', 'e', ' ', 't',
            'o', ' ', 'r', 'e', 'w', 'r', 'i', 't', 'e', ' ', 'a', 'n', 'd',
            ' ', 'u', 's', 'a', 'b', 'l', 'e', ' ', 'r', 'u', 'l', 'e', 's']))
    (critical_pairs_impl [lr] u))
  (\ x -> Inl (snd x)))))))));

check_prop_rstepa ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => Bool ->
                    (Term a b -> Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                      [(Term a b, Term a b)] ->
                        Pos ->
                          (Term a b, Term a b) ->
                            Term a b ->
                              Term a b ->
                                Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_prop_rstepa nfs pa r p rule s t =
  bindb (check (membera r rule)
          (shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
             [' ', '-', '>', ' '] rule .
            shows_string
              [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'r', 'u', 'l',
                'e', ' ', 'o', 'f'] .
              shows_nl .
                shows_trs (shows_prec Zero_nat) (shows_prec Zero_nat)
                  ['r', 'e', 'w', 'r', 'i', 't', 'e', ' ', 's', 'y', 's', 't',
                    'e', 'm', ':']
                  [' ', '-', '>', ' '] r .
                  shows_nl))
    (\ _ -> check_prop_rstep_rule nfs pa p rule s t);

check_rstep ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    Pos ->
                      (Term a b, Term a b) ->
                        Term a b ->
                          Term a b -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_rstep = check_prop_rstepa False (\ _ -> Inr ());

rewriting_proc ::
  forall a b.
    (Eq b, Key b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    Maybe [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                      (Term b [Prelude.Char], Term b [Prelude.Char]) ->
                        (Term b [Prelude.Char], Term b [Prelude.Char]) ->
                          (Term b [Prelude.Char], Term b [Prelude.Char]) ->
                            (Term b [Prelude.Char], Term b [Prelude.Char]) ->
                              Pos ->
                                a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
rewriting_proc i u stb sta st lr p dpp =
  (case let {
          s = fst stb;
          t = snd sta;
        } in bindb (check_rstep (rulesd i dpp) p lr (snd stb) t)
               (\ _ ->
                 bindb (check (nFQ_subset_NF_rulesb i dpp)
                         (shows_prec_list Zero_nat
                           ['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't', ' ',
                             'r', 'e', 'w', 'r', 'i', 't', 'i', 'n', 'g', ' ',
                             'r', 'e', 'q', 'u', 'i', 'r', 'e', 'd']))
                   (\ _ ->
                     bindb (check_rewrite_common_preconditions i u stb [s] t lr
                             p True dpp)
                       (\ _ ->
                         bindb (check (eq_rule_mod_vars sta st)
                                 (shows_prec_list Zero_nat
                                    ['t', 'h', 'e', ' ', 'r', 'u', 'l', 'e',
                                      ' '] .
                                   shows_rule (shows_prec Zero_nat)
                                     (shows_prec_list Zero_nat)
                                     [' ', '-', '>', ' '] sta .
                                     shows_prec_list Zero_nat
                                       [' ', 'i', 's', ' ', 'n', 'o', 't', ' ',
 'a', ' ', 'r', 'e', 'n', 'a', 'm', 'e', 'd', ' ', 'v', 'a', 'r', 'i', 'a', 'n',
 't', ' ', 'o', 'f', ' '] .
                                       shows_rule (shows_prec Zero_nat)
 (shows_prec_list Zero_nat) [' ', '-', '>', ' '] st))
                           (\ _ ->
                             bindb (check (equal_term s (fst sta))
                                     (shows_prec_list Zero_nat
                                       ['l', 'e', 'f', 't', '-', 'h', 'a', 'n',
 'd', ' ', 's', 'i', 'd', 'e', 's', ' ', 'o', 'f', ' ', 'o', 'l', 'd', ' ', 'a',
 'n', 'd', ' ', 'n', 'e', 'w', ' ', 'p', 'a', 'i', 'r', ' ', 'd', 'i', 'f', 'f',
 'e', 'r']))
                               (\ _ ->
                                 bindb (check
 (membera (pb i dpp) stb || null (rc i dpp))
 (shows_prec_list Zero_nat
   ['s', 't', 'r', 'i', 'c', 't', ' ', 'D', 'P', ' ', 'o', 'r', ' ', 'n', 'o',
     ' ', 's', 't', 'r', 'i', 'c', 't', ' ', 'r', 'u', 'l', 'e', 's', ' ', 'r',
     'e', 'q', 'u', 'i', 'r', 'e', 'd']))
                                   (\ _ ->
                                     check (nfsc i dpp || wwf_rulesa i dpp)
                                       (shows_prec_list Zero_nat
 ['w', 'e', 'l', 'l', '-', 'f', 'o', 'r', 'm', 'e', 'd', ' ', 'r', 'u', 'l',
   'e', 's', ' ', 'o', 'r', ' ', 'n', 'o', 'r', 'm', 'a', 'l', ' ', 's', 'u',
   'b', 's', 't', '.', ' ', 'r', 'e', 'q', 'u', 'i', 'r', 'e', 'd'])))))))
    of {
    Inl a -> Inl a;
    Inr _ -> Inr (replace_paira i dpp stb [st]);
  });

nF_subst_impl ::
  forall a b.
    (Eq b) => (Term a b -> Bool) ->
                Bool -> (Term a b, Term a b) -> (b -> Term a b) -> Bool;
nF_subst_impl nf nfs r sigma =
  (if nfs then all (\ x -> nf (sigma x)) (vars_rule_list r) else True);

qnarrows_impl ::
  forall a.
    (Eq a) => (Term a [Prelude.Char] -> Bool) ->
                Bool ->
                  [(Term a [Prelude.Char], Term a [Prelude.Char])] ->
                    Term a [Prelude.Char] ->
                      [(Term a [Prelude.Char],
                         [Prelude.Char] -> Term a [Prelude.Char])];
qnarrows_impl isnf nfs r t =
  concatMap
    (\ p ->
      let {
        tp = subt_at t p;
      } in (if not (is_Var tp)
             then concatMap
                    (\ (l, ra) ->
                      concatMap
                        (\ (mu_1, mu_2) ->
                          (if nF_subst_impl isnf nfs (l, ra) mu_2
                            then (if all isnf (args (subst_apply_term l mu_2))
                                   then [(ctxt_apply
    (ctxt_of_pos_term p (subst_apply_term t mu_1)) (subst_apply_term ra mu_2),
   mu_1)]
                                   else [])
                            else []))
                        (option_to_list
                          (mgu_var_disjoint_generic (\ a -> 'x' : a)
                            (\ a -> 'y' : a) tp l)))
                    r
             else []))
    (poss_list t);

narrowing_proc ::
  forall a b.
    (Eq b, Key b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    (Term b [Prelude.Char], Term b [Prelude.Char]) ->
                      Pos ->
                        [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                          a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
narrowing_proc i st p sts dpp =
  (case let {
          (s, t) = st;
          q = qc i dpp;
        } in bindb (check
                     (nFQ_subset_NF_rulesb i dpp || null q && linear_term t)
                     (shows_prec_list Zero_nat
                       ['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't', ' ', 'o',
                         'r', ' ', 'f', 'u', 'l', 'l', ' ', 'r', 'e', 'w', 'r',
                         'i', 't', 'i', 'n', 'g', ' ', 'r', 'e', 'q', 'u', 'i',
                         'r', 'e', 'd', ' ', '(', 'a', 'n', 'd', ' ', 'l', 'i',
                         'n', 'e', 'a', 'r', 'i', 't', 'y', ' ', 'o', 'f', ' ',
                         't', ' ', 'i', 'n', ' ', 'f', 'u', 'l', 'l', ' ', 'r',
                         'e', 'w', 'r', 'i', 't', 'i', 'n', 'g', ' ', 'c', 'a',
                         's', 'e', ')']))
               (\ _ ->
                 let {
                   ic = icap_impl_dpp_mv i dpp;
                   isnf = is_QNFc i dpp;
                   pairs = pairsa i dpp;
                 } in bindb (check (membera (poss_list (ic [s] t)) p)
                              (shows_prec_list Zero_nat
                                 ['p', 'o', 's', 'i', 't', 'i', 'o', 'n', ' ',
                                   'n', 'o', 't', ' ', 'c', 'o', 'n', 't', 'a',
                                   'i', 'n', 'e', 'd', ' ', 'i', 'n', ' ', 'c',
                                   'a', 'p', 'p', 'e', 'd', ' ', 't', 'e', 'r',
                                   'm', ' ', 'o', 'f', ' '] .
                                shows_prec_term Zero_nat t))
                        (\ _ ->
                          let {
                            tp = subt_at t p;
                            nfs = nfsc i dpp;
                            narrows = qnarrows_impl isnf nfs (rulesd i dpp) tp;
                            stsa =
                              filter (\ (smu, _) -> isnf smu)
                                (map (\ (ta, mu) ->
                                       (subst_apply_term s mu,
 ctxt_apply (ctxt_of_pos_term p (subst_apply_term t mu)) ta))
                                  narrows);
                          } in bindb (catcha
                                       (forallM
 (\ new ->
   check (any (\ sta ->
                instance_rule new sta && (not nfs || (null q || wf_rule sta)))
           sts)
     (shows_prec_list Zero_nat
        ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'f', 'i', 'n', 'd',
          ' ', 'n', 'a', 'r', 'r', 'o', 'w', 'e', 'd', ' ', 'p', 'a', 'i', 'r',
          ' '] .
       shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
         [' ', '-', '>', ' '] new))
 stsa)
                                       (\ x -> Inl (snd x)))
                                 (\ _ ->
                                   let {
                                     iedg = is_iedg_edge_dpp i dpp (s, t);
                                   } in bindb
  (catcha (check_subseteq (vars_term_lista tp) (vars_term_lista s))
    (\ x ->
      Inl (shows_prec_list Zero_nat
            (['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', ' '] ++
              x ++ [' ', 'o', 'n', 'l', 'y', ' ', 'o', 'c', 'c', 'u', 'r', 's',
                     ' ', 'o', 'n', ' ', 'r', 'h', 's', ' ', 'o', 'f', ' ', 'p',
                     'a', 'i', 'r']))))
  (\ _ ->
    bindb (check (membera (pb i dpp) st || null (rc i dpp))
            (shows_prec_list Zero_nat
              ['s', 't', 'r', 'i', 'c', 't', ' ', 'D', 'P', ' ', 'o', 'r', ' ',
                'n', 'o', ' ', 's', 't', 'r', 'i', 'c', 't', ' ', 'r', 'u', 'l',
                'e', 's', ' ', 'r', 'e', 'q', 'u', 'i', 'r', 'e', 'd']))
      (\ _ ->
        (if isnf tp
          then catcha
                 (forallM
                   (\ (u, v) ->
                     bindb (check (membera (poss_list u) p)
                             (shows_prec_list Zero_nat
                                ['p', 'o', 's', 'i', 't', 'i', 'o', 'n', ' ',
                                  'n', 'o', 't', ' ', 'c', 'o', 'n', 't', 'a',
                                  'i', 'n', 'e', 'd', ' ', 'i', 'n', ' ', 'l',
                                  'h', 's', ' ', 'o', 'f', ' ', 'p', 'a', 'i',
                                  'r', ' '] .
                               shows_rule (shows_prec Zero_nat)
                                 (shows_prec_list Zero_nat) [' ', '-', '>', ' ']
                                 (u, v)))
                       (\ _ ->
                         (case mgu_var_disjoint_generic (\ a -> 'x' : a)
                                 (\ a -> 'y' : a) tp (subt_at u p)
                           of {
                           Nothing -> Inr ();
                           Just (mu_1, mu_2) ->
                             check (not (isnf (subst_apply_term s mu_1)) ||
                                     not (isnf (subst_apply_term u mu_2)))
                               (shows_prec_list Zero_nat
                                  ['t', ' ', '|', '_', ' ', 'p', ' ', 'a', 'n',
                                    'd', ' ', 'u', ' ', '|', '_', ' ', 'p', ' ',
                                    'u', 'n', 'i', 'f', 'y', ' ', 'a', 'n', 'd',
                                    ' ', 's', 'a', 't', 'i', 's', 'f', 'y', ' ',
                                    'v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', ' ',
                                    'c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n',
                                    ' ', 'f', 'o', 'r', ' ', 'p', 'a', 'i', 'r',
                                    ' ', '(', 'u', ',', 'v', ')', ' ', '=',
                                    ' '] .
                                 shows_rule (shows_prec Zero_nat)
                                   (shows_prec_list Zero_nat)
                                   [' ', '-', '>', ' '] (u, v));
                         })))
                   (filter (\ (u, _) -> iedg u) pairs))
                 (\ x -> Inl (snd x))
          else Inr ()))))))
    of {
    Inl a -> Inl a;
    Inr _ -> Inr (replace_paira i dpp st sts);
  });

check_NF_terms_eq ::
  forall a b. (Eq a, Eq b) => [Term a b] -> [Term a b] -> Sum (Term a b) ();
check_NF_terms_eq qa q =
  bindb (check_NF_terms_subset qa q) (\ _ -> check_NF_terms_subset q qa);

check_dpp_subsumes ::
  forall a b c d.
    (Eq b, Showa b, Eq c, Showa c, Eq d,
      Showa d) => Dpp_ops_ext a (Lab b c) d () ->
                    (Bool,
                      (Bool,
                        ([(Term (Lab b c) d, Term (Lab b c) d)],
                          ([(Term (Lab b c) d, Term (Lab b c) d)],
                            ([Term (Lab b c) d],
                              ([(Term (Lab b c) d, Term (Lab b c) d)],
                                [(Term (Lab b c) d, Term (Lab b c) d)])))))) ->
                      a -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_dpp_subsumes i (nfs, (m, (p, (pw, (q, (r, rw)))))) d =
  catcha
    (let {
       pa = pb i d;
       pwaa = pwa i d;
       qa = qc i d;
       ra = rc i d;
       rwa = rwc i d;
       nfsa = nfsc i d;
       ma = minimal i d;
       pba = p ++ pw;
       rb = ra ++ rwa;
       rba = r ++ rw;
     } in bindb (check (ma == m)
                  (shows_prec_list Zero_nat
                    ['i', 'n', 'c', 'o', 'm', 'p', 'a', 't', 'i', 'b', 'l', 'e',
                      ' ', 'm', 'i', 'n', 'i', 'm', 'a', 'l', 'i', 't', 'y',
                      ' ', 'f', 'l', 'a', 'g', 's']))
            (\ _ ->
              bindb (check (nfsa == nfs)
                      (shows_prec_list Zero_nat
                        ['i', 'n', 'c', 'o', 'm', 'p', 'a', 't', 'i', 'b', 'l',
                          'e', ' ', 's', 'u', 'b', 's', 't', 'i', 't', 'u', 't',
                          'i', 'o', 'n', 's', '-', 'i', 'n', '-', 'n', 'o', 'r',
                          'm', 'a', 'l', '-', 'f', 'o', 'r', 'm', ' ', 'f', 'l',
                          'a', 'g', 's']))
                (\ _ ->
                  bindb (catcha (check_subseteq pa p)
                          (\ x ->
                            Inl (toomuch ['p', 'a', 'i', 'r']
                                  (shows_rule (shows_prec_lab Zero_nat)
                                    (shows_prec Zero_nat) [' ', '-', '>', ' ']
                                    x))))
                    (\ _ ->
                      bindb (catcha (check_subseteq pwaa pba)
                              (\ x ->
                                Inl (toomuch
                                      ['w', 'e', 'a', 'k', ' ', 'p', 'a', 'i',
'r']
                                      (shows_rule (shows_prec_lab Zero_nat)
(shows_prec Zero_nat) [' ', '-', '>', ' '] x))))
                        (\ _ ->
                          bindb (catcha (check_NF_terms_eq qa q)
                                  (\ x ->
                                    Inl (shows_prec_list Zero_nat
   ['N', 'F', '(', 'Q', ')', ' ', 'd', 'i', 'f', 'f', 'e', 'r', 's', ' ', 'd',
     'u', 'e', ' ', 't', 'o', ' ', 't', 'e', 'r', 'm', ' '] .
  shows_term (shows_prec_lab Zero_nat) (shows_prec Zero_nat) x)))
                            (\ _ ->
                              bindb (catcha (check_subseteq ra r)
                                      (\ x ->
Inl (toomuch ['s', 't', 'r', 'i', 'c', 't', ' ', 'r', 'u', 'l', 'e']
      (shows_rule (shows_prec_lab Zero_nat) (shows_prec Zero_nat)
        [' ', '-', '>', ' '] x))))
                                (\ _ ->
                                  bindb (catcha (check_subseteq rb rba)
  (\ x ->
    Inl (toomuch
          ['s', 't', 'r', 'i', 'c', 't', '/', 'w', 'e', 'a', 'k', ' ', 'r', 'u',
            'l', 'e']
          (shows_rule (shows_prec_lab Zero_nat) (shows_prec Zero_nat)
            [' ', '-', '>', ' '] x))))
                                    (\ _ ->
                                      bindb
(catcha (check_subseteq rba rb)
  (\ x ->
    Inl (missing
          ['s', 't', 'r', 'i', 'c', 't', '/', 'w', 'e', 'a', 'k', ' ', 'r', 'u',
            'l', 'e']
          (shows_rule (shows_prec_lab Zero_nat) (shows_prec Zero_nat)
            [' ', '-', '>', ' '] x))))
(\ _ -> Inr ())))))))))
    (\ x ->
      Inl (shows_string
             ['f', 'i', 'n', 'i', 't', 'e', 'n', 'e', 's', 's', ' ', 'o', 'f',
               ' ', 't', 'h', 'e', ' ', 'p', 'r', 'o', 'b', 'l', 'e', 'm'] .
            shows_nl .
              shows_dpp (shows_prec_lab Zero_nat) (shows_prec Zero_nat) i d .
                shows_nl .
                  shows_string
                    ['m', 'a', 'y', ' ', 'n', 'o', 't', ' ', 'b', 'e', ' ', 'c',
                      'o', 'n', 'c', 'l', 'u', 'd', 'e', 'd', ' ', 'f', 'r',
                      'o', 'm', ' ', 'a', 's', 's', 'u', 'm', 'i', 'n', 'g',
                      ' ', 'f', 'i', 'n', 'i', 't', 'e', 'n', 'e', 's', 's',
                      ' ', 'o', 'f', ' ', 't', 'h', 'e', ' ', 'p', 'r', 'o',
                      'b', 'l', 'e', 'm'] .
                    shows_nl .
                      shows_dpp (shows_prec_lab Zero_nat) (shows_prec Zero_nat)
                        i (mkc i nfs m p pw q r rw) .
                        shows_nl . x . shows_nl));

set_impl_lab :: forall a b. Phantom (Lab a b) Set_impl;
set_impl_lab = Phantom Set_RBT;

instance Set_impla (Lab a b) where {
  set_impl = set_impl_lab;
};

corder_lab ::
  forall a b.
    (Eq a, Linorder a, Eq b,
      Linorder b) => Maybe (Lab a b -> Lab a b -> Bool,
                             Lab a b -> Lab a b -> Bool);
corder_lab = Just (less_eq_lab, less_lab);

instance (Eq a, Linorder a, Eq b, Linorder b) => Corder (Lab a b) where {
  corder = corder_lab;
};

get_fcc_option ::
  forall a b c.
    Dp_termination_proof a b c ->
      Maybe (Lab a b,
              ([Ctxt (Lab a b) c],
                ([(Term (Lab a b) c, Term (Lab a b) c)],
                  ([(Term (Lab a b) c, Term (Lab a b) c)],
                    Dp_termination_proof a b c))));
get_fcc_option (Fcc_Proc f fcs pb rb prf) = Just (f, (fcs, (pb, (rb, prf))));
get_fcc_option P_is_Empty = Nothing;
get_fcc_option (Subterm_Criterion_Proc v va vb vc) = Nothing;
get_fcc_option (Redpair_Proc v va vb) = Nothing;
get_fcc_option (Redpair_UR_Proc v va vb vc) = Nothing;
get_fcc_option (Usable_Rules_Proc v va) = Nothing;
get_fcc_option (Dep_Graph_Proc v) = Nothing;
get_fcc_option (Mono_Redpair_Proc v va vb vc) = Nothing;
get_fcc_option (Mono_Redpair_UR_Proc v va vb vc vd) = Nothing;
get_fcc_option (Size_Change_Subterm_Proc v) = Nothing;
get_fcc_option (Size_Change_Redpair_Proc v va vb) = Nothing;
get_fcc_option (Uncurry_Proc v va vb vc vd) = Nothing;
get_fcc_option (Split_Proc v va vb vc) = Nothing;
get_fcc_option (Semlab_Proc v va vb vc vd) = Nothing;
get_fcc_option (Switch_Innermost_Proc v va) = Nothing;
get_fcc_option (Rewriting_Proc v va vb vc vd ve vf) = Nothing;
get_fcc_option (Instantiation_Proc v va vb) = Nothing;
get_fcc_option (Forward_Instantiation_Proc v va vb vc) = Nothing;
get_fcc_option (Narrowing_Proc v va vb vc) = Nothing;
get_fcc_option (Assume_Finite v va) = Nothing;
get_fcc_option (Unlab_Proc v va vb) = Nothing;
get_fcc_option (Q_Reduction_Proc v va) = Nothing;
get_fcc_option (Complex_Constant_Removal_Proc v va) = Nothing;
get_fcc_option (General_Redpair_Proc v va vb vc vd) = Nothing;

check_dp_termination_proof ::
  forall a b.
    (Countable b, Eq b, Key b,
      Showa b) => Bool ->
                    ([Prelude.Char] -> [Prelude.Char]) ->
                      Dpp_ops_ext a (Lab b [Nat]) [Prelude.Char] () ->
                        a -> Dp_termination_proof b [Nat] [Prelude.Char] ->
                               Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_dp_termination_proof assms ia i dpp P_is_Empty =
  debug (ia []) ['P', ' ', 'i', 's', ' ', 'e', 'm', 'p', 't', 'y']
    (if null (pb i dpp) && (null (pwa i dpp) || null (rc i dpp)) then Inr ()
      else Inl (ia . shows_string
                       [':', ' ', 'P', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ',
                         'e', 'm', 'p', 't', 'y', ' ', 'i', 'n', ' ', 't', 'h',
                         'e', ' ', 'f', 'o', 'l', 'l', 'o', 'w', 'i', 'n', 'g',
                         ' ', 'D', 'P', '-', 'p', 'r', 'o', 'b', 'l', 'e', 'm',
                         ' '] .
                       shows_nl .
                         shows_dpp (shows_prec_lab Zero_nat)
                           (shows_prec_list Zero_nat) i dpp));
check_dp_termination_proof assms ia i dpp (Subterm_Criterion_Proc p rseq rP prf)
  = debug (ia [])
      ['S', 'u', 'b', 't', 'e', 'r', 'm', '_', 'C', 'r', 'i', 't', 'e', 'r',
        'i', 'o', 'n', '_', 'P', 'r', 'o', 'c']
      (let {
         pa = pairsa i dpp;
         pr = ceta_list_diff pa rP;
       } in bindb (catcha (subterm_criterion_proc i p rseq pr dpp)
                    (\ x ->
                      Inl (ia . shows_string
                                  [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w',
                                    'h', 'e', 'n', ' ', 'a', 'p', 'p', 'l', 'y',
                                    'i', 'n', 'g', ' ', 't', 'h', 'e', ' ', 's',
                                    'u', 'b', 't', 'e', 'r', 'm', ' ', 'c', 'r',
                                    'i', 't', 'e', 'r', 'i', 'o', 'n', ' ', 't',
                                    'o', ' ', 't', 'h', 'e', ' ', 'D', 'P', ' ',
                                    'p', 'r', 'o', 'b', 'l', 'e', 'm'] .
                                  shows_nl .
                                    shows_dpp (shows_prec_lab Zero_nat)
                                      (shows_prec_list Zero_nat) i dpp .
                                      shows_nl .
shows_string
  ['a', 'n', 'd', ' ', 't', 'r', 'y', 'i', 'n', 'g', ' ', 't', 'o', ' ', 'r',
    'e', 'm', 'o', 'v', 'e', ' ', 't', 'h', 'e', ' ', 'p', 'a', 'i', 'r', 's',
    ' '] .
  shows_nl .
    shows_rules (shows_prec_lab Zero_nat) (shows_prec_list Zero_nat)
      [' ', '-', '>', ' '] pr .
      shows_nl . x)))
              (\ dppa ->
                catcha
                  (check_dp_termination_proof assms
                    (ia . shows_string ['.', '1']) i dppa prf)
                  (\ x ->
                    Inl (ia . shows_string
                                [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b',
                                  'e', 'l', 'o', 'w', ' ', 't', 'h', 'e', ' ',
                                  's', 'u', 'b', 't', 'e', 'r', 'm', ' ', 'c',
                                  'r', 'i', 't', 'e', 'r', 'i', 'o', 'n'] .
                                shows_nl . indent x))));
check_dp_termination_proof assms ia i dpp (Redpair_Proc redp rP prf) =
  debug (ia []) ['R', 'e', 'd', 'p', 'a', 'i', 'r', '_', 'P', 'r', 'o', 'c']
    (let {
       p = pairsa i dpp;
       pr = ceta_list_diff p rP;
       proc =
         (case redp of {
           Inl rrp ->
             generic_ur_af_root_redtriple_proc i (get_root_redtriple rrp)
               Nothing;
           Inr rp -> generic_ur_af_redtriple_proc i (get_redtriple rp) Nothing;
         });
     } in bindb (catcha (proc pr dpp)
                  (\ x ->
                    Inl (ia . shows_string
                                [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w',
                                  'h', 'e', 'n', ' ', 'a', 'p', 'p', 'l', 'y',
                                  'i', 'n', 'g', ' ', 't', 'h', 'e', ' ', 'r',
                                  'e', 'd', 'u', 'c', 't', 'i', 'o', 'n', ' ',
                                  'p', 'a', 'i', 'r', ' ', 'p', 'r', 'o', 'c',
                                  'e', 's', 's', 'o', 'r', ' ', 't', 'o', ' ',
                                  'r', 'e', 'm', 'o', 'v', 'e', ' ', 'f', 'r',
                                  'o', 'm', ' ', 't', 'h', 'e', ' ', 'D', 'P',
                                  ' ', 'p', 'r', 'o', 'b', 'l', 'e', 'm'] .
                                shows_nl .
                                  shows_dpp (shows_prec_lab Zero_nat)
                                    (shows_prec_list Zero_nat) i dpp .
                                    shows_nl .
                                      shows_string
[' ', 't', 'h', 'e', ' ', 'p', 'a', 'i', 'r', 's', ' '] .
shows_nl .
  shows_rules (shows_prec_lab Zero_nat) (shows_prec_list Zero_nat)
    [' ', '-', '>', ' '] pr .
    shows_nl . x)))
            (\ dppa ->
              catcha
                (check_dp_termination_proof assms (ia . shows_string ['.', '1'])
                  i dppa prf)
                (\ x ->
                  Inl (ia . shows_string
                              [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e',
                                'l', 'o', 'w', ' ', 't', 'h', 'e', ' ', 'r',
                                'e', 'd', 'u', 'c', 't', 'i', 'o', 'n', ' ',
                                'p', 'a', 'i', 'r', ' ', 'p', 'r', 'o', 'c',
                                'e', 's', 's', 'o', 'r'] .
                              shows_nl . indent x))));
check_dp_termination_proof assms ia i dpp (Usable_Rules_Proc u prf) =
  debug (ia [])
    ['U', 's', 'a', 'b', 'l', 'e', '_', 'R', 'u', 'l', 'e', 's', '_', 'P', 'r',
      'o', 'c']
    (bindb
      (catcha (usable_rules_proc i u dpp)
        (\ x ->
          Inl (ia . shows_string
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e',
                        'n', ' ', 'a', 'p', 'p', 'l', 'y', 'i', 'n', 'g', ' ',
                        't', 'h', 'e', ' ', 'u', 's', 'a', 'b', 'l', 'e', ' ',
                        'r', 'u', 'l', 'e', 's', ' ', 'p', 'r', 'o', 'c', 'e',
                        's', 's', 'o', 'r', ' ', 't', 'o', ' ', 'r', 'e', 's',
                        't', 'r', 'i', 'c', 't', ' ', 't', 'h', 'e', ' ', 'D',
                        'P', ' ', 'p', 'r', 'o', 'b', 'l', 'e', 'm'] .
                      shows_nl .
                        shows_dpp (shows_prec_lab Zero_nat)
                          (shows_prec_list Zero_nat) i dpp .
                          shows_nl .
                            shows_string
                              [' ', 't', 'o', ' ', 't', 'h', 'e', ' ', 'u', 's',
                                'a', 'b', 'l', 'e', ' ', 'r', 'u', 'l', 'e',
                                's', ' '] .
                              shows_nl .
                                shows_rules (shows_prec_lab Zero_nat)
                                  (shows_prec_list Zero_nat)
                                  [' ', '-', '>', ' '] u .
                                  shows_nl . x)))
      (\ dppa ->
        catcha
          (check_dp_termination_proof assms (ia . shows_string ['.', '1']) i
            dppa prf)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                          'o', 'w', ' ', 't', 'h', 'e', ' ', 'u', 's', 'a', 'b',
                          'l', 'e', ' ', 'r', 'u', 'l', 'e', 's', ' ', 'p', 'r',
                          'o', 'c', 'e', 's', 's', 'o', 'r'] .
                        shows_nl . indent x))));
check_dp_termination_proof assms ia i dpp (Q_Reduction_Proc q prf) =
  debug (ia [])
    ['Q', '_', 'R', 'e', 'd', 'u', 'c', 't', 'i', 'o', 'n', '_', 'P', 'r', 'o',
      'c']
    (bindb
      (catcha (q_reduction_proc i q dpp)
        (\ x ->
          Inl (ia . shows_prec_list Zero_nat
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e',
                        'n', ' ', 'a', 'p', 'p', 'l', 'y', 'i', 'n', 'g', ' ',
                        't', 'h', 'e', ' ', 'Q', '-', 'r', 'e', 'd', 'u', 'c',
                        't', 'i', 'o', 'n', ' ', 'p', 'r', 'o', 'c', 'e', 's',
                        's', 'o', 'r'] .
                      shows_nl . x)))
      (\ dppa ->
        catcha
          (check_dp_termination_proof assms (ia . shows_string ['.', '1']) i
            dppa prf)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                          'o', 'w', ' ', 't', 'h', 'e', ' ', 'Q', '-', 'r', 'e',
                          'd', 'u', 'c', 't', 'i', 'o', 'n', ' ', 'p', 'r', 'o',
                          'c', 'e', 's', 's', 'o', 'r'] .
                        shows_nl . indent x))));
check_dp_termination_proof assms ia i dpp (Mono_Redpair_Proc redp rP rR prf) =
  debug (ia [])
    ['M', 'o', 'n', 'o', '_', 'R', 'e', 'd', 'p', 'a', 'i', 'r', '_', 'P', 'r',
      'o', 'c']
    (let {
       p = pairsa i dpp;
       pr = ceta_list_diff p rP;
       r = rulesd i dpp;
       rr = ceta_list_diff r rR;
     } in bindb (catcha (mono_redpair_proc i (get_redtriple redp) pr rr dpp)
                  (\ x ->
                    Inl (ia . shows_string
                                [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w',
                                  'h', 'e', 'n', ' ', 'a', 'p', 'p', 'l', 'y',
                                  'i', 'n', 'g', ' ', 't', 'h', 'e', ' ', 'm',
                                  'o', 'n', 'o', ' ', 'r', 'e', 'd', 'u', 'c',
                                  't', 'i', 'o', 'n', ' ', 'p', 'a', 'i', 'r',
                                  ' ', 'p', 'r', 'o', 'c', 'e', 's', 's', 'o',
                                  'r', ' ', 't', 'o', ' ', 'r', 'e', 'm', 'o',
                                  'v', 'e', ' ', 'f', 'r', 'o', 'm', ' ', 't',
                                  'h', 'e', ' ', 'D', 'P', ' ', 'p', 'r', 'o',
                                  'b', 'l', 'e', 'm'] .
                                shows_nl .
                                  shows_dpp (shows_prec_lab Zero_nat)
                                    (shows_prec_list Zero_nat) i dpp .
                                    shows_nl .
                                      shows_string
[' ', 't', 'h', 'e', ' ', 'p', 'a', 'i', 'r', 's', ' '] .
shows_nl .
  shows_rules (shows_prec_lab Zero_nat) (shows_prec_list Zero_nat)
    [' ', '-', '>', ' '] pr .
    shows_nl .
      shows_string
        [' ', 'a', 'n', 'd', ' ', 't', 'h', 'e', ' ', 'r', 'u', 'l', 'e', 's',
          ' '] .
        shows_nl .
          shows_rules (shows_prec_lab Zero_nat) (shows_prec_list Zero_nat)
            [' ', '-', '>', ' '] rr .
            shows_nl . x)))
            (\ dppa ->
              catcha
                (check_dp_termination_proof assms (ia . shows_string ['.', '1'])
                  i dppa prf)
                (\ x ->
                  Inl (ia . shows_string
                              [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e',
                                'l', 'o', 'w', ' ', 't', 'h', 'e', ' ', 'm',
                                'o', 'n', 'o', ' ', 'r', 'e', 'd', 'u', 'c',
                                't', 'i', 'o', 'n', ' ', 'p', 'a', 'i', 'r',
                                ' ', 'p', 'r', 'o', 'c', 'e', 's', 's', 'o',
                                'r'] .
                              shows_nl . indent x))));
check_dp_termination_proof assms ia i dpp (Dep_Graph_Proc edpts) =
  debug (ia [])
    ['D', 'e', 'p', '_', 'G', 'r', 'a', 'p', 'h', '_', 'P', 'r', 'o', 'c']
    (bindb
      (catcha (dep_graph_proc i dpp edpts)
        (\ x ->
          Inl (ia . shows_string
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'i',
                        'l', 'e', ' ', 't', 'r', 'y', 'i', 'n', 'g', ' ', 't',
                        'o', ' ', 'p', 'e', 'r', 'f', 'o', 'r', 'm', ' ', 'S',
                        'C', 'C', '-', 'd', 'e', 'c', 'o', 'm', 'p', 'o', 's',
                        'i', 't', 'i', 'o', 'n', ' ', ' ', 'o', 'n', ' '] .
                      shows_nl .
                        shows_dpp (shows_prec_lab Zero_nat)
                          (shows_prec_list Zero_nat) i dpp .
                          shows_nl . x)))
      (\ pdpps ->
        catcha
          (catcha
            (forallM_index
              (\ (prof, dppa) j ->
                check_dp_termination_proof assms
                  (ia . shows_string ['.'] .
                          shows_prec_nat Zero_nat (plus_nat j (Nat_of_num One)))
                  i dppa prof)
              pdpps)
            (\ x -> Inl (snd x)))
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                          'o', 'w', ' ', 't', 'h', 'e', ' ', 'd', 'e', 'p', 'e',
                          'n', 'd', 'e', 'n', 'c', 'y', ' ', 'g', 'r', 'a', 'p',
                          'h', ' ', 'p', 'r', 'o', 'c', 'e', 's', 's', 'o',
                          'r'] .
                        shows_nl . indent x))));
check_dp_termination_proof assms ia i dpp (Redpair_UR_Proc redp rP ur prf) =
  debug (ia [])
    ['R', 'e', 'd', 'p', 'a', 'i', 'r', '_', 'U', 'R', '_', 'P', 'r', 'o', 'c']
    (let {
       p = pairsa i dpp;
       pr = ceta_list_diff p rP;
       proc =
         (case redp of {
           Inl rrp ->
             generic_ur_af_root_redtriple_proc i (get_root_redtriple rrp)
               (Just ur);
           Inr rp ->
             generic_ur_af_redtriple_proc i (get_redtriple rp) (Just ur);
         });
     } in bindb (catcha (proc pr dpp)
                  (\ x ->
                    Inl (ia . shows_string
                                [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w',
                                  'h', 'e', 'n', ' ', 'a', 'p', 'p', 'l', 'y',
                                  'i', 'n', 'g', ' ', 't', 'h', 'e', ' ', 'r',
                                  'e', 'd', 'u', 'c', 't', 'i', 'o', 'n', ' ',
                                  'p', 'a', 'i', 'r', ' ', 'p', 'r', 'o', 'c',
                                  'e', 's', 's', 'o', 'r', ' ', 'w', 'i', 't',
                                  'h', ' ', 'u', 's', 'a', 'b', 'l', 'e', ' ',
                                  'r', 'u', 'l', 'e', 's', ' ', 't', 'o', ' ',
                                  'r', 'e', 'm', 'o', 'v', 'e', ' ', 'f', 'r',
                                  'o', 'm', ' ', 't', 'h', 'e', ' ', 'D', 'P',
                                  ' ', 'p', 'r', 'o', 'b', 'l', 'e', 'm'] .
                                shows_nl .
                                  shows_dpp (shows_prec_lab Zero_nat)
                                    (shows_prec_list Zero_nat) i dpp .
                                    shows_nl .
                                      shows_string
[' ', 't', 'h', 'e', ' ', 'p', 'a', 'i', 'r', 's', ' '] .
shows_nl .
  shows_rules (shows_prec_lab Zero_nat) (shows_prec_list Zero_nat)
    [' ', '-', '>', ' '] pr .
    shows_nl . x)))
            (\ dppa ->
              catcha
                (check_dp_termination_proof assms (ia . shows_string ['.', '1'])
                  i dppa prf)
                (\ x ->
                  Inl (ia . shows_string
                              [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e',
                                'l', 'o', 'w', ' ', 't', 'h', 'e', ' ', 'r',
                                'e', 'd', 'u', 'c', 't', 'i', 'o', 'n', ' ',
                                'p', 'a', 'i', 'r', ' ', 'p', 'r', 'o', 'c',
                                'e', 's', 's', 'o', 'r'] .
                              shows_nl . indent x))));
check_dp_termination_proof assms ia i dpp
  (Mono_Redpair_UR_Proc redp rP rR ur prf) =
  debug (ia [])
    ['M', 'o', 'n', 'o', '_', 'R', 'e', 'd', 'p', 'a', 'i', 'r', '_', 'U', 'R',
      '_', 'P', 'r', 'o', 'c']
    (let {
       p = pairsa i dpp;
       pr = ceta_list_diff p rP;
       r = rulesd i dpp;
       rr = ceta_list_diff r rR;
     } in bindb (catcha
                  (mono_ur_redpair_proc i (get_redtriple redp) pr rr ur dpp)
                  (\ x ->
                    Inl (ia . shows_string
                                [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w',
                                  'h', 'e', 'n', ' ', 'a', 'p', 'p', 'l', 'y',
                                  'i', 'n', 'g', ' ', 't', 'h', 'e', ' ', 'm',
                                  'o', 'n', 'o', ' ', 'r', 'e', 'd', 'u', 'c',
                                  't', 'i', 'o', 'n', ' ', 'p', 'a', 'i', 'r',
                                  ' ', 'p', 'r', 'o', 'c', 'e', 's', 's', 'o',
                                  'r', ' ', 'w', 'i', 't', 'h', ' ', 'u', 's',
                                  'a', 'b', 'l', 'e', ' ', 'r', 'u', 'l', 'e',
                                  's', ' ', 't', 'o', ' ', 'r', 'e', 'm', 'o',
                                  'v', 'e', ' ', 'f', 'r', 'o', 'm', ' ', 't',
                                  'h', 'e', ' ', 'D', 'P', ' ', 'p', 'r', 'o',
                                  'b', 'l', 'e', 'm'] .
                                shows_nl .
                                  shows_dpp (shows_prec_lab Zero_nat)
                                    (shows_prec_list Zero_nat) i dpp .
                                    shows_nl .
                                      shows_string
[' ', 't', 'h', 'e', ' ', 'p', 'a', 'i', 'r', 's', ' '] .
shows_nl .
  shows_rules (shows_prec_lab Zero_nat) (shows_prec_list Zero_nat)
    [' ', '-', '>', ' '] pr .
    shows_nl .
      shows_string
        [' ', 'a', 'n', 'd', ' ', 't', 'h', 'e', ' ', 'r', 'u', 'l', 'e', 's',
          ' '] .
        shows_nl .
          shows_rules (shows_prec_lab Zero_nat) (shows_prec_list Zero_nat)
            [' ', '-', '>', ' '] rr .
            shows_nl . x)))
            (\ dppa ->
              catcha
                (check_dp_termination_proof assms (ia . shows_string ['.', '1'])
                  i dppa prf)
                (\ x ->
                  Inl (ia . shows_string
                              [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e',
                                'l', 'o', 'w', ' ', 't', 'h', 'e', ' ', 'm',
                                'o', 'n', 'o', ' ', 'r', 'e', 'd', 'u', 'c',
                                't', 'i', 'o', 'n', ' ', 'p', 'a', 'i', 'r',
                                ' ', 'p', 'r', 'o', 'c', 'e', 's', 's', 'o',
                                'r', ' ', 'w', 'i', 't', 'h', ' ', 'u', 's',
                                'a', 'b', 'l', 'e', ' ', 'r', 'u', 'l', 'e',
                                's'] .
                              shows_nl . indent x))));
check_dp_termination_proof assms ia i dpp (Uncurry_Proc mode u_info p r prf) =
  debug (ia []) ['U', 'n', 'c', 'u', 'r', 'r', 'y', '_', 'P', 'r', 'o', 'c']
    (bindb
      (catcha (uncurry_proc_both i mode u_info p r dpp)
        (\ x ->
          Inl (ia . shows_string
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e',
                        'n', ' ', 'a', 'p', 'p', 'l', 'y', 'i', 'n', 'g', ' ',
                        't', 'h', 'e', ' ', 'u', 'n', 'c', 'u', 'r', 'r', 'y',
                        'i', 'n', 'g', ' ', 'p', 'r', 'o', 'c', 'e', 's', 's',
                        'o', 'r', ' ', 'o', 'n', ' ', 't', 'h', 'e', ' ', 'D',
                        'P', ' ', 'p', 'r', 'o', 'b', 'l', 'e', 'm'] .
                      shows_nl .
                        shows_dpp (shows_prec_lab Zero_nat)
                          (shows_prec_list Zero_nat) i dpp .
                          shows_nl . x)))
      (\ dppa ->
        catcha
          (check_dp_termination_proof assms (ia . shows_string ['.', '1']) i
            dppa prf)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                          'o', 'w', ' ', 't', 'h', 'e', ' ', 'u', 'n', 'c', 'u',
                          'r', 'r', 'y', 'i', 'n', 'g', ' ', 'p', 'r', 'o', 'c',
                          'e', 's', 's', 'o', 'r'] .
                        shows_nl . indent x))));
check_dp_termination_proof assms ia i dpp (Size_Change_Subterm_Proc graphs) =
  debug (ia [])
    ['S', 'i', 'z', 'e', '_', 'C', 'h', 'a', 'n', 'g', 'e', '_', 'S', 'u', 'b',
      't', 'e', 'r', 'm', '_', 'P', 'r', 'o', 'c']
    (sct_subterm_proc i graphs dpp);
check_dp_termination_proof assms ia i dpp
  (Size_Change_Redpair_Proc redp u_opt graphs) =
  debug (ia [])
    ['S', 'i', 'z', 'e', '_', 'C', 'h', 'a', 'n', 'g', 'e', '_', 'R', 'e', 'd',
      'p', 'a', 'i', 'r', '_', 'P', 'r', 'o', 'c']
    (sct_ur_af_proc i (get_redtriple redp) graphs u_opt dpp);
check_dp_termination_proof assms ia i dpp (Fcc_Proc f fcs pb r prf) =
  debug (ia []) ['F', 'c', 'c', '_', 'P', 'r', 'o', 'c']
    (bindb
      (catcha (fcc_proc i f fcs pb r dpp)
        (\ x ->
          Inl (ia . shows_string
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e',
                        'n', ' ', 'a', 'p', 'p', 'l', 'y', 'i', 'n', 'g', ' ',
                        't', 'h', 'e', ' ', 'f', 'l', 'a', 't', ' ', 'c', 'o',
                        'n', 't', 'e', 'x', 't', ' ', 'c', 'l', 'o', 's', 'u',
                        'r', 'e', ' ', 'p', 'r', 'o', 'c', 'e', 's', 's', 'o',
                        'r', ' ', 'o', 'n', ' ', 't', 'h', 'e', ' ', 'D', 'P',
                        ' ', 'p', 'r', 'o', 'b', 'l', 'e', 'm'] .
                      shows_nl .
                        shows_dpp (shows_prec_lab Zero_nat)
                          (shows_prec_list Zero_nat) i dpp .
                          shows_nl . x)))
      (\ dppa ->
        catcha
          (check_dp_termination_proof assms (ia . shows_string ['.', '1']) i
            dppa prf)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                          'o', 'w', ' ', 't', 'h', 'e', ' ', 'f', 'l', 'a', 't',
                          ' ', 'c', 'o', 'n', 't', 'e', 'x', 't', ' ', 'c', 'l',
                          'o', 's', 'u', 'r', 'e', ' ', 'p', 'r', 'o', 'c', 'e',
                          's', 's', 'o', 'r'] .
                        shows_nl . indent x))));
check_dp_termination_proof assms ia i dpp (Split_Proc prem rrem prf1 prf2) =
  debug (ia []) ['S', 'p', 'l', 'i', 't', '_', 'P', 'r', 'o', 'c']
    (case get_fcc_option prf1 of {
      Nothing ->
        let {
          (dpp1, dpp2) = split_proc i dpp prem rrem;
        } in bindb (catcha
                     (check_dp_termination_proof assms
                       (ia . shows_string ['.', '1']) i dpp1 prf1)
                     (\ x ->
                       Inl (ia . shows_string
                                   [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b',
                                     'e', 'l', 'o', 'w', ' ', 't', 'h', 'e',
                                     ' ', 's', 'p', 'l', 'i', 't', ' ', 'p',
                                     'r', 'o', 'c', 'e', 's', 's', 'o', 'r'] .
                                   shows_nl . indent x)))
               (\ _ ->
                 catcha
                   (check_dp_termination_proof assms
                     (ia . shows_string ['.', '2']) i dpp2 prf2)
                   (\ x ->
                     Inl (ia . shows_string
                                 [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b',
                                   'e', 'l', 'o', 'w', ' ', 't', 'h', 'e', ' ',
                                   's', 'p', 'l', 'i', 't', ' ', 'p', 'r', 'o',
                                   'c', 'e', 's', 's', 'o', 'r'] .
                                 shows_nl . indent x)));
      Just (f, (fcs, (pb, (rb, prf1a)))) ->
        debug (ia [])
          ['S', 'p', 'l', 'i', 't', '_', 'P', 'r', 'o', 'c', 'F', 'c', 'c']
          (bindb (fcc_split_proc i f fcs pb rb prem rrem dpp)
            (\ (dpp1, dpp2) ->
              bindb (catcha
                      (check_dp_termination_proof assms
                        (ia . shows_string ['.', '1', '.', '1']) i dpp1 prf1a)
                      (\ x ->
                        Inl (ia . shows_string
                                    [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ',
                                      'b', 'e', 'l', 'o', 'w', ' ', 't', 'h',
                                      'e', ' ', 's', 'p', 'l', 'i', 't', ' ',
                                      'a', 'n', 'd', ' ', 'f', 'c', 'c', ' ',
                                      'p', 'r', 'o', 'c', 'e', 's', 's', 'o',
                                      'r'] .
                                    shows_nl . indent x)))
                (\ _ ->
                  catcha
                    (check_dp_termination_proof assms
                      (ia . shows_string ['.', '2']) i dpp2 prf2)
                    (\ x ->
                      Inl (ia . shows_string
                                  [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b',
                                    'e', 'l', 'o', 'w', ' ', 't', 'h', 'e', ' ',
                                    's', 'p', 'l', 'i', 't', ' ', 'p', 'r', 'o',
                                    'c', 'e', 's', 's', 'o', 'r'] .
                                  shows_nl . indent x)))));
    });
check_dp_termination_proof assms ia i dpp (Semlab_Proc sli lP lQ lR prf) =
  debug (ia []) ['S', 'e', 'm', 'l', 'a', 'b', '_', 'P', 'r', 'o', 'c']
    (bindb
      (catcha (semlab_fin_proc i sli lP lQ lR dpp)
        (\ x ->
          Inl (ia . shows_string
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e',
                        'n', ' ', 'a', 'p', 'p', 'l', 'y', 'i', 'n', 'g', ' ',
                        't', 'h', 'e', ' ', 's', 'e', 'm', 'l', 'a', 'b', ' ',
                        'p', 'r', 'o', 'c', 'e', 's', 's', 'o', 'r', ' ', 'o',
                        'n', ' ', 't', 'h', 'e', ' ', 'D', 'P', ' ', 'p', 'r',
                        'o', 'b', 'l', 'e', 'm'] .
                      shows_nl .
                        shows_dpp (shows_prec_lab Zero_nat)
                          (shows_prec_list Zero_nat) i dpp .
                          shows_nl . x)))
      (\ dppa ->
        catcha
          (check_dp_termination_proof assms (ia . shows_string ['.', '1']) i
            dppa prf)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                          'o', 'w', ' ', 't', 'h', 'e', ' ', 's', 'e', 'm', 'l',
                          'a', 'b', ' ', 'p', 'r', 'o', 'c', 'e', 's', 's', 'o',
                          'r'] .
                        shows_nl . indent x))));
check_dp_termination_proof assms ia i dpp (Switch_Innermost_Proc joins prf) =
  debug (ia [])
    ['S', 'w', 'i', 't', 'c', 'h', '_', 'I', 'n', 'n', 'e', 'r', 'm', 'o', 's',
      't', '_', 'P', 'r', 'o', 'c']
    (bindb
      (catcha (switch_innermost_proc i joins dpp)
        (\ x ->
          Inl (ia . shows_string
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e',
                        'n', ' ', 'a', 'p', 'p', 'l', 'y', 'i', 'n', 'g', ' ',
                        't', 'h', 'e', ' ', 'p', 'r', 'o', 'c', 'e', 's', 's',
                        'o', 'r', ' ', 't', 'o', ' ', 's', 'w', 'i', 't', 'c',
                        'h', ' ', 't', 'o', ' ', 'i', 'n', 'n', 'e', 'r', 'm',
                        'o', 's', 't', ' ', 'o', 'n', ' ', 't', 'h', 'e', ' ',
                        'D', 'P', ' ', 'p', 'r', 'o', 'b', 'l', 'e', 'm'] .
                      shows_nl .
                        shows_dpp (shows_prec_lab Zero_nat)
                          (shows_prec_list Zero_nat) i dpp .
                          shows_nl . x)))
      (\ dppa ->
        catcha
          (check_dp_termination_proof assms (ia . shows_string ['.', '1']) i
            dppa prf)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                          'o', 'w', ' ', 't', 'h', 'e', ' ', 's', 'w', 'i', 't',
                          'c', 'h', ' ', 't', 'o', ' ', 'i', 'n', 'n', 'e', 'r',
                          'm', 'o', 's', 't', ' ', 'p', 'r', 'o', 'c', 'e', 's',
                          's', 'o', 'r'] .
                        shows_nl . indent x))));
check_dp_termination_proof assms ia i dppa (Assume_Finite dpp dps) =
  debug (ia [])
    ['F', 'i', 'n', 'i', 't', 'e', 'n', 'e', 's', 's', ' ', 'A', 's', 's', 'u',
      'm', 'p', 't', 'i', 'o', 'n', ' ', 'o', 'r', ' ', 'U', 'n', 'k', 'n', 'o',
      'w', 'n', ' ', 'P', 'r', 'o', 'o', 'f']
    (if assms
      then bindb (catcha (check_dpp_subsumes i dpp dppa)
                   (\ x ->
                     Inl (ia . shows_string
                                 [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i',
                                   'n', ' ', 'f', 'i', 'n', 'i', 't', 'e', 'n',
                                   'e', 's', 's', ' ', 'a', 's', 's', 'u', 'm',
                                   'p', 't', 'i', 'o', 'n', ' ', 'o', 'r', ' ',
                                   'u', 'n', 'k', 'n', 'o', 'w', 'n', ' ', 'p',
                                   'r', 'o', 'o', 'f'] .
                                 shows_nl . x . shows_nl)))
             (\ _ ->
               catcha
                 (catcha
                   (forallM_index
                     (\ (dppb, p) j ->
                       check_dp_termination_proof assms
                         (ia . shows_string ['.'] .
                                 shows_prec_nat Zero_nat
                                   (plus_nat j (Nat_of_num One)))
                         i (mk_dpp i dppb) p)
                     dps)
                   (\ x -> Inl (snd x)))
                 (\ x ->
                   Inl (ia . shows_string
                               [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b',
                                 'e', 'l', 'o', 'w', ' ', 'u', 'n', 'k', 'n',
                                 'o', 'w', 'n', ' ', 'p', 'r', 'o', 'o', 'f'] .
                               shows_nl . indent x)))
      else Inl (ia . shows_string
                       [':', ' ', 't', 'h', 'e', ' ', 'p', 'r', 'o', 'o', 'f',
                         ' ', 'c', 'o', 'n', 't', 'a', 'i', 'n', 's', ' ', 'a',
                         ' ', 'f', 'i', 'n', 'i', 't', 'e', 'n', 'e', 's', 's',
                         ' ', 'a', 's', 's', 'u', 'm', 'p', 't', 'i', 'o', 'n',
                         ' ', 'o', 'r', ' ', 'u', 'n', 'k', 'n', 'o', 'w', 'n',
                         ' ', 'p', 'r', 'o', 'o', 'f'] .
                       shows_nl));
check_dp_termination_proof assms ia i dpp
  (Rewriting_Proc u_opt stb sta st lr p prf) =
  debug (ia [])
    ['R', 'e', 'w', 'r', 'i', 't', 'i', 'n', 'g', '_', 'P', 'r', 'o', 'c']
    (bindb
      (catcha (rewriting_proc i u_opt stb sta st lr p dpp)
        (\ x ->
          Inl (ia . shows_string
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e',
                        'n', ' ', 'a', 'p', 'p', 'l', 'y', 'i', 'n', 'g', ' ',
                        't', 'h', 'e', ' ', 'r', 'e', 'w', 'r', 'i', 't', 'i',
                        'n', 'g', ' ', 'p', 'r', 'o', 'c', 'e', 's', 's', 'o',
                        'r', ' ', 't', 'o', ' ', 'r', 'e', 'w', 'r', 'i', 't',
                        'e', ' ', 't', 'h', 'e', ' ', 'p', 'a', 'i', 'r', ' '] .
                      shows_nl .
                        shows_rule (shows_prec_lab Zero_nat)
                          (shows_prec_list Zero_nat) [' ', '-', '>', ' '] stb .
                          shows_nl .
                            shows_string
                              [' ', 't', 'o', ' ', 't', 'h', 'e', ' ', 'p', 'a',
                                'i', 'r', ' '] .
                              shows_nl .
                                shows_rule (shows_prec_lab Zero_nat)
                                  (shows_prec_list Zero_nat)
                                  [' ', '-', '>', ' '] st .
                                  shows_nl . x)))
      (\ dppa ->
        catcha
          (check_dp_termination_proof assms (ia . shows_string ['.', '1']) i
            dppa prf)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                          'o', 'w', ' ', 't', 'h', 'e', ' ', 'r', 'e', 'w', 'r',
                          'i', 't', 'i', 'n', 'g', ' ', 'p', 'r', 'o', 'c', 'e',
                          's', 's', 'o', 'r'] .
                        shows_nl . indent x))));
check_dp_termination_proof assms ia i dpp (Narrowing_Proc st p sts prf) =
  debug (ia [])
    ['N', 'a', 'r', 'r', 'o', 'w', 'i', 'n', 'g', '_', 'P', 'r', 'o', 'c']
    (bindb
      (catcha (narrowing_proc i st p sts dpp)
        (\ x ->
          Inl (ia . shows_string
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e',
                        'n', ' ', 'a', 'p', 'p', 'l', 'y', 'i', 'n', 'g', ' ',
                        't', 'h', 'e', ' ', 'n', 'a', 'r', 'r', 'o', 'w', 'i',
                        'n', 'g', ' ', 'p', 'r', 'o', 'c', 'e', 's', 's', 'o',
                        'r', ' ', 't', 'o', ' ', 'n', 'a', 'r', 'r', 'o', 'w',
                        ' ', 't', 'h', 'e', ' ', 'p', 'a', 'i', 'r', ' '] .
                      shows_nl .
                        shows_rule (shows_prec_lab Zero_nat)
                          (shows_prec_list Zero_nat) [' ', '-', '>', ' '] st .
                          shows_nl .
                            shows_string
                              [' ', 't', 'o', ' ', 't', 'h', 'e', ' ', 'p', 'a',
                                'i', 'r', 's', ' '] .
                              shows_nl .
                                shows_trs (shows_prec_lab Zero_nat)
                                  (shows_prec_list Zero_nat)
                                  ['r', 'e', 'w', 'r', 'i', 't', 'e', ' ', 's',
                                    'y', 's', 't', 'e', 'm', ':']
                                  [' ', '-', '>', ' '] sts .
                                  shows_nl . x)))
      (\ dppa ->
        catcha
          (check_dp_termination_proof assms (ia . shows_string ['.', '1']) i
            dppa prf)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                          'o', 'w', ' ', 't', 'h', 'e', ' ', 'n', 'a', 'r', 'r',
                          'o', 'w', 'i', 'n', 'g', ' ', 'p', 'r', 'o', 'c', 'e',
                          's', 's', 'o', 'r'] .
                        shows_nl . indent x))));
check_dp_termination_proof assms ia i dpp (Instantiation_Proc st sts prf) =
  debug (ia [])
    ['I', 'n', 's', 't', 'a', 'n', 't', 'i', 'a', 't', 'i', 'o', 'n', '_', 'P',
      'r', 'o', 'c']
    (bindb
      (catcha (instantiation_proc i st sts dpp)
        (\ x ->
          Inl (ia . shows_string
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e',
                        'n', ' ', 'a', 'p', 'p', 'l', 'y', 'i', 'n', 'g', ' ',
                        't', 'h', 'e', ' ', 'i', 'n', 's', 't', 'a', 'n', 't',
                        'i', 'a', 't', 'i', 'o', 'n', ' ', 'p', 'r', 'o', 'c',
                        'e', 's', 's', 'o', 'r', ' ', 't', 'o', ' ', 'i', 'n',
                        's', 't', 'a', 'n', 't', 'i', 'a', 't', 'e', ' ', 't',
                        'h', 'e', ' ', 'p', 'a', 'i', 'r', ' '] .
                      shows_nl .
                        shows_rule (shows_prec_lab Zero_nat)
                          (shows_prec_list Zero_nat) [' ', '-', '>', ' '] st .
                          shows_nl .
                            shows_string
                              [' ', 't', 'o', ' ', 't', 'h', 'e', ' ', 'p', 'a',
                                'i', 'r', 's', ' '] .
                              shows_nl .
                                shows_trs (shows_prec_lab Zero_nat)
                                  (shows_prec_list Zero_nat)
                                  ['r', 'e', 'w', 'r', 'i', 't', 'e', ' ', 's',
                                    'y', 's', 't', 'e', 'm', ':']
                                  [' ', '-', '>', ' '] sts .
                                  shows_nl . x)))
      (\ dppa ->
        catcha
          (check_dp_termination_proof assms (ia . shows_string ['.', '1']) i
            dppa prf)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                          'o', 'w', ' ', 't', 'h', 'e', ' ', 'i', 'n', 's', 't',
                          'a', 'n', 't', 'i', 'a', 't', 'i', 'o', 'n', ' ', 'p',
                          'r', 'o', 'c', 'e', 's', 's', 'o', 'r'] .
                        shows_nl . indent x))));
check_dp_termination_proof assms ia i dpp
  (Forward_Instantiation_Proc st sts u_opt prf) =
  debug (ia [])
    ['F', 'o', 'r', 'w', 'a', 'r', 'd', '_', 'I', 'n', 's', 't', 'a', 'n', 't',
      'i', 'a', 't', 'i', 'o', 'n', '_', 'P', 'r', 'o', 'c']
    (bindb
      (catcha (forward_instantiation_proc i st sts u_opt dpp)
        (\ x ->
          Inl (ia . shows_string
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e',
                        'n', ' ', 'a', 'p', 'p', 'l', 'y', 'i', 'n', 'g', ' ',
                        't', 'h', 'e', ' ', 'f', 'o', 'r', 'w', 'a', 'r', 'd',
                        '_', 'i', 'n', 's', 't', 'a', 'n', 't', 'i', 'a', 't',
                        'i', 'o', 'n', ' ', 'p', 'r', 'o', 'c', 'e', 's', 's',
                        'o', 'r', ' ', 't', 'o', ' ', 'i', 'n', 's', 't', 'a',
                        'n', 't', 'i', 'a', 't', 'e', ' ', 't', 'h', 'e', ' ',
                        'p', 'a', 'i', 'r', ' '] .
                      shows_nl .
                        shows_rule (shows_prec_lab Zero_nat)
                          (shows_prec_list Zero_nat) [' ', '-', '>', ' '] st .
                          shows_nl .
                            shows_string
                              [' ', 't', 'o', ' ', 't', 'h', 'e', ' ', 'p', 'a',
                                'i', 'r', 's', ' '] .
                              shows_nl .
                                shows_trs (shows_prec_lab Zero_nat)
                                  (shows_prec_list Zero_nat)
                                  ['r', 'e', 'w', 'r', 'i', 't', 'e', ' ', 's',
                                    'y', 's', 't', 'e', 'm', ':']
                                  [' ', '-', '>', ' '] sts .
                                  shows_nl . x)))
      (\ dppa ->
        catcha
          (check_dp_termination_proof assms (ia . shows_string ['.', '1']) i
            dppa prf)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                          'o', 'w', ' ', 't', 'h', 'e', ' ', 'f', 'o', 'r', 'w',
                          'a', 'r', 'd', ' ', 'i', 'n', 's', 't', 'a', 'n', 't',
                          'i', 'a', 't', 'i', 'o', 'n', ' ', 'p', 'r', 'o', 'c',
                          'e', 's', 's', 'o', 'r'] .
                        shows_nl . indent x))));
check_dp_termination_proof assms ia i dpp (Unlab_Proc p r prf) =
  debug (ia []) ['U', 'n', 'l', 'a', 'b', '_', 'P', 'r', 'o', 'c']
    (Inl (shows_prec_list Zero_nat
           ['u', 'n', 'l', 'a', 'b', 'e', 'l', 'i', 'n', 'g', ' ', 'p', 'r',
             'o', 'c', 'e', 's', 's', 'o', 'r', ' ', 'n', 'o', 't', ' ', 's',
             'u', 'p', 'p', 'o', 'r', 't', 'e', 'd']));
check_dp_termination_proof assms ia i dpp
  (General_Redpair_Proc rp ps pb prof prfs) =
  debug (ia [])
    ['G', 'e', 'n', 'e', 'r', 'a', 'l', '_', 'R', 'e', 'd', 'p', 'a', 'i', 'r',
      '_', 'P', 'r', 'o', 'c', 'P', 'r', 'o', 'c']
    (let {
       n = size_list prfs;
     } in bindb (check (less_nat Zero_nat n)
                  (shows_prec_list Zero_nat
                    ['a', 't', ' ', 'l', 'e', 'a', 's', 't', ' ', 'o', 'n', 'e',
                      ' ', 's', 'u', 'b', 'p', 'r', 'o', 'o', 'f', ' ', 'i',
                      's', ' ', 'r', 'e', 'q', 'u', 'i', 'r', 'e', 'd']))
            (\ _ ->
              let {
                merge = equal_nat n (Nat_of_num One);
              } in bindb (catcha
                           (conditional_general_reduction_pair_proc i
                             (get_non_inf_order rp) ps pb prof merge dpp)
                           (\ x ->
                             Inl (ia . shows_string
 [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e', 'n', ' ', 'a', 'p',
   'p', 'l', 'y', 'i', 'n', 'g', ' ', 't', 'h', 'e', ' ', 'g', 'e', 'n', 'e',
   'r', 'i', 'c', ' ', 'r', 'e', 'd', 'u', 'c', 't', 'i', 'o', 'n', ' ', 'p',
   'a', 'i', 'r', ' ', 'p', 'r', 'o', 'c', 'e', 's', 's', 'o', 'r', ' ', 't',
   'o', ' ', 't', 'h', 'e', ' ', 'D', 'P', ' ', 'p', 'r', 'o', 'b', 'l', 'e',
   'm'] .
 shows_nl .
   shows_dpp (shows_prec_lab Zero_nat) (shows_prec_list Zero_nat) i dpp .
     shows_nl . x)))
                     (\ dpps ->
                       bindb (catcha
                               (check_dp_termination_proof assms
                                 (ia . shows_string ['.', '1']) i
                                 (nth dpps Zero_nat) (nth prfs Zero_nat))
                               (\ x ->
                                 Inl (ia . shows_string
     [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l', 'o', 'w', ' ', 't',
       'h', 'e', ' ', 'g', 'e', 'n', 'e', 'r', 'i', 'c', ' ', 'r', 'e', 'd',
       'u', 'c', 't', 'i', 'o', 'n', ' ', 'p', 'a', 'i', 'r', ' ', 'p', 'r',
       'o', 'c', 'e', 's', 's', 'o', 'r'] .
     shows_nl . indent x)))
                         (\ _ ->
                           (if merge then Inr ()
                             else catcha
                                    (check_dp_termination_proof assms
                                      (ia . shows_string ['.', '2']) i
                                      (nth dpps (Nat_of_num One))
                                      (nth prfs (Nat_of_num One)))
                                    (\ x ->
                                      Inl
(ia . shows_string
        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l', 'o', 'w', ' ',
          't', 'h', 'e', ' ', 'g', 'e', 'n', 'e', 'r', 'i', 'c', ' ', 'r', 'e',
          'd', 'u', 'c', 't', 'i', 'o', 'n', ' ', 'p', 'a', 'i', 'r', ' ', 'p',
          'r', 'o', 'c', 'e', 's', 's', 'o', 'r'] .
        shows_nl . indent x)))))));
check_dp_termination_proof assms ia i dpp (Complex_Constant_Removal_Proc p prf)
  = debug (ia [])
      ['C', 'o', 'm', 'p', 'l', 'e', 'x', '_', 'C', 'o', 'n', 's', 't', 'a',
        'n', 't', '_', 'R', 'e', 'm', 'o', 'v', 'a', 'l', '_', 'P', 'r', 'o',
        'c']
      (bindb
        (catcha (complex_constant_removal_proc i p dpp)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e',
                          'n', ' ', 'a', 'p', 'p', 'l', 'y', 'i', 'n', 'g', ' ',
                          't', 'h', 'e', ' ', 'c', 'o', 'm', 'p', 'l', 'e', 'x',
                          ' ', 'c', 'o', 'n', 's', 't', 'a', 'n', 't', ' ', 'r',
                          'e', 'm', 'o', 'v', 'a', 'l', ' ', 'p', 'r', 'o', 'c',
                          'e', 's', 's', 'o', 'r', ' ', 't', 'o', ' ', 't', 'h',
                          'e', ' ', 'D', 'P', ' ', 'p', 'r', 'o', 'b', 'l', 'e',
                          'm'] .
                        shows_nl .
                          shows_dpp (shows_prec_lab Zero_nat)
                            (shows_prec_list Zero_nat) i dpp .
                            shows_nl . x)))
        (\ dppa ->
          catcha
            (check_dp_termination_proof assms (ia . shows_string ['.', '1']) i
              dppa prf)
            (\ x ->
              Inl (ia . shows_string
                          [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e',
                            'l', 'o', 'w', ' ', 't', 'h', 'e', ' ', 'c', 'o',
                            'm', 'p', 'l', 'e', 'x', ' ', 'c', 'o', 'n', 's',
                            't', 'a', 'n', 't', ' ', 'r', 'e', 'm', 'o', 'v',
                            'a', 'l', ' ', 'p', 'r', 'o', 'c', 'e', 's', 's',
                            'o', 'r'] .
                          shows_nl . indent x))));

unlab_to_split_proc ::
  forall a b c.
    (Eq a, Key a, Eq b, Key b, Eq c,
      Key c) => Dp_termination_proof a b c ->
                  (Dp_termination_proof a b c,
                    [([(Term (Lab a b) c, Term (Lab a b) c)],
                       ([(Term (Lab a b) c, Term (Lab a b) c)],
                         Dp_termination_proof a b c))]);
unlab_to_split_proc P_is_Empty = (P_is_Empty, []);
unlab_to_split_proc (Dep_Graph_Proc ps) =
  (Dep_Graph_Proc
     (map (\ (po, a) -> (mapa (fst . unlab_to_split_proc) po, a)) ps),
    []);
unlab_to_split_proc (Subterm_Criterion_Proc a1 a2 a3 p) =
  update (Subterm_Criterion_Proc a1 a2 a3) (unlab_to_split_proc p);
unlab_to_split_proc (Redpair_Proc a1 a2 p) =
  update (Redpair_Proc a1 a2) (unlab_to_split_proc p);
unlab_to_split_proc (Redpair_UR_Proc a1 a2 a3 p) =
  update (Redpair_UR_Proc a1 a2 a3) (unlab_to_split_proc p);
unlab_to_split_proc (Usable_Rules_Proc a1 p) =
  update (Usable_Rules_Proc a1) (unlab_to_split_proc p);
unlab_to_split_proc (Q_Reduction_Proc a1 p) =
  update (Q_Reduction_Proc a1) (unlab_to_split_proc p);
unlab_to_split_proc (Mono_Redpair_Proc a1 a2 a3 p) =
  update (Mono_Redpair_Proc a1 a2 a3) (unlab_to_split_proc p);
unlab_to_split_proc (Mono_Redpair_UR_Proc a1 a2 a3 a4 p) =
  update (Mono_Redpair_UR_Proc a1 a2 a3 a4) (unlab_to_split_proc p);
unlab_to_split_proc (Size_Change_Subterm_Proc a1) =
  (Size_Change_Subterm_Proc a1, []);
unlab_to_split_proc (Size_Change_Redpair_Proc a1 a2 a3) =
  (Size_Change_Redpair_Proc a1 a2 a3, []);
unlab_to_split_proc (Uncurry_Proc a1 a2 a3 a4 p) =
  update (Uncurry_Proc a1 a2 a3 a4) (unlab_to_split_proc p);
unlab_to_split_proc (Fcc_Proc a1 a2 a3 a4 p) =
  update (Fcc_Proc a1 a2 a3 a4) (unlab_to_split_proc p);
unlab_to_split_proc (Switch_Innermost_Proc a1 p) =
  update (Switch_Innermost_Proc a1) (unlab_to_split_proc p);
unlab_to_split_proc (Rewriting_Proc a1 a2 a3 a4 a5 a6 p) =
  update (Rewriting_Proc a1 a2 a3 a4 a5 a6) (unlab_to_split_proc p);
unlab_to_split_proc (Narrowing_Proc a1 a2 a3 p) =
  update (Narrowing_Proc a1 a2 a3) (unlab_to_split_proc p);
unlab_to_split_proc (Instantiation_Proc a1 a2 p) =
  update (Instantiation_Proc a1 a2) (unlab_to_split_proc p);
unlab_to_split_proc (Forward_Instantiation_Proc a1 a2 a3 p) =
  update (Forward_Instantiation_Proc a1 a2 a3) (unlab_to_split_proc p);
unlab_to_split_proc (Assume_Finite d dps) = (Assume_Finite d dps, []);
unlab_to_split_proc (Unlab_Proc pa r p) = (P_is_Empty, [(pa, (r, p))]);
unlab_to_split_proc (Split_Proc a1 a2 p q) =
  (Split_Proc a1 a2 (fst (unlab_to_split_proc p)) (fst (unlab_to_split_proc q)),
    []);
unlab_to_split_proc (Semlab_Proc a1 lP a2 lR p) =
  let {
    (pa, list) = unlab_to_split_proc p;
    sl = Semlab_Proc a1 lP a2 lR pa;
  } in (case list of {
         [] -> (sl, list);
         (pb, (r, prof)) : lista ->
           let {
             ulP = unlab_of_trs lP;
             ulR = unlab_of_trs lR;
             pr = ceta_list_diff ulP pb;
             rr = ceta_list_diff ulR r;
           } in (Split_Proc pr rr sl prof, lista);
       });
unlab_to_split_proc (General_Redpair_Proc a1 a2 a3 a4 ps) =
  (General_Redpair_Proc a1 a2 a3 a4 ps, []);
unlab_to_split_proc (Complex_Constant_Removal_Proc a1 p) =
  update (Complex_Constant_Removal_Proc a1) (unlab_to_split_proc p);

check_dp_termination_proof_with_unlab ::
  forall a b.
    (Countable b, Eq b, Key b,
      Showa b) => Bool ->
                    ([Prelude.Char] -> [Prelude.Char]) ->
                      Dpp_ops_ext a (Lab b [Nat]) [Prelude.Char] () ->
                        a -> Dp_termination_proof b [Nat] [Prelude.Char] ->
                               Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_dp_termination_proof_with_unlab a ia i dpp prf =
  check_dp_termination_proof a ia i dpp (fst (unlab_to_split_proc prf));

sorted_list_subset :: forall a. (Eq a, Linorder a) => [a] -> [a] -> Maybe a;
sorted_list_subset (a : asa) (b : bs) =
  (if a == b then sorted_list_subset asa (b : bs)
    else (if less b a then sorted_list_subset (a : asa) bs else Just a));
sorted_list_subset [] uu = Nothing;
sorted_list_subset (a : uv) [] = Just a;

check_subseteq_sorted :: forall a. (Eq a, Linorder a) => [a] -> [a] -> Sum a ();
check_subseteq_sorted xs ys =
  (case sorted_list_subset (sort_key (\ x -> x) xs) (sort_key (\ x -> x) ys) of
    {
    Nothing -> Inr ();
    Just a -> Inl a;
  });

applicable_rule_impla ::
  forall a b. (Term a b -> Bool) -> (Term a b, Term a b) -> Bool;
applicable_rule_impla q lr = all q (args (fst lr));

is_QNFa :: forall a b c d. Tp_ops_ext a b c d -> a -> Term b c -> Bool;
is_QNFa
  (Tp_ops_ext qreltrs q r rw rules q_empty is_QNF nFQ_subset_NF_rules rules_map
    delete_R_Rw split_rules mk nfs more)
  = is_QNF;

rulesb :: forall a b c d. Tp_ops_ext a b c d -> a -> [(Term b c, Term b c)];
rulesb
  (Tp_ops_ext qreltrs q r rw rules q_empty is_QNF nFQ_subset_NF_rules rules_map
    delete_R_Rw split_rules mk nfs more)
  = rules;

dP_list ::
  forall a b.
    (Eq a,
      Eq b) => (a -> a) ->
                 [(Term a b, Term a b)] -> [(a, Nat)] -> [(Term a b, Term a b)];
dP_list shp r d_list =
  concatMap
    (\ lr ->
      let {
        l = fst lr;
        s = sharp_term shp l;
      } in map_filter
             (\ x ->
               (if not (supt_impl l x) &&
                     not (is_Var x) && membera d_list (the (root x))
                 then Just (s, sharp_term shp x) else Nothing))
             (supteq_list (snd lr)))
    r;

dependency_pairs_tt ::
  forall a b c d.
    (Eq b, Linorder b, Showa b, Eq c, Linorder c,
      Showa c) => Tp_ops_ext a b c () ->
                    Dpp_ops_ext d b c () ->
                      a -> Bool ->
                             Bool ->
                               (b -> b) ->
                                 [(Term b c, Term b c)] ->
                                   Sum ([Prelude.Char] -> [Prelude.Char]) d;
dependency_pairs_tt i j tp nfs m shp p =
  let {
    r = rulesb i tp;
    q = qa i tp;
    iQ = is_QNFa i tp;
    u = filter (applicable_rule_impla iQ) r;
  } in (case catcha
               (bindb
                 (if isOK (check_wf_trs u) then Inr ()
                   else check (nfs &&
                                nfsa i tp &&
                                  isOK (check_NF_terms_subset q (map fst r)) &&
                                    all (\ l -> not (is_Var l)) (map fst r))
                          (shows_prec_list Zero_nat
                            ['n', 'e', 'i', 't', 'h', 'e', 'r', ' ', 'i', 's',
                              ' ', 't', 'h', 'e', ' ', 'T', 'R', 'S', ' ', 'w',
                              'e', 'l', 'l', '-', 'f', 'o', 'r', 'm', 'e', 'd',
                              ',', ' ', 'n', 'o', 'r', ' ', 'i', 's', ' ', 't',
                              'h', 'e', ' ', 'r', 'e', 's', 't', 'r', 'i', 'c',
                              't', 'i', 'o', 'n', ' ', 't', 'o', ' ', 'i', 'n',
                              'n', 'e', 'r', 'm', 'o', 's', 't', ' ', 'w', 'i',
                              't', 'h', ' ', 'n', 'o', 'r', 'm', 'a', 'l', ' ',
                              'f', 'o', 'r', 'm', ' ', 's', 'u', 'b', 's', 't',
                              'i', 't', 'u', 't', 'i', 'o', 'n', 's', ' ', 'p',
                              'r', 'e', 's', 'e', 'n', 't']))
                 (\ _ ->
                   bindb (catcha (forallM check_no_var q) (\ x -> Inl (snd x)))
                     (\ _ ->
                       let {
                         qr = map (\ (Fun f ss) -> (f, size_list ss)) q;
                         d = defs_list u;
                       } in bindb (catcha
                                    (forallM
                                      (\ (f, n) ->
check (not (membera d (shp f, n)))
  (shows_string ['s', 'h', 'a', 'r', 'p', 'i', 'n', 'g', ' '] .
    shows_prec Zero_nat f .
      shows_string
        [' ', 'y', 'i', 'e', 'l', 'd', 's', ' ', 't', 'h', 'e', ' ', 'd', 'e',
          'f', 'i', 'n', 'e', 'd', ' ', 's', 'y', 'm', 'b', 'o', 'l', ' '] .
        shows_prec Zero_nat (shp f)))
                                      d)
                                    (\ x -> Inl (snd x)))
                              (\ _ ->
                                bindb (catcha
(forallM
  (\ (f, n) ->
    check (not (membera qr (shp f, n)))
      (shows_string ['s', 'h', 'a', 'r', 'p', 'i', 'n', 'g', ' '] .
        shows_prec Zero_nat f .
          shows_string
            [' ', 'y', 'i', 'e', 'l', 'd', 's', ' ', 't', 'h', 'e', ' ', 's',
              'y', 'm', 'b', 'o', 'l', ' '] .
            shows_prec Zero_nat (shp f) .
              shows_string
                [' ', 'w', 'h', 'i', 'c', 'h', ' ', 'i', 's', ' ', 'a', ' ',
                  'r', 'o', 'o', 't', ' ', 'o', 'f', ' ', 'Q']))
  d)
(\ x -> Inl (snd x)))
                                  (\ _ ->
                                    catcha
                                      (check_subseteq_sorted (dP_list shp u d)
p)
                                      (\ x ->
Inl (shows_string ['t', 'h', 'e', ' ', 'D', 'P', ' '] .
      shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
        [' ', '-', '>', ' '] x .
        shows_string
          [' ', 'd', 'o', 'e', 's', ' ', 'n', 'o', 't', ' ', 'a', 'p', 'p', 'e',
            'a', 'r', ' ', 'i', 'n', ' ', 't', 'h', 'e', ' ', 'D', 'P', ' ',
            'p', 'r', 'o', 'b', 'l', 'e', 'm'] .
          shows_nl)))))))
               (\ x ->
                 Inl (shows_string
                        ['t', 'h', 'e', ' ', 'D', 'P', '-', 't', 'r', 'a', 'n',
                          's', 'f', 'o', 'r', 'm', 'a', 't', 'i', 'o', 'n', ' ',
                          'i', 's', ' ', 'n', 'o', 't', ' ', 'a', 'p', 'p', 'l',
                          'i', 'e', 'd', ' ', 'c', 'o', 'r', 'r', 'e', 'c', 't',
                          'l', 'y', '.'] .
                       shows_nl . x))
         of {
         Inl a -> Inl a;
         Inr _ -> Inr (mkc j nfs m p [] q [] r);
       });

switch_innermost_tt ::
  forall a b.
    (Eq b,
      Showa b) => Tp_ops_ext a b [Prelude.Char] () ->
                    Join_info b ->
                      a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
switch_innermost_tt i joins_i trs =
  let {
    r = rulesb i trs;
  } in (case let {
               cp = critical_pairs_impl r r;
             } in bindb (catcha
                          (forallM
                            (\ (b, _) ->
                              check b
                                (shows_prec_list Zero_nat
                                  ['r', 'u', 'l', 'e', 's', ' ', 'a', 'r', 'e',
                                    ' ', 'n', 'o', 't', ' ', 'o', 'v', 'e', 'r',
                                    'l', 'a', 'y']))
                            cp)
                          (\ x -> Inl (snd x)))
                    (\ _ ->
                      bindb (check_critical_pairs r cp joins_i)
                        (\ _ -> check_wf_trs r))
         of {
         Inl a -> Inl a;
         Inr _ -> Inr (mka i True (map fst r) r []);
       });

unary_term :: forall a b. Term a b -> Bool;
unary_term (Var x) = True;
unary_term (Fun f [t]) = unary_term t;
unary_term (Fun v []) = False;
unary_term (Fun v (vb : vd : ve)) = False;

check_unary_signature ::
  forall a b.
    (Showa a,
      Showa b) => [(Term a b, Term a b)] ->
                    Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_unary_signature r =
  catcha
    (catcha
      (forallM
        (\ x ->
          (if let {
                (l, ra) = x;
              } in unary_term l && unary_term ra
            then Inr () else Inl x))
        r)
      (\ x -> Inl (snd x)))
    (\ x ->
      Inl (shows_string ['t', 'h', 'e', ' ', 'r', 'u', 'l', 'e', ' '] .
            shows_nl .
              shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                [' ', '-', '>', ' '] x .
                shows_nl .
                  shows_string
                    ['v', 'i', 'o', 'l', 'a', 't', 'e', 's', ' ', 't', 'h', 'e',
                      ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n', ' ',
                      't', 'h', 'a', 't', ' ', 'a', 'l', 'l', ' ', 'f', 'u',
                      'n', 'c', 't', 'i', 'o', 'n', ' ', 's', 'y', 'm', 'b',
                      'o', 'l', 's'] .
                    shows_nl .
                      shows_prec_list Zero_nat
                        ['h', 'a', 'v', 'e', ' ', 't', 'o', ' ', 'b', 'e', ' ',
                          'u', 'n', 'a', 'r', 'y']));

rev_term :: forall a b. Ctxt a b -> Term a b -> Term a b;
rev_term c (Var x) = ctxt_apply c (Var x);
rev_term c (Fun f [t]) = rev_term (More f [] c []) t;

rev_rule :: forall a b. (Term a b, Term a b) -> (Term a b, Term a b);
rev_rule (l, r) = (rev_term Hole l, rev_term Hole r);

string_reversal_tt ::
  forall a b c.
    (Showa b,
      Showa c) => Tp_ops_ext a b c () ->
                    a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
string_reversal_tt i trs =
  let {
    rs = rulesb i trs;
    r = ra i trs;
    s = rwa i trs;
  } in (case check_unary_signature rs of {
         Inl a -> Inl a;
         Inr _ -> Inr (mka i False [] (map rev_rule r) (map rev_rule s));
       });

q_emptya :: forall a b c d. Tp_ops_ext a b c d -> a -> Bool;
q_emptya
  (Tp_ops_ext qreltrs q r rw rules q_empty is_QNF nFQ_subset_NF_rules rules_map
    delete_R_Rw split_rules mk nfs more)
  = q_empty;

sem_lab_rel_tt ::
  forall a b c d.
    (Eq a, Showa a, Eq b,
      Showa b) => ([(Term a b, Term a b)] ->
                    [(Term a b, Term a b)] ->
                      ([(Term a b, Term a b)],
                        ([(Term a b, Term a b)], [(Term a b, Term a b)]))) ->
                    (a -> (a, c)) ->
                      Tp_ops_ext d a b () ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) () ->
                          ([(Term a b, Term a b)] ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                            ([(Term a b, Term a b)] ->
                              [(Term a b, Term a b)] ->
                                Sum ([Prelude.Char] -> [Prelude.Char]) ()) ->
                              [Term a b] ->
                                [(Term a b, Term a b)] ->
                                  d -> Sum ([Prelude.Char] -> [Prelude.Char]) d;
sem_lab_rel_tt splitter ld i valid check_decr check_model_lab lQ lAll tp =
  let {
    r = ra i tp;
    rw = rwa i tp;
    nfs = nfsa i tp;
    (lR, (lRw, d)) = splitter lAll rw;
  } in (case bindb valid
               (\ _ ->
                 let {
                   q = qa i tp;
                 } in catcha
                        (bindb
                          (if nfs && not (q_emptya i tp) then check_wf_trs d
                            else Inr ())
                          (\ _ ->
                            bindb (check_decr d)
                              (\ _ ->
                                bindb (check_sl_Qa ld lQ q)
                                  (\ _ ->
                                    bindb (check_model_lab lR r)
                                      (\ _ -> check_model_lab lRw rw)))))
                        (\ x ->
                          Inl (shows_string
                                 ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w',
                                   'i', 't', 'h', ' ', 'l', 'a', 'b', 'e', 'l',
                                   'e', 'd', ' ', 'T', 'R', 'S', ':'] .
                                shows_nl . x)))
         of {
         Inl a -> Inl a;
         Inr _ -> Inr (mka i nfs lQ lR (lRw ++ d));
       });

sem_lab_fin_tt ::
  forall a b c d e.
    (Eq a, Showa a, Eq b, Showa b,
      Showa d) => ([(Term a b, Term a b)] ->
                    [(Term a b, Term a b)] ->
                      ([(Term a b, Term a b)],
                        ([(Term a b, Term a b)], [(Term a b, Term a b)]))) ->
                    (a -> Nat -> c -> a) ->
                      (a -> (a, c)) ->
                        (d -> d -> Bool) ->
                          Tp_ops_ext e a b () ->
                            ([(a, Nat)] ->
                              [(a, Nat)] ->
                                Sum ([Prelude.Char] -> [Prelude.Char])
                                  (Sl_ops_ext a d c b ())) ->
                              [Term a b] ->
                                [(Term a b, Term a b)] ->
                                  e -> Sum ([Prelude.Char] -> [Prelude.Char]) e;
sem_lab_fin_tt splitter lc ld cge i gen lQ lAll tp =
  bindb (gen (funas_trs_list (rulesb i tp)) [])
    (\ ops ->
      let {
        check_ml =
          check_sl_model_lab_trs (sl_I ops) (sl_L ops) (sl_C ops) cge lc;
        check_d = sl_check_decr ops;
      } in sem_lab_rel_tt splitter ld i (Inr ()) check_d check_ml lQ lAll tp);

semlab_fin_tt ::
  forall a b c.
    (Eq b, Showa b, Eq c,
      Showa c) => Tp_ops_ext a (Lab b [Nat]) c () ->
                    Sl_variant (Lab b [Nat]) c ->
                      [Term (Lab b [Nat]) c] ->
                        [(Term (Lab b [Nat]) c, Term (Lab b [Nat]) c)] ->
                          a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
semlab_fin_tt j (Rootlab uu) =
  sem_lab_fin_tt (model_splitter label_decomp) label label_decomp equal_lab j
    (slm_gen_to_sl_gen (rl_slm Nothing));
semlab_fin_tt j (Finitelab sli) =
  sem_lab_fin_tt (model_splitter label_decomp) label label_decomp equal_nat j
    (slm_gen_to_sl_gen (\ _ _ -> Inr (sli_to_slm sli)));
semlab_fin_tt j (QuasiFinitelab sli v) =
  sem_lab_fin_tt (quasi_splitter label_decomp) label label_decomp qmodel_cge j
    (\ f g -> qsli_to_sl v f g sli);

rule_removal_tt ::
  forall a b c.
    (Showa b,
      Showa c) => Tp_ops_ext a b c () ->
                    Redtriple_ext b c () ->
                      [(Term b c, Term b c)] ->
                        a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
rule_removal_tt i rp rremove trs =
  (case catcha
          (let {
             (rs, rns) = split_rulesa i trs rremove;
           } in bindb (valid rp)
                  (\ _ ->
                    bindb (catcha (mono rp (rs ++ rns))
                            (\ x ->
                              Inl (shows_string
                                     ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ',
                                       'w', 'i', 't', 'h', ' ', 'm', 'o', 'n',
                                       'o', 't', 'o', 'n', 'i', 'c', 'i', 't',
                                       'y', ' ', 'o', 'f', ' ', 's', 't', 'r',
                                       'i', 'c', 't', ' ', 'o', 'r', 'd', 'e',
                                       'r'] .
                                    shows_nl . x)))
                      (\ _ ->
                        bindb (catcha
                                (catcha (forallM (ns rp) rns)
                                  (\ x -> Inl (snd x)))
                                (\ x ->
                                  Inl (shows_string
 ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ', 'o', 'r',
   'i', 'e', 'n', 't', 'i', 'n', 'g', ' ', 'T', 'R', 'S'] .
shows_nl . x)))
                          (\ _ ->
                            catcha
                              (catcha (forallM (s rp) rs) (\ x -> Inl (snd x)))
                              (\ x ->
                                Inl (shows_string
                                       ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ',
 'w', 'h', 'e', 'n', ' ', 'o', 'r', 'i', 'e', 'n', 't', 'i', 'n', 'g', ' ', 'T',
 'R', 'S'] .
                                      shows_nl . x))))))
          (\ x ->
            Inl (shows_string
                   ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'a', 'p',
                     'p', 'l', 'y', ' ', 't', 'h', 'e', ' ', 'r', 'e', 'd', 'u',
                     'c', 't', 'i', 'o', 'n', ' ', 'p', 'a', 'i', 'r', ' ', 'p',
                     'r', 'o', 'c', 'e', 's', 's', 'o', 'r', ' ', 'w', 'i', 't',
                     'h', ' ', 't', 'h', 'e', ' ', 'f', 'o', 'l', 'l', 'o', 'w',
                     'i', 'n', 'g'] .
                  shows_nl . desca rp . shows_nl . x))
    of {
    Inl a -> Inl a;
    Inr _ -> Inr (delete_R_Rwa i trs rremove rremove);
  });

fcc_tt ::
  forall a b c.
    (Eq b, Showa b, Eq c,
      Showa c) => Tp_ops_ext a b c () ->
                    [Ctxt b c] ->
                      [(Term b c, Term b c)] ->
                        a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
fcc_tt i fcs cRb tp =
  let {
    r = ra i tp;
    rw = rwa i tp;
    nfs = nfsa i tp;
    rb = r ++ rw;
    (cR, cRw) = partition_rules fcs r cRb;
    _ = qa i tp;
    vs = vars_trs_list rb;
    fas = funas_trs_list rb;
  } in (case bindb (check (not (null fcs))
                     (shows_string
                        ['a', 't', ' ', 'l', 'e', 'a', 's', 't', ' ', 'o', 'n',
                          'e', ' ', 'f', 'l', 'a', 't', ' ', 'c', 'o', 'n', 't',
                          'e', 'x', 't', ' ', 'i', 's', ' ', 'r', 'e', 'q', 'u',
                          'i', 'r', 'e', 'd', ' ', 'f', 'o', 'r', ' ', 'f', 'l',
                          'a', 't', ' ', 'c', 'o', 'n', 't', 'e', 'x', 't', ' ',
                          'c', 'l', 'o', 's', 'u', 'r', 'e'] .
                       shows_nl))
               (\ _ ->
                 bindb (catcha (forallM (check_flat_ctxt vs) fcs)
                         (\ x -> Inl (snd x)))
                   (\ _ ->
                     bindb (catcha (forallM (check_is_flat_ctxt vs fas) fcs)
                             (\ x -> Inl (snd x)))
                       (\ _ ->
                         bindb (catcha
                                 (forallM (check_flat_ctxt_complete fcs) fas)
                                 (\ x -> Inl (snd x)))
                           (\ _ ->
                             bindb (catcha
                                     (forallM (check_rule_preserving fcs cR) r)
                                     (\ x -> Inl (snd x)))
                               (\ _ ->
                                 catcha
                                   (forallM (check_rule_preserving fcs cRb) rw)
                                   (\ x -> Inl (snd x)))))))
         of {
         Inl a -> Inl a;
         Inr _ -> Inr (mka i nfs [] cR cRw);
       });

shows_tp ::
  forall a b c.
    (a -> [Prelude.Char] -> [Prelude.Char]) ->
      (b -> [Prelude.Char] -> [Prelude.Char]) ->
        Tp_ops_ext c a b () -> c -> [Prelude.Char] -> [Prelude.Char];
shows_tp fun var i t =
  let {
    nfs = nfsa i t;
    r = ra i t;
    rw = rwa i t;
    q = qa i t;
  } in shows_trs fun var ['r', 'u', 'l', 'e', 's', ':'] [' ', '-', '>', ' '] r .
         (if null rw then id
           else shows_trs fun var
                  ['r', 'e', 'l', 'a', 't', 'i', 'v', 'e', ' ', 'r', 'u', 'l',
                    'e', 's', ':']
                  [' ', '-', '>', '=', ' '] rw) .
           (if null q then id
             else shows_terms fun var
                    ['Q', '-', 'c', 'o', 'm', 'p', 'o', 'n', 'e', 'n', 't', ':']
                    q) .
             (if nfs
               then shows_string
                      ['s', 'u', 'b', 's', 't', 'i', 't', 'u', 't', 'i', 'o',
                        'n', 's', ' ', 'a', 'r', 'e', ' ', 'a', 's', 's', 'u',
                        'm', 'e', 'd', ' ', 't', 'o', ' ', 'b', 'e', ' ', 'i',
                        'n', ' ', 'n', 'o', 'r', 'm', 'a', 'l', ' ', 'f', 'o',
                        'r', 'm'] .
                      shows_nl
               else id);

data Ta_rule_impl a b = TA_rule_impl b [a] a (Rbt a ());

data Ta_impl_ext a b c =
  Ta_impl_ext (Rbt a ()) (Rbt (b, Nat) [Ta_rule_impl a b]) [a] (Rbt a ())
    [(a, a)] (a -> Rbt a ()) (a -> Rbt a ()) c;

ta_rhs_states_set :: forall a b c. Ta_impl_ext a b c -> Rbt a ();
ta_rhs_states_set
  (Ta_impl_ext ta_final_impl ta_rules_impl ta_r_lhs_states_impl
    ta_rhs_states_set ta_eps_impl ta_epss_impl ta_epsrs_impl more)
  = ta_rhs_states_set;

r_lhs_states_impl :: forall a b. Ta_rule_impl a b -> [a];
r_lhs_states_impl (TA_rule_impl f qsa q qs) = qsa;

rm_set_lookup :: forall a b. (Linorder a) => Rbt a [b] -> a -> [b];
rm_set_lookup rm =
  (\ a -> (case rm_alpha rm a of {
            Nothing -> [];
            Just rules -> rules;
          }));

rqss_impl :: forall a b. Ta_rule_impl a b -> Rbt a ();
rqss_impl (TA_rule_impl f qsa q qs) = qs;

ta_res_impl_all ::
  forall a b c.
    (Linorder a, Eq b,
      Linorder b) => Rbt a () ->
                       Rbt (b, Nat) [Ta_rule_impl a b] -> Term b c -> Rbt a ();
ta_res_impl_all q ta (Var uu) = q;
ta_res_impl_all q ta (Fun f ts) =
  let {
    rec = map (ta_res_impl_all q ta) ts;
    n = size_list ts;
    rules = rm_set_lookup ta (f, n);
    arules =
      filter
        (\ rule ->
          let {
            qs = r_lhs_states_impl rule;
          } in all_interval_nat (\ i -> rs_memb (nth qs i) (nth rec i)) Zero_nat
                 n)
        rules;
    a = map rqss_impl arules;
  } in foldl rs_union (rs_empty ()) a;

ta_rules_impl ::
  forall a b c. Ta_impl_ext a b c -> Rbt (b, Nat) [Ta_rule_impl a b];
ta_rules_impl
  (Ta_impl_ext ta_final_impl ta_rules_impl ta_r_lhs_states_impl
    ta_rhs_states_set ta_eps_impl ta_epss_impl ta_epsrs_impl more)
  = ta_rules_impl;

rule_state_compatible_heuristic ::
  forall a b c.
    (Eq a, Linorder a, Eq b, Linorder b,
      Linorder c) => Ta_impl_ext a b () -> Term b c -> Bool;
rule_state_compatible_heuristic ta l =
  rs_isEmpty (ta_res_impl_all (ta_rhs_states_set ta) (ta_rules_impl ta) l);

ta_r_lhs_states_impl :: forall a b c. Ta_impl_ext a b c -> [a];
ta_r_lhs_states_impl
  (Ta_impl_ext ta_final_impl ta_rules_impl ta_r_lhs_states_impl
    ta_rhs_states_set ta_eps_impl ta_epss_impl ta_epsrs_impl more)
  = ta_r_lhs_states_impl;

ta_match_impl ::
  forall a b c.
    (Eq a, Linorder a, Eq b, Linorder b, Eq c,
      Linorder c) => Rbt (a, Nat) [Ta_rule_impl b a] ->
                       (b -> Rbt b ()) -> Term a c -> b -> Rbt [(c, b)] ();
ta_match_impl ta eps (Var x) q =
  list_to_rs (map (\ qa -> [(x, qa)]) (rs_to_list (eps q)));
ta_match_impl ta eps (Fun f ts) q =
  let {
    n = size_list ts;
    rules = rm_set_lookup ta (f, n);
    ep = eps q;
    fa = (\ rule ->
           list_to_rs
             (let {
                (TA_rule_impl _ qs qa _) = rule;
              } in (if rs_memb qa ep
                     then let {
                            rec = map (\ (tsi, qsi) ->
rs_to_list (ta_match_impl ta eps tsi qsi))
                                    (zip ts qs);
                          } in map concat (concat_lists rec)
                     else [])));
  } in foldl (\ a x -> rs_union a (fa x)) (rs_empty ()) rules;

ta_epsrs_impl :: forall a b c. Ta_impl_ext a b c -> a -> Rbt a ();
ta_epsrs_impl
  (Ta_impl_ext ta_final_impl ta_rules_impl ta_r_lhs_states_impl
    ta_rhs_states_set ta_eps_impl ta_epss_impl ta_epsrs_impl more)
  = ta_epsrs_impl;

ta_epss_impl :: forall a b c. Ta_impl_ext a b c -> a -> Rbt a ();
ta_epss_impl
  (Ta_impl_ext ta_final_impl ta_rules_impl ta_r_lhs_states_impl
    ta_rhs_states_set ta_eps_impl ta_epss_impl ta_epsrs_impl more)
  = ta_epss_impl;

ta_res_impl ::
  forall a b.
    (Eq a, Linorder a,
      Linorder b) => Rbt (a, Nat) [Ta_rule_impl b a] ->
                       (b -> Rbt b ()) -> Term a b -> Rbt b ();
ta_res_impl ta eps (Var q) = eps q;
ta_res_impl ta eps (Fun f ts) =
  let {
    rec = map (ta_res_impl ta eps) ts;
    n = size_list ts;
    rules = rm_set_lookup ta (f, n);
    arules =
      filter
        (\ rule ->
          let {
            qs = r_lhs_states_impl rule;
          } in all_interval_nat (\ i -> rs_memb (nth qs i) (nth rec i)) Zero_nat
                 n)
        rules;
    a = map rqss_impl arules;
  } in foldl rs_union (rs_empty ()) a;

rule_state_compatible_eff_list ::
  forall a b c.
    (Eq a, Linorder a, Eq b, Linorder b, Eq c,
      Linorder c) => Ta_impl_ext a b () ->
                       (Rbt a () -> Rbt a () -> Maybe a) ->
                         (Term b c, Term b c) ->
                           Sum ((Term b a, Term b a), a) ();
rule_state_compatible_eff_list ta rel (Fun f ls, r) =
  let {
    rm = ta_rules_impl ta;
    eps = ta_epss_impl ta;
    epsa = ta_epsrs_impl ta;
    n = size_list ls;
    ta_res = ta_res_impl rm eps;
  } in catcha
         (forallM
           (\ (TA_rule_impl fa _ q _) ->
             catcha
               (forallM
                 (\ sigma ->
                   let {
                     sigmaa = fun_of sigma;
                     l_sigma = map_vars sigmaa (Fun fa ls);
                     r_sigma = map_vars sigmaa r;
                     qsl = ta_res l_sigma;
                     qsr = ta_res r_sigma;
                   } in (case rel qsl qsr of {
                          Nothing -> Inr ();
                          Just qa -> Inl ((l_sigma, r_sigma), qa);
                        }))
                 (rs_to_list (ta_match_impl rm epsa (Fun fa ls) q)))
               (\ x -> Inl (snd x)))
           (rm_set_lookup rm (f, n)))
         (\ x -> Inl (snd x));
rule_state_compatible_eff_list ta rel (Var x, r) =
  let {
    rm = ta_rules_impl ta;
    eps = ta_epss_impl ta;
    ta_res = ta_res_impl rm eps;
  } in catcha
         (forallM
           (\ q ->
             let {
               r_sigma = map_vars (\ _ -> q) r;
             } in (case rel (list_to_rs [q]) (ta_res r_sigma) of {
                    Nothing -> Inr ();
                    Just _ -> Inl ((Var q, r_sigma), q);
                  }))
           (ta_r_lhs_states_impl ta))
         (\ xa -> Inl (snd xa));

state_compatible_eff_list ::
  forall a b c.
    (Eq a, Linorder a, Eq b, Linorder b, Eq c,
      Linorder c) => Ta_impl_ext a b () ->
                       (Rbt a () -> Rbt a () -> Maybe a) ->
                         [(Term b c, Term b c)] ->
                           Sum ((Term b c, Term b c), ((Term b a, Term b a), a))
                             ();
state_compatible_eff_list ta rel r =
  let {
    check = rule_state_compatible_eff_list ta rel;
  } in catcha (forallM (\ lr -> catcha (check lr) (\ x -> Inl (lr, x))) r)
         (\ x -> Inl (snd x));

flatten_term_enum_filter ::
  forall a b. (Term a b -> Bool) -> Term [a] b -> [Term a b];
flatten_term_enum_filter f (Var x) =
  let {
    tx = Var x;
  } in (if f tx then [tx] else []);
flatten_term_enum_filter f (Fun fs ts) =
  let {
    lts = map (flatten_term_enum_filter f) ts;
  } in (if any null lts then []
         else let {
                ss = concat_lists lts;
              } in filter f (concatMap (\ fa -> map (Fun fa) ss) fs));

inverse_base_term_filter ::
  forall a b. (Term (a, Nat) b -> Bool) -> Term a b -> Nat -> [Term (a, Nat) b];
inverse_base_term_filter filt l c =
  let {
    hs = upt Zero_nat (plus_nat c (Nat_of_num One));
  } in flatten_term_enum_filter filt
         (map_term (\ f -> map (\ h -> lift h f) hs) l);

cover_bound_list_filter ::
  forall a b.
    (Term (a, Nat) b -> Bool) ->
      ((Term a b, Term a b) -> Term a b -> Bool) ->
        Nat -> [(Term a b, Term a b)] -> [(Term (a, Nat) b, Term (a, Nat) b)];
cover_bound_list_filter filt ff c r =
  concatMap
    (\ (l, ra) ->
      let {
        ee = ff (l, ra);
      } in map (\ la ->
                 (la, map_term
                        (lift (plus_nat
                                (min_list
                                  (map height
                                    (sym_collect (\ t -> ee (map_term base t))
                                      la)))
                                (Nat_of_num One)))
                        ra))
             (inverse_base_term_filter filt l c))
    r;

ta_final_impl :: forall a b c. Ta_impl_ext a b c -> Rbt a ();
ta_final_impl
  (Ta_impl_ext ta_final_impl ta_rules_impl ta_r_lhs_states_impl
    ta_rhs_states_set ta_eps_impl ta_epss_impl ta_epsrs_impl more)
  = ta_final_impl;

ta_contains_impl ::
  forall a b.
    (Eq a, Linorder a, Eq b,
      Linorder b) => [(a, Nat)] ->
                       Ta_impl_ext b a () -> [b] -> Sum (Sum b (Term a b)) ();
ta_contains_impl f ta qs =
  let {
    fin = ta_final_impl ta;
    look = rm_set_lookup (ta_rules_impl ta);
    _ = ta_epss_impl ta;
  } in bindb (catcha
               (catcha (forallM (\ q -> check (rs_memb q fin) q) qs)
                 (\ x -> Inl (snd x)))
               (\ x -> Inl (Inl x)))
         (\ _ ->
           catcha
             (catcha
               (forallM
                 (\ (fa, n) ->
                   let {
                     rules = look (fa, n);
                   } in catcha
                          (catcha
                            (forallM
                              (\ x ->
                                (if any (\ rule ->
  r_lhs_states_impl rule == x &&
    let {
      qq = rqss_impl rule;
    } in any (\ q -> rs_memb q qq) qs)
                                      rules
                                  then Inr () else Inl x))
                              (concat_lists (replicate n qs)))
                            (\ x -> Inl (snd x)))
                          (\ x -> Inl (Fun fa (map Var x))))
                 f)
               (\ x -> Inl (snd x)))
             (\ x -> Inl (Inr x)));

is_Id_relation :: forall a. Ta_relation a -> Bool;
is_Id_relation Id_Relation = True;
is_Id_relation (Some_Relation v) = False;

check_coherent_rule ::
  forall a b.
    (Eq a, Linorder a, Showa a, Eq b,
      Showa b) => (a -> [a]) ->
                    Rbt (a, a) () ->
                      [Ta_rule a b] ->
                        Ta_rule a b ->
                          Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_coherent_rule iter rel rules (TA_rule f qs q) =
  catcha
    (forallM
      (\ i ->
        let {
          qi = nth qs i;
        } in catcha
               (forallM
                 (\ qia ->
                   let {
                     qsa = list_update qs i qia;
                   } in check (not (null (filter
   (\ (TA_rule g qsb qa) -> f == g && qsa == qsb && rs_memb (q, qa) rel)
   rules)))
                          (shows_prec_list Zero_nat ['r', 'u', 'l', 'e', ' '] .
                            shows_prec Zero_nat f .
                              shows_prec_list Zero_nat ['('] .
                                shows_prec_list Zero_nat qs .
                                  shows_prec_list Zero_nat
                                    [')', ' ', '-', '>', ' '] .
                                    shows_prec Zero_nat q .
                                      shows_prec_list Zero_nat
[' ', 'w', 'i', 't', 'h', ' '] .
shows_prec_nat Zero_nat (plus_nat i (Nat_of_num One)) .
  shows_prec_list Zero_nat
    ['.', ' ', 'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', ' ', 'd', 'e', 'c', 'r',
      'e', 'a', 's', 'e', 'd', ' ', 't', 'o', ' '] .
    shows_prec Zero_nat qia .
      shows_prec_list Zero_nat
        [' ', 'h', 'a', 's', ' ', 'n', 'o', ' ', 'c', 'o', 'u', 'n', 't', 'e',
          'r', 'p', 'a', 'r', 't']))
                 (iter qi))
               (\ x -> Inl (snd x)))
      (upt Zero_nat (size_list qs)))
    (\ x -> Inl (snd x));

check_coherent ::
  forall a b.
    (Eq a, Linorder a, Showa a, Eq b,
      Showa b) => Tree_automaton a b ->
                    Ta_relation a -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_coherent uu Id_Relation = Inr ();
check_coherent (Tree_Automaton fin rules uv) (Some_Relation rel) =
  let {
    iter =
      (\ q ->
        map_filter
          (\ x ->
            (if let {
                  (a, _) = x;
                } in a == q
              then Just (snd x) else Nothing))
          rel);
    rs = list_to_rs rel;
  } in bindb (catcha (check_subseteq (concatMap iter fin) fin)
               (\ x ->
                 Inl (shows_prec Zero_nat x .
                       shows_prec_list Zero_nat
                         [' ', 'i', 's', ' ', 'i', 'n', ' ', 'r', 'e', 'l', 'a',
                           't', 'i', 'o', 'n', ' ', 't', 'o', ' ', 'a', ' ',
                           'f', 'i', 'n', 'a', 'l', ' ', 's', 't', 'a', 't',
                           'e', ',', ' ', 'b', 'u', 't', ' ', 'n', 'o', 't',
                           ' ', 'a', ' ', 'f', 'i', 'n', 'a', 'l', ' ', 's',
                           't', 'a', 't', 'e', ' ', 'i', 't', 's', 'e', 'l',
                           'f'])))
         (\ _ ->
           catcha (forallM (check_coherent_rule iter rs rules) rules)
             (\ x -> Inl (snd x)));

relpow_impl ::
  forall a b.
    ([a] -> [a]) -> ([a] -> b -> b) -> (a -> b -> Bool) -> [a] -> b -> Nat -> b;
relpow_impl succ un memb new have m =
  (if equal_nat m Zero_nat then un new have
    else (if null new then have
           else let {
                  maybe = succ new;
                  havea = un new have;
                  newa = filter (\ n -> not (memb n havea)) maybe;
                } in relpow_impl succ un memb newa havea
                       (minus_nat m (Nat_of_num One))));

rtrancl_impl ::
  forall a b.
    ([(a, a)] -> [a] -> [a]) ->
      ([a] -> b -> b) -> (a -> b -> Bool) -> b -> [(a, a)] -> [a] -> b;
rtrancl_impl gen_succ un memb emp rel =
  let {
    succ = gen_succ rel;
    n = size_list rel;
  } in (\ asa -> relpow_impl succ un memb asa emp n);

rtrancl_rbt_impl :: forall a. (Linorder a) => [(a, a)] -> [a] -> Rbt a ();
rtrancl_rbt_impl =
  rtrancl_impl
    (\ r ->
      let {
        rm = elem_list_to_rm fst r;
      } in (\ asa ->
             rs_to_list
               (foldl
                 (\ a x ->
                   rs_union a (list_to_rs (map snd (rm_set_lookup rm x))))
                 (rs_empty ()) asa)))
    (\ asa bs -> rs_union bs (list_to_rs asa)) rs_memb (rs_empty ());

memo_rbt_rtrancl :: forall a. (Linorder a) => [(a, a)] -> a -> Rbt a ();
memo_rbt_rtrancl r =
  let {
    tr = rtrancl_rbt_impl r;
    rm = list_to_rm
           (map (\ a -> (a, tr [a])) (((rs_to_list . list_to_rs) . map fst) r));
  } in (\ a ->
         (case rm_lookup a rm of {
           Nothing -> list_to_rs [a];
           Just asa -> asa;
         }));

conv_ta_rule :: forall a b. (a -> Rbt a ()) -> Ta_rule a b -> Ta_rule_impl a b;
conv_ta_rule eps (TA_rule f qs q) = TA_rule_impl f qs q (eps q);

r_sym_impl :: forall a b. Ta_rule_impl a b -> (b, Nat);
r_sym_impl (TA_rule_impl f qsa q qs) = (f, size_list qsa);

generate_ta ::
  forall a b.
    (Linorder a, Eq b, Linorder b) => Tree_automaton a b -> Ta_impl_ext a b ();
generate_ta (Tree_Automaton fin rules eps) =
  let {
    ep = memo_rbt_rtrancl eps;
    epr = memo_rbt_rtrancl (map (\ (q, qa) -> (qa, q)) eps);
    rqs_rs = foldl (\ a x -> rs_union a (ep (r_rhs x))) (rs_empty ()) rules;
    rrules = map (conv_ta_rule ep) rules;
  } in Ta_impl_ext (list_to_rs fin) (elem_list_to_rm r_sym_impl rrules)
         (rs_to_list rqs_rs) rqs_rs eps ep epr ();

generate_ta_cond ::
  forall a b.
    (Eq a, Linorder a, Showa a, Eq b, Linorder b,
      Showa b) => Tree_automaton a b ->
                    Ta_relation a ->
                      Sum ([Prelude.Char] -> [Prelude.Char])
                        (Ta_impl_ext a b ());
generate_ta_cond ta rel =
  let {
    (Tree_Automaton _ _ eps) = ta;
  } in bindb (check (is_Id_relation rel || null eps)
               (shows_prec_list Zero_nat
                 ['r', 'e', 'l', 'a', 't', 'i', 'o', 'n', ' ', 'm', 'u', 's',
                   't', ' ', 'b', 'e', ' ', 'I', 'd', ',', ' ', 'o', 'r', ' ',
                   'n', 'o', ' ', 'e', 'p', 's', 'i', 'l', 'o', 'n', ' ', 'r',
                   'u', 'l', 'e', 's', ' ', 'm', 'u', 's', 't', ' ', 'b', 'e',
                   ' ', 'p', 'r', 'e', 's', 'e', 'n', 't']))
         (\ _ ->
           bindb (catcha (check_coherent ta rel)
                   (\ x ->
                     Inl (shows_prec_list Zero_nat
                            ['a', 'u', 't', 'o', 'm', 'a', 't', 'o', 'n', ' ',
                              'i', 's', ' ', 'n', 'o', 't', ' ', 'c', 'o', 'h',
                              'e', 'r', 'e', 'n', 't', ' ', 'w', '.', 'r', '.',
                              't', '.', ' ', 'r', 'e', 'l', 'a', 't', 'i', 'o',
                              'n'] .
                           shows_nl . x)))
             (\ _ -> Inr (generate_ta ta)));

bounds_condition ::
  forall a b.
    (Showa a, Eq b,
      Showa b) => Boundstype ->
                    [(Term a b, Term a b)] ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) ();
bounds_condition Roof uu = Inr ();
bounds_condition Match r =
  catcha
    (catcha
      (forallM
        (\ x ->
          (if let {
                (l, ra) = x;
              } in ms_lesseq (vars_term_list ra) (vars_term_list l)
            then Inr () else Inl x))
        r)
      (\ x -> Inl (snd x)))
    (\ x ->
      Inl (let {
             (l, ra) = x;
           } in shows_prec_list Zero_nat ['r', 'u', 'l', 'e', ' '] .
                  shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                    [' ', '-', '>', ' '] (l, ra) .
                    shows_prec_list Zero_nat
                      [' ', 'i', 's', ' ', 'd', 'u', 'p', 'l', 'i', 'c', 'a',
                        't', 'i', 'n', 'g']));

boundstype_fun ::
  forall a b. (Eq b) => Boundstype -> (Term a b, Term a b) -> Term a b -> Bool;
boundstype_fun Roof = roof;
boundstype_fun Match = match;

rs_subset :: forall a. (Linorder a) => Rbt a () -> Rbt a () -> Maybe a;
rs_subset asa bs =
  rs_iteratei asa (\ a -> (case a of {
                            Nothing -> True;
                            Just _ -> False;
                          }))
    (\ a _ -> (if rs_memb a bs then Nothing else Just a)) Nothing;

rel_checker ::
  forall a.
    (Eq a, Linorder a) => Ta_relation a -> Rbt a () -> Rbt a () -> Maybe a;
rel_checker (Some_Relation rel) =
  (\ lhs rhs ->
    let {
      rlist = rs_to_list rhs;
    } in (case catcha
                 (forallM
                   (\ l -> check (any (\ r -> membera rel (l, r)) rlist) l)
                   (rs_to_list lhs))
                 (\ x -> Inl (snd x))
           of {
           Inl a -> Just a;
           Inr _ -> Nothing;
         }));
rel_checker Id_Relation = rs_subset;

check_bounds ::
  forall a b.
    (Eq a, Linorder a, Showa a, Ceq b, Corder b, Eq b, Linorder b, Set_impla b,
      Showa b) => Bounds_info a b ->
                    [(Term a b, Term a b)] ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_bounds (Bounds_Info typea c qfin preTA rel) r =
  bindb (generate_ta_cond preTA rel)
    (\ ta ->
      let {
        rell = rel_checker rel;
      } in bindb (check_wf_trs r)
             (\ _ ->
               bindb (check_left_linear_trs r)
                 (\ _ ->
                   bindb (bounds_condition typea r)
                     (\ _ ->
                       bindb (check
                               (any (\ q -> rs_memb q (ta_rhs_states_set ta))
                                 qfin)
                               (shows_prec_list Zero_nat
                                 ['d', 'i', 'd', ' ', 'n', 'o', 't', ' ', 'f',
                                   'i', 'n', 'd', ' ', 'm', 'e', 'n', 't', 'i',
                                   'o', 'n', 'e', 'd', ' ', 'f', 'i', 'n', 'a',
                                   'l', ' ', 's', 't', 'a', 't', 'e', ' ', 'i',
                                   'n', ' ', 'T', 'A']))
                         (\ _ ->
                           bindb (catcha
                                   (catcha
                                     (forallM
                                       (\ x ->
 (if let {
       (f, _) = x;
     } in less_eq_nat (height f) c
   then Inr () else Inl x))
                                       (map fst
 (rm_to_list (ta_rules_impl ta))))
                                     (\ x -> Inl (snd x)))
                                   (\ x ->
                                     Inl (let {
    (f, _) = x;
  } in shows_prec_prod Zero_nat f .
         shows_prec_list Zero_nat
           [' ', 'i', 's', ' ', 's', 'y', 'm', 'b', 'o', 'l', ' ', 'i', 'n',
             ' ', 'T', 'A', ' ', 'w', 'i', 't', 'h', ' ', 'h', 'e', 'i', 'g',
             'h', 't', ' ', 'l', 'a', 'r', 'g', 'e', 'r', ' ', 't', 'h', 'a',
             'n', ' ', 'c', ' ', '=', ' '] .
           shows_prec_nat Zero_nat c)))
                             (\ _ ->
                               bindb (catcha
                                       (ta_contains_impl
 (map (\ (f, a) -> (lift Zero_nat f, a)) (funas_trs_list r)) ta qfin)
                                       (\ x ->
 Inl (shows_prec_list Zero_nat
        ['i', 't', ' ', 'c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'b',
          'e', ' ', 'g', 'u', 'a', 'r', 'a', 'n', 't', 'e', 'e', 'd', ' ', 't',
          'h', 'a', 't', ' ', 'l', 'i', 'f', 't', '0', '(', 'T', '(', 'S', 'i',
          'g', 'm', 'a', ')', ')', ' ', 'i', 's', ' ', 'a', 'c', 'c', 'e', 'p',
          't', 'e', 'd', ' ', 'b', 'y', ' ', 'T', 'A'] .
       shows_nl .
         (case x of {
           Inl q ->
             shows_prec_list Zero_nat ['s', 't', 'a', 't', 'e', ' '] .
               shows_prec Zero_nat q .
                 shows_prec_list Zero_nat
                   [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'f', 'i', 'n', 'a',
                     'l'];
           Inr fqs ->
             shows_prec_list Zero_nat
               ['t', 'h', 'e', 'r', 'e', ' ', 'i', 's', ' ', 'n', 'o', ' ', 't',
                 'r', 'a', 'n', 's', 'i', 't', 'i', 'o', 'n', ' ', 'f', 'r',
                 'o', 'm', ' '] .
               shows_prec_term Zero_nat fqs .
                 shows_prec_list Zero_nat
                   [' ', 't', 'o', ' ', 'a', ' ', 'f', 'i', 'n', 'a', 'l', ' ',
                     's', 't', 'a', 't', 'e'];
         }))))
                                 (\ _ ->
                                   catcha
                                     (state_compatible_eff_list ta rell
                                       (cover_bound_list_filter
 (\ l -> not (rule_state_compatible_heuristic ta l)) (boundstype_fun typea) c
 r))
                                     (\ x ->
                                       Inl
 (let {
    (lr, (lr_rhs, q)) = x;
  } in shows_prec_list Zero_nat
         ['T', 'A', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'c', 'o', 'm', 'p',
           'a', 't', 'i', 'b', 'l', 'e', ' ', 'w', 'i', 't', 'h', ' ', 'R'] .
         shows_nl .
           shows_prec_list Zero_nat
             ['f', 'o', 'r', ' ', 'r', 'u', 'l', 'e', ' '] .
             shows_rule (shows_prec_prod Zero_nat) (shows_prec Zero_nat)
               [' ', '-', '>', ' '] lr .
               shows_nl .
                 shows_prec_list Zero_nat
                   ['w', 'h', 'i', 'c', 'h', ' ', 'i', 's', ' ', 'i', 'n', 's',
                     't', 'a', 'n', 't', 'i', 'a', 't', 'e', 'd', ' ', 'b', 'y',
                     ' ', 's', 't', 'a', 't', 'e', 's', ' ', 't', 'o', ' '] .
                   shows_rule (shows_prec_prod Zero_nat) (shows_prec Zero_nat)
                     [' ', '-', '>', ' '] lr_rhs .
                     shows_nl .
                       shows_prec_list Zero_nat
                         ['t', 'h', 'e', ' ', 's', 't', 'a', 't', 'e', ' '] .
                         shows_prec Zero_nat q .
                           shows_prec_list Zero_nat
                             [' ', 'i', 's', ' ', 'o', 'n', 'l', 'y', ' ', 'r',
                               'e', 'a', 'c', 'h', 'a', 'b', 'l', 'e', ' ', 'f',
                               'r', 'o', 'm', ' ', 't', 'h', 'e', ' ', 'l', 'h',
                               's'] .
                             shows_nl)))))))));

bounds_tt ::
  forall a b c.
    (Eq b, Linorder b, Showa b, Ceq c, Corder c, Eq c, Linorder c, Set_impla c,
      Showa c) => Tp_ops_ext a b c () ->
                    Bounds_info b c ->
                      a -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
bounds_tt i info tp = let {
                        a = rulesb i tp;
                      } in check_bounds info a;

check_tp_subsumes ::
  forall a b c d.
    (Eq b, Showa b, Eq c, Showa c, Eq d,
      Showa d) => Tp_ops_ext a (Lab b c) d () ->
                    (Bool,
                      ([Term (Lab b c) d],
                        ([(Term (Lab b c) d, Term (Lab b c) d)],
                          [(Term (Lab b c) d, Term (Lab b c) d)]))) ->
                      a -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_tp_subsumes i (nfs, (q, (r, rw))) tp =
  catcha
    (let {
       nfsaa = nfsa i tp;
       qaa = qa i tp;
       raa = ra i tp;
       rwaa = rwa i tp;
       rb = r ++ rw;
     } in bindb (check (nfsaa == nfs)
                  (shows_prec_list Zero_nat
                    ['i', 'n', 'c', 'o', 'm', 'p', 'a', 't', 'i', 'b', 'l', 'e',
                      ' ', 's', 'u', 'b', 's', 't', 'i', 't', 'u', 't', 'i',
                      'o', 'n', 's', '-', 'i', 'n', '-', 'n', 'o', 'r', 'm',
                      'a', 'l', '-', 'f', 'o', 'r', 'm', ' ', 'f', 'l', 'a',
                      'g', 's']))
            (\ _ ->
              bindb (catcha (check_NF_terms_subset qaa q)
                      (\ x ->
                        Inl (shows_prec_list Zero_nat
                               ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w',
                                 'i', 't', 'h', ' ', 'i', 'n', 'n', 'e', 'r',
                                 'm', 'o', 's', 't', ' ', 's', 't', 'r', 'a',
                                 't', 'e', 'g', 'y', ' ', 'd', 'u', 'e', ' ',
                                 't', 'o', ' ', 't', 'e', 'r', 'm', ' '] .
                              shows_term (shows_prec_lab Zero_nat)
                                (shows_prec Zero_nat) x)))
                (\ _ ->
                  bindb (catcha (check_subseteq raa r)
                          (\ x ->
                            Inl (toomuch ['r', 'u', 'l', 'e']
                                  (shows_rule (shows_prec_lab Zero_nat)
                                    (shows_prec Zero_nat) [' ', '-', '>', ' ']
                                    x))))
                    (\ _ ->
                      bindb (catcha (check_subseteq rwaa rb)
                              (\ x ->
                                Inl (toomuch
                                      ['r', 'e', 'l', 'a', 't', 'i', 'v', 'e',
' ', 'r', 'u', 'l', 'e']
                                      (shows_rule (shows_prec_lab Zero_nat)
(shows_prec Zero_nat) [' ', '-', '>', ' '] x))))
                        (\ _ -> Inr ())))))
    (\ x ->
      Inl (shows_string
             ['t', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i', 'o', 'n', ' ', 'o',
               'f', ' ', 't', 'h', 'e', ' ', 'p', 'r', 'o', 'b', 'l', 'e',
               'm'] .
            shows_nl .
              shows_tp (shows_prec_lab Zero_nat) (shows_prec Zero_nat) i tp .
                shows_nl .
                  shows_string
                    ['m', 'a', 'y', ' ', 'n', 'o', 't', ' ', 'b', 'e', ' ', 'c',
                      'o', 'n', 'c', 'l', 'u', 'd', 'e', 'd', ' ', 'f', 'r',
                      'o', 'm', ' ', 'a', 's', 's', 'u', 'm', 'i', 'n', 'g',
                      ' ', 't', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i', 'o',
                      'n', ' ', 'o', 'f', ' ', 't', 'h', 'e', ' ', 'p', 'r',
                      'o', 'b', 'l', 'e', 'm'] .
                    shows_nl .
                      shows_tp (shows_prec_lab Zero_nat) (shows_prec Zero_nat) i
                        (mka i nfs q r rw) .
                        shows_nl . x . shows_nl));

check_trs_termination_proof ::
  forall a b c.
    (Countable b, Eq b, Key b,
      Showa b) => Bool ->
                    ([Prelude.Char] -> [Prelude.Char]) ->
                      Tp_ops_ext a (Lab b [Nat]) [Prelude.Char] () ->
                        Dpp_ops_ext c (Lab b [Nat]) [Prelude.Char] () ->
                          a -> Trs_termination_proof b [Nat] [Prelude.Char] ->
                                 Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_trs_termination_proof a ia i j tp R_is_Empty =
  debug (ia []) ['R', ' ', 'i', 's', ' ', 'e', 'm', 'p', 't', 'y']
    (if null (ra i tp) then Inr ()
      else Inl (ia . shows_string
                       [':', ' ', 'R', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ',
                         'e', 'm', 'p', 't', 'y', ' ', 'i', 'n', ' ', 't', 'h',
                         'e', ' ', 'f', 'o', 'l', 'l', 'o', 'w', 'i', 'n', 'g',
                         ' ', 't', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i', 'o',
                         'n', '-', 'p', 'r', 'o', 'b', 'l', 'e', 'm', ' '] .
                       shows_nl .
                         shows_tp (shows_prec_lab Zero_nat)
                           (shows_prec_list Zero_nat) i tp));
check_trs_termination_proof a ia i j tp (Rule_Removal redp rR prf) =
  debug (ia []) ['R', 'u', 'l', 'e', ' ', 'R', 'e', 'm', 'o', 'v', 'a', 'l']
    (let {
       r = rulesb i tp;
       rr = ceta_list_diff r rR;
     } in bindb (catcha (rule_removal_tt i (get_redtriple redp) rr tp)
                  (\ x ->
                    Inl (ia . shows_string
                                [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w',
                                  'h', 'e', 'n', ' ', 'a', 'p', 'p', 'l', 'y',
                                  'i', 'n', 'g', ' ', 't', 'h', 'e', ' ', 'r',
                                  'u', 'l', 'e', ' ', 'r', 'e', 'm', 'o', 'v',
                                  'a', 'l', ' ', 't', 'e', 'c', 'h', 'n', 'i',
                                  'q', 'u', 'e', ' ', 'o', 'n', ' '] .
                                shows_nl .
                                  shows_tp (shows_prec_lab Zero_nat)
                                    (shows_prec_list Zero_nat) i tp .
                                    shows_nl .
                                      shows_string
[' ', 't', 'o', ' ', 'r', 'e', 'm', 'o', 'v', 'e', ' ', 't', 'h', 'e', ' ', 'r',
  'u', 'l', 'e', 's', ' '] .
shows_nl .
  shows_rules (shows_prec_lab Zero_nat) (shows_prec_list Zero_nat)
    [' ', '-', '>', ' '] rr .
    shows_nl . x)))
            (\ tpa ->
              catcha
                (check_trs_termination_proof a (ia . shows_string ['.', '1']) i
                  j tpa prf)
                (\ x ->
                  Inl (ia . shows_string
                              [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e',
                                'l', 'o', 'w', ' ', 't', 'h', 'e', ' ', 'r',
                                'u', 'l', 'e', ' ', 'r', 'e', 'm', 'o', 'v',
                                'a', 'l', ' ', 't', 'e', 'c', 'h', 'n', 'i',
                                'q', 'u', 'e'] .
                              shows_nl . indent x))));
check_trs_termination_proof a ia i j tp (DP_Trans nfs m p prf) =
  debug (ia []) ['D', 'P', ' ', 't', 'r', 'a', 'n', 's']
    (bindb
      (catcha (dependency_pairs_tt i j tp nfs m Sharp p)
        (\ x ->
          Inl (ia . shows_string
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e',
                        'n', ' ', 's', 'w', 'i', 't', 'c', 'h', 'i', 'n', 'g',
                        ' ', 'f', 'r', 'o', 'm', ' ', 't', 'h', 'e', ' ', 'T',
                        'R', 'S'] .
                      shows_nl .
                        shows_tp (shows_prec_lab Zero_nat)
                          (shows_prec_list Zero_nat) i tp .
                          shows_nl .
                            shows_string
                              ['t', 'o', ' ', 't', 'h', 'e', ' ', 'i', 'n', 'i',
                                't', 'i', 'a', 'l', ' ', 'D', 'P', ' ', 'p',
                                'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'i',
                                't', 'h', ' ', 'p', 'a', 'i', 'r', 's', ' '] .
                              shows_nl .
                                shows_rules (shows_prec_lab Zero_nat)
                                  (shows_prec_list Zero_nat)
                                  [' ', '-', '>', ' '] p .
                                  shows_nl . x)))
      (\ dpp ->
        catcha
          (check_dp_termination_proof_with_unlab a
            (ia . shows_string ['.', '1']) j dpp prf)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                          'o', 'w', ' ', 's', 'w', 'i', 't', 'c', 'h', ' ', 't',
                          'o', ' ', 'd', 'e', 'p', 'e', 'n', 'd', 'e', 'n', 'c',
                          'y', ' ', 'p', 'a', 'i', 'r', 's'] .
                        shows_nl . indent x))));
check_trs_termination_proof a ia i j tp (String_Reversal prf) =
  debug (ia [])
    ['S', 't', 'r', 'i', 'n', 'g', ' ', 'R', 'e', 'v', 'e', 'r', 's', 'a', 'l']
    (bindb
      (catcha (string_reversal_tt i tp)
        (\ x ->
          Inl (ia . shows_string
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e',
                        'n', ' ', 'a', 'p', 'p', 'l', 'y', 'i', 'n', 'g', ' ',
                        's', 't', 'r', 'i', 'n', 'g', ' ', 'r', 'e', 'v', 'e',
                        'r', 's', 'a', 'l', ' ', 'o', 'n', ' '] .
                      shows_nl .
                        shows_tp (shows_prec_lab Zero_nat)
                          (shows_prec_list Zero_nat) i tp .
                          shows_nl . x)))
      (\ tpa ->
        catcha
          (check_trs_termination_proof a (ia . shows_string ['.', '1']) i j tpa
            prf)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                          'o', 'w', ' ', 't', 'h', 'e', ' ', 's', 't', 'r', 'i',
                          'n', 'g', ' ', 'r', 'e', 'v', 'e', 'r', 's', 'a', 'l',
                          ' ', 't', 'e', 'c', 'h', 'n', 'i', 'q', 'u', 'e'] .
                        shows_nl . indent x))));
check_trs_termination_proof a ia i j tp (Semlab sli lQ lAll prf) =
  debug (ia []) ['S', 'e', 'm', 'l', 'a', 'b']
    (bindb
      (catcha (semlab_fin_tt i sli lQ lAll tp)
        (\ x ->
          Inl (ia . shows_string
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e',
                        'n', ' ', 'a', 'p', 'p', 'l', 'y', 'i', 'n', 'g', ' ',
                        's', 'e', 'm', 'a', 'n', 't', 'i', 'c', ' ', 'l', 'a',
                        'b', 'e', 'l', 'l', 'i', 'n', 'g', ' ', 'o', 'n', ' '] .
                      shows_nl .
                        shows_tp (shows_prec_lab Zero_nat)
                          (shows_prec_list Zero_nat) i tp .
                          shows_nl . x)))
      (\ tpa ->
        catcha
          (check_trs_termination_proof a (ia . shows_string ['.', '1']) i j tpa
            prf)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                          'o', 'w', ' ', 't', 'h', 'e', ' ', 's', 'e', 'm', '.',
                          'l', 'a', 'b', ' ', 't', 'e', 'c', 'h', 'n', 'i', 'q',
                          'u', 'e'] .
                        shows_nl . indent x))));
check_trs_termination_proof a ia i j tp (Bounds info) =
  debug (ia []) ['B', 'o', 'u', 'n', 'd', 's']
    (catcha (bounds_tt i info tp)
      (\ x ->
        Inl (ia . shows_string
                    [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e', 'n',
                      ' ', 'a', 'p', 'p', 'l', 'y', 'i', 'n', 'g', ' ', 'b',
                      'o', 'u', 'n', 'd', 's', ' ', 'o', 'n', ' ', 't', 'h',
                      'e', ' ', 't', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i',
                      'o', 'n', ' ', 'p', 'r', 'o', 'b', 'l', 'e', 'm', ' '] .
                    shows_nl .
                      shows_tp (shows_prec_lab Zero_nat)
                        (shows_prec_list Zero_nat) i tp .
                        shows_nl . x)));
check_trs_termination_proof a ia i j tp (Uncurry u_info rR prf) =
  debug (ia []) ['U', 'n', 'c', 'u', 'r', 'r', 'y']
    (bindb
      (catcha (uncurry_tt i u_info rR tp)
        (\ x ->
          Inl (ia . shows_string
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e',
                        'n', ' ', 'a', 'p', 'p', 'l', 'y', 'i', 'n', 'g', ' ',
                        'c', 'u', 'r', 'r', 'y', 'i', 'n', 'g', ' ', 't', 'r',
                        'a', 'n', 's', 'f', 'o', 'r', 'm', 'a', 't', 'i', 'o',
                        'n'] .
                      shows_nl . x)))
      (\ tpa ->
        catcha
          (check_trs_termination_proof a (ia . shows_string ['.', '1']) i j tpa
            prf)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                          'o', 'w', ' ', 't', 'h', 'e', ' ', 'u', 'n', 'c', 'u',
                          'r', 'r', 'y', 'i', 'n', 'g', ' ', 't', 'e', 'c', 'h',
                          'n', 'i', 'q', 'u', 'e'] .
                        shows_nl . indent x))));
check_trs_termination_proof a ia i j tp (Fcc fcs r prf) =
  debug (ia []) ['F', 'c', 'c']
    (bindb
      (catcha (fcc_tt i fcs r tp)
        (\ x ->
          Inl (ia . shows_string
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e',
                        'n', ' ', 'a', 'p', 'p', 'l', 'y', 'i', 'n', 'g', ' ',
                        'f', 'l', 'a', 't', ' ', 'c', 'o', 'n', 't', 'e', 'x',
                        't', ' ', 'c', 'l', 'o', 's', 'u', 'r', 'e'] .
                      shows_nl . x)))
      (\ tpa ->
        catcha
          (check_trs_termination_proof a (ia . shows_string ['.', '1']) i j tpa
            prf)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                          'o', 'w', ' ', 'f', 'l', 'a', 't', ' ', 'c', 'o', 'n',
                          't', 'e', 'x', 't', ' ', 'c', 'l', 'o', 's', 'u', 'r',
                          'e'] .
                        shows_nl . indent x))));
check_trs_termination_proof a ia i j tp (Split rrem prf1 prf2) =
  debug (ia []) ['S', 'p', 'l', 'i', 't']
    (let {
       (tp1, tp2) = split_tt i tp rrem;
     } in bindb (catcha
                  (check_trs_termination_proof a (ia . shows_string ['.', '1'])
                    i j tp1 prf1)
                  (\ x ->
                    Inl (ia . shows_string
                                [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b',
                                  'e', 'l', 'o', 'w', ' ', 't', 'h', 'e', ' ',
                                  's', 'p', 'l', 'i', 't', 't', 'i', 'n', 'g'] .
                                shows_nl . indent x)))
            (\ _ ->
              catcha
                (check_trs_termination_proof a (ia . shows_string ['.', '2']) i
                  j tp2 prf2)
                (\ x ->
                  Inl (ia . shows_string
                              [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e',
                                'l', 'o', 'w', ' ', 't', 'h', 'e', ' ', 's',
                                'p', 'l', 'i', 't', 't', 'i', 'n', 'g'] .
                              shows_nl . indent x))));
check_trs_termination_proof a ia i j tp (Switch_Innermost joins prf) =
  debug (ia [])
    ['S', 'w', 'i', 't', 'c', 'h', ' ', 'I', 'n', 'n', 'e', 'r', 'm', 'o', 's',
      't']
    (bindb
      (catcha (switch_innermost_tt i joins tp)
        (\ x ->
          Inl (ia . shows_string
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e',
                        'n', ' ', 's', 'w', 'i', 't', 'c', 'h', 'i', 'n', 'g',
                        ' ', 't', 'o', ' ', 'i', 'n', 'n', 'e', 'r', 'm', 'o',
                        's', 't', ' ', 'o', 'n', ' '] .
                      shows_nl .
                        shows_tp (shows_prec_lab Zero_nat)
                          (shows_prec_list Zero_nat) i tp .
                          shows_nl . x)))
      (\ tpa ->
        catcha
          (check_trs_termination_proof a (ia . shows_string ['.', '1']) i j tpa
            prf)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                          'o', 'w', ' ', 't', 'h', 'e', ' ', 's', 'w', 'i', 't',
                          'c', 'h', ' ', 't', 'o', ' ', 'i', 'n', 'n', 'e', 'r',
                          'm', 'o', 's', 't'] .
                        shows_nl . indent x))));
check_trs_termination_proof a ia i j tp (Drop_Equality prf) =
  debug (ia [])
    ['D', 'r', 'o', 'p', ' ', 'E', 'q', 'u', 'a', 'l', 'i', 't', 'y']
    (let {
       tpa = mka i (nfsa i tp) (qa i tp) (ra i tp)
               (filter (\ (l, r) -> not (equal_term l r)) (rwa i tp));
     } in catcha
            (check_trs_termination_proof a (ia . shows_string ['.', '1']) i j
              tpa prf)
            (\ x ->
              Inl (ia . shows_string
                          [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e',
                            'l', 'o', 'w', ' ', 'd', 'r', 'o', 'p', 'p', 'i',
                            'n', 'g', ' ', 'e', 'q', 'u', 'a', 'l', 'i', 't',
                            'y', ' ', 'r', 'u', 'l', 'e', 's'] .
                          shows_nl . indent x)));
check_trs_termination_proof a ia i j tp (Remove_Nonapplicable_Rules r prf) =
  debug (ia [])
    ['R', 'e', 'm', 'o', 'v', 'i', 'n', 'g', ' ', 'n', 'o', 'n', '-', 'a', 'p',
      'p', 'l', 'i', 'c', 'a', 'b', 'l', 'e', ' ', 'r', 'u', 'l', 'e', 's']
    (let {
       _ = ra i tp;
     } in bindb (catcha (check_non_applicable_rules (is_QNFa i tp) r)
                  (\ x ->
                    Inl (ia . shows_string
                                [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w',
                                  'h', 'e', 'n', ' ', 'r', 'e', 'm', 'o', 'v',
                                  'i', 'n', 'g', ' ', 'n', 'o', 'n', '-', 'a',
                                  'p', 'p', 'l', 'i', 'c', 'a', 'b', 'l', 'e',
                                  ' ', 'r', 'u', 'l', 'e', 's'] .
                                shows_nl .
                                  indent
                                    (shows_rule (shows_prec_lab Zero_nat)
                                       (shows_prec_list Zero_nat)
                                       [' ', '-', '>', ' '] x .
                                      shows_prec_list Zero_nat
[' ', 'i', 's', ' ', 'a', 'p', 'p', 'l', 'i', 'c', 'a', 'b', 'l', 'e']))))
            (\ _ ->
              let {
                tpa = delete_R_Rwa i tp r r;
              } in catcha
                     (check_trs_termination_proof a
                       (ia . shows_string ['.', '1']) i j tpa prf)
                     (\ x ->
                       Inl (ia . shows_string
                                   [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b',
                                     'e', 'l', 'o', 'w', ' ', 't', 'h', 'e',
                                     ' ', 'n', 'o', 'n', '-', 'a', 'p', 'p',
                                     'l', 'i', 'c', 'a', 'b', 'l', 'e', ' ',
                                     'r', 'u', 'l', 'e', 's', ' ', 'r', 'e',
                                     'm', 'o', 'v', 'a', 'l'] .
                                   shows_nl . indent x))));
check_trs_termination_proof a ia i j tpa (Assume_SN tp tps) =
  debug (ia [])
    ['T', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i', 'o', 'n', ' ', 'A', 's', 's',
      'u', 'm', 'p', 't', 'i', 'o', 'n', ' ', 'o', 'r', ' ', 'U', 'n', 'k', 'n',
      'o', 'w', 'n', ' ', 'P', 'r', 'o', 'o', 'f']
    (if a then bindb (catcha (check_tp_subsumes i tp tpa)
                       (\ x ->
                         Inl (ia . shows_string
                                     [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ',
                                       'i', 'n', ' ', 't', 'e', 'r', 'm', 'i',
                                       'n', 'a', 't', 'i', 'o', 'n', ' ', 'a',
                                       's', 's', 'u', 'm', 'p', 't', 'i', 'o',
                                       'n', ' ', 'o', 'r', ' ', 'u', 'n', 'k',
                                       'n', 'o', 'w', 'n', ' ', 'p', 'r', 'o',
                                       'o', 'f'] .
                                     shows_nl . x . shows_nl)))
                 (\ _ ->
                   catcha
                     (catcha
                       (forallM_index
                         (\ (tpb, p) ja ->
                           check_trs_termination_proof a
                             (ia . shows_string ['.'] .
                                     shows_prec_nat Zero_nat
                                       (plus_nat ja (Nat_of_num One)))
                             i j (mk_tp i tpb) p)
                         tps)
                       (\ x -> Inl (snd x)))
                     (\ x ->
                       Inl (ia . shows_string
                                   [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b',
                                     'e', 'l', 'o', 'w', ' ', 'u', 'n', 'k',
                                     'n', 'o', 'w', 'n', ' ', 'p', 'r', 'o',
                                     'o', 'f'] .
                                   shows_nl . indent x)))
      else Inl (ia . shows_string
                       [':', ' ', 't', 'h', 'e', ' ', 'p', 'r', 'o', 'o', 'f',
                         ' ', 'c', 'o', 'n', 't', 'a', 'i', 'n', 's', ' ', 'a',
                         ' ', 't', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i', 'o',
                         'n', ' ', 'a', 's', 's', 'u', 'm', 'p', 't', 'i', 'o',
                         'n', ' ', 'o', 'r', ' ', 'u', 'n', 'k', 'n', 'o', 'w',
                         'n', ' ', 'p', 'r', 'o', 'o', 'f'] .
                       shows_nl));

check_cr_proof ::
  forall a b c.
    (Countable b, Eq b, Key b,
      Showa b) => Bool ->
                    ([Prelude.Char] -> [Prelude.Char]) ->
                      Tp_ops_ext a (Lab b [Nat]) [Prelude.Char] () ->
                        Dpp_ops_ext c (Lab b [Nat]) [Prelude.Char] () ->
                          [(Term (Lab b [Nat]) [Prelude.Char],
                             Term (Lab b [Nat]) [Prelude.Char])] ->
                            Cr_proof b [Nat] [Prelude.Char] ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_cr_proof a ia i j r (SN_WCR joins_i prf) =
  debug (ia []) ['S', 'N', '_', 'W', 'C', 'R']
    (let {
       tp = mka i False [] r [];
     } in bindb (catcha
                  (check_trs_termination_proof a (ia . shows_string ['.', '1'])
                    i j tp prf)
                  (\ x ->
                    Inl (ia . shows_string
                                [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b',
                                  'e', 'l', 'o', 'w', ' ', 's', 't', 'r', 'o',
                                  'n', 'g', ' ', 'n', 'o', 'r', 'm', 'a', 'l',
                                  'i', 'z', 'a', 't', 'i', 'o', 'n', ' ', '+',
                                  ' ', 'w', 'c', 'r'] .
                                shows_nl . indent x)))
            (\ _ ->
              catcha (check_critical_pairs r (critical_pairs_impl r r) joins_i)
                (\ x ->
                  Inl (ia . shows_prec_list Zero_nat
                              ['e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e', 'n',
                                ' ', 'p', 'r', 'o', 'v', 'i', 'n', 'g', ' ',
                                'l', 'o', 'c', 'a', 'l', ' ', 'c', 'o', 'n',
                                'f', 'l', 'u', 'e', 'n', 'c', 'e', ' ', 'o',
                                'f', ' '] .
                              shows_tp (shows_prec_lab Zero_nat)
                                (shows_prec_list Zero_nat) i tp .
                                shows_nl . indent x))));
check_cr_proof a ia i j r Weakly_Orthogonal =
  debug (ia [])
    ['W', 'e', 'a', 'k', 'l', 'y', ' ', 'O', 'r', 't', 'h', 'o', 'g', 'o', 'n',
      'a', 'l']
    (catcha (check_weakly_orthogonal r)
      (\ x ->
        Inl (ia . shows_prec_list Zero_nat
                    [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ', 'c',
                      'h', 'e', 'c', 'k', 'i', 'n', 'g', ' ', 'w', 'e', 'a',
                      'k', 'l', 'y', ' ', 'o', 'r', 't', 'h', 'o', 'g', 'o',
                      'n', 'a', 'l', ' ', 's', 'y', 's', 't', 'e', 'm', ' ',
                      'f', 'o', 'r', ' ', 't', 'h', 'e', ' ', 'T', 'R', 'S'] .
                    shows_nl .
                      shows_trs (shows_prec_lab Zero_nat)
                        (shows_prec_list Zero_nat)
                        ['r', 'e', 'w', 'r', 'i', 't', 'e', ' ', 's', 'y', 's',
                          't', 'e', 'm', ':']
                        [' ', '-', '>', ' '] r .
                        indent x)));
check_cr_proof a ia i j r (Strongly_Closed n) =
  debug (ia [])
    ['S', 't', 'r', 'o', 'n', 'g', 'l', 'y', ' ', 'C', 'l', 'o', 's', 'e', 'd']
    (catcha (check_strongly_closed r n)
      (\ x ->
        Inl (ia . shows_prec_list Zero_nat
                    [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ', 'c',
                      'h', 'e', 'c', 'k', 'i', 'n', 'g', ' ', 's', 't', 'r',
                      'o', 'n', 'g', ' ', 'c', 'l', 'o', 's', 'e', 'd', 'n',
                      'e', 's', 's', ' ', 'f', 'o', 'r', ' ', 't', 'h', 'e',
                      ' ', 'T', 'R', 'S'] .
                    shows_nl .
                      shows_trs (shows_prec_lab Zero_nat)
                        (shows_prec_list Zero_nat)
                        ['r', 'e', 'w', 'r', 'i', 't', 'e', ' ', 's', 'y', 's',
                          't', 'e', 'm', ':']
                        [' ', '-', '>', ' '] r .
                        indent x)));

cEnum_nat :: Maybe ([Nat], ((Nat -> Bool) -> Bool, (Nat -> Bool) -> Bool));
cEnum_nat = Nothing;

instance Cenum Nat where {
  cEnum = cEnum_nat;
};

cEnum_lab ::
  forall a b.
    Maybe ([Lab a b], ((Lab a b -> Bool) -> Bool, (Lab a b -> Bool) -> Bool));
cEnum_lab = Nothing;

instance Cenum (Lab a b) where {
  cEnum = cEnum_lab;
};

si_subst :: forall a b. Subst_incr a b -> b -> Term a b;
si_subst x = fst (rep_subst_incr x);

pat_dv_impl ::
  forall a b.
    (Eq a, Eq b) => (Term a b, ([(b, Term a b)], [(b, Term a b)])) -> [b];
pat_dv_impl p =
  let {
    (_, (sigma, mu)) = p;
  } in remdups (map fst (mk_subst_domain sigma ++ mk_subst_domain mu));

check_nfc ::
  forall a b.
    (Showa a,
      Showa b) => Bool ->
                    [(Term a b, Term a b)] ->
                      [Term a b] ->
                        [Term a b] ->
                          Bool ->
                            Term a b ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_nfc inn r q ss nfs t =
  check inn
    (shows_prec_list Zero_nat
      ['w', 'e', ' ', 'd', 'o', ' ', 'n', 'o', 't', ' ', 'h', 'a', 'v', 'e',
        ' ', 'e', 'x', 'a', 'c', 't', 'l', 'y', ' ', 'i', 'n', 'n', 'e', 'r',
        'm', 'o', 's', 't', ' ', 'a', 'n', 'd', ' ', 'c', 'u', 'r', 'r', 'e',
        'n', 't', 'l', 'y', ' ', 'n', 'o', ' ', 'b', 'e', 't', 't', 'e', 'r',
        ' ', 'n', 'f', 'c', '-', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n',
        ' ', 't', 'e', 's', 't', ' ', 'i', 's', ' ', 'i', 'm', 'p', 'l', 'e',
        'm', 'e', 'n', 't', 'e', 'd']);

intersect_values ::
  forall a b.
    (Eq a, Linorder b) => (a -> Maybe b) -> [a] -> Rbt b [a] -> Rbt b [a];
intersect_values key vs m = foldr (aux key m) vs (rm_empty ());

intersect_rules ::
  forall a b.
    (Eq a, Linorder a,
      Eq b) => [(Term a b, Term a b)] ->
                 Rbt (a, Nat) [(Bool, (Term a b, Term a b))] ->
                   Rbt (a, Nat) [(Bool, (Term a b, Term a b))];
intersect_rules rs =
  intersect_values key
    (map (\ a -> (True, a)) rs ++ map (\ a -> (False, a)) rs);

ceiling :: forall a. (Floor_ceiling a) => a -> Int;
ceiling x = uminus_int (floor (uminus x));

xml_ctrs_input ::
  forall a b c.
    (Showa a, Showa b,
      Showa c) => [((Term (Lab a [b]) c, Term (Lab a [b]) c),
                     [(Term (Lab a [b]) c, Term (Lab a [b]) c)])] ->
                    Xml;
xml_ctrs_input ctrs =
  Xml ['c', 't', 'r', 's', 'I', 'n', 'p', 'u', 't'] []
    [Xml ['c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n', 'a', 'l', 'R', 'u', 'l',
           'e', 's']
       [] (map xml_crule ctrs) Nothing]
    Nothing;

starts_with :: [Prelude.Char] -> [Prelude.Char] -> Bool;
starts_with t s = take (size_list s) (trim t) == s;

check_non_join ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    Term a b ->
                      [(Pos, ((Term a b, Term a b), Term a b))] ->
                        [(Pos, ((Term a b, Term a b), Term a b))] ->
                          Non_join_info a b ->
                            Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_non_join r s seq1 seq2 reason =
  let {
    chk = check_rsteps_last r s;
  } in bindb (chk seq1)
         (\ _ ->
           bindb (chk seq2)
             (\ _ ->
               let {
                 u = rseq_last s seq1;
                 v = rseq_last s seq2;
               } in (case reason of {
                      Diff_NFs ->
                        bindb (check (not (equal_term u v))
                                (shows_prec_list Zero_nat
                                   ['t', 'h', 'e', ' ', 'r', 'e', 'w', 'r', 'i',
                                     't', 'e', ' ', 's', 'e', 'q', 'u', 'e',
                                     'n', 'c', 'e', 's', ' ', 'e', 'n', 'd',
                                     ' ', 'i', 'n', ' ', 't', 'h', 'e', ' ',
                                     's', 'a', 'm', 'e', ' ', 't', 'e', 'r',
                                     'm', ' '] .
                                  shows_prec_term Zero_nat u))
                          (\ _ ->
                            let {
                              chknf =
                                (\ sa ->
                                  check (nF_terms_list (map fst r) sa)
                                    (shows_prec_list Zero_nat
                                       ['t', 'h', 'e', ' ', 't', 'e', 'r', 'm',
 ' '] .
                                      shows_term (shows_prec Zero_nat)
(shows_prec Zero_nat) sa .
shows_prec_list Zero_nat
  [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'i', 'n', ' ', 'n', 'o', 'r', 'm',
    'a', 'l', ' ', 'f', 'o', 'r', 'm']));
                            } in bindb (chknf u) (\ _ -> chknf v));
                      Tcap_Non_Unif grd_subst ->
                        let {
                          sigma = grd_subst u v;
                          cu = capI r (subst_apply_term u sigma);
                          cv = capI r (subst_apply_term v sigma);
                        } in check (is_none (mergea cu cv))
                               (shows_prec_list Zero_nat
                                  ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't',
                                    ' ', 'i', 'n', 'f', 'e', 'r', ' ', 't', 'h',
                                    'a', 't', ' '] .
                                 shows_prec_term Zero_nat u .
                                   shows_prec_list Zero_nat
                                     [' ', 'a', 'n', 'd', ' '] .
                                     shows_prec_term Zero_nat v .
                                       shows_prec_list Zero_nat
 [' ', 'a', 'r', 'e', ' ', 'n', 'o', 't', ' ', 'j', 'o', 'i', 'n', 'a', 'b',
   'l', 'e']);
                    })));

check_ncr_proof ::
  forall a b c.
    (Countable b, Eq b, Key b,
      Showa b) => Bool ->
                    ([Prelude.Char] -> [Prelude.Char]) ->
                      Tp_ops_ext a (Lab b [Nat]) [Prelude.Char] () ->
                        Dpp_ops_ext c (Lab b [Nat]) [Prelude.Char] () ->
                          [(Term (Lab b [Nat]) [Prelude.Char],
                             Term (Lab b [Nat]) [Prelude.Char])] ->
                            Ncr_proof b [Nat] [Prelude.Char] ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_ncr_proof a ia i j r (SN_NWCR prf) =
  debug (ia []) ['S', 'N', '_', 'N', 'W', 'C', 'R']
    (let {
       tp = mka i False [] r [];
     } in bindb (catcha
                  (check_trs_termination_proof a (ia . shows_string ['.', '1'])
                    i j tp prf)
                  (\ x ->
                    Inl (ia . shows_string
                                [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b',
                                  'e', 'l', 'o', 'w', ' ', 's', 't', 'r', 'o',
                                  'n', 'g', ' ', 'n', 'o', 'r', 'm', 'a', 'l',
                                  'i', 'z', 'a', 't', 'i', 'o', 'n', ' ', '+',
                                  ' ', 'w', 'c', 'r'] .
                                shows_nl . indent x)))
            (\ _ ->
              catcha
                (check
                  (not (isOK (check_critical_pairs_NF r
                               (critical_pairs_impl r r))))
                  (shows_prec_list Zero_nat
                    ['a', 'l', 'l', ' ', 'c', 'r', 'i', 't', 'i', 'c', 'a', 'l',
                      ' ', 'p', 'a', 'i', 'r', 's', ' ', 'a', 'r', 'e', ' ',
                      'j', 'o', 'i', 'n', 'a', 'b', 'l', 'e']))
                (\ x ->
                  Inl (ia . shows_prec_list Zero_nat
                              ['e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e', 'n',
                                ' ', 'd', 'i', 's', 'p', 'r', 'o', 'v', 'i',
                                'n', 'g', ' ', 'l', 'o', 'c', 'a', 'l', ' ',
                                'c', 'o', 'n', 'f', 'l', 'u', 'e', 'n', 'c',
                                'e', ' ', 'o', 'f', ' '] .
                              shows_tp (shows_prec_lab Zero_nat)
                                (shows_prec_list Zero_nat) i tp .
                                shows_nl . indent x))));
check_ncr_proof a ia i j r (Non_Join s seq1 seq2 prf) =
  debug (ia []) ['N', 'o', 'n', '_', 'J', 'o', 'i', 'n']
    (catcha (check_non_join r s seq1 seq2 prf)
      (\ x ->
        Inl (ia . shows_prec_list Zero_nat
                    ['e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e', 'n', ' ', 'd',
                      'i', 's', 'p', 'r', 'o', 'v', 'i', 'n', 'g', ' ', 'C',
                      'R', ' ', 'o', 'f', ' '] .
                    shows_trs (shows_prec_lab Zero_nat)
                      (shows_prec_list Zero_nat)
                      ['r', 'e', 'w', 'r', 'i', 't', 'e', ' ', 's', 'y', 's',
                        't', 'e', 'm', ':']
                      [' ', '-', '>', ' '] r .
                      shows_nl . indent x)));

conflicts ::
  forall a b.
    (Eq a,
      Eq b) => (a -> Term b a) ->
                 (Term b a, (Term b a, Nat)) -> [(Term b a, (Term b a, Nat))];
conflicts mu (Fun f ts, (Fun g ss, n)) =
  (if f == g && equal_nat (size_list ts) (size_list ss)
    then concatMap (\ (s, t) -> conflicts mu (s, (t, n))) (zip ts ss)
    else [(Fun f ts, (Fun g ss, n))]);
conflicts mu (Var x, (Fun g ss, n)) = [(Var x, (Fun g ss, n))];
conflicts mu (Fun f ts, (Var y, n)) =
  (if equal_nat n Zero_nat then [(Var y, (Fun f ts, Zero_nat))]
    else conflicts mu (Fun f ts, (mu y, minus_nat n (Nat_of_num One))));
conflicts mu (Var x, (Var y, n)) =
  (if equal_nat n Zero_nat
    then (if x == y then [] else [(Var x, (Var y, Zero_nat))])
    else conflicts mu (Var x, (mu y, minus_nat n (Nat_of_num One))));

si_v_incr :: forall a b. Subst_incr a b -> Set b;
si_v_incr x = fst (snd (rep_subst_incr x));

vars_subst_impl :: forall a b. (Eq a, Eq b) => [(a, Term b a)] -> [a];
vars_subst_impl sigma =
  let {
    sigmaa = mk_subst_domain sigma;
  } in map fst sigmaa ++ concatMap (vars_term_lista . snd) sigmaa;

corder_ctxt ::
  forall a b.
    (Eq a, Linorder a, Eq b,
      Linorder b) => Maybe (Ctxt a b -> Ctxt a b -> Bool,
                             Ctxt a b -> Ctxt a b -> Bool);
corder_ctxt =
  Just ((\ x y ->
          ctxt_rec (\ a -> (case a of {
                             Hole -> False;
                             More _ _ _ _ -> True;
                           }))
            (\ x_0 x_1 x_2 x_3 res_0 a ->
              (case a of {
                Hole -> False;
                More y_0 y_1 y_2 y_3 ->
                  less x_0 y_0 ||
                    x_0 == y_0 &&
                      (less_list x_1 y_1 ||
                        x_1 == y_1 &&
                          (res_0 y_2 ||
                            equal_ctxt x_2 y_2 && less_list x_3 y_3));
              }))
            x y ||
            equal_ctxt x y),
         ctxt_rec (\ a -> (case a of {
                            Hole -> False;
                            More _ _ _ _ -> True;
                          }))
           (\ x_0 x_1 x_2 x_3 res_0 a ->
             (case a of {
               Hole -> False;
               More y_0 y_1 y_2 y_3 ->
                 less x_0 y_0 ||
                   x_0 == y_0 &&
                     (less_list x_1 y_1 ||
                       x_1 == y_1 &&
                         (res_0 y_2 ||
                           equal_ctxt x_2 y_2 && less_list x_3 y_3));
             })));

instance (Eq a, Linorder a, Eq b, Linorder b) => Corder (Ctxt a b) where {
  corder = corder_ctxt;
};

n0 :: Pos -> Pos -> Pos -> Nat;
n0 p q oo =
  nat (ceiling
        (divide_rat (of_nat (minus_nat (size_pos oo) (size_pos q)))
          (of_nat (size_pos p))));

show_pat_term ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => (Term a b, ([(b, Term a b)], [(b, Term a b)])) ->
                    [Prelude.Char] -> [Prelude.Char];
show_pat_term p =
  let {
    (s, (sigma, tau)) = p;
  } in shows_prec_prod Zero_nat
         (s, (mk_subst_domain sigma, mk_subst_domain tau));

show_pat_rule ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => ((Term a b, ([(b, Term a b)], [(b, Term a b)])),
                    ((Term a b, ([(b, Term a b)], [(b, Term a b)])), Bool)) ->
                    [Prelude.Char] -> [Prelude.Char];
show_pat_rule pr =
  let {
    (p1, (p2, _)) = pr;
  } in show_pat_term p1 .
         shows_string [' ', '-', '-', '>', ' '] . show_pat_term p2;

bounded_postfixes :: Pos -> [Pos] -> [Pos];
bounded_postfixes p ps =
  map_filter (\ x -> (if not (is_none x) then Just (the x) else Nothing))
    (map (pos_prefix p) ps);

rel_rules_of ::
  forall a b. Maybe [(Term a b, Term a b)] -> [(Term a b, Term a b)];
rel_rules_of Nothing = [];
rel_rules_of (Just r) = r;

subst_power_impl ::
  forall a b. (Eq a, Eq b) => [(a, Term b a)] -> Nat -> [(a, Term b a)];
subst_power_impl sigma n =
  (if equal_nat n Zero_nat then []
    else subst_compose_impl sigma
           (subst_power_impl sigma (minus_nat n (Nat_of_num One))));

newtype Tp a b = Tp
  (Bool,
    ([Term a b],
      (Bool,
        ([(Term a b, Term a b)],
          ([(Term a b, Term a b)],
            Rbt (a, Nat) [(Bool, (Term a b, Term a b))])))));

impl_ofb ::
  forall a b.
    (Key a,
      Key b) => Tp a b ->
                  (Bool,
                    ([Term a b],
                      (Bool,
                        ([(Term a b, Term a b)],
                          ([(Term a b, Term a b)],
                            Rbt (a, Nat) [(Bool, (Term a b, Term a b))])))));
impl_ofb (Tp x) = x;

q_impl ::
  forall a b.
    (Bool,
      ([Term a b],
        (Bool,
          ([(Term a b, Term a b)],
            ([(Term a b, Term a b)],
              Rbt (a, Nat) [(Bool, (Term a b, Term a b))]))))) ->
      [Term a b];
q_impl (uu, (q, uv)) = q;

q :: forall a b. (Key a, Key b) => Tp a b -> [Term a b];
q tp = q_impl (impl_ofb tp);

r_impl ::
  forall a b.
    (Eq a,
      Linorder a) => (Bool,
                       ([Term a b],
                         (Bool,
                           ([(Term a b, Term a b)],
                             ([(Term a b, Term a b)],
                               Rbt (a, Nat)
                                 [(Bool, (Term a b, Term a b))]))))) ->
                       [(Term a b, Term a b)];
r_impl (uu, (uv, (uw, (vR, (ux, m))))) = vR ++ rules_with id m;

r :: forall a b. (Eq a, Key a, Key b) => Tp a b -> [(Term a b, Term a b)];
r tp = r_impl (impl_ofb tp);

xml2outermost_nontermination_proof ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          (Outermost_nontermination_proof a [Prelude.Char]);
xml2outermost_nontermination_proof xml2name x =
  singleton
    ['t', 'r', 's', 'N', 'o', 'n', 't', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i',
      'o', 'n', 'P', 'r', 'o', 'o', 'f']
    (options
      [(['l', 'o', 'o', 'p'],
         change (loop xml2name)
           (\ (s, (rseq, (a, b))) ->
             OTRS_Loop s (map (\ (xa, (y, (_, z))) -> (xa, (y, z))) rseq) a b)),
        (['r', 'u', 'l', 'e', 'R', 'e', 'm', 'o', 'v', 'a', 'l'],
          pair ['r', 'u', 'l', 'e', 'R', 'e', 'm', 'o', 'v', 'a', 'l']
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (xml2outermost_nontermination_proof xml2name) OTRS_Rule_Removal)])
    id x;

xml2dp_nontermination_proof ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Dp_nontermination_proof a [Prelude.Char]);
xml2dp_nontermination_proof xml2name x =
  singleton
    ['d', 'p', 'N', 'o', 'n', 't', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i', 'o',
      'n', 'P', 'r', 'o', 'o', 'f']
    (options
      [(['d', 'p', 'R', 'u', 'l', 'e', 'R', 'e', 'm', 'o', 'v', 'a', 'l'],
         choice
           ['d', 'p', 'R', 'u', 'l', 'e', 'R', 'e', 'm', 'o', 'v', 'a', 'l']
           [triple
              ['d', 'p', 'R', 'u', 'l', 'e', 'R', 'e', 'm', 'o', 'v', 'a', 'l']
              (singleton ['d', 'p', 's'] (rules xml2name) Just)
              (singleton ['t', 'r', 's'] (rules xml2name) Just)
              (xml2dp_nontermination_proof xml2name) DP_Rule_Removal,
             pair ['d', 'p', 'R', 'u', 'l', 'e', 'R', 'e', 'm', 'o', 'v', 'a',
                    'l']
               (singleton ['t', 'r', 's'] (rules xml2name) Just)
               (xml2dp_nontermination_proof xml2name) (DP_Rule_Removal Nothing),
             pair ['d', 'p', 'R', 'u', 'l', 'e', 'R', 'e', 'm', 'o', 'v', 'a',
                    'l']
               (singleton ['d', 'p', 's'] (rules xml2name) Just)
               (xml2dp_nontermination_proof xml2name)
               (\ p -> DP_Rule_Removal p Nothing)]),
        (['l', 'o', 'o', 'p'],
          change (loop xml2name) (\ (s, (rseq, (a, b))) -> DP_Loop s rseq a b)),
        (['n', 'o', 'n', 'L', 'o', 'o', 'p'],
          change (nonloop xml2name) DP_Nonloop),
        (['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't', 'L', 'h', 's', 's', 'R',
           'e', 'm', 'o', 'v', 'a', 'l', 'P', 'r', 'o', 'c'],
          pair ['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't', 'L', 'h', 's', 's',
                 'R', 'e', 'm', 'o', 'v', 'a', 'l', 'P', 'r', 'o', 'c']
            (innermostLhss xml2name) (xml2dp_nontermination_proof xml2name)
            DP_Q_Reduction),
        (['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't', 'L', 'h', 's', 's', 'I',
           'n', 'c', 'r', 'e', 'a', 's', 'e', 'P', 'r', 'o', 'c'],
          pair ['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't', 'L', 'h', 's', 's',
                 'I', 'n', 'c', 'r', 'e', 'a', 's', 'e', 'P', 'r', 'o', 'c']
            (innermostLhss xml2name) (xml2dp_nontermination_proof xml2name)
            DP_Q_Increase),
        (['i', 'n', 's', 't', 'a', 'n', 't', 'i', 'a', 't', 'i', 'o', 'n', 'P',
           'r', 'o', 'c'],
          pair ['i', 'n', 's', 't', 'a', 'n', 't', 'i', 'a', 't', 'i', 'o', 'n',
                 'P', 'r', 'o', 'c']
            (singleton ['d', 'p', 's'] (rules xml2name) id)
            (xml2dp_nontermination_proof xml2name) DP_Instantiation),
        (['n', 'a', 'r', 'r', 'o', 'w', 'i', 'n', 'g', 'P', 'r', 'o', 'c'],
          tuple4
            ['n', 'a', 'r', 'r', 'o', 'w', 'i', 'n', 'g', 'P', 'r', 'o', 'c']
            (rule xml2name) pos
            (singleton ['n', 'a', 'r', 'r', 'o', 'w', 'i', 'n', 'g', 's']
              (rules xml2name) id)
            (xml2dp_nontermination_proof xml2name) DP_Narrowing),
        (['r', 'e', 'w', 'r', 'i', 't', 'i', 'n', 'g', 'P', 'r', 'o', 'c'],
          guard (\ xa -> equal_nat (num_children xa) (Nat_of_num (Bit1 One)))
            (triple
              ['r', 'e', 'w', 'r', 'i', 't', 'i', 'n', 'g', 'P', 'r', 'o', 'c']
              (rule xml2name) (rstep xml2name)
              (xml2dp_nontermination_proof xml2name)
              (\ (s, t) (p, (lr, ta)) ->
                DP_Rewriting Nothing (s, t) (s, ta) (s, ta) lr p))
            (guard
              (\ xa ->
                equal_nat (num_children xa) (Nat_of_num (Bit0 (Bit0 One))))
              (guard
                (\ xa ->
                  tag (nth (children xa) (Nat_of_num (Bit0 One))) ==
                    ['u', 's', 'a', 'b', 'l', 'e', 'R', 'u', 'l', 'e', 's'])
                (tuple4
                  ['r', 'e', 'w', 'r', 'i', 't', 'i', 'n', 'g', 'P', 'r', 'o',
                    'c']
                  (rule xml2name) (rstep xml2name)
                  (singleton
                    ['u', 's', 'a', 'b', 'l', 'e', 'R', 'u', 'l', 'e', 's']
                    (rules xml2name) id)
                  (xml2dp_nontermination_proof xml2name)
                  (\ (s, t) (p, (lr, ta)) u ->
                    DP_Rewriting (Just u) (s, t) (s, ta) (s, ta) lr p))
                (tuple4
                  ['r', 'e', 'w', 'r', 'i', 't', 'i', 'n', 'g', 'P', 'r', 'o',
                    'c']
                  (rule xml2name) (rstep xml2name) (rule xml2name)
                  (xml2dp_nontermination_proof xml2name)
                  (\ (s, t) (p, (lr, ta)) st ->
                    DP_Rewriting Nothing (s, t) (s, ta) st lr p)))
              (tuple5
                ['r', 'e', 'w', 'r', 'i', 't', 'i', 'n', 'g', 'P', 'r', 'o',
                  'c']
                (rule xml2name) (rstep xml2name) (rule xml2name)
                (singleton
                  ['u', 's', 'a', 'b', 'l', 'e', 'R', 'u', 'l', 'e', 's']
                  (rules xml2name) id)
                (xml2dp_nontermination_proof xml2name)
                (\ (s, t) (p, (lr, ta)) st u ->
                  DP_Rewriting (Just u) (s, t) (s, ta) st lr p)))),
        (['s', 'w', 'i', 't', 'c', 'h', 'F', 'u', 'l', 'l', 'S', 't', 'r', 'a',
           't', 'e', 'g', 'y', 'P', 'r', 'o', 'c'],
          pair ['s', 'w', 'i', 't', 'c', 'h', 'F', 'u', 'l', 'l', 'S', 't', 'r',
                 'a', 't', 'e', 'g', 'y', 'P', 'r', 'o', 'c']
            (wcr_proof xml2name) (xml2dp_nontermination_proof xml2name)
            DP_Termination_Switch)])
    id x;

xml2trs_nontermination_proof ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Trs_nontermination_proof a [Prelude.Char]);
xml2trs_nontermination_proof xml2name x =
  singleton
    ['t', 'r', 's', 'N', 'o', 'n', 't', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i',
      'o', 'n', 'P', 'r', 'o', 'o', 'f']
    (options
      [(['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 'C', 'o', 'n', 'd', 'i', 't',
          'i', 'o', 'n', 'V', 'i', 'o', 'l', 'a', 't', 'e', 'd'],
         leaf ['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 'C', 'o', 'n', 'd', 'i',
                't', 'i', 'o', 'n', 'V', 'i', 'o', 'l', 'a', 't', 'e', 'd']
           TRS_Not_Well_Formed),
        (['l', 'o', 'o', 'p'],
          change (loop xml2name)
            (\ (s, (rseq, (a, b))) ->
              TRS_Loop s (map (\ (xa, (y, (_, z))) -> (xa, (y, z))) rseq) a b)),
        (['n', 'o', 'n', 'L', 'o', 'o', 'p'],
          change (nonloop xml2name) TRS_Nonloop),
        (['r', 'u', 'l', 'e', 'R', 'e', 'm', 'o', 'v', 'a', 'l'],
          pair ['r', 'u', 'l', 'e', 'R', 'e', 'm', 'o', 'v', 'a', 'l']
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (xml2trs_nontermination_proof xml2name) TRS_Rule_Removal),
        (['d', 'p', 'T', 'r', 'a', 'n', 's'],
          triple ['d', 'p', 'T', 'r', 'a', 'n', 's']
            (singleton ['d', 'p', 's'] (rules xml2name) id)
            (bool ['m', 'a', 'r', 'k', 'e', 'd', 'S', 'y', 'm', 'b', 'o', 'l',
                    's'])
            (xml2dp_nontermination_proof xml2name) (\ p _ -> TRS_DP_Trans p)),
        (['s', 't', 'r', 'i', 'n', 'g', 'R', 'e', 'v', 'e', 'r', 's', 'a', 'l'],
          pair ['s', 't', 'r', 'i', 'n', 'g', 'R', 'e', 'v', 'e', 'r', 's', 'a',
                 'l']
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (xml2trs_nontermination_proof xml2name)
            (\ _ -> TRS_String_Reversal)),
        (['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't', 'L', 'h', 's', 's', 'I',
           'n', 'c', 'r', 'e', 'a', 's', 'e'],
          pair ['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't', 'L', 'h', 's', 's',
                 'I', 'n', 'c', 'r', 'e', 'a', 's', 'e']
            (innermostLhss xml2name) (xml2trs_nontermination_proof xml2name)
            TRS_Q_Increase)])
    id x;

xml2reltrs_nontermination_proof ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char] (Reltrs_nontermination_proof a [Prelude.Char]);
xml2reltrs_nontermination_proof xml2name x =
  singleton
    ['r', 'e', 'l', 'a', 't', 'i', 'v', 'e', 'N', 'o', 'n', 't', 'e', 'r', 'm',
      'i', 'n', 'a', 't', 'i', 'o', 'n', 'P', 'r', 'o', 'o', 'f']
    (options
      [(['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 'C', 'o', 'n', 'd', 'i', 't',
          'i', 'o', 'n', 'V', 'i', 'o', 'l', 'a', 't', 'e', 'd'],
         leaf ['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 'C', 'o', 'n', 'd', 'i',
                't', 'i', 'o', 'n', 'V', 'i', 'o', 'l', 'a', 't', 'e', 'd']
           Rel_Not_Well_Formed),
        (['l', 'o', 'o', 'p'],
          change (loop xml2name)
            (\ (s, (rseq, (a, b))) -> Rel_Loop s rseq a b)),
        (['t', 'r', 's', 'N', 'o', 'n', 't', 'e', 'r', 'm', 'i', 'n', 'a', 't',
           'i', 'o', 'n', 'P', 'r', 'o', 'o', 'f'],
          change (xml2trs_nontermination_proof xml2name) Rel_R_Not_SN),
        (['r', 'u', 'l', 'e', 'R', 'e', 'm', 'o', 'v', 'a', 'l'],
          triple ['r', 'u', 'l', 'e', 'R', 'e', 'm', 'o', 'v', 'a', 'l']
            (singleton ['t', 'r', 's'] (rules xml2name) Just)
            (singleton ['t', 'r', 's'] (rules xml2name) Just)
            (xml2reltrs_nontermination_proof xml2name) Rel_Rule_Removal)])
    id x;

xml2reltrs_termination_proof ::
  forall a.
    (Eq a,
      Key a) => (Xml -> Sum_bot [Prelude.Char] (Lab a [Nat])) ->
                  Xml ->
                    Sum_bot [Prelude.Char]
                      (Trs_termination_proof a [Nat] [Prelude.Char]);
xml2reltrs_termination_proof xml2name x =
  singleton
    ['r', 'e', 'l', 'a', 't', 'i', 'v', 'e', 'T', 'e', 'r', 'm', 'i', 'n', 'a',
      't', 'i', 'o', 'n', 'P', 'r', 'o', 'o', 'f']
    (options
      [(['r', 'I', 's', 'E', 'm', 'p', 't', 'y'],
         leaf ['r', 'I', 's', 'E', 'm', 'p', 't', 'y'] R_is_Empty),
        (['s', 'I', 's', 'E', 'm', 'p', 't', 'y'],
          singleton ['s', 'I', 's', 'E', 'm', 'p', 't', 'y']
            (xml2trs_termination_proof xml2name) id),
        (['r', 'u', 'l', 'e', 'R', 'e', 'm', 'o', 'v', 'a', 'l'],
          tuple4 ['r', 'u', 'l', 'e', 'R', 'e', 'm', 'o', 'v', 'a', 'l']
            (ordering_constraint_proofa False xml2name)
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (xml2reltrs_termination_proof xml2name)
            (\ rp one two -> Rule_Removal rp (one ++ two))),
        (['s', 'e', 'm', 'l', 'a', 'b'],
          guard (\ xa ->
                  equal_nat (num_children xa) (Nat_of_num (Bit0 (Bit0 One))))
            (tuple4 ['s', 'e', 'm', 'l', 'a', 'b'] (sl_variant xml2name)
              (singleton ['t', 'r', 's'] (rules xml2name) id)
              (singleton ['t', 'r', 's'] (rules xml2name) id)
              (xml2reltrs_termination_proof xml2name)
              (\ sli lr lrw -> Semlab sli [] (lr ++ lrw)))
            (tuple5 ['s', 'e', 'm', 'l', 'a', 'b'] (sl_variant xml2name)
              (singleton ['t', 'r', 's'] (rules xml2name) id)
              (singleton ['t', 'r', 's'] (rules xml2name) id)
              (innermostLhss xml2name) (xml2reltrs_termination_proof xml2name)
              (\ sli lr lrw lq -> Semlab sli lq (lr ++ lrw)))),
        (['u', 'n', 'c', 'u', 'r', 'r', 'y'],
          tuple4 ['u', 'n', 'c', 'u', 'r', 'r', 'y'] (uncurry_info xml2name)
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (xml2reltrs_termination_proof xml2name)
            (\ i r s -> Uncurry i (r ++ s))),
        (['s', 't', 'r', 'i', 'n', 'g', 'R', 'e', 'v', 'e', 'r', 's', 'a', 'l'],
          triple
            ['s', 't', 'r', 'i', 'n', 'g', 'R', 'e', 'v', 'e', 'r', 's', 'a',
              'l']
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (xml2reltrs_termination_proof xml2name) (\ _ _ -> String_Reversal)),
        (['e', 'q', 'u', 'a', 'l', 'i', 't', 'y', 'R', 'e', 'm', 'o', 'v', 'a',
           'l'],
          singleton
            ['e', 'q', 'u', 'a', 'l', 'i', 't', 'y', 'R', 'e', 'm', 'o', 'v',
              'a', 'l']
            (xml2reltrs_termination_proof xml2name) Drop_Equality),
        (['r', 'e', 'l', 'a', 't', 'i', 'v', 'e', 'T', 'e', 'r', 'm', 'i', 'n',
           'a', 't', 'i', 'o', 'n', 'A', 's', 's', 'u', 'm', 'p', 't', 'i', 'o',
           'n'],
          singleton
            ['r', 'e', 'l', 'a', 't', 'i', 'v', 'e', 'T', 'e', 'r', 'm', 'i',
              'n', 'a', 't', 'i', 'o', 'n', 'A', 's', 's', 'u', 'm', 'p', 't',
              'i', 'o', 'n']
            (xml1to2elements ['t', 'r', 's', 'I', 'n', 'p', 'u', 't']
              (singleton ['t', 'r', 's'] (rules xml2name) id)
              (singleton
                ['r', 'e', 'l', 'a', 't', 'i', 'v', 'e', 'R', 'u', 'l', 'e',
                  's']
                (rules xml2name) id)
              (\ r a ->
                (case a of {
                  Nothing -> Assume_SN (False, ([], (r, []))) [];
                  Just rw -> Assume_SN (False, ([], (r, rw))) [];
                })))
            id)])
    id x;

xml2fp_nontermination_proof ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Fp_nontermination_proof a [Prelude.Char]);
xml2fp_nontermination_proof xml2name x =
  singleton
    ['t', 'r', 's', 'N', 'o', 'n', 't', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i',
      'o', 'n', 'P', 'r', 'o', 'o', 'f']
    (options
      [(['l', 'o', 'o', 'p'],
         change (loop xml2name)
           (\ (s, (rseq, (a, b))) ->
             FPTRS_Loop s (map (\ (xa, (y, (_, z))) -> (xa, (y, z))) rseq) a
               b))])
    id x;

xml2quasi_reductive_proof ::
  forall a.
    (Eq a,
      Key a) => (Xml -> Sum_bot [Prelude.Char] (Lab a [Nat])) ->
                  Xml ->
                    Sum_bot [Prelude.Char]
                      (Quasi_reductive_proof a [Nat] [Prelude.Char]);
xml2quasi_reductive_proof xml2name =
  singleton
    ['q', 'u', 'a', 's', 'i', 'R', 'e', 'd', 'u', 'c', 't', 'i', 'v', 'e', 'P',
      'r', 'o', 'o', 'f']
    (options
      [(['u', 'n', 'r', 'a', 'v', 'e', 'l', 'i', 'n', 'g'],
         pair ['u', 'n', 'r', 'a', 'v', 'e', 'l', 'i', 'n', 'g']
           (many ['u', 'n', 'r', 'a', 'v', 'e', 'l', 'i', 'n', 'g', 'I', 'n',
                   'f', 'o', 'r', 'm', 'a', 't', 'i', 'o', 'n']
             (many1
               ['u', 'n', 'r', 'a', 'v', 'e', 'l', 'i', 'n', 'g', 'E', 'n', 't',
                 'r', 'y']
               (crule xml2name) (rule xml2name) (\ a b -> (a, b)))
             id)
           (xml2trs_termination_proof xml2name) Unravel)])
    id;

subsumption_proof ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml ->
        Sum_bot [Prelude.Char]
          [((Term a [Prelude.Char], Term a [Prelude.Char]),
             [(Pos, ((Term a [Prelude.Char], Term a [Prelude.Char]),
                      (Bool, Term a [Prelude.Char])))])];
subsumption_proof xml2name =
  many ['s', 'u', 'b', 's', 'u', 'm', 'p', 't', 'i', 'o', 'n', 'P', 'r', 'o',
         'o', 'f']
    (pair ['r', 'u', 'l', 'e', 'S', 'u', 'b', 's', 'u', 'm', 'p', 't', 'i', 'o',
            'n', 'P', 'r', 'o', 'o', 'f']
      (rule xml2name) (conversion xml2name) (\ a b -> (a, b)))
    id;

xml2completion_proof ::
  forall a.
    (Eq a,
      Key a) => (Xml -> Sum_bot [Prelude.Char] (Lab a [Nat])) ->
                  Xml ->
                    Sum_bot [Prelude.Char]
                      (Completion_proof a [Nat] [Prelude.Char]);
xml2completion_proof xml2name =
  triple
    ['c', 'o', 'm', 'p', 'l', 'e', 't', 'i', 'o', 'n', 'P', 'r', 'o', 'o', 'f']
    (wcr_proof xml2name) (xml2trs_termination_proof xml2name)
    (xml1to2elements
      ['e', 'q', 'u', 'i', 'v', 'a', 'l', 'e', 'n', 'c', 'e', 'P', 'r', 'o',
        'o', 'f']
      (subsumption_proof xml2name) (subsumption_proof xml2name)
      (\ a b -> (a, b)))
    (\ w t (a, b) -> SN_WCR_Eq w t a b);

xml2equational_disproof ::
  forall a.
    (Eq a,
      Key a) => (Xml -> Sum_bot [Prelude.Char] (Lab a [Nat])) ->
                  Xml ->
                    Sum_bot [Prelude.Char]
                      (Equational_disproof a [Nat] [Prelude.Char]);
xml2equational_disproof xml2name =
  singleton
    ['e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 'a', 'l', 'D', 'i', 's', 'p', 'r',
      'o', 'o', 'f']
    (options
      [(['c', 'o', 'm', 'p', 'l', 'e', 't', 'i', 'o', 'n', 'A', 'n', 'd', 'N',
          'o', 'r', 'm', 'a', 'l', 'i', 'z', 'a', 't', 'i', 'o', 'n'],
         pair ['c', 'o', 'm', 'p', 'l', 'e', 't', 'i', 'o', 'n', 'A', 'n', 'd',
                'N', 'o', 'r', 'm', 'a', 'l', 'i', 'z', 'a', 't', 'i', 'o', 'n']
           (singleton ['t', 'r', 's'] (rules xml2name) id)
           (xml2completion_proof xml2name)
           Completion_and_Normalization_Different)])
    id;

xml2equational_proof ::
  forall a.
    (Eq a,
      Key a) => (Xml -> Sum_bot [Prelude.Char] (Lab a [Nat])) ->
                  Xml ->
                    Sum_bot [Prelude.Char]
                      (Equational_proof a [Nat] [Prelude.Char]);
xml2equational_proof xml2name =
  singleton
    ['e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 'a', 'l', 'P', 'r', 'o', 'o', 'f']
    (options
      [(['e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 'a', 'l', 'P', 'r', 'o', 'o',
          'f', 'T', 'r', 'e', 'e'],
         singleton
           ['e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 'a', 'l', 'P', 'r', 'o',
             'o', 'f', 'T', 'r', 'e', 'e']
           (xml2eq_proof xml2name) Equational_Proof_Tree),
        (['c', 'o', 'n', 'v', 'e', 'r', 's', 'i', 'o', 'n'],
          change (conversion xml2name) Conversion),
        (['c', 'o', 'm', 'p', 'l', 'e', 't', 'i', 'o', 'n', 'A', 'n', 'd', 'N',
           'o', 'r', 'm', 'a', 'l', 'i', 'z', 'a', 't', 'i', 'o', 'n'],
          pair ['c', 'o', 'm', 'p', 'l', 'e', 't', 'i', 'o', 'n', 'A', 'n', 'd',
                 'N', 'o', 'r', 'm', 'a', 'l', 'i', 'z', 'a', 't', 'i', 'o',
                 'n']
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (xml2completion_proof xml2name) Completion_and_Normalization)])
    id;

xml2complexity_proof ::
  forall a.
    (Xml -> Sum_bot [Prelude.Char] a) ->
      Xml -> Sum_bot [Prelude.Char] (Complexity_proof a [Prelude.Char]);
xml2complexity_proof xml2name x =
  singleton
    ['c', 'o', 'm', 'p', 'l', 'e', 'x', 'i', 't', 'y', 'P', 'r', 'o', 'o', 'f']
    (options
      [(['r', 'u', 'l', 'e', 'S', 'h', 'i', 'f', 't', 'i', 'n', 'g'],
         triple ['r', 'u', 'l', 'e', 'S', 'h', 'i', 'f', 't', 'i', 'n', 'g']
           (ordering_constraint_proofa False xml2name)
           (singleton ['t', 'r', 's'] (rules xml2name) id)
           (xml2complexity_proof xml2name) Rule_Shift_Complexity),
        (['r', 'e', 'm', 'o', 'v', 'e', 'N', 'o', 'n', 'A', 'p', 'p', 'l', 'i',
           'c', 'a', 'b', 'l', 'e', 'R', 'u', 'l', 'e', 's'],
          pair ['r', 'e', 'm', 'o', 'v', 'e', 'N', 'o', 'n', 'A', 'p', 'p', 'l',
                 'i', 'c', 'a', 'b', 'l', 'e', 'R', 'u', 'l', 'e', 's']
            (singleton ['t', 'r', 's'] (rules xml2name) id)
            (xml2complexity_proof xml2name)
            Remove_Nonapplicable_Rules_Complexity),
        (['r', 'I', 's', 'E', 'm', 'p', 't', 'y'],
          leaf ['r', 'I', 's', 'E', 'm', 'p', 't', 'y'] RisEmpty_Complexity)])
    id x;

xml2cert_problem ::
  (Xml -> Sum_bot [Prelude.Char] [Prelude.Char]) ->
    (Xml -> Sum_bot [Prelude.Char] (Lab [Prelude.Char] [Nat])) ->
      Xml ->
        Sum_bot [Prelude.Char]
          (Cert_problem [Prelude.Char] [Nat] [Prelude.Char]);
xml2cert_problem xml2uname xml2name (Xml name egal cs texta) =
  (if name ==
        ['c', 'e', 'r', 't', 'i', 'f', 'i', 'c', 'a', 't', 'i', 'o', 'n', 'P',
          'r', 'o', 'b', 'l', 'e', 'm'] &&
        is_none texta && less_eq_nat (Nat_of_num (Bit1 One)) (size_list cs)
    then binda (xml2input xml2name (nth cs Zero_nat))
           (\ inp ->
             binda (text ['c', 'p', 'f', 'V', 'e', 'r', 's', 'i', 'o', 'n']
                     (nth cs (Nat_of_num One)))
               (\ _ ->
                 (case inp of {
                   DP_input (m, (p, (q, r))) ->
                     singleton ['p', 'r', 'o', 'o', 'f']
                       (options
                         [(['d', 'p', 'P', 'r', 'o', 'o', 'f'],
                            change (xml2dp_termination_proof xml2name)
                              (DP_Termination_Proof False m p [] q [] r)),
                           (['d', 'p', 'N', 'o', 'n', 't', 'e', 'r', 'm', 'i',
                              'n', 'a', 't', 'i', 'o', 'n', 'P', 'r', 'o', 'o',
                              'f'],
                             change (xml2dp_nontermination_proof xml2name)
                               (DP_Nontermination_Proof False m p q r))])
                       id (nth cs (Nat_of_num (Bit0 One)));
                   TRS_input (q, (r, Nothing)) ->
                     singleton ['p', 'r', 'o', 'o', 'f']
                       (options
                         [(['t', 'r', 's', 'T', 'e', 'r', 'm', 'i', 'n', 'a',
                             't', 'i', 'o', 'n', 'P', 'r', 'o', 'o', 'f'],
                            change (xml2trs_termination_proof xml2name)
                              (TRS_Termination_Proof False q r Nothing)),
                           (['c', 'r', 'P', 'r', 'o', 'o', 'f'],
                             (if null (strategy_to_Q q r)
                               then change (xml2cr_proof xml2name)
                                      (TRS_Confluence_Proof False r)
                               else (\ _ ->
                                      errora
['s', 't', 'r', 'a', 't', 'e', 'g', 'i', 'e', 's', ' ', 'f', 'o', 'r', ' ', 'c',
  'o', 'n', 'f', 'l', 'u', 'e', 'n', 'c', 'e', ' ', 'u', 'n', 's', 'u', 'p',
  'p', 'o', 'r', 't', 'e', 'd']))),
                           (['c', 'r', 'D', 'i', 's', 'p', 'r', 'o', 'o', 'f'],
                             (if null (strategy_to_Q q r)
                               then change (xml2ncr_proof xml2name)
                                      (TRS_Non_Confluence_Proof False r)
                               else (\ _ ->
                                      errora
['s', 't', 'r', 'a', 't', 'e', 'g', 'i', 'e', 's', ' ', 'f', 'o', 'r', ' ', 'c',
  'o', 'n', 'f', 'l', 'u', 'e', 'n', 'c', 'e', ' ', 'u', 'n', 's', 'u', 'p',
  'p', 'o', 'r', 't', 'e', 'd']))),
                           (['t', 'r', 's', 'N', 'o', 'n', 't', 'e', 'r', 'm',
                              'i', 'n', 'a', 't', 'i', 'o', 'n', 'P', 'r', 'o',
                              'o', 'f'],
                             change (xml2trs_nontermination_proof xml2name)
                               (TRS_Nontermination_Proof False q r))])
                       id (nth cs (Nat_of_num (Bit0 One)));
                   TRS_input (q, (r, Just s)) ->
                     singleton ['p', 'r', 'o', 'o', 'f']
                       (options
                         [(['r', 'e', 'l', 'a', 't', 'i', 'v', 'e', 'T', 'e',
                             'r', 'm', 'i', 'n', 'a', 't', 'i', 'o', 'n', 'P',
                             'r', 'o', 'o', 'f'],
                            change (xml2reltrs_termination_proof xml2name)
                              (TRS_Termination_Proof False q r (Just s))),
                           (['r', 'e', 'l', 'a', 't', 'i', 'v', 'e', 'N', 'o',
                              'n', 't', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i',
                              'o', 'n', 'P', 'r', 'o', 'o', 'f'],
                             change (xml2reltrs_nontermination_proof xml2name)
                               (Relative_TRS_Nontermination_Proof False q r
                                 s))])
                       id (nth cs (Nat_of_num (Bit0 One)));
                   COMP_input (e, r) ->
                     singleton ['p', 'r', 'o', 'o', 'f']
                       (options
                         [(['c', 'o', 'm', 'p', 'l', 'e', 't', 'i', 'o', 'n',
                             'P', 'r', 'o', 'o', 'f'],
                            change (xml2completion_proof xml2name)
                              (Completion_Proof e r))])
                       id (nth cs (Nat_of_num (Bit0 One)));
                   EQ_input (eqs, eq) ->
                     singleton ['p', 'r', 'o', 'o', 'f']
                       (options
                         [(['e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 'a', 'l',
                             'P', 'r', 'o', 'o', 'f'],
                            change (xml2equational_proof xml2name)
                              (Equational_Proof eqs eq)),
                           (['e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 'a', 'l',
                              'D', 'i', 's', 'p', 'r', 'o', 'o', 'f'],
                             change (xml2equational_disproof xml2name)
                               (Equational_Disproof eqs eq))])
                       id (nth cs (Nat_of_num (Bit0 One)));
                   CPX_input (q, (r, (s, (cm, cc)))) ->
                     singleton ['p', 'r', 'o', 'o', 'f']
                       (change (xml2complexity_proof xml2name)
                         (Complexity_Proof q r s cm cc))
                       id (nth cs (Nat_of_num (Bit0 One)));
                   OTRS_input (q, r) ->
                     singleton ['p', 'r', 'o', 'o', 'f']
                       (change (xml2outermost_nontermination_proof xml2name)
                         (Outermost_Nontermination_Proof q r))
                       id (nth cs (Nat_of_num (Bit0 One)));
                   FPTRS_input (r, p) ->
                     singleton ['p', 'r', 'o', 'o', 'f']
                       (change (xml2fp_nontermination_proof xml2name)
                         (FP_Nontermination_Proof p r))
                       id (nth cs (Nat_of_num (Bit0 One)));
                   CTRS_input ctrs ->
                     singleton ['p', 'r', 'o', 'o', 'f']
                       (change (xml2quasi_reductive_proof xml2name)
                         (Quasi_Reductive_Proof ctrs))
                       id (nth cs (Nat_of_num (Bit0 One)));
                 })))
    else errora
           (['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'p', 'a', 'r',
              's', 'e', ' ', 'r', 'o', 'o', 't', ' ', 'e', 'l', 'e', 'm', 'e',
              'n', 't', ' ', '<'] ++
             name ++ ['>']));

xml_complexity_measure ::
  forall a b c. (Showa a, Showa b) => Complexity_measure (Lab a [b]) c -> Xml;
xml_complexity_measure (Derivational_Complexity f) =
  Xml ['d', 'e', 'r', 'i', 'v', 'a', 't', 'i', 'o', 'n', 'a', 'l', 'C', 'o',
        'm', 'p', 'l', 'e', 'x', 'i', 't', 'y']
    [] [xml_signature f] Nothing;
xml_complexity_measure (Runtime_Complexity c d) =
  Xml ['r', 'u', 'n', 't', 'i', 'm', 'e', 'C', 'o', 'm', 'p', 'l', 'e', 'x',
        'i', 't', 'y']
    [] [xml_signature c, xml_signature d] Nothing;

xml_complexity_class :: Complexity_class -> Xml;
xml_complexity_class (Comp_Poly n) =
  Xml ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l'] [] []
    (Just (shows_prec_nat Zero_nat n []));

xml_forbidden_pattern ::
  forall a b c.
    (Showa a, Showa b,
      Showa c) => (Ctxt (Lab a [b]) c, (Term (Lab a [b]) c, Location)) -> Xml;
xml_forbidden_pattern =
  (\ (c, (t, l)) ->
    Xml ['f', 'o', 'r', 'b', 'i', 'd', 'd', 'e', 'n', 'P', 'a', 't', 't', 'e',
          'r', 'n']
      [] [xml_term (ctxt_apply c t), xml_pos (hole_pos c),
           (case l of {
             H -> Xml ['h', 'e', 'r', 'e'] [] [] Nothing;
             A -> Xml ['a', 'b', 'o', 'v', 'e'] [] [] Nothing;
             Ba -> Xml ['b', 'e', 'l', 'o', 'w'] [] [] Nothing;
           })]
      Nothing);

xml_fp_trs_input ::
  forall a b c.
    (Showa a, Showa b,
      Showa c) => [(Ctxt (Lab a [b]) c, (Term (Lab a [b]) c, Location))] ->
                    [(Term (Lab a [b]) c, Term (Lab a [b]) c)] -> Xml;
xml_fp_trs_input p r =
  Xml ['t', 'r', 's', 'I', 'n', 'p', 'u', 't'] []
    [xml_rules ['t', 'r', 's'] r,
      Xml ['s', 't', 'r', 'a', 't', 'e', 'g', 'y'] []
        [Xml ['f', 'o', 'r', 'b', 'i', 'd', 'd', 'e', 'n', 'P', 'a', 't', 't',
               'e', 'r', 'n', 's']
           [] (map xml_forbidden_pattern p) Nothing]
        Nothing]
    Nothing;

xml_cert_problem ::
  forall a b c. (Showa a, Showa b, Showa c) => Cert_problem a [b] c -> Xml;
xml_cert_problem (TRS_Termination_Proof nfs q r s_o uu) =
  xml_trs_input (Inl q) r s_o;
xml_cert_problem (TRS_Nontermination_Proof nfs q r uv) =
  xml_trs_input (Inl q) r Nothing;
xml_cert_problem (Outermost_Nontermination_Proof q r uw) =
  xml_trs_input (Inr q) r Nothing;
xml_cert_problem (FP_Nontermination_Proof p r ux) = xml_fp_trs_input p r;
xml_cert_problem (Relative_TRS_Nontermination_Proof nfs q r s uy) =
  xml_trs_input (Inl q) r (Just s);
xml_cert_problem (DP_Termination_Proof nfs m p pw q r rw uz) =
  Xml ['d', 'p', 'I', 'n', 'p', 'u', 't'] []
    (xml_rules ['t', 'r', 's'] rw :
      xml_rules ['d', 'p', 's'] p :
        xml_Q (Inl q) ++
          [Xml ['m', 'i', 'n', 'i', 'm', 'a', 'l'] [] []
             (Just (if m then ['t', 'r', 'u', 'e']
                     else ['f', 'a', 'l', 's', 'e']))])
    Nothing;
xml_cert_problem (DP_Nontermination_Proof nfs m p q r va) =
  Xml ['d', 'p', 'I', 'n', 'p', 'u', 't'] []
    (xml_rules ['t', 'r', 's'] r :
      xml_rules ['d', 'p', 's'] p :
        xml_Q (Inl q) ++
          [Xml ['m', 'i', 'n', 'i', 'm', 'a', 'l'] [] []
             (Just (if m then ['t', 'r', 'u', 'e']
                     else ['f', 'a', 'l', 's', 'e']))])
    Nothing;
xml_cert_problem (TRS_Confluence_Proof nfs r vb) =
  xml_trs_input (Inl No_Strategy) r Nothing;
xml_cert_problem (TRS_Non_Confluence_Proof nfs r vc) =
  xml_trs_input (Inl No_Strategy) r Nothing;
xml_cert_problem (Completion_Proof e r vd) =
  Xml ['c', 'o', 'm', 'p', 'l', 'e', 't', 'i', 'o', 'n', 'I', 'n', 'p', 'u',
        't']
    [] [xml_rules ['e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 's'] e,
         xml_rules ['t', 'r', 's'] r]
    Nothing;
xml_cert_problem (Equational_Proof e eq ve) =
  Xml ['e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 'a', 'l', 'R', 'e', 'a', 's',
        'o', 'n', 'i', 'n', 'g', 'I', 'n', 'p', 'u', 't']
    [] [xml_rules ['e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 's'] e,
         Xml ['e', 'q', 'u', 'a', 't', 'i', 'o', 'n'] []
           [xml_term (fst eq), xml_term (snd eq)] Nothing]
    Nothing;
xml_cert_problem (Equational_Disproof e eq vf) =
  Xml ['e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 'a', 'l', 'R', 'e', 'a', 's',
        'o', 'n', 'i', 'n', 'g', 'I', 'n', 'p', 'u', 't']
    [] [xml_rules ['e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 's'] e,
         Xml ['e', 'q', 'u', 'a', 't', 'i', 'o', 'n'] []
           [xml_term (fst eq), xml_term (snd eq)] Nothing]
    Nothing;
xml_cert_problem (Complexity_Proof q r s cm cc vg) =
  Xml ['c', 'o', 'm', 'p', 'l', 'e', 'x', 'i', 't', 'y', 'I', 'n', 'p', 'u',
        't']
    [] [xml_trs_input (Inl q) r s, xml_complexity_measure cm,
         xml_complexity_class cc]
    Nothing;
xml_cert_problem (Quasi_Reductive_Proof ctrs vh) = xml_ctrs_input ctrs;

rules_non_collapsing_impl ::
  forall a b.
    (Bool,
      (Bool,
        ([(Term a b, Term a b)],
          ([(Term a b, Term a b)],
            ([Term a b],
              (Bool,
                (Bool,
                  ([(Term a b, Term a b)],
                    ([(Term a b, Term a b)],
                      (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                        (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                          Bool))))))))))) ->
      Bool;
rules_non_collapsing_impl (uu, (uv, (uw, (ux, (uy, (uz, (nc, va))))))) = nc;

newtype Dpp a b = Dpp
  (Bool,
    (Bool,
      ([(Term a b, Term a b)],
        ([(Term a b, Term a b)],
          ([Term a b],
            (Bool,
              (Bool,
                ([(Term a b, Term a b)],
                  ([(Term a b, Term a b)],
                    (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                      (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                        Bool)))))))))));

impl_ofc ::
  forall a b.
    (Linorder a) => Dpp a b ->
                      (Bool,
                        (Bool,
                          ([(Term a b, Term a b)],
                            ([(Term a b, Term a b)],
                              ([Term a b],
                                (Bool,
                                  (Bool,
                                    ([(Term a b, Term a b)],
                                      ([(Term a b, Term a b)],
(Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
  (Rbt (a, Nat) [(Bool, (Term a b, Term a b))], Bool)))))))))));
impl_ofc (Dpp x) = x;

rules_non_collapsing :: forall a b. (Linorder a) => Dpp a b -> Bool;
rules_non_collapsing d = rules_non_collapsing_impl (impl_ofc d);

nFQ_subset_NF_rules_impla ::
  forall a b.
    (Bool,
      (Bool,
        ([(Term a b, Term a b)],
          ([(Term a b, Term a b)],
            ([Term a b],
              (Bool,
                (Bool,
                  ([(Term a b, Term a b)],
                    ([(Term a b, Term a b)],
                      (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                        (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                          Bool))))))))))) ->
      Bool;
nFQ_subset_NF_rules_impla (uu, (uv, (uw, (ux, (uy, (b, uz)))))) = b;

nFQ_subset_NF_rulesa :: forall a b. (Linorder a) => Dpp a b -> Bool;
nFQ_subset_NF_rulesa d = nFQ_subset_NF_rules_impla (impl_ofc d);

rules_no_left_var_impl ::
  forall a b.
    (Bool,
      (Bool,
        ([(Term a b, Term a b)],
          ([(Term a b, Term a b)],
            ([Term a b],
              (Bool,
                (Bool,
                  ([(Term a b, Term a b)],
                    ([(Term a b, Term a b)],
                      (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                        (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                          Bool))))))))))) ->
      Bool;
rules_no_left_var_impl (uu, (uv, (uw, (ux, (uy, (uz, (va, ([], ([], vb)))))))))
  = True;
rules_no_left_var_impl (v, (vb, (ve, (vg, (vi, (vk, (vm, (vq : vr, vp)))))))) =
  False;
rules_no_left_var_impl
  (v, (vb, (ve, (vg, (vi, (vk, (vm, (vo, (vs : vt, vr))))))))) = False;

rules_no_left_var :: forall a b. (Linorder a) => Dpp a b -> Bool;
rules_no_left_var d = rules_no_left_var_impl (impl_ofc d);

reverse_rules_map_impl ::
  forall a b.
    (Eq a,
      Linorder a) => (Bool,
                       (Bool,
                         ([(Term a b, Term a b)],
                           ([(Term a b, Term a b)],
                             ([Term a b],
                               (Bool,
                                 (Bool,
                                   ([(Term a b, Term a b)],
                                     ([(Term a b, Term a b)],
                                       (Rbt (a, Nat)
  [(Bool, (Term a b, Term a b))],
 (Rbt (a, Nat) [(Bool, (Term a b, Term a b))], Bool))))))))))) ->
                       (a, Nat) -> [(Term a b, Term a b)];
reverse_rules_map_impl
  (uu, (uv, (uw, (ux, (uy, (uz, (va, (vb, (vc, (vd, (m, ve))))))))))) fn =
  (case rm_lookup fn m of {
    Nothing -> [];
    Just a -> map snd a;
  });

reverse_rules_map ::
  forall a b.
    (Eq a, Linorder a) => Dpp a b -> (a, Nat) -> [(Term a b, Term a b)];
reverse_rules_map d = reverse_rules_map_impl (impl_ofc d);

applicable_rule_implc ::
  forall a b. (Term a b -> Bool) -> (Term a b, Term a b) -> Bool;
applicable_rule_implc nf r = all nf (args (fst r));

wwf_qtrs_impl ::
  forall a b. (Eq b) => (Term a b -> Bool) -> [(Term a b, Term a b)] -> Bool;
wwf_qtrs_impl nf r =
  all (\ ra -> wf_rule ra || not (applicable_rule_implc nf ra)) r;

intersect_rules_impl ::
  forall a b.
    (Eq a, Linorder a,
      Eq b) => (Bool,
                 (Bool,
                   ([(Term a b, Term a b)],
                     ([(Term a b, Term a b)],
                       ([Term a b],
                         (Bool,
                           (Bool,
                             ([(Term a b, Term a b)],
                               ([(Term a b, Term a b)],
                                 (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                                   (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                                     Bool))))))))))) ->
                 [(Term a b, Term a b)] ->
                   (Bool,
                     (Bool,
                       ([(Term a b, Term a b)],
                         ([(Term a b, Term a b)],
                           ([Term a b],
                             (Bool,
                               (Bool,
                                 ([(Term a b, Term a b)],
                                   ([(Term a b, Term a b)],
                                     (Rbt (a, Nat)
[(Bool, (Term a b, Term a b))],
                                       (Rbt (a, Nat)
  [(Bool, (Term a b, Term a b))],
 Bool)))))))))));
intersect_rules_impl d ri =
  let {
    (nfs, (mi, (p, (pw, (q, (nfq, (nc, (vR, (vRw, (m, (rm, wwf))))))))))) = d;
    (vri, ria) = partition (is_Var . fst) ri;
    vr = list_inter vR vri;
    vrw = list_inter vRw vri;
    ma = intersect_rules ria m;
    rma = intersect_rules (map (\ (x, y) -> (y, x)) ri) rm;
    rs = vr ++ vrw ++ map snd (values ma);
  } in (nfs, (mi, (p, (pw, (q, (nfq || nF_subset (map fst rs) q,
                                 (nc || all (\ (_, r) -> not (is_Var r)) rs,
                                   (vr, (vrw,
  (ma, (rma, wwf || wwf_qtrs_impl (nF_terms_list q) rs)))))))))));

intersect_rulesa ::
  forall a b.
    (Eq a, Linorder a, Eq b) => Dpp a b -> [(Term a b, Term a b)] -> Dpp a b;
intersect_rulesa d rs = Dpp (intersect_rules_impl (impl_ofc d) rs);

intersect_pairs_impl ::
  forall a b.
    (Eq a,
      Eq b) => (Bool,
                 (Bool,
                   ([(Term a b, Term a b)],
                     ([(Term a b, Term a b)],
                       ([Term a b],
                         (Bool,
                           (Bool,
                             ([(Term a b, Term a b)],
                               ([(Term a b, Term a b)],
                                 (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                                   (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                                     Bool))))))))))) ->
                 [(Term a b, Term a b)] ->
                   (Bool,
                     (Bool,
                       ([(Term a b, Term a b)],
                         ([(Term a b, Term a b)],
                           ([Term a b],
                             (Bool,
                               (Bool,
                                 ([(Term a b, Term a b)],
                                   ([(Term a b, Term a b)],
                                     (Rbt (a, Nat)
[(Bool, (Term a b, Term a b))],
                                       (Rbt (a, Nat)
  [(Bool, (Term a b, Term a b))],
 Bool)))))))))));
intersect_pairs_impl (nfs, (mi, (p, (pw, rest)))) ps =
  (nfs, (mi, (list_inter p ps, (list_inter pw ps, rest))));

intersect_pairs ::
  forall a b.
    (Eq a, Linorder a, Eq b) => Dpp a b -> [(Term a b, Term a b)] -> Dpp a b;
intersect_pairs d ps = Dpp (intersect_pairs_impl (impl_ofc d) ps);

replace_pair_impl ::
  forall a b.
    (Eq a,
      Eq b) => (Bool,
                 (Bool,
                   ([(Term a b, Term a b)],
                     ([(Term a b, Term a b)],
                       ([Term a b],
                         (Bool,
                           (Bool,
                             ([(Term a b, Term a b)],
                               ([(Term a b, Term a b)],
                                 (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                                   (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                                     Bool))))))))))) ->
                 (Term a b, Term a b) ->
                   [(Term a b, Term a b)] ->
                     (Bool,
                       (Bool,
                         ([(Term a b, Term a b)],
                           ([(Term a b, Term a b)],
                             ([Term a b],
                               (Bool,
                                 (Bool,
                                   ([(Term a b, Term a b)],
                                     ([(Term a b, Term a b)],
                                       (Rbt (a, Nat)
  [(Bool, (Term a b, Term a b))],
 (Rbt (a, Nat) [(Bool, (Term a b, Term a b))], Bool)))))))))));
replace_pair_impl (nfs, (mi, (p, (pw, rest)))) pair ps =
  (nfs, (mi, (replace_impl pair ps p, (replace_impl pair ps pw, rest))));

replace_pair ::
  forall a b.
    (Eq a, Linorder a,
      Eq b) => Dpp a b ->
                 (Term a b, Term a b) -> [(Term a b, Term a b)] -> Dpp a b;
replace_pair d pair ps = Dpp (replace_pair_impl (impl_ofc d) pair ps);

rules_implb ::
  forall a b.
    (Eq a,
      Linorder a) => (Bool,
                       (Bool,
                         ([(Term a b, Term a b)],
                           ([(Term a b, Term a b)],
                             ([Term a b],
                               (Bool,
                                 (Bool,
                                   ([(Term a b, Term a b)],
                                     ([(Term a b, Term a b)],
                                       (Rbt (a, Nat)
  [(Bool, (Term a b, Term a b))],
 (Rbt (a, Nat) [(Bool, (Term a b, Term a b))], Bool))))))))))) ->
                       [(Term a b, Term a b)];
rules_implb (uu, (uv, (uw, (ux, (uy, (uz, (va, (vr, (vrw, (m, vb)))))))))) =
  vr ++ vrw ++ map snd (values m);

split_rules_impla ::
  forall a b.
    (Eq a, Linorder a,
      Eq b) => (Bool,
                 (Bool,
                   ([(Term a b, Term a b)],
                     ([(Term a b, Term a b)],
                       ([Term a b],
                         (Bool,
                           (Bool,
                             ([(Term a b, Term a b)],
                               ([(Term a b, Term a b)],
                                 (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                                   (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                                     Bool))))))))))) ->
                 [(Term a b, Term a b)] ->
                   ([(Term a b, Term a b)], [(Term a b, Term a b)]);
split_rules_impla d rs = partition (membera rs) (rules_implb d);

split_rulesb ::
  forall a b.
    (Eq a, Linorder a,
      Eq b) => Dpp a b ->
                 [(Term a b, Term a b)] ->
                   ([(Term a b, Term a b)], [(Term a b, Term a b)]);
split_rulesb d = split_rules_impla (impl_ofc d);

pairs_impl ::
  forall a b.
    (Bool,
      (Bool,
        ([(Term a b, Term a b)],
          ([(Term a b, Term a b)],
            ([Term a b],
              (Bool,
                (Bool,
                  ([(Term a b, Term a b)],
                    ([(Term a b, Term a b)],
                      (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                        (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                          Bool))))))))))) ->
      [(Term a b, Term a b)];
pairs_impl (uu, (uv, (p, (pw, uw)))) = p ++ pw;

split_pairs_impl ::
  forall a b.
    (Eq a,
      Eq b) => (Bool,
                 (Bool,
                   ([(Term a b, Term a b)],
                     ([(Term a b, Term a b)],
                       ([Term a b],
                         (Bool,
                           (Bool,
                             ([(Term a b, Term a b)],
                               ([(Term a b, Term a b)],
                                 (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                                   (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                                     Bool))))))))))) ->
                 [(Term a b, Term a b)] ->
                   ([(Term a b, Term a b)], [(Term a b, Term a b)]);
split_pairs_impl d ps = partition (membera ps) (pairs_impl d);

split_pairs ::
  forall a b.
    (Eq a, Linorder a,
      Eq b) => Dpp a b ->
                 [(Term a b, Term a b)] ->
                   ([(Term a b, Term a b)], [(Term a b, Term a b)]);
split_pairs d = split_pairs_impl (impl_ofc d);

delete_R_Rw_impla ::
  forall a b.
    (Eq a, Linorder a,
      Eq b) => (Bool,
                 (Bool,
                   ([(Term a b, Term a b)],
                     ([(Term a b, Term a b)],
                       ([Term a b],
                         (Bool,
                           (Bool,
                             ([(Term a b, Term a b)],
                               ([(Term a b, Term a b)],
                                 (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                                   (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                                     Bool))))))))))) ->
                 [(Term a b, Term a b)] ->
                   [(Term a b, Term a b)] ->
                     (Bool,
                       (Bool,
                         ([(Term a b, Term a b)],
                           ([(Term a b, Term a b)],
                             ([Term a b],
                               (Bool,
                                 (Bool,
                                   ([(Term a b, Term a b)],
                                     ([(Term a b, Term a b)],
                                       (Rbt (a, Nat)
  [(Bool, (Term a b, Term a b))],
 (Rbt (a, Nat) [(Bool, (Term a b, Term a b))], Bool)))))))))));
delete_R_Rw_impla d r rw =
  let {
    (nfs, (mi, (p, (pw, (q, (nfq, (nc, (vR, (vRw, (m, (rm, wwf))))))))))) = d;
    (vr, ra) = partition (is_Var . fst) r;
    (vrw, rwa) = partition (is_Var . fst) rw;
    vra = list_diff vR vr;
    vrwa = list_diff vRw vrw;
    ma = delete_rules True ra (delete_rules False rwa m);
    rma = delete_rules True (map (\ (x, y) -> (y, x)) r)
            (delete_rules False (map (\ (x, y) -> (y, x)) rw) rm);
    rs = vra ++ vrwa ++ map snd (values ma);
  } in (nfs, (mi, (p, (pw, (q, (nfq || nF_subset (map fst rs) q,
                                 (nc || all (\ (_, rb) -> not (is_Var rb)) rs,
                                   (vra, (vrwa,
   (ma, (rma, wwf || wwf_qtrs_impl (nF_terms_list q) rs)))))))))));

delete_R_Rwb ::
  forall a b.
    (Eq a, Linorder a,
      Eq b) => Dpp a b ->
                 [(Term a b, Term a b)] -> [(Term a b, Term a b)] -> Dpp a b;
delete_R_Rwb d r rw = Dpp (delete_R_Rw_impla (impl_ofc d) r rw);

delete_P_Pw_impl ::
  forall a b.
    (Eq a,
      Eq b) => (Bool,
                 (Bool,
                   ([(Term a b, Term a b)],
                     ([(Term a b, Term a b)],
                       ([Term a b],
                         (Bool,
                           (Bool,
                             ([(Term a b, Term a b)],
                               ([(Term a b, Term a b)],
                                 (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                                   (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                                     Bool))))))))))) ->
                 [(Term a b, Term a b)] ->
                   [(Term a b, Term a b)] ->
                     (Bool,
                       (Bool,
                         ([(Term a b, Term a b)],
                           ([(Term a b, Term a b)],
                             ([Term a b],
                               (Bool,
                                 (Bool,
                                   ([(Term a b, Term a b)],
                                     ([(Term a b, Term a b)],
                                       (Rbt (a, Nat)
  [(Bool, (Term a b, Term a b))],
 (Rbt (a, Nat) [(Bool, (Term a b, Term a b))], Bool)))))))))));
delete_P_Pw_impl (nfs, (mi, (p, (pw, rest)))) pd pwd =
  (nfs, (mi, (list_diff p pd, (list_diff pw pwd, rest))));

delete_P_Pw ::
  forall a b.
    (Eq a, Linorder a,
      Eq b) => Dpp a b ->
                 [(Term a b, Term a b)] -> [(Term a b, Term a b)] -> Dpp a b;
delete_P_Pw d p pw = Dpp (delete_P_Pw_impl (impl_ofc d) p pw);

wwf_rules_impl ::
  forall a b.
    (Bool,
      (Bool,
        ([(Term a b, Term a b)],
          ([(Term a b, Term a b)],
            ([Term a b],
              (Bool,
                (Bool,
                  ([(Term a b, Term a b)],
                    ([(Term a b, Term a b)],
                      (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                        (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                          Bool))))))))))) ->
      Bool;
wwf_rules_impl
  (uu, (uv, (uw, (ux, (uy, (uz, (va, (vb, (vc, (vd, (ve, wwf))))))))))) = wwf;

wwf_rules :: forall a b. (Linorder a) => Dpp a b -> Bool;
wwf_rules d = wwf_rules_impl (impl_ofc d);

rules_map_impla ::
  forall a b.
    (Eq a,
      Linorder a) => (Bool,
                       (Bool,
                         ([(Term a b, Term a b)],
                           ([(Term a b, Term a b)],
                             ([Term a b],
                               (Bool,
                                 (Bool,
                                   ([(Term a b, Term a b)],
                                     ([(Term a b, Term a b)],
                                       (Rbt (a, Nat)
  [(Bool, (Term a b, Term a b))],
 (Rbt (a, Nat) [(Bool, (Term a b, Term a b))], Bool))))))))))) ->
                       (a, Nat) -> [(Term a b, Term a b)];
rules_map_impla (uu, (uv, (uw, (ux, (uy, (uz, (va, (vb, (vc, (m, vd)))))))))) fn
  = (case rm_lookup fn m of {
      Nothing -> [];
      Just a -> map snd a;
    });

rules_mapa ::
  forall a b.
    (Eq a, Linorder a) => Dpp a b -> (a, Nat) -> [(Term a b, Term a b)];
rules_mapa d = rules_map_impla (impl_ofc d);

q_empty_impla ::
  forall a b.
    (Bool,
      (Bool,
        ([(Term a b, Term a b)],
          ([(Term a b, Term a b)],
            ([Term a b],
              (Bool,
                (Bool,
                  ([(Term a b, Term a b)],
                    ([(Term a b, Term a b)],
                      (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                        (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                          Bool))))))))))) ->
      Bool;
q_empty_impla (uu, (uv, (uw, (ux, (q, uy))))) = null q;

q_emptyb :: forall a b. (Linorder a) => Dpp a b -> Bool;
q_emptyb d = q_empty_impla (impl_ofc d);

is_QNF_impla ::
  forall a b c.
    (Eq a, Eq b,
      Eq c) => (Bool,
                 (Bool,
                   ([(Term a b, Term a b)],
                     ([(Term a b, Term a b)],
                       ([Term a b],
                         (Bool,
                           (Bool,
                             ([(Term a b, Term a b)],
                               ([(Term a b, Term a b)],
                                 (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                                   (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                                     Bool))))))))))) ->
                 Term a c -> Bool;
is_QNF_impla (uu, (uv, (uw, (ux, (q, uy))))) = nF_terms_list q;

is_QNFb :: forall a b. (Eq a, Linorder a, Eq b) => Dpp a b -> Term a b -> Bool;
is_QNFb d = is_QNF_impla (impl_ofc d);

rulesc :: forall a b. (Eq a, Linorder a) => Dpp a b -> [(Term a b, Term a b)];
rulesc d = rules_implb (impl_ofc d);

pairs :: forall a b. (Linorder a) => Dpp a b -> [(Term a b, Term a b)];
pairs d = pairs_impl (impl_ofc d);

dpp_impl ::
  forall a b.
    (Eq a,
      Linorder a) => (Bool,
                       (Bool,
                         ([(Term a b, Term a b)],
                           ([(Term a b, Term a b)],
                             ([Term a b],
                               (Bool,
                                 (Bool,
                                   ([(Term a b, Term a b)],
                                     ([(Term a b, Term a b)],
                                       (Rbt (a, Nat)
  [(Bool, (Term a b, Term a b))],
 (Rbt (a, Nat) [(Bool, (Term a b, Term a b))], Bool))))))))))) ->
                       (Bool,
                         (Bool,
                           (Set (Term a b, Term a b),
                             (Set (Term a b, Term a b),
                               (Set (Term a b),
                                 (Set (Term a b, Term a b),
                                   Set (Term a b, Term a b)))))));
dpp_impl (nfs, (mi, (p, (pw, (q, (uu, (uv, (vr, (vrw, (m, uw)))))))))) =
  (nfs, (mi, (set p,
               (set pw,
                 (set q,
                   (set (vr ++ rules_with id m),
                     set (vrw ++ rules_with not m)))))));

dppa ::
  forall a b.
    (Eq a,
      Linorder a) => Dpp a b ->
                       (Bool,
                         (Bool,
                           (Set (Term a b, Term a b),
                             (Set (Term a b, Term a b),
                               (Set (Term a b),
                                 (Set (Term a b, Term a b),
                                   Set (Term a b, Term a b)))))));
dppa d = dpp_impl (impl_ofc d);

nfs_impla ::
  forall a b.
    (Bool,
      (Bool,
        ([(Term a b, Term a b)],
          ([(Term a b, Term a b)],
            ([Term a b],
              (Bool,
                (Bool,
                  ([(Term a b, Term a b)],
                    ([(Term a b, Term a b)],
                      (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                        (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                          Bool))))))))))) ->
      Bool;
nfs_impla (nfs, uu) = nfs;

nfsb :: forall a b. (Linorder a) => Dpp a b -> Bool;
nfsb d = nfs_impla (impl_ofc d);

rw_impla ::
  forall a b.
    (Eq a,
      Linorder a) => (Bool,
                       (Bool,
                         ([(Term a b, Term a b)],
                           ([(Term a b, Term a b)],
                             ([Term a b],
                               (Bool,
                                 (Bool,
                                   ([(Term a b, Term a b)],
                                     ([(Term a b, Term a b)],
                                       (Rbt (a, Nat)
  [(Bool, (Term a b, Term a b))],
 (Rbt (a, Nat) [(Bool, (Term a b, Term a b))], Bool))))))))))) ->
                       [(Term a b, Term a b)];
rw_impla (uu, (uv, (uw, (ux, (uy, (uz, (va, (vb, (vrw, (m, vc)))))))))) =
  vrw ++ rules_with not m;

rwb :: forall a b. (Eq a, Linorder a) => Dpp a b -> [(Term a b, Term a b)];
rwb d = rw_impla (impl_ofc d);

pw_impl ::
  forall a b.
    (Bool,
      (Bool,
        ([(Term a b, Term a b)],
          ([(Term a b, Term a b)],
            ([Term a b],
              (Bool,
                (Bool,
                  ([(Term a b, Term a b)],
                    ([(Term a b, Term a b)],
                      (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                        (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                          Bool))))))))))) ->
      [(Term a b, Term a b)];
pw_impl (uu, (uv, (uw, (pw, ux)))) = pw;

pw :: forall a b. (Linorder a) => Dpp a b -> [(Term a b, Term a b)];
pw d = pw_impl (impl_ofc d);

mk_impla ::
  forall a b.
    (Eq a, Linorder a,
      Eq b) => Bool ->
                 Bool ->
                   [(Term a b, Term a b)] ->
                     [(Term a b, Term a b)] ->
                       [Term a b] ->
                         [(Term a b, Term a b)] ->
                           [(Term a b, Term a b)] ->
                             (Bool,
                               (Bool,
                                 ([(Term a b, Term a b)],
                                   ([(Term a b, Term a b)],
                                     ([Term a b],
                                       (Bool,
 (Bool,
   ([(Term a b, Term a b)],
     ([(Term a b, Term a b)],
       (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
         (Rbt (a, Nat) [(Bool, (Term a b, Term a b))], Bool)))))))))));
mk_impla nfs mi p pw q r rw =
  let {
    (vr, ra) = partition (is_Var . fst) r;
    (vrw, rwa) = partition (is_Var . fst) rw;
    rs = r ++ rw;
  } in (nfs, (mi, (p, (pw, (q, (nF_subset (map fst rs) q,
                                 (all (\ (_, rb) -> not (is_Var rb)) rs,
                                   (vr, (vrw,
  (insert_rules True ra (insert_rules False rwa (rm_empty ())),
    (insert_rules True (map (\ (x, y) -> (y, x)) r)
       (insert_rules False (map (\ (x, y) -> (y, x)) rw) (rm_empty ())),
      wwf_qtrs_impl (nF_terms_list q) rs)))))))))));

mkb ::
  forall a b.
    (Eq a, Linorder a,
      Eq b) => Bool ->
                 Bool ->
                   [(Term a b, Term a b)] ->
                     [(Term a b, Term a b)] ->
                       [Term a b] ->
                         [(Term a b, Term a b)] ->
                           [(Term a b, Term a b)] -> Dpp a b;
mkb nfs mi p pw q r rw = Dpp (mk_impla nfs mi p pw q r rw);

r_impla ::
  forall a b.
    (Eq a,
      Linorder a) => (Bool,
                       (Bool,
                         ([(Term a b, Term a b)],
                           ([(Term a b, Term a b)],
                             ([Term a b],
                               (Bool,
                                 (Bool,
                                   ([(Term a b, Term a b)],
                                     ([(Term a b, Term a b)],
                                       (Rbt (a, Nat)
  [(Bool, (Term a b, Term a b))],
 (Rbt (a, Nat) [(Bool, (Term a b, Term a b))], Bool))))))))))) ->
                       [(Term a b, Term a b)];
r_impla (uu, (uv, (uw, (ux, (uy, (uz, (va, (vr, (vb, (m, vc)))))))))) =
  vr ++ rules_with id m;

rb :: forall a b. (Eq a, Linorder a) => Dpp a b -> [(Term a b, Term a b)];
rb d = r_impla (impl_ofc d);

q_impla ::
  forall a b.
    (Bool,
      (Bool,
        ([(Term a b, Term a b)],
          ([(Term a b, Term a b)],
            ([Term a b],
              (Bool,
                (Bool,
                  ([(Term a b, Term a b)],
                    ([(Term a b, Term a b)],
                      (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                        (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                          Bool))))))))))) ->
      [Term a b];
q_impla (uu, (uv, (uw, (ux, (q, uy))))) = q;

qb :: forall a b. (Linorder a) => Dpp a b -> [Term a b];
qb d = q_impla (impl_ofc d);

p_impl ::
  forall a b.
    (Bool,
      (Bool,
        ([(Term a b, Term a b)],
          ([(Term a b, Term a b)],
            ([Term a b],
              (Bool,
                (Bool,
                  ([(Term a b, Term a b)],
                    ([(Term a b, Term a b)],
                      (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                        (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                          Bool))))))))))) ->
      [(Term a b, Term a b)];
p_impl (uu, (uv, (p, uw))) = p;

pa :: forall a b. (Linorder a) => Dpp a b -> [(Term a b, Term a b)];
pa d = p_impl (impl_ofc d);

m_impl ::
  forall a b.
    (Bool,
      (Bool,
        ([(Term a b, Term a b)],
          ([(Term a b, Term a b)],
            ([Term a b],
              (Bool,
                (Bool,
                  ([(Term a b, Term a b)],
                    ([(Term a b, Term a b)],
                      (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                        (Rbt (a, Nat) [(Bool, (Term a b, Term a b))],
                          Bool))))))))))) ->
      Bool;
m_impl (uu, (mi, uv)) = mi;

m :: forall a b. (Linorder a) => Dpp a b -> Bool;
m d = m_impl (impl_ofc d);

dpp_rbt_impl ::
  forall a b. (Eq a, Linorder a, Eq b) => Dpp_ops_ext (Dpp a b) a b ();
dpp_rbt_impl =
  Dpp_ops_ext dppa pa pw pairs qb rb rwb rulesc q_emptyb rules_no_left_var
    rules_non_collapsing is_QNFb nFQ_subset_NF_rulesa rules_mapa
    reverse_rules_map intersect_pairs replace_pair intersect_rulesa delete_P_Pw
    delete_R_Rwb split_pairs split_rulesb mkb m nfsb wwf_rules ();

nFQ_subset_NF_rules_impl ::
  forall a b.
    (Bool,
      ([Term a b],
        (Bool,
          ([(Term a b, Term a b)],
            ([(Term a b, Term a b)],
              Rbt (a, Nat) [(Bool, (Term a b, Term a b))]))))) ->
      Bool;
nFQ_subset_NF_rules_impl (uu, (uv, (b, uw))) = b;

nFQ_subset_NF_rules :: forall a b. (Key a, Key b) => Tp a b -> Bool;
nFQ_subset_NF_rules tp = nFQ_subset_NF_rules_impl (impl_ofb tp);

rules_impl ::
  forall a b.
    (Eq a,
      Linorder a) => (Bool,
                       ([Term a b],
                         (Bool,
                           ([(Term a b, Term a b)],
                             ([(Term a b, Term a b)],
                               Rbt (a, Nat)
                                 [(Bool, (Term a b, Term a b))]))))) ->
                       [(Term a b, Term a b)];
rules_impl (uu, (uv, (uw, (vR, (vRw, m))))) = vR ++ vRw ++ map snd (values m);

split_rules_impl ::
  forall a b.
    (Eq a, Key a, Eq b,
      Key b) => (Bool,
                  ([Term a b],
                    (Bool,
                      ([(Term a b, Term a b)],
                        ([(Term a b, Term a b)],
                          Rbt (a, Nat) [(Bool, (Term a b, Term a b))]))))) ->
                  [(Term a b, Term a b)] ->
                    ([(Term a b, Term a b)], [(Term a b, Term a b)]);
split_rules_impl tp rs =
  let {
    m = ceta_set_of rs;
  } in partition m (rules_impl tp);

split_rules ::
  forall a b.
    (Eq a, Key a, Eq b,
      Key b) => Tp a b ->
                  [(Term a b, Term a b)] ->
                    ([(Term a b, Term a b)], [(Term a b, Term a b)]);
split_rules tp = split_rules_impl (impl_ofb tp);

delete_R_Rw_impl ::
  forall a b.
    (Eq a, Linorder a,
      Eq b) => (Bool,
                 ([Term a b],
                   (Bool,
                     ([(Term a b, Term a b)],
                       ([(Term a b, Term a b)],
                         Rbt (a, Nat) [(Bool, (Term a b, Term a b))]))))) ->
                 [(Term a b, Term a b)] ->
                   [(Term a b, Term a b)] ->
                     (Bool,
                       ([Term a b],
                         (Bool,
                           ([(Term a b, Term a b)],
                             ([(Term a b, Term a b)],
                               Rbt (a, Nat) [(Bool, (Term a b, Term a b))])))));
delete_R_Rw_impl (nfs, (q, (uu, (vR, (vRw, m))))) r rw =
  let {
    (vr, ra) = partition (is_Var . fst) r;
    (vrw, rwa) = partition (is_Var . fst) rw;
    vra = list_diff vR vr;
    vrwa = list_diff vRw vrw;
    ma = delete_rules True ra (delete_rules False rwa m);
  } in (nfs, (q, (nF_subset (map fst (vra ++ vrwa ++ map snd (values ma))) q,
                   (vra, (vrwa, ma)))));

delete_R_Rw ::
  forall a b.
    (Eq a, Key a, Eq b,
      Key b) => Tp a b ->
                  [(Term a b, Term a b)] -> [(Term a b, Term a b)] -> Tp a b;
delete_R_Rw tp r rw = Tp (delete_R_Rw_impl (impl_ofb tp) r rw);

rules_map_impl ::
  forall a b.
    (Eq a,
      Linorder a) => (Bool,
                       ([Term a b],
                         (Bool,
                           ([(Term a b, Term a b)],
                             ([(Term a b, Term a b)],
                               Rbt (a, Nat)
                                 [(Bool, (Term a b, Term a b))]))))) ->
                       (a, Nat) -> [(Term a b, Term a b)];
rules_map_impl (uu, (uv, (uw, (ux, (uy, m))))) fn =
  (case rm_lookup fn m of {
    Nothing -> [];
    Just a -> map snd a;
  });

rules_map ::
  forall a b.
    (Eq a, Key a, Key b) => Tp a b -> (a, Nat) -> [(Term a b, Term a b)];
rules_map tp = rules_map_impl (impl_ofb tp);

qreltrs_impl ::
  forall a b.
    (Eq a,
      Linorder a) => (Bool,
                       ([Term a b],
                         (Bool,
                           ([(Term a b, Term a b)],
                             ([(Term a b, Term a b)],
                               Rbt (a, Nat)
                                 [(Bool, (Term a b, Term a b))]))))) ->
                       (Bool,
                         (Set (Term a b),
                           (Set (Term a b, Term a b),
                             Set (Term a b, Term a b))));
qreltrs_impl (nfs, (q, (uu, (vR, (vRw, m))))) =
  (nfs, (set q, (set (vR ++ rules_with id m), set (vRw ++ rules_with not m))));

qreltrs ::
  forall a b.
    (Eq a, Key a,
      Key b) => Tp a b ->
                  (Bool,
                    (Set (Term a b),
                      (Set (Term a b, Term a b), Set (Term a b, Term a b))));
qreltrs tp = qreltrs_impl (impl_ofb tp);

q_empty_impl ::
  forall a b.
    (Bool,
      ([Term a b],
        (Bool,
          ([(Term a b, Term a b)],
            ([(Term a b, Term a b)],
              Rbt (a, Nat) [(Bool, (Term a b, Term a b))]))))) ->
      Bool;
q_empty_impl (uu, (q, uv)) = null q;

q_empty :: forall a b. (Key a, Key b) => Tp a b -> Bool;
q_empty tp = q_empty_impl (impl_ofb tp);

is_QNF_impl ::
  forall a b.
    (Eq a,
      Eq b) => (Bool,
                 ([Term a b],
                   (Bool,
                     ([(Term a b, Term a b)],
                       ([(Term a b, Term a b)],
                         Rbt (a, Nat) [(Bool, (Term a b, Term a b))]))))) ->
                 Term a b -> Bool;
is_QNF_impl (uu, (q, uv)) = nF_terms_list q;

is_QNF :: forall a b. (Eq a, Key a, Eq b, Key b) => Tp a b -> Term a b -> Bool;
is_QNF tp = is_QNF_impl (impl_ofb tp);

rulesa :: forall a b. (Eq a, Key a, Key b) => Tp a b -> [(Term a b, Term a b)];
rulesa tp = rules_impl (impl_ofb tp);

nfs_impl ::
  forall a b.
    (Linorder a) => (Bool,
                      ([Term a b],
                        (Bool,
                          ([(Term a b, Term a b)],
                            ([(Term a b, Term a b)],
                              Rbt (a, Nat)
                                [(Bool, (Term a b, Term a b))]))))) ->
                      Bool;
nfs_impl (nfs, uu) = nfs;

nfs :: forall a b. (Key a, Key b) => Tp a b -> Bool;
nfs tp = nfs_impl (impl_ofb tp);

rw_impl ::
  forall a b.
    (Eq a,
      Linorder a) => (Bool,
                       ([Term a b],
                         (Bool,
                           ([(Term a b, Term a b)],
                             ([(Term a b, Term a b)],
                               Rbt (a, Nat)
                                 [(Bool, (Term a b, Term a b))]))))) ->
                       [(Term a b, Term a b)];
rw_impl (uu, (uv, (uw, (ux, (vRw, m))))) = vRw ++ rules_with not m;

rw :: forall a b. (Eq a, Key a, Key b) => Tp a b -> [(Term a b, Term a b)];
rw tp = rw_impl (impl_ofb tp);

mk_impl ::
  forall a b.
    (Eq a, Linorder a,
      Eq b) => Bool ->
                 [Term a b] ->
                   [(Term a b, Term a b)] ->
                     [(Term a b, Term a b)] ->
                       (Bool,
                         ([Term a b],
                           (Bool,
                             ([(Term a b, Term a b)],
                               ([(Term a b, Term a b)],
                                 Rbt (a, Nat)
                                   [(Bool, (Term a b, Term a b))])))));
mk_impl nfs q r rw =
  let {
    (vr, ra) = partition (is_Var . fst) r;
    (vrw, rwa) = partition (is_Var . fst) rw;
  } in (nfs, (q, (nF_subset (map fst (r ++ rw)) q,
                   (vr, (vrw, insert_rules True ra
                                (insert_rules False rwa (rm_empty ())))))));

mk :: forall a b.
        (Eq a, Key a, Eq b,
          Key b) => Bool ->
                      [Term a b] ->
                        [(Term a b, Term a b)] ->
                          [(Term a b, Term a b)] -> Tp a b;
mk nfs q r rw = Tp (mk_impl nfs q r rw);

tp_rbt_impl ::
  forall a b. (Eq a, Key a, Eq b, Key b) => Tp_ops_ext (Tp a b) a b ();
tp_rbt_impl =
  Tp_ops_ext qreltrs q r rw rulesa q_empty is_QNF nFQ_subset_NF_rules rules_map
    delete_R_Rw split_rules mk nfs ();

instance Countable Prelude.Char where {
};

o_ematch_probs_impl ::
  forall a b.
    (a -> Term b a) ->
      Ctxt b a ->
        Term b a ->
          Pos -> Term b a -> [(Ctxt b a, (Term b a, (Ctxt b a, Term b a)))];
o_ematch_probs_impl mu c l q t =
  map (\ p ->
        (subt_at_ctxt c p, (l, (subst_apply_ctxt c mu, subst_apply_term t mu))))
    (proper_prefix_list (hole_pos c));

o_match_probs_impl ::
  forall a b. Term a b -> Pos -> Term a b -> [(Term a b, Term a b)];
o_match_probs_impl l q t = map (\ p -> (subt_at t p, l)) (proper_prefix_list q);

set_impl_term :: forall a b. Phantom (Term a b) Set_impl;
set_impl_term = Phantom Set_RBT;

instance Set_impla (Term a b) where {
  set_impl = set_impl_term;
};

ident_solvea ::
  forall a b.
    (Eq a, Linorder a, Eq b,
      Linorder b) => Subst_incr a b ->
                       Set (Term a b, (Term a b, Nat)) ->
                         (Term a b, (Term a b, Nat)) -> Maybe Nat;
ident_solvea mu_incr cps st =
  let {
    cp = conflicts (si_subst mu_incr) st;
  } in (if any (\ (u, (_, _)) -> not (is_Var u)) cp then Nothing
         else (if any (\ (u, (v, _)) ->
                        member (u, v) (image (\ (ua, (va, _)) -> (ua, va)) cps))
                    cp
                then Nothing
                else bind (mapMa
                            (\ (u, (v, m)) ->
                              ident_solvea mu_incr (inserta (u, (v, m)) cps)
                                (subst_apply_term u (si_subst mu_incr),
                                  (v, plus_nat m (Nat_of_num One))))
                            (conflicts (si_subst mu_incr) st))
                       (\ is -> Just (max_list (map suc is)))));

ident_solve ::
  forall a b.
    (Eq a, Linorder a, Eq b,
      Linorder b) => Subst_incr a b -> (Term a b, Term a b) -> Maybe Nat;
ident_solve mu_incr =
  (\ (s, t) ->
    ident_solvea mu_incr
      (set_empty
        (of_phantom
          (set_impl_prod :: Phantom (Term a b, (Term a b, Nat)) Set_impl)))
      (s, (t, Zero_nat)));

ident_decision ::
  forall a b.
    (Eq a, Linorder a, Eq b,
      Linorder b) => Subst_incr a b -> (Term a b, Term a b) -> Bool;
ident_decision sigma ip = not (is_none (ident_solve sigma ip));

ident_prob_of_smp ::
  forall a b. (Eq a, Eq b) => [(Term a b, Term a b)] -> [(Term a b, Term a b)];
ident_prob_of_smp [] = [];
ident_prob_of_smp ((t, l) : other) =
  map_filter
    (\ x ->
      (if let {
            (_, s) = x;
          } in equal_term s l
        then Just (let {
                     (s, _) = x;
                   } in (t, s))
        else Nothing))
    other ++
    ident_prob_of_smp other;

simplify_mp ::
  forall a b.
    (Eq a, Ceq b,
      Corder b) => Subst_incr a b ->
                     [(Term a b, Term a b)] ->
                       [(Term a b, Term a b)] ->
                         Maybe ([(Term a b, Term a b)], Nat);
simplify_mp mu_incr ((Var x, Fun f ls) : mp) solved =
  bind (guarda (member x (si_v_incr mu_incr)))
    (\ _ ->
      let {
        m = map (\ (s, a) -> (subst_apply_term s (si_subst mu_incr), a));
      } in bind (simplify_mp mu_incr (m ((Var x, Fun f ls) : mp)) (m solved))
             (\ (smp, i) -> Just (smp, plus_nat i (Nat_of_num One))));
simplify_mp mu_incr ((Fun g ts, Fun f ls) : mp) solved =
  bind (guarda (f == g))
    (\ _ ->
      bind (zip_option ts ls)
        (\ pairs -> simplify_mp mu_incr (pairs ++ mp) solved));
simplify_mp mu_incr ((s, Var x) : mp) solved =
  simplify_mp mu_incr mp ((s, Var x) : solved);
simplify_mp mu_incr [] solved = Just (solved, Zero_nat);

gmatch_decision ::
  forall a b.
    (Eq a, Linorder a, Ceq b, Corder b, Eq b,
      Linorder b) => Subst_incr a b -> [(Term a b, Term a b)] -> Bool;
gmatch_decision sigma mp =
  not (is_none
        (bind (simplify_mp sigma mp [])
          (\ (smp, _) ->
            guarda (all (ident_decision sigma) (ident_prob_of_smp smp)))));

match_decision ::
  forall a b.
    (Eq a, Linorder a, Ceq b, Corder b, Eq b,
      Linorder b) => Subst_incr a b -> (Term a b, Term a b) -> Bool;
match_decision mu mp = gmatch_decision mu [mp];

eident_prob_to_ident_prob ::
  forall a b.
    (Ctxt a b, (Term a b, (Ctxt a b, Term a b))) -> (Term a b, Term a b);
eident_prob_to_ident_prob (d, (si, (c, t))) = (ctxt_apply d t, si);

eident_prob_of_semp ::
  forall a b.
    (Eq a,
      Eq b) => (Ctxt a b,
                 (Term a b, (Ctxt a b, (Term a b, [(Term a b, Term a b)])))) ->
                 Maybe (Ctxt a b, (Term a b, (Ctxt a b, Term a b)));
eident_prob_of_semp (d, (l, (c, (t, mp)))) =
  bind (map_of (map (\ (x, y) -> (y, x)) mp) l)
    (\ si -> Just (d, (si, (c, t))));

ident_prob_of_semp ::
  forall a b.
    (Eq a,
      Eq b) => (Ctxt a b,
                 (Term a b, (Ctxt a b, (Term a b, [(Term a b, Term a b)])))) ->
                 [(Term a b, Term a b)];
ident_prob_of_semp (d, (l, (c, (t, mp)))) = ident_prob_of_smp mp;

simplify_emp_main ::
  forall a b.
    (Eq a, Linorder a, Ceq b, Corder b, Eq b,
      Linorder b) => Subst_incr a b ->
                       (Ctxt a b,
                         (Term a b,
                           (Ctxt a b, (Term a b, [(Term a b, Term a b)])))) ->
                         [(Term a b, Term a b)] ->
                           Maybe (Maybe (Ctxt a b,
  (Term a b, (Ctxt a b, (Term a b, [(Term a b, Term a b)])))));
simplify_emp_main mu_incr (Hole, (Fun g ls, (c, (t, [])))) solved =
  (if gmatch_decision mu_incr ((t, Fun g ls) : solved) then Just Nothing
    else (if equal_ctxt c Hole then Nothing
           else simplify_emp_main mu_incr
                  (c, (Fun g ls,
                        (subst_apply_ctxt c (si_subst mu_incr),
                          (subst_apply_term t (si_subst mu_incr), []))))
                  solved));
simplify_emp_main mu_incr (More f bef d aft, (Fun g ls, (c, (t, [])))) solved =
  bind (guarda (f == g))
    (\ _ ->
      bind (guarda
             (equal_nat (size_list ls)
               (plus_nat (plus_nat (size_list bef) (size_list aft))
                 (Nat_of_num One))))
        (\ _ ->
          let {
            pairs_bef = zip bef (take (size_list bef) ls);
            pairs_aft =
              zip aft (drop (plus_nat (size_list bef) (Nat_of_num One)) ls);
          } in simplify_emp_main mu_incr
                 (d, (nth ls (size_list bef), (c, (t, pairs_bef ++ pairs_aft))))
                 solved));
simplify_emp_main mu_incr (d, (Var x, (c, (t, [])))) solved =
  Just (Just (d, (Var x, (c, (t, solved)))));
simplify_emp_main mu_incr (d, (l, (c, (t, (Var x, Fun f ls) : mp)))) solved =
  bind (guarda (member x (si_v_incr mu_incr)))
    (\ _ ->
      let {
        m = map (\ (s, a) -> (subst_apply_term s (si_subst mu_incr), a));
      } in simplify_emp_main mu_incr
             (subst_apply_ctxt d (si_subst mu_incr),
               (l, (subst_apply_ctxt c (si_subst mu_incr),
                     (subst_apply_term t (si_subst mu_incr),
                       m ((Var x, Fun f ls) : mp)))))
             (m solved));
simplify_emp_main mu_incr (d, (l, (c, (t, (Fun g ts, Fun f ls) : mp)))) solved =
  bind (guarda (f == g))
    (\ _ ->
      bind (zip_option ts ls)
        (\ pairs ->
          simplify_emp_main mu_incr (d, (l, (c, (t, pairs ++ mp)))) solved));
simplify_emp_main mu_incr (d, (l, (c, (t, (s, Var x) : mp)))) solved =
  simplify_emp_main mu_incr (d, (l, (c, (t, mp)))) ((s, Var x) : solved);

simplify_emp ::
  forall a b.
    (Eq a, Linorder a, Ceq b, Corder b, Eq b,
      Linorder b) => Subst_incr a b ->
                       (Ctxt a b, (Term a b, (Ctxt a b, Term a b))) ->
                         Sum (Ctxt a b,
                               (Term a b,
                                 (Ctxt a b,
                                   (Term a b, [(Term a b, Term a b)]))))
                           Bool;
simplify_emp mu_incr emp =
  let {
    (d, (l, (c, t))) = emp;
  } in (case simplify_emp_main mu_incr (d, (l, (c, (t, [])))) [] of {
         Nothing -> Inr False;
         Just Nothing -> Inr True;
         Just (Just a) -> Inl a;
       });

ident_prob_of_emp ::
  forall a b.
    (Eq a, Linorder a, Ceq b, Corder b, Eq b,
      Linorder b) => Subst_incr a b ->
                       (Ctxt a b, (Term a b, (Ctxt a b, Term a b))) ->
                         Maybe [(Term a b, Term a b)];
ident_prob_of_emp mu_incr emp =
  (case simplify_emp mu_incr emp of {
    Inl semp ->
      Just (map eident_prob_to_ident_prob
              (option_to_list (eident_prob_of_semp semp)) ++
             ident_prob_of_semp semp);
    Inr True -> Just [];
    Inr False -> Nothing;
  });

ostep_ctxt_subst_cond_impl ::
  forall a b.
    (Eq a, Linorder a, Ceq b, Corder b, Eq b,
      Linorder b) => Subst_incr a b ->
                       Ctxt a b -> Term a b -> Pos -> Term a b -> Bool;
ostep_ctxt_subst_cond_impl mu_incr c l q t =
  not (any (match_decision mu_incr) (o_match_probs_impl l q t) ||
        any (\ mp ->
              bex (seta (ident_prob_of_emp mu_incr mp))
                (all (ident_decision mu_incr)))
          (o_ematch_probs_impl (si_subst mu_incr) c l q t));

ostep_ctxt_subst_cond_decision ::
  forall a b.
    (Eq a, Linorder a, Ceq b, Corder b, Eq b,
      Linorder b) => Subst_incr a b ->
                       (Ctxt a b, (Term a b, (Pos, Term a b))) -> Bool;
ostep_ctxt_subst_cond_decision mu =
  (\ (c, (l, (a, b))) -> ostep_ctxt_subst_cond_impl mu c l a b);

rtrancl_list_impl :: forall a. (Eq a) => [(a, a)] -> [a] -> [a];
rtrancl_list_impl =
  rtrancl_impl
    (\ r asa ->
      remdups
        (map_filter
          (\ x ->
            (if let {
                  (a, _) = x;
                } in membera asa a
              then Just (snd x) else Nothing))
          r))
    (\ xs ys -> filter (\ x -> not (membera ys x)) xs ++ ys)
    (\ x xs -> membera xs x) [];

v_incr_impl :: forall a b. (Eq a) => [(a, Term b a)] -> [a];
v_incr_impl d =
  let {
    (ixs, uxs) = partition (\ (_, t) -> not (is_Var t)) d;
    rel = map (\ (x, y) -> (the_Var y, x)) uxs;
    a = map fst ixs;
  } in rtrancl_list_impl rel a;

w_impl :: forall a b. (Eq a) => [(a, Term b a)] -> Term b a -> [a];
w_impl d =
  let {
    filt = filter (\ (x, y) -> not (x == y));
    xvs = concatMap (\ (x, t) -> map (\ a -> (x, a)) (vars_term_lista t)) d;
    rel = filt xvs;
    rtran = rtrancl_list_impl rel;
  } in (\ t -> rtran (vars_term_lista t));

subst_incr :: forall a b. (Eq a, Eq b) => [(a, Term b a)] -> Subst_incr b a;
subst_incr x =
  Abs_subst_incr
    (let {
       dom = mk_subst_domain x;
     } in (mk_subst Var x, (set (v_incr_impl dom), w_impl dom)));

check_oloop ::
  forall a b.
    (Eq a, Linorder a, Showa a, Ceq b, Corder b, Eq b, Linorder b,
      Showa b) => [(Term a b, Term a b)] ->
                    [Term a b] ->
                      Ctxt a b ->
                        [(b, Term a b)] ->
                          Term a b ->
                            [(Pos, ((Term a b, Term a b), Term a b))] ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_oloop r q c sigma t seq =
  let {
    mu = subst_incr sigma;
    mua = si_subst mu;
  } in bindb (check (not (null seq))
               (shows_prec_list Zero_nat
                 ['l', 'o', 'o', 'p', 'i', 'n', 'g', ' ', 'r', 'e', 'd', 'u',
                   'c', 't', 'i', 'o', 'n', ' ', 'm', 'u', 's', 't', ' ', 'n',
                   'o', 't', ' ', 'b', 'e', ' ', 'e', 'm', 'p', 't', 'y']))
         (\ _ ->
           bindb (check
                   (equal_term (let {
                                  (_, (_, ta)) = last seq;
                                } in ta)
                     (ctxt_apply c (subst_apply_term t mua)))
                   (shows_prec_list Zero_nat
                     ['l', 'a', 's', 't', ' ', 't', 'e', 'r', 'm', ' ', 'i',
                       'n', ' ', 's', 'e', 'q', 'u', 'e', 'n', 'c', 'e', ' ',
                       'i', 's', ' ', 'n', 'o', 't', ' ', 'C', '[', 't', ' ',
                       's', 'i', 'g', 'm', 'a', ']']))
             (\ _ ->
               let {
                 seqa = zip (t : map (\ (_, (_, ta)) -> ta) seq) seq;
                 check_ostep = ostep_ctxt_subst_cond_decision mu;
               } in bindb (catcha
                            (forallM
                              (\ (ta, (p, (ra, s))) ->
                                bindb (check_rstep r p ra ta s)
                                  (\ _ ->
                                    catcha
                                      (forallM
(\ l ->
  check (check_ostep (c, (l, (p, ta))))
    (shows_prec_list Zero_nat
       ['r', 'e', 'd', 'u', 'c', 't', 'i', 'o', 'n', ' ', 'f', 'r', 'o', 'm',
         ' '] .
      shows_prec_term Zero_nat ta .
        shows_prec_list Zero_nat [' ', '-', '-', '>'] .
          shows_prec_pos Zero_nat p .
            shows_prec_list Zero_nat [' '] .
              shows_prec_term Zero_nat s .
                shows_prec_list Zero_nat
                  [' ', 'd', 'o', 'e', 's', ' ', 'n', 'o', 't', ' ', 'r', 'e',
                    's', 'p', 'e', 'c', 't', ' ', 'i', 't', 'e', 'r', 'a', 't',
                    'e', 'd', ' ', 'o', 'u', 't', 'e', 'r', 'm', 'o', 's', 't',
                    ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n']))
q)
                                      (\ x -> Inl (snd x))))
                              seqa)
                            (\ x -> Inl (snd x)))
                      (\ _ -> Inr ())));

check_outermost_nontermination_proof ::
  forall a b c.
    (Eq b, Key b, Showa b, Ceq c, Corder c, Eq c, Key c,
      Showa c) => ([Prelude.Char] -> [Prelude.Char]) ->
                    Tp_ops_ext a b c () ->
                      a -> Outermost_nontermination_proof b c ->
                             Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_outermost_nontermination_proof ia i tp (OTRS_Loop s rseq sigma c) =
  debug (ia []) ['L', 'o', 'o', 'p']
    (let {
       r = rulesb i tp;
       q = qa i tp;
     } in catcha (check_oloop r q c sigma s rseq)
            (\ x ->
              Inl (ia . shows_string
                          [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h',
                            'e', 'n', ' ', 'c', 'h', 'e', 'c', 'k', 'i', 'n',
                            'g', ' ', 'o', 'u', 't', 'e', 'r', 'm', 'o', 's',
                            't', ' ', 'l', 'o', 'o', 'p'] .
                          shows_nl . indent x)));
check_outermost_nontermination_proof ia i tp (OTRS_Rule_Removal r prf) =
  debug (ia []) ['R', 'u', 'l', 'e', ' ', 'R', 'e', 'm', 'o', 'v', 'a', 'l']
    (let {
       ra = rulesb i tp;
       rrm = ceta_list_diff ra r;
     } in catcha
            (check_outermost_nontermination_proof (ia . shows_string ['.', '1'])
              i (delete_R_Rwa i tp rrm rrm) prf)
            (\ x ->
              Inl (ia . shows_string
                          [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e',
                            'l', 'o', 'w', ' ', 't', 'h', 'e', ' ', 'r', 'u',
                            'l', 'e', ' ', 'r', 'e', 'm', 'o', 'v', 'a', 'l'] .
                          shows_nl . indent x)));

switch_termination_proc ::
  forall a b.
    (Eq b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    Join_info b ->
                      a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
switch_termination_proc i joins_i dpp =
  let {
    p = pairsa i dpp;
    r = rulesd i dpp;
    q = qc i dpp;
  } in (case let {
               cp = critical_pairs_impl r r;
             } in bindb (catcha
                          (forallM
                            (\ (b, _) ->
                              check b
                                (shows_prec_list Zero_nat
                                  ['r', 'u', 'l', 'e', 's', ' ', 'a', 'r', 'e',
                                    ' ', 'n', 'o', 't', ' ', 'o', 'v', 'e', 'r',
                                    'l', 'a', 'y']))
                            cp)
                          (\ x -> Inl (snd x)))
                    (\ _ ->
                      bindb (check_wf_trs r)
                        (\ _ ->
                          bindb (check_critical_pairs r cp joins_i)
                            (\ _ ->
                              bindb (check (null (critical_pairs_impl p r))
                                      (shows_prec_list Zero_nat
['t', 'h', 'e', 'r', 'e', ' ', 'a', 'r', 'e', ' ', 'o', 'v', 'e', 'r', 'l', 'a',
  'p', 's', ' ', 'b', 'e', 't', 'w', 'e', 'e', 'n', ' ', 'P', ' ', 'a', 'n',
  'd', ' ', 'R']))
                                (\ _ ->
                                  catcha (check_NF_terms_subset (map fst r) q)
                                    (\ x ->
                                      Inl
(shows_prec_term Zero_nat x .
  shows_prec_list Zero_nat
    [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'i', 'n', ' ', 'n', 'o', 'r', 'm',
      'a', 'l', ' ', 'f', 'o', 'r', 'm', ' ', 'w', '.', 'r', '.', 't', '.', ' ',
      'R']))))))
         of {
         Inl a -> Inl a;
         Inr _ -> Inr (mkc i (nfsc i dpp) False p [] [] [] r);
       });

rewriting_complete_proc ::
  forall a b.
    (Eq b, Key b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    Maybe [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                      (Term b [Prelude.Char], Term b [Prelude.Char]) ->
                        (Term b [Prelude.Char], Term b [Prelude.Char]) ->
                          (Term b [Prelude.Char], Term b [Prelude.Char]) ->
                            (Term b [Prelude.Char], Term b [Prelude.Char]) ->
                              Pos ->
                                a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
rewriting_complete_proc i u_opt stb sta st lr p dpp =
  (case let {
          s = fst stb;
          t = snd stb;
          ta = snd sta;
          r = rulesd i dpp;
        } in bindb (check_rstep r p lr t ta)
               (\ _ ->
                 bindb (check (nFQ_subset_NF_rulesb i dpp)
                         (shows_prec_list Zero_nat
                           ['i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't', ' ',
                             'r', 'e', 'w', 'r', 'i', 't', 'i', 'n', 'g', ' ',
                             'r', 'e', 'q', 'u', 'i', 'r', 'e', 'd']))
                   (\ _ ->
                     bindb (check_rewrite_common_preconditions i u_opt stb
                             (args s) ta lr p False dpp)
                       (\ _ ->
                         bindb (check (not (is_Var s))
                                 (shows_prec_list Zero_nat
                                   ['l', 'h', 's', ' ', 'o', 'f', ' ', 'p', 'a',
                                     'i', 'r', ' ', 'm', 'u', 's', 't', ' ',
                                     'n', 'o', 't', ' ', 'b', 'e', ' ', 'v',
                                     'a', 'r', 'i', 'a', 'b', 'l', 'e']))
                           (\ _ ->
                             bindb (check (eq_rule_mod_vars sta st)
                                     (shows_prec_list Zero_nat
['t', 'h', 'e', ' ', 'r', 'u', 'l', 'e', ' '] .
                                       shows_rule (shows_prec Zero_nat)
 (shows_prec_list Zero_nat) [' ', '-', '>', ' '] sta .
 shows_prec_list Zero_nat
   [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'r', 'e', 'n', 'a', 'm',
     'e', 'd', ' ', 'v', 'a', 'r', 'i', 'a', 'n', 't', ' ', 'o', 'f', ' '] .
   shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
     [' ', '-', '>', ' '] st))
                               (\ _ ->
                                 bindb (check (equal_term s (fst sta))
 (shows_prec_list Zero_nat
   ['l', 'e', 'f', 't', '-', 'h', 'a', 'n', 'd', ' ', 's', 'i', 'd', 'e', 's',
     ' ', 'o', 'f', ' ', 'o', 'l', 'd', ' ', 'a', 'n', 'd', ' ', 'n', 'e', 'w',
     ' ', 'p', 'a', 'i', 'r', ' ', 'd', 'i', 'f', 'f', 'e', 'r']))
                                   (\ _ ->
                                     let {
                                       q = qc i dpp;
                                       inn =
 isOK (check_NF_terms_subset (map fst r) q);
                                     } in bindb
    (check_nfc inn r q (args s) (nfsc i dpp) (subt_at t p))
    (\ _ ->
      bindb (catcha
              (forallM
                (\ (l, _) ->
                  check (not (is_Var l))
                    (shows_prec_list Zero_nat
                      ['l', 'h', 's', 's', ' ', 'm', 'u', 's', 't', ' ', 'n',
                        'o', 't', ' ', 'b', 'e', ' ', 'v', 'a', 'r', 'i', 'a',
                        'b', 'l', 'e', 's']))
                r)
              (\ x -> Inl (snd x)))
        (\ _ ->
          (if not (is_Var t)
            then check (not (not (null (rules_mapb i dpp (the (root t))))))
                   (shows_prec_list Zero_nat
                      ['r', 'o', 'o', 't', ' ', 'o', 'f', ' '] .
                     shows_prec_term Zero_nat t .
                       shows_prec_list Zero_nat
                         [' ', 'm', 'u', 's', 't', ' ', 'n', 'o', 't', ' ', 'b',
                           'e', ' ', 'd', 'e', 'f', 'i', 'n', 'e', 'd'])
            else Inr ())))))))))
    of {
    Inl a -> Inl a;
    Inr _ -> Inr (replace_paira i dpp stb [st]);
  });

rstep_enum_impl ::
  forall a b.
    (Eq a,
      Eq b) => [(Term a b, Term a b)] ->
                 Term a b ->
                   Term a b ->
                     Pos -> [((Term a b, Term a b), (b -> Term a b, Pos))];
rstep_enum_impl r ta t p =
  concat
    (map_filter
      (\ x ->
        (if less_eq_pos p x
          then Just (let {
                       tp = subt_at ta x;
                     } in (if membera (poss_list t) x
                            then (if equal_ctxt (ctxt_of_pos_term x ta)
                                       (ctxt_of_pos_term x t)
                                   then concatMap
  (\ tpa ->
    concatMap
      (\ (l, ra) ->
        map (\ mu -> ((l, ra), (mk_subst (\ _ -> ta) mu, x)))
          (option_to_list (match_list [(tp, l), (tpa, ra)])))
      r)
  [subt_at t x]
                                   else [])
                            else []))
          else Nothing))
      (poss_list ta));

narrow_enum_impl ::
  forall a b.
    (Eq a,
      Eq b) => [(Term a b, Term a b)] ->
                 (Term a b, Term a b) ->
                   (Term a b, Term a b) ->
                     Pos ->
                       [(b -> Term a b,
                          ((Term a b, Term a b), (Pos, b -> Term a b)))];
narrow_enum_impl r sta st p =
  let {
    (s, t) = sta;
    (sa, ta) = st;
  } in concatMap
         (\ mu ->
           concatMap (\ (lr, (tau, q)) -> [(mu, (lr, (q, tau)))])
             (rstep_enum_impl r (subst_apply_term t mu) ta p))
         (option_to_list (matcha sa s));

check_narrow ::
  forall a b.
    (Eq b, Key b,
      Showa b) => Bool ->
                    Dpp_ops_ext a b [Prelude.Char] () ->
                      a -> [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                             [Term b [Prelude.Char]] ->
                               Bool ->
                                 (Term b [Prelude.Char],
                                   Term b [Prelude.Char]) ->
                                   (Term b [Prelude.Char],
                                     Term b [Prelude.Char]) ->
                                     ([Prelude.Char] -> Term b [Prelude.Char],
                                       ((Term b [Prelude.Char],
  Term b [Prelude.Char]),
 (Pos, [Prelude.Char] -> Term b [Prelude.Char]))) ->
                                       Bool;
check_narrow inn i dpp r q nfs sta st quad =
  let {
    ((_, t), ((s, ta), (mu, (lr, (p, _))))) = (sta, (st, quad));
  } in isOK (check_nfc inn r q (args s) nfs
              (subt_at (subst_apply_term t mu) p)) &&
         isOK (check_rewrite_common_preconditions i Nothing
                (s, subst_apply_term t mu) (args s) ta lr p False dpp);

narrowing_complete_proc ::
  forall a b.
    (Eq b, Key b,
      Showa b) => Dpp_ops_ext a b [Prelude.Char] () ->
                    (Term b [Prelude.Char], Term b [Prelude.Char]) ->
                      Pos ->
                        [(Term b [Prelude.Char], Term b [Prelude.Char])] ->
                          a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
narrowing_complete_proc i st p sts dpp =
  (case let {
          (s, t) = st;
          q = qc i dpp;
          nfs = nfsc i dpp;
          rules = rulesd i dpp;
          _ = pairsa i dpp;
          check_ndef =
            check_no_defined_root (\ fn -> not (null (rules_mapb i dpp fn)));
          inn = isOK (check_NF_terms_subset (map fst rules) q);
          cnarrow = check_narrow inn i dpp rules q nfs st;
        } in bindb (check (null q || nFQ_subset_NF_rulesb i dpp)
                     (shows_prec_list Zero_nat
                       ['f', 'u', 'l', 'l', ' ', 'o', 'r', ' ', 'i', 'n', 'n',
                         'e', 'r', 'm', 'o', 's', 't', ' ', 'r', 'e', 'w', 'r',
                         'i', 't', 'i', 'n', 'g', ' ', 'r', 'e', 'q', 'u', 'i',
                         'r', 'e', 'd']))
               (\ _ ->
                 bindb (check (null q || inn)
                         (shows_prec_list Zero_nat
                           ['c', 'u', 'r', 'r', 'e', 'n', 't', 'l', 'y', ' ',
                             'o', 'n', 'l', 'y', ' ', 'f', 'u', 'l', 'l', ' ',
                             'o', 'r', ' ', 'e', 'x', 'a', 'c', 't', 'l', 'y',
                             ' ', 'i', 'n', 'n', 'e', 'r', 'm', 'o', 's', 't',
                             ' ', 's', 'u', 'p', 'p', 'o', 'r', 't', 'e', 'd']))
                   (\ _ ->
                     bindb (if null q then Inr ()
                             else bindb (check_no_var s)
                                    (\ _ ->
                                      bindb (check_no_var t)
(\ _ ->
  bindb (check_ndef t)
    (\ _ ->
      (if nfs
        then bindb (catcha (forallM (\ (l, _) -> check_no_var l) rules)
                     (\ x -> Inl (snd x)))
               (\ _ ->
                 check (wf_rule (s, t))
                   (shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
                      [' ', '-', '>', ' '] (s, t) .
                     shows_prec_list Zero_nat
                       [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'w', 'e', 'l',
                         'l', ' ', 'f', 'o', 'r', 'm', 'e', 'd']))
        else Inr ())))))
                       (\ _ ->
                         let {
                           _ = icap_impl_dpp_mv i dpp;
                           _ = is_QNFc i dpp;
                         } in catcha
                                (forallM
                                  (\ sta ->
                                    let {
                                      quads = narrow_enum_impl rules st sta p;
                                    } in check (any (cnarrow sta) quads)
   (shows_rule (shows_prec Zero_nat) (shows_prec_list Zero_nat)
      [' ', '-', '>', ' '] sta .
     shows_prec_list Zero_nat
       (case quads of {
         [] -> [' ', 'd', 'o', 'e', 's', ' ', 'n', 'o', 't', ' ', 's', 'e', 'e',
                 'm', ' ', 't', 'o', ' ', 'b', 'e', ' ', 'n', 'a', 'r', 'r',
                 'o', 'w', 'e', 'd', ' ', 'p', 'a', 'i', 'r'];
         _ : _ ->
           [' ', 'v', 'i', 'o', 'l', 'a', 't', 'e', 's', ' ', 's', 'i', 'd',
             'e', ' ', 'c', 'o', 'n', 'd', 'i', 't', 'i', 'o', 'n', 's', ' ',
             'f', 'o', 'r', ' ', 'c', 'o', 'm', 'p', 'l', 'e', 't', 'e', 'n',
             'e', 's', 's'];
       })))
                                  sts)
                                (\ x -> Inl (snd x)))))
    of {
    Inl a -> Inl a;
    Inr _ -> Inr (replace_paira i dpp st sts);
  });

check_instance ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    [(Term a b, Term a b)] ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_instance pa p =
  catcha
    (forallM
      (\ st ->
        check (any (instance_rule st) pa)
          (shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
             [' ', '-', '>', ' '] st .
            shows_prec_list Zero_nat
              [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', 'n', ' ', 'i', 'n',
                's', 't', 'a', 'n', 'c', 'e', ' ', 'o', 'f', ' ', 'a', 'n', 'y',
                ' ', 'o', 'r', 'i', 'g', 'i', 'n', 'a', 'l', ' ', 'p', 'a', 'i',
                'r']))
      p)
    (\ x -> Inl (snd x));

check_qrstep_subst ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => (Term a b -> Sum (Term a b, Term a b) ()) ->
                    Bool ->
                      [(Term a b, Term a b)] ->
                        Pos ->
                          (Term a b, Term a b) ->
                            Term a b ->
                              Term a b ->
                                Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_qrstep_subst cni nfs =
  let {
    main =
      check_prop_rstep nfs
        (\ t ->
          catcha (cni t)
            (\ _ ->
              Inl (shows_prec_term Zero_nat t .
                    shows_prec_list Zero_nat
                      [' ', 'm', 'u', ' ', '^', '^', ' ', 'i', ' ', 'i', 's',
                        ' ', 'n', 'o', 't', ' ', 'i', 'n', ' ', 'Q', '-', 'n',
                        'o', 'r', 'm', 'a', 'l', ' ', 'f', 'o', 'r', 'm', ' ',
                        'f', 'o', 'r', ' ', 'a', 'l', 'l', ' ', 'i'])));
  } in (\ r p ra s t ->
         bindb (check (not (is_Var (fst ra)))
                 (shows_prec_list Zero_nat
                   ['l', 'o', 'o', 'p', ' ', 'c', 'h', 'e', 'c', 'k', ' ', 'r',
                     'e', 'q', 'u', 'i', 'r', 'e', 's', ' ', 'l', 'h', 's', 's',
                     ' ', 't', 'o', ' ', 'b', 'e', ' ', 'n', 'o', 'n', '-', 'v',
                     'a', 'r', 'i', 'a', 'b', 'l', 'e']))
           (\ _ -> main r p ra s t));

check_rqrstep_subst ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => (Term a b -> Sum (Term a b, Term a b) ()) ->
                    Bool ->
                      [(Term a b, Term a b)] ->
                        (Term a b, Term a b) ->
                          Term a b ->
                            Term a b ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_rqrstep_subst cni nfs = (\ r -> check_qrstep_subst cni nfs r Empty);

check_qsteps_subst ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => (Term a b -> Sum (Term a b, Term a b) ()) ->
                    Bool ->
                      [(Term a b, Term a b)] ->
                        [(Term a b, Term a b)] ->
                          [(Pos, ((Term a b, Term a b), (Bool, Term a b)))] ->
                            Term a b ->
                              Term a b ->
                                Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_qsteps_subst cni nfs p r [] s u =
  check (equal_term s u)
    (shows_string
       ['t', 'h', 'e', ' ', 'l', 'a', 's', 't', ' ', 't', 'e', 'r', 'm', ' ',
         'o', 'f', ' ', 't', 'h', 'e', ' ', 'r', 'e', 'w', 'r', 'i', 't', 'e',
         ' ', 's', 'e', 'q', 'u', 'e', 'n', 'c', 'e'] .
      shows_nl .
        shows_prec_term Zero_nat s .
          shows_nl .
            shows_string
              ['d', 'o', 'e', 's', ' ', 'n', 'o', 't', ' ', 'c', 'o', 'r', 'r',
                'e', 's', 'p', 'o', 'n', 'd', ' ', 't', 'o', ' ', 't', 'h', 'e',
                ' ', 'g', 'o', 'a', 'l', ' ', 't', 'e', 'r', 'm'] .
              shows_nl . shows_prec_term Zero_nat u . shows_nl);
check_qsteps_subst cni nfs p ra ((uu, (r, (True, t))) : prts) s u =
  bindb (check_rqrstep_subst cni nfs p r s t)
    (\ _ -> check_qsteps_subst cni nfs p ra prts t u);
check_qsteps_subst cni nfs pa ra ((p, (r, (False, t))) : prts) s u =
  bindb (check_qrstep_subst cni nfs ra p r s t)
    (\ _ -> check_qsteps_subst cni nfs pa ra prts t u);

match_prob_of_rp_impl ::
  forall a b.
    (Eq a,
      Eq b) => Subst_incr a b -> (Term a b, Term a b) -> [(Term a b, Term a b)];
match_prob_of_rp_impl mu (t, Var x) = [(t, Var x)];
match_prob_of_rp_impl mu (t, Fun v va) =
  let {
    sterms = remdups (t : map (si_subst mu) (si_W mu t));
    uterms = concatMap (filter (\ ta -> not (is_Var ta)) . supteq_list) sterms;
  } in map (\ u -> (u, Fun v va)) (remdups uterms);

redex_decision ::
  forall a b.
    (Eq a, Linorder a, Ceq b, Corder b, Eq b,
      Linorder b) => Subst_incr a b -> (Term a b, Term a b) -> Bool;
redex_decision mu rp = any (match_decision mu) (match_prob_of_rp_impl mu rp);

redex_rps_decision ::
  forall a b.
    (Ceq a, Corder a, Eq a, Linorder a, Eq b,
      Linorder b) => [(a, Term b a)] ->
                       [(Term b a, Term b a)] -> Sum (Term b a, Term b a) ();
redex_rps_decision mu =
  let {
    mua = subst_incr mu;
    main = redex_decision mua;
  } in (\ xs ->
         catcha (forallM (\ tl -> check (not (main tl)) tl) xs)
           (\ x -> Inl (snd x)));

check_NF_iteration ::
  forall a b.
    (Ceq a, Corder a, Eq a, Linorder a, Eq b,
      Linorder b) => [(a, Term b a)] ->
                       [Term b a] -> Term b a -> Sum (Term b a, Term b a) ();
check_NF_iteration mu =
  let {
    dec = redex_rps_decision mu;
  } in (\ q t -> dec (map (\ a -> (t, a)) q));

check_qrsteps_subst ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => (Term a b -> Sum (Term a b, Term a b) ()) ->
                    Bool ->
                      [(Term a b, Term a b)] ->
                        [(Pos, ((Term a b, Term a b), Term a b))] ->
                          Term a b ->
                            Term a b ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_qrsteps_subst cni nfs r prts s u =
  check_qsteps_subst cni nfs [] r
    (map (\ (p, (ra, t)) -> (p, (ra, (False, t)))) prts) s u;

check_loop ::
  forall a b.
    (Eq a, Linorder a, Showa a, Ceq b, Corder b, Eq b, Linorder b,
      Showa b) => [Term a b] ->
                    Bool ->
                      (Term a b -> Bool) ->
                        Term a b ->
                          [(Pos, ((Term a b, Term a b), Term a b))] ->
                            [(b, Term a b)] ->
                              Ctxt a b ->
                                [(Term a b, Term a b)] ->
                                  Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_loop q nfs nf s rseq sigma c r =
  bindb (check (not (null rseq))
          (shows_prec_list Zero_nat
            ['r', 'e', 'w', 'r', 'i', 't', 'e', ' ', 's', 'e', 'q', 'u', 'e',
              'n', 'c', 'e', ' ', 'm', 'u', 's', 't', ' ', 'b', 'e', ' ', 'n',
              'o', 'n', '-', 'e', 'm', 'p', 't', 'y']))
    (\ _ ->
      (if null q
        then check_qrsteps (\ _ -> True) nfs r rseq s
               (ctxt_apply c (subst_apply_term s (mk_subst Var sigma)))
        else check_qrsteps_subst (check_NF_iteration sigma q) nfs r rseq s
               (ctxt_apply c (subst_apply_term s (mk_subst Var sigma)))));

check_dp_loop ::
  forall a b.
    (Eq a, Linorder a, Showa a, Ceq b, Corder b, Eq b, Linorder b,
      Showa b) => [Term a b] ->
                    Bool ->
                      (Term a b -> Bool) ->
                        Term a b ->
                          [(Pos, ((Term a b, Term a b), (Bool, Term a b)))] ->
                            [(b, Term a b)] ->
                              Ctxt a b ->
                                [(Term a b, Term a b)] ->
                                  [(Term a b, Term a b)] ->
                                    Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_dp_loop q nfs nf s prseq sigma c p r =
  (if equal_ctxt c Hole
    then bindb (check (not (null prseq))
                 (shows_prec_list Zero_nat
                   ['r', 'e', 'w', 'r', 'i', 't', 'e', ' ', 's', 'e', 'q', 'u',
                     'e', 'n', 'c', 'e', ' ', 'm', 'u', 's', 't', ' ', 'b', 'e',
                     ' ', 'n', 'o', 'n', '-', 'e', 'm', 'p', 't', 'y']))
           (\ _ ->
             (if null q
               then check_qsteps nf nfs p r prseq s
                      (subst_apply_term s (mk_subst Var sigma))
               else check_qsteps_subst (check_NF_iteration sigma q) nfs p r
                      prseq s (subst_apply_term s (mk_subst Var sigma))))
    else check_loop q nfs nf s (map (\ (x, (y, (_, z))) -> (x, (y, z))) prseq)
           sigma c r);

inverse_var_renaming_impl ::
  forall a b. (Eq a, Eq b) => [(a, Term b a)] -> [(a, Term b a)];
inverse_var_renaming_impl sigma =
  let {
    a = mk_subst_domain sigma;
  } in map (\ (x, y) -> (the_Var y, Var x)) a;

vars_pat_term_impl ::
  forall a b.
    (Eq a, Eq b) => (Term a b, ([(b, Term a b)], [(b, Term a b)])) -> [b];
vars_pat_term_impl p =
  let {
    (s, (sigma, mu)) = p;
  } in remdups
         (vars_term_lista s ++ vars_subst_impl sigma ++ vars_subst_impl mu);

var_renaming_impl :: forall a b. (Eq a, Eq b) => [(a, Term b a)] -> Bool;
var_renaming_impl sigma =
  let {
    sigmaa = map snd (mk_subst_domain sigma);
  } in all is_Var sigmaa && distinct sigmaa;

pat_dom_renaming_impl ::
  forall a b.
    (Eq a,
      Eq b) => (Term a b, ([(b, Term a b)], [(b, Term a b)])) ->
                 [(b, Term a b)] -> Bool;
pat_dom_renaming_impl p rho =
  let {
    rhoa = mk_subst_domain rho;
    xs = map Var (vars_pat_term_impl p);
  } in var_renaming_impl rho &&
         all (membera (pat_dv_impl p)) (map fst rhoa) &&
           all (\ t -> not (membera xs t)) (map snd rhoa);

check_pat_eqv_prf ::
  forall a b.
    (Eq a, Linorder a, Showa a, Cenum b, Ceq b, Corder b, Eq b, Linorder b,
      Showa b) => Pat_eqv_prf a b ->
                    (Term a b, ([(b, Term a b)], [(b, Term a b)])) ->
                      Sum ([Prelude.Char] -> [Prelude.Char])
                        (Term a b, ([(b, Term a b)], [(b, Term a b)]));
check_pat_eqv_prf (Pat_Irrelevant sigmaa mua) (t, (sigma, mu)) =
  let {
    w = w_impl (mk_subst_domain sigma) t;
    sig = mk_subst Var sigma;
    siga = mk_subst Var sigmaa;
    mub = mk_subst Var mu;
    muba = mk_subst Var mua;
  } in bindb (catcha
               (catcha
                 (forallM
                   (\ x ->
                     bindb (check (equal_term (sig x) (siga x))
                             (x, (sig x,
                                   (siga x,
                                     ['p', 'u', 'm', 'p', 'i', 'n', 'g']))))
                       (\ _ ->
                         check (equal_term (mub x) (muba x))
                           (x, (mub x,
                                 (muba x,
                                   ['c', 'l', 'o', 's', 'i', 'n', 'g'])))))
                   w)
                 (\ x -> Inl (snd x)))
               (\ x ->
                 Inl (let {
                        (xa, (tb, (ta, sub))) = x;
                      } in shows_string
                             ['e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ', 'e',
                               'q', 'u', 'i', 'v', 'a', 'l', 'e', 'n', 'c', 'e',
                               ' ', '(', 'i', 'r', 'r', 'e', 'l', 'e', 'v', 'a',
                               'n', 't', ')', ':', ' ', 'f', 'o', 'r', ' ', 'v',
                               'a', 'r', 'i', 'a', 'b', 'l', 'e', ' '] .
                             shows_prec Zero_nat xa .
                               shows_string
                                 [' ', 'o', 'b', 't', 'a', 'i', 'n', ' ', 'd',
                                   'i', 'f', 'f', 'e', 'r', 'e', 'n', 't', ' ',
                                   'v', 'a', 'l', 'u', 'e', 's', ' ', 'f', 'o',
                                   'r', ' '] .
                                 shows_prec_list Zero_nat sub .
                                   shows_string
                                     [' ', 's', 'u', 'b', 's', 't', 'i', 't',
                                       'u', 't', 'i', 'o', 'n', ':', ' '] .
                                     shows_prec_term Zero_nat tb .
                                       shows_string [' ', '!', '=', ' '] .
 shows_prec_term Zero_nat ta)))
         (\ _ -> Inr (t, (sigmaa, mua)));
check_pat_eqv_prf (Pat_Simplify mu_1 mu_2) (t, (sigma, mu)) =
  bindb (check (subst_eq mu (subst_compose_impl mu_1 mu_2))
          (shows_prec_list Zero_nat
            ['m', 'u', ' ', '!', '=', ' ', 'm', 'u', '1', ' ', 'm', 'u', '2']))
    (\ _ ->
      bindb (check (commutes_impl mu_1 sigma)
              (shows_prec_list Zero_nat
                ['s', 'i', 'g', 'm', 'a', ' ', 'a', 'n', 'd', ' ', 'm', 'u',
                  '1', ' ', 'd', 'o', ' ', 'n', 'o', 't', ' ', 'c', 'o', 'm',
                  'm', 'u', 't', 'e']))
        (\ _ -> Inr (subst_apply_term t (mk_subst Var mu_1), (sigma, mu_2))));
check_pat_eqv_prf (Pat_Dom_Renaming rho) (t, (sigma, mu)) =
  bindb (check (pat_dom_renaming_impl (t, (sigma, mu)) rho)
          (shows_prec_list Zero_nat
            ['r', 'h', 'o', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ',
              'd', 'o', 'm', 'a', 'i', 'n', ' ', 'r', 'e', 'n', 'a', 'm', 'i',
              'n', 'g', ' ', 'f', 'o', 'r', ' ', 'p']))
    (\ _ ->
      let {
        i_rho = inverse_var_renaming_impl rho;
        sigmaa =
          mk_subst_case
            (map (the_Var . mk_subst Var rho) (map fst (mk_subst_domain sigma)))
            (\ x ->
              subst_apply_term
                (subst_apply_term
                  (subst_apply_term (Var x) (mk_subst Var i_rho))
                  (mk_subst Var sigma))
                (mk_subst Var rho))
            [];
        mua = mk_subst_case
                (map (the_Var . mk_subst Var rho)
                  (map fst (mk_subst_domain mu)))
                (\ x ->
                  subst_apply_term
                    (subst_apply_term (Var x) (mk_subst Var i_rho))
                    (mk_subst Var mu))
                i_rho;
      } in Inr (subst_apply_term t (mk_subst Var rho), (sigmaa, mua)));

subst_compose_impla ::
  forall a b.
    (Eq a, Eq b) => [(a, Term b a)] -> (a -> Term b a) -> [(a, Term b a)];
subst_compose_impla sigma rho =
  map (\ (x, s) -> (x, subst_apply_term s rho)) (mk_subst_domain sigma);

subst_replace_impl ::
  forall a b. (Eq a) => [(a, Term b a)] -> a -> Term b a -> [(a, Term b a)];
subst_replace_impl sigma x t = (x, t) : filter (\ (y, _) -> not (y == x)) sigma;

check_pat_rule_prf ::
  forall a b.
    (Eq a, Linorder a, Showa a, Cenum b, Ceq b, Corder b, Eq b, Linorder b,
      Showa b) => [(Term a b, Term a b)] ->
                    [(Term a b, Term a b)] ->
                      Pat_rule_prf a b ->
                        Sum ([Prelude.Char] -> [Prelude.Char])
                          ((Term a b, ([(b, Term a b)], [(b, Term a b)])),
                            ((Term a b, ([(b, Term a b)], [(b, Term a b)])),
                              Bool));
check_pat_rule_prf ra p (Pat_OrigRule (l, r) isPair) =
  (if isPair
    then bindb (check (membera p (l, r))
                 (shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                    [' ', '-', '>', ' '] (l, r) .
                   shows_prec_list Zero_nat
                     [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'p',
                       'a', 'i', 'r']))
           (\ _ -> Inr ((l, ([], [])), ((r, ([], [])), isPair)))
    else bindb (check (membera ra (l, r))
                 (shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                    [' ', '-', '>', ' '] (l, r) .
                   shows_prec_list Zero_nat
                     [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'r',
                       'u', 'l', 'e']))
           (\ _ -> Inr ((l, ([], [])), ((r, ([], [])), isPair))));
check_pat_rule_prf r p (Pat_InitPump pat sigma theta) =
  bindb (check_pat_rule_prf r p pat)
    (\ (a, b) ->
      let {
        (s, (sig, tau)) = a;
      } in (\ (aa, ba) ->
             let {
               (t, (siga, taua)) = aa;
             } in (\ bb ->
                    catcha
                      (bindb
                        (check (null (sig ++ tau ++ siga ++ taua))
                          (shows_prec_list Zero_nat
                            ['s', 'u', 'b', 's', 't', 'i', 't', 'u', 't', 'i',
                              'o', 'n', 's', ' ', 'm', 'u', 's', 't', ' ', 'b',
                              'e', ' ', 'e', 'm', 'p', 't', 'y']))
                        (\ _ ->
                          bindb (check
                                  (equal_term
                                    (subst_apply_term s (mk_subst Var theta))
                                    (subst_apply_term t (mk_subst Var sigma)))
                                  (shows_prec_list Zero_nat
                                    ['s', ' ', 't', 'h', 'e', 't', 'a', ' ',
                                      '!', '=', ' ', 't', ' ', 's', 'i', 'g',
                                      'm', 'a']))
                            (\ _ ->
                              bindb (check (commutes_impl theta sigma)
                                      (shows_prec_list Zero_nat
['s', 'i', 'g', 'm', 'a', ' ', 'a', 'n', 'd', ' ', 't', 'h', 'e', 't', 'a', ' ',
  'd', 'o', ' ', 'n', 'o', 't', ' ', 'c', 'o', 'm', 'm', 'u', 't', 'e']))
                                (\ _ ->
                                  Inr ((s, (sigma, [])),
((t, (theta, [])), bb))))))
                      (\ x ->
                        Inl (shows_prec_list Zero_nat
                               ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w',
                                 'i', 't', 'h', ' '] .
                              shows_prec_list Zero_nat
                                ['i', 'n', 'i', 't', 'i', 'a', 'l', ' ', 'p',
                                  'u', 'm', 'p', 'i', 'n', 'g'] .
                                shows_prec_list Zero_nat
                                  [' ', 'a', 'f', 't', 'e', 'r', ' ', 'd', 'e',
                                    'r', 'i', 'v', 'i', 'n', 'g', ' ', 'c', 'o',
                                    'r', 'r', 'e', 'c', 't', ' ', 'p', 'a', 't',
                                    't', 'e', 'r', 'n', ' ', 'r', 'u', 'l', 'e',
                                    ' '] .
                                  shows_nl .
                                    show_pat_rule
                                      ((s, (sig, tau)),
((t, (siga, taua)), bb)) .
                                      x)))
               ba)
        b);
check_pat_rule_prf r pa (Pat_InitPumpCtxt pat sigma p z) =
  bindb (check_pat_rule_prf r pa pat)
    (\ (a, b) ->
      let {
        (s, (sig, tau)) = a;
      } in (\ (aa, ba) ->
             let {
               (t, (siga, taua)) = aa;
             } in (\ bb ->
                    catcha
                      (bindb
                        (check (not bb)
                          (shows_prec_list Zero_nat
                            ['p', 'a', 'i', 'r', 's', ' ', 'n', 'o', 't', ' ',
                              'a', 'l', 'l', 'o', 'w', 'e', 'd', ' ', 'i', 'n',
                              ' ', 'i', 'n', 'i', 't', ' ', 'p', 'u', 'm', 'p',
                              ' ', 'c', 't', 'x', 't']))
                        (\ _ ->
                          bindb (check (null (sig ++ tau ++ siga ++ taua))
                                  (shows_prec_list Zero_nat
                                    ['s', 'u', 'b', 's', 't', 'i', 't', 'u',
                                      't', 'i', 'o', 'n', 's', ' ', 'm', 'u',
                                      's', 't', ' ', 'b', 'e', ' ', 'e', 'm',
                                      'p', 't', 'y']))
                            (\ _ ->
                              bindb (check (in_poss p t)
                                      (shows_prec_list Zero_nat
['p', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'v', 'a', 'l', 'i', 'd',
  ' ', 'p', 'o', 's', 'i', 't', 'i', 'o', 'n']))
                                (\ _ ->
                                  bindb (check
  (equal_term s (subst_apply_term (subt_at t p) (mk_subst Var sigma)))
  (shows_prec_list Zero_nat
    ['s', ' ', '!', '=', ' ', 't', ' ', '|', '_', ' ', 'p', ' ', 's', 'i', 'g',
      'm', 'a']))
                                    (\ _ ->
                                      bindb
(check
  (not (membera
         (vars_term_lista s ++ vars_term_lista t ++ vars_subst_impl sigma) z))
  (shows_prec_list Zero_nat
    ['z', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'f', 'r', 'e', 's', 'h']))
(\ _ ->
  let {
    tz = ctxt_apply (ctxt_of_pos_term p t) (Var z);
  } in Inr ((s, (sigma, [])),
             ((tz, ((z, tz) : sigma, [(z, subt_at t p)])), bb))))))))
                      (\ x ->
                        Inl (shows_prec_list Zero_nat
                               ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w',
                                 'i', 't', 'h', ' '] .
                              shows_prec_list Zero_nat
                                ['i', 'n', 'i', 't', 'i', 'a', 'l', ' ', 'p',
                                  'u', 'm', 'p', 'i', 'n', 'g', ' ', '(', 'w',
                                  'i', 't', 'h', ' ', 'c', 't', 'x', 't', ')',
                                  ' '] .
                                shows_prec_list Zero_nat
                                  [' ', 'a', 'f', 't', 'e', 'r', ' ', 'd', 'e',
                                    'r', 'i', 'v', 'i', 'n', 'g', ' ', 'c', 'o',
                                    'r', 'r', 'e', 'c', 't', ' ', 'p', 'a', 't',
                                    't', 'e', 'r', 'n', ' ', 'r', 'u', 'l', 'e',
                                    ' '] .
                                  shows_nl .
                                    show_pat_rule
                                      ((s, (sig, tau)),
((t, (siga, taua)), bb)) .
                                      x)))
               ba)
        b);
check_pat_rule_prf r p (Pat_Equiv pat left eqv) =
  bindb (check_pat_rule_prf r p pat)
    (\ (pleft, (pright, b)) ->
      catcha
        (bindb (check_pat_eqv_prf eqv (if left then pleft else pright))
          (\ pnew ->
            Inr (if left then (pnew, (pright, b)) else (pleft, (pnew, b)))))
        (\ x ->
          Inl (shows_prec_list Zero_nat
                 ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'i', 't', 'h',
                   ' '] .
                shows_prec_list Zero_nat
                  ['p', 'a', 't', 't', 'e', 'r', 'n', ' ', 'e', 'q', 'u', 'i',
                    'v', 'a', 'l', 'e', 'n', 'c', 'e'] .
                  shows_prec_list Zero_nat
                    [' ', 'a', 'f', 't', 'e', 'r', ' ', 'd', 'e', 'r', 'i', 'v',
                      'i', 'n', 'g', ' ', 'c', 'o', 'r', 'r', 'e', 'c', 't',
                      ' ', 'p', 'a', 't', 't', 'e', 'r', 'n', ' ', 'r', 'u',
                      'l', 'e', ' '] .
                    shows_nl . show_pat_rule (pleft, (pright, b)) . x)));
check_pat_rule_prf r pa (Pat_Narrow pat1 pat2 p) =
  bindb (check_pat_rule_prf r pa pat1)
    (\ (a, b) ->
      let {
        (s, (sigma, mu)) = a;
      } in (\ (aa, ba) ->
             let {
               (t, (sig, mua)) = aa;
             } in (\ b1 ->
                    bindb (check_pat_rule_prf r pa pat2)
                      (\ (ab, bb) ->
                        let {
                          (u, (sig1, mu1)) = ab;
                        } in (\ (ac, bc) ->
                               let {
                                 (v, (sig2, mu2)) = ac;
                               } in (\ b2 ->
                                      catcha
(bindb
  (check
    (subst_eq sig sigma &&
      subst_eq sig1 sigma &&
        subst_eq sig2 sigma &&
          subst_eq mua mu && subst_eq mu1 mu && subst_eq mu2 mu)
    (shows_prec_list Zero_nat
      ['s', 'u', 'b', 's', 't', 'i', 't', 'u', 't', 'i', 'o', 'n', 's', ' ',
        'a', 'r', 'e', ' ', 'n', 'o', 't', ' ', 'i', 'd', 'e', 'n', 't', 'i',
        'c', 'a', 'l']))
  (\ _ ->
    bindb (check (in_poss p t)
            (shows_prec_list Zero_nat
              ['p', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'v', 'a',
                'l', 'i', 'd', ' ', 'p', 'o', 's', 'i', 't', 'i', 'o', 'n']))
      (\ _ ->
        bindb (check (equal_term (subt_at t p) u)
                (shows_prec_list Zero_nat
                  ['t', ' ', '|', '_', ' ', 'p', ' ', '!', '=', ' ', 'u']))
          (\ _ ->
            bindb (check (if b2 then equal_pos p Empty else True)
                    (shows_prec_list Zero_nat
                      ['t', 'h', 'e', 'r', 'e', ' ', 'i', 's', ' ', 'a', ' ',
                        'P', ' ', 's', 't', 'e', 'p', ',', ' ', 's', 'o', ' ',
                        'p', ' ', 'm', 'u', 's', 't', ' ', 'b', 'e', ' ', 'e',
                        'p', 's', 'i', 'l', 'o', 'n']))
              (\ _ ->
                Inr ((s, (sigma, mu)),
                      ((ctxt_apply (ctxt_of_pos_term p t) v, (sigma, mu)),
                        b1 || b2)))))))
(\ x ->
  Inl (shows_prec_list Zero_nat
         ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'i', 't', 'h', ' '] .
        shows_prec_list Zero_nat
          ['p', 'a', 't', 't', 'e', 'r', 'n', ' ', 'n', 'a', 'r', 'r', 'o', 'w',
            'i', 'n', 'g'] .
          shows_prec_list Zero_nat
            [' ', 'a', 'f', 't', 'e', 'r', ' ', 'd', 'e', 'r', 'i', 'v', 'i',
              'n', 'g', ' ', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ', 'p', 'a',
              't', 't', 'e', 'r', 'n', ' ', 'r', 'u', 'l', 'e', 's', ' '] .
            shows_nl .
              show_pat_rule ((s, (sigma, mu)), ((t, (sig, mua)), b1)) .
                shows_nl .
                  shows_prec_list Zero_nat [' ', 'a', 'n', 'd', ' '] .
                    shows_nl .
                      show_pat_rule ((u, (sig1, mu1)), ((v, (sig2, mu2)), b2)) .
                        x)))
                                 bc)
                          bb))
               ba)
        b);
check_pat_rule_prf r p (Pat_Inst pat rho Pat_Base) =
  bindb (check_pat_rule_prf r p pat)
    (\ (a, b) ->
      let {
        (s, (sigma_s, mu_s)) = a;
      } in (\ (aa, ba) ->
             let {
               (t, (sigma_t, mu_t)) = aa;
             } in (\ bb ->
                    catcha
                      (let {
                         xs = map fst
                                (mk_subst_domain sigma_s ++
                                  mk_subst_domain mu_s ++
                                    mk_subst_domain sigma_t ++
                                      mk_subst_domain mu_t);
                       } in bindb (catcha
                                    (forallM
                                      (\ x ->
check (not (membera xs x))
  (shows_prec_list Zero_nat
    ['d', 'o', 'm', 'a', 'i', 'n', 's', ' ', 'n', 'o', 't', ' ', 'd', 'i', 's',
      'j', 'o', 'i', 'n', 't']))
                                      (vars_subst_impl rho))
                                    (\ x -> Inl (snd x)))
                              (\ _ ->
                                let {
                                  rhoa = mk_subst Var rho;
                                } in Inr ((subst_apply_term s rhoa,
    (subst_compose_impla sigma_s rhoa, subst_compose_impla mu_s rhoa)),
   ((subst_apply_term t rhoa,
      (subst_compose_impla sigma_t rhoa, subst_compose_impla mu_t rhoa)),
     bb))))
                      (\ x ->
                        Inl (shows_prec_list Zero_nat
                               ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w',
                                 'i', 't', 'h', ' '] .
                              shows_prec_list Zero_nat
                                ['p', 'a', 't', 't', 'e', 'r', 'n', ' ', 'i',
                                  'n', 's', 't', 'a', 'n', 't', 'i', 'a', 't',
                                  'i', 'o', 'n', ' ', '(', 'b', 'a', 's', 'e',
                                  ')'] .
                                shows_prec_list Zero_nat
                                  [' ', 'a', 'f', 't', 'e', 'r', ' ', 'd', 'e',
                                    'r', 'i', 'v', 'i', 'n', 'g', ' ', 'c', 'o',
                                    'r', 'r', 'e', 'c', 't', ' ', 'p', 'a', 't',
                                    't', 'e', 'r', 'n', ' ', 'r', 'u', 'l', 'e',
                                    ' '] .
                                  shows_nl .
                                    show_pat_rule
                                      ((s, (sigma_s, mu_s)),
((t, (sigma_t, mu_t)), bb)) .
                                      x)))
               ba)
        b);
check_pat_rule_prf r p (Pat_Inst pat rho Pat_Pump) =
  bindb (check_pat_rule_prf r p pat)
    (\ (a, b) ->
      let {
        (s, (sigma_s, mu_s)) = a;
      } in (\ (aa, ba) ->
             let {
               (t, (sigma_t, mu_t)) = aa;
             } in (\ bb ->
                    catcha
                      (bindb
                        (check (commutes_impl rho sigma_s)
                          (shows_prec_list Zero_nat
                            ['r', 'h', 'o', ' ', 'd', 'o', 'e', 's', ' ', 'n',
                              'o', 't', ' ', 'c', 'o', 'm', 'm', 'u', 't', 'e',
                              ' ', 'w', 'i', 't', 'h', ' ', 's', 'i', 'g', 'm',
                              'a', '_', 's']))
                        (\ _ ->
                          bindb (check (commutes_impl rho mu_s)
                                  (shows_prec_list Zero_nat
                                    ['r', 'h', 'o', ' ', 'd', 'o', 'e', 's',
                                      ' ', 'n', 'o', 't', ' ', 'c', 'o', 'm',
                                      'm', 'u', 't', 'e', ' ', 'w', 'i', 't',
                                      'h', ' ', 'm', 'u', '_', 's']))
                            (\ _ ->
                              bindb (check (commutes_impl rho sigma_t)
                                      (shows_prec_list Zero_nat
['r', 'h', 'o', ' ', 'd', 'o', 'e', 's', ' ', 'n', 'o', 't', ' ', 'c', 'o', 'm',
  'm', 'u', 't', 'e', ' ', 'w', 'i', 't', 'h', ' ', 's', 'i', 'g', 'm', 'a',
  '_', 't']))
                                (\ _ ->
                                  bindb (check (commutes_impl rho mu_t)
  (shows_prec_list Zero_nat
    ['r', 'h', 'o', ' ', 'd', 'o', 'e', 's', ' ', 'n', 'o', 't', ' ', 'c', 'o',
      'm', 'm', 'u', 't', 'e', ' ', 'w', 'i', 't', 'h', ' ', 'm', 'u', '_',
      't']))
                                    (\ _ ->
                                      Inr
((s, (subst_compose_impl sigma_s rho, mu_s)),
  ((t, (subst_compose_impl sigma_t rho, mu_t)), bb)))))))
                      (\ x ->
                        Inl (shows_prec_list Zero_nat
                               ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w',
                                 'i', 't', 'h', ' '] .
                              shows_prec_list Zero_nat
                                ['p', 'a', 't', 't', 'e', 'r', 'n', ' ', 'i',
                                  'n', 's', 't', 'a', 'n', 't', 'i', 'a', 't',
                                  'i', 'o', 'n', ' ', '(', 'p', 'u', 'm', 'p',
                                  'i', 'n', 'g', ')'] .
                                shows_prec_list Zero_nat
                                  [' ', 'a', 'f', 't', 'e', 'r', ' ', 'd', 'e',
                                    'r', 'i', 'v', 'i', 'n', 'g', ' ', 'c', 'o',
                                    'r', 'r', 'e', 'c', 't', ' ', 'p', 'a', 't',
                                    't', 'e', 'r', 'n', ' ', 'r', 'u', 'l', 'e',
                                    ' '] .
                                  shows_nl .
                                    show_pat_rule
                                      ((s, (sigma_s, mu_s)),
((t, (sigma_t, mu_t)), bb)) .
                                      x)))
               ba)
        b);
check_pat_rule_prf r p (Pat_Inst pat rho Pat_Close) =
  bindb (check_pat_rule_prf r p pat)
    (\ (a, b) ->
      let {
        (s, (sigma_s, mu_s)) = a;
      } in (\ (aa, ba) ->
             let {
               (t, (sigma_t, mu_t)) = aa;
             } in (\ bb ->
                    Inr ((s, (sigma_s, subst_compose_impl mu_s rho)),
                          ((t, (sigma_t, subst_compose_impl mu_t rho)), bb)))
               ba)
        b);
check_pat_rule_prf r p (Pat_Rewr pat rewr Pat_Base uu) =
  bindb (check_pat_rule_prf r p pat)
    (\ (a, b) ->
      let {
        (s, (sigma_s, mu_s)) = a;
      } in (\ (aa, ba) ->
             let {
               (t, (sigma_t, mu_t)) = aa;
             } in (\ bb ->
                    catcha
                      (let {
                         (ta, rseq) = rewr;
                         tb = last (ta : map (\ (_, (_, tb)) -> tb) rseq);
                       } in bindb (check (equal_term t ta)
                                    (shows_prec_list Zero_nat
                                      ['t', 'e', 'r', 'm', 's', ' ', 't', ' ',
'd', 'o', ' ', 'n', 'o', 't', ' ', 'm', 'a', 't', 'c', 'h']))
                              (\ _ ->
                                bindb (check_rsteps r rseq ta tb)
                                  (\ _ ->
                                    Inr ((s, (sigma_s, mu_s)),
  ((tb, (sigma_t, mu_t)), bb)))))
                      (\ x ->
                        Inl (shows_prec_list Zero_nat
                               ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w',
                                 'i', 't', 'h', ' '] .
                              shows_prec_list Zero_nat
                                ['p', 'a', 't', 't', 'e', 'r', 'n', ' ', 'r',
                                  'e', 'w', 'r', 'i', 't', 'i', 'n', 'g', ' ',
                                  '(', 'b', 'a', 's', 'e', ')'] .
                                shows_prec_list Zero_nat
                                  [' ', 'a', 'f', 't', 'e', 'r', ' ', 'd', 'e',
                                    'r', 'i', 'v', 'i', 'n', 'g', ' ', 'c', 'o',
                                    'r', 'r', 'e', 'c', 't', ' ', 'p', 'a', 't',
                                    't', 'e', 'r', 'n', ' ', 'r', 'u', 'l', 'e',
                                    ' '] .
                                  shows_nl .
                                    show_pat_rule
                                      ((s, (sigma_s, mu_s)),
((t, (sigma_t, mu_t)), bb)) .
                                      x)))
               ba)
        b);
check_pat_rule_prf r p (Pat_Rewr pat rewr Pat_Pump x) =
  bindb (check_pat_rule_prf r p pat)
    (\ (a, b) ->
      let {
        (s, (sigma_s, mu_s)) = a;
      } in (\ (aa, ba) ->
             let {
               (t, (sigma_t, mu_t)) = aa;
             } in (\ bb ->
                    catcha
                      (let {
                         (ta, rseq) = rewr;
                         tb = last (ta : map (\ (_, (_, tb)) -> tb) rseq);
                       } in bindb (check
                                    (equal_term (mk_subst Var sigma_t x) ta)
                                    (shows_prec_list Zero_nat
                                      ['s', 'i', 'g', 'm', 'a', '_', 't', ' ',
'x', ' ', 'd', 'o', 'e', 's', ' ', 'n', 'o', 't', ' ', 'm', 'a', 't', 'c', 'h',
' ', 's', 't', 'a', 'r', 't', 'i', 'n', 'g', ' ', 't', 'e', 'r', 'm']))
                              (\ _ ->
                                bindb (check_rsteps r rseq ta tb)
                                  (\ _ ->
                                    Inr ((s, (sigma_s, mu_s)),
  ((t, (subst_replace_impl sigma_t x tb, mu_t)), bb)))))
                      (\ xa ->
                        Inl (shows_prec_list Zero_nat
                               ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w',
                                 'i', 't', 'h', ' '] .
                              shows_prec_list Zero_nat
                                ['p', 'a', 't', 't', 'e', 'r', 'n', ' ', 'r',
                                  'e', 'w', 'r', 'i', 't', 'i', 'n', 'g', ' ',
                                  '(', 'p', 'u', 'm', 'p', 'i', 'n', 'g', ')'] .
                                shows_prec_list Zero_nat
                                  [' ', 'a', 'f', 't', 'e', 'r', ' ', 'd', 'e',
                                    'r', 'i', 'v', 'i', 'n', 'g', ' ', 'c', 'o',
                                    'r', 'r', 'e', 'c', 't', ' ', 'p', 'a', 't',
                                    't', 'e', 'r', 'n', ' ', 'r', 'u', 'l', 'e',
                                    ' '] .
                                  shows_nl .
                                    show_pat_rule
                                      ((s, (sigma_s, mu_s)),
((t, (sigma_t, mu_t)), bb)) .
                                      xa)))
               ba)
        b);
check_pat_rule_prf r p (Pat_Rewr pat rewr Pat_Close x) =
  bindb (check_pat_rule_prf r p pat)
    (\ (a, b) ->
      let {
        (s, (sigma_s, mu_s)) = a;
      } in (\ (aa, ba) ->
             let {
               (t, (sigma_t, mu_t)) = aa;
             } in (\ bb ->
                    catcha
                      (let {
                         (ta, rseq) = rewr;
                         tb = last (ta : map (\ (_, (_, tb)) -> tb) rseq);
                       } in bindb (check (equal_term (mk_subst Var mu_t x) ta)
                                    (shows_prec_list Zero_nat
                                      ['s', 'i', 'g', 'm', 'a', '_', 't', ' ',
'x', ' ', 'd', 'o', 'e', 's', ' ', 'n', 'o', 't', ' ', 'm', 'a', 't', 'c', 'h',
' ', 's', 't', 'a', 'r', 't', 'i', 'n', 'g', ' ', 't', 'e', 'r', 'm']))
                              (\ _ ->
                                bindb (check_rsteps r rseq ta tb)
                                  (\ _ ->
                                    Inr ((s, (sigma_s, mu_s)),
  ((t, (sigma_t, subst_replace_impl mu_t x tb)), bb)))))
                      (\ xa ->
                        Inl (shows_prec_list Zero_nat
                               ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w',
                                 'i', 't', 'h', ' '] .
                              shows_prec_list Zero_nat
                                ['p', 'a', 't', 't', 'e', 'r', 'n', ' ', 'r',
                                  'e', 'w', 'r', 'i', 't', 'i', 'n', 'g', ' ',
                                  '(', 'c', 'l', 'o', 's', 'i', 'n', 'g', ')'] .
                                shows_prec_list Zero_nat
                                  [' ', 'a', 'f', 't', 'e', 'r', ' ', 'd', 'e',
                                    'r', 'i', 'v', 'i', 'n', 'g', ' ', 'c', 'o',
                                    'r', 'r', 'e', 'c', 't', ' ', 'p', 'a', 't',
                                    't', 'e', 'r', 'n', ' ', 'r', 'u', 'l', 'e',
                                    ' '] .
                                  shows_nl .
                                    show_pat_rule
                                      ((s, (sigma_s, mu_s)),
((t, (sigma_t, mu_t)), bb)) .
                                      xa)))
               ba)
        b);

check_non_loop_prf ::
  forall a b.
    (Eq a, Linorder a, Showa a, Cenum b, Ceq b, Corder b, Eq b, Linorder b,
      Showa b) => [(Term a b, Term a b)] ->
                    [(Term a b, Term a b)] ->
                      Non_loop_prf a b ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_non_loop_prf r pa (Non_Loop_Prf pat sigma mu m b p) =
  bindb (check_pat_rule_prf r pa pat)
    (\ (a, c) ->
      let {
        (s, (sigmaa, mua)) = a;
      } in (\ (aa, ca) ->
             let {
               (t, (sigma_t, mu_t)) = aa;
             } in (\ is_pair ->
                    catcha
                      (bindb
                        (check (if is_pair then equal_pos p Empty else True)
                          (shows_prec_list Zero_nat
                            ['p', ' ', 'm', 'u', 's', 't', ' ', 'b', 'e', ' ',
                              'e', 'm', 'p', 't', 'y', ',', ' ', 's', 'i', 'n',
                              'c', 'e', ' ', 'p', 'a', 'i', 'r', 's', ' ', 'a',
                              'r', 'e', ' ', 'c', 'o', 'n', 't', 'a', 'i', 'n',
                              'e', 'd']))
                        (\ _ ->
                          bindb (check (commutes_impl sigmaa sigma)
                                  (shows_prec_list Zero_nat
                                    ['s', 'i', 'g', 'm', 'a', ' ', 'a', 'n',
                                      'd', ' ', 's', 'i', 'g', 'm', 'a', '\'',
                                      ' ', 'd', 'o', ' ', 'n', 'o', 't', ' ',
                                      'c', 'o', 'm', 'm', 'u', 't', 'e']))
                            (\ _ ->
                              bindb (check (commutes_impl mua sigma)
                                      (shows_prec_list Zero_nat
['m', 'u', ' ', 'a', 'n', 'd', ' ', 's', 'i', 'g', 'm', 'a', '\'', ' ', 'd',
  'o', ' ', 'n', 'o', 't', ' ', 'c', 'o', 'm', 'm', 'u', 't', 'e']))
                                (\ _ ->
                                  bindb (check
  (subst_eq sigma_t (subst_compose_impl (subst_power_impl sigmaa m) sigma))
  (shows_prec_list Zero_nat
    ['s', 'i', 'g', 'm', 'a', '_', 't', ' ', '!', '=', ' ', 's', 'i', 'g', 'm',
      'a', '^', 'm', ' ', 's', 'i', 'g', 'm', 'a', '\'', ' ']))
                                    (\ _ ->
                                      bindb
(check (subst_eq mu_t (subst_compose_impl mua mu))
  (shows_prec_list Zero_nat
    ['m', 'u', '_', 't', ' ', '!', '=', ' ', 'm', 'u', ' ', 'm', 'u', '\'',
      ' ']))
(\ _ ->
  bindb (check (in_poss p t)
          (shows_prec_list Zero_nat
            ['p', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'p', 'o',
              's', 'i', 't', 'i', 'o', 'n', ' ', 'i', 'n', ' ', 't']))
    (\ _ ->
      check (equal_term
              (subst_apply_term s (mk_subst Var (subst_power_impl sigmaa b)))
              (subt_at t p))
        (shows_prec_list Zero_nat
          ['s', ' ', 's', 'i', 'g', 'm', 'a', '^', 'b', ' ', '!', '=', ' ', 't',
            ' ', '|', '_', ' ', 'p']))))))))
                      (\ x ->
                        Inl (shows_prec_list Zero_nat
                               ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w',
                                 'i', 't', 'h', ' '] .
                              shows_prec_list Zero_nat
                                ['a', 'p', 'p', 'l', 'i', 'c', 'a', 't', 'i',
                                  'o', 'n', ' ', 'c', 'o', 'n', 'd', 'i', 't',
                                  'i', 'o', 'n', ' ', 'o', 'f', ' ', 'n', 'o',
                                  'n', '-', 'l', 'o', 'o', 'p', ' ', 't', 'h',
                                  'e', 'o', 'r', 'e', 'm'] .
                                shows_prec_list Zero_nat
                                  [' ', 'a', 'f', 't', 'e', 'r', ' ', 'd', 'e',
                                    'r', 'i', 'v', 'i', 'n', 'g', ' ', 'c', 'o',
                                    'r', 'r', 'e', 'c', 't', ' ', 'p', 'a', 't',
                                    't', 'e', 'r', 'n', ' ', 'r', 'u', 'l', 'e',
                                    ' '] .
                                  shows_nl .
                                    show_pat_rule
                                      ((s, (sigmaa, mua)),
((t, (sigma_t, mu_t)), is_pair)) .
                                      x)))
               ca)
        c);

check_dp_nontermination_proof ::
  forall a b.
    (Cenum b, Ceq b, Corder b, Eq b, Key b, Set_impla b,
      Showa b) => ([Prelude.Char] -> [Prelude.Char]) ->
                    Dpp_ops_ext a b [Prelude.Char] () ->
                      a -> Dp_nontermination_proof b [Prelude.Char] ->
                             Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_dp_nontermination_proof ia i dpp (DP_Loop s rseq sigma c) =
  debug (ia []) ['L', 'o', 'o', 'p']
    (let {
       p = pairsa i dpp;
       r = rulesd i dpp;
       nf = is_QNFc i dpp;
       nfs = nfsc i dpp;
       q = qc i dpp;
     } in catcha (check_dp_loop q nfs nf s rseq sigma c p r)
            (\ x ->
              Inl (ia . shows_string
                          [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i', 'n',
                            ' ', 'c', 'h', 'e', 'c', 'k', 'i', 'n', 'g', ' ',
                            'l', 'o', 'o', 'p', ' ', 'f', 'o', 'r', ' ', 't',
                            'h', 'e', ' ', 'f', 'o', 'l', 'l', 'o', 'w', 'i',
                            'n', 'g', ' ', 'D', 'P', '-', 'p', 'r', 'o', 'b',
                            'l', 'e', 'm', ' '] .
                          shows_nl .
                            shows_dpp (shows_prec Zero_nat)
                              (shows_prec_list Zero_nat) i dpp .
                              shows_nl . indent x)));
check_dp_nontermination_proof ia i dpp (DP_Nonloop prf) =
  debug (ia []) ['N', 'o', 'n', 'l', 'o', 'o', 'p']
    (catcha
      (let {
         p = pairsa i dpp;
         r = rulesd i dpp;
         _ = nfsc i dpp;
       } in bindb (check (null (qc i dpp))
                    (shows_prec_list Zero_nat
                      ['s', 't', 'r', 'a', 't', 'e', 'g', 'y', ' ', 'f', 'o',
                        'r', ' ', 'n', 'o', 'n', '-', 'l', 'o', 'o', 'p', 's',
                        ' ', 'u', 'n', 's', 'u', 'p', 'p', 'o', 'r', 't', 'e',
                        'd']))
              (\ _ -> check_non_loop_prf r p prf))
      (\ x ->
        Inl (ia . shows_string
                    [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ', 'c',
                      'h', 'e', 'c', 'k', 'i', 'n', 'g', ' ', 'n', 'o', 'n',
                      'l', 'o', 'o', 'p', ' ', 'f', 'o', 'r', ' ', 't', 'h',
                      'e', ' ', 'f', 'o', 'l', 'l', 'o', 'w', 'i', 'n', 'g',
                      ' ', 'D', 'P', '-', 'p', 'r', 'o', 'b', 'l', 'e', 'm',
                      ' '] .
                    shows_nl .
                      shows_dpp (shows_prec Zero_nat) (shows_prec_list Zero_nat)
                        i dpp .
                        shows_nl . indent x)));
check_dp_nontermination_proof ia i dpp (DP_Rule_Removal p r prf) =
  debug (ia []) ['R', 'u', 'l', 'e', ' ', 'R', 'e', 'm', 'o', 'v', 'a', 'l']
    (let {
       prm = (if is_none p then [] else ceta_list_diff (pairsa i dpp) (the p));
       rrm = (if is_none r then [] else ceta_list_diff (rulesd i dpp) (the r));
     } in catcha
            (check_dp_nontermination_proof (ia . shows_string ['.', '1']) i
              (delete_R_Rwc i (delete_P_Pwa i dpp prm prm) rrm rrm) prf)
            (\ x ->
              Inl (ia . shows_string
                          [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e',
                            'l', 'o', 'w', ' ', 't', 'h', 'e', ' ', 'p', 'a',
                            'i', 'r', '/', 'r', 'u', 'l', 'e', ' ', 'r', 'e',
                            'm', 'o', 'v', 'a', 'l'] .
                          shows_nl . indent x)));
check_dp_nontermination_proof ia i dpp (DP_Q_Reduction q prf) =
  debug (ia []) ['Q', ' ', 'r', 'e', 'd', 'u', 'c', 't', 'i', 'o', 'n']
    (let {
       p = pairsa i dpp;
       r = rulesd i dpp;
       qa = qc i dpp;
       nfs = nfsc i dpp;
       f = set (funas_trs_list (p ++ r));
       rQ = filter (\ qb -> less_eq_set (funas_term qb) f) qa;
     } in bindb (catcha
                  (catcha (check_NF_terms_subset q rQ)
                    (\ x ->
                      Inl (shows_prec_list Zero_nat
                             ['t', 'h', 'e', ' ', 't', 'e', 'r', 'm', ' '] .
                            shows_prec_term Zero_nat x .
                              shows_prec_list Zero_nat
                                [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i',
                                  'n', 'g', ' ', 'i', 'n', ' ', 'Q', '\'',
                                  ' '])))
                  (\ x ->
                    Inl (ia . shows_string
                                [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i',
                                  'n', ' ', 'r', 'e', 'd', 'u', 'c', 'i', 'n',
                                  'g', ' ', 't', 'h', 'e', ' ', 'i', 'n', 'n',
                                  'e', 'r', 'm', 'o', 's', 't', ' ', 'l', 'h',
                                  's', 's', ' ', 'i', 'n', ' ', 't', 'h', 'e',
                                  ' ', 'f', 'o', 'l', 'l', 'o', 'w', 'i', 'n',
                                  'g', ' ', 'D', 'P', '-', 'p', 'r', 'o', 'b',
                                  'l', 'e', 'm', ' '] .
                                shows_nl .
                                  shows_dpp (shows_prec Zero_nat)
                                    (shows_prec_list Zero_nat) i dpp .
                                    shows_nl . indent x)))
            (\ _ ->
              catcha
                (check_dp_nontermination_proof (ia . shows_string ['.', '1']) i
                  (mkc i nfs False p [] q [] r) prf)
                (\ x ->
                  Inl (ia . shows_string
                              [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e',
                                'l', 'o', 'w', ' ', 't', 'h', 'e', ' ', 'Q',
                                ' ', 'r', 'e', 'd', 'u', 'c', 't', 'i', 'o',
                                'n'] .
                              shows_nl . indent x))));
check_dp_nontermination_proof ia i dpp (DP_Q_Increase q prf) =
  debug (ia []) ['Q', ' ', 'i', 'n', 'c', 'r', 'e', 'a', 's', 'e']
    (let {
       p = pairsa i dpp;
       r = rulesd i dpp;
       qa = qc i dpp;
       nfs = nfsc i dpp;
     } in catcha
            (check_dp_nontermination_proof (ia . shows_string ['.', '1']) i
              (mkc i nfs False p [] (list_union qa q) [] r) prf)
            (\ x ->
              Inl (ia . shows_string
                          [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e',
                            'l', 'o', 'w', ' ', 't', 'h', 'e', ' ', 'Q', ' ',
                            'i', 'n', 'c', 'r', 'e', 'a', 's', 'e'] .
                          shows_nl . indent x)));
check_dp_nontermination_proof ia i dpp (DP_Termination_Switch joins_o prf) =
  debug (ia [])
    ['S', 'w', 'i', 't', 'c', 'h', ' ', 't', 'o', ' ', 'T', 'e', 'r', 'm', 'i',
      'n', 'a', 't', 'i', 'o', 'n']
    (bindb
      (catcha (switch_termination_proc i joins_o dpp)
        (\ x ->
          Inl (ia . shows_string
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ',
                        's', 'w', 'i', 't', 'c', 'h', 'i', 'n', 'g', ' ', 't',
                        'o', ' ', 'f', 'u', 'l', 'l', ' ', 's', 't', 'r', 'a',
                        't', 'e', 'g', 'y', ' ', 'f', 'o', 'r', ' ', 't', 'h',
                        'e', ' ', 'D', 'P', '-', 'p', 'r', 'o', 'b', 'l', 'e',
                        'm', ' '] .
                      shows_nl .
                        shows_dpp (shows_prec Zero_nat)
                          (shows_prec_list Zero_nat) i dpp .
                          shows_nl . indent x)))
      (\ dppa ->
        catcha
          (check_dp_nontermination_proof (ia . shows_string ['.', '1']) i dppa
            prf)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                          'o', 'w', ' ', 't', 'h', 'e', ' ', 't', 'e', 'r', 'm',
                          'i', 'n', 'a', 't', 'i', 'o', 'n', ' ', 's', 'w', 'i',
                          't', 'c', 'h', ' ', 'p', 'r', 'o', 'c', 'e', 's', 's',
                          'o', 'r'] .
                        shows_nl . indent x))));
check_dp_nontermination_proof ia i dpp (DP_Instantiation p prf) =
  debug (ia [])
    ['I', 'n', 's', 't', 'a', 'n', 't', 'i', 'a', 't', 'i', 'o', 'n']
    (let {
       pa = pairsa i dpp;
       q = qc i dpp;
       r = rulesd i dpp;
       nfs = nfsc i dpp;
     } in bindb (catcha
                  (bindb
                    (check (not nfs || null q)
                      (shows_prec_list Zero_nat
                        ['n', 'o', 'r', 'm', 'a', 'l', ' ', 'f', 'o', 'r', 'm',
                          ' ', 's', 'u', 'b', 's', 't', '.', ' ', 'c', 'u', 'r',
                          'r', 'e', 'n', 't', 'l', 'y', ' ', 'n', 'o', 't', ' ',
                          's', 'u', 'p', 'p', 'o', 'r', 't', 'e', 'd', ' ', 'f',
                          'o', 'r', ' ', 'i', 'n', 'n', 'e', 'r', 'm', 'o', 's',
                          't']))
                    (\ _ -> check_instance pa p))
                  (\ x ->
                    Inl (ia . shows_string
                                [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w',
                                  'h', 'e', 'n', ' ', 'i', 'n', 's', 't', 'a',
                                  'n', 't', 'i', 'a', 't', 'i', 'n', 'g', ' ',
                                  't', 'h', 'e', ' ', 'f', 'o', 'l', 'l', 'o',
                                  'w', 'i', 'n', 'g', ' ', 'D', 'P', '-', 'p',
                                  'r', 'o', 'b', 'l', 'e', 'm', ' '] .
                                shows_nl .
                                  shows_dpp (shows_prec Zero_nat)
                                    (shows_prec_list Zero_nat) i dpp .
                                    shows_nl . indent x)))
            (\ _ ->
              catcha
                (check_dp_nontermination_proof (ia . shows_string ['.', '1']) i
                  (mkc i nfs False p [] q [] r) prf)
                (\ x ->
                  Inl (ia . shows_string
                              [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e',
                                'l', 'o', 'w', ' ', 't', 'h', 'e', ' ', 'i',
                                'n', 's', 't', 'a', 'n', 't', 'i', 'a', 't',
                                'i', 'o', 'n'] .
                              shows_nl . indent x))));
check_dp_nontermination_proof ia i dpp (DP_Rewriting u_opt stb sta st lr p prf)
  = debug (ia []) ['R', 'e', 'w', 'r', 'i', 't', 'i', 'n', 'g']
      (bindb
        (catcha (rewriting_complete_proc i u_opt stb sta st lr p dpp)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e',
                          'n', ' ', 'a', 'p', 'p', 'l', 'y', 'i', 'n', 'g', ' ',
                          't', 'h', 'e', ' ', 'r', 'e', 'w', 'r', 'i', 't', 'i',
                          'n', 'g', ' ', 'p', 'r', 'o', 'c', 'e', 's', 's', 'o',
                          'r', ' ', 't', 'o', ' ', 'r', 'e', 'w', 'r', 'i', 't',
                          'e', ' ', 't', 'h', 'e', ' ', 'p', 'a', 'i', 'r',
                          ' '] .
                        shows_nl .
                          shows_rule (shows_prec Zero_nat)
                            (shows_prec_list Zero_nat) [' ', '-', '>', ' ']
                            stb .
                            shows_nl .
                              shows_string
                                [' ', 't', 'o', ' ', 't', 'h', 'e', ' ', 'p',
                                  'a', 'i', 'r', ' '] .
                                shows_nl .
                                  shows_rule (shows_prec Zero_nat)
                                    (shows_prec_list Zero_nat)
                                    [' ', '-', '>', ' '] st .
                                    shows_nl . x)))
        (\ dppa ->
          catcha
            (check_dp_nontermination_proof (ia . shows_string ['.', '1']) i dppa
              prf)
            (\ x ->
              Inl (ia . shows_string
                          [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e',
                            'l', 'o', 'w', ' ', 't', 'h', 'e', ' ', 'r', 'e',
                            'w', 'r', 'i', 't', 'i', 'n', 'g', ' ', 'p', 'r',
                            'o', 'c', 'e', 's', 's', 'o', 'r'] .
                          shows_nl . indent x))));
check_dp_nontermination_proof ia i dpp (DP_Narrowing st p sts prf) =
  debug (ia []) ['N', 'a', 'r', 'r', 'o', 'w', 'i', 'n', 'g']
    (bindb
      (catcha (narrowing_complete_proc i st p sts dpp)
        (\ x ->
          Inl (ia . shows_string
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e',
                        'n', ' ', 'a', 'p', 'p', 'l', 'y', 'i', 'n', 'g', ' ',
                        't', 'h', 'e', ' ', 'n', 'a', 'r', 'r', 'o', 'w', 'i',
                        'n', 'g', ' ', 'p', 'r', 'o', 'c', 'e', 's', 's', 'o',
                        'r', ' ', 't', 'o', ' ', 'r', 'e', 'w', 'r', 'i', 't',
                        'e', ' ', 't', 'h', 'e', ' ', 'p', 'a', 'i', 'r', ' '] .
                      shows_nl .
                        shows_rule (shows_prec Zero_nat)
                          (shows_prec_list Zero_nat) [' ', '-', '>', ' '] st .
                          shows_nl .
                            shows_string
                              [' ', 't', 'o', ' ', 't', 'h', 'e', ' ', 'p', 'a',
                                'i', 'r', 's', ' '] .
                              shows_nl .
                                shows_trs (shows_prec Zero_nat)
                                  (shows_prec_list Zero_nat)
                                  ['r', 'e', 'w', 'r', 'i', 't', 'e', ' ', 's',
                                    'y', 's', 't', 'e', 'm', ':']
                                  [' ', '-', '>', ' '] sts .
                                  shows_nl . x)))
      (\ dppa ->
        catcha
          (check_dp_nontermination_proof (ia . shows_string ['.', '1']) i dppa
            prf)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                          'o', 'w', ' ', 't', 'h', 'e', ' ', 'r', 'e', 'w', 'r',
                          'i', 't', 'i', 'n', 'g', ' ', 'p', 'r', 'o', 'c', 'e',
                          's', 's', 'o', 'r'] .
                        shows_nl . indent x))));

applicable_rule_impl ::
  forall a b. (Term a b -> Bool) -> (Term a b, Term a b) -> Bool;
applicable_rule_impl nf r = all nf (args (fst r));

check_wwf_qtrs ::
  forall a b.
    (Showa a, Eq b,
      Showa b) => (Term a b -> Bool) ->
                    [(Term a b, Term a b)] ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_wwf_qtrs nf r =
  catcha
    (catcha
      (forallM
        (\ ra ->
          (if applicable_rule_impl nf ra
            then catcha
                   (bindb
                     (check (not (is_Var (fst ra)))
                       (shows_string
                         ['v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', ' ', 'l', 'e',
                           'f', 't', '-', 'h', 'a', 'n', 'd', ' ', 's', 'i',
                           'd', 'e', ' ', 'i', 'n']))
                     (\ _ ->
                       catcha
                         (check_subseteq (vars_term_lista (snd ra))
                           (vars_term_lista (fst ra)))
                         (\ x ->
                           Inl (shows_string
                                  ['f', 'r', 'e', 'e', ' ', 'v', 'a', 'r', 'i',
                                    'a', 'b', 'l', 'e', ' '] .
                                 shows_prec Zero_nat x .
                                   shows_string
                                     [' ', 'i', 'n', ' ', 'r', 'i', 'g', 'h',
                                       't', '-', 'h', 'a', 'n', 'd', ' ', 's',
                                       'i', 'd', 'e', ' ', 'o', 'f']))))
                   (\ x ->
                     Inl (x . shows_string [' ', 'r', 'u', 'l', 'e', ' '] .
                                shows_rule (shows_prec Zero_nat)
                                  (shows_prec Zero_nat) [' ', '-', '>', ' ']
                                  ra .
                                  shows_nl))
            else Inr ()))
        r)
      (\ x -> Inl (snd x)))
    (\ x ->
      Inl (shows_string
             ['t', 'h', 'e', ' ', 'Q', '-', 'T', 'R', 'S', ' ', 'i', 's', ' ',
               'n', 'o', 't', ' ', 'w', 'e', 'a', 'k', 'l', 'y', ' ', 'w', 'e',
               'l', 'l', '-', 'f', 'o', 'r', 'm', 'e', 'd'] .
            shows_nl . x));

check_not_wwf_qtrs ::
  forall a b.
    (Key a, Showa a, Eq b, Key b,
      Showa b) => (Term a b -> Bool) ->
                    [(Term a b, Term a b)] ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_not_wwf_qtrs nf r =
  check (not (isOK (check_wwf_qtrs nf r)))
    (shows_string
       ['T', 'h', 'e', ' ', 'Q', '-', 'T', 'R', 'S', ' ', 'i', 's', ' ', 'w',
         'e', 'l', 'l', ' ', 'f', 'o', 'r', 'm', 'e', 'd'] .
      shows_nl);

check_dps ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => (a -> a) ->
                    [(Term a b, Term a b)] ->
                      [(Term a b, Term a b)] -> Sum (Term a b, Term a b) ();
check_dps unshp r p =
  let {
    d = defs_list r;
  } in catcha
         (forallM
           (\ x ->
             (if let {
                   (ll, rr) = x;
                 } in not (is_Var rr) &&
                        not (membera d (the (root rr))) &&
                          any (\ (l, ra) ->
                                equal_term l (sharp_term unshp ll) &&
                                  (equal_term ra (sharp_term unshp rr) ||
                                    supt_impl ra (sharp_term unshp rr)))
                            r
               then Inr () else Inl x))
           p)
         (\ x -> Inl (snd x));

unsharp :: forall a b. Lab a b -> Lab a b;
unsharp (Sharp f) = f;
unsharp (Lab v va) = Lab v va;
unsharp (FunLab v va) = FunLab v va;
unsharp (UnLab v) = UnLab v;

check_trs_nontermination_proof ::
  forall a b c d.
    (Eq b, Key b, Showa b, Eq c, Key c,
      Showa c) => ([Prelude.Char] -> [Prelude.Char]) ->
                    Tp_ops_ext a (Lab b c) [Prelude.Char] () ->
                      Dpp_ops_ext d (Lab b c) [Prelude.Char] () ->
                        a -> Trs_nontermination_proof (Lab b c)
                               [Prelude.Char] ->
                               Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_trs_nontermination_proof ia i j tp (TRS_Loop s rseq sigma c) =
  debug (ia []) ['L', 'o', 'o', 'p']
    (let {
       r = rulesb i tp;
       nf = is_QNFa i tp;
       q = qa i tp;
       nfs = nfsa i tp;
     } in catcha (check_loop q nfs nf s rseq sigma c r)
            (\ x ->
              Inl (ia . shows_string
                          [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h',
                            'e', 'n', ' ', 'c', 'h', 'e', 'c', 'k', 'i', 'n',
                            'g', ' ', 'l', 'o', 'o', 'p', ' ', 'o', 'f', ' '] .
                          shows_nl .
                            shows_tp (shows_prec_lab Zero_nat)
                              (shows_prec_list Zero_nat) i tp .
                              shows_nl . indent x)));
check_trs_nontermination_proof ia i j tp (TRS_Nonloop prf) =
  debug (ia []) ['N', 'o', 'n', 'l', 'o', 'o', 'p']
    (catcha
      (let {
         r = rulesb i tp;
       } in bindb (check (null (qa i tp))
                    (shows_prec_list Zero_nat
                      ['s', 't', 'r', 'a', 't', 'e', 'g', 'y', ' ', 'f', 'o',
                        'r', ' ', 'n', 'o', 'n', '-', 'l', 'o', 'o', 'p', 's',
                        ' ', 'u', 'n', 's', 'u', 'p', 'p', 'o', 'r', 't', 'e',
                        'd']))
              (\ _ -> check_non_loop_prf r [] prf))
      (\ x ->
        Inl (shows_prec_list Zero_nat
               ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'c', 'h',
                 'e', 'c', 'k', 'i', 'n', 'g', ' ', 'n', 'o', 'n', '-', 'l',
                 'o', 'o', 'p', 'i', 'n', 'g', ' ', 'r', 'e', 'd', 'u', 'c',
                 't', 'i', 'o', 'n', ' ', 'f', 'o', 'r', ' '] .
              shows_nl .
                shows_tp (shows_prec_lab Zero_nat) (shows_prec_list Zero_nat) i
                  tp .
                  indent x)));
check_trs_nontermination_proof ia i j tp TRS_Not_Well_Formed =
  debug (ia [])
    ['N', 'o', 't', ' ', 'W', 'e', 'l', 'l', '-', 'F', 'o', 'r', 'm', 'e', 'd']
    (bindb
      (check (null (qa i tp) || not (nfsa i tp))
        (shows_prec_list Zero_nat
          ['s', 't', 'r', 'a', 't', 'e', 'g', 'i', 'e', 's', ' ', 'a', 'n', 'd',
            ' ', 'n', 'o', 'r', 'm', 'a', 'l', ' ', 'f', 'o', 'r', 'm', ' ',
            's', 'u', 'b', 's', 't', 'i', 't', 'u', 't', 'i', 'o', 'n', 's',
            ' ', 'p', 'r', 'o', 'b', 'l', 'e', 'm']))
      (\ _ ->
        catcha (check_not_wwf_qtrs (is_QNFa i tp) (rulesb i tp))
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ',
                          'n', 'o', 't', ' ', 'w', 'e', 'l', 'l', '-', 'f', 'o',
                          'r', 'm', 'e', 'd', ' ', 'p', 'r', 'o', 'o', 'f'] .
                        shows_nl . x))));
check_trs_nontermination_proof ia i j tp (TRS_Rule_Removal r prf) =
  debug (ia []) ['R', 'u', 'l', 'e', ' ', 'R', 'e', 'm', 'o', 'v', 'a', 'l']
    (let {
       ra = rulesb i tp;
       rrm = ceta_list_diff ra r;
     } in catcha
            (check_trs_nontermination_proof (ia . shows_string ['.', '1']) i j
              (delete_R_Rwa i tp rrm rrm) prf)
            (\ x ->
              Inl (ia . shows_string
                          [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e',
                            'l', 'o', 'w', ' ', 't', 'h', 'e', ' ', 'r', 'u',
                            'l', 'e', ' ', 'r', 'e', 'm', 'o', 'v', 'a', 'l'] .
                          shows_nl . indent x)));
check_trs_nontermination_proof ia i j tp (TRS_String_Reversal prf) =
  debug (ia [])
    ['S', 't', 'r', 'i', 'n', 'g', ' ', 'R', 'e', 'v', 'e', 'r', 's', 'a', 'l']
    (let {
       r = rulesb i tp;
     } in bindb (catcha
                  (bindb
                    (check (q_emptya i tp)
                      (shows_prec_list Zero_nat
                        ['Q', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'e', 'm',
                          'p', 't', 'y']))
                    (\ _ ->
                      (case check_unary_signature r of {
                        Inl a -> Inl a;
                        Inr _ -> Inr (mka i False [] (map rev_rule r) []);
                      })))
                  (\ x ->
                    Inl (ia . shows_string
                                [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w',
                                  'h', 'e', 'n', ' ', 'a', 'p', 'p', 'l', 'y',
                                  'i', 'n', 'g', ' ', 's', 't', 'r', 'i', 'n',
                                  'g', ' ', 'r', 'e', 'v', 'e', 'r', 's', 'a',
                                  'l', ' ', 'o', 'n'] .
                                shows_nl .
                                  shows_tp (shows_prec_lab Zero_nat)
                                    (shows_prec_list Zero_nat) i tp .
                                    shows_nl . x)))
            (\ tpa ->
              catcha
                (check_trs_nontermination_proof (ia . shows_string ['.', '1']) i
                  j tpa prf)
                (\ x ->
                  Inl (ia . shows_string
                              [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e',
                                'l', 'o', 'w', ' ', 't', 'h', 'e', ' ', 's',
                                't', 'r', 'i', 'n', 'g', ' ', 'r', 'e', 'v',
                                'e', 'r', 's', 'a', 'l', ' ', 't', 'e', 'c',
                                'h', 'n', 'i', 'q', 'u', 'e'] .
                              shows_nl . indent x))));
check_trs_nontermination_proof ia i j tp (TRS_DP_Trans p prf) =
  debug (ia [])
    ['D', 'P', ' ', 'T', 'r', 'a', 'n', 's', 'f', 'o', 'r', 'm', 'a', 't', 'i',
      'o', 'n']
    (let {
       r = rulesb i tp;
       q = qa i tp;
     } in bindb (catcha
                  (bindb
                    (check (null (qa i tp) || not (nfsa i tp))
                      (shows_prec_list Zero_nat
                        ['s', 't', 'r', 'a', 't', 'e', 'g', 'i', 'e', 's', ' ',
                          'a', 'n', 'd', ' ', 'n', 'o', 'r', 'm', 'a', 'l', ' ',
                          'f', 'o', 'r', 'm', ' ', 's', 'u', 'b', 's', 't', 'i',
                          't', 'u', 't', 'i', 'o', 'n', 's', ' ', 'p', 'r', 'o',
                          'b', 'l', 'e', 'm']))
                    (\ _ ->
                      catcha (check_dps unsharp r p)
                        (\ x ->
                          Inl (shows_prec_list Zero_nat
                                 ['p', 'r', 'o', 'b', 'l', 'e', 'm', 'a', 't',
                                   'i', 'c', ' ', 'r', 'u', 'l', 'e', ':',
                                   ' '] .
                                shows_rule (shows_prec_lab Zero_nat)
                                  (shows_prec_list Zero_nat)
                                  [' ', '-', '>', ' '] x))))
                  (\ x ->
                    Inl (ia . shows_string
                                [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i',
                                  'n', ' ', 'D', 'P', ' ', 't', 'r', 'a', 'n',
                                  's', 'f', 'o', 'r', 'm', 'a', 't', 'i', 'o',
                                  'n', ' ', 'o', 'n', ' '] .
                                shows_nl .
                                  shows_tp (shows_prec_lab Zero_nat)
                                    (shows_prec_list Zero_nat) i tp .
                                    shows_nl . x)))
            (\ _ ->
              let {
                dpp = mkc j False False p [] q [] r;
              } in catcha
                     (check_dp_nontermination_proof
                       (ia . shows_string ['.', '1']) j dpp prf)
                     (\ x ->
                       Inl (ia . shows_string
                                   [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b',
                                     'e', 'l', 'o', 'w', ' ', 't', 'h', 'e',
                                     ' ', 'd', 'p', ' ', 't', 'r', 'a', 'n',
                                     's', 'f', 'o', 'r', 'm', 'a', 't', 'i',
                                     'o', 'n'] .
                                   shows_nl . indent x))));
check_trs_nontermination_proof ia i j tp (TRS_Q_Increase q prf) =
  debug (ia []) ['Q', ' ', 'i', 'n', 'c', 'r', 'e', 'a', 's', 'e']
    (let {
       r = rulesb i tp;
       qaa = qa i tp;
       tpa = mka i (nfsa i tp) (list_union qaa q) r [];
     } in catcha
            (check_trs_nontermination_proof (ia . shows_string ['.', '1']) i j
              tpa prf)
            (\ x ->
              Inl (ia . shows_string
                          [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e',
                            'l', 'o', 'w', ' ', 't', 'h', 'e', ' ', 'Q', ' ',
                            'i', 'n', 'c', 'r', 'e', 'a', 's', 'e', ' ', 't',
                            'e', 'c', 'h', 'n', 'i', 'q', 'u', 'e'] .
                          shows_nl . indent x)));

check_wf_reltrs ::
  forall a b.
    (Showa a, Eq b,
      Showa b) => ([(Term a b, Term a b)], [(Term a b, Term a b)]) ->
                    Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_wf_reltrs (r, s) =
  bindb (check_wf_trs r)
    (\ _ ->
      (if null r then Inr ()
        else catcha
               (forallM
                 (\ rule ->
                   catcha
                     (catcha
                       (check_subseteq (vars_term_lista (snd rule))
                         (vars_term_lista (fst rule)))
                       (\ x ->
                         Inl (shows_string
                                ['f', 'r', 'e', 'e', ' ', 'v', 'a', 'r', 'i',
                                  'a', 'b', 'l', 'e', ' '] .
                               shows_prec Zero_nat x .
                                 shows_string
                                   [' ', 'i', 'n', ' ', 'r', 'i', 'g', 'h', 't',
                                     '-', 'h', 'a', 'n', 'd', ' ', 's', 'i',
                                     'd', 'e', ' ', 'o', 'f'])))
                     (\ x ->
                       Inl (x . shows_string [' ', 'r', 'u', 'l', 'e', ' '] .
                                  shows_rule (shows_prec Zero_nat)
                                    (shows_prec Zero_nat) [' ', '-', '>', ' ']
                                    rule .
                                    shows_nl)))
                 s)
               (\ x -> Inl (snd x))));

check_not_wf_reltrs ::
  forall a b.
    (Showa a, Eq b,
      Showa b) => ([(Term a b, Term a b)], [(Term a b, Term a b)]) ->
                    Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_not_wf_reltrs rs =
  check (not (isOK (check_wf_reltrs rs)))
    (shows_string
       ['T', 'h', 'e', ' ', 'T', 'R', 'S', 's', ' ', 'R', ' ', 'a', 'n', 'd',
         ' ', 'S', ' ', 'a', 'r', 'e', ' ', 'w', 'e', 'l', 'l', ' ', 'f', 'o',
         'r', 'm', 'e', 'd'] .
      shows_nl);

check_rel_seq ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    [(Term a b, Term a b)] ->
                      [(Pos, ((Term a b, Term a b), (Bool, Term a b)))] ->
                        Term a b ->
                          Term a b ->
                            Bool -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_rel_seq r sa [] s u True =
  check (equal_term s u)
    (shows_string
       ['t', 'h', 'e', ' ', 'l', 'a', 's', 't', ' ', 't', 'e', 'r', 'm', ' ',
         'o', 'f', ' ', 't', 'h', 'e', ' ', 'r', 'e', 'w', 'r', 'i', 't', 'e',
         ' ', 's', 'e', 'q', 'u', 'e', 'n', 'c', 'e'] .
      shows_nl .
        shows_prec_term Zero_nat s .
          shows_string
            (shows_nl
              ['d', 'o', 'e', 's', ' ', 'n', 'o', 't', ' ', 'c', 'o', 'r', 'r',
                'e', 's', 'p', 'o', 'n', 'd', ' ', 't', 'o', ' ', 't', 'h', 'e',
                ' ', 'g', 'o', 'a', 'l', ' ', 't', 'e', 'r', 'm']) .
            shows_nl . shows_prec_term Zero_nat u . shows_nl);
check_rel_seq r sa [] s u False =
  Inl (shows_prec_list Zero_nat
        ['d', 'i', 'd', ' ', 'n', 'o', 't', ' ', 'f', 'i', 'n', 'd', ' ', 's',
          't', 'r', 'i', 'c', 't', ' ', 's', 't', 'e', 'p', ' ', 'i', 'n', ' ',
          'r', 'e', 'w', 'r', 'i', 't', 'e', ' ', 's', 'e', 'q', 'u', 'e', 'n',
          'c', 'e']);
check_rel_seq ra sa ((p, (r, (True, t))) : prts) s u b =
  bindb (check_qrstep (\ _ -> True) False ra p r s t)
    (\ _ -> check_rel_seq ra sa prts t u True);
check_rel_seq ra sa ((p, (r, (False, t))) : prts) s u b =
  bindb (check_qrstep (\ _ -> True) False sa p r s t)
    (\ _ -> check_rel_seq ra sa prts t u b);

check_rel_loop ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => Term a b ->
                    [(Pos, ((Term a b, Term a b), (Bool, Term a b)))] ->
                      [(b, Term a b)] ->
                        Ctxt a b ->
                          [(Term a b, Term a b)] ->
                            [(Term a b, Term a b)] ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_rel_loop sa rseq sigma c r s =
  check_rel_seq r s rseq sa
    (ctxt_apply c (subst_apply_term sa (mk_subst Var sigma))) False;

check_reltrs_nontermination_proof ::
  forall a b c d.
    (Eq b, Key b, Showa b, Eq c, Key c,
      Showa c) => ([Prelude.Char] -> [Prelude.Char]) ->
                    Tp_ops_ext a (Lab b c) [Prelude.Char] () ->
                      Dpp_ops_ext d (Lab b c) [Prelude.Char] () ->
                        a -> Reltrs_nontermination_proof (Lab b c)
                               [Prelude.Char] ->
                               Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_reltrs_nontermination_proof ia i j tp (Rel_Loop s rseq sigma c) =
  debug (ia []) ['L', 'o', 'o', 'p']
    (let {
       r = ra i tp;
       sa = rwa i tp;
     } in bindb (check (q_emptya i tp)
                  (shows_prec_list Zero_nat
                    ['Q', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'e', 'm', 'p',
                      't', 'y']))
            (\ _ ->
              catcha (check_rel_loop s rseq sigma c r sa)
                (\ x ->
                  Inl (ia . shows_string
                              [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i', 'n',
                                ' ', 'l', 'o', 'o', 'p', ' ', 'p', 'r', 'o',
                                'o', 'f'] .
                              shows_nl . x))));
check_reltrs_nontermination_proof ia i j tp (Rel_R_Not_SN prf) =
  let {
    q = qa i tp;
    r = ra i tp;
    nfs = nfsa i tp;
    tpa = mka i nfs q r [];
  } in catcha
         (check_trs_nontermination_proof (ia . shows_string ['.', '1']) i j tpa
           prf)
         (\ x ->
           Inl (ia . shows_string
                       [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                         'o', 'w', ' ', 't', 'h', 'e', ' ', 'n', 'o', 'n', 't',
                         'e', 'r', 'm', 'i', 'n', 'a', 't', 'i', 'o', 'n', ' ',
                         'p', 'r', 'o', 'o', 'f', ' ', 'f', 'o', 'r', ' ',
                         'R'] .
                       shows_nl . indent x));
check_reltrs_nontermination_proof ia i j tp Rel_Not_Well_Formed =
  debug (ia [])
    ['N', 'o', 't', ' ', 'W', 'e', 'l', 'l', '-', 'F', 'o', 'r', 'm', 'e', 'd']
    (let {
       r = ra i tp;
       s = rwa i tp;
     } in catcha
            (bindb
              (check (q_emptya i tp)
                (shows_prec_list Zero_nat
                  ['Q', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'e', 'm', 'p',
                    't', 'y']))
              (\ _ -> check_not_wf_reltrs (r, s)))
            (\ x ->
              Inl (ia . shows_string
                          [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i', 'n',
                            ' ', 'n', 'o', 't', '-', 'w', 'e', 'l', 'l', '-',
                            'f', 'o', 'r', 'm', 'e', 'd', ' ', 'p', 'r', 'o',
                            'o', 'f'] .
                          shows_nl . x)));
check_reltrs_nontermination_proof ia i j tp (Rel_Rule_Removal r s prf) =
  debug (ia []) ['R', 'u', 'l', 'e', ' ', 'R', 'e', 'm', 'o', 'v', 'a', 'l']
    (let {
       rrm = (if is_none r then [] else ceta_list_diff (ra i tp) (the r));
       srm = (if is_none s then [] else ceta_list_diff (rwa i tp) (the s));
     } in catcha
            (check_reltrs_nontermination_proof (ia . shows_string ['.', '1']) i
              j (delete_R_Rwa i tp rrm srm) prf)
            (\ x ->
              Inl (ia . shows_string
                          [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e',
                            'l', 'o', 'w', ' ', 't', 'h', 'e', ' ', 'r', 'u',
                            'l', 'e', ' ', 'r', 'e', 'm', 'o', 'v', 'a', 'l'] .
                          shows_nl . indent x)));

shows_prec_location :: Nat -> Location -> [Prelude.Char] -> [Prelude.Char];
shows_prec_location uu A = shows_prec_list Zero_nat ['a', 'b', 'o', 'v', 'e'];
shows_prec_location uv Ba = shows_prec_list Zero_nat ['b', 'e', 'l', 'o', 'w'];
shows_prec_location uw H = shows_prec_list Zero_nat ['h', 'e', 'r', 'e'];

shows_pattern ::
  forall a b.
    (Showa a,
      Showa b) => (Ctxt a b, (Term a b, Location)) ->
                    [Prelude.Char] -> [Prelude.Char];
shows_pattern (c, (s, p)) =
  shows_prec_list Zero_nat ['('] .
    shows_prec_term Zero_nat (ctxt_apply c s) .
      shows_prec_list Zero_nat [',', ' '] .
        shows_prec_pos Zero_nat (hole_pos c) .
          shows_prec_list Zero_nat [',', ' '] .
            shows_prec_location Zero_nat p . shows_prec_list Zero_nat [')'];

pos_dec :: Pos -> Pos -> Pos -> Maybe (Nat, Pos);
pos_dec p q oo =
  (if equal_pos p Empty
    then (case pos_suffix oo q of {
           Nothing -> Nothing;
           Just r -> Just (Zero_nat, r);
         })
    else let {
           n0 = nat (ceiling
                      (divide_rat
                        (of_nat (minus_nat (size_pos oo) (size_pos q)))
                        (of_nat (size_pos p))));
         } in (case pos_suffix oo (append (power p n0) q) of {
                Nothing -> Nothing;
                Just r -> Just (n0, r);
              }));

ctxt_subst ::
  forall a b. Ctxt a b -> (b -> Term a b) -> Nat -> Term a b -> Term a b;
ctxt_subst uu uv n t =
  (if equal_nat n Zero_nat then t
    else ctxt_apply uu
           (subst_apply_term (ctxt_subst uu uv (minus_nat n (Nat_of_num One)) t)
             uv));

h_match_probs ::
  forall a b.
    (Eq a, Linorder a, Eq b,
      Linorder b) => (a -> Term b a) ->
                       Term b a ->
                         Pos ->
                           Pos ->
                             Ctxt b a -> Term b a -> Set (Term b a, Term b a);
h_match_probs mu l oo q c t =
  (case pos_dec (hole_pos c) q oo of {
    Nothing ->
      set_empty
        (of_phantom (set_impl_prod :: Phantom (Term b a, Term b a) Set_impl));
    Just (n, o) ->
      inserta (subt_at (ctxt_subst c mu n t) o, l)
        (set_empty
          (of_phantom
            (set_impl_prod :: Phantom (Term b a, Term b a) Set_impl)));
  });

fp_H_decide ::
  forall a b.
    (Eq a, Linorder a, Ceq b, Corder b, Eq b,
      Linorder b) => Subst_incr a b ->
                       Term a b -> Pos -> Pos -> Ctxt a b -> Term a b -> Bool;
fp_H_decide mu l oo q c t =
  not (bex (h_match_probs (si_subst mu) l oo q c t) (match_decision mu));

decompositions :: Pos -> [(Pos, Pos)];
decompositions p = map (\ pa -> (pa, the (pos_prefix pa p))) (prefix_list p);

n0b :: Pos -> Pos -> Pos -> Nat;
n0b p q oo =
  nat (ceiling
        (divide_rat
          (of_nat
            (minus_nat (plus_nat (size_pos oo) (Nat_of_num One)) (size_pos q)))
          (of_nat (size_pos p))));

fp_B_decide ::
  forall a b.
    (Eq a, Linorder a, Ceq b, Corder b, Eq b,
      Linorder b) => Subst_incr a b ->
                       Term a b -> Pos -> Pos -> Ctxt a b -> Term a b -> Bool;
fp_B_decide mu l oo q c t =
  not (bex (foldr (sup_set . (\ qa -> h_match_probs (si_subst mu) l oo qa c t))
             (proper_prefix_list q)
             (set_empty
               (of_phantom
                 (set_impl_prod :: Phantom (Term a b, Term a b) Set_impl))))
        (match_decision mu)) &&
    not (bex (let {
                p = hole_pos c;
                n = (\ pa -> n0b p pa oo);
                ps = filter
                       (\ (pa, pb) ->
                         less_pos oo (append pb (power p (n pb))) &&
                           less_pos pa p)
                       (remdups (decompositions p));
              } in set (map (\ (pb, pa) ->
                              (subt_at_ctxt c pb,
                                (l, (subst_apply_ctxt c (si_subst mu),
                                      subst_apply_term
(ctxt_subst c (si_subst mu) (n pa) t) (si_subst mu)))))
                         (remdups ps)))
          (\ ep ->
            bex (seta (ident_prob_of_emp mu ep)) (all (ident_decision mu))));

fp_A_decide ::
  forall a b.
    (Eq a, Linorder a, Ceq b, Corder b, Eq b,
      Linorder b) => Subst_incr a b ->
                       Term a b -> Pos -> Pos -> Ctxt a b -> Term a b -> Bool;
fp_A_decide mu l oo q c t =
  not (bex (case subt_at t q of {
             Var _ ->
               set_empty
                 (of_phantom
                   (set_impl_prod :: Phantom (Term a b, Term a b) Set_impl));
             Fun _ _ ->
               let {
                 h = hole_pos c;
                 n = n0 h q oo;
                 hn = power h n;
                 cs = ctxt_subst c (si_subst mu) n t;
                 q_s = bounded_postfixes q (poss_list t);
                 qoo_s =
                   concatMap
                     (\ qa ->
                       map (\ a -> (qa, a))
                         (prefix_list (append hn (append q qa))))
                     q_s;
                 qoo_sf =
                   filter
                     (\ qoo -> less_pos (append hn q) (append (snd qoo) oo))
                     qoo_s;
                 m1 = map (\ qoo -> (subt_at cs (snd qoo), l)) qoo_sf;
                 sterms = remdups (map (si_subst mu) (si_W mu (subt_at t q)));
                 uterms =
                   concatMap (filter (\ ta -> not (is_Var ta)) . supteq_list)
                     sterms;
                 m2 = map (\ u -> (u, l)) (remdups uterms);
               } in set (m1 ++ m2);
           })
        (match_decision mu));

equal_location :: Location -> Location -> Bool;
equal_location Ba A = False;
equal_location A Ba = False;
equal_location Ba H = False;
equal_location H Ba = False;
equal_location A H = False;
equal_location H A = False;
equal_location Ba Ba = True;
equal_location A A = True;
equal_location H H = True;

fp_decide ::
  forall a b.
    (Eq a, Linorder a, Ceq b, Corder b, Eq b,
      Linorder b) => Subst_incr a b ->
                       (Pos, (Ctxt a b, Term a b)) ->
                         (Ctxt a b, (Term a b, Location)) -> Bool;
fp_decide mu =
  (\ (q, (c, t)) (l, (la, loc)) ->
    (if equal_location loc H
      then fp_H_decide mu (ctxt_apply l la) (hole_pos l) q c t else True) &&
      (if equal_location loc A
        then fp_A_decide mu (ctxt_apply l la) (hole_pos l) q c t else True) &&
        (if equal_location loc Ba
          then fp_B_decide mu (ctxt_apply l la) (hole_pos l) q c t else True));

fp_valid ::
  forall a b c.
    (Eq a, Linorder a, Eq b, Linorder b, Ceq c,
      Corder c) => Set (Ctxt a b, (Term a b, c)) -> Bool;
fp_valid p = ball p (\ (l, (la, _)) -> not (is_Var (ctxt_apply l la)));

location_rec :: forall a. a -> a -> a -> Location -> a;
location_rec f1 f2 f3 H = f1;
location_rec f1 f2 f3 A = f2;
location_rec f1 f2 f3 Ba = f3;

corder_location ::
  Maybe (Location -> Location -> Bool, Location -> Location -> Bool);
corder_location =
  Just ((\ x y ->
          location_rec
            (\ a -> (case a of {
                      H -> False;
                      A -> True;
                      Ba -> True;
                    }))
            (\ a -> (case a of {
                      H -> False;
                      A -> False;
                      Ba -> True;
                    }))
            (\ a -> (case a of {
                      H -> False;
                      A -> False;
                      Ba -> False;
                    }))
            x y ||
            equal_location x y),
         location_rec
           (\ a -> (case a of {
                     H -> False;
                     A -> True;
                     Ba -> True;
                   }))
           (\ a -> (case a of {
                     H -> False;
                     A -> False;
                     Ba -> True;
                   }))
           (\ a -> (case a of {
                     H -> False;
                     A -> False;
                     Ba -> False;
                   })));

instance Corder Location where {
  corder = corder_location;
};

ceq_location :: Maybe (Location -> Location -> Bool);
ceq_location = Just equal_location;

instance Ceq Location where {
  ceq = ceq_location;
};

check_fploop ::
  forall a b.
    (Eq a, Linorder a, Showa a, Ceq b, Corder b, Eq b, Linorder b,
      Showa b) => [(Term a b, Term a b)] ->
                    [(Ctxt a b, (Term a b, Location))] ->
                      Ctxt a b ->
                        [(b, Term a b)] ->
                          Term a b ->
                            [(Pos, ((Term a b, Term a b), Term a b))] ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_fploop r p c sigma t seq =
  let {
    mu = subst_incr sigma;
    mua = si_subst mu;
  } in bindb (check (not (null seq))
               (shows_prec_list Zero_nat
                 ['l', 'o', 'o', 'p', 'i', 'n', 'g', ' ', 'r', 'e', 'd', 'u',
                   'c', 't', 'i', 'o', 'n', ' ', 'm', 'u', 's', 't', ' ', 'n',
                   'o', 't', ' ', 'b', 'e', ' ', 'e', 'm', 'p', 't', 'y']))
         (\ _ ->
           bindb (check
                   (equal_term (let {
                                  (_, (_, ta)) = last seq;
                                } in ta)
                     (ctxt_apply c (subst_apply_term t mua)))
                   (shows_prec_list Zero_nat
                     ['l', 'a', 's', 't', ' ', 't', 'e', 'r', 'm', ' ', 'i',
                       'n', ' ', 's', 'e', 'q', 'u', 'e', 'n', 'c', 'e', ' ',
                       'i', 's', ' ', 'n', 'o', 't', ' ', 'C', '[', 't', ' ',
                       's', 'i', 'g', 'm', 'a', ']']))
             (\ _ ->
               bindb (check (fp_valid (set p))
                       (shows_prec_list Zero_nat
                         ['l', 'h', 's', 's', ' ', 'i', 'n', ' ', 'f', 'o', 'r',
                           'b', 'i', 'd', 'd', 'e', 'n', ' ', 'p', 'a', 't',
                           't', 'e', 'r', 'n', 's', ' ', 'm', 'u', 's', 't',
                           ' ', 'n', 'o', 't', ' ', 'b', 'e', ' ', 'v', 'a',
                           'r', 'i', 'a', 'b', 'l', 'e', 's']))
                 (\ _ ->
                   bindb (catcha
                           (forallM
                             (\ (l, _) ->
                               check (not (is_Var l))
                                 (shows_prec_list Zero_nat
                                   ['l', 'h', 's', 's', ' ', 'o', 'f', ' ', 'T',
                                     'R', 'S', ' ', 'm', 'u', 's', 't', ' ',
                                     'n', 'o', 't', ' ', 'b', 'e', ' ', 'v',
                                     'a', 'r', 'i', 'a', 'b', 'l', 'e', 's']))
                             r)
                           (\ x -> Inl (snd x)))
                     (\ _ ->
                       let {
                         seqa = zip (t : map (\ (_, (_, ta)) -> ta) seq) seq;
                       } in catcha
                              (forallM
                                (\ (ta, (q, (ra, s))) ->
                                  bindb (check_rstep r q ra ta s)
                                    (\ _ ->
                                      let {
check_fpstep = fp_decide mu (q, (c, ta));
                                      } in
catcha
  (forallM
    (\ pt ->
      check (check_fpstep pt)
        (shows_prec_list Zero_nat
           ['i', 't', 'e', 'r', 'a', 't', 'i', 'n', 'g', ' ', 'r', 'e', 'd',
             'u', 'c', 't', 'i', 'o', 'n', ' '] .
          shows_prec_term Zero_nat ta .
            shows_prec_list Zero_nat [' ', '-', '-', '>'] .
              shows_prec_pos Zero_nat q .
                shows_prec_list Zero_nat [' '] .
                  shows_prec_term Zero_nat s .
                    shows_prec_list Zero_nat
                      [' ', 'd', 'o', 'e', 's', ' ', 'n', 'o', 't', ' ', 'r',
                        'e', 's', 'p', 'e', 'c', 't', ' ', 'f', 'o', 'r', 'b',
                        'i', 'd', 'd', 'e', 'n', ' ', 'p', 'a', 't', 't', 'e',
                        'r', 'n', ' '] .
                      shows_pattern pt))
    p)
  (\ x -> Inl (snd x))))
                                seqa)
                              (\ x -> Inl (snd x))))));

check_fp_nontermination_proof ::
  forall a b c.
    (Eq b, Key b, Showa b, Ceq c, Corder c, Eq c, Key c,
      Showa c) => ([Prelude.Char] -> [Prelude.Char]) ->
                    Tp_ops_ext a b c () ->
                      a -> [(Ctxt b c, (Term b c, Location))] ->
                             Fp_nontermination_proof b c ->
                               Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_fp_nontermination_proof ia i tp p (FPTRS_Loop s rseq sigma c) =
  debug (ia []) ['L', 'o', 'o', 'p']
    (let {
       r = rulesb i tp;
     } in catcha (check_fploop r p c sigma s rseq)
            (\ x ->
              Inl (ia . shows_string
                          [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h',
                            'e', 'n', ' ', 'c', 'h', 'e', 'c', 'k', 'i', 'n',
                            'g', ' ', 'f', 'o', 'r', 'b', 'i', 'd', 'd', 'e',
                            'n', ' ', 'p', 'a', 't', 't', 'e', 'r', 'n', ' ',
                            'l', 'o', 'o', 'p'] .
                          shows_nl . indent x)));

shows_conditions ::
  forall a b.
    (Showa a,
      Showa b) => [(Term a b, Term a b)] ->
                    Bool -> [Prelude.Char] -> [Prelude.Char];
shows_conditions [] uu = id;
shows_conditions (x : xs) b =
  shows_prec_list Zero_nat (if b then [' ', '|', ' '] else [',', ' ']) .
    shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
      [' ', '-', '>', '*', ' '] x .
      shows_conditions xs False;

shows_crule ::
  forall a b.
    (Showa a,
      Showa b) => ((Term a b, Term a b), [(Term a b, Term a b)]) ->
                    [Prelude.Char] -> [Prelude.Char];
shows_crule cr =
  shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat) [' ', '-', '>', ' ']
    (fst cr) .
    shows_conditions (snd cr) True;

rhs_n ::
  forall a b.
    (((Term a b, Term a b), [(Term a b, Term a b)]) -> Nat -> Ctxt a b) ->
      ((Term a b, Term a b), [(Term a b, Term a b)]) -> Nat -> Term a b;
rhs_n u (lr, cs) n =
  (if less_nat n (size_list cs) then ctxt_apply (u (lr, cs) n) (fst (nth cs n))
    else snd lr);

lhs_n ::
  forall a b.
    (((Term a b, Term a b), [(Term a b, Term a b)]) -> Nat -> Ctxt a b) ->
      ((Term a b, Term a b), [(Term a b, Term a b)]) -> Nat -> Term a b;
lhs_n u (lr, cs) n =
  (if equal_nat n Zero_nat then fst lr
    else ctxt_apply (u (lr, cs) (minus_nat n (Nat_of_num One)))
           (snd (nth cs (minus_nat n (Nat_of_num One)))));

rules_impla ::
  forall a b.
    (((Term a b, Term a b), [(Term a b, Term a b)]) -> Nat -> Ctxt a b) ->
      ((Term a b, Term a b), [(Term a b, Term a b)]) -> [(Term a b, Term a b)];
rules_impla u cr =
  map (\ i -> (lhs_n u cr i, rhs_n u cr i))
    (upt Zero_nat (plus_nat (size_list (snd cr)) (Nat_of_num One)));

create_ctxts :: forall a b. [(Term a b, Term a b)] -> Maybe (Nat -> Ctxt a b);
create_ctxts r =
  (case r of {
    [] -> Nothing;
    _ : rr ->
      bind (mapMa
             (\ a ->
               (case a of {
                 (Var _, _) -> Nothing;
                 (Fun u [], _) -> Nothing;
                 (Fun u (_ : ts), _) -> Just (More u [] Hole ts);
               }))
             rr)
        (\ cs ->
          let {
            _ = size_list cs;
          } in Just (\ i ->
                      (if less_nat i (size_list cs) then nth cs i else Hole)));
  });

create_U ::
  forall a b.
    (Eq a,
      Eq b) => [(((Term a b, Term a b), [(Term a b, Term a b)]),
                  [(Term a b, Term a b)])] ->
                 Maybe (((Term a b, Term a b), [(Term a b, Term a b)]) ->
                         Nat -> Ctxt a b);
create_U c_rs =
  bind (mapMa
         (\ (cr, rs) ->
           bind (guarda
                  (equal_nat (size_list rs)
                    (plus_nat (size_list (snd cr)) (Nat_of_num One))))
             (\ _ -> bind (create_ctxts rs) (\ ctxt -> Just (cr, ctxt))))
         c_rs)
    (\ cr_ctxts ->
      let {
        m = map_of cr_ctxts;
      } in Just (\ cr ->
                  (case m cr of {
                    Nothing -> (\ _ -> Hole);
                    Just ctxt -> ctxt;
                  })));

check_unraveling ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(((Term a b, Term a b), [(Term a b, Term a b)]),
                     [(Term a b, Term a b)])] ->
                    [((Term a b, Term a b), [(Term a b, Term a b)])] ->
                      Sum ([Prelude.Char] -> [Prelude.Char])
                        [(Term a b, Term a b)];
check_unraveling c_rs ctrs =
  catcha
    (bindb
      (catcha (check_subseteq ctrs (map fst c_rs))
        (\ x ->
          Inl (shows_prec_list Zero_nat
                 ['d', 'i', 'd', ' ', 'n', 'o', 't', ' ', 'f', 'i', 'n', 'd',
                   ' ', 'r', 'u', 'l', 'e', ' '] .
                shows_crule x . shows_nl)))
      (\ _ ->
        bindb (case create_U c_rs of {
                Nothing ->
                  Inl (shows_prec_list Zero_nat
                        ['u', 'n', 'a', 'b', 'l', 'e', ' ', 't', 'o', ' ', 'e',
                          'x', 't', 'r', 'a', 'c', 't', ' ', 'u', 'n', 'r', 'a',
                          'v', 'e', 'l', 'i', 'n', 'g', ' ', 'c', 'o', 'n', 't',
                          'e', 'x', 't', 's']);
                Just a -> Inr a;
              })
          (\ u ->
            bindb (catcha
                    (forallM
                      (\ (c, rs) ->
                        check (rules_impla u c == rs)
                          (shows_prec_list Zero_nat
                             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'i',
                               't', 'h', ' ', 'r', 'u', 'l', 'e', 's', ' ', 'o',
                               'f', ' '] .
                            shows_crule c . shows_nl))
                      c_rs)
                    (\ x -> Inl (snd x)))
              (\ _ -> Inr (concatMap snd c_rs)))))
    (\ x ->
      Inl (shows_prec_list Zero_nat
             ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'u', 'n',
               'r', 'a', 'v', 'e', 'l', 'i', 'n', 'g', ' '] .
            shows_nl . x));

check_quasi_reductive_proof ::
  forall a b c.
    (Countable b, Eq b, Key b,
      Showa b) => Bool ->
                    ([Prelude.Char] -> [Prelude.Char]) ->
                      Tp_ops_ext a (Lab b [Nat]) [Prelude.Char] () ->
                        Dpp_ops_ext c (Lab b [Nat]) [Prelude.Char] () ->
                          [((Term (Lab b [Nat]) [Prelude.Char],
                              Term (Lab b [Nat]) [Prelude.Char]),
                             [(Term (Lab b [Nat]) [Prelude.Char],
                                Term (Lab b [Nat]) [Prelude.Char])])] ->
                            Quasi_reductive_proof b [Nat] [Prelude.Char] ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_quasi_reductive_proof a ia i j ctrs (Unravel u_info prf) =
  debug (ia []) ['U', 'n', 'r', 'a', 'v', 'e', 'l']
    (bindb
      (catcha (check_unraveling u_info ctrs)
        (\ x ->
          Inl (ia . shows_string
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ',
                        'u', 'n', 'r', 'a', 'v', 'e', 'l', 'i', 'n', 'g'] .
                      shows_nl . indent x)))
      (\ r ->
        let {
          tp = mka i False [] r [];
        } in catcha
               (check_trs_termination_proof a (ia . shows_string ['.', '1']) i j
                 tp prf)
               (\ x ->
                 Inl (ia . shows_string
                             [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e',
                               'l', 'o', 'w', ' ', 's', 't', 'r', 'o', 'n', 'g',
                               ' ', 'n', 'o', 'r', 'm', 'a', 'l', 'i', 'z', 'a',
                               't', 'i', 'o', 'n', ' ', '+', ' ', 'w', 'c',
                               'r'] .
                             shows_nl . indent x))));

check_estep ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    Pos ->
                      (Term a b, Term a b) ->
                        Bool ->
                          Term a b ->
                            Term a b ->
                              Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_estep e p rule l_to_r s t =
  bindb (check (any (eq_rule_mod_vars rule) e)
          (shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
             [' ', '-', '>', ' '] rule .
            shows_string
              [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', 'n', ' ', 'e', 'q',
                'u', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f'] .
              shows_nl .
                shows_trs (shows_prec Zero_nat) (shows_prec Zero_nat)
                  ['e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 'a', 'l', ' ', 's',
                    'y', 's', 't', 'e', 'm', ':']
                  [' ', '=', ' '] e .
                  shows_nl))
    (\ _ ->
      bindb (check (in_poss p s)
              (shows_prec_pos Zero_nat p .
                shows_string
                  [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'p', 'o',
                    's', 'i', 't', 'i', 'o', 'n', ' ', 'o', 'f', ' '] .
                  shows_prec_term Zero_nat s . shows_nl))
        (\ _ ->
          bindb (check (in_poss p t)
                  (shows_prec_pos Zero_nat p .
                    shows_string
                      [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a', ' ', 'p',
                        'o', 's', 'i', 't', 'i', 'o', 'n', ' ', 'o', 'f', ' '] .
                      shows_prec_term Zero_nat t . shows_nl))
            (\ _ ->
              let {
                c = ctxt_of_pos_term p s;
                d = ctxt_of_pos_term p t;
                u = subt_at s p;
                v = subt_at t p;
                rrule = (if l_to_r then rule else (snd rule, fst rule));
                err = shows_string
                        ['t', 'h', 'e', ' ', 't', 'e', 'r', 'm', ' '] .
                        shows_prec_term Zero_nat t .
                          shows_string
                            [' ', 'd', 'o', 'e', 's', ' ', 'n', 'o', 't', ' ',
                              'r', 'e', 's', 'u', 'l', 't', ' ', 'f', 'r', 'o',
                              'm', ' ', 'a', ' ', 'p', 'r', 'o', 'p', 'e', 'r',
                              ' ', 'a', 'p', 'p', 'l', 'i', 'c', 'a', 't', 'i',
                              'o', 'n', ' ', 'o', 'f', ' ', 't', 'e', 'r', 'm',
                              ' '] .
                            shows_prec_term Zero_nat s .
                              shows_string
                                [' ', 'u', 's', 'i', 'n', 'g', ' ', 'e', 'q',
                                  'u', 'a', 't', 'i', 'o', 'n', ' '] .
                                shows_nl .
                                  shows_rule (shows_prec Zero_nat)
                                    (shows_prec Zero_nat) [' ', '=', ' ']
                                    rrule .
                                    shows_string
                                      [' ', 'a', 't', ' ', 'p', 'o', 's', 'i',
't', 'i', 'o', 'n', ' '] .
                                      shows_prec_pos Zero_nat p . shows_nl;
              } in (case match_list [(u, fst rrule), (v, snd rrule)] of {
                     Nothing -> Inl err;
                     Just _ -> check (equal_ctxt c d) err;
                   }))));

check_conversion ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    [(Pos, ((Term a b, Term a b), (Bool, Term a b)))] ->
                      Term a b ->
                        Term a b -> Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_conversion e [] s u =
  check (equal_term s u)
    (shows_string
       ['t', 'h', 'e', ' ', 'l', 'a', 's', 't', ' ', 't', 'e', 'r', 'm', ' ',
         'o', 'f', ' ', 't', 'h', 'e', ' ', 'c', 'o', 'n', 'v', 'e', 'r', 's',
         'i', 'o', 'n', ' '] .
      shows_nl .
        shows_prec_term Zero_nat s .
          shows_nl .
            shows_string
              ['d', 'o', 'e', 's', ' ', 'n', 'o', 't', ' ', 'c', 'o', 'r', 'r',
                'e', 's', 'p', 'o', 'n', 'd', ' ', 't', 'o', ' ', 't', 'h', 'e',
                ' ', 'g', 'o', 'a', 'l', ' ', 't', 'e', 'r', 'm'] .
              shows_nl . shows_prec_term Zero_nat u . shows_nl);
check_conversion e ((p, (r, (l_to_r, t))) : c) s u =
  bindb (check_estep e p r l_to_r s t) (\ _ -> check_conversion e c t u);

check_subsumptions_guided ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    [((Term a b, Term a b),
                       [(Pos, ((Term a b, Term a b), (Bool, Term a b)))])] ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_subsumptions_guided e [] = Inr ();
check_subsumptions_guided ea ((e, seq) : convs) =
  bindb (catcha (check_conversion ea seq (fst e) (snd e))
          (\ x ->
            Inl (shows_string
                   ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'i', 'n', ' ', 'c',
                     'o', 'n', 'v', 'e', 'r', 's', 'i', 'o', 'n', ' ', 'f', 'o',
                     'r', ' ', 'e', 'q', 'u', 'a', 't', 'i', 'o', 'n', ' '] .
                  shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                    [' ', '=', ' '] e .
                    shows_nl . x)))
    (\ _ -> check_subsumptions_guided (e : ea) convs);

check_subsumption_guided ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    [(Term a b, Term a b)] ->
                      [((Term a b, Term a b),
                         [(Pos, ((Term a b, Term a b), (Bool, Term a b)))])] ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_subsumption_guided ea e convs =
  bindb (catcha (check_subseteq ea (map fst convs))
          (\ x ->
            Inl (shows_string
                   ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'f', 'i',
                     'n', 'd', ' ', 'c', 'o', 'n', 'v', 'e', 'r', 's', 'i', 'o',
                     'n', ' ', 'f', 'o', 'r', ' ', 'e', 'q', 'u', 'a', 't', 'i',
                     'o', 'n', ' '] .
                  shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                    [' ', '=', ' '] x)))
    (\ _ -> check_subsumptions_guided e convs);

check_subsumption_NF ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    [(Term a b, Term a b)] ->
                      Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_subsumption_NF e r =
  catcha
    (forallM
      (\ ea ->
        catcha (check_join_NF r (fst ea) (snd ea))
          (\ x ->
            Inl (shows_string
                   ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'j', 'o',
                     'i', 'n', ' ', 'e', 'q', 'u', 'a', 't', 'i', 'o', 'n',
                     ' '] .
                  shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                    [' ', '=', ' '] ea .
                    shows_nl . x)))
      e)
    (\ x -> Inl (snd x));

check_subsumption ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    [(Term a b, Term a b)] ->
                      Maybe [((Term a b, Term a b),
                               [(Pos, ((Term a b, Term a b),
(Bool, Term a b)))])] ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_subsumption e r convs_o =
  (case convs_o of {
    Nothing -> check_subsumption_NF e r;
    Just a -> check_subsumption_guided e r a;
  });

check_completion_proof ::
  forall a b c.
    (Countable b, Eq b, Key b,
      Showa b) => Bool ->
                    ([Prelude.Char] -> [Prelude.Char]) ->
                      Tp_ops_ext a (Lab b [Nat]) [Prelude.Char] () ->
                        Dpp_ops_ext c (Lab b [Nat]) [Prelude.Char] () ->
                          [(Term (Lab b [Nat]) [Prelude.Char],
                             Term (Lab b [Nat]) [Prelude.Char])] ->
                            [(Term (Lab b [Nat]) [Prelude.Char],
                               Term (Lab b [Nat]) [Prelude.Char])] ->
                              Completion_proof b [Nat] [Prelude.Char] ->
                                Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_completion_proof a ia i j e r (SN_WCR_Eq joins_i prf conv1 conv2) =
  debug (ia []) ['S', 'N', '_', 'W', 'C', 'R', '_', 'E', 'q']
    (let {
       tp = mka i False [] r [];
     } in bindb (catcha
                  (check_trs_termination_proof a (ia . shows_string ['.', '1'])
                    i j tp prf)
                  (\ x ->
                    Inl (ia . shows_string
                                [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b',
                                  'e', 'l', 'o', 'w', ' ', 's', 't', 'r', 'o',
                                  'n', 'g', ' ', 'n', 'o', 'r', 'm', 'a', 'l',
                                  'i', 'z', 'a', 't', 'i', 'o', 'n', ' ', '+',
                                  ' ', 'w', 'c', 'r'] .
                                shows_nl . indent x)))
            (\ _ ->
              bindb (catcha (check_subsumption_guided r e conv1)
                      (\ x ->
                        Inl (ia . shows_prec_list Zero_nat
                                    [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ',
                                      'w', 'h', 'e', 'n', ' ', 's', 'h', 'o',
                                      'w', 'i', 'n', 'g', ' ', 't', 'h', 'a',
                                      't', ' ', 'r', 'e', 'w', 'r', 'i', 't',
                                      'e', ' ', 'r', 'e', 'l', 'a', 't', 'i',
                                      'o', 'n', ' ', 'c', 'a', 'n', ' ', 'b',
                                      'e', ' ', 's', 'i', 'm', 'u', 'l', 'a',
                                      't', 'e', 'd', ' ', 'b', 'y', ' ', 'e',
                                      'q', 'u', 'a', 't', 'i', 'o', 'n', 's'] .
                                    shows_nl . indent x)))
                (\ _ ->
                  bindb (catcha (check_subsumption e r conv2)
                          (\ x ->
                            Inl (ia . shows_prec_list Zero_nat
[':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e', 'n', ' ', 's', 'h', 'o',
  'w', 'i', 'n', 'g', ' ', 't', 'h', 'a', 't', ' ', 'e', 'q', 'u', 'a', 't',
  'i', 'o', 'n', 's', ' ', 'c', 'a', 'n', ' ', 'b', 'e', ' ', 's', 'i', 'm',
  'u', 'l', 'a', 't', 'e', 'd', ' ', 'b', 'y', ' ', 'r', 'e', 'w', 'r', 'i',
  't', 'e', ' ', 's', 'y', 's', 't', 'e', 'm'] .
shows_nl . indent x)))
                    (\ _ ->
                      catcha
                        (check_critical_pairs r (critical_pairs_impl r r)
                          joins_i)
                        (\ x ->
                          Inl (ia . shows_prec_list Zero_nat
                                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ',
'w', 'h', 'e', 'n', ' ', 'p', 'r', 'o', 'v', 'i', 'n', 'g', ' ', 'l', 'o', 'c',
'a', 'l', ' ', 'c', 'o', 'n', 'f', 'l', 'u', 'e', 'n', 'c', 'e', ' ', 'o', 'f',
' '] .
                                      shows_nl .
shows_tp (shows_prec_lab Zero_nat) (shows_prec_list Zero_nat) i tp .
  shows_nl . indent x))))));

check_equational_disproof ::
  forall a b c.
    (Countable b, Eq b, Key b,
      Showa b) => Bool ->
                    ([Prelude.Char] -> [Prelude.Char]) ->
                      Tp_ops_ext a (Lab b [Nat]) [Prelude.Char] () ->
                        Dpp_ops_ext c (Lab b [Nat]) [Prelude.Char] () ->
                          [(Term (Lab b [Nat]) [Prelude.Char],
                             Term (Lab b [Nat]) [Prelude.Char])] ->
                            (Term (Lab b [Nat]) [Prelude.Char],
                              Term (Lab b [Nat]) [Prelude.Char]) ->
                              Equational_disproof b [Nat] [Prelude.Char] ->
                                Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_equational_disproof a ia i j e eq
  (Completion_and_Normalization_Different r p) =
  debug (ia [])
    ['C', 'o', 'm', 'p', 'l', 'e', 't', 'i', 'o', 'n', '_', 'a', 'n', 'd', '_',
      'N', 'o', 'r', 'm', 'a', 'l', 'i', 'z', 'a', 't', 'i', 'o', 'n']
    (bindb (check_completion_proof a ia i j e r p)
      (\ _ ->
        let {
          s = fst eq;
          t = snd eq;
        } in (case (compute_rstep_NF r s, compute_rstep_NF r t) of {
               (Nothing, b) ->
                 Inl (shows_string
                        ['e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e', 'n', ' ',
                          'c', 'o', 'm', 'p', 'u', 't', 'i', 'n', 'g', ' ', 'n',
                          'o', 'r', 'm', 'a', 'l', ' ', 'f', 'o', 'r', 'm', 's',
                          ' ', 'o', 'f', ' '] .
                       shows_term (shows_prec_lab Zero_nat)
                         (shows_prec_list Zero_nat) s .
                         shows_string [' ', 'a', 'n', 'd', ' '] .
                           shows_term (shows_prec_lab Zero_nat)
                             (shows_prec_list Zero_nat) t);
               (Just sa, Nothing) ->
                 Inl (shows_string
                        ['e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e', 'n', ' ',
                          'c', 'o', 'm', 'p', 'u', 't', 'i', 'n', 'g', ' ', 'n',
                          'o', 'r', 'm', 'a', 'l', ' ', 'f', 'o', 'r', 'm', 's',
                          ' ', 'o', 'f', ' '] .
                       shows_term (shows_prec_lab Zero_nat)
                         (shows_prec_list Zero_nat) s .
                         shows_string [' ', 'a', 'n', 'd', ' '] .
                           shows_term (shows_prec_lab Zero_nat)
                             (shows_prec_list Zero_nat) t);
               (Just sa, Just ta) ->
                 (if not (equal_term sa ta) then Inr ()
                   else Inl (shows_term (shows_prec_lab Zero_nat)
                               (shows_prec_list Zero_nat) s .
                              shows_string [' ', 'a', 'n', 'd', ' '] .
                                shows_term (shows_prec_lab Zero_nat)
                                  (shows_prec_list Zero_nat) t .
                                  shows_string
                                    [' ', 'h', 'a', 'v', 'e', ' ', 's', 'a',
                                      'm', 'e', ' ', 'n', 'o', 'r', 'm', 'a',
                                      'l', ' ', 'f', 'o', 'r', 'm', ' '] .
                                    shows_term (shows_prec_lab Zero_nat)
                                      (shows_prec_list Zero_nat) sa));
             })));

eq_proof_lines ::
  forall a b.
    (Showa a,
      Showa b) => Eq_proof a b ->
                    Nat ->
                      ([Prelude.Char] -> [Prelude.Char],
                        (Nat, (Term a b, Term a b)));
eq_proof_lines (Refl s) i =
  ((shows_nl .
     shows_prec_nat Zero_nat (plus_nat i (Nat_of_num One)) .
       shows_string [':', ' ']) .
     shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat) [' ', '=', ' ']
       (s, s) .
       shows_string [' ', '[', 'r', 'e', 'f', 'l', ']'],
    (plus_nat i (Nat_of_num One), (s, s)));
eq_proof_lines (Sym p) i =
  let {
    (s, (ia, (l, r))) = eq_proof_lines p i;
  } in (s . (shows_nl .
              shows_prec_nat Zero_nat (plus_nat ia (Nat_of_num One)) .
                shows_string [':', ' ']) .
              shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                [' ', '=', ' '] (r, l) .
                shows_string [' ', '[', 's', 'y', 'm', ' '] .
                  shows_prec_nat Zero_nat ia . shows_string [']'],
         (plus_nat ia (Nat_of_num One), (r, l)));
eq_proof_lines (Trans p1 p2) i =
  let {
    (s1, (i1, (s, _))) = eq_proof_lines p1 i;
    (s2, (i2, (_, v))) = eq_proof_lines p2 i1;
  } in (s1 . s2 . (shows_nl .
                    shows_prec_nat Zero_nat (plus_nat i2 (Nat_of_num One)) .
                      shows_string [':', ' ']) .
                    shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                      [' ', '=', ' '] (s, v) .
                      shows_string [' ', '[', 't', 'r', 'a', 'n', 's', ' '] .
                        shows_prec_nat Zero_nat i1 .
                          shows_string [',', ' '] .
                            shows_prec_nat Zero_nat i2 . shows_string [']'],
         (plus_nat i2 (Nat_of_num One), (s, v)));
eq_proof_lines (Assm (l, r) sigma) i =
  let {
    eq = (subst_apply_term l sigma, subst_apply_term r sigma);
  } in ((shows_nl .
          shows_prec_nat Zero_nat (plus_nat i (Nat_of_num One)) .
            shows_string [':', ' ']) .
          shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat) [' ', '=', ' ']
            eq .
            shows_string [' ', '[', 'a', 's', 's', 'm', ' '] .
              shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                [' ', '=', ' '] (l, r) .
                shows_string [']'],
         (plus_nat i (Nat_of_num One), eq));
eq_proof_lines (Cong f ps) i =
  let {
    (s, (is, (ls, rs))) = eq_proofs_lines ps i;
    eq = (Fun f ls, Fun f rs);
    ia = last is;
    isa = butlast is;
  } in (s . (shows_nl .
              shows_prec_nat Zero_nat (plus_nat ia (Nat_of_num One)) .
                shows_string [':', ' ']) .
              shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                [' ', '=', ' '] eq .
                shows_list_gen (shows_prec_nat Zero_nat)
                  [' ', '[', 'c', 'o', 'n', 'g', ']']
                  [' ', '[', 'c', 'o', 'n', 'g', ' '] [',', ' '] [']'] isa,
         (plus_nat ia (Nat_of_num One), eq));

eq_proofs_lines ::
  forall a b.
    (Showa a,
      Showa b) => [Eq_proof a b] ->
                    Nat ->
                      ([Prelude.Char] -> [Prelude.Char],
                        ([Nat], ([Term a b], [Term a b])));
eq_proofs_lines [] i = (id, ([i], ([], [])));
eq_proofs_lines (p : ps) i =
  let {
    (s1, (ia, (l, r))) = eq_proof_lines p i;
    (s2, (is, (ls, rs))) = eq_proofs_lines ps ia;
  } in (s1 . s2, (ia : is, (l : ls, r : rs)));

check_proves ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    Eq_proof a b ->
                      Sum ([Prelude.Char] -> [Prelude.Char])
                        (Term a b, Term a b);
check_proves e (Refl s) = Inr (s, s);
check_proves e (Sym p) = bindb (check_proves e p) (\ (s, t) -> Inr (t, s));
check_proves e (Trans p1 p2) =
  bindb (check_proves e p1)
    (\ (s, t) ->
      bindb (check_proves e p2)
        (\ (ta, u) ->
          (if equal_term t ta then Inr (s, u)
            else Inl (shows_string
                        ['t', 'h', 'e', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'o',
                          'c', 'c', 'u', 'r', 's', ' ', 'i', 'n', ' ', 't', 'h',
                          'e', ' ', 'f', 'o', 'l', 'l', 'o', 'w', 'i', 'n', 'g',
                          ' ', 'p', 'a', 'r', 't', ' '] .
                       shows_nl .
                         fst (eq_proof_lines (Trans p1 p2) Zero_nat) .
                           shows_nl .
                             shows_nl .
                               shows_prec_term Zero_nat t .
                                 shows_string
                                   [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'e',
                                     'q', 'u', 'a', 'l', ' ', 't', 'o', ' '] .
                                   shows_prec_term Zero_nat ta))));
check_proves e (Assm (l, r) sigma) =
  (if membera e (l, r)
    then Inr (subst_apply_term l sigma, subst_apply_term r sigma)
    else Inl (shows_string
                ['t', 'h', 'e', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'o', 'c',
                  'c', 'u', 'r', 's', ' ', 'i', 'n', ' ', 't', 'h', 'e', ' ',
                  'f', 'o', 'l', 'l', 'o', 'w', 'i', 'n', 'g', ' ', 'p', 'a',
                  'r', 't', ' '] .
               shows_nl .
                 fst (eq_proof_lines (Assm (l, r) sigma) Zero_nat) .
                   shows_nl .
                     shows_nl .
                       shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                         [' ', '=', ' '] (l, r) .
                         shows_string
                           [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'i', 'n',
                             ' ', 't', 'h', 'e', ' '] .
                           shows_trs (shows_prec Zero_nat) (shows_prec Zero_nat)
                             ['e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 'a', 'l',
                               ' ', 's', 'y', 's', 't', 'e', 'm', ':']
                             [' ', '=', ' '] e));
check_proves e (Cong f ps) =
  bindb (mapM (check_proves e) ps)
    (\ sts -> Inr (Fun f (map fst sts), Fun f (map snd sts)));

check_eq_proof ::
  forall a b.
    (Eq a, Showa a, Eq b,
      Showa b) => [(Term a b, Term a b)] ->
                    Eq_proof a b ->
                      (Term a b, Term a b) ->
                        Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_eq_proof e p eq =
  catcha
    (bindb (check_proves e p)
      (\ eqa ->
        (if eq == eqa then Inr ()
          else Inl (shows_string
                     ['t', 'h', 'e', ' ', 'p', 'r', 'o', 'o', 'f', ' ', 'd',
                       'o', 'e', 's', ' ', 'n', 'o', 't', ' ', 'f', 'i', 't',
                       ' ', 't', 'h', 'e', ' ', 'g', 'o', 'a', 'l']))))
    (\ x ->
      Inl (shows_string
             ['t', 'h', 'e', 'r', 'e', ' ', 'i', 's', ' ', 'a', 'n', ' ', 'e',
               'r', 'r', 'o', 'r', ' ', 'i', 'n', ' ', 't', 'h', 'e', ' ', 'e',
               'q', 'u', 'a', 't', 'i', 'o', 'n', 'a', 'l', ' ', 'l', 'o', 'g',
               'i', 'c', ' ', 'p', 'r', 'o', 'o', 'f'] .
            shows_nl .
              fst (eq_proof_lines p Zero_nat) .
                shows_nl .
                  shows_nl .
                    shows_string
                      ['f', 'o', 'r', ' ', 'p', 'r', 'o', 'v', 'i', 'n', 'g',
                        ' ', 't', 'h', 'e', ' ', 'e', 'q', 'u', 'a', 't', 'i',
                        'o', 'n'] .
                      shows_nl .
                        shows_nl .
                          shows_rule (shows_prec Zero_nat) (shows_prec Zero_nat)
                            [' ', '=', ' '] eq .
                            shows_nl .
                              shows_nl .
                                shows_string
                                  ['u', 's', 'i', 'n', 'g', ' ', 't', 'h', 'e',
                                    ' '] .
                                  shows_trs (shows_prec Zero_nat)
                                    (shows_prec Zero_nat)
                                    ['e', 'q', 'u', 'a', 't', 'i', 'o', 'n',
                                      'a', 'l', ' ', 's', 'y', 's', 't', 'e',
                                      'm', ':']
                                    [' ', '=', ' '] e .
                                    shows_nl . x));

check_equational_proof ::
  forall a b c.
    (Countable b, Eq b, Key b,
      Showa b) => Bool ->
                    ([Prelude.Char] -> [Prelude.Char]) ->
                      Tp_ops_ext a (Lab b [Nat]) [Prelude.Char] () ->
                        Dpp_ops_ext c (Lab b [Nat]) [Prelude.Char] () ->
                          [(Term (Lab b [Nat]) [Prelude.Char],
                             Term (Lab b [Nat]) [Prelude.Char])] ->
                            (Term (Lab b [Nat]) [Prelude.Char],
                              Term (Lab b [Nat]) [Prelude.Char]) ->
                              Equational_proof b [Nat] [Prelude.Char] ->
                                Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_equational_proof a ia i j e eq (Equational_Proof_Tree p) =
  debug (ia [])
    ['E', 'q', 'u', 'a', 't', 'i', 'o', 'n', 'a', 'l', '_', 'P', 'r', 'o', 'o',
      'f', '_', 'T', 'r', 'e', 'e']
    (check_eq_proof e p eq);
check_equational_proof a ia i j e eq (Conversion eseq) =
  debug (ia []) ['C', 'o', 'n', 'v', 'e', 'r', 's', 'i', 'o', 'n']
    (check_conversion e eseq (fst eq) (snd eq));
check_equational_proof a ia i j e eq (Completion_and_Normalization r p) =
  debug (ia [])
    ['C', 'o', 'm', 'p', 'l', 'e', 't', 'i', 'o', 'n', '_', 'a', 'n', 'd', '_',
      'N', 'o', 'r', 'm', 'a', 'l', 'i', 'z', 'a', 't', 'i', 'o', 'n']
    (bindb (check_completion_proof a ia i j e r p)
      (\ _ ->
        let {
          s = fst eq;
          t = snd eq;
        } in (case (compute_rstep_NF r s, compute_rstep_NF r t) of {
               (Nothing, b) ->
                 Inl (shows_string
                        ['e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e', 'n', ' ',
                          'c', 'o', 'm', 'p', 'u', 't', 'i', 'n', 'g', ' ', 'n',
                          'o', 'r', 'm', 'a', 'l', ' ', 'f', 'o', 'r', 'm', 's',
                          ' ', 'o', 'f', ' '] .
                       shows_term (shows_prec_lab Zero_nat)
                         (shows_prec_list Zero_nat) s .
                         shows_string [' ', 'a', 'n', 'd', ' '] .
                           shows_term (shows_prec_lab Zero_nat)
                             (shows_prec_list Zero_nat) t);
               (Just sa, Nothing) ->
                 Inl (shows_string
                        ['e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e', 'n', ' ',
                          'c', 'o', 'm', 'p', 'u', 't', 'i', 'n', 'g', ' ', 'n',
                          'o', 'r', 'm', 'a', 'l', ' ', 'f', 'o', 'r', 'm', 's',
                          ' ', 'o', 'f', ' '] .
                       shows_term (shows_prec_lab Zero_nat)
                         (shows_prec_list Zero_nat) s .
                         shows_string [' ', 'a', 'n', 'd', ' '] .
                           shows_term (shows_prec_lab Zero_nat)
                             (shows_prec_list Zero_nat) t);
               (Just sa, Just ta) ->
                 (if equal_term sa ta then Inr ()
                   else Inl (shows_term (shows_prec_lab Zero_nat)
                               (shows_prec_list Zero_nat) s .
                              shows_string [' ', 'a', 'n', 'd', ' '] .
                                shows_term (shows_prec_lab Zero_nat)
                                  (shows_prec_list Zero_nat) t .
                                  shows_string
                                    [' ', 'h', 'a', 'v', 'e', ' ', 'd', 'i',
                                      'f', 'f', 'e', 'r', 'e', 'n', 't', ' ',
                                      'n', 'o', 'r', 'm', 'a', 'l', ' ', 'f',
                                      'o', 'r', 'm', 's']));
             })));

shows_prec_complexity_class ::
  Nat -> Complexity_class -> [Prelude.Char] -> [Prelude.Char];
shows_prec_complexity_class d c =
  (if equal_nat (degree c) Zero_nat
    then shows_prec_list Zero_nat ['O', '(', '1', ')']
    else (if equal_nat (degree c) (Nat_of_num One)
           then shows_prec_list Zero_nat ['O', '(', 'n', ')']
           else shows_prec_list Zero_nat ['O', '(', 'n', '^'] .
                  shows_prec_nat Zero_nat (degree c) .
                    shows_prec_list Zero_nat [')']));

less_eq_complexity_class :: Complexity_class -> Complexity_class -> Bool;
less_eq_complexity_class x y = less_eq_nat (degree x) (degree y);

rule_shift_complexity_tt ::
  forall a b c.
    (Eq b, Key b, Showa b, Eq c, Key c,
      Showa c) => Tp_ops_ext a b c () ->
                    Redtriple_ext b c () ->
                      [(Term b c, Term b c)] ->
                        Complexity_measure b c ->
                          Complexity_class ->
                            a -> Sum ([Prelude.Char] -> [Prelude.Char]) a;
rule_shift_complexity_tt i rp rdelete cm cc tp =
  let {
    r = ra i tp;
    rw = rwa i tp;
    r2 = ceta_list_diff r rdelete;
  } in (case catcha
               (bindb (valid rp)
                 (\ _ ->
                   bindb (catcha (mono rp (rdelete ++ rw ++ r2))
                           (\ x ->
                             Inl (shows_string
                                    ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ',
                                      'w', 'i', 't', 'h', ' ', 'm', 'o', 'n',
                                      'o', 't', 'o', 'n', 'i', 'c', 'i', 't',
                                      'y', ' ', 'o', 'f', ' ', 's', 't', 'r',
                                      'i', 'c', 't', ' ', 'o', 'r', 'd', 'e',
                                      'r'] .
                                   shows_nl . x)))
                     (\ _ ->
                       bindb (catcha
                               (catcha (forallM (s rp) rdelete)
                                 (\ x -> Inl (snd x)))
                               (\ x ->
                                 Inl (shows_string
['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ', 'o', 'r', 'i',
  'e', 'n', 't', 'i', 'n', 'g', ' ', 's', 't', 'r', 'i', 'c', 't', ' ', 'T',
  'R', 'S'] .
                                       shows_nl . x)))
                         (\ _ ->
                           bindb (catcha
                                   (catcha (forallM (ns rp) (rw ++ r2))
                                     (\ x -> Inl (snd x)))
                                   (\ x ->
                                     Inl (shows_string
    ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h', 'e', 'n', ' ', 'o', 'r',
      'i', 'e', 'n', 't', 'i', 'n', 'g', ' ', 'n', 'o', 'n', '-', 's', 't', 'r',
      'i', 'c', 't', ' ', 'T', 'R', 'S'] .
   shows_nl . x)))
                             (\ _ ->
                               bindb (cpx rp cm)
                                 (\ cca ->
                                   check (less_eq_complexity_class cca cc)
                                     (shows_prec_list Zero_nat
['c', 'o', 'u', 'l', 'd', ' ', 'o', 'n', 'l', 'y', ' ', 'd', 'e', 'r', 'i', 'v',
  'e', ' ', 'c', 'o', 'm', 'p', 'l', 'e', 'x', 'i', 't', 'y', ' '] .
                                       shows_prec_complexity_class Zero_nat
 cca)))))))
               (\ x ->
                 Inl (shows_string
                        ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'd',
                          'e', 'r', 'i', 'v', 'e', ' ', 't', 'h', 'e', ' ', 'i',
                          'n', 't', 'e', 'n', 'd', 'e', 'd', ' ', 'c', 'o', 'm',
                          'p', 'l', 'e', 'x', 'i', 't', 'y', ' '] .
                       shows_prec_complexity_class Zero_nat cc .
                         shows_prec_list Zero_nat
                           [' ', 'f', 'r', 'o', 'm', ' ', 't', 'h', 'e', ' ',
                             'f', 'o', 'l', 'l', 'o', 'w', 'i', 'n', 'g'] .
                           shows_nl . desca rp . shows_nl . x))
         of {
         Inl a -> Inl a;
         Inr _ -> Inr (mka i (nfsa i tp) (qa i tp) r2 (list_union rw rdelete));
       });

check_complexity_proof ::
  forall a b c.
    (Eq b, Key b, Showa b, Eq c, Key c,
      Showa c) => ([Prelude.Char] -> [Prelude.Char]) ->
                    Tp_ops_ext a b c () ->
                      a -> Complexity_measure b c ->
                             Complexity_class ->
                               Complexity_proof b c ->
                                 Sum ([Prelude.Char] -> [Prelude.Char]) ();
check_complexity_proof ia i tp cm cc (Rule_Shift_Complexity redp rdelete prf) =
  debug (ia [])
    ['R', 'u', 'l', 'e', ' ', 'R', 'e', 'm', 'o', 'v', 'a', 'l', ' ', 'C', 'o',
      'm', 'p', 'l', 'e', 'x', 'i', 't', 'y']
    (bindb
      (catcha (rule_shift_complexity_tt i (get_redtriple redp) rdelete cm cc tp)
        (\ x ->
          Inl (ia . shows_string
                      [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'e',
                        'n', ' ', 'a', 'p', 'p', 'l', 'y', 'i', 'n', 'g', ' ',
                        't', 'h', 'e', ' ', 'r', 'u', 'l', 'e', ' ', 's', 'h',
                        'i', 'f', 't', 'i', 'n', 'g', ' ', 't', 'e', 'c', 'h',
                        'n', 'i', 'q', 'u', 'e', ' ', 'o', 'n', ' '] .
                      shows_nl .
                        shows_tp (shows_prec Zero_nat) (shows_prec Zero_nat) i
                          tp .
                          shows_nl . x)))
      (\ tpa ->
        catcha
          (check_complexity_proof (ia . shows_string ['.', '1']) i tpa cm cc
            prf)
          (\ x ->
            Inl (ia . shows_string
                        [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b', 'e', 'l',
                          'o', 'w', ' ', 't', 'h', 'e', ' ', 'r', 'u', 'l', 'e',
                          ' ', 's', 'h', 'i', 'f', 't', 'i', 'n', 'g', ' ', 'p',
                          'r', 'o', 'c', 'e', 's', 's', 'o', 'r'] .
                        shows_nl . indent x))));
check_complexity_proof ia i tp cm cc RisEmpty_Complexity =
  debug (ia [])
    ['R', ' ', 'i', 's', ' ', 'e', 'm', 'p', 't', 'y', ' ', 'f', 'o', 'r', ' ',
      'c', 'o', 'm', 'p', 'l', 'e', 'x', 'i', 't', 'y']
    (check (null (ra i tp))
      (ia . shows_string
              [':', ' ', 'R', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'e', 'm',
                'p', 't', 'y', ' ', 'i', 'n', ' '] .
              shows_nl .
                shows_tp (shows_prec Zero_nat) (shows_prec Zero_nat) i tp));
check_complexity_proof ia i tp cm cc
  (Remove_Nonapplicable_Rules_Complexity r prf) =
  debug (ia [])
    ['R', 'e', 'm', 'o', 'v', 'i', 'n', 'g', ' ', 'n', 'o', 'n', '-', 'a', 'p',
      'p', 'l', 'i', 'c', 'a', 'b', 'l', 'e', ' ', 'r', 'u', 'l', 'e', 's']
    (let {
       _ = ra i tp;
     } in bindb (catcha (check_non_applicable_rules (is_QNFa i tp) r)
                  (\ x ->
                    Inl (ia . shows_string
                                [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'w',
                                  'h', 'e', 'n', ' ', 'r', 'e', 'm', 'o', 'v',
                                  'i', 'n', 'g', ' ', 'n', 'o', 'n', '-', 'a',
                                  'p', 'p', 'l', 'i', 'c', 'a', 'b', 'l', 'e',
                                  ' ', 'r', 'u', 'l', 'e', 's'] .
                                shows_nl .
                                  indent
                                    (shows_rule (shows_prec Zero_nat)
                                       (shows_prec Zero_nat)
                                       [' ', '-', '>', ' '] x .
                                      shows_prec_list Zero_nat
[' ', 'i', 's', ' ', 'a', 'p', 'p', 'l', 'i', 'c', 'a', 'b', 'l', 'e']))))
            (\ _ ->
              let {
                tpa = delete_R_Rwa i tp r r;
              } in catcha
                     (check_complexity_proof (ia . shows_string ['.', '1']) i
                       tpa cm cc prf)
                     (\ x ->
                       Inl (ia . shows_string
                                   [':', ' ', 'e', 'r', 'r', 'o', 'r', ' ', 'b',
                                     'e', 'l', 'o', 'w', ' ', 't', 'h', 'e',
                                     ' ', 'n', 'o', 'n', '-', 'a', 'p', 'p',
                                     'l', 'i', 'c', 'a', 'b', 'l', 'e', ' ',
                                     'r', 'u', 'l', 'e', 's', ' ', 'r', 'e',
                                     'm', 'o', 'v', 'a', 'l'] .
                                   shows_nl . indent x))));

ostrategy_to_Q ::
  forall a b.
    (Eq a, Eq b) => Ostrategy a b -> [(Term a b, Term a b)] -> [Term a b];
ostrategy_to_Q Outermost r = remdups (map fst r);
ostrategy_to_Q (Outermost_Q q) uu = q;

certify_cert_problem ::
  forall a b c.
    (Countable b, Eq b, Key b,
      Showa b) => Bool ->
                    Tp_ops_ext a (Lab b [Nat]) [Prelude.Char] () ->
                      Dpp_ops_ext c (Lab b [Nat]) [Prelude.Char] () ->
                        Cert_problem b [Nat] [Prelude.Char] -> Cert_result;
certify_cert_problem a i j (TRS_Termination_Proof nfs q r Nothing prf) =
  (case check_trs_termination_proof a (shows_string ['1']) i j
          (mka i nfs (strategy_to_Q q r) r []) prf
    of {
    Inl err ->
      Error ((shows_string
                ['t', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i', 'o', 'n', ' ',
                  'p', 'r', 'o', 'o', 'f', ' ', 'n', 'o', 't', ' ', 'a', 'c',
                  'c', 'e', 'p', 't', 'e', 'd'] .
               shows_nl . err)
              []);
    Inr _ -> Certified (xml_tag (TRS_Termination_Proof nfs q r Nothing prf));
  });
certify_cert_problem a i j (TRS_Termination_Proof nfs q r (Just s) prf) =
  (case check_trs_termination_proof a (shows_string ['1']) i j
          (mka i nfs (strategy_to_Q q r) r s) prf
    of {
    Inl err ->
      Error ((shows_string
                ['r', 'e', 'l', 'a', 't', 'i', 'v', 'e', ' ', 't', 'e', 'r',
                  'm', 'i', 'n', 'a', 't', 'i', 'o', 'n', ' ', 'p', 'r', 'o',
                  'o', 'f', ' ', 'n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p',
                  't', 'e', 'd'] .
               shows_nl . err)
              []);
    Inr _ -> Certified (xml_tag (TRS_Termination_Proof nfs q r (Just s) prf));
  });
certify_cert_problem a i j (Complexity_Proof q r s_o cm cc prf) =
  (case check_complexity_proof (shows_string ['1']) i
          (mka i True (strategy_to_Q q r) r (rel_rules_of s_o)) cm cc prf
    of {
    Inl err ->
      Error ((shows_string
                ['c', 'o', 'm', 'p', 'l', 'e', 'x', 'i', 't', 'y', ' ', 'p',
                  'r', 'o', 'o', 'f', ' ', 'n', 'o', 't', ' ', 'a', 'c', 'c',
                  'e', 'p', 't', 'e', 'd'] .
               shows_nl . err)
              []);
    Inr _ -> Certified (xml_tag (Complexity_Proof q r s_o cm cc prf));
  });
certify_cert_problem a i j (TRS_Nontermination_Proof nfs q r prf) =
  (case check_trs_nontermination_proof (shows_string ['1']) i j
          (mka i nfs (strategy_to_Q q r) r []) prf
    of {
    Inl err ->
      Error ((shows_string
                ['n', 'o', 'n', 't', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i',
                  'o', 'n', ' ', 'p', 'r', 'o', 'o', 'f', ' ', 'n', 'o', 't',
                  ' ', 'a', 'c', 'c', 'e', 'p', 't', 'e', 'd'] .
               shows_nl . err)
              []);
    Inr _ -> Certified (xml_tag (TRS_Nontermination_Proof nfs q r prf));
  });
certify_cert_problem a i j (Outermost_Nontermination_Proof q r prf) =
  (case check_outermost_nontermination_proof (shows_string ['1']) i
          (mka i False (ostrategy_to_Q q r) r []) prf
    of {
    Inl err ->
      Error ((shows_string
                ['o', 'u', 't', 'e', 'r', 'm', 'o', 's', 't', ' ', 'n', 'o',
                  'n', 't', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i', 'o', 'n',
                  ' ', 'p', 'r', 'o', 'o', 'f', ' ', 'n', 'o', 't', ' ', 'a',
                  'c', 'c', 'e', 'p', 't', 'e', 'd'] .
               shows_nl . err)
              []);
    Inr _ -> Certified (xml_tag (Outermost_Nontermination_Proof q r prf));
  });
certify_cert_problem a i j (FP_Nontermination_Proof p r prf) =
  (case check_fp_nontermination_proof (shows_string ['1']) i
          (mka i False [] r []) p prf
    of {
    Inl err ->
      Error ((shows_string
                ['f', 'o', 'r', 'b', 'i', 'd', 'd', 'e', 'n', ' ', 'p', 'a',
                  't', 't', 'e', 'r', 'n', ' ', 'n', 'o', 'n', 't', 'e', 'r',
                  'm', 'i', 'n', 'a', 't', 'i', 'o', 'n', ' ', 'p', 'r', 'o',
                  'o', 'f', ' ', 'n', 'o', 't', ' ', 'a', 'c', 'c', 'e', 'p',
                  't', 'e', 'd'] .
               shows_nl . err)
              []);
    Inr _ -> Certified (xml_tag (FP_Nontermination_Proof p r prf));
  });
certify_cert_problem a i j (Relative_TRS_Nontermination_Proof nfs q r s prf) =
  (case check_reltrs_nontermination_proof (shows_string ['1']) i j
          (mka i nfs (strategy_to_Q q r) r s) prf
    of {
    Inl err ->
      Error ((shows_string
                ['r', 'e', 'l', 'a', 't', 'i', 'v', 'e', ' ', 'n', 'o', 'n',
                  't', 'e', 'r', 'm', 'i', 'n', 'a', 't', 'i', 'o', 'n', ' ',
                  'p', 'r', 'o', 'o', 'f', ' ', 'n', 'o', 't', ' ', 'a', 'c',
                  'c', 'e', 'p', 't', 'e', 'd'] .
               shows_nl . err)
              []);
    Inr _ ->
      Certified (xml_tag (Relative_TRS_Nontermination_Proof nfs q r s prf));
  });
certify_cert_problem a i j (DP_Termination_Proof nfs m p pw q r rw prf) =
  (case check_dp_termination_proof_with_unlab a (shows_string ['1']) j
          (mkc j nfs m p pw (strategy_to_Q q (r ++ rw)) r rw) prf
    of {
    Inl err ->
      Error ((shows_string
                ['f', 'i', 'n', 'i', 't', 'e', 'n', 'e', 's', 's', ' ', 'p',
                  'r', 'o', 'o', 'f', ' ', 'n', 'o', 't', ' ', 'a', 'c', 'c',
                  'e', 'p', 't', 'e', 'd'] .
               shows_nl . err)
              []);
    Inr _ -> Certified (xml_tag (DP_Termination_Proof nfs m p pw q r rw prf));
  });
certify_cert_problem a i j (DP_Nontermination_Proof nfs m p q r prf) =
  (case check_dp_nontermination_proof (shows_string ['1']) j
          (mkc j nfs m p [] (strategy_to_Q q r) [] r) prf
    of {
    Inl err ->
      Error ((shows_string
                ['i', 'n', 'f', 'i', 'n', 'i', 't', 'e', 'n', 'e', 's', 's',
                  ' ', 'p', 'r', 'o', 'o', 'f', ' ', 'n', 'o', 't', ' ', 'a',
                  'c', 'c', 'e', 'p', 't', 'e', 'd'] .
               shows_nl . err)
              []);
    Inr _ -> Certified (xml_tag (DP_Nontermination_Proof nfs m p q r prf));
  });
certify_cert_problem a i j (TRS_Confluence_Proof nfs r prf) =
  (case check_cr_proof a (shows_string ['1']) i j r prf of {
    Inl err ->
      Error ((shows_string
                ['c', 'o', 'n', 'f', 'l', 'u', 'e', 'n', 'c', 'e', ' ', 'p',
                  'r', 'o', 'o', 'f', ' ', 'n', 'o', 't', ' ', 'a', 'c', 'c',
                  'e', 'p', 't', 'e', 'd'] .
               shows_nl . err)
              []);
    Inr _ -> Certified (xml_tag (TRS_Confluence_Proof nfs r prf));
  });
certify_cert_problem a i j (TRS_Non_Confluence_Proof nfs r prf) =
  (case check_ncr_proof a (shows_string ['1']) i j r prf of {
    Inl err ->
      Error ((shows_string
                ['c', 'o', 'n', 'f', 'l', 'u', 'e', 'n', 'c', 'e', ' ', 'd',
                  'i', 's', 'p', 'r', 'o', 'o', 'f', ' ', 'n', 'o', 't', ' ',
                  'a', 'c', 'c', 'e', 'p', 't', 'e', 'd'] .
               shows_nl . err)
              []);
    Inr _ -> Certified (xml_tag (TRS_Non_Confluence_Proof nfs r prf));
  });
certify_cert_problem a i j (Completion_Proof e r prf) =
  (case check_completion_proof a (shows_string ['1']) i j e r prf of {
    Inl err ->
      Error ((shows_string
                ['c', 'o', 'm', 'p', 'l', 'e', 't', 'i', 'o', 'n', ' ', 'p',
                  'r', 'o', 'o', 'f', ' ', 'n', 'o', 't', ' ', 'a', 'c', 'c',
                  'e', 'p', 't', 'e', 'd'] .
               shows_nl . err)
              []);
    Inr _ -> Certified (xml_tag (Completion_Proof e r prf));
  });
certify_cert_problem a i j (Equational_Proof e eq prf) =
  (case check_equational_proof a (shows_string ['1']) i j e eq prf of {
    Inl err ->
      Error ((shows_string
                ['e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 'a', 'l', ' ', 'p',
                  'r', 'o', 'o', 'f', ' ', 'n', 'o', 't', ' ', 'a', 'c', 'c',
                  'e', 'p', 't', 'e', 'd'] .
               shows_nl . err)
              []);
    Inr _ -> Certified (xml_tag (Equational_Proof e eq prf));
  });
certify_cert_problem a i j (Equational_Disproof e eq prf) =
  (case check_equational_disproof a (shows_string ['1']) i j e eq prf of {
    Inl err ->
      Error ((shows_string
                ['e', 'q', 'u', 'a', 't', 'i', 'o', 'n', 'a', 'l', ' ', 'd',
                  'i', 's', 'p', 'r', 'o', 'o', 'f', ' ', 'n', 'o', 't', ' ',
                  'a', 'c', 'c', 'e', 'p', 't', 'e', 'd'] .
               shows_nl . err)
              []);
    Inr _ -> Certified (xml_tag (Equational_Disproof e eq prf));
  });
certify_cert_problem a i j (Quasi_Reductive_Proof ctrs prf) =
  (case check_quasi_reductive_proof a (shows_string ['1']) i j ctrs prf of {
    Inl err ->
      Error ((shows_string
                ['q', 'u', 'a', 's', 'i', ' ', 'r', 'e', 'd', 'u', 'c', 't',
                  'i', 'v', 'e', ' ', 'p', 'r', 'o', 'o', 'f', ' ', 'n', 'o',
                  't', ' ', 'a', 'c', 'c', 'e', 'p', 't', 'e', 'd'] .
               shows_nl . err)
              []);
    Inr _ -> Certified (xml_tag (Quasi_Reductive_Proof ctrs prf));
  });

extract_input_proof ::
  [Prelude.Char] -> Maybe ([Prelude.Char], ([Prelude.Char], [Prelude.Char]));
extract_input_proof s =
  (case search_len (filter (\ c -> not (membera [' ', '\n', '\t', '\r'] c)) s)
          ['<', 'i', 'n', 'p', 'u', 't', '>']
          (size_list ['<', 'i', 'n', 'p', 'u', 't', '>'])
    of {
    Nothing -> Nothing;
    Just (_, minput) ->
      (case search_len minput ['<', '/', 'i', 'n', 'p', 'u', 't', '>']
              (size_list ['<', '/', 'i', 'n', 'p', 'u', 't', '>'])
        of {
        Nothing -> Nothing;
        Just (the_input, sa) ->
          (case search_len sa ['<', 'p', 'r', 'o', 'o', 'f', '>']
                  (size_list ['<', 'p', 'r', 'o', 'o', 'f', '>'])
            of {
            Nothing -> Nothing;
            Just (version, prf) -> Just (the_input, (version, prf));
          });
      });
  });

eval_list_haskell :: forall a. [a] -> Sum_bot [Prelude.Char] [a];
eval_list_haskell (x : xs) =
  binda (eval_list_haskell xs) (\ ys -> returna (x : ys));
eval_list_haskell [] = returna [];

xmldoc2cert_problem ::
  Xmldoc ->
    Sum_bot [Prelude.Char] (Cert_problem [Prelude.Char] [Nat] [Prelude.Char]);
xmldoc2cert_problem (Xmldoc header xml) =
  debug ['0']
    ['p', 'a', 'r', 's', 'i', 'n', 'g', ' ', 'x', 'm', 'l', ' ', 't', 'o', ' ',
      'c', 'e', 'r', 't', 'i', 'f', 'i', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'p',
      'r', 'o', 'b', 'l', 'e', 'm']
    (xml2cert_problem (text ['n', 'a', 'm', 'e']) plain_name xml);

parse_cert_problem ::
  [Prelude.Char] ->
    Sum_bot [Prelude.Char] (Cert_problem [Prelude.Char] [Nat] [Prelude.Char]);
parse_cert_problem s =
  (case doc_of_stringa s of {
    Inl a -> errora a;
    Inr a -> xmldoc2cert_problem a;
  });

eq_white_space :: [Prelude.Char] -> [Prelude.Char] -> Bool;
eq_white_space s1 s2 =
  debug ['0']
    ['c', 'o', 'm', 'p', 'a', 'r', 'i', 'n', 'g', ' ', 'w', 'h', 'e', 't', 'h',
      'e', 'r', ' ', 'p', 'a', 'r', 's', 'e', 'd', ' ', 'i', 'n', 'p', 'u', 't',
      ' ', 'c', 'o', 'r', 'r', 'e', 's', 'p', 'o', 'n', 'd', 's', ' ', 't', 'o',
      ' ', 'r', 'e', 'a', 'l', ' ', 'i', 'n', 'p', 'u', 't']
    (filter (\ c -> not (membera [' ', '\n', '\t', '\r'] c)) s1 == s2);

certify_proof :: Bool -> [Prelude.Char] -> Sum_bot [Prelude.Char] Cert_result;
certify_proof a s =
  catch (case extract_input_proof s of {
          Nothing ->
            returna
              (Unsupported
                ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'x',
                  't', 'r', 'a', 'c', 't', ' ', 'i', 'n', 'p', 'u', 't', ' ',
                  'a', 'n', 'd', ' ', 'p', 'r', 'o', 'o', 'f', ' ', 'f', 'r',
                  'o', 'm', ' ', 'g', 'i', 'v', 'e', 'n', ' ', 's', 't', 'r',
                  'i', 'n', 'g']);
          Just (the_input, (_, the_proof)) ->
            binda (eval_list_haskell (take max_tag (trim the_proof)))
              (\ short_prf ->
                binda (parse_cert_problem s)
                  (\ cp ->
                    returna
                      (if eq_white_space
                            (shows_prec_xml Zero_nat (xml_cert_problem cp) [])
                            the_input
                        then (case certify_cert_problem a tp_rbt_impl
                                     dpp_rbt_impl cp
                               of {
                               Certified tag ->
                                 (if starts_with short_prf tag
                                   then Certified tag
                                   else Error
  (['p', 'r', 'o', 'v', 'e', 'n', ' ', 'p', 'r', 'o', 'p', 'e', 'r', 't', 'y',
     ' '] ++
    tag ++
      [' ', 'd', 'o', 'e', 's', ' ', 'n', 'o', 't', ' ', 'c', 'o', 'r', 'r',
        'e', 's', 'p', 'o', 'n', 'd', ' ', 't', 'o', ' ', 'p', 'r', 'o', 'o',
        'f', ' ', 'i', 'n', ' ', 'i', 'n', 'p', 'u', 't', ' ', 's', 't', 'r',
        'i', 'n', 'g', ':', ' '] ++
        short_prf));
                               Unsupported aa -> Unsupported aa;
                               Error aa -> Error aa;
                             })
                        else Unsupported
                               (concat
                                 [['p', 'a', 'r', 's', 'e', 'd', ' ', 'p', 'r',
                                    'o', 'b', 'l', 'e', 'm', ' ', 'd', 'o', 'e',
                                    's', ' ', 'n', 'o', 't', ' ', 'c', 'o', 'r',
                                    'r', 'e', 's', 'p', 'o', 'n', 'd', ' ', 't',
                                    'o', ' ', 'i', 'n', 'p', 'u', 't'],
                                   ['\n'], ['i', 'n', 'p', 'u', 't', ':'],
                                   ['\n'],
                                   filter
                                     (\ c ->
                                       not (membera [' ', '\n', '\t', '\r'] c))
                                     the_input,
                                   ['\n'], ['\n'],
                                   ['p', 'a', 'r', 's', 'e', 'd', ':'], ['\n'],
                                   filter
                                     (\ c ->
                                       not (membera [' ', '\n', '\t', '\r'] c))
                                     (shows_prec_xml Zero_nat
                                       (xml_cert_problem cp) []),
                                   ['\n']]))));
        })
    (\ err ->
      returna
        (Unsupported
          (['e', 'r', 'r', 'o', 'r', ' ', 'w', 'h', 'i', 'l', 'e', ' ', 'p',
             'a', 'r', 's', 'i', 'n', 'g'] ++
            ['\n'] ++ err)));

}
